/*
 * Khoros: $Id: private.h,v 1.7.2.1 1997/03/06 22:20:25 mirage Exp $
 */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Include file for KCMS private API
   >>>>
   >>>>    Written By: Neil Bowers
   >>>>
   >>>>          Date: Oct 30, 1992 14:54
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kcms_private_h_
#define _kcms_private_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

	/*-------------------------------------*
	|       #defines
	---------------------------------------*/

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/

	/*-------------------------------------*
	|       macros
	---------------------------------------*/

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/


/*----------------------------------------------------------------
|	Toolbox object private API: toolbox.c
\---------------------------------------------------------------*/
/* tb_create.c */
kobject	kcms_tb_create			PROTO((kstring, kstring));
/* toolbox.c */
int	kcms_tb_close			PROTO((kobject));
/* tb_utils.c */
int     kcms_tb_remove_cmobj		PROTO((kobject, kstring));
/* tb_deps.c */
int     kcms_add_tb_dependency      PROTO((kobject, kstring, int));
int     kcms_delete_tb_dependency   PROTO((kobject, kstring, int));

/*----------------------------------------------------------------
|	CM object private API: cmobj.c
\---------------------------------------------------------------*/

kobject	kcms_cmobj_initialize		PROTO((kobject, kstring, kstring));
kobject	kcms_cmobj_complete_open	PROTO((kobject));
int	kcms_cmobj_close		PROTO((kobject));
/* cmobj_dup.c */
kobject	kcms_cmobj_duplicate		PROTO((kobject, kobject));
/* cmobj_destroy.c */
int	kcms_cmobj_destroy		PROTO((kobject));


/*----------------------------------------------------------------
|	File object private API: file.c
\---------------------------------------------------------------*/

int	kcms_fobj_free		PROTO((kobject));
kobject	kcms_fobj_duplicate	PROTO((kobject, kobject));
int	kcms_fobj_destroy	PROTO((kobject));
int	kcms_fobj_pack		PROTO((kobject, kstring));


/*----------------------------------------------------------------
|	Utility routines: utilities.c
\---------------------------------------------------------------*/
kstring	kcms_query_template		PROTO((kobject, int));

kbool kcms_valid_object_path            PROTO((kstring));

/* generate.c */
int kcms_gen_imakeandmake               PROTO((kobject, kstring));

/*----------------------------------------------------------------
|	sed utility routines: sedutils.c
\---------------------------------------------------------------*/
int kcms_copyfile  PROTO((kobject, kobject, kstring, kstring));
int kcms_checkfile PROTO((kobject, kobject, kstring, kstring));


#endif /* _kcms_private_h_ */
/* Don't add after this point */
