/*
 * Khoros: $Id: kcodegen.h,v 1.17.2.2 1997/03/12 23:43:43 mirage Exp $
 */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Include file for code generation library, public API
   >>>>
   >>>>    Written By: Danielle Argiro
   >>>>
   >>>>          Date: Apr 16, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kcodegen_kcodegen_h_
#define _kcodegen_kcodegen_h_


	/*-------------------------------------* 
        |       #include
	---------------------------------------*/
#include "kcodegen/private.h"


	/*-------------------------------------*
	|       #defines
	---------------------------------------*/

/* various formats for output of CLUI usage */
#define KGEN_CLUI_PSTR_SYNTAX    1
#define KGEN_CLUI_MAN1_SYNTAX    2
#define KGEN_CLUI_INFO_STRUCT    3
#define KGEN_CLUI_GETARGS_SYNTAX 4
#define KGEN_CLUI_HELP_SYNTAX    5
#define KGEN_CLUI_PRINT_USAGE    6
#define KGEN_CLUI_HTML_SYNTAX    7

/* #define prog types for kgen_initialize */
#define KGEN_NONE       0
#define KGEN_KROUTINE   1
#define KGEN_XVROUTINE  2
#define KGEN_PANE       3

/* #define locations for standard argument *.pane files */
#define KGEN_KSTDARGS_PANEPATH    "$BOOTSTRAP/objects/library/kcodegen/uis/kstdargs.pane"
#define KGEN_XVSTDARGS_PANEPATH   "$BOOTSTRAP/objects/library/kcodegen/uis/xvstdargs.pane"

#define KGEN_VERSION "%s %d.%d.%d.%d (%s)"


	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/


	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/


	/*-------------------------------------*
	|       macros
	---------------------------------------*/


	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/* clui_init.c */
kform *kgen_initialize PROTO((char *, int, char *, char *, void (*)(void)));
int kclui_initialize   PROTO((char *, int, char *, char *, void (*)(void),
                            void (*)(kaddr), void (*)(kexit_status, kaddr)));
int kclui_init    PROTO((char *, char *, int, uis_struct *,
                         void (*)(void), void (*)(kaddr), 
                         void (*)(kexit_status, kaddr)));
kform *kgen_init  PROTO((char *, char *, int, uis_struct *, void (*)(void)));

/* generate.c */
int	kgen_generate_clui		PROTO((kobject));
int	kgen_generate_gui		PROTO((kobject));
int     kgen_generate_object            PROTO((kobject));
int	kgen_interpret_clui_usage	PROTO((kfile *, kform *, 
				               char *, char *,
					       void (*usage_additions)(void)));
int	kgen_interpret_clui_selections	PROTO((kfile *, kform *));
int	kgen_interpret_clui_args	PROTO((char *, char *, kform *, int));

int	kgen_generate_manpage		PROTO((kobject, header_info *, char *));

long	  kgen_att2ghost		PROTO((kcms_attr));
int       kgen_generate_libpixmap       PROTO((kobject));
kcms_attr kgen_ghost2att		PROTO((long));

#endif /* _kcodegen_kcodegen_h_ */
/* Don't add after this point */
