/*
 * Khoros: $Id: kexpr.h,v 1.5.2.4 1997/05/03 19:29:07 mirage Exp $
 */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: The Khoros Expression declaration file
   >>>>
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Jan 10, 1993 00:37
   >>>>
   >>>> Modifications:
   >>>>    PH (4/1/97) Added KexprResult and kexpr_eval
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kexpr_kexpr_h_
#define _kexpr_kexpr_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

#include <kexpr/kevaluate.h>


	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

#define KEXPR_GLOBAL_ID   -1
#define KEXPR_FUNCTION_ID -2
#define KEXPR_CONSTANT_ID -3

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

typedef struct _KexprResult
{
   int status;          /* return code */
   int type;		/* type of result */
   int strlength;       /* length of string buffer */
   /* values */
   double double_value;
   char   *string_value;
} KexprResult;

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/* routines.c */
KexprResult *kexpr_eval      PROTO((long, char *, KexprResult *, char *));
int   kexpr_evaluate_generic PROTO((long, char *, int, kaddr, char *));
kaddr kexpr_compile_function PROTO((long, char *, char *));
int   kexpr_execute_function PROTO((kaddr, int, kaddr, char *, kvalist));
int   kexpr_parent_set       PROTO((long, long));
int   kexpr_parent_unset     PROTO((long));
int   kexpr_variables_print  PROTO((long, kfile *));
char  **kexpr_variables_list PROTO((long, int, int *));
char  **kexpr_variables_def  PROTO((long, int *));
int   kexpr_variables_copy   PROTO((long, long));
int   kexpr_variables_clear  PROTO((long));
int   kexpr_variables_reset  PROTO((long));
int   kexpr_variable_delete  PROTO((long, char *));
int   kexpr_variable_add     PROTO((long, char *));
void  kexpr_delete_result    PROTO((KexprResult *));
char *kexpr_substitute_exprs PROTO((char *, long));
void  kexpr_set_define_mode  PROTO((int));

/* private routines */
int   kexpr_evaluate   PROTO((long, klist *));
int   kexpr_set_array  PROTO((long, char *, int, int, kaddr));
kaddr kexpr_get_array  PROTO((long, char *, int *, int *));
klist *kexpr_create    PROTO((long, char *));

#endif /* _kexpr_kexpr_h_ */
/* Don't add after this point */
