/*
 * Khoros: $Id: khash.h,v 1.9.2.1 1997/03/10 17:04:01 mirage Exp $
 */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose:  To provide function declarations and
   >>>>			definitions for the kutils hash utilities
   >>>>
   >>>>    Written By:  Mark Young
   >>>>
   >>>>          Date:  Sep 13, 1995
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kutils_khash_h_
#define _kutils_khash_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

        /*-------------------------------------*
        |       defines
        ---------------------------------------*/

        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

typedef struct
{
	int      type;
	size_t   size;
	size_t   count;
	ssize_t  esize;
	kaddr    table; 
	kaddr    *data; 
	unsigned char *occupied; 
	unsigned long *hashvals; 
} khash;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/


        /*-------------------------------------*
        |       macros
        ---------------------------------------*/


        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

khash *khash_init      PROTO((int, size_t));
int   khash_add        PROTO((khash *, kvalist));
long  khash_location   PROTO((khash *, kvalist));
int   khash_clientdata PROTO((khash *, kvalist));
int   khash_check      PROTO((khash *, kvalist));
int   khash_delete     PROTO((khash *, kvalist));
int   khash_free       PROTO((khash *, void (*routine) PROTO((kaddr))));
int   khash_reinit     PROTO((khash *, void (*routine) PROTO((kaddr))));
unsigned long khash_value PROTO((register const char *, register ssize_t));

#endif /* _kutils_khash_h_ */
/* Don't add after this point. */
