 /*
  * Khoros: $Id: kopsys.h,v 1.6 1997/01/20 03:50:02 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: This file contains the operating system dependent
   >>>>		       definition files for the different operating systems
   >>>>		       that Khoros has been ported to.
   >>>>
   >>>>    Written By: Mark Young, John Salas, Jeremy Worley
   >>>>
   >>>>          Date: Jul 16, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _machine_kopsys_h_
#define _machine_kopsys_h_

        /*-------------------------------------*
        |       #include 
        ---------------------------------------*/

                     /* This one for OSF */
#ifdef KOPSYS_OSF
#include <machine/osf.h>
#endif

                     /* This one for OSF1 */
#ifdef KOPSYS_OSF1
#include <machine/osf1.h>
#endif

                     /* This one for AIX */
#ifdef KOPSYS_AIX
#include <machine/aix.h>
#endif

                     /* This one for HPUX */
#ifdef KOPSYS_HPUX
#include <machine/hpux.h>
#endif

                     /* This one for SUNOS */
#ifdef KOPSYS_SUNOS
#include <machine/sunos.h>
#endif

                     /* This one for SOLARIS */
#ifdef KOPSYS_SOLARIS
#include <machine/solaris.h>
#endif

                     /* This one for ULTRIX */
#ifdef KOPSYS_ULTRIX
#include <machine/ultrix.h>
#endif

                     /* This one for IRIX */
#ifdef KOPSYS_IRIX
#include <machine/irix.h>
#endif

                     /* This one for UNICOS */
#ifdef KOPSYS_UNICOS
#include <machine/unicos.h>
#endif

                     /* This one for UNICOSMK */
#ifdef KOPSYS_UNICOSMK
#include <machine/unicosmk.h>
#endif

                     /* This one for DGUX */
#ifdef KOPSYS_DGUX
#include <machine/dgux.h>
#endif

                     /* This one for BSDI */
#ifdef KOPSYS_BSDI
#include <machine/bsdi.h>
#endif

                     /* This one for LINUX */
#ifdef KOPSYS_LINUX
#include <machine/linux.h>
#endif

                     /* This one for 386BSD */
#ifdef KOPSYS_386BSD
#include <machine/386bsd.h>
#endif

                     /* This one for NETBSD */
#ifdef KOPSYS_NETBSD
#include <machine/netbsd.h>
#endif

                     /* This one for FREEBSD */
#ifdef KOPSYS_FREEBSD
#include <machine/freebsd.h>
#endif

                     /* This one for INTERACTIVE */
#ifdef KOPSYS_INTERACTIVE
#include <machine/i386.h>
#endif

                     /* This one for CONVEX */
#ifdef KOPSYS_CONVEX
#include <machine/convex.h>
#endif

                     /* This one for SVR3 */
#ifdef KOPSYS_SVR3
#include <machine/svr3.h>
#endif

                     /* This one for NEXT */
#ifdef KOPSYS_NEXT
#include <machine/next.h>
#endif

                     /* This one for AUX */
#ifdef KOPSYS_AUX
#include <machine/aux.h>
#endif

                     /* This one for NEWSOS */
#ifdef KOPSYS_NEWSOS
#include <machine/newsos.h>
#endif

                     /* This one for LUNA */
#ifdef KOPSYS_LUNA
#include <machine/luna.h>
#endif

		     /* This one for Sequent Dynix/Ptx */
#ifdef KOPSYS_DYNIX
#include <machine/dynix.h>
#endif

                     /* This one for HP Convex Exemplar */
#ifdef KOPSYS_EXEMPLAR
#include <machine/exemplar.h>
#endif


        /*-------------------------------------*
        |       defines
        ---------------------------------------*/

#ifdef __GNUC__
#  define KASINH_DEF
#  define KACOSH_DEF
#  define KATANH_DEF
#  define KCBRT_DEF
#  define KHYPOT_DEF
#  define HAVE_NO_STRERROR
#endif

        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

#ifdef __GNUC__
double strtod PROTO((const char *, char **));
#endif

#endif /* _machine_kopsys_h_ */
/* Don't add after this point */
