 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:51:19 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:51:19 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "conductor.h"
/*-----------------------------------------------------------
| 
|  Routine Name: conductor_get_args
| 
|       Purpose: Gets command line args for conductor
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname conductor
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void conductor_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for conductor is out of sync with arguments specified in conductor's *.pane file; please rerun ghostwriter on conductor.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the conductor structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "conductor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "conductor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "force",
			  &(clui_info->force_flag))))
	{
	    kerror(NULL, "conductor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "debug",
			  &(clui_info->debug_flag))))
	{
	    kerror(NULL, "conductor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generates code for the GUI of an xvroutine.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' conductor",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $BOOTSTRAPBIN/conductor",
  "-H 1  5x1+41+0 'Help' 'man page for absolute value' $BOOTSTRAP/objects/kroutine/conductor/help/conductor.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 0 0 51.75x1+1+2 ' ' 'Toolbox  Name ' 'toolbox name' tb",
  "-s 1 0 1 0 0 51.75x1+1+3.5 ' ' 'Program Object Name' 'program object name' oname",
  "-t 1 0 1 0 0 11.375x1+23+5 'Force Over-Write' 'force output?' force",
  "-t 1 0 1 0 0 12.875x1+38+5 'Add Debug Code' 'add debug code?' debug",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/conductor/uis/conductor.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	16,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


