 /*
  * Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 20:51:35 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 20:51:35 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ghostwriter.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ghostwriter_get_args
| 
|       Purpose: Gets command line args for ghostwriter
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ghostwriter
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ghostwriter_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ghostwriter is out of sync with arguments specified in ghostwriter's *.pane file; please rerun ghostwriter on ghostwriter.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ghostwriter structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "ghostwriter_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "ghostwriter_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "force",
			  &(clui_info->force_flag))))
	{
	    kerror(NULL, "ghostwriter_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "debug",
			  &(clui_info->debug_flag))))
	{
	    kerror(NULL, "ghostwriter_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 10x10+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 10x10+0+0 +1+0 'Generates code & doc for all software objects.' subform",
  "-P 1 0 56.75x5.68182+0+1 +0+0 ' ' ghostwriter",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+39+0 'Run' 'execute operation' $BOOTSTRAPBIN/ghostwriter",
  "-H 1  5x1+45+0 'Help' 'man page for absolute value' $BOOTSTRAP/objects/kroutine/ghostwriter/help/ghostwriter.hlp help",
  "-Q 1 0 5.5x1+51+0 'Close'",
  "-s 1 0 1 0 0 55.5x1+1+2 ' ' 'Toolbox  Name ' 'toolbox name' tb",
  "-s 1 0 1 0 0 55.5x1+1+3 ' ' 'Object  Name  ' 'object name' oname",
  "-t 1 0 1 0 0 15x1+1+4.5 'Force Output' 'force output?' force",
  "-t 0 0 1 0 0 15x1+25+4.5 'Generate Debug Statements' 'generate debug stmts?' debug",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/ghostwriter/uis/ghostwriter.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	16,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


