 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:51:49 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:51:49 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kcp.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kcp_get_args
| 
|       Purpose: Gets command line args for kcp
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcp
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kcp_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kcp is out of sync with arguments specified in kcp's *.pane file; please rerun ghostwriter on kcp.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kcp structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_flag(pane, "force",
			  &(clui_info->force_flag))))
	{
	    kerror(NULL, "kcp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "otb",
			  &(clui_info->otb_string),
			  &(clui_info->otb_flag))))
	{
	    kerror(NULL, "kcp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "ntb",
			  &(clui_info->ntb_string),
			  &(clui_info->ntb_flag))))
	{
	    kerror(NULL, "kcp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kcp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kcp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kcp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Copy a toolbox, software object, or file' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kcp",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute kcp' $BOOTSTRAPBIN/kcp",
  "-H 1  5x1+41+0 'Help' 'help page for kcp' $BOOTSTRAP/objects/kroutine/kcp/help/kcp.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-t 1 0 1 0 0 11.625x1+0+9 'Force Output' 'force output?' force",
  "-C 1",
  "-B 0",
  "-s 1 0 1 1 0 52x1+0+2 ' ' 'Old Toolbox' 'origination toolbox' otb",
  "-s 1 0 1 1 0 52x1+0+3 ' ' 'New Toolbox' 'destination toolbox' ntb",
  "-s 1 0 1 1 0 52x1+0+4 ' ' 'Object Name' 'software object to be copied' oname",
  "-E",
  "-B 0",
  "-I 1 0 1 0 0 1 52x1+0+6 ' ' 'Old File' 'original file' i",
  "-O 1 0 1 0 0 1 52x1+0+7 ' ' 'New File' 'copied file' o",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/kcp/uis/kcp.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	24,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


