 /*
  * Khoros: $Id: kecho.h,v 1.18.2.2 1997/05/31 20:52:02 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kecho
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kecho_h_
#define _kecho_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <bootstrap.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 * what to echo (Required string toggle)
 *	toolboxes (list all the toolbox objects)
 *	path (echo the path of the object)
 *	binpath (echo the binary path of the object)
 *	lsrc (list Lex source code files in the object)
 *	allfiles (list all files in the object)
 *	objects (list the software objects in a toolbox)
 *	libpath (echo the library path of the object)
 *	allsrc (list all source code files in the object)
 *	src (list C source code files in the object)
 *	category (echo object category string)
 *	subcategory (echo object subcategory string)
 *	bname (echo the software objects binary name)
 *	fsrc (list all FORTRAN source code in the object)
 *	icon (echo the icon name for the object)
 *	object-info (echo all string attributes)
 *	description (echo the short description of the object)
 *	ysrc (list YACC source code files in the object)
 *	version (echo the version string for the object)
 *	poc (echo the point of contact string)
 *	email (echo the email address of the point of contact)
 *	keywords (list the keywords associated with the object)
 *	type (echo the object type)
 *	alib (echo the associated library)
 *	config-name (echo the configuration name used at build time),
 */
char	*echo_toggle;		/* what to echo STRING TOGGLE */
int	 echo_flag;		/* what to echo FLAG */

/*
 *  toolbox name (optional string)
 */
char	*tb_string;	/* toolbox name STRING */
int	 tb_flag;   	/* toolbox name FLAG */

/*
 *  Colonel Flag (optional flag)
 */
int	 fullpath_flag;  	/* Colonel Flag FLAG */

/*----- optional ME group ----*/
/*
 *  Program or Library Object Name (optional string)
 */
char	*oname_string;	/* Program or Library Object Name STRING */
int	 oname_flag;   	/* Program or Library Object Name FLAG */

/*
 *  type of object (optional string)
 */
char	*type_string;	/* type of object STRING */
int	 type_flag;   	/* type of object FLAG */

/*-- optional ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
extern unsigned long reqtype;
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void kecho_get_args PROTO((kaddr));
void kecho_usage_additions PROTO((void));
void kecho_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
int print_object_info    PROTO((kobject));
int kecho_print_keywords PROTO((kobject));
/* -include_routines_end */

#endif
