 /*
  * Khoros: $Id: usage.c,v 1.18.2.2 1997/05/31 20:52:04 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.18.2.2 1997/05/31 20:52:04 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kecho.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kecho_get_args
| 
|       Purpose: Gets command line args for kecho
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kecho
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kecho_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kecho is out of sync with arguments specified in kecho's *.pane file; please rerun ghostwriter on kecho.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kecho structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kecho_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "echo", KVF_TOGGLE_VAL,
			  &(clui_info->echo_toggle),
			  &(clui_info->echo_flag))))
	{
	    kerror(NULL, "kecho_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_flag(pane, "fullpath",
			  &(clui_info->fullpath_flag))))
	{
	    kerror(NULL, "kecho_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kecho_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "type",
			  &(clui_info->type_string),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kecho_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Echo attributes of toolbox or software object' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kecho",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $BOOTSTRAPBIN/kecho",
  "-H 1  5x1+41+0 'Help' 'help page for kecho' $BOOTSTRAP/objects/kroutine/kecho/help/kecho.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 0 0 50x1+2+1.5 ' ' 'Toolbox Name' 'toolbox name' tb",
  "-T 1 0 0 1 0 50x8+3+6 +0+0 1 'What To Echo?' 'what to echo' echo",
  "-s 1 0 1 1 0 10x1+2+1 'toolboxes' 'toolboxes' 'list all the toolbox objects' dummy",
  "-s 1 0 1 0 0 10x1+14+1 'path' 'path' 'echo the path of the object' dummy",
  "-s 1 0 1 0 0 10x1+26+1 'binpath' 'binpath' 'echo the binary path of the object' dummy",
  "-s 1 0 1 0 0 9.25x1+38+1 'lsrc' 'lsrc' 'list Lex source code files in the object' dummy",
  "-s 1 0 1 0 0 9.25x1+2+2 'allfiles' 'allfiles' 'list all files in the object' dummy",
  "-s 1 0 1 0 0 10x1+14+2 'objects' 'objects' 'list the software objects in a toolbox' dummy",
  "-s 1 0 1 0 0 10x1+26+2 'libpath' 'libpath' 'echo the library path of the object' dummy",
  "-s 1 0 1 0 0 10x1+26+3 'allsrc' 'allsrc' 'list all source code files in the object' dummy",
  "-s 1 0 1 0 0 9.25x1+38+2 'src' 'src' 'list C source code files in the object' dummy",
  "-s 1 0 1 0 0 9.25x1+2+3 'category' 'category' 'echo object category string' dummy",
  "-s 1 0 1 0 0 10.625x1+14+3 'subcategory' 'subcategory' 'echo object subcategory string' dummy",
  "-s 1 0 1 0 0 10x1+26+4 'bname' 'bname' 'echo the software objects binary name' dummy",
  "-s 1 0 1 0 0 9.25x1+38+3 'fsrc' 'fsrc' 'list all FORTRAN source code in the object' dummy",
  "-s 1 0 1 0 0 10x1+2+4 'icon' 'icon' 'echo the icon name for the object' dummy",
  "-s 1 0 1 0 0 10.625x1+14+4 'object-info' 'object-info' 'echo all string attributes' dummy",
  "-s 1 0 1 0 0 11.375x1+26+5 'description' 'description' 'echo the short description of the object' dummy",
  "-s 1 0 1 0 0 9.25x1+38+4 'ysrc' 'ysrc' 'list YACC source code files in the object' dummy",
  "-s 1 0 1 0 0 10x1+2+5 'version' 'version' 'echo the version string for the object' dummy",
  "-s 1 0 1 0 0 10x1+14+5 'poc' 'poc' 'echo the point of contact string' dummy",
  "-s 1 0 1 0 0 10x1+26+6 'email' 'email' 'echo the email address of the point of contact' dummy",
  "-s 1 0 1 0 0 10x1+38+5 'keywords' 'keywords' 'list the keywords associated with the object' dummy",
  "-s 1 0 1 0 0 10x1+2+6 'type' 'type' 'echo the object type' dummy",
  "-s 1 0 1 0 0 10x1+14+6 'alib' 'alib' 'echo the associated library' dummy",
  "-s 1 0 1 0 0 10x1+38+6 'config-name' 'config-name' 'echo the configuration name used at build time' dummy",
  "-E",
  "-t 1 0 1 0 0 19.625x1+3+14 'Generate explicit path' 'Colonel Flag' fullpath",
  "-C 0",
  "-s 1 0 1 0 0 50x1+2+3 ' ' 'Object Name' 'Program or Library Object Name' oname",
  "-s 1 0 1 0 0 50x1+2+4.5 ' ' 'Object Type' 'type of object' type",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/kecho/uis/kecho.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	44,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


