 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 20:52:19 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 20:52:19 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kexec.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kexec_get_args
| 
|       Purpose: Gets command line args for kexec
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kexec
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kexec_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kexec is out of sync with arguments specified in kexec's *.pane file; please rerun ghostwriter on kexec.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kexec structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "cmd",
			  &(clui_info->cmd_string),
			  &(clui_info->cmd_flag))))
	{
	    kerror(NULL, "kexec_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "args",
			  &(clui_info->args_string),
			  &(clui_info->args_flag))))
	{
	    kerror(NULL, "kexec_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "m",
			  &(clui_info->m_string),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "kexec_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kexec_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kexec_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Execute a process' kexec",
  "-P 1 0 52x1+0+1 +27+0 ' ' kexec_pane",
  "-D 1 0 9.25x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $GUIBIN/kexec",
  "-H 1  5x1+41+0 'Help' 'man page for kexec' $BOOTSTRAP/objects/kroutine/kexec/help/kexec.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 1 0 50.25x1+1+4 ' ' 'Command' 'command to be executed' cmd",
  "-s 1 0 1 1 0 50.25x1+1+6 ' ' 'Arguments' 'command arguments' args",
  "-s 1 0 1 0 0 50.75x1+1+7 ' ' 'machine     ' 'machine' m",
  "-B 0",
  "-s 1 0 1 1 0 51x1+1+2 ' ' 'Toolbox Name' 'toolbox to execute object from' tb",
  "-s 1 0 1 1 0 51x1+1+3 ' ' 'Object Name ' 'Program Object Name to be executed' oname",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/kexec/uis/kexec.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


