 /*
  * Khoros: $Id: kgendepend.c,v 1.15.2.2 1997/05/31 20:52:30 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: kgendepend.c,v 1.15.2.2 1997/05/31 20:52:30 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for kgendepend
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "kgendepend.h"

/*-----------------------------------------------------------
|
|  Routine Name: main() - Update Makefile for dependencies on *.h files.
|
|       Purpose: main program for kgendepend
|
|         Input:
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
	kform *pane;
/* -main_variable_list_end */

	khoros_init(argc, argv, "BOOTSTRAP", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$BOOTSTRAP/objects/kroutine/kgendepend");
/* -main_get_args_call */
        /*
         *      IMPORTANT NOTE  (Danielle, Jan 20, 1997): 
         *
         * kgendepend must call kgen_init, kexit_handler, kman_get_args and 
         * kvf_destroy_form itself, rather than making one call to kclui_init.
         * The reason for this is that kclui_init makes a call to 
         * kclui_check_args, which will error out if it sees syntax like
         * "-- -I/research/devel/mirage/design/include", something kgendepend
	 * must support for when it gets called by kgenmake.
	 */
	pane = kgen_init("BOOTSTRAP", "kgendepend", KGEN_KROUTINE, 
			 &clui_uis_spec, kgendepend_usage_additions);
	kexit_handler(kgendepend_free_args, NULL);
        kgendepend_get_args(pane);
        kvf_destroy_form(pane);
/* -main_get_args_call_end */

/* -main_before_lib_call */
/* -main_before_lib_call_end */

/* -main_library_call */
	process_depend(argc, argv);
/* -main_library_call_end */

/* -main_after_lib_call */
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: kgendepend_usage_additions
| 
|       Purpose: Prints usage additions in kgendepend_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgendepend
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgendepend_usage_additions(void)
{
	kfprintf(kstderr, "\tUpdate Makefile for dependencies on *.h files.\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: kgendepend_free_args
| 
|       Purpose: Frees CLUI struct allocated in kgendepend_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgendepend
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
kgendepend_free_args(
    kexit_status status,
    kaddr        client_data)
{
/* -free_handler_additions */
/* -free_handler_additions_end */
}
