 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:52:48 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:52:48 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgenimake.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgenimake_get_args
| 
|       Purpose: Gets command line args for kgenimake
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenimake
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgenimake_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgenimake is out of sync with arguments specified in kgenimake's *.pane file; please rerun ghostwriter on kgenimake.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgenimake structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "recreate",
			  &(clui_info->recreate_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dir",
			  &(clui_info->dir_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mdir",
			  &(clui_info->mdir_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "example",
			  &(clui_info->example_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "manual",
			  &(clui_info->manual_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "xexample",
			  &(clui_info->xexample_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mindex",
			  &(clui_info->mindex_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "testsuite",
			  &(clui_info->testsuite_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mglossary",
			  &(clui_info->mglossary_flag))))
	{
	    kerror(NULL, "kgenimake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create or update Imakefile according to directory contents' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kgenimake",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute kgenimake' $BOOTSTRAPBIN/kgenimake",
  "-H 1  5x1+41+0 'Help' 'help page for absolute value' $BOOTSTRAP/objects/kroutine/kgenimake/help/kgenimake.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 1 0 40x1+2+1.5 ' ' 'Toolbox Name' 'Toolbox name' tb",
  "-t 1 0 1 0 0 8.375x1+2+9.5 'Recreate' 'Recreate Imakefile from template' recreate",
  "-C 0",
  "-s 1 0 1 1 0 40x1+2+3 ' ' 'Object Name ' 'The object name' oname",
  "-t 1 0 1 0 0 16.625x1+2+5 'Directory Imakefile' 'create directory imakefile' dir",
  "-t 1 0 1 0 0 21.875x1+28+5 'Manual Directory Imakefile' 'create manual directory imakefile' mdir",
  "-t 1 0 1 0 0 15.125x1+2+6 'Example Imakefile' 'create example imakefile' example",
  "-t 1 0 1 0 0 14.375x1+28+6 'Manual Imakefile' 'create manual imakefile' manual",
  "-t 1 0 1 0 0 18.125x1+2+7 'X11 Example Imakefile' 'create X11 example imakefile' xexample",
  "-t 1 0 1 0 0 18.875x1+28+7 'Manual Index Imakefile' 'create manual index Imakefile' mindex",
  "-t 1 0 1 0 0 16.625x1+2+8 'Testsuite Imakefile' 'create testsuite imakefile' testsuite",
  "-t 1 0 1 0 0 21.125x1+28+8 'Manual Glossary Imakefile' 'create manual glossary Imakefile' mglossary",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/kgenimake/uis/kgenimake.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	25,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


