/*
  * Khoros: $Id: kgenmake.h,v 1.7.2.2 1997/05/31 20:52:58 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kgenmake
   >>>> 
   >>>>    Written By: Mark Young & Steve Jorgensen
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: May 02, 1995
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kgenmake_h_
#define _kgenmake_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

/* -include_includes */
#if defined(__STDC__) || defined(__stdc__) || defined(__cplusplus)
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE
#endif

#ifndef _XOPEN_SOURCE
#define _XOPEN_SOURCE
#endif

#define PROTO(s)       s
#define KPARAM(t,v)    t v
#define KNONE	       void
#define KDECL(line)
#define CONCAT(x,y)    x ## y

#else

#undef  _POSIX_SOURCE
#undef  _XOPEN_SOURCE

#define PROTO(s)       ()
#define KPARAM(t,v)    v
#define KNONE
#define KDECL(line)    line
#define CONCAT(x,y)    x/**/y
#endif

#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <stddef.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/stat.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
#define LENGTH 1024
#define TABLESIZE 1024
#define TRUE  1
#define FALSE 0
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

/* -include_typedefs */
typedef struct _kilist
{
        int   identifier;
        char *client_data;
        unsigned char head;

        struct _kilist *next, *prev;
} kilist;
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define kstring_copy(x,y)       (kstring_3cat(x, NULL, NULL, y))
#define kstring_cat(x,y,z)      (kstring_3cat(x, y, NULL, z))
#define kstrdup(x)              (kstring_3cat(x, NULL, NULL, NULL))
#define kstrlen(x)              (((x) == NULL) ? 0 : strlen(x))
#define kmalloc(x)              (((x) == 0) ? NULL : malloc((size_t)(x)))
#define kcalloc(x,y)            (((x) == 0 || (y) == 0) ? NULL : calloc((size_t)(x),(size_t)(y)))
#define krealloc(x,y)           (((y) == 0) ? NULL : (((x) == NULL) ? malloc((size_t)(y)) : realloc((x),(size_t)(y))))
#undef kfree_and_NULL
#define kfree_and_NULL(x)                if ((x) != NULL) free(x)
#define kabs(x)                 (((x) < 0) ? (-(x)) : (x))
#define kmax(x, y)              (((x) < (y)) ? ((y)) : (x))
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));

/* -include_routines */
void process_make PROTO((int, char **));

/* line.c */
char *KReadLine PROTO((FILE *));
char *KProcessLine PROTO((char *));
char *kre_comp PROTO((char *));
int kre_exec PROTO((char *));
int kre_subs PROTO((char *, char *));
int kcpp PROTO((FILE *));
char *SpecExpand PROTO((char *));
char *kstrcpy PROTO((char *, char *));
char *kstrstr PROTO((char *, char *));
kilist *kilist_head PROTO((kilist *));
kilist *kilist_tail PROTO((kilist *));
kilist *kilist_locate PROTO((kilist *, int));
kilist *kilist_locate_clientdata PROTO((kilist *, char *));
kilist *kilist_add PROTO((kilist *, int, char *));
kilist *kilist_push PROTO((kilist *, int, char *));
kilist *kilist_pop PROTO((kilist *));
kilist *kilist_delete PROTO((kilist *, int));
char *kstring_3cat PROTO((char *, char *, char *, char *));
char *kstring_cleanup PROTO((char *, int, char *));
char *kstring_replace PROTO((char *, char *, char *, char *));
long khash PROTO((char *, int));
int ktoken_find PROTO((char *, int, int *));
int kstring_to_token PROTO((char *));
char *ktoken_to_string PROTO((int));

/* -include_routines_end */

#endif /* _kdenmake_h_ */
/* Don't add after this point */
