/*
  * Khoros: $Id: kimake.h,v 1.10 1997/02/07 22:57:40 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: This file contains the Operating System
   >>>>		       and Architecture definitions.
   >>>>
   >>>>    Written By: Mark Young & John Salas
   >>>>
   >>>>          Date: May 27, 1995
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kimake_h_
#define _kimake_h_

        /*-------------------------------------*
        |       #include 
        ---------------------------------------*/


        /*-------------------------------------*
        |       #defines 
        ---------------------------------------*/

/*
 * To add support for another platform:
 *
 *     1.  Identify a machine-specific cpp symbol.  If your preprocessor
 *         doesn't have any built in, you'll need to add the symbol to the
 *         cpp_argv table in util/imake/imake.c and rebuild imake with the
 *         BOOTSTRAPCFLAGS variable set (see the macII for an example).
 *
 *     2.  Add all machine-specific cpp symbols (either defined by you or by
 *         the preprocessor or compiler) to the predefs table in
 *         util/makedepend/main.c.
 *
 *     3.  But a new #ifdef block below that defines MacroIncludeFile
 *         for your new platform and then #undefs the machine-specific
 *         preprocessor symbols (to avoid problems with file names).
 *
 *     4.  Create a .cf file with the name given by the MacroIncludeFile.
 */

/*
 *  Defines for raw storage format of the different architecture
 *  definitions
 *	 KARCH_ALPHA	 	supported
 *	 KARCH_VAX	 	supported
 *	 KARCH_SPARC	 	supported
 *	 KARCH_I80x86	 	supported
 *	 KARCH_MC680x0	 	supported
 *	 KARCH_MIPSEB		supported
 *	 KARCH_NS32000		supported
 *	 KARCH_MIPSEL		supported
 *	 KARCH_APOLLO		supported
 *	 KARCH_PARISC		supported
 *	 KARCH_CRAY		supported
 *	 KARCH_RS6000		supported
 *	 KARCH_CONVEX		supported
 *	 KARCH_M88x00		supported
 *	 KARCH_I860		supported
 */

/*
 *   Get the correct machine
 */
                     /* This one for ALPHA */
#ifdef KARCH_ALPHA
#define KARCH_NAME "KARCH_ALPHA"
#endif
                     /* This one for VAX */
#ifdef KARCH_VAX
#define KARCH_NAME "KARCH_VAX"
#endif
                     /* This one for SPARC */
#ifdef KARCH_SPARC
#define KARCH_NAME "KARCH_SPARC"
#endif
                     /* This one for I80x86 */
#ifdef KARCH_I80x86
#define KARCH_NAME "KARCH_I80x86"
#endif
                     /* This one for MC680x0 */
#ifdef KARCH_MC680x0
#define KARCH_NAME "KARCH_MC680x0"
#endif
                     /* This one for MIPSEB */
#ifdef KARCH_MIPSEB
#define KARCH_NAME "KARCH_MIPSEB"
#endif
                     /* This one for NS32000 */
#ifdef KARCH_NS32000
#define KARCH_NAME "KARCH_NS32000"
#endif
                     /* This one for MIPSEL */
#ifdef KARCH_MIPSEL
#define KARCH_NAME "KARCH_MIPSEL"
#endif
                     /* This one for APOLLO */
#ifdef KARCH_APOLLO
#define KARCH_NAME "KARCH_APOLLO"
#endif
                     /* This one for PARISC */
#ifdef KARCH_PARISC
#define KARCH_NAME "KARCH_PARISC"
#endif
                     /* This one for CRAY */
#ifdef KARCH_CRAY
#define KARCH_NAME "KARCH_CRAY"
#endif
                     /* This one for CRAY T3E */
#ifdef KARCH_CRAY_T3E
#define KARCH_NAME "KARCH_CRAY_T3E"
#endif
                     /* This one for RS6000 */
#ifdef KARCH_RS6000
#define KARCH_NAME "KARCH_RS6000"
#endif
                     /* This one for CONVEX */
#ifdef KARCH_CONVEX
#define KARCH_NAME "KARCH_CONVEX"
#endif
                     /* This one for M88x00 */
#ifdef KARCH_M88x00
#define KARCH_NAME "KARCH_M88x00"
#endif
                     /* This one for I860 */
#ifdef KARCH_I860
#define KARCH_NAME "KARCH_I860"
#endif

#if !defined(KARCH_NAME)
#define KARCH_NAME "KARCH_UNKNOWN"
#endif

/*
 *  Defines for raw storage format of the different operating system
 *  definitions
 *	 KOPSYS_UNKNOWN	 	integrated
 *	 KOPSYS_OSF	 	ported
 *	 KOPSYS_OSF1	 	ported
 *	 KOPSYS_AIX	 	ported
 *	 KOPSYS_HPUX	 	ported
 *	 KOPSYS_SUNOS		ported
 *	 KOPSYS_SOLARIS		ported
 *	 KOPSYS_ULTRIX		not ported
 *	 KOPSYS_IRIX		ported
 *	 KOPSYS_UNICOS		ported
 *	 KOPSYS_UNICOSMK	ported
 *	 KOPSYS_DGUX		ported
 *	 KOPSYS_BSDI		ported
 *	 KOPSYS_LINUX		ported
 *	 KOPSYS_386BSD		not ported
 *	 KOPSYS_NETBSD		not ported
 *	 KOPSYS_FREEBSD		ported
 *	 KOPSYS_INTERACTIVE	not ported
 *	 KOPSYS_SCO		not ported
 *	 KOPSYS_CONVEX		not ported
 *	 KOPSYS_APOLLO		not ported
 *	 KOPSYS_SVR3		not ported
 *	 KOPSYS_NEXT		not ported
 *	 KOPSYS_AUX	 	not ported
 *	 KOPSYS_NEWSOS		not ported
 *	 KOPSYS_LUNA		not ported
 *	 KOPSYS_DYNIX		ported
 *	 KOPSYS_EXEMPLAR	ported
 */

/*
 *   Get the correct operating system
 */
                     /* This one for OSF */
#ifdef KOPSYS_OSF
#define KOPSYS_NAME "KOPSYS_OSF"
#endif
                     /* This one for OSF1 */
#ifdef KOPSYS_OSF1
#define KOPSYS_NAME "KOPSYS_OSF1"
#endif
                     /* This one for AIX */
#ifdef KOPSYS_AIX
#define KOPSYS_NAME "KOPSYS_AIX"
#define DEFAULT_CPP "/usr/lpp/X11/Xamples/util/cpp/cpp"
#endif
                     /* This one for HPUX */
#ifdef KOPSYS_HPUX
#define KOPSYS_NAME "KOPSYS_HPUX"
#define DEFAULT_CPP "cc -E"
#define FIXUP_CPP_WHITESPACE
#endif
                     /* This one for SUNOS */
#ifdef KOPSYS_SUNOS
#define KOPSYS_NAME "KOPSYS_SUNOS"
#endif
                     /* This one for SOLARIS */
#ifdef KOPSYS_SOLARIS
#define KOPSYS_NAME "KOPSYS_SOLARIS"
#define DEFAULT_CPP "/usr/ccs/lib/cpp"
#endif
                     /* This one for ULTRIX */
#ifdef KOPSYS_ULTRIX
#define KOPSYS_NAME "KOPSYS_ULTRIX"
#endif
                     /* This one for IRIX */
#ifdef KOPSYS_IRIX
#define KOPSYS_NAME "KOPSYS_IRIX"
#endif
                     /* This one for UNICOS */
#ifdef KOPSYS_UNICOS
#define KOPSYS_NAME "KOPSYS_UNICOS"
#define DEFAULT_CPP "/opt/ctl/bin/cpp -N"
#endif
                     /* This one for UNICOS */
#ifdef KOPSYS_UNICOSMK
#define KOPSYS_NAME "KOPSYS_UNICOSMK"
#define DEFAULT_CPP "/opt/ctl/bin/cpp -N"
#endif
                     /* This one for DGUX */
#ifdef KOPSYS_DGUX
#define KOPSYS_NAME "KOPSYS_DGUX"
#endif
                     /* This one for BSDI */
#ifdef KOPSYS_BSDI
#define KOPSYS_NAME "KOPSYS_BSDI"
#define DEFAULT_CPP "/usr/bin/cpp"
#endif
                     /* This one for LINUX */
#ifdef KOPSYS_LINUX
#define KOPSYS_NAME "KOPSYS_LINUX"
#define DEFAULT_CPP "/lib/cpp -traditional"
#endif
                     /* This one for 386BSD */
#ifdef KOPSYS_386BSD
#define KOPSYS_NAME "KOPSYS_386BSD"
#define DEFAULT_CPP "/usr/libexec/cpp"
#endif
                     /* This one for NETBSD */
#ifdef KOPSYS_NETBSD
#define KOPSYS_NAME "KOPSYS_NETBSD"
#define DEFAULT_CPP "/usr/libexec/cpp"
#endif
                     /* This one for FREEBSD */
#ifdef KOPSYS_FREEBSD
#define KOPSYS_NAME "KOPSYS_FREEBSD"
#define DEFAULT_CPP "/usr/libexec/cpp -traditional"
#endif
                     /* This one for INTERACTIVE */
#ifdef KOPSYS_INTERACTIVE
#define KOPSYS_NAME "KOPSYS_INTERACTIVE"
#endif
                     /* This one for SCO UNIX */
#ifdef KOPSYS_SCO
#define KOPSYS_NAME "KOPSYS_SCO"
#endif
                     /* This one for CONVEX */
#ifdef KOPSYS_CONVEX
#define KOPSYS_NAME "KOPSYS_CONVEX"
#endif
                     /* This one for APOLLO */
#ifdef KOPSYS_APOLLO
#define KOPSYS_NAME "KOPSYS_APOLLO"
#define DEFAULT_CPP "/usr/lib/cpp"
#endif
                     /* This one for SVR3 */
#ifdef KOPSYS_SVR3
#define KOPSYS_NAME "KOPSYS_SVR3"
#endif
                     /* This one for NEXT */
#ifdef KOPSYS_NEXT
#define KOPSYS_NAME "KOPSYS_NEXT"
#endif
                     /* This one for AUX */
#ifdef KOPSYS_AUX
#define KOPSYS_NAME "KOPSYS_AUX"
#endif
                     /* This one for NEWSOS */
#ifdef KOPSYS_NEWSOS
#define KOPSYS_NAME "KOPSYS_NEWSOS"
#endif
                     /* This one for LUNA */
#ifdef KOPSYS_LUNA
#define KOPSYS_NAME "KOPSYS_LUNA"
#endif

		     /* This one for Sequent Dynix/Ptx */
#ifdef KOPSYS_DYNIX
#define KOPSYS_NAME "KOPSYS_DYNIX"
#endif

		     /* This one for HP Convex Exemplar */
#ifdef KOPSYS_EXEMPLAR
#define KOPSYS_NAME "KOPSYS_EXEMPLAR"
#endif

#if !defined(KOPSYS_NAME)
#define KOPSYS_NAME "KOPSYS_UNKNOWN"
#endif

#if !defined(KCONFIG_DEFINE)
#define KCONFIG_NAME "generic"
#endif

#ifndef DEFAULT_CPP
#   define DEFAULT_CPP "/lib/cpp"
#endif

        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/


#endif /* _kimake_h_ */
/* Don't add after this point */
