 /*
  * Khoros: $Id: kgenmanual.c,v 1.14.2.2 1997/05/31 20:53:13 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: kgenmanual.c,v 1.14.2.2 1997/05/31 20:53:13 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for kgenmanual
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "kgenmanual.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Generates the manual for a toolbox.
|
|       Purpose: main program for kgenmanual
|
|         Input:
|		char *clui_info->tb_string; {toolbox name}
|		int   clui_info->tb_flag; {TRUE if -tb specified}
|
|		char *clui_info->i_file; {Input Filename}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->o_file; {Output Filename}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
/* -main_variable_list_end */

	khoros_init(argc, argv, "BOOTSTRAP", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$BOOTSTRAP/objects/kroutine/kgenmanual");
	kexit_handler(kgenmanual_free_args, NULL);

/* -main_get_args_call */
	kclui_init("BOOTSTRAP", "kgenmanual", KGEN_KROUTINE,  &clui_uis_spec,
		   kgenmanual_usage_additions, kgenmanual_get_args,
 		   kgenmanual_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
/* -main_before_lib_call_end */

/* -main_library_call */
   if (!run_kgenmanual(clui_info->i_file, clui_info->o_file))
   {
      kerror(NULL, "main()",
	     "An Error occured during the generation of the output file\n"
	     "'%s'\nAs a result the output file was not generated\n",
	     clui_info->o_file);
      kexit(KEXIT_FAILURE);
   }
/* -main_library_call_end */

/* -main_after_lib_call */
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: kgenmanual_usage_additions
| 
|       Purpose: Prints usage additions in kgenmanual_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenmanual
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgenmanual_usage_additions(void)
{
	kfprintf(kstderr, "\tGenerates the manual for a toolbox.\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: kgenmanual_free_args
| 
|       Purpose: Frees CLUI struct allocated in kgenmanual_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenmanual
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
kgenmanual_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->tb_string);
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
