 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:53:16 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:53:16 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgenmanual.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgenmanual_get_args
| 
|       Purpose: Gets command line args for kgenmanual
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenmanual
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgenmanual_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgenmanual is out of sync with arguments specified in kgenmanual's *.pane file; please rerun ghostwriter on kgenmanual.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgenmanual structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kgenmanual_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kgenmanual_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kgenmanual_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generates the manual for a toolbox.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kgenmanual",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute kgenmanual' $BOOTSTRAPBIN/kgenmanual",
  "-H 1  5x1+41+0 'Help' 'help page for kgenmanual' $BOOTSTRAP/objects/kroutine/kgenmanual/help/kgenmanual.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 0 1 0 53.75x1+1+1 ' ' 'Toolbox  Name ' 'toolbox name' tb",
  "-I 1 0 0 1 1 1 52x1+0+2 ' ' 'Input filename (chaptername.man)' 'Input Filename' i",
  "-O 1 0 0 1 1 1 52x1+0+3 ' ' 'Output filename (chaptername.ms)' 'Output Filename' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/kgenmanual/uis/kgenmanual.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


