 /*
  * Khoros: $Id: usage.c,v 1.15.2.3 1997/05/31 20:53:32 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.3 1997/05/31 20:53:32 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgenobj.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgenobj_get_args
| 
|       Purpose: Gets command line args for kgenobj
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenobj
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgenobj_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgenobj is out of sync with arguments specified in kgenobj's *.pane file; please rerun ghostwriter on kgenobj.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgenobj structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "description",
			  &(clui_info->description_string),
			  &(clui_info->description_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "temp_obj",
			  &(clui_info->temp_obj_string),
			  &(clui_info->temp_obj_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "temp_tb",
			  &(clui_info->temp_tb_string),
			  &(clui_info->temp_tb_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "bname",
			  &(clui_info->bname_string),
			  &(clui_info->bname_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "icon_name",
			  &(clui_info->icon_name_string),
			  &(clui_info->icon_name_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "author",
			  &(clui_info->author_string),
			  &(clui_info->author_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "email",
			  &(clui_info->email_string),
			  &(clui_info->email_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "form",
			  &(clui_info->form_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "lang", KVF_TOGGLE_VAL,
			  &(clui_info->lang_toggle),
			  &(clui_info->lang_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_value(pane, "type", KVF_TOGGLE_VAL,
			  &(clui_info->type_toggle),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_flag(pane, "pane",
			  &(clui_info->pane_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "cantata",
			  &(clui_info->cantata_logic),
			  &(clui_info->cantata_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "cat",
			  &(clui_info->cat_string),
			  &(clui_info->cat_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "subcat",
			  &(clui_info->subcat_string),
			  &(clui_info->subcat_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "lib",
			  &(clui_info->lib_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "lname",
			  &(clui_info->lname_string),
			  &(clui_info->lname_flag))))
	{
	    kerror(NULL, "kgenobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate a software object from scratch.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kgenobj",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute kgenobj' $BOOTSTRAPBIN/kgenobj",
  "-H 1  5x1+41+0 'Help' 'man page for absolute value' $BOOTSTRAP/objects/kroutine/kgenobj/help/kgenobj.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 0 1 0 52x1+0+1.5 ' ' 'Toolbox  Name ' 'toolbox name' tb",
  "-s 1 0 0 1 0 52x1+0+2.5 ' ' 'Object   Name ' 'object name' oname",
  "-s 1 0 1 1 0 52x1+0+4 ' ' 'Short Description' 'short description of object' description",
  "-s 1 0 1 1 0 52x1+0+5.5 ' ' 'Template Object ' 'Software object to use as a template' temp_obj",
  "-s 1 0 1 1 0 52x1+0+6.5 ' ' 'Template Toolbox' 'Toolbox Template Object is in.  If not specified, it assumes the toolbox for the new object' temp_tb",
  "-s 1 0 1 1 0 52x1+0+7.5 ' ' 'Binary   Name   ' 'binary name' bname",
  "-s 1 0 1 1 0 52x1+0+8.5 ' ' 'Icon Name' 'name for icon or glyph' icon_name",
  "-s 1 0 1 1 0 52x1+0+9.5 ' ' 'Author' 'name of object author' author",
  "-s 1 0 1 1 0 52x1+0+10.5 ' ' 'Email Address' 'email address of object author' email",
  "-t 1 0 1 0 0 12.875x1+0+13.5 'Form UIS File' 'Start a *.form file for the object' form",
  "-T 1 0 1 1 0 25.625x8+0+15 +2.375+0 1 'Alternate programming language' 'Alternate programming language' lang",
  "-s 1 0 1 1 0 6x1+4+1 'none' 'none' 'none' dummy",
  "-s 1 0 1 0 0 6x1+4+2 'C++' 'C++' 'C++' dummy",
  "-s 1 0 1 0 0 7x1+4+3 'fortran' 'fortran' 'fortran' dummy",
  "-s 1 0 1 0 0 6x1+4+4 'perl' 'perl' 'perl' dummy",
  "-s 1 0 1 0 0 6x1+4+5 'csh' 'csh' 'csh' dummy",
  "-s 1 0 1 0 0 6x1+4+6 'sh' 'sh' 'sh' dummy",
  "-s 1 0 1 0 0 6x1+4+7 'ksh' 'ksh' 'ksh' dummy",
  "-E",
  "-T 1 0 0 1 0 25x8+32+15 +0+0 1 'Object Type' 'type of object' type",
  "-s 1 0 1 1 0 9x1+4+1 'kroutine' 'kroutine' 'kroutine' dummy",
  "-s 1 0 1 0 0 10x1+4+2 'xvroutine' 'xvroutine' 'xvroutine' dummy",
  "-s 1 0 1 0 0 15x1+4+3 'example' 'example' 'example' dummy",
  "-s 1 0 1 0 0 18x1+4+4 'testsuite' 'testsuite' 'testsuite' dummy",
  "-s 1 0 1 0 0 18x1+4+5 'library' 'library (library)' 'library' dummy",
  "-s 1 0 1 0 0 18x1+4+6 'script' 'script (shell script)' 'script' dummy",
  "-s 1 0 1 0 0 18x1+4+7 'pane' 'pane (pane only)' 'pane' dummy",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 12.875x1+0+12 'Pane UIS File' 'Start a *.pane file for the object' pane",
  "-l 1 0 1 0 0 29.75x1+15+12 0 'Available from Cantata?' 'No' 'Yes' 'Will this object be available from Cantata?' cantata",
  "-s 1 0 1 0 0 42.25x1+15+13 ' ' 'Category     Name ' 'category name' cat",
  "-s 1 0 1 0 0 42.25x1+15+14 ' ' 'Subcategory  Name ' 'subcategory name' subcat",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 24.625x1+0+23.5 'Generate l*.c file?' 'Allow the user to specify whether or not to create a l*.c file' lib",
  "-s 1 0 1 0 0 39.25x1+0+24.5 'lname' 'library object name' 'library object to associate l*.c with' lname",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/kgenobj/uis/kgenobj.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	50,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


