 /*
  * Khoros: $Id: kgenstruct.c,v 1.17.2.2 1997/05/31 20:53:44 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: kgenstruct.c,v 1.17.2.2 1997/05/31 20:53:44 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for kgenstruct
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "kgenstruct.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Generates code used by the structure read and write code
|
|       Purpose: main program for kgenstruct
|
|         Input:
|		char *clui_info->x_file; {structure specification}
|		int   clui_info->x_flag; {TRUE if -x specified}
|
|		M.I. group:
|		    char *clui_info->tb_string; {Toolbox to run kgenstruct on}
|		    int   clui_info->tb_flag; {TRUE if -tb specified}
|
|		    char *clui_info->oname_string; {Object name to run kgenstruct on}
|		    int   clui_info->oname_flag; {TRUE if -oname specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
   kobject tb           = NULL;
   kobject cmobj        = NULL;
   kstring toolbox_name = NULL;
   kstring object_name  = NULL;
/* -main_variable_list_end */

	khoros_init(argc, argv, "BOOTSTRAP", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$BOOTSTRAP/objects/kroutine/kgenstruct");
	kexit_handler(kgenstruct_free_args, NULL);

/* -main_get_args_call */
	kclui_init("BOOTSTRAP", "kgenstruct", KGEN_KROUTINE,  &clui_uis_spec,
		   kgenstruct_usage_additions, kgenstruct_get_args,
 		   kgenstruct_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
   if (clui_info->tb_flag)
      toolbox_name = clui_info->tb_string;
   if (clui_info->oname_flag)
      object_name = clui_info->oname_string;

   /*-- we'll generate to ./ if we can't get these --*/ 
   kcms_get_imake_symbols(&toolbox_name, &object_name, NULL, NULL);

   /*-- if we got just a toolbox, then we are an example/testsuite --*/
   if (toolbox_name && (object_name == NULL))
      toolbox_name = NULL;
/* -main_before_lib_call_end */

/* -main_library_call */
   if (toolbox_name != NULL)
      if ((tb = kcms_open_toolbox(toolbox_name)) == NULL)
      {
         if (toolbox_name != NULL)
            kerror(NULL, "Open Toolbox", "Unable to open toolbox `%s'.",
	           toolbox_name);
         else
	    kerror(NULL, "Open Toolbox", "Unable to open a NULL toolbox name.");
         kexit(KEXIT_FAILURE);
      }

   if (tb)
      if ((cmobj = kcms_open_cmobj(tb, object_name)) == NULL)
      {
         kcms_close(tb);
         if (object_name != NULL)
            kerror(NULL, "Open Object",
	   	   "Unable to open object `%s' in toolbox '%s'.",
		   object_name, toolbox_name);
         else
	    kerror(NULL, "Open Object" ,"Unable to open NULL object name.");
         kexit(KEXIT_FAILURE);
      }

   c_output(clui_info->x_file, cmobj);
   reinitialize();
   h_output(clui_info->x_file, cmobj);
/* -main_library_call_end */

/* -main_after_lib_call */
   if (tb) kcms_close(tb);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: kgenstruct_usage_additions
| 
|       Purpose: Prints usage additions in kgenstruct_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenstruct
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgenstruct_usage_additions(void)
{
	kfprintf(kstderr, "\tGenerates code used by the structure read and write code\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: kgenstruct_free_args
| 
|       Purpose: Frees CLUI struct allocated in kgenstruct_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenstruct
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
kgenstruct_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->x_file);
		kfree_and_NULL(clui_info->tb_string);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
