/*
  * Khoros: $Id: rpc_hout.c,v 1.7 1997/01/20 03:58:54 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: rpc_hout.c,v 1.7 1997/01/20 03:58:54 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>      	      RPC .h Generator Code
   >>>>
   >>>>	  This was khoros-ized from the file rpc_hout.c 
   >>>>   in the program rpcgen by Sun Microsystems, Inc. 
   >>>>
   >>>>   Static:
   >>>>			pconstdef()
   >>>>			pstructdef()
   >>>>			puniondef()
   >>>>			pdefine()
   >>>>			puldefine()
   >>>>			define_printed()
   >>>>			pprogramdef()
   >>>>			pprocdef()
   >>>>			penumdef()
   >>>>			ptypedef()
   >>>>			pdeclaration()
   >>>>  Private:
   >>>>			print_datadef()
   >>>>   Public:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

/* @(#)rpc_hout.c	2.1 88/08/01 4.0 RPCSRC */
/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user.
 * 
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 * 
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 * 
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 * 
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 * 
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * rpc_hout.c, Header file outputter for the RPC protocol compiler 
 * Copyright (C) 1987, Sun Microsystems, Inc. 
 */
#include "kgenstruct.h"

static void pheader        PROTO((char *));
static void pproto         PROTO((char *));
static void pconstdef      PROTO((definition *));
static void pstructdef     PROTO((definition *));
static void puniondef      PROTO((definition *));
static void pdefine        PROTO((char *, char *));
static void puldefine      PROTO((char *, char *));
static int  define_printed PROTO((proc_list *, version_list *));
static void pprogramdef    PROTO((definition *));
static void pprocdef       PROTO((proc_list *, version_list *));
static void penumdef       PROTO((definition *));
static void ptypedef       PROTO((definition *));
static void pdeclaration   PROTO((char *, declaration *, int));

/*
 * Print the C-version of an xdr definition 
 */
void
print_datadef(definition *def)
{
   if (def->def_kind != DEF_CONST) 
      kfprintf(fout, "\n");

   switch (def->def_kind) 
   {
      case DEF_STRUCT:
         pheader(def->def_name);
	 pstructdef(def);
	 break;
      case DEF_UNION:
         pheader(def->def_name);
	 puniondef(def);
	 break;
      case DEF_ENUM:
         pheader(def->def_name);
	 penumdef(def);
	 break;
      case DEF_TYPEDEF:
         pheader(def->def_name);
	 ptypedef(def);
	 break;
      case DEF_PROGRAM:
	 pprogramdef(def);
	 break;
      case DEF_CONST:
	 pconstdef(def);
	 break;
   }

   if (def->def_kind != DEF_PROGRAM && def->def_kind != DEF_CONST)
      pproto(def->def_name);
   
   if (def->def_kind != DEF_CONST) 
      kfprintf(fout, "\n");

   return;
}


static void
pheader(char *name)
{
   kfprintf(fout, 
	    "   /*--------------------------------------------------------\n");
   kfprintf(fout, 
	    "   |    %s \n", name);
   kfprintf(fout, 
	    "   |    . . . . . . . . . . . . . . . . . . . .\n");
   kfprintf(fout, 
	    "   |    The type identifier for this is %s\n   |\n", 
	    type_name(name));
   kfprintf(fout, 
	    "   |    To define this as a type, call kdefine_%s()\n", name);
   kfprintf(fout, 
	    "   \\--------------------------------------------------------*/");
   kfprintf(fout, "\n\n");
   return;
}


static void
pproto(char *name)
{
   /*-- print function prototypes for the readers and writers --*/
   kfprintf(fout, "\n\n");
   kfprintf(fout, "extern int %s;\n\n", type_name(name));
   kfprintf(fout, "int  kdefine_%s PROTO((void));\n", name);
   return;
}


static void
pconstdef(definition *def)
{
   pdefine(def->def_name, def->def.co);
   return;
}

static void
pstructdef(definition *def)
{
   decl_list *l;
   char *name = def->def_name;
   
   kfprintf(fout, "struct %s {\n", name);
   for (l = def->def.st.decls; l != NULL; l = l->next) 
      pdeclaration(name, &l->decl, 1);

   kfprintf(fout, "};\n");
   return;
}

static void
puniondef(definition *def)
{
   case_list *l;
   char *name = def->def_name;
   declaration *decl;
   
   kfprintf(fout, "struct %s {\n", name);
   decl = &def->def.un.enum_decl;
   if (streq(decl->type, "bool")) 
      kfprintf(fout, "   bool_t %s;\n", decl->name);
   else 
      kfprintf(fout, "   %s %s;\n", decl->type, decl->name);

   kfprintf(fout, "   union {\n");
   for (l = def->def.un.cases; l != NULL; l = l->next) 
      pdeclaration(name, &l->case_decl, 2);

   decl = def->def.un.default_decl;
   if (decl && !streq(decl->type, "void")) 
      pdeclaration(name, decl, 2);

   kfprintf(fout, "   } %s_u;\n", name);
   kfprintf(fout, "};\n");
   kfprintf(fout, "typedef struct %s %s;\n", name, name);
   return;
}



static void
pdefine(char *name, char *num)
{
   kfprintf(fout, "#define %s %s\n", name, num);
   return;
}

static void
puldefine(char *name, char *num)
{
   kfprintf(fout, "#define %s ((u_long)%s)\n", name, num);
   return;
}

static int
define_printed(proc_list *stop, version_list *start)
{
   version_list *vers;
   proc_list *proc;
   
   for (vers = start; vers != NULL; vers = vers->next) 
   {
      for (proc = vers->procs; proc != NULL; proc = proc->next) 
      {
	 if (proc == stop) 
	    return FALSE;
	 else if (kstrcmp(proc->proc_name, stop->proc_name) == 0) 
	    return TRUE;
      }
   }
   abort();
   /* NOTREACHED */
   return FALSE;
}


static void 
pprogramdef(definition *def)
{
   version_list *vers;
   proc_list *proc;

   puldefine(def->def_name, def->def.pr.prog_num);
   for (vers = def->def.pr.versions; vers != NULL; vers = vers->next) 
   {
      puldefine(vers->vers_name, vers->vers_num);
      for (proc = vers->procs; proc != NULL; proc = proc->next) 
      {
	 if (!define_printed(proc, def->def.pr.versions)) 
	    puldefine(proc->proc_name, proc->proc_num);
	 pprocdef(proc, vers);
      }
   }
   return;
}

static void
pprocdef(proc_list *proc, version_list *vp)
{
   kfprintf(fout, "extern ");
   if (proc->res_prefix) 
   {
      if (streq(proc->res_prefix, "enum")) 
	 kfprintf(fout, "enum ");
      else
	 kfprintf(fout, "struct ");
   }
   if (streq(proc->res_type, "bool")) 
      kfprintf(fout, "bool_t 	*");
   else if (streq(proc->res_type, "string")) 
      kfprintf(fout, "char **");
   else
      kfprintf(fout, "%s *", fixtype(proc->res_type));

   pvname(proc->proc_name, vp->vers_num);
   kfprintf(fout, "();\n");
   return;
}

static void
penumdef(definition *def)
{
   char *name = def->def_name;
   enumval_list *l;
   char *last = NULL;
   int count = 0;
   
   kfprintf(fout, "enum %s {\n", name);
   for (l = def->def.en.vals; l != NULL; l = l->next) 
   {
      kfprintf(fout, "   %s", l->name);
      if (l->assignment) 
      {
	 kfprintf(fout, " = %s", l->assignment);
	 last = l->assignment;
	 count = 1;
      } 
      else 
      {
	 if (last == NULL) 
	    kfprintf(fout, " = %d", count++);
	 else 
	    kfprintf(fout, " = %s + %d", last, count++);
      }
      if (l->next != NULL) 
         kfprintf(fout, ",\n");
   }
   kfprintf(fout, "};\n");
   kfprintf(fout, "typedef enum %s %s;\n", name, name);
   return;
}

static void
ptypedef(definition *def)
{
   char *name = def->def_name;
   char *old = def->def.ty.old_type;
   char prefix[8];	/* enough to contain "struct ", including NUL */
   relation rel = def->def.ty.rel;


   if (!streq(name, old)) 
   {
      if (streq(old, "string")) 
      {
	 old = "char";
	 rel = REL_POINTER;
      } 
      else if (streq(old, "opaque")) 
	 old = "char";
      else if (streq(old, "bool")) 
	 old = "bool_t";
      
      /*-- temporary kludge for now to replace below --*/
      if (def->def.ty.old_prefix)
         s_print(prefix, "%s ", def->def.ty.old_prefix);
      else
	 prefix[0] = 0;

      kfprintf(fout, "typedef ");
      switch (rel) 
      {
	 case REL_ARRAY:
	    kfprintf(fout, "struct {\n");
	    kfprintf(fout, "   unsigned int %s_len;\n", name);
	    kfprintf(fout, "   %s%s *%s_val;\n", prefix, old, name);
	    kfprintf(fout, "} %s", name);
	    break;
	 case REL_POINTER:
	    kfprintf(fout, "%s%s *%s", prefix, old, name);
	    break;
	 case REL_VECTOR:
	    kfprintf(fout, "%s%s %s[%s]", prefix, old, name,
		    def->def.ty.array_max);
	    break;
	 case REL_ALIAS:
	    kfprintf(fout, "%s%s %s", prefix, old, name);
	    break;
      }
      kfprintf(fout, ";\n");
   }
   return;
}


static void
pdeclaration(char *name, declaration *dec, int tab)
{
   char buf[8];	/* enough to hold "struct ", include NUL */
   char *prefix;
   char *type;
   
   if (streq(dec->type, "void")) 
      return;

   tabify(fout, tab);
   if (streq(dec->type, name) && !dec->prefix) 
      kfprintf(fout, "struct ");

   if (streq(dec->type, "string")) 
   {
      kfprintf(fout, "char *%s", dec->name);
   } 
   else 
   {
      prefix = "";
      if (streq(dec->type, "bool")) 
	 type = "bool_t";
      else if (streq(dec->type, "opaque")) 
	 type = "char";
      else 
      {
	 if (dec->prefix) 
	 {
	    s_print(buf, "%s ", dec->prefix);
	    prefix = buf;
	 }
	 type = dec->type;
      }
      switch (dec->rel) 
      {
	 case REL_ALIAS:
	    kfprintf(fout, "%s%s %s", prefix, type, dec->name);
	    break;
	 case REL_VECTOR:
	    kfprintf(fout, "%s%s %s[%s]", prefix, type, dec->name,
		    dec->array_max);
	    break;
	 case REL_POINTER:
	    kfprintf(fout, "%s%s *%s", prefix, type, dec->name);
	    break;
	 case REL_ARRAY:
	    kfprintf(fout, "struct {\n");
	    tabify(fout, tab);
	    kfprintf(fout, "   unsigned int %s_len;\n", dec->name);
	    tabify(fout, tab);
	    kfprintf(fout, "   %s%s *%s_val;\n", prefix, type, dec->name);
	    tabify(fout, tab);
	    kfprintf(fout, "} %s", dec->name);
	    break;
      }
   }
   kfprintf(fout, ";\n");
   return;
}
