 /*
  * Khoros: $Id: usage.c,v 1.14.2.3 1997/05/31 20:54:02 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.3 1997/05/31 20:54:02 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgentb.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgentb_get_args
| 
|       Purpose: Gets command line args for kgentb
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgentb
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgentb_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgentb is out of sync with arguments specified in kgentb's *.pane file; please rerun ghostwriter on kgentb.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgentb structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kgentb_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "path",
			  &(clui_info->path_string),
			  &(clui_info->path_flag))))
	{
	    kerror(NULL, "kgentb_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "title",
			  &(clui_info->title_string),
			  &(clui_info->title_flag))))
	{
	    kerror(NULL, "kgentb_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "info",
			  &(clui_info->info_string),
			  &(clui_info->info_flag))))
	{
	    kerror(NULL, "kgentb_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "author",
			  &(clui_info->author_string),
			  &(clui_info->author_flag))))
	{
	    kerror(NULL, "kgentb_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "email",
			  &(clui_info->email_string),
			  &(clui_info->email_flag))))
	{
	    kerror(NULL, "kgentb_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "add",
			  &(clui_info->add_flag))))
	{
	    kerror(NULL, "kgentb_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'kgentb:  Creates a toolbox' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kgentb",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 6x1.03846+32+0 'Run' 'execute kgentb' $BOOTSTRAPBIN/kgentb",
  "-H 1  6x1.03846+39+0 'Help' 'help page for kgentb' $BOOTSTRAP/objects/kroutine/kgentb/help/kgentb.hlp help",
  "-Q 1 0 6.25x1.03846+46+0 'Close'",
  "-s 1 0 0 1 0 51x1+1+2 ' ' 'Toolbox Name' 'toolbox to create' tb",
  "-s 1 0 0 1 0 51x1+1+3 ' ' 'Toolbox Path' 'toolbox path' path",
  "-s 1 0 1 1 0 51x1+1+4.5 ' ' 'Toolbox Title ' 'toolbox title' title",
  "-s 1 0 1 1 0 51x1+1+5.5 ' ' 'Toolbox Info  ' 'toolbox description file' info",
  "-s 1 0 1 1 0 51x1+1+6.5 ' ' 'Toolbox Author' 'toolbox author' author",
  "-s 1 0 1 1 0 51x1+1+7.5 ' ' 'Author Email  ' 'toolbox author email' email",
  "-t 1 0 1 0 0 6.25x1+1+9 'Add Toolbox Instead of Generate' 'add toolbox instead of generate?' add",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/kgentb/uis/kgentb.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


