 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:54:19 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:54:19 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kman.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kman_get_args
| 
|       Purpose: Gets command line args for kman
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kman
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kman_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kman is out of sync with arguments specified in kman's *.pane file; please rerun ghostwriter on kman.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kman structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "k",
			  &(clui_info->k_string),
			  &(clui_info->k_flag))))
	{
	    kerror(NULL, "kman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "f",
			  &(clui_info->f_string),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "kman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "r",
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "kman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "man",
			  &(clui_info->man_flag))))
	{
	    kerror(NULL, "kman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hlp",
			  &(clui_info->hlp_flag))))
	{
	    kerror(NULL, "kman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "manual",
			  &(clui_info->manual_flag))))
	{
	    kerror(NULL, "kman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Displays and prints man pages for software objects' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kman",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute kman' $BOOTSTRAPBIN/kman",
  "-H 1  5x1+41+0 'Help' 'help page for kman' $BOOTSTRAP/objects/kroutine/kman/help/kman.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 0 0 49.75x1+2+2 ' ' 'Toolbox' 'toolbox in which to search for the manpage' tb",
  "-s 1 0 1 0 0 49.75x1+2+3 ' ' 'Keyword' 'keyword to search the whatis file for' k",
  "-s 1 0 1 0 0 49.75x1+2+5 ' ' 'Roff Formatter' 'roff formater command for printing man pages' f",
  "-t 1 0 1 0 0 8.875x1+2+6 'Reformat' 'reformats the man page' r",
  "-C 0",
  "-t 1 0 1 1 0 5.125x1+2+8 'man' 'format using manpage macros' man",
  "-t 1 0 1 0 0 5.875x1+12+8 'help' 'format using helppage macros' hlp",
  "-t 1 0 1 0 0 7.375x1+21+8 'manual' 'format using manual macros' manual",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/kman/uis/kman.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	21,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


