 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:54:33 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:54:33 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "krename.h"
/*-----------------------------------------------------------
| 
|  Routine Name: krename_get_args
| 
|       Purpose: Gets command line args for krename
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname krename
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void krename_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for krename is out of sync with arguments specified in krename's *.pane file; please rerun ghostwriter on krename.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the krename structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "krename_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "krename_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "new",
			  &(clui_info->new_string),
			  &(clui_info->new_flag))))
	{
	    kerror(NULL, "krename_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Renames a software object' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' krename",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $BOOTSTRAPBIN/krename",
  "-H 1  5x1+41+0 'Help' 'help page' $BOOTSTRAP/objects/kroutine/krename/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 0 1 0 44.75x1+1+1.5 ' ' 'Toolbox ' 'name of toolbox' tb",
  "-s 1 0 0 1 0 45x1+1+2.5 ' ' 'Object  ' 'name of object in specified toolbox' oname",
  "-s 1 0 0 1 0 45x1+1+3.5 ' ' 'New Name' 'new name for object' new",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/krename/uis/krename.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


