 /*
  * Khoros: $Id: kset.h,v 1.15.2.2 1997/05/31 20:55:05 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kset
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kset_h_
#define _kset_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <bootstrap.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  name of toolbox (optional string)
 */
char	*tb_string;	/* name of toolbox STRING */
int	 tb_flag;   	/* name of toolbox FLAG */

/*
 *  name of object (optional string)
 */
char	*oname_string;	/* name of object STRING */
int	 oname_flag;   	/* name of object FLAG */

/*
 *  flag to specify whether to suppress prompts (optional flag)
 */
int	 force_flag;  	/* flag to specify whether to suppress prompts FLAG */

/*
 *  full name of author or point of contact (optional string)
 */
char	*author_string;	/* full name of author or point of contact STRING */
int	 author_flag;   	/* full name of author or point of contact FLAG */

/*
 *  email address of author or point of contact (optional string)
 */
char	*email_string;	/* email address of author or point of contact STRING */
int	 email_flag;   	/* email address of author or point of contact FLAG */

/*
 *  string to use as icon name for object  (optional string)
 */
char	*icon_string;	/* string to use as icon name for object  STRING */
int	 icon_flag;   	/* string to use as icon name for object  FLAG */

/*
 *  miscellaneous file to add to object (optional string)
 */
char	*misc_string;	/* miscellaneous file to add to object STRING */
int	 misc_flag;   	/* miscellaneous file to add to object FLAG */

/*
 *  Add a keyword to the specified object (optional string)
 */
char	*addkeyword_string;	/* Add a keyword to the specified object STRING */
int	 addkeyword_flag;   	/* Add a keyword to the specified object FLAG */

/*
 *  Remove a keyword to the object specified (optional string)
 */
char	*rmkeyword_string;	/* Remove a keyword to the object specified STRING */
int	 rmkeyword_flag;   	/* Remove a keyword to the object specified FLAG */

/*
 *  Short Description (optional string)
 */
char	*description_string;	/* Short Description STRING */
int	 description_flag;   	/* Short Description FLAG */

/*
 *  category of object (optional string)
 */
char	*category_string;	/* category of object STRING */
int	 category_flag;   	/* category of object FLAG */

/*
 *  subcategory of object (optional string)
 */
char	*subcategory_string;	/* subcategory of object STRING */
int	 subcategory_flag;   	/* subcategory of object FLAG */

/*
 *  version string (optional string)
 */
char	*version_string;	/* version string STRING */
int	 version_flag;   	/* version string FLAG */

/*
 *  associated toolbox name (optional string)
 */
char	*atb_string;	/* associated toolbox name STRING */
int	 atb_flag;   	/* associated toolbox name FLAG */

/*
 *  associated object name (optional string)
 */
char	*aoname_string;	/* associated object name STRING */
int	 aoname_flag;   	/* associated object name FLAG */

/*
 *  associated command-line args (optional string)
 */
char	*aargs_string;	/* associated command-line args STRING */
int	 aargs_flag;   	/* associated command-line args FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void kset_get_args PROTO((kaddr));
void kset_usage_additions PROTO((void));
void kset_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
void kset_add_misc_file(kobject, kstring);
/* -include_routines_end */

#endif
