 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 20:55:06 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 20:55:06 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kset.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kset_get_args
| 
|       Purpose: Gets command line args for kset
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kset
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kset_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kset is out of sync with arguments specified in kset's *.pane file; please rerun ghostwriter on kset.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kset structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "force",
			  &(clui_info->force_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "author",
			  &(clui_info->author_string),
			  &(clui_info->author_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "email",
			  &(clui_info->email_string),
			  &(clui_info->email_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "icon",
			  &(clui_info->icon_string),
			  &(clui_info->icon_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "misc",
			  &(clui_info->misc_string),
			  &(clui_info->misc_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "addkeyword",
			  &(clui_info->addkeyword_string),
			  &(clui_info->addkeyword_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "rmkeyword",
			  &(clui_info->rmkeyword_string),
			  &(clui_info->rmkeyword_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "description",
			  &(clui_info->description_string),
			  &(clui_info->description_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "category",
			  &(clui_info->category_string),
			  &(clui_info->category_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "subcategory",
			  &(clui_info->subcategory_string),
			  &(clui_info->subcategory_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "version",
			  &(clui_info->version_string),
			  &(clui_info->version_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "atb",
			  &(clui_info->atb_string),
			  &(clui_info->atb_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "aoname",
			  &(clui_info->aoname_string),
			  &(clui_info->aoname_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "aargs",
			  &(clui_info->aargs_string),
			  &(clui_info->aargs_flag))))
	{
	    kerror(NULL, "kset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Sets attributes of toolbox or software objects' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kset",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $BOOTSTRAPBIN/kset",
  "-H 1  5x1+41+0 'Help' 'help page' $BOOTSTRAP/objects/kroutine/kset/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 1 0 31x1+1+1.5 ' ' 'Toolbox ' 'name of toolbox' tb",
  "-s 1 0 1 1 0 31x1+1+2.5 ' ' 'Object  ' 'name of object' oname",
  "-t 1 0 1 0 0 5.5x1+1+4 'Force Overwrites?' 'flag to specify whether to suppress prompts' force",
  "-s 1 0 1 1 0 49.5x1+1+5.5 ' ' 'Author Name' 'full name of author or point of contact' author",
  "-s 1 0 1 1 0 49.5x1+1+7 ' ' 'Author Email' 'email address of author or point of contact' email",
  "-s 1 0 1 1 0 49.5x1+1+8.5 ' ' 'Icon Name' 'string to use as icon name for object ' icon",
  "-s 1 0 1 1 0 49.5x1+1+10 ' ' 'Add Miscellaneous File' 'miscellaneous file to add to object' misc",
  "-s 1 0 1 1 0 49.5x1+1+11.5 ' ' 'Add Keyword   ' 'Add a keyword to the specified object' addkeyword",
  "-s 1 0 1 1 0 49.5x1+1+12.5 ' ' 'Remove Keyword' 'Remove a keyword to the object specified' rmkeyword",
  "-s 1 0 1 1 0 49.5x1+1+14 ' ' 'Description' 'Short Description' description",
  "-s 1 0 1 1 0 49.5x1+1+15.5 ' ' 'Category' 'category of object' category",
  "-s 1 0 1 1 0 49.5x1+1+17 ' ' 'Subcategory' 'subcategory of object' subcategory",
  "-s 1 0 1 1 0 49x1+1+18.5 ' ' 'Version' 'version string' version",
  "-s 1 0 1 1 0 49x1+1+20 ' ' 'Associated Toolbox' 'associated toolbox name' atb",
  "-s 1 0 1 1 0 49x1+20+20 ' ' 'Associated Object' 'associated object name' aoname",
  "-s 1 0 1 1 0 49x1+40+20 ' ' 'Associated Arguments' 'associated command-line args' aargs",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$BOOTSTRAP/objects/kroutine/kset/uis/kset.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	28,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


