 /*
  * Khoros: $Id: phantomd.c,v 1.6.2.2 1997/05/31 20:55:20 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: phantomd.c,v 1.6.2.2 1997/05/31 20:55:20 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for phantomd
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "phantomd.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Phantom Daemon
|
|       Purpose: main program for phantomd
|
|         Input:
|		char *clui_info->i_file; {First Input data object}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->o_file; {Resulting output data object}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
	char buffer[KLENGTH];
/* -main_variable_list_end */

	khoros_init(argc, argv, "BOOTSTRAP", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$BOOTSTRAP/objects/kroutine/phantomd");
	kexit_handler(phantomd_free_args, NULL);

/* -main_get_args_call */
	kclui_init("BOOTSTRAP", "phantomd", KGEN_KROUTINE,  &clui_uis_spec,
		   phantomd_usage_additions, phantomd_get_args,
 		   phantomd_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
	if (clui_info->i_file != NULL)
	   ifile = kfopen(clui_info->i_file, "r");
	else
	   ifile = kstdin;

	if (clui_info->o_file != NULL)
	   ofile = kfopen(clui_info->o_file, "w");
	else
	   ofile = kstdout;
/* -main_before_lib_call_end */

/* -main_library_call */
	while (kfgets(buffer, KLENGTH, ifile) != NULL)
	   process_command(buffer);
/* -main_library_call_end */

/* -main_after_lib_call */
	kfclose(ifile);
	kfclose(ofile);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: phantomd_usage_additions
| 
|       Purpose: Prints usage additions in phantomd_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname phantomd
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void phantomd_usage_additions(void)
{
	kfprintf(kstderr, "\tPhantom Daemon\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: phantomd_free_args
| 
|       Purpose: Frees CLUI struct allocated in phantomd_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname phantomd
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
phantomd_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
