/*
 * Khoros: $Id: stdargs.c,v 1.2 1996/11/21 22:33:31 mirage Exp $
 */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: stdargs.c,v 1.2 1996/11/21 22:33:31 mirage Exp $";
#endif



/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>  Definitions/Initializations of standard arg UIS structures
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"


/*
 * This UIS structure represents the standard Khoros command line
 * arguments for kroutines.  It is used by process_command_line()
 * for appending these arguments onto the form tree of a khoros program.
 * Note that it can be regenerated by copying kcodegen/uis/kstdargs.pane
 * to the *.pane file of a temporary kroutine, using ghostwriter to 
 * generate the structure definition/initialization, and then substituting
 * "kstdargs" for the "clui" wherever it appears.  Alternatively it can
 *  be done by hand.
 */
char *kstdargs_uis[] = {

  "-F 4.3 1 0 30x5+10+20 +0+0 '  ' kstdargs_form",
  "-M 1 1 50x5+0+0 +0+0 '  ' subform",
  "-P 1 0 40x5+0+0 +0+0 '  ' pane",
  "-t 1 0 1 0 0 6x1+1+1 'GUI' 'run from GUI as defined in *.pane file' gui",
  "-t 1 0 1 0 0 6x1+1+2 'Version' 'gives the version number of the program' V",
  "-t 1 0 1 0 0 6x1+1+3 'Brief Usage' 'gives brief usage' U",
  "-t 1 0 1 0 0 9.75x1+1+4 'Full Usage' 'gives full usage' usage",
  "-t 1 0 1 0 0 9.125x1+1+5 'Prompting' 'interactive prompting for arguments' P",
  "-O 1 0 1 0 0 1 56x1+1+6.5 ' ' 'Output Answer File' 'Creates an answer file' A",
  "-I 1 0 1 0 0 1 56x1+1+7.5 ' ' 'Input Answer File' 'Uses an answer file' a",
  "-I 1 0 1 0 0 1 56x1+1+8.5 ' ' 'Print Answer File Values' 'prints answer file values' ap",
  "-E",
  "-E",
  "-E",
};

size_t kstdargs_line_lookup[] = { 1,2,3,4,5,6,7,8,9,10,11,12,13,14,};

size_t kstdargs_file_lookup[] = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,};

char *kstdargs_filenames[] = {
  "$BOOTSTRAP/objects/library/kcodegen/uis/kstdargs.pane",
};

uis_struct kstdargs_uis_spec = {
        kstdargs_uis,
        14,
        kstdargs_file_lookup,
        kstdargs_line_lookup,
        kstdargs_filenames,
        1,
        512};



/*
 * This UIS structure represents the standard Khoros command line
 * arguments for xvroutines.  It is used by process_command_line()
 * for appending these arguments onto the form tree of a khoros program.
 * Note that it can be regenerated by copying kcodegen/uis/xvstdargs.pane
 * to the *.pane file of a temporary kroutine, using ghostwriter to 
 * generate the structure definition/initialization, and then substituting
 * "xvstdargs" for the "clui" wherever it appears.  Alternatively it can
 *  be done by hand.
 */

char *xvstdargs_uis[] = {

  "-F 4.3 1 0 30x5+10+20 +0+0 '  ' xvstdargs_form",
  "-M 1 1 50x15+0+0 +0+0 '  ' subform",
  "-P 1 0 49.75x8.59091+0+0 +0+0 '  ' pane",
  "-t 1 0 1 0 0 6x1+1+1 'GUI' 'run from GUI as defined in *.pane file' gui",
  "-t 1 0 1 0 0 6x1+1+2 'Version' 'gives the version number of the program' V",
  "-t 1 0 1 0 0 6x1+1+3 'Brief Usage' 'gives brief usage' U",
  "-t 1 0 1 0 0 9.75x1+1+4 'Full Usage' 'gives full usage' usage",
  "-t 1 0 1 0 0 9.125x1+1+5 'Prompting' 'interactive prompting for arguments' P",
  "",
  "-I 1 0 1 0 0 1 55.5x1+1+7 ' ' 'Alternate *.form file' 'substitutes an alternate *.form UIS file' form",
  "-i 1 0 1 0 0 55.5x1+1+9 -1 1000 -1 1 1 'X placement' 'x value for GUI autoplacement' x",
  "-i 1 0 1 0 0 55.5x1+1+10 -1 1000 -1 1 1 'Y placement' 'y value for GUI autoplacement' y",
  "-O 1 0 1 0 0 1 55.5x1+1+12 ' ' 'Output Answer File' 'Creates an answer file' A",
  "-I 1 0 1 0 0 1 55.5x1+1+13 ' ' 'Input Answer File' 'Uses an answer file' a",
  "-I 1 0 1 0 0 1 55.5x1+1+14 ' ' 'Print Answer File Values' 'prints answer file values' ap",
  "-E",
  "-E",
  "-E",
};

size_t xvstdargs_line_lookup[] = { 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,};

size_t xvstdargs_file_lookup[] = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};

char *xvstdargs_filenames[] = {
  "$BOOTSTRAP/objects/library/kcodegen/uis/xvstdargs.pane",
};

uis_struct xvstdargs_uis_spec = {
        xvstdargs_uis,
        18,
        xvstdargs_file_lookup,
        xvstdargs_line_lookup,
        xvstdargs_filenames,
        1,
        512};


/*
 * these routines are used by kgenmanual and kman
 * (they break the wall but oh well)
 */
uis_struct *kgen_get_xvstdargs_uis_spec(void)
{
	return(&xvstdargs_uis_spec);
}
uis_struct *kgen_get_kstdargs_uis_spec(void)
{
        return(&kstdargs_uis_spec);
}

