/*
 * Khoros: $Id: utilities.c,v 1.7 1997/01/29 04:04:16 mirage Exp $
 */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: utilities.c,v 1.7 1997/01/29 04:04:16 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		Library Routine for ktestutils
   >>>>		
   >>>>  Private:
   >>>>                 ktest_error()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/*-----------------------------------------------------------
| Routine Name:	ktest_error - simple error routine for internal checks
|
| Purpose:	This is a simple error handling routine, which prints
|		an error message to standard output, then exits with
|		an error status.
|
| Input:	func_name - The name of the function generating the message.
|		errstring - The error message.
|
| Written By:	Neil Bowers
| Date:		30-jan-1995
------------------------------------------------------------*/
void
ktest_error(
   kstring  func_name,
   kstring  errstring)
{
   kprintf("KTESTUTILS ERROR - %s(): %s\n", func_name, errstring);
   kexit(KEXIT_FAILURE);
}
