eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: kgenglossary - no short description specified
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: kgenglossary.pl,v 1.9.2.1 1997/03/17 22:41:15 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
if ( ! defined $ENV{'HOME'})
{
   die "The HOME environment variable must be set.\n";
}
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis = 'Generate glossary for manual';
@clui_args  = (
        '[verbose]', '',      'display verbose information as program runs'
);

# initialize Khoros perl lib
&khoros'initialize("BOOTSTRAP",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

opendir(MANDIR, "./..") || die "Can't read parent directory: $!\n";
@directories = grep(/^[^.]/, readdir(MANDIR));
closedir(MANDIR);

foreach $dir (@directories)
{
   next unless -d "../$dir" && -f "../$dir/glossary.raw";

   open(RAWFILE, "< ../$dir/glossary.raw") || do
   {
      warn "kgenglossary: Could not read glossary.raw for chapter $dir: $!\n";
      next;
   };

   (print "kgenglossary:"),$ok=1 unless $ok;
   print " $dir";
   while (<RAWFILE>)
   {
      chop;
      ($word,$definition) = split(/:/);
      $glossary{$word} = $definition;
   }
}
close RAWFILE;
print "\n" if $ok;

open(ROFF, "> glossary.roff") || die "Can't write glossary.roff: $!\n";
foreach $word (sort by_alpha keys %glossary)
{
   $section = substr($word, 0, 1);
   $section = "\U$section";
   if ($section ne $cursect)
   {
      print ROFF ".LB \"$section\"\n";
      $cursect = $section;
   }
   print ROFF ".G< \"$word\" \"",$glossary{$word},"\"\n";
}
close(ROFF);

sub by_alpha
{
   "\L$a" cmp "\L$b";
}
