eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: kgenindex - no short description specified
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: kgenindex.pl,v 1.9.2.1 1997/03/17 22:41:17 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
if ( ! defined $ENV{'HOME'})
{
   die "The HOME environment variable must be set.\n";
}
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis = 'no short description specified';
@clui_args  = (
   '[verbose]',  '',  'display verbose information as program runs'
);

# initialize Khoros perl lib
&khoros'initialize("BOOTSTRAP",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

opendir(MANDIR, "./..") || die "Can't read parent directory: $!\n";
@directories = grep(/^[^.]/, readdir(MANDIR));
closedir(MANDIR);

foreach $dir (sort @directories)
{
   next unless -d "../$dir" && -f "../$dir/index.raw";

   open(RAWFILE, "< ../$dir/index.raw") || do
   {
      warn "kgenindex: Could not read index.raw for chapter $dir: $!\n";
      next;
   };

   (print "kgenindex:"),$ok=1 unless $ok;
   print " $dir";
   while (<RAWFILE>)
   {
      chop;
      s/\\f[BHIRP]//g;
      s/\\f\(CW//g;
      s/\\f\(BI//g;
      s/\\s[+-][0-9]//g;

      ($chapter, $page, $word, $category, $definitive) = split(/:/);
      next if $word eq 'N/A';
      $hardref = $reference = "$chapter-$page";
      $reference = "\\fB$reference\\fP" if $definitive eq 'BOLD';
      if ($category =~ /^\s*$/)
      {
	 if ($definitive eq 'BOLD' &&
	     !defined $seenReference{"$word\t$reference"} &&
	     defined $seenReference{"$word\t$hardref"})
	 {
	    #-- we've already added a regular reference for this page
	    #-- but this is a definitive reference, so update reference
	    $index{$word} =~ s/\b$hardref\b/\\fB$hardref\\fP/;
	    $seenReference{"$word\t$reference"} = 1;
	    next;
	 }

	 #-- we've already seen a reference for this word on this page
	 #-- so skip this one
	 next if defined $seenReference{"$word\t$hardref"};

         $index{$word} .= (defined $index{$word}
			   ? ", $reference"
			   : "$reference");
	 $seenReference{"$word\t$hardref"} = 1;
	 $seenReference{"$word\t$reference"} = 1;
      }
      else
      {
	 if ($definitive eq 'BOLD' &&
	     !defined $seenReference{"$category\t$word\t$reference"} &&
	     defined $seenReference{"$category\t$word\t$hardref"})
	 {
	    #-- we've already added a regular reference for this page
	    #-- but this is a definitive reference, so update reference
	    $index{"$category\t$word"} =~ s/\b$hardref\b/\\fB$hardref\\fP/;
	    $seenReference{"$category\t$word\t$reference"} = 1;
	    next;
	 }

	 next if defined $seenReference{"$category\t$word\t$hardref"};
         if (defined $index{"$category\t$word"})
         {
            $index{"$category\t$word"} .= ", $reference";
         }
         else
         {
            $index{"$category\t$word"} .= "$reference";
         }
	 $seenReference{"$category\t$word\t$hardref"} = 1;
	 $seenReference{"$category\t$word\t$reference"} = 1;
      }
   }
}
close RAWFILE;
print "\n" if $ok;

open(ROFF, "> index.roff") || die "Can't write index.roff: $!\n";
print ROFF ".2C\n";
foreach $word (sort by_alpha keys %index)
{
   $section = substr($word, 0, 1);
   $section = "\U$section";
   if ($section ne $cursect)
   {
      print ROFF ".LB \"$section\"\n";
      $cursect = $section;
   }
   if ($word =~ /\t/)
   {
      ($category, $minor) = split(/\t/, $word);

      # have we printed out the major index entry, if we need to?
      if (!defined $index{$category} && !$printedCategory{$category})
      {
	 print ROFF ".Ib \"$category\"\n";
	 $printedCategory{$category} = 1;
      }

      print ROFF ".I< \"$category\" \"$minor\" \"", $index{$word},"\"\n";
   }
   else
   {
      print ROFF ".I> \"$word\" \"", $index{$word},"\"\n";
   }
}
close(ROFF);

# the following line was obviously doing something, dunno what yet ...
# sed -e "s/\([0-9A-Z][0-9]*:[0-9A-Z][0-9]*:\)\(.*\)::/\1:\2:/" index.raw

sub by_alpha
{
   "\L$a" cmp "\L$b";
}
