#!/bin/sh

#
# Khoros: $Id: klicense.sh,v 1.7.2.2 1997/06/02 20:14:49 mirage Exp $
#

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

#************************************************************
#
#  Routine Name: klicense - Khoros License Information
#
#       Purpose: This program will display the Khoros license.
#
#         Input: None
#
#    Written By: Tom Sauer & Steve Jorgensen
#          Date: Aug 27, 1994
# Modifications: 
#
#************************************************************/

# This section begins a useful library of routines that are general enough to
# be used in other sh scripts.
# ------------------------------------------------------------------------
# set up some other standard commands.
# eventually we should do something like the below code for echo,
# check for each of them on the path.  Oh for perl!
 
  tr="tr"
  cp="cp"
  mv="mv -f"
  rm="rm -f"
 awk="awk"
 sed="sed"
 cat="cat"
grep="grep"
strings="strings"
TMPDIR=${TMPDIR:-/tmp}
clr=""
for dir in `echo $PATH | $sed -e 's/:/ /g'`; do
    [ -x "$dir/clear" -a ! -d "$dir/clear" ] && clr="$dir/clear"
done

#
#  Assume a vt100 variant
#
if [ "$clr" = "" ]; then
  clr="echo -c [H[J"
fi
 
# clean up if they interrupt the script.
#----------------------------------------------------------
cleanup()
{
        echo ""
        $rm $TMPDIR/klicense.*.$$
        echo ""
        exit 0
}
trap cleanup 2

# build a $echoN variable and $echoEnd combination that will give
# will allow the echon procedure to work well.
FindEchoN()
{
        # build a list of potential echos, starting with sh built-in
        echoEnd=""
        elist="echo"
        for dir in `echo $PATH | $sed -e 's/:/ /g'`; do
                [ -x "$dir/echo" ] && elist="$elist $dir/echo"
        done
 
        # work through list, see if one of them groks -n
        for echo in $elist; do
                result=`$echo -n hello`
                if [ "$result" != "-n hello" ]; then
                        echoN="$echo -n"
                        break
                fi
        done
        if [ "$echoN" = "" ]; then
                echoN=echo
                echoEnd="\c"
                result=`$echoN "testing"$echoEnd`
                if [ "$result" != "testing" ]; then
                        unset echoEnd
                fi
        fi
}

# quitting
quit()
{
        cleanup
}

# echo without without return
echon()
{
        $echoN "$* $echoEnd"
}

# clear screen function
newtopic()
{
        $clr
}

# find the more or page program
findmore()
{
	if [ "$PAGER" != "" ]; then
	   pager=$PAGER
           return
	fi

        pager="/usr/ucb/more"
        if [ -x $pager ]; then
                return
        fi

        dlist=`echo $PATH | $sed -e 's/:/ /g'`

        for dir in $dlist; do
                if [ -x "$dir/more" ]; then
                        pager="$dir/more"
                        return
                fi
        done

        for dir in $dlist; do
                if [ -x "$dir/page" ]; then
                        pager="$dir/page"
                        return
                fi
        done

        for dir in $dlist; do
                if [ -x "$dir/pg" ]; then
                        pager="$dir/pg"
                        return
                fi
        done

        pager="$cat"
}

# Display the Khoros License
dislicense()
{
	Findkecho

	findmore

        $echoN "Formatting Khoros License for display.....Please wait..."

        if [ $foundkecho = 1 ]; then
	   boot_path=`kecho -tb bootstrap -echo path`
	   lic_path="$boot_path/repos/license/License"
	else
	   if [ -f bootstrap/repos/license/License ]; then
	      lic_path="$boot_path/repos/license/License"
           else
	      TryToolboxesFile
              if [ "$bootdir" != "" ]; then
	         lic_path="$bootdir/repos/license/License"
              else
                 echo ""
                 echo ""
                 echo "Can not find License file.  Please check to make sure you have a"
		 echo "$HOME/.Toolboxes file which is created by kconfigure."
                 echo ""
                 echo "You can look at the file,"
                 echo ""
		 echo "   <KHOROS_INSTALL_DIR>/bootstrap/repos/license/License"
                 echo ""
                 echo "to review the terms of the license."
                 echo ""
		 exit 1
              fi
           fi
	fi
	newtopic
        $pager $lic_path
}

#
# Find kecho
#
Findkecho() {

   foundkecho=0
   kecho=""
   for dir in `echo $PATH | $sed -e 's/:/ /g'`; do
      if [ -x "$dir/kecho" -a ! -d "$dir/kecho" ]; then
         kecho="$dir/kecho"
         foundkecho=1
      fi
   done

}

CountTimes()
{
   newfiletock="$*"
   counttbsfiles=0

   for cktbsfile in $tblist; do
      if [ "$cktbsfile" = "$newfiletock" ]; then
         counttbsfiles=1;
      fi
   done
}

TryToolboxesFile()
{
   if [ "$KHOROS_TOOLBOX" = "" ]; then
      ktb="$HOME/.Toolboxes"
   else
      ktb="$KHOROS_TOOLBOX"
   fi
   
   tblist=""
   for tbfile in `echo $ktb | $sed -e 's/:/ /g'`; do
      [ -f "$tbfile" ] && tblist="$tblist $tbfile"
   done
   
   newlist="$tblist"
   
   while [ X"$newlist" != X ]; do
      for tbfile in $newlist; do
   
         newfiles=`$grep '^#include' $tbfile | $sed -e 's/^#include[ 	]*\([^ 	][^ 	]*\)/\1/'`
        
         nfiles=""
         for newfile in $newfiles; do
            CountTimes $newfile
            [ $counttbsfiles = 0 -a -f "$newfile" ] && nfiles="$nfiles $newfile"
         done
   
         for newfile in $nfiles; do
            CountTimes $newfile
            [ $counttbsfiles = 0 -a -f "$newfile" ] && tblist="$tblist $newfile"
         done
      done
      newlist="$nfiles"
   done
   
   for tbfile in $tblist; do
      bootdir=`$grep "^BOOTSTRAP" $tbfile | $awk -F\; '{ print $1 }' | \
         $awk -F: '{ print $NF }'` 
      if [ "$bootdir" != "" ]; then
         break
      fi
   done
}
 
# This section begins the main program part of the sh script
# ------------------------------------------------------------------------

newtopic
FindEchoN
dislicense
quit

