 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:39:59 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:39:59 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kappend.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kappend_get_args
| 
|       Purpose: Gets command line args for kappend
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kappend
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kappend_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kappend is out of sync with arguments specified in kappend's *.pane file; please rerun ghostwriter on kappend.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kappend structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i4",
			  &(clui_info->i4_file),
			  &(clui_info->i4_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i5",
			  &(clui_info->i5_file),
			  &(clui_info->i5_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i6",
			  &(clui_info->i6_file),
			  &(clui_info->i6_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i7",
			  &(clui_info->i7_file),
			  &(clui_info->i7_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i8",
			  &(clui_info->i8_file),
			  &(clui_info->i8_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i9",
			  &(clui_info->i9_file),
			  &(clui_info->i9_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i10",
			  &(clui_info->i10_file),
			  &(clui_info->i10_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "append",
			  &(clui_info->append_logic),
			  &(clui_info->append_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "mapping", KVF_LIST_LABEL,
			  &(clui_info->mapping_label),
			  &(clui_info->mapping_flag)) &&
	      kclui_get_value(pane, "mapping", KVF_LIST_VAL,
			  &(clui_info->mapping_list),
			  &(clui_info->mapping_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "w",
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "h",
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "d",
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "t",
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "e",
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "kappend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Append (or Prepend) Input Objects to Base Object' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kappend",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $DATAMANIP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kappend",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kappend/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input 1 (Base)' 'Base Input data object (input 1)' i1",
  "-I 1 0 1 1 0 1 52x1+0+3 ' ' 'Input  2' 'input file 2' i2",
  "-I 1 0 1 0 0 1 52x1+0+4 ' ' 'Input  3' 'input file 3' i3",
  "-I 1 0 1 0 0 1 52x1+0+5 ' ' 'Input  4' 'input file 4' i4",
  "-I 1 0 1 0 0 1 52x1+0+6 ' ' 'Input  5' 'input file 5' i5",
  "-I 1 0 1 0 0 1 52x1+0+7 ' ' 'Input  6' 'input file 6' i6",
  "-I 1 0 1 0 0 1 52x1+0+8 ' ' 'Input  7' 'input file 7' i7",
  "-I 1 0 1 0 0 1 52x1+0+9 ' ' 'Input  8' 'input file 8' i8",
  "-I 1 0 1 0 0 1 52x1+0+10 ' ' 'Input  9' 'input file 9' i9",
  "-I 1 0 1 0 0 1 52x1+0+11 ' ' 'Input 10' 'input file 10' i10",
  "-l 1 0 1 2 0 30.375x1+5+13.5 1 ' ' 'Prepend Objects to Base Object' 'Append Objects to Base Object' 'If True, append objects to base, otherwise prepend' append",
  "-x 1 0 1 2 0 42.5x1+1+18 3 0 0 'When Some Objects Have Maps: ' 'Defines map treatment when some, but not all, objects have maps ' mapping 'Map Data Thru Maps ' 'Use First Map Only' 'Create Map for Each Input'",
  "-O 1 0 0 1 0 1 52x1+0+20.5 ' ' 'Output' 'Resulting output data object' o",
  "-C 0",
  "-t 1 0 1 0 0 6x1+6+16 'Width' 'Stack objects along width dimension' w",
  "-t 1 0 1 0 0 7x1+14+16 'Height' 'Stack objects along height dimension' h",
  "-t 1 0 1 0 0 6x1+23+16 'Depth' 'Stack objects along depth dimension' d",
  "-t 1 0 1 1 0 5.25x1+31+16 'Time' 'Stack objects along time dimension' t",
  "-t 1 0 1 0 0 8.25x1+38+16 'Elements' 'Stack objects along elements dimension' e",
  "-E",
  "-b +6+15 'Stack objects along following dimension:' blank1",
  "-b +2+12.5 'Specify Placement:' blank18",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kappend/uis/kappend.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	34,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


