 /*
  * Khoros: $Id: karith1.h,v 1.14.2.2 1997/05/31 18:40:17 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for karith1
   >>>> 
   >>>>    Written By: Scott Wilson, Donna Koechner, Mark Young, Ashish Malhotra
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _karith1_h_
#define _karith1_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include "kdatamanip/kdatamanip.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input data object (required infile)
 */
char	*i_file;	/* input data object FILENAME */
int	 i_flag;	/* input data object FLAG */

/*
 *  resulting output data object (required outfile)
 */
char	*o_file;	/* resulting output data object FILENAME */
int	 o_flag;	/* resulting output data object FLAG */

/*----- required ME group ----*/
/*
 *  Output = Absolute Value of input (optional flag)
 */
int	 abs_flag;  	/* Output = Absolute Value of input FLAG */

/*
 *  Output = Sine of Input (optional flag)
 */
int	 sin_flag;  	/* Output = Sine of Input FLAG */

/*
 *  Output = Square Root of Input (optional flag)
 */
int	 sqrt_flag;  	/* Output = Square Root of Input FLAG */

/*
 *  Output = Arc Sine of Input (optional flag)
 */
int	 asin_flag;  	/* Output = Arc Sine of Input FLAG */

/*
 *  Output = Cube Root of Input (optional flag)
 */
int	 cbrt_flag;  	/* Output = Cube Root of Input FLAG */

/*
 *  Output = Cosine of Input (optional flag)
 */
int	 cos_flag;  	/* Output = Cosine of Input FLAG */

/*
 *  Output = Negative of Input (optional flag)
 */
int	 neg_flag;  	/* Output = Negative of Input FLAG */

/*
 *  Output = Arc Cosine of Input (optional flag)
 */
int	 acos_flag;  	/* Output = Arc Cosine of Input FLAG */

/*
 *  Output = Reciprocal of Input (optional flag)
 */
int	 recip_flag;  	/* Output = Reciprocal of Input FLAG */

/*
 *  Output = Tangent of Input (optional flag)
 */
int	 tan_flag;  	/* Output = Tangent of Input FLAG */

/*
 *  Output = integer Ceiling of Input (optional flag)
 */
int	 ceil_flag;  	/* Output = integer Ceiling of Input FLAG */

/*
 *  Output = Arc Tangent of Input (optional flag)
 */
int	 atan_flag;  	/* Output = Arc Tangent of Input FLAG */

/*
 *  Output = Integer Floor of Input (optional flag)
 */
int	 floor_flag;  	/* Output = Integer Floor of Input FLAG */

/*
 *  Output = Hyperbolic Sine of Input (optional flag)
 */
int	 sinh_flag;  	/* Output = Hyperbolic Sine of Input FLAG */

/*
 *  Output = integer Truncate of Input (optional flag)
 */
int	 trunc_flag;  	/* Output = integer Truncate of Input FLAG */

/*
 *  Output = Hyperbolic Arc Sine of Input (optional flag)
 */
int	 asinh_flag;  	/* Output = Hyperbolic Arc Sine of Input FLAG */

/*
 *  Output = Fractional Part of Input (optional flag)
 */
int	 fract_flag;  	/* Output = Fractional Part of Input FLAG */

/*
 *  Output = Hyperbolic Cosine of Input (optional flag)
 */
int	 cosh_flag;  	/* Output = Hyperbolic Cosine of Input FLAG */

/*
 *  Output = Natural log  of Gamma Function of Input (optional flag)
 */
int	 lgamma_flag;  	/* Output = Natural log  of Gamma Function of Input FLAG */

/*
 *  Output = Hyperbolic Arc Cosine of Input (optional flag)
 */
int	 acosh_flag;  	/* Output = Hyperbolic Arc Cosine of Input FLAG */

/*
 *  Output = Error Function of Input (optional flag)
 */
int	 erf_flag;  	/* Output = Error Function of Input FLAG */

/*
 *  Output = Hyperbolic Tangent of Input (optional flag)
 */
int	 tanh_flag;  	/* Output = Hyperbolic Tangent of Input FLAG */

/*
 *  Output = Complementary Error Function of Input (optional flag)
 */
int	 erfc_flag;  	/* Output = Complementary Error Function of Input FLAG */

/*
 *  Output = Hyperbolic Arc Tangent of Input (optional flag)
 */
int	 atanh_flag;  	/* Output = Hyperbolic Arc Tangent of Input FLAG */

/*
 *  Output = Sinc Function:  sin(x)/x (optional flag)
 */
int	 sinc_flag;  	/* Output = Sinc Function:  sin(x)/x FLAG */

/*
 *  Bitwise NOT operation (optional flag)
 */
int	 not_flag;  	/* Bitwise NOT operation FLAG */

/*
 *  Bitwise CLEAR: set all valid bits to 0 (optional flag)
 */
int	 clear_flag;  	/* Bitwise CLEAR: set all valid bits to 0 FLAG */

/*
 *  Bitwise SET: set all valid bits to 1 (optional flag)
 */
int	 set_flag;  	/* Bitwise SET: set all valid bits to 1 FLAG */

/*-- required ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void karith1_get_args PROTO((kaddr));
void karith1_usage_additions PROTO((void));
void karith1_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
