 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:40:19 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:40:19 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "karith1.h"
/*-----------------------------------------------------------
| 
|  Routine Name: karith1_get_args
| 
|       Purpose: Gets command line args for karith1
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname karith1
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void karith1_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for karith1 is out of sync with arguments specified in karith1's *.pane file; please rerun ghostwriter on karith1.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the karith1 structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "abs",
			  &(clui_info->abs_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sin",
			  &(clui_info->sin_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sqrt",
			  &(clui_info->sqrt_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "asin",
			  &(clui_info->asin_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cbrt",
			  &(clui_info->cbrt_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cos",
			  &(clui_info->cos_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "neg",
			  &(clui_info->neg_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "acos",
			  &(clui_info->acos_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "recip",
			  &(clui_info->recip_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tan",
			  &(clui_info->tan_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ceil",
			  &(clui_info->ceil_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "atan",
			  &(clui_info->atan_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "floor",
			  &(clui_info->floor_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sinh",
			  &(clui_info->sinh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "trunc",
			  &(clui_info->trunc_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "asinh",
			  &(clui_info->asinh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "fract",
			  &(clui_info->fract_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cosh",
			  &(clui_info->cosh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "lgamma",
			  &(clui_info->lgamma_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "acosh",
			  &(clui_info->acosh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "erf",
			  &(clui_info->erf_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tanh",
			  &(clui_info->tanh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "erfc",
			  &(clui_info->erfc_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "atanh",
			  &(clui_info->atanh_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sinc",
			  &(clui_info->sinc_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "not",
			  &(clui_info->not_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "clear",
			  &(clui_info->clear_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "set",
			  &(clui_info->set_flag))))
	{
	    kerror(NULL, "karith1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Single Operator Pointwise Arithmetic' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' karith1",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/karith1",
  "-H 1  5x1+41+0 'Help' 'man page for karith1' $DATAMANIP/objects/kroutine/karith1/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'input data object' i",
  "-O 1 0 0 1 0 1 51.75x1+0+23.5 ' ' 'Output' 'resulting output data object' o",
  "-b +1+4 'Select Operation:' b1",
  "-b +4+5 'Arithmetic' b2",
  "-b +4+18.5 'Bitwise Logical' b3",
  "-b +28+5 'Trigonmetric' b5",
  "-C 1",
  "-t 1 0 1 1 0 21.75x1+4+6 'absolute value' 'Output = Absolute Value of input' abs",
  "-t 1 0 1 0 0 21.75x1+28+6 'sine' 'Output = Sine of Input' sin",
  "-t 1 0 1 0 0 21.75x1+4+7 'square root' 'Output = Square Root of Input' sqrt",
  "-t 1 0 1 0 0 21.75x1+28+7 'arc sine' 'Output = Arc Sine of Input' asin",
  "-t 1 0 1 0 0 21.75x1+4+8 'cube root' 'Output = Cube Root of Input' cbrt",
  "-t 1 0 1 0 0 21.75x1+28+8 'cosine' 'Output = Cosine of Input' cos",
  "-t 1 0 1 0 0 21.75x1+4+9 'negate' 'Output = Negative of Input' neg",
  "-t 1 0 1 0 0 21.75x1+28+9 'arc cosine' 'Output = Arc Cosine of Input' acos",
  "-t 1 0 1 0 0 21.75x1+4+10 'reciprocal' 'Output = Reciprocal of Input' recip",
  "-t 1 0 1 0 0 21.75x1+28+10 'tangent' 'Output = Tangent of Input' tan",
  "-t 1 0 1 0 0 21.75x1+4+11 'ceiling' 'Output = integer Ceiling of Input' ceil",
  "-t 1 0 1 0 0 21.75x1+28+11 'arc tangent' 'Output = Arc Tangent of Input' atan",
  "-t 1 0 1 0 0 21.75x1+4+12 'floor' 'Output = Integer Floor of Input' floor",
  "-t 1 0 1 0 0 21.75x1+28+12 'hyperbolic sine' 'Output = Hyperbolic Sine of Input' sinh",
  "-t 1 0 1 0 0 21.75x1+4+13 'truncate' 'Output = integer Truncate of Input' trunc",
  "-t 1 0 1 0 0 21.75x1+28+13 'hyperbolic arc sine' 'Output = Hyperbolic Arc Sine of Input' asinh",
  "-t 1 0 1 0 0 21.75x1+4+14 'fraction' 'Output = Fractional Part of Input' fract",
  "-t 1 0 1 0 0 21.75x1+28+14 'hyperbolic cosine' 'Output = Hyperbolic Cosine of Input' cosh",
  "-t 1 0 1 0 0 21.75x1+4+15 'ln gamma' 'Output = Natural log  of Gamma Function of Input' lgamma",
  "-t 1 0 1 0 0 21.75x1+28+15 'hyperbolic arc cosine' 'Output = Hyperbolic Arc Cosine of Input' acosh",
  "-t 1 0 1 0 0 21.75x1+4+16 'error function' 'Output = Error Function of Input' erf",
  "-t 1 0 1 0 0 21.75x1+28+16 'hyperbolic tangent' 'Output = Hyperbolic Tangent of Input' tanh",
  "-t 1 0 1 0 0 21.75x1+4+17 'complementary error function' 'Output = Complementary Error Function of Input' erfc",
  "-t 1 0 1 0 0 21.75x1+28+17 'hyperbolic arc tangent' 'Output = Hyperbolic Arc Tangent of Input' atanh",
  "-t 1 0 1 0 0 21.75x1+28+18 'sinc:  sin(x)/x' 'Output = Sinc Function:  sin(x)/x' sinc",
  "",
  "-t 1 0 1 0 0 21.75x1+4+19.5 'NOT' 'Bitwise NOT operation' not",
  "-t 1 0 1 0 0 21.75x1+4+20.5 'CLEAR (0)' 'Bitwise CLEAR: set all valid bits to 0' clear",
  "-t 1 0 1 0 0 21.75x1+4+21.5 'SET (1)' 'Bitwise SET: set all valid bits to 1' set",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/karith1/uis/karith1.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	49,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


