 /*
  * Khoros: $Id: usage.c,v 1.14.2.3 1997/06/09 23:24:36 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.3 1997/06/09 23:24:36 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "karith2.h"
/*-----------------------------------------------------------
| 
|  Routine Name: karith2_get_args
| 
|       Purpose: Gets command line args for karith2
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname karith2
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void karith2_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for karith2 is out of sync with arguments specified in karith2's *.pane file; please rerun ghostwriter on karith2.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the karith2 structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "add",
			  &(clui_info->add_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hypot",
			  &(clui_info->hypot_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sub",
			  &(clui_info->sub_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "atan2",
			  &(clui_info->atan2_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "subfrom",
			  &(clui_info->subfrom_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mul",
			  &(clui_info->mul_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "div",
			  &(clui_info->div_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ldexp",
			  &(clui_info->ldexp_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "divinto",
			  &(clui_info->divinto_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pow",
			  &(clui_info->pow_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "absdiff",
			  &(clui_info->absdiff_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "min",
			  &(clui_info->min_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "max",
			  &(clui_info->max_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mod",
			  &(clui_info->mod_flag))))
	{
	    kerror(NULL, "karith2_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Dual Operator Pointwise Arithmetic' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' karith2",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/karith2",
  "-H 1  5x1+41+0 'Help' 'man page for karith2' $DATAMANIP/objects/kroutine/karith2/help/karith2.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input 1' 'first input data object' i1",
  "-O 1 0 0 1 0 1 52x1+0+22.5 ' ' 'Output' 'resulting output data object' o",
  "-b +1+3.75 'Enter 2nd Input or Constant Value(s)' b1",
  "-C 1",
  "-I 1 0 1 1 0 1 48x1+4+5 ' ' 'Input 2' 'second input data object' i2",
  "-K 0",
  "-h 1 0 1 0 1 35x1+4+6 3 3 0 0 1 1 'Real Constant' 'Real constant value     ' real",
  "-h 1 0 1 0 1 35x1+4+7 3 3 0 0 1 1 'Imag Constant' 'Imaginary constant value' imag",
  "-E",
  "-E",
  "-b +1+8.5 'Select Operation:' b2",
  "-b +3+9.5 'Arithmetic' b3",
  "-b +27+9.5 'Trigonmetry' b4",
  "-b +27+13.5 'Functions' b5",
  "-C 1",
  "-t 1 0 1 1 0 17.75x1+4+10.5 'Add' 'Add: o = i1 + (i2 or val)' add",
  "-t 1 0 1 0 0 14.75x1+28+10.5 'Hypotenuse' 'Hypotenuse:  o = sqrt(i1*i1 + (i2*i2* or val*val))' hypot",
  "-t 1 0 1 0 0 17.75x1+4+11.5 'Subtract' 'Subtract: o = i1 - (i2 or val)' sub",
  "-t 1 0 1 0 0 14.75x1+28+11.5 'atan(y/x)' 'atan2: o = arc tangent (i1 / (i2 or val)' atan2",
  "-t 1 0 1 0 0 17.75x1+4+12.5 'Subtract From' 'Subtract From: o = (i2 or val) - i1' subfrom",
  "-t 1 0 1 0 0 17.5x1+4+13.5 'Multiply' 'Multiply: o = i1 * (i2 or val)' mul",
  "-t 1 0 1 0 0 17.5x1+4+14.5 'Divide' 'Divide: o = i1 / (i2 or val)' div",
  "-t 1 0 1 0 0 14.25x1+28+14.5 'ldexp' 'ldexp: i1 * 2 ** (i2 or val)' ldexp",
  "-t 1 0 1 0 0 17.5x1+4+15.5 'Divide Into' 'Divide Into:  o = (i2 or val) / i1' divinto",
  "-t 1 0 1 0 0 17.5x1+4+16.5 'Power' 'Power: o = i1 raised to power of (i2 or val)' pow",
  "-t 1 0 1 0 0 17.5x1+4+17.5 'Absolute Difference' 'Absolute Difference:  o = | i1 - (i2 or val) |' absdiff",
  "-t 1 0 1 0 0 17.5x1+4+18.5 'Minimum' 'Minimum: Returns lower value between i1 and (i2 or val)' min",
  "-t 1 0 1 0 0 17.5x1+4+19.5 'Maximum' 'Maximum: Returns higher value between i1 and (i2 or val)' max",
  "-t 1 0 1 0 0 17.5x1+4+20.5 'Modulo' 'Modulus: o = remainder (i1/i2)' mod",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/karith2/uis/karith2.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	42,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


