 /*
  * Khoros: $Id: kasc2map.h,v 1.14.2.2 1997/05/31 18:41:17 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kasc2map
   >>>> 
   >>>>    Written By: John Salas, Steve Kubica
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kasc2map_h_
#define _kasc2map_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include "ksegops/ksegops.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  ASCII input data file containing new data segment (required infile)
 */
char	*i1_file;	/* ASCII input data file containing new data segment FILENAME */
int	 i1_flag;	/* ASCII input data file containing new data segment FLAG */

/*
 *  output data object (required outfile)
 */
char	*o_file;	/* output data object FILENAME */
int	 o_flag;	/* output data object FLAG */

/*
 *  data object input to insert the new segment into (optional infile)
 */
char	*i2_file;	/* data object input to insert the new segment into FILENAME */
int	 i2_flag;	/* data object input to insert the new segment into FLAG */

/*
 *  starting point in ASCII file to start importing at (optional integer)
 */
int	 so_int; 	/* starting point in ASCII file to start importing at INT */
int	 so_flag;	/* starting point in ASCII file to start importing at FLAG */

/*
 *  number of points in ASCII file to skip between reads (optional integer)
 */
int	 sf_int; 	/* number of points in ASCII file to skip between reads INT */
int	 sf_flag;	/* number of points in ASCII file to skip between reads FLAG */

/*
 *  map width size must be > 0 (optional integer)
 */
int	 wsize_int; 	/* map width size must be > 0 INT */
int	 wsize_flag;	/* map width size must be > 0 FLAG */

/*
 *  position in the index order for the map width dimension (Optional list)
 */
int	 windex_list;	/* position in the index order for the map width dimension LIST INDEX */
char	 *windex_label;	/* position in the index order for the map width dimension LIST LABEL */
int	 windex_flag;	/* position in the index order for the map width dimension FLAG */

/*
 *  map height size must be > 0 (optional integer)
 */
int	 hsize_int; 	/* map height size must be > 0 INT */
int	 hsize_flag;	/* map height size must be > 0 FLAG */

/*
 *  position in the index order for the map height dimension (Optional list)
 */
int	 hindex_list;	/* position in the index order for the map height dimension LIST INDEX */
char	 *hindex_label;	/* position in the index order for the map height dimension LIST LABEL */
int	 hindex_flag;	/* position in the index order for the map height dimension FLAG */

/*
 *  map depth size must be > 0 (optional integer)
 */
int	 dsize_int; 	/* map depth size must be > 0 INT */
int	 dsize_flag;	/* map depth size must be > 0 FLAG */

/*
 *  position in the index order for the map depth dimension (Optional list)
 */
int	 dindex_list;	/* position in the index order for the map depth dimension LIST INDEX */
char	 *dindex_label;	/* position in the index order for the map depth dimension LIST LABEL */
int	 dindex_flag;	/* position in the index order for the map depth dimension FLAG */

/*
 *  map time size must be > 0 (optional integer)
 */
int	 tsize_int; 	/* map time size must be > 0 INT */
int	 tsize_flag;	/* map time size must be > 0 FLAG */

/*
 *  position in the index order for the map time dimension (Optional list)
 */
int	 tindex_list;	/* position in the index order for the map time dimension LIST INDEX */
char	 *tindex_label;	/* position in the index order for the map time dimension LIST LABEL */
int	 tindex_flag;	/* position in the index order for the map time dimension FLAG */

/*
 *  map elements size must be > 0 (optional integer)
 */
int	 esize_int; 	/* map elements size must be > 0 INT */
int	 esize_flag;	/* map elements size must be > 0 FLAG */

/*
 *  position in the index order for the map elements dimension (Optional list)
 */
int	 eindex_list;	/* position in the index order for the map elements dimension LIST INDEX */
char	 *eindex_label;	/* position in the index order for the map elements dimension LIST LABEL */
int	 eindex_flag;	/* position in the index order for the map elements dimension FLAG */

/*
 *  data type (Optional list)
 */
int	 type_list;	/* data type LIST INDEX */
char	 *type_label;	/* data type LIST LABEL */
int	 type_flag;	/* data type FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void kasc2map_get_args PROTO((kaddr));
void kasc2map_usage_additions PROTO((void));
void kasc2map_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
