 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:42:09 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:42:09 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kasc2time.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kasc2time_get_args
| 
|       Purpose: Gets command line args for kasc2time
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kasc2time
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kasc2time_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kasc2time is out of sync with arguments specified in kasc2time's *.pane file; please rerun ghostwriter on kasc2time.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kasc2time structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kasc2time_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kasc2time_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "so",
			  &(clui_info->so_int),
			  &(clui_info->so_flag))))
	{
	    kerror(NULL, "kasc2time_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kasc2time_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kasc2time_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kasc2time_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Import ASCII Data File to Time Segment' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kascii_time",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kasc2time",
  "-H 1  5x1+41+0 'Help' 'man page for kascii_time' $DATAMANIP/objects/kroutine/kasc2time/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'ASCII Input File' 'ASCII input data file containing new data segment' i1",
  "-I 1 0 1 0 0 1 49x1+3+4 ' ' 'Data Object Input' 'data object input to insert the new segment into' i2",
  "-i 1 0 1 2 0 20x1+6+5.5 1 1 0 0 0 'Start Offset ' 'starting point in ASCII file to start importing at' so",
  "-i 1 0 1 2 0 19.5x1+6+7 2 2 1 0 0 'TIME size    ' 'time' tsize",
  "-x 1 0 1 2 0 39x1+6+8.5 13 1 11 'Data Type   ' 'data type' type 'Bit' 'Byte' 'Unsigned Byte' 'Short' 'Unsigned Short' 'Integer' 'Unsigned Integer' 'Long' 'Unsigned Long' 'Float' 'Double' 'Complex' 'Double Complex'",
  "-O 1 0 0 1 0 1 52x1+0+10.5 ' ' 'Output Object' 'output data object' o",
  "-b +3+3 'Insert Segment in the following Data Object' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kasc2time/uis/kasc2time.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


