 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:42:30 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:42:30 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kasc2val.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kasc2val_get_args
| 
|       Purpose: Gets command line args for kasc2val
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kasc2val
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kasc2val_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kasc2val is out of sync with arguments specified in kasc2val's *.pane file; please rerun ghostwriter on kasc2val.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kasc2val structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "so",
			  &(clui_info->so_int),
			  &(clui_info->so_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "sf",
			  &(clui_info->sf_int),
			  &(clui_info->sf_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "windex", KVF_LIST_LABEL,
			  &(clui_info->windex_label),
			  &(clui_info->windex_flag)) &&
	      kclui_get_value(pane, "windex", KVF_LIST_VAL,
			  &(clui_info->windex_list),
			  &(clui_info->windex_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "hindex", KVF_LIST_LABEL,
			  &(clui_info->hindex_label),
			  &(clui_info->hindex_flag)) &&
	      kclui_get_value(pane, "hindex", KVF_LIST_VAL,
			  &(clui_info->hindex_list),
			  &(clui_info->hindex_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "dindex", KVF_LIST_LABEL,
			  &(clui_info->dindex_label),
			  &(clui_info->dindex_flag)) &&
	      kclui_get_value(pane, "dindex", KVF_LIST_VAL,
			  &(clui_info->dindex_list),
			  &(clui_info->dindex_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "tindex", KVF_LIST_LABEL,
			  &(clui_info->tindex_label),
			  &(clui_info->tindex_flag)) &&
	      kclui_get_value(pane, "tindex", KVF_LIST_VAL,
			  &(clui_info->tindex_list),
			  &(clui_info->tindex_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "eindex", KVF_LIST_LABEL,
			  &(clui_info->eindex_label),
			  &(clui_info->eindex_flag)) &&
	      kclui_get_value(pane, "eindex", KVF_LIST_VAL,
			  &(clui_info->eindex_list),
			  &(clui_info->eindex_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kasc2val_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Import ASCII Data File to Value Segment' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kascii_value",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kasc2val",
  "-H 1  5x1+41+0 'Help' 'man page for kascii_value' $DATAMANIP/objects/kroutine/kasc2val/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'ASCII Input File' 'ASCII input data file containing new data segment' i1",
  "-I 1 0 1 0 0 1 49x1+3+4 ' ' 'Data Object Input' 'data object input to insert the new segment into' i2",
  "-i 1 0 1 2 0 18.5x1+3+6 1 1 0 0 0 'Start Offset ' 'starting point in ASCII file to start importing at' so",
  "-i 1 0 1 2 0 18.5x1+28+6 1 1 0 0 0 'Skip Factor ' 'number of points in ASCII file to skip between reads' sf",
  "-i 1 0 1 2 0 10x1+16+8.5 2 2 1 0 0 ' ' 'width size must be > 0' wsize",
  "-x 1 0 1 2 0 12x1+31+8.5 5 1 1 ' ' 'position in the index order for the width dimension' windex 'First' 'Second' 'Third' 'Fourth' 'Fifth'",
  "-i 1 0 1 2 0 10x1+16+9.5 2 2 1 0 0 ' ' 'height size must be > 0' hsize",
  "-x 1 0 1 2 0 12x1+31+9.5 5 1 2 ' ' 'position in the index order for the height dimension' hindex 'First' 'Second' 'Third' 'Fourth' 'Fifth'",
  "-i 1 0 1 2 0 10x1+16+10.5 2 2 1 0 0 ' ' 'depth size must be > 0' dsize",
  "-x 1 0 1 2 0 12x1+31+10.5 5 1 3 ' ' 'position in the index order for the depth dimension' dindex 'First' 'Second' 'Third' 'Fourth' 'Fifth'",
  "-i 1 0 1 2 0 10x1+16+11.5 2 2 1 0 0 ' ' 'time size must be > 0' tsize",
  "-x 1 0 1 2 0 12x1+31+11.5 5 1 4 ' ' 'position in the index order for the time dimension' tindex 'First' 'Second' 'Third' 'Fourth' 'Fifth'",
  "-i 1 0 1 2 0 10x1+16+12.5 2 2 1 0 0 ' ' 'elements size must be > 0' esize",
  "-x 1 0 1 2 0 12x1+31+12.5 5 1 5 ' ' 'position in the index order for the elements dimension' eindex 'First' 'Second' 'Third' 'Fourth' 'Fifth'",
  "-x 1 0 1 2 0 36x1+6+14 13 1 11 'Data Type   ' 'data type' type 'Bit' 'Byte' 'Unsigned Byte' 'Short' 'Unsigned Short' 'Integer' 'Unsigned Integer' 'Long' 'Unsigned Long' 'Float' 'Double' 'Complex' 'Double Complex'",
  "-O 1 0 0 1 0 1 52x1+0+15.5 ' ' 'Output Object' 'output data object' o",
  "-b +32+7.5 'Value Indicies' valindicies",
  "-b +17+7.5 'Value Sizes' valsizes",
  "-b +3+3 'Insert Segment in the following Data Object' blank1",
  "-b +6+8.5 'WIDTH' blank2",
  "-b +6+9.5 'HEIGHT' blank3",
  "-b +6+10.5 'DEPTH' blank4",
  "-b +6+11.5 'TIME' blank5",
  "-b +6+12.5 'ELEMENTS' blank6",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kasc2val/uis/kasc2val.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	36,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


