 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:42:50 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:42:50 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kaxis.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kaxis_get_args
| 
|       Purpose: Gets command line args for kaxis
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kaxis
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kaxis_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kaxis is out of sync with arguments specified in kaxis's *.pane file; please rerun ghostwriter on kaxis.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kaxis structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ww",
			  &(clui_info->ww_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wh",
			  &(clui_info->wh_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wd",
			  &(clui_info->wd_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hw",
			  &(clui_info->hw_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hh",
			  &(clui_info->hh_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hd",
			  &(clui_info->hd_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dw",
			  &(clui_info->dw_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dh",
			  &(clui_info->dh_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dd",
			  &(clui_info->dd_flag))))
	{
	    kerror(NULL, "kaxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Reorient Data on the Width, Height, and Depth Axes' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Orient",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kaxis",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kaxis/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 51.75x1+0+2 ' ' 'Input ' 'input data object' i",
  "",
  "-O 1 0 0 1 0 1 52x1+0+9 ' ' 'Output' 'resulting data object' o",
  "-b +2+4 'Assign Input Width  to Output:' b22",
  "-b +2+5.5 'Assign Input Height to Output:' b33",
  "-b +2+7 'Assign Input Depth  to Output:' b44",
  "-C 0",
  "-t 1 0 1 1 0 6.75x1+27+4 'Width' 'assign input width data to output width axis' ww",
  "-t 1 0 1 0 0 6.875x1+35+4 'Height' 'Assign input width data to output height axis' wh",
  "-t 1 0 1 0 0 6.125x1+43+4 'Depth' 'Assign input width data to output depth axis' wd",
  "-E",
  "",
  "-C 0",
  "-t 1 0 1 0 0 6.125x1+27+5.5 'Width' 'Assign input height data to output width axis' hw",
  "-t 1 0 1 1 0 6.875x1+35+5.5 'Height' 'Assign input height data to output height axis' hh",
  "-t 1 0 1 0 0 6.125x1+43+5.5 'Depth' 'Assign input height data to output depth axis' hd",
  "-E",
  "",
  "-C 0",
  "-t 1 0 1 0 0 6.5x1+27+7 'Width' 'Assign input depth data to output width axis' dw",
  "-t 1 0 1 0 0 6.875x1+35+7 'Height' 'Assign input depth data to output height axis' dh",
  "-t 1 0 1 1 0 6.125x1+43+7 'Depth' 'Assign input depth data to output depth axis' dd",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kaxis/uis/kaxis.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	35,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


