 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:43:11 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:43:11 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kbessel.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kbessel_get_args
| 
|       Purpose: Gets command line args for kbessel
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kbessel
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kbessel_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kbessel is out of sync with arguments specified in kbessel's *.pane file; please rerun ghostwriter on kbessel.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kbessel structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kbessel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kbessel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "j",
			  &(clui_info->j_flag))))
	{
	    kerror(NULL, "kbessel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "y",
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "kbessel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ord0",
			  &(clui_info->ord0_flag))))
	{
	    kerror(NULL, "kbessel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ord1",
			  &(clui_info->ord1_flag))))
	{
	    kerror(NULL, "kbessel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "order",
			  &(clui_info->order_int),
			  &(clui_info->order_flag))))
	{
	    kerror(NULL, "kbessel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute Bessel Functions' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Bessel",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kbessel",
  "-H 1  5x1+41+0 'Help' 'help page for Bessel functions' $DATAMANIP/objects/kroutine/kbessel/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'input data object' i",
  "-O 1 0 0 1 0 1 52x1+0+11.5 ' ' 'Output' 'resulting output data object' o",
  "-C 1",
  "-t 1 0 1 1 0 25x1+4+4 'Bessel Function of the First Kind' 'Bessel function of the first kind' j",
  "-t 1 0 1 0 0 25x1+4+5 'Bessel Function of the Second Kind' 'Bessel function of the second kind' y",
  "-E",
  "-b +1+6.5 'Select Order:' b1",
  "-C 1",
  "-t 1 0 1 0 1 12x1+4+7.5 'Order 0' 'Compute Bessel function of order 0' ord0",
  "-t 1 0 1 1 1 12x1+4+8.5 'Order 1' 'Compute Bessel function of order 1' ord1",
  "-i 1 0 1 0 1 25x1+4+9.5 0 0 2 1 0 'Specify Order' 'Compute Bessel function of specified order' order",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kbessel/uis/kbessel.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	24,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


