 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:43:36 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:43:36 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kbitwise.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kbitwise_get_args
| 
|       Purpose: Gets command line args for kbitwise
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kbitwise
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kbitwise_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kbitwise is out of sync with arguments specified in kbitwise's *.pane file; please rerun ghostwriter on kbitwise.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kbitwise structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "real",
			  &(clui_info->real_int),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "and",
			  &(clui_info->and_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ls",
			  &(clui_info->ls_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "or",
			  &(clui_info->or_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "rs",
			  &(clui_info->rs_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "xor",
			  &(clui_info->xor_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "srs",
			  &(clui_info->srs_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "nand",
			  &(clui_info->nand_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "rr",
			  &(clui_info->rr_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "nor",
			  &(clui_info->nor_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "lr",
			  &(clui_info->lr_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "andrev",
			  &(clui_info->andrev_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "andinv",
			  &(clui_info->andinv_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "orrev",
			  &(clui_info->orrev_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "orinv",
			  &(clui_info->orinv_flag))))
	{
	    kerror(NULL, "kbitwise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Dual Operand Bitwise Operations' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kbitwise",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kbitwise",
  "-H 1  5x1+41+0 'Help' 'man page for kbitwise' $DATAMANIP/objects/kroutine/kbitwise/help/kbitwise.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input 1' 'first input data object' i1",
  "-O 1 0 0 1 0 1 52x1+0+19 ' ' 'Output' 'resulting output data object' o",
  "-C 0",
  "-I 1 0 1 0 0 1 48.25x1+4+5 ' ' 'Input 2' 'second input data object' i2",
  "-i 1 0 1 1 0 30x1+4+6 0 0 1 0 0 'Constant ' 'constant value' real",
  "-E",
  "-b +1+3.75 'Enter a 2nd Input or a Constant Value' b1",
  "-b +1+8 'Select Bitwise Operation:' b2",
  "-C 1",
  "-t 1 0 1 1 0 16x1+4+9 'AND' 'Bitwise AND:  o = i1 & (i2 or val)' and",
  "-t 1 0 1 0 0 17.5x1+26+9 'Left Shift' 'Bitwise Left Shift:  o = i1 << by (i2 or val)' ls",
  "-t 1 0 1 0 0 16x1+4+10 'OR' 'Bitwise OR:   o = i1 | (i2 or val)' or",
  "-t 1 0 1 0 0 17.5x1+26+10 'Unsigned Right Shift' 'Bitwise Right Shift:  o = i1 >> by (i2 or val)' rs",
  "-t 1 0 1 0 0 16x1+4+11 'XOR' 'Bitwise XOR:  o = i1 ^ (i2 or val)' xor",
  "-t 0 0 1 0 0 17.5x1+26+11 'Signed Right Shift' 'Bitwise Signed Right Shift by (i2 or val)' srs",
  "-t 1 0 1 0 0 16x1+4+12 'NAND' 'Bitwise NAND: o = (~i1) | (~(i2 or val))' nand",
  "-t 0 0 1 0 0 17.5x1+26+12 'Right Rotate' 'Bitwise Right Rotate by (i2 or val)' rr",
  "-t 1 0 1 0 0 16x1+4+13 'NOR' 'Bitwise NOR:  o = (~i1) & (~(i2 or val))' nor",
  "-t 0 0 1 0 0 18x1+26+13 'Left Rotate' 'Bitwise Left Rotate by (i2 or val)' lr",
  "-t 1 0 1 0 0 16x1+4+14 '1 AND (NOT 2)' 'Bitwise AND Reverse:   o = i1 & (~(i2 or val))' andrev",
  "-t 1 0 1 0 0 16x1+4+15 '(NOT 1) AND 2' 'Bitwise AND Inverted:  o = (~i1) & (i2 or val)' andinv",
  "-t 1 0 1 0 0 16x1+4+16 '1 OR (NOT 2)' 'Bitwise OR Reverse:    o = i1 | (~(i2 or val))' orrev",
  "-t 1 0 1 0 0 16x1+4+17 '(NOT 1) OR 2' 'Bitwise OR Inverted:   o = (~i1) | i2' orinv",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kbitwise/uis/kbitwise.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	36,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


