 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:44:00 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:44:00 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kblend.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kblend_get_args
| 
|       Purpose: Gets command line args for kblend
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kblend
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kblend_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kblend is out of sync with arguments specified in kblend's *.pane file; please rerun ghostwriter on kblend.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kblend structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kblend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kblend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kblend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ratio",
			  &(clui_info->ratio_double),
			  &(clui_info->ratio_flag))))
	{
	    kerror(NULL, "kblend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "iratio",
			  &(clui_info->iratio_file),
			  &(clui_info->iratio_flag))))
	{
	    kerror(NULL, "kblend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Output = (Input 1 * Constant) + (Input 2 (1 - Constant))' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kblend",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kblend",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kblend/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input 1 ' 'first input data object' i1",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Input 2 ' 'second input file object' i2",
  "",
  "-O 1 0 0 1 0 1 52x1+0+8 ' ' 'Output' 'resulting output data object' o",
  "",
  "-C 1",
  "-h 1 0 1 1 1 50x1+2+5 0 1 0.5 0 1 0 'Blending Constant' 'Ratio of blending the two objects' ratio",
  "-I 1 0 1 0 0 1 50x1+2+6 ' ' 'Blending file' 'Input object for providing blending ratios' iratio",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kblend/uis/kblend.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	21,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


