 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:44:25 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:44:25 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kclip.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kclip_get_args
| 
|       Purpose: Gets command line args for kclip
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kclip
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kclip_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kclip is out of sync with arguments specified in kclip's *.pane file; please rerun ghostwriter on kclip.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kclip structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kclip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "thresh",
			  &(clui_info->thresh_logic),
			  &(clui_info->thresh_flag))))
	{
	    kerror(NULL, "kclip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "fval",
			  &(clui_info->fval_double),
			  &(clui_info->fval_flag))))
	{
	    kerror(NULL, "kclip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tval",
			  &(clui_info->tval_double),
			  &(clui_info->tval_flag))))
	{
	    kerror(NULL, "kclip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kclip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "lc",
			  &(clui_info->lc_double),
			  &(clui_info->lc_flag))))
	{
	    kerror(NULL, "kclip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "ilc",
			  &(clui_info->ilc_file),
			  &(clui_info->ilc_flag))))
	{
	    kerror(NULL, "kclip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "uc",
			  &(clui_info->uc_double),
			  &(clui_info->uc_flag))))
	{
	    kerror(NULL, "kclip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "iuc",
			  &(clui_info->iuc_file),
			  &(clui_info->iuc_flag))))
	{
	    kerror(NULL, "kclip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 10x10+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 10x10+0+0 +1+0 'Clip or Threshold the Range of Values in Object' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' Clip",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kclip",
  "-H 1  5x1+41+0 'Help' 'help page for kclip' $DATAMANIP/objects/kroutine/kclip/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input file' i",
  "-l 1 0 1 2 0 23.75x1+1+4 0 'Operation Type  ' 'Clip Data' 'Threshold Data' 'Clip (0) or Threshold (1) Object Data' thresh",
  "-h 1 0 1 0 1 51x1+1+14 0 0 0 0 0 0 'Output Value when evaluation is FALSE ' 'Value assigned to output if evaluation is FALSE' fval",
  "-h 1 0 1 0 1 51x1+1+15 0 0 255 0 0 0 'Output Value when evaluation is TRUE  ' 'Value assigned to output if evaluation is TRUE (thresholding only)' tval",
  "-O 1 0 0 1 0 1 52x1+0+24 ' ' ' Output ' 'output file' o",
  "-K 1",
  "-C 0",
  "-h 1 0 1 1 1 48x1+4+7 0 0 128 0 0 0 'Lower Cutoff Value  ' 'Constant lower cutoff value' lc",
  "-I 1 0 1 0 0 1 48x1+4+8 ' ' 'Lower Cutoff Values File' 'File containing lower cutoff values' ilc",
  "-E",
  "-C 0",
  "-h 1 0 1 0 1 48x1+4+10.5 0 0 255 0 0 0 'Upper Cutoff Value' 'Constant upper cutoff value' uc",
  "-I 1 0 1 0 0 1 48x1+4+11.5 ' ' 'Upper Cutoff Values File' 'File containing upper cutoff values' iuc",
  "-E",
  "-E",
  "-b +1+6 'If data value is LESS THAN Lower Cutoff, evaluation = FALSE' b2",
  "-b +1+9.5 'If data value is GREATER THAN Upper Cutoff, evaluation = FALSE' b3",
  "-b +1+13 'Output Values:' b4",
  "-b +5+21.5 'Where TRUE/FALSE Output Values are NOT selected, the Cutoff' b5",
  "-b +5+19.5 'FALSE Value assigned when evaluation for LOWER Cutoff is False.' b6",
  "-b +5+20.5 'TRUE Value assigned when evaluation for UPPER Cutoff is False.' b7",
  "-b +1+16.5 'For Clipping Only:' b51",
  "-b +3+17.5 'Where Evaluation is TRUE, output always equals input.' b512",
  "-b +3+18.5 'Where Evaluation is FALSE:' b5123",
  "-b +7+22.5 'Values are used.' b54",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kclip/uis/kclip.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	37,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


