 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:44:49 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:44:49 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kcmplx.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kcmplx_get_args
| 
|       Purpose: Gets command line args for kcmplx
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcmplx
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kcmplx_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kcmplx is out of sync with arguments specified in kcmplx's *.pane file; please rerun ghostwriter on kcmplx.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kcmplx structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kcmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kcmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "conj",
			  &(clui_info->conj_flag))))
	{
	    kerror(NULL, "kcmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "p2r",
			  &(clui_info->p2r_flag))))
	{
	    kerror(NULL, "kcmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "r2p",
			  &(clui_info->r2p_flag))))
	{
	    kerror(NULL, "kcmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Single Operand Complex Arithmetic' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kcmplx",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kcmplx",
  "-H 1  5x1+41+0 'Help' 'man page for kcmplx' $DATAMANIP/objects/kroutine/kcmplx/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'input data object' i",
  "-O 1 0 0 1 0 1 52x1+0+8.5 ' ' 'Output' 'resulting output data object' o",
  "-b +1+3.5 'Select Complex Calculation:' b1",
  "-C 1",
  "-t 1 0 1 1 0 25x1+4+4.5 'Conjugate' 'Complex Conjugate' conj",
  "-t 1 0 1 0 0 25.625x1+4+5.5 'Polar to Rectangular Conversion' 'Convert Polar Coordinates to Rectangular Coordinates' p2r",
  "-t 1 0 1 0 0 25.625x1+4+6.5 'Rectangular to Polar Conversion' 'Convert Rectangular Coordinates to Polar Coordinates' r2p",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kcmplx/uis/kcmplx.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


