 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:45:15 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:45:15 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kcmplx2real.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kcmplx2real_get_args
| 
|       Purpose: Gets command line args for kcmplx2real
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcmplx2real
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kcmplx2real_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kcmplx2real is out of sync with arguments specified in kcmplx2real's *.pane file; please rerun ghostwriter on kcmplx2real.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kcmplx2real structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "or",
			  &(clui_info->or_file),
			  &(clui_info->or_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "oi",
			  &(clui_info->oi_file),
			  &(clui_info->oi_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "op",
			  &(clui_info->op_file),
			  &(clui_info->op_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "om",
			  &(clui_info->om_file),
			  &(clui_info->om_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mag",
			  &(clui_info->mag_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "magsq",
			  &(clui_info->magsq_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "logmag1",
			  &(clui_info->logmag1_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "logmagsq1",
			  &(clui_info->logmagsq1_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "logmag",
			  &(clui_info->logmag_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "logmagsq",
			  &(clui_info->logmagsq_flag))))
	{
	    kerror(NULL, "kcmplx2real_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Output = Real, Imaginary, Phase, or Magnitude Component of Input' subform",
  "-P 1 0 52.25x8+0+1 +0+0 ' ' kcmplxconv",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kcmplx2real",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kcmplx2real/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input data object' i",
  "-b +1+9 'Output Files:' b1",
  "-K 1",
  "-O 1 0 1 1 0 1 52x1+0+10 ' ' 'Real     ' 'Output data object containing REAL component of input ' or",
  "-O 1 0 1 0 0 1 52x1+0+11 ' ' 'Imaginary' 'Output data object containing imaginary component of input' oi",
  "-O 1 0 1 0 0 1 52x1+0+12 ' ' 'Phase    ' 'Output data object containing phase of input' op",
  "-O 1 0 1 0 0 1 52x1+0+13 ' ' 'Magnitude' 'Output data object containing magnitude of input' om",
  "-C 0",
  "-t 1 0 1 0 0 9.5x1+6+5 'Magnitude' 'Magnitude = sqrt(real*real + imag*imag)' mag",
  "-t 1 0 1 0 0 15.125x1+28+5 'Magnitude Squared' 'Magnitude Squared = real*real + imag*imag' magsq",
  "-t 1 0 1 1 0 16.625x1+6+6 'Log (Magnitude + 1)' 'Log(Magnitude+1) = log(sqrt(real*real + imag*imag)+1)' logmag1",
  "-t 1 0 1 0 0 22.625x1+28+6 'Log (Magnitude Squared + 1)' 'Log(Magnitude Squared+1) = log(real*real+imag*imag+1)' logmagsq1",
  "-t 1 0 1 0 0 15.625x1+6+7 'Log (Magnitude)' 'Log(Magnitude) = log(sqrt(real*real + imag*imag))' logmag",
  "-t 1 0 1 0 0 14x1+28+7 'Log (Magnitude Squared)' 'Log(Magnitude Squared) = log(real*real + imag*imag)' logmagsq",
  "-E",
  "-E",
  "-b +4+4 'If Magnitude Output Selected, Specify Calculation:' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kcmplx2real/uis/kcmplx2real.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	29,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


