 /*
  * Khoros: $Id: usage.c,v 1.14.2.3 1997/05/31 18:45:37 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.3 1997/05/31 18:45:37 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kcomment.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kcomment_get_args
| 
|       Purpose: Gets command line args for kcomment
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcomment
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kcomment_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kcomment is out of sync with arguments specified in kcomment's *.pane file; please rerun ghostwriter on kcomment.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kcomment structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kcomment_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "s",
			  &(clui_info->s_string),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "kcomment_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kcomment_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "ed",
			  &(clui_info->ed_logic),
			  &(clui_info->ed_flag))))
	{
	    kerror(NULL, "kcomment_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "re",
			  &(clui_info->re_flag))))
	{
	    kerror(NULL, "kcomment_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pr",
			  &(clui_info->pr_flag))))
	{
	    kerror(NULL, "kcomment_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "app",
			  &(clui_info->app_flag))))
	{
	    kerror(NULL, "kcomment_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Change the Comment on a Data Object' info",
  "-P 1 0 52x1+0+1 +6+0 ' ' kcomment",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kcomment",
  "-H 1  5x1+41+0 'Help' 'man page for kcomment' $DATAMANIP/objects/kroutine/kcomment/help help0",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input' 'Input Data Object' i",
  "-s 1 0 1 2 1 49.5x5+2+8.5 ' ' ' ' 'Comment String' s",
  "-O 1 0 1 1 0 1 52x1+0+14 ' ' 'Output' 'Resulting Output Data Object' o",
  "-b +3+4.5 '- OR -   Modify Comment With String Below' blank1",
  "-b +3+7.5 'Enter String Here :' blank2",
  "-C 0",
  "-l 1 0 1 1 0 30x1+4+3 1 'Edit Existing Comment   ' 'False' 'True' 'Edit Existing Comment' ed",
  "-t 1 0 1 0 0 7.625x1+4+6 'Replace' 'Replace Comment with String' re",
  "-t 1 0 1 0 0 7.625x1+18+6 'Prepend' 'Prepend String to Comment' pr",
  "-t 1 0 1 0 0 6.875x1+32+6 'Append' 'Append Comment to String' app",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kcomment/uis/kcomment.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	23,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


