 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:46:04 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:46:04 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kcompare.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kcompare_get_args
| 
|       Purpose: Gets command line args for kcompare
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcompare
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kcompare_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kcompare is out of sync with arguments specified in kcompare's *.pane file; please rerun ghostwriter on kcompare.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kcompare structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tol",
			  &(clui_info->tol_double),
			  &(clui_info->tol_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tval",
			  &(clui_info->tval_double),
			  &(clui_info->tval_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "fval",
			  &(clui_info->fval_double),
			  &(clui_info->fval_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "eq",
			  &(clui_info->eq_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ne",
			  &(clui_info->ne_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "gt",
			  &(clui_info->gt_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ge",
			  &(clui_info->ge_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "lt",
			  &(clui_info->lt_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "le",
			  &(clui_info->le_flag))))
	{
	    kerror(NULL, "kcompare_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Comparison Operators' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' klogical",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kcompare",
  "-H 1  5x1+41+0 'Help' 'man page for kline' $DATAMANIP/objects/kroutine/kcompare/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input #1' 'first input data object' i1",
  "-h 0 0 1 0 1 32x1+1+15.5 0 0 0 0 1 1 'Tolerance' 'Tolerance' tol",
  "-h 1 0 1 2 1 32x1+1+17 0 0 1 0 1 1 'TRUE Value  ' 'Value assigned to output if evaluation is TRUE' tval",
  "-h 1 0 1 2 1 32x1+1+18 0 0 0 0 1 1 'FALSE Value ' 'Value assigned to output if evaluation is FALSE' fval",
  "-O 1 0 0 1 0 1 52x1+0+20 ' ' 'Output' 'resulting output data object' o",
  "-b +1+3.75 'Enter a 2nd Input or a Constant Value' b1",
  "-C 1",
  "-I 1 0 1 1 0 1 49x1+3+5 ' ' 'Input #2' 'second input data object' i2",
  "-h 1 0 1 0 1 30x1+3+6 1 1 1 0 1 1 'Constant' 'constant value' real",
  "-E",
  "-b +1+7.5 'Select Comparison Operation:' b2",
  "-C 1",
  "-t 1 0 1 1 0 25x1+4+8.5 'Equal' 'Equal: if i1 == (i2 or val), i1 = TRUE' eq",
  "-t 1 0 1 0 0 25x1+4+9.5 'Not Equal' 'Not Equal:  if i1 != (i2 or val), i1 = TRUE' ne",
  "-t 1 0 1 0 0 25x1+4+10.5 'Greater Than' 'Greater Than:  if i1 >  (i2 or val), i1 = TRUE' gt",
  "-t 1 0 1 0 0 25x1+4+11.5 'Greater Than or Equal' 'Greater Than or Equal:  if i1 >= (i2 or val), i1 = TRUE' ge",
  "-t 1 0 1 0 0 25x1+4+12.5 'Less Than' 'Less Than:  if i1 <  (i2 or val), i1 = TRUE' lt",
  "-t 1 0 1 0 0 25x1+4+13.5 'Less Than or Equal' 'Less Than or Equal:  if i1 <= (i2 or val), i1 = TRUE' le",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kcompare/uis/kcompare.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	31,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


