 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:46:32 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:46:32 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kconvert.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kconvert_get_args
| 
|       Purpose: Gets command line args for kconvert
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kconvert
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kconvert_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kconvert is out of sync with arguments specified in kconvert's *.pane file; please rerun ghostwriter on kconvert.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kconvert structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "scale",
			  &(clui_info->scale_double),
			  &(clui_info->scale_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "roff",
			  &(clui_info->roff_double),
			  &(clui_info->roff_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ioff",
			  &(clui_info->ioff_double),
			  &(clui_info->ioff_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "val",
			  &(clui_info->val_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "map",
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mask",
			  &(clui_info->mask_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "loc",
			  &(clui_info->loc_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "time",
			  &(clui_info->time_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "segment",
			  &(clui_info->segment_string),
			  &(clui_info->segment_flag))))
	{
	    kerror(NULL, "kconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Convert Data Storage Type  (Optional Scale & Offset)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Convert_Type",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kconvert",
  "-H 1  5x1+41+0 'Help' 'help page for kconvert' $DATAMANIP/objects/kroutine/kconvert/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'input data object' i",
  "-x 1 0 1 2 0 44.875x1+1+3.5 14 0 0 'Select Output Data Type:  ' 'Convert to specified data type' type 'Propagate Input Type' 'Bit' 'Byte' 'Unsigned Byte' 'Short' 'Unsigned Short' 'Integer' 'Unsigned Integer' 'Long' 'Unsigned Long' 'Float' 'Double' 'Complex' 'Double Complex'",
  "-h 1 0 1 2 1 40x1+1+10 0 0 1 0 1 1 'Scale Factor          ' 'Real scale factor' scale",
  "-h 1 0 1 2 1 40x1+1+11 0 0 0 0 1 1 'Real Offset Value     ' 'Real offset value' roff",
  "-h 1 0 1 2 1 40x1+1+12 0 0 0 0 1 1 'Imaginary Offset Value' 'Imaginary offset value' ioff",
  "-O 1 0 0 1 0 1 52x1+0+13.5 ' ' 'Output' 'resulting data object' o",
  "-C 1",
  "-t 1 0 1 1 0 10.375x1+2+6.5 'Value' 'If -val flag is selected, operate on Value segment' val",
  "-t 1 0 1 0 0 10.375x1+12+6.5 'Map' 'If -map flag is selected, operate on Map segment' map",
  "-t 1 0 1 0 0 10.375x1+22+6.5 'Mask' 'If -mask flag is selected, operate on Mask segment' mask",
  "-t 1 0 1 0 0 10.375x1+32+6.5 'Location' 'If -loc flag is selected, operate on Location segment' loc",
  "-t 1 0 1 0 0 10.375x1+42+6.5 'Time' 'If -time flag is selected, operate on Time segment' time",
  "-y 1 0 1 0 0 47x1+2+8 0 0 'Alternate Segment' 'Perform operation on user specified segment' segment",
  "-E",
  "-b +1+5 'Select Data Segment(s):' blank2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kconvert/uis/kconvert.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	27,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


