 /*
  * Khoros: $Id: usage.c,v 1.7.2.2 1997/05/31 18:48:06 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.7.2.2 1997/05/31 18:48:06 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kelevation.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kelevation_get_args
| 
|       Purpose: Gets command line args for kelevation
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kelevation
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kelevation_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kelevation is out of sync with arguments specified in kelevation's *.pane file; please rerun ghostwriter on kelevation.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kelevation structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "xbegin",
			  &(clui_info->xbegin_double),
			  &(clui_info->xbegin_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "xend",
			  &(clui_info->xend_double),
			  &(clui_info->xend_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ybegin",
			  &(clui_info->ybegin_double),
			  &(clui_info->ybegin_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "yend",
			  &(clui_info->yend_double),
			  &(clui_info->yend_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "doff",
			  &(clui_info->doff_int),
			  &(clui_info->doff_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "toff",
			  &(clui_info->toff_int),
			  &(clui_info->toff_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "eoff",
			  &(clui_info->eoff_int),
			  &(clui_info->eoff_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kelevation_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create Elevation Location Data From Value Plane ' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kelevation",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kelevation",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kelevation/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input value data object to use for elevation' i",
  "",
  "-h 1 0 1 2 0 16x1+6+5.5 0 0 0 1 0 0 'X ' 'Explicit Location Begin for X dimension' xbegin",
  "-h 1 0 1 2 0 16x1+25+5.5 0 0 1 1 0 0 'X ' 'Explicit Location End for X dimension' xend",
  "-h 1 0 1 2 0 16x1+6+6.5 0 0 0 1 0 0 'Y ' 'Explicit Location Begin for Y dimension' ybegin",
  "-h 1 0 1 2 0 16x1+25+6.5 0 0 1 1 0 0 'Y ' 'Explicit Location End for Y dimension' yend",
  "-i 1 0 1 1 1 24x1+8+9.5 1 1 0 0 0 'Depth   ' 'Depth of Value Plane to transfer' doff",
  "-i 1 0 1 1 1 24x1+8+10.5 1 1 0 0 0 'Time    ' 'Time of Value Plane to transfer' toff",
  "-i 1 0 1 1 1 24x1+8+11.5 1 1 0 0 0 'Elements' 'Element of Value Plane to transfer' eoff",
  "",
  "-x 1 0 1 2 0 44.875x1+2+13 14 0 0 'Select Output Data Type:  ' 'Resulting Elevation will be in data type' type 'Propagate Value Type' 'Bit' 'Byte' 'Unsigned Byte' 'Short' 'Unsigned Short' 'Integer' 'Unsigned Integer' 'Long' 'Unsigned Long' 'Float' 'Double' 'Complex' 'Double Complex'",
  "",
  "-O 1 0 0 1 0 1 52x1+0+14.5 ' ' 'Output' 'Resulting Output Object with elevation' o",
  "",
  "-b +8+4.5 'LOCATION BEGIN' b1",
  "-b +27+4.5 'LOCATION END' b2",
  "-b +2+8.5 'Value Plane to Become Explicit (Z) Locations' blank1",
  "-b +2+3.5 'Explicit (X,Y) Location Range' blank2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kelevation/uis/kelevation.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	30,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


