 /*
  * Khoros: $Id: usage.c,v 1.4.2.2 1997/05/31 18:48:25 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.4.2.2 1997/05/31 18:48:25 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kexprn.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kexprn_get_args
| 
|       Purpose: Gets command line args for kexprn
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kexprn
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kexprn_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kexprn is out of sync with arguments specified in kexprn's *.pane file; please rerun ghostwriter on kexprn.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kexprn structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "kexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i4",
			  &(clui_info->i4_file),
			  &(clui_info->i4_flag))))
	{
	    kerror(NULL, "kexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i5",
			  &(clui_info->i5_file),
			  &(clui_info->i5_flag))))
	{
	    kerror(NULL, "kexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i6",
			  &(clui_info->i6_file),
			  &(clui_info->i6_flag))))
	{
	    kerror(NULL, "kexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "expr",
			  &(clui_info->expr_string),
			  &(clui_info->expr_flag))))
	{
	    kerror(NULL, "kexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Output = Function(Input1, Input2)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kexprn",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $DATAMANIP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kexprn",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kexprn/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 51.5x1+0+2.5 ' ' ' i1 ' 'input data object 1' i1",
  "-I 1 0 1 0 0 1 49.5x1+2+3.5 ' ' ' i2 ' 'input data object 2' i2",
  "-I 1 0 1 0 0 1 49.5x1+2+4.5 ' ' ' i3 ' 'input data object 3' i3",
  "-I 1 0 1 0 0 1 49.5x1+2+5.5 ' ' ' i4 ' 'input data object 4' i4",
  "-I 1 0 1 0 0 1 49.5x1+2+6.5 ' ' ' i5 ' 'input data object 5' i5",
  "-I 1 0 1 0 0 1 48.5x1+2+7.5 ' ' ' i6 ' 'input data object 6' i6",
  "-s 1 0 0 1 0 49.5x2.81818+1+10 ' ' ' ' 'arithmetic expression' expr",
  "-O 1 0 0 1 0 1 51.5x1+0+14.5 ' ' '  o ' 'resulting output data object' o",
  "-x 1 0 1 2 0 44.375x1+1+16 14 0 0 'Select Output Data Type:  ' 'Output Data type' type 'Propagate Input Type' 'Bit' 'Byte' 'Unsigned Byte' 'Short' 'Unsigned Short' 'Integer' 'Unsigned Integer' 'Long' 'Unsigned Long' 'Float' 'Double' 'Complex' 'Double Complex'",
  "-b +1+1.5 'Input Data Objects:' b1",
  "-b +1+9 'Arithmetic Expression:' b2",
  "-b +1+13.5 'Output Data Object (o):' b3",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kexprn/uis/kexprn.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	24,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


