 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:48:52 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:48:52 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kextract.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kextract_get_args
| 
|       Purpose: Gets command line args for kextract
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kextract
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kextract_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kextract is out of sync with arguments specified in kextract's *.pane file; please rerun ghostwriter on kextract.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kextract structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "woff",
			  &(clui_info->woff_int),
			  &(clui_info->woff_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hoff",
			  &(clui_info->hoff_int),
			  &(clui_info->hoff_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "doff",
			  &(clui_info->doff_int),
			  &(clui_info->doff_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "toff",
			  &(clui_info->toff_int),
			  &(clui_info->toff_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "eoff",
			  &(clui_info->eoff_int),
			  &(clui_info->eoff_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "subpos",
			  &(clui_info->subpos_logic),
			  &(clui_info->subpos_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kextract_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Extract Rectangular Region from Object' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Extract_Region",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kextract",
  "-H 1  5x1+41+0 'Help' 'help page for kextract' $DATAMANIP/objects/kroutine/kextract/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input ' 'Input object' i",
  "",
  "-i 1 0 1 1 1 29.5x1+19+4 2 2 1 1 1 'Width   ' 'Specifies the region width' wsize",
  "-i 1 0 1 1 1 29.5x1+19+5 2 2 1 1 1 'Height  ' 'Specifies the region height' hsize",
  "-i 1 0 1 0 1 29.5x1+19+6 2 2 1 1 1 'Depth   ' 'Specifies the region depth' dsize",
  "-i 1 0 1 0 1 29.5x1+19+7 2 2 1 1 1 'Time    ' 'Specifies the region size on time dimension' tsize",
  "-i 1 0 1 0 1 29.5x1+19+8 2 2 1 1 1 'Elements' 'Specifies the region size on elements dimension' esize",
  "-i 1 0 1 1 1 29.5x1+19+10.5 0 0 0 1 1 'Width   ' 'Specifies origin of region on width dimension' woff",
  "-i 1 0 1 1 1 29.5x1+19+11.5 0 0 0 1 1 'Height  ' 'Specifies origin of region on height dimension' hoff",
  "-i 1 0 1 0 1 29.5x1+19+12.5 0 0 0 1 1 'Depth   ' 'Specifies origin of region on depth dimension' doff",
  "-i 1 0 1 0 1 29.5x1+19+13.5 0 0 0 1 1 'Time    ' 'Specifies origin of region on time dimension' toff",
  "-i 1 0 1 0 1 29.5x1+19+14.5 0 0 0 1 1 'Elements' 'Specifies origin of region on elements dimension' eoff",
  "-l 1 0 1 2 0 46x1+1+18.5 0 'Record Region Origin (Subobject Position) in Output ' 'No' 'Yes' 'Record region origin (Subobject Position) in output' subpos",
  "-O 1 0 0 1 0 0 51.5x1+0+20 ' ' 'Output' 'Resulting output region' o",
  "-b +1+10.5 'Specify Region Origin:' b1",
  "-b +1+4 'Specify Region Size:' b2",
  "-b +1+16 'If Size is not selected for a dimension, all data on that' blank1",
  "-b +1+17 'dimension will be extracted, starting at the specified Origin' blank10",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kextract/uis/kextract.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	30,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


