 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:49:12 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:49:12 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kfft.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kfft_get_args
| 
|       Purpose: Gets command line args for kfft
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kfft
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kfft_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kfft is out of sync with arguments specified in kfft's *.pane file; please rerun ghostwriter on kfft.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the kfft structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dir",
			  &(clui_info->dir_logic),
			  &(clui_info->dir_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "center",
			  &(clui_info->center_logic),
			  &(clui_info->center_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "scale", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->scale_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->scale_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_cycle),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "whole",
			  &(clui_info->whole_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "w",
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "h",
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "d",
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "t",
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "e",
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "kfft_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Fast Fourier Transform (Forward and Inverse)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' FFT",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kfft",
  "-H 1  5x1+41+0 'Help' 'help page for kfft' $DATAMANIP/objects/kroutine/kfft/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Complex Input' 'complex input object' i",
  "-l 1 0 1 1 0 40x1+1+4 0 'FFT direction:  ' 'Forward     ' 'Inverse' 'FFT direction (0 is forward, 1 is inverse)' dir",
  "-l 1 0 1 1 0 40x1+1+5.5 1 'Shift Transform:' 'Not Centered (DC at origin)' 'Centered (DC at N/2)' 'select to center (1) or not to center (0) the transform' center",
  "-T 1 0 1 1 0 24.125x1+1+7 +0+0 3 'Scaling Options:' 'scale FFT by 1, 1/N or 1/sqrt(N)' scale",
  "-t 1 0 1 0 0 10x1+3+1 'Unity scaling' 'Scale the output data by unity' dummy",
  "-t 1 0 1 0 0 10x1+3+2 'Scale output by 1/N per transform axis' 'Scale output data by 1/N per transform axis' dummy",
  "-t 1 0 1 1 0 10x1+3+3 'Scale output by 1/sqrt(N) per transform axis' 'Scale output data by 1/sqrt(N) per transform axis' dummy",
  "-E",
  "-c 1 0 1 2 0 30.5x1.5+2+15.5 2 12 12 'Output data type ' 'Output object data type' type 'Complex' 'Double Complex'",
  "-O 1 0 0 1 0 1 52x1+0+17.5 ' ' 'Complex Output' 'complex output object' o",
  "-b +1+11.5 'Choose dimensions to be transformed:' b2",
  "-C 0",
  "-t 1 0 1 1 0 12.875x1+2+12.5 'Whole Data Set' 'compute FFT along all dimensions ' whole",
  "-K 0",
  "-t 1 0 1 0 0 9x1+2+14 'Width  ' 'if set, FFT is taken along the width dimension' w",
  "-t 1 0 1 0 0 9x1+12+14 'Height ' 'if set, FFT is taken along the height dimension' h",
  "-t 1 0 1 0 0 9x1+22+14 'Depth  ' 'if set, FFT is taken along the depth dimension' d",
  "-t 1 0 1 0 0 9x1+32+14 'Time   ' 'if set, FFT is taken along the time dimension' t",
  "-t 1 0 1 0 0 9x1+42+14 'Element' 'if set, FFT is taken along the element dimension' e",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kfft/uis/kfft.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	33,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


