 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:49:35 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:49:35 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kflip.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kflip_get_args
| 
|       Purpose: Gets command line args for kflip
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kflip
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kflip_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kflip is out of sync with arguments specified in kflip's *.pane file; please rerun ghostwriter on kflip.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kflip structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kflip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kflip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "w",
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "kflip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "h",
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "kflip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "d",
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "kflip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "t",
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "kflip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "e",
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "kflip_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Reflect Data Along Specified Axes' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kflip",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kflip",
  "-H 1  5x1+41+0 'Help' 'help page for kflip' $DATAMANIP/objects/kroutine/kflip/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image' 'Source (input) object' i",
  "-O 1 0 0 1 0 1 52x1+0+7.5 ' ' 'Output Image' 'Destination (output) object' o",
  "-b +1+4 'Reflection Directions:' b0",
  "-K 1",
  "-t 1 0 1 1 0 7x1+2+5.5 'Width' 'reflection in the WIDTH direction' w",
  "-t 1 0 1 0 0 8x1+11+5.5 'Height' 'reflection in the HEIGHT direction' h",
  "-t 1 0 1 0 0 7x1+20+5.5 'Depth' 'reflection in the DEPTH direction' d",
  "-t 1 0 1 0 0 7x1+29+5.5 'Time' 'reflection in the TIME direction ' t",
  "-t 1 0 1 0 0 9.5x1+38+5.5 'Elements' 'reflection in the ELEMENTS direction' e",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kflip/uis/kflip.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	22,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


