 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:49:55 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:49:55 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kformats.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kformats_get_args
| 
|       Purpose: Gets command line args for kformats
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kformats
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kformats_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kformats is out of sync with arguments specified in kformats's *.pane file; please rerun ghostwriter on kformats.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kformats structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ascii",
			  &(clui_info->ascii_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "kdf",
			  &(clui_info->kdf_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "avs",
			  &(clui_info->avs_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "xbm",
			  &(clui_info->xbm_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "arf",
			  &(clui_info->arf_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "viff",
			  &(clui_info->viff_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pnm",
			  &(clui_info->pnm_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "xwd",
			  &(clui_info->xwd_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "raw",
			  &(clui_info->raw_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "xpm",
			  &(clui_info->xpm_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "rast",
			  &(clui_info->rast_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "format",
			  &(clui_info->format_string),
			  &(clui_info->format_flag))))
	{
	    kerror(NULL, "kformats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Conversion Between the Formats Supported in Khoros 2' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kformats",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kformats",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kformats/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input data object' i",
  "-O 1 0 0 1 0 1 51.75x1+0+13.5 ' ' 'Output' 'Resulting output data object' o",
  "-C 1",
  "-t 1 0 1 0 0 11x1+4+5 'ASCII' 'Output in ASCII format' ascii",
  "-t 1 0 1 1 0 22.75x1+27+5 'KDF  (Khoros 2.0 Data  Format)' 'Output as KDF (Khoros 2.0 Format)' kdf",
  "-t 1 0 1 0 0 11x1+4+6 'AVS' 'Output in Application Visualization System (AVS) format' avs",
  "-t 1 0 1 0 0 10.75x1+27+6 'XBM' 'Output in X Bitmap (XBM) format' xbm",
  "-t 1 0 1 0 0 11x1+4+7 'ARF' 'Output in ARF Format' arf",
  "-t 1 0 1 0 0 22.75x1+27+7 'VIFF (Khoros 1.0 Image Format)' 'Output as Viff (Khoros 1.0 Image Format)' viff",
  "-t 1 0 1 0 0 11x1+4+8 'PNM' 'Output in Portable Any Map (PNM) format' pnm",
  "-t 1 0 1 0 0 10.75x1+27+8 'XWD' 'Output in X Window Dump (XWD) format' xwd",
  "-t 1 0 1 0 0 10.75x1+4+9 'Raw' 'Output in Raw (headerless) format' raw",
  "-t 1 0 1 0 0 10.75x1+27+9 'XPM' 'Output in X Pixmap (XPM) format' xpm",
  "-t 1 0 1 0 0 10.75x1+4+10 'Sun Raster' 'Output in Sun Raster format' rast",
  "-s 1 0 1 0 0 47.75x1+4+12 ' ' 'User Specified Supported Format ' 'Supported format not available via the format flags' format",
  "-E",
  "-b +2+4 'Specify Output Data Format:' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kformats/uis/kformats.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	29,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


