 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:50:18 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:50:18 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgate.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgate_get_args
| 
|       Purpose: Gets command line args for kgate
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgate
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgate_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgate is out of sync with arguments specified in kgate's *.pane file; please rerun ghostwriter on kgate.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgate structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kgate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kgate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "igate",
			  &(clui_info->igate_file),
			  &(clui_info->igate_flag))))
	{
	    kerror(NULL, "kgate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "logic",
			  &(clui_info->logic_logic),
			  &(clui_info->logic_flag))))
	{
	    kerror(NULL, "kgate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "gval",
			  &(clui_info->gval_double),
			  &(clui_info->gval_flag))))
	{
	    kerror(NULL, "kgate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "subpos",
			  &(clui_info->subpos_logic),
			  &(clui_info->subpos_flag))))
	{
	    kerror(NULL, "kgate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kgate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Based on Gating Input, Output Values Will Be From Input 1 or Input 2' replace",
  "-P 1 0 52.25x10.0909+0+1 +0+0 ' ' kgate",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kgate",
  "-H 1  5x1+41+0 'Help' 'help page for kgate' $DATAMANIP/objects/kroutine/kgate/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input 1     ' 'First input data object' i1",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Input 2     ' 'Second input file object' i2",
  "-I 1 0 0 1 0 1 52x1+0+4 ' ' 'Gating Input' 'Gating input data object' igate",
  "-l 1 0 1 2 0 50x1+1+6 1 'If value in Gating Input equals Gate Value  ' 'Output = Input 1' 'Output = Input 2' 'Gating logic: if gate data = gval, (0) use i1, (1) use i2' logic",
  "-h 1 0 1 2 1 26x1+1+7 0 0 0 0 0 0 'Gate Value ' 'Value on which to gate' gval",
  "-l 1 0 1 2 0 26x1+1+8.5 1 'Use Subobject Position ' 'No' 'Yes' 'Use subobject position attribute' subpos",
  "-O 1 0 0 1 0 1 52x1+0+10 ' ' 'Output' 'Resulting output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kgate/uis/kgate.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


