 /*
  * Khoros: $Id: kgconst.h,v 1.14.2.2 1997/05/31 18:50:36 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kgconst
   >>>> 
   >>>>    Written By: Donna Koechner
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kgconst_h_
#define _kgconst_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include "kdatamanip/kdatamanip.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Output file containing constant value data (required outfile)
 */
char	*o_file;	/* Output file containing constant value data FILENAME */
int	 o_flag;	/* Output file containing constant value data FLAG */

/*
 *  Width size of constant value data (optional integer)
 */
int	 wsize_int; 	/* Width size of constant value data INT */
int	 wsize_flag;	/* Width size of constant value data FLAG */

/*
 *  Height size of constant value data (optional integer)
 */
int	 hsize_int; 	/* Height size of constant value data INT */
int	 hsize_flag;	/* Height size of constant value data FLAG */

/*
 *  Depth size of constant value data (optional integer)
 */
int	 dsize_int; 	/* Depth size of constant value data INT */
int	 dsize_flag;	/* Depth size of constant value data FLAG */

/*
 *  Time size of constant value data (optional integer)
 */
int	 tsize_int; 	/* Time size of constant value data INT */
int	 tsize_flag;	/* Time size of constant value data FLAG */

/*
 *  Element dimension size of constant value data (optional integer)
 */
int	 esize_int; 	/* Element dimension size of constant value data INT */
int	 esize_flag;	/* Element dimension size of constant value data FLAG */

/*
 *  Real constant level (optional double)
 */
double	 real_double;	/* Real constant level DOUBLE */
int	 real_flag;   	/* Real constant level FLAG */

/*
 *  Imaginary constant level (optional double)
 */
double	 imag_double;	/* Imaginary constant level DOUBLE */
int	 imag_flag;   	/* Imaginary constant level FLAG */

/*
 *  Data type of constant value data (Optional list)
 */
int	 type_list;	/* Data type of constant value data LIST INDEX */
char	 *type_label;	/* Data type of constant value data LIST LABEL */
int	 type_flag;	/* Data type of constant value data FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void kgconst_get_args PROTO((kaddr));
void kgconst_usage_additions PROTO((void));
void kgconst_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
