 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:50:39 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:50:39 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgconst.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgconst_get_args
| 
|       Purpose: Gets command line args for kgconst
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgconst
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgconst_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgconst is out of sync with arguments specified in kgconst's *.pane file; please rerun ghostwriter on kgconst.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgconst structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kgconst_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kgconst_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kgconst_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kgconst_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kgconst_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "kgconst_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "kgconst_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kgconst_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kgconst_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate Object Containing Constant Value Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Constant",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kgconst",
  "-H 1  5x1+41+0 'Help' 'help page for kgconst' $DATAMANIP/objects/kroutine/kgconst/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-i 1 0 1 1 1 39.75x1+1+2 2 2 1 1 1 'Width    ' 'Width size of constant value data' wsize",
  "-i 1 0 1 1 1 39.75x1+1+3 2 2 1 1 1 'Height   ' 'Height size of constant value data' hsize",
  "-i 1 0 1 0 1 39.75x1+1+4 2 2 1 1 1 'Depth    ' 'Depth size of constant value data' dsize",
  "-i 1 0 1 0 1 39.75x1+1+5 2 2 1 1 1 'Time     ' 'Time size of constant value data' tsize",
  "-i 1 0 1 0 1 39.75x1+1+6 2 2 1 1 1 'Elements ' 'Element dimension size of constant value data' esize",
  "-h 1 0 1 2 1 39.75x1+1+8 0 0 0 0 1 1 'Real Constant Level     ' 'Real constant level' real",
  "-h 1 0 1 2 1 39.75x1+1+9 0 0 0 0 1 1 'Imaginary Constant Level' 'Imaginary constant level' imag",
  "-x 1 0 1 2 0 42.375x1.13636+1+11 13 1 10 'Select Data Type:  ' 'Data type of constant value data' type 'bit' 'byte' 'unsigned byte' 'short' 'unsigned short' 'integer' 'unsigned integer' 'long' 'unsigned long' 'float' 'double' 'complex' 'double complex'",
  "-O 1 0 0 1 0 1 51.75x1+0+13 ' ' 'Output' 'Output file containing constant value data' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kgconst/uis/kgconst.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	21,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


