 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:51:00 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:51:00 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgeneric.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgeneric_get_args
| 
|       Purpose: Gets command line args for kgeneric
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgeneric
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgeneric_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgeneric is out of sync with arguments specified in kgeneric's *.pane file; please rerun ghostwriter on kgeneric.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgeneric structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "prefix",
			  &(clui_info->prefix_string),
			  &(clui_info->prefix_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "di1",
			  &(clui_info->di1_logic),
			  &(clui_info->di1_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "iname1",
			  &(clui_info->iname1_string),
			  &(clui_info->iname1_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "di2",
			  &(clui_info->di2_logic),
			  &(clui_info->di2_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "iname2",
			  &(clui_info->iname2_string),
			  &(clui_info->iname2_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "di3",
			  &(clui_info->di3_logic),
			  &(clui_info->di3_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "iname3",
			  &(clui_info->iname3_string),
			  &(clui_info->iname3_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do1",
			  &(clui_info->do1_logic),
			  &(clui_info->do1_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname1",
			  &(clui_info->oname1_string),
			  &(clui_info->oname1_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do2",
			  &(clui_info->do2_logic),
			  &(clui_info->do2_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname2",
			  &(clui_info->oname2_string),
			  &(clui_info->oname2_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do3",
			  &(clui_info->do3_logic),
			  &(clui_info->do3_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname3",
			  &(clui_info->oname3_string),
			  &(clui_info->oname3_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o3",
			  &(clui_info->o3_file),
			  &(clui_info->o3_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dn1",
			  &(clui_info->dn1_logic),
			  &(clui_info->dn1_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name1",
			  &(clui_info->name1_string),
			  &(clui_info->name1_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "val1",
			  &(clui_info->val1_string),
			  &(clui_info->val1_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dn2",
			  &(clui_info->dn2_logic),
			  &(clui_info->dn2_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name2",
			  &(clui_info->name2_string),
			  &(clui_info->name2_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "val2",
			  &(clui_info->val2_string),
			  &(clui_info->val2_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dn3",
			  &(clui_info->dn3_logic),
			  &(clui_info->dn3_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name3",
			  &(clui_info->name3_string),
			  &(clui_info->name3_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "val3",
			  &(clui_info->val3_string),
			  &(clui_info->val3_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dn4",
			  &(clui_info->dn4_logic),
			  &(clui_info->dn4_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name4",
			  &(clui_info->name4_string),
			  &(clui_info->name4_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "val4",
			  &(clui_info->val4_string),
			  &(clui_info->val4_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dn5",
			  &(clui_info->dn5_logic),
			  &(clui_info->dn5_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name5",
			  &(clui_info->name5_string),
			  &(clui_info->name5_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "val5",
			  &(clui_info->val5_string),
			  &(clui_info->val5_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dn6",
			  &(clui_info->dn6_logic),
			  &(clui_info->dn6_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name6",
			  &(clui_info->name6_string),
			  &(clui_info->name6_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "val6",
			  &(clui_info->val6_string),
			  &(clui_info->val6_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dn7",
			  &(clui_info->dn7_logic),
			  &(clui_info->dn7_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name7",
			  &(clui_info->name7_string),
			  &(clui_info->name7_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "val7",
			  &(clui_info->val7_string),
			  &(clui_info->val7_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dn8",
			  &(clui_info->dn8_logic),
			  &(clui_info->dn8_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name8",
			  &(clui_info->name8_string),
			  &(clui_info->name8_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "val8",
			  &(clui_info->val8_string),
			  &(clui_info->val8_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "trailer",
			  &(clui_info->trailer_string),
			  &(clui_info->trailer_flag))))
	{
	    kerror(NULL, "kgeneric_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "# DoNotAutoUpdate",
  "-F 4.3 1 0 10x10+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 10x10+0+0 +31+0 'Generic Routine Interface (glue)' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' kgeneric",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+72+0 'Run' 'Execute kgeneric' $DATAMANIPBIN/kgeneric",
  "-H 1  5x1+78+0 'Help' 'documentation for kgeneric' $DATAMANIP/objects/kroutine/kgeneric/help help",
  "-Q 1 0 5x1+84+0 'Close'",
  "-s 1 0 1 1 0 80x1+2+2 ' ' 'Prefix' 'prefix string' prefix",
  "-I 1 0 1 1 0 0 50x1+2+4 ' ' 'Input Image ' 'input image' i",
  "-O 1 0 1 1 0 0 50x1+2+5 ' ' 'Output Image' 'output image or file' o",
  "-l 1 0 0 1 0 4x1+2+7 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for input name #1' di1",
  "-s 1 0 1 0 0 35x1+6+7 ' ' 'Input name #1 ' 'name of input argument #1' iname1",
  "-I 1 0 1 0 0 0 45x1+44+7 ' ' 'Input Filename #1 ' 'input filename #1' i1",
  "-l 1 0 0 1 0 4x1+2+8 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for input name #2' di2",
  "-s 1 0 1 0 0 35x1+6+8 ' ' 'Input name #2 ' 'name of input argument #2' iname2",
  "-I 1 0 1 0 0 0 45x1+44+8 ' ' 'Input Filename #2 ' 'input filename #2' i2",
  "-l 1 0 0 1 0 4x1+2+9 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for input name #3' di3",
  "-s 1 0 1 0 0 35x1+6+9 ' ' 'Input name #3 ' 'name of input argument #3' iname3",
  "-I 1 0 1 0 0 0 45x1+44+9 ' ' 'Input Filename #3 ' 'input filename #3' i3",
  "-l 1 0 0 1 0 4x1+2+10 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for output name #1' do1",
  "-s 1 0 1 0 0 35x1+6+10 ' ' 'Output name #1' 'name of output argument #1' oname1",
  "-O 1 0 1 0 0 0 45x1+44+10 ' ' 'Output Filename #1' 'output filename #1' o1",
  "-l 1 0 0 1 0 4x1+2+11 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for output name #2' do2",
  "-s 1 0 1 0 0 35x1+6+11 ' ' 'Output name #2' 'name of output argument #2' oname2",
  "-O 1 0 1 0 0 0 45x1+44+11 ' ' 'Output Filename #2' 'output filename #2' o2",
  "-l 1 0 0 1 0 4x1+2+12 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for output name #3' do3",
  "-s 1 0 1 0 0 35x1+6+12 ' ' 'Output name #3' 'name of output argument #3' oname3",
  "-O 1 0 1 0 0 0 45x1+44+12 ' ' 'Output Filename #3' 'output filename #3' o3",
  "-l 1 0 0 1 0 4x1+2+14 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for arg name #1' dn1",
  "-s 1 0 1 0 0 35x1+6+14 ' ' 'Arg name #1' 'Name of argument #1' name1",
  "-s 1 0 1 0 0 45x1+44+14 ' ' 'Argument #1 value' 'argument #1 value' val1",
  "-l 1 0 0 1 0 4x1+2+15 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for arg name #2' dn2",
  "-s 1 0 1 0 0 35x1+6+15 ' ' 'Arg name #2' 'Name of argument #2' name2",
  "-s 1 0 1 0 0 45x1+44+15 ' ' 'Argument #2 value' 'argument #2 value' val2",
  "-l 1 0 0 1 0 4x1+2+16 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for arg name #3' dn3",
  "-s 1 0 1 0 0 35x1+6+16 ' ' 'Arg name #3' 'Name of argument #3' name3",
  "-s 1 0 1 0 0 45x1+44+16 ' ' 'Argument #3 value' 'argument #3 value' val3",
  "-l 1 0 0 1 0 4x1+2+17 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for arg name #4' dn4",
  "-s 1 0 1 0 0 35x1+6+17 ' ' 'Arg name #4' 'Name of argument #4' name4",
  "-s 1 0 1 0 0 45x1+44+17 ' ' 'Argument #4 value' 'argument #4 value' val4",
  "-l 1 0 0 1 0 4x1+2+18 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for arg name #5' dn5",
  "-s 1 0 1 0 0 35x1+6+18 ' ' 'Arg name #5' 'Name of argument #5' name5",
  "-s 1 0 1 0 0 45x1+44+18 ' ' 'Argument #5 value' 'argument #5 value' val5",
  "-l 1 0 0 1 0 4x1+2+19 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for arg name #6' dn6",
  "-s 1 0 1 0 0 35x1+6+19 ' ' 'Arg name #6' 'Name of argument #6' name6",
  "-s 1 0 1 0 0 45x1+44+19 ' ' 'Argument #6 value' 'argument #6 value' val6",
  "-l 1 0 0 1 0 4x1+2+20 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for arg name #7' dn7",
  "-s 1 0 1 0 0 35x1+6+20 ' ' 'Arg name #7' 'Name of argument #7' name7",
  "-s 1 0 1 0 0 45x1+44+20 ' ' 'Argument #7 value' 'argument #7 value' val7",
  "-l 1 0 0 1 0 4x1+2+21 0 ' ' '  ' '-' 'selects minus sign (TRUE) or blank (FALSE) for arg name #8' dn8",
  "-s 1 0 1 0 0 35x1+6+21 ' ' 'Arg name #8' 'Name of argument #8' name8",
  "-s 1 0 1 0 0 45x1+44+21 ' ' 'Argument #8 value' 'argument #8 value' val8",
  "-s 1 0 1 0 0 80x1+2+23 ' ' 'Trailer' 'trailer string' trailer",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kgeneric/uis/kgeneric.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	59,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


