 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:51:18 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:51:18 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgenloc.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgenloc_get_args
| 
|       Purpose: Gets command line args for kgenloc
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenloc
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgenloc_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgenloc is out of sync with arguments specified in kgenloc's *.pane file; please rerun ghostwriter on kgenloc.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the kgenloc structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "xbegin",
			  &(clui_info->xbegin_double),
			  &(clui_info->xbegin_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "xend",
			  &(clui_info->xend_double),
			  &(clui_info->xend_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ybegin",
			  &(clui_info->ybegin_double),
			  &(clui_info->ybegin_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "yend",
			  &(clui_info->yend_double),
			  &(clui_info->yend_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "zbegin",
			  &(clui_info->zbegin_double),
			  &(clui_info->zbegin_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "zend",
			  &(clui_info->zend_double),
			  &(clui_info->zend_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "grid", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->grid_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->grid_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kgenloc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate Location Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kgenloc",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $DATAMANIP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kgenloc",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kgenloc/help help",
  "-Q 1 0 5.25x1+47+0 'Close'",
  "-I 1 0 1 2 0 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "",
  "-h 1 0 1 2 0 16x1+4+4.5 0 0 0 1 0 0 'X ' 'Explicit Location Begin for X dimension' xbegin",
  "-h 1 0 1 2 0 16x1+26+4.5 0 0 1 1 0 0 'X ' 'Explicit Location End for X dimension' xend",
  "-h 1 0 1 2 0 16x1+4+5.5 0 0 0 1 0 0 'Y ' 'Explicit Location Begin for Y dimension' ybegin",
  "-h 1 0 1 2 0 16x1+26+5.5 0 0 1 1 0 0 'Y ' 'Explicit Location End for Y dimension' yend",
  "-h 1 0 1 2 0 16x1+4+6.5 0 0 0 1 0 0 'Z ' 'Explicit Location Begin for Z dimension' zbegin",
  "-h 1 0 1 2 0 16x1+26+6.5 0 0 1 1 0 0 'Z ' 'Explicit Location End for Z dimension' zend",
  "-T 1 0 1 2 0 42.5x1+2+8.5 +0+0 1 'Grid Type :' 'Grid Type to use when creating Location Data' grid",
  "-t 1 0 1 1 0 10x1+10+0 'Uniform' 'create uniform location data' dummy",
  "-t 1 0 1 0 0 12x1+20+0 'Rectilinear' 'create rectilinear location data' dummy",
  "-t 1 0 1 0 0 10.5x1+32+0 'Curvilinear' 'create curvilinear location data' dummy",
  "-E",
  "",
  "-i 1 0 1 1 0 22x1+24+12.5 2 2 512 1 1 ' Width     ' 'Width of location data' wsize",
  "-i 1 0 1 1 0 22x1+24+13.5 2 2 512 1 1 ' Height    ' 'Height of location data' hsize",
  "-i 1 0 1 1 0 22x1+24+14.5 2 2 1 1 1 ' Depth     ' 'Depth of location data' dsize",
  "-x 1 0 1 2 0 42x1.09091+2+17 13 1 10 'Select Data Type:           ' 'Data type of location data' type 'bit' 'byte' 'unsigned byte' 'short' 'unsigned short' 'integer' 'unsigned integer' 'long' 'unsigned long' 'float' 'double' 'complex' 'double complex'",
  "-O 1 0 0 1 0 1 52x1+0+18.5 ' ' 'Output' 'Resulting output data object' o",
  "-b +3+3.5 'LOCATION BEGIN' b1",
  "-b +25+3.5 'LOCATION END' b2",
  "-b +2+11.5 'Size Specification :' blank3",
  "-b +4+13.5 'overwritten from Input' blank4",
  "-b +4+12.5 'Specified sizes will be' blank5",
  "-b +4+14.5 'location or value segment' blank6",
  "-b +6+10 '. . . . . . . . . . . . . . . . . . . . . . . .' blank7",
  "-b +4+15.5 'sizes when available' blank8",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kgenloc/uis/kgenloc.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	39,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


