 /*
  * Khoros: $Id: kgexprn.h,v 1.4.2.2 1997/05/31 18:51:36 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kgexprn
   >>>> 
   >>>>    Written By: Mark Young
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kgexprn_h_
#define _kgexprn_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  function expression (required string)
 */
char	*expr_string;	/* function expression STRING */
int	 expr_flag;   	/* function expression FLAG */

/*
 *  resulting output image (required outfile)
 */
char	*o_file;	/* resulting output image FILENAME */
int	 o_flag;	/* resulting output image FLAG */

/*
 *  Beginning width value (optional double)
 */
double	 wbegin_double;	/* Beginning width value DOUBLE */
int	 wbegin_flag;   	/* Beginning width value FLAG */

/*
 *  Ending width value (optional double)
 */
double	 wend_double;	/* Ending width value DOUBLE */
int	 wend_flag;   	/* Ending width value FLAG */

/*
 *  Width size of value data (optional integer)
 */
int	 wsize_int; 	/* Width size of value data INT */
int	 wsize_flag;	/* Width size of value data FLAG */

/*
 *  Beginning height value (optional double)
 */
double	 hbegin_double;	/* Beginning height value DOUBLE */
int	 hbegin_flag;   	/* Beginning height value FLAG */

/*
 *  Ending height value (optional double)
 */
double	 hend_double;	/* Ending height value DOUBLE */
int	 hend_flag;   	/* Ending height value FLAG */

/*
 *  Height size of value data (optional integer)
 */
int	 hsize_int; 	/* Height size of value data INT */
int	 hsize_flag;	/* Height size of value data FLAG */

/*
 *  Beginning depth value (optional double)
 */
double	 dbegin_double;	/* Beginning depth value DOUBLE */
int	 dbegin_flag;   	/* Beginning depth value FLAG */

/*
 *  Ending depth value (optional double)
 */
double	 dend_double;	/* Ending depth value DOUBLE */
int	 dend_flag;   	/* Ending depth value FLAG */

/*
 *  Depth size of value data (optional integer)
 */
int	 dsize_int; 	/* Depth size of value data INT */
int	 dsize_flag;	/* Depth size of value data FLAG */

/*
 *  Beginning time value (optional double)
 */
double	 tbegin_double;	/* Beginning time value DOUBLE */
int	 tbegin_flag;   	/* Beginning time value FLAG */

/*
 *  Ending time value (optional double)
 */
double	 tend_double;	/* Ending time value DOUBLE */
int	 tend_flag;   	/* Ending time value FLAG */

/*
 *  Time size of value data (optional integer)
 */
int	 tsize_int; 	/* Time size of value data INT */
int	 tsize_flag;	/* Time size of value data FLAG */

/*
 *  Beginning elements value (optional double)
 */
double	 ebegin_double;	/* Beginning elements value DOUBLE */
int	 ebegin_flag;   	/* Beginning elements value FLAG */

/*
 *  Ending elements value (optional double)
 */
double	 eend_double;	/* Ending elements value DOUBLE */
int	 eend_flag;   	/* Ending elements value FLAG */

/*
 *  Elements size of value data (optional integer)
 */
int	 esize_int; 	/* Elements size of value data INT */
int	 esize_flag;	/* Elements size of value data FLAG */

/*
 *  Data type of sinusoidal value data (Optional list)
 */
int	 type_list;	/* Data type of sinusoidal value data LIST INDEX */
char	 *type_label;	/* Data type of sinusoidal value data LIST LABEL */
int	 type_flag;	/* Data type of sinusoidal value data FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void kgexprn_get_args PROTO((kaddr));
void kgexprn_usage_additions PROTO((void));
void kgexprn_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
