 /*
  * Khoros: $Id: usage.c,v 1.4.2.2 1997/05/31 18:51:38 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.4.2.2 1997/05/31 18:51:38 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgexprn.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgexprn_get_args
| 
|       Purpose: Gets command line args for kgexprn
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgexprn
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgexprn_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgexprn is out of sync with arguments specified in kgexprn's *.pane file; please rerun ghostwriter on kgexprn.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgexprn structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "expr",
			  &(clui_info->expr_string),
			  &(clui_info->expr_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wbegin",
			  &(clui_info->wbegin_double),
			  &(clui_info->wbegin_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wend",
			  &(clui_info->wend_double),
			  &(clui_info->wend_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hbegin",
			  &(clui_info->hbegin_double),
			  &(clui_info->hbegin_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hend",
			  &(clui_info->hend_double),
			  &(clui_info->hend_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dbegin",
			  &(clui_info->dbegin_double),
			  &(clui_info->dbegin_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dend",
			  &(clui_info->dend_double),
			  &(clui_info->dend_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tbegin",
			  &(clui_info->tbegin_double),
			  &(clui_info->tbegin_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tend",
			  &(clui_info->tend_double),
			  &(clui_info->tend_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ebegin",
			  &(clui_info->ebegin_double),
			  &(clui_info->ebegin_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "eend",
			  &(clui_info->eend_double),
			  &(clui_info->eend_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kgexprn_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate Object Value Data From Expression' subform",
  "-P 1 0 52x14.5+0+1 +0+0 ' ' kgexpr",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kgexprn",
  "-H 1  5x1+41+0 'Help' 'documentation for kgexprn' $DATAMANIP/objects/kroutine/kgexprn/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 0 1 0 50x4+1+1.5 'w + h' 'f(w,h,d,t,e)  =' 'function expression' expr",
  "-h 1 0 1 2 0 13x1+11+6 0 0 0 0 0 0 'Begin' 'Beginning width value' wbegin",
  "-h 1 0 1 2 0 13x1+25+6 0 0 511 0 0 0 'End' 'Ending width value' wend",
  "-i 1 0 1 2 0 12x1+39+6 2 2 512 0 0 'Size' 'Width size of value data' wsize",
  "-h 1 0 1 2 0 13x1+11+7 0 0 0 0 0 0 'Begin' 'Beginning height value' hbegin",
  "-h 1 0 1 2 0 13x1+25+7 0 0 511 0 0 0 'End' 'Ending height value' hend",
  "-i 1 0 1 2 0 12x1+39+7 2 2 512 0 0 'Size' 'Height size of value data' hsize",
  "-h 1 0 1 2 0 13x1+11+8 0 0 0 0 0 0 'Begin' 'Beginning depth value' dbegin",
  "-h 1 0 1 2 0 13x1+25+8 0 0 0 0 0 0 'End' 'Ending depth value' dend",
  "-i 1 0 1 2 0 12x1+39+8 2 2 1 0 0 'Size' 'Depth size of value data' dsize",
  "-h 1 0 1 2 0 13x1+11+9 0 0 0 0 0 0 'Begin' 'Beginning time value' tbegin",
  "-h 1 0 1 2 0 13x1+25+9 0 0 0 0 0 0 'End' 'Ending time value' tend",
  "-i 1 0 1 2 0 12x1+39+9 2 2 1 0 0 'Size' 'Time size of value data' tsize",
  "-h 1 0 1 2 0 13x1+11+10 0 0 0 0 0 0 'Begin' 'Beginning elements value' ebegin",
  "-h 1 0 1 2 0 13x1+25+10 0 0 0 0 0 0 'End' 'Ending elements value' eend",
  "-i 1 0 1 2 0 12x1+39+10 2 2 1 0 0 'Size' 'Elements size of value data' esize",
  "-x 1 0 1 2 0 44.25x1.09091+1+11.5 13 1 10 'Select Data Type:  ' 'Data type of sinusoidal value data' type 'bit' 'byte' 'unsigned byte' 'short' 'unsigned short' 'integer' 'unsigned integer' 'long' 'unsigned long' 'float' 'double' 'complex' 'double complex'",
  "-O 1 0 0 1 0 0 50x1+1+13 ' ' 'Output Image' 'resulting output image' o",
  "-b +1+6 'Width    (w)' blank1",
  "-b +1+7 'Height   (h)' blank2",
  "-b +1+8 'Depth    (d)' blank3",
  "-b +1+9 'Time     (t)' blank4",
  "-b +1+10 'Elements (e)' blank5",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kgexprn/uis/kgexprn.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	35,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


