 /*
  * Khoros: $Id: kgnoise.h,v 1.14.2.2 1997/05/31 18:51:54 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kgnoise
   >>>> 
   >>>>    Written By: Ashish Malhotra, Scott Wilson
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kgnoise_h_
#define _kgnoise_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include "kdatamanip/kdatamanip.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Output file containing noise data (required outfile)
 */
char	*o_file;	/* Output file containing noise data FILENAME */
int	 o_flag;	/* Output file containing noise data FLAG */

/*----- required ME group ----*/
	/*---- nested optional MI group ----*/
/*
 *  Generate Gaussian noise (optional flag)
 */
int	 gauss_flag;  	/* Generate Gaussian noise FLAG */

/*
 *  Mean for Gaussian noise (optional double)
 */
double	 gmean_double;	/* Mean for Gaussian noise DOUBLE */
int	 gmean_flag;   	/* Mean for Gaussian noise FLAG */

/*
 *  Variance for Gaussian noise (optional double)
 */
double	 gvar_double;	/* Variance for Gaussian noise DOUBLE */
int	 gvar_flag;   	/* Variance for Gaussian noise FLAG */

	/*-- nested optional MI group end --*/

	/*---- nested optional MI group ----*/
/*
 *  Generate Rayleigh Noise (optional flag)
 */
int	 ray_flag;  	/* Generate Rayleigh Noise FLAG */

/*
 *  Variance for Rayleigh noise (optional double)
 */
double	 rvar_double;	/* Variance for Rayleigh noise DOUBLE */
int	 rvar_flag;   	/* Variance for Rayleigh noise FLAG */

	/*-- nested optional MI group end --*/

	/*---- nested optional MI group ----*/
/*
 *  Generate uniformly distributed noise (optional flag)
 */
int	 unif_flag;  	/* Generate uniformly distributed noise FLAG */

/*
 *  Maximum value for uniform distribution (optional double)
 */
double	 umax_double;	/* Maximum value for uniform distribution DOUBLE */
int	 umax_flag;   	/* Maximum value for uniform distribution FLAG */

/*
 *  Minimum value for uniform noise (optional double)
 */
double	 umin_double;	/* Minimum value for uniform noise DOUBLE */
int	 umin_flag;   	/* Minimum value for uniform noise FLAG */

	/*-- nested optional MI group end --*/

	/*---- nested optional MI group ----*/
/*
 *  Generate Poisson Noise (optional flag)
 */
int	 poiss_flag;  	/* Generate Poisson Noise FLAG */

/*
 *  Amount of time (optional double)
 */
double	 ptime_double;	/* Amount of time DOUBLE */
int	 ptime_flag;   	/* Amount of time FLAG */

/*
 *  Variance for Poisson distribution (optional double)
 */
double	 pvar_double;	/* Variance for Poisson distribution DOUBLE */
int	 pvar_flag;   	/* Variance for Poisson distribution FLAG */

	/*-- nested optional MI group end --*/

	/*---- nested optional MI group ----*/
/*
 *  Generate exponential noise (optional flag)
 */
int	 exp_flag;  	/* Generate exponential noise FLAG */

/*
 *  Variance for exponential distribution (optional double)
 */
double	 evar_double;	/* Variance for exponential distribution DOUBLE */
int	 evar_flag;   	/* Variance for exponential distribution FLAG */

	/*-- nested optional MI group end --*/

/*-- required ME group end ---*/

/*
 *  Width size of noise value data (optional integer)
 */
int	 wsize_int; 	/* Width size of noise value data INT */
int	 wsize_flag;	/* Width size of noise value data FLAG */

/*
 *  Height size of noise value data (optional integer)
 */
int	 hsize_int; 	/* Height size of noise value data INT */
int	 hsize_flag;	/* Height size of noise value data FLAG */

/*
 *  Depth size of noise value data (optional integer)
 */
int	 dsize_int; 	/* Depth size of noise value data INT */
int	 dsize_flag;	/* Depth size of noise value data FLAG */

/*
 *  Time size of noise value data (optional integer)
 */
int	 tsize_int; 	/* Time size of noise value data INT */
int	 tsize_flag;	/* Time size of noise value data FLAG */

/*
 *  Element dimension size of noise data (optional integer)
 */
int	 esize_int; 	/* Element dimension size of noise data INT */
int	 esize_flag;	/* Element dimension size of noise data FLAG */

/*
 *  Data type of noise value data (Optional list)
 */
int	 type_list;	/* Data type of noise value data LIST INDEX */
char	 *type_label;	/* Data type of noise value data LIST LABEL */
int	 type_flag;	/* Data type of noise value data FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void kgnoise_get_args PROTO((kaddr));
void kgnoise_usage_additions PROTO((void));
void kgnoise_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
