 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:51:56 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:51:56 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgnoise.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgnoise_get_args
| 
|       Purpose: Gets command line args for kgnoise
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgnoise
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgnoise_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgnoise is out of sync with arguments specified in kgnoise's *.pane file; please rerun ghostwriter on kgnoise.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgnoise structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "gauss",
			  &(clui_info->gauss_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "gmean",
			  &(clui_info->gmean_double),
			  &(clui_info->gmean_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "gvar",
			  &(clui_info->gvar_double),
			  &(clui_info->gvar_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ray",
			  &(clui_info->ray_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "rvar",
			  &(clui_info->rvar_double),
			  &(clui_info->rvar_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "unif",
			  &(clui_info->unif_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "umax",
			  &(clui_info->umax_double),
			  &(clui_info->umax_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "umin",
			  &(clui_info->umin_double),
			  &(clui_info->umin_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "poiss",
			  &(clui_info->poiss_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ptime",
			  &(clui_info->ptime_double),
			  &(clui_info->ptime_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "pvar",
			  &(clui_info->pvar_double),
			  &(clui_info->pvar_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "exp",
			  &(clui_info->exp_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "evar",
			  &(clui_info->evar_double),
			  &(clui_info->evar_flag))))
	{
	    kerror(NULL, "kgnoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate Noise Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Noise",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kgnoise",
  "-H 1  5x1+41+0 'Help' 'help page for kgnoise' $DATAMANIP/objects/kroutine/kgnoise/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-i 1 0 1 1 1 33x1+2+1.5 2 2 512 1 1 'Width    ' 'Width size of noise value data' wsize",
  "-i 1 0 1 1 1 33x1+2+2.5 2 2 512 1 1 'Height   ' 'Height size of noise value data' hsize",
  "-i 1 0 1 0 1 33x1+2+3.5 2 2 1 1 1 'Depth    ' 'Depth size of noise value data' dsize",
  "-i 1 0 1 0 1 33x1+2+4.5 2 2 1 1 1 'Time     ' 'Time size of noise value data' tsize",
  "-i 1 0 1 0 1 33x1+2+5.5 2 2 1 1 1 'Elements ' 'Element dimension size of noise data' esize",
  "-x 1 0 1 2 0 38.75x1+1+19.5 13 1 10 'Select Data Type:  ' 'Data type of noise value data' type 'bit' 'byte' 'unsigned byte' 'short' 'unsigned short' 'integer' 'unsigned integer' 'long' 'unsigned long' 'float' 'double' 'complex' 'double complex'",
  "-O 1 0 0 1 0 1 52x1+0+21.5 ' ' 'Output' 'Output file containing noise data' o",
  "-C 1",
  "-B 0",
  "-t 1 0 1 1 0 16.125x1+2+8.5 'Gaussian Noise' 'Generate Gaussian noise' gauss",
  "-h 1 0 1 1 1 23x1+2+9.5 0 0 0 10 0 0 'Mean     ' 'Mean for Gaussian noise' gmean",
  "-h 1 0 1 1 1 23x1+2+10.5 2 2 1 10 0 0 'Variance ' 'Variance for Gaussian noise' gvar",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 15.625x1+2+12.5 'Rayleigh Noise' 'Generate Rayleigh Noise' ray",
  "-h 1 0 1 0 1 23x1+2+13.5 2 2 1 10 0 0 'Variance ' 'Variance for Rayleigh noise' rvar",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 14.625x1+29+8.5 'Uniform Noise' 'Generate uniformly distributed noise' unif",
  "-h 1 0 1 0 1 23x1+29+9.5 0 0 1 10 0 0 'Maximum ' 'Maximum value for uniform distribution' umax",
  "-h 1 0 1 0 1 23x1+29+10.5 0 0 0 10 0 0 'Minimum ' 'Minimum value for uniform noise' umin",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 15.625x1+2+15.5 'Poisson Noise' 'Generate Poisson Noise' poiss",
  "-h 1 0 1 0 1 29x1+2+16.5 2 2 1 1 0 0 'Amount of Time ' 'Amount of time' ptime",
  "-h 1 0 1 0 1 29x1+2+17.5 2 2 1 1 0 0 'Variance       ' 'Variance for Poisson distribution' pvar",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 18.625x1+29+12.5 'Exponential Noise' 'Generate exponential noise' exp",
  "-h 1 0 1 0 1 23x1+29+13.5 2 2 1 10 0 0 'Variance ' 'Variance for exponential distribution' evar",
  "-E",
  "-E",
  "-b +2+7 'Select Noise Type:' text1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kgnoise/uis/kgnoise.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	45,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


