 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:52:15 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:52:15 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgsin.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgsin_get_args
| 
|       Purpose: Gets command line args for kgsin
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgsin
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgsin_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgsin is out of sync with arguments specified in kgsin's *.pane file; please rerun ghostwriter on kgsin.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgsin structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wnum",
			  &(clui_info->wnum_double),
			  &(clui_info->wnum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wp",
			  &(clui_info->wp_double),
			  &(clui_info->wp_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hnum",
			  &(clui_info->hnum_double),
			  &(clui_info->hnum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hp",
			  &(clui_info->hp_double),
			  &(clui_info->hp_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dnum",
			  &(clui_info->dnum_double),
			  &(clui_info->dnum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dp",
			  &(clui_info->dp_double),
			  &(clui_info->dp_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tnum",
			  &(clui_info->tnum_double),
			  &(clui_info->tnum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tp",
			  &(clui_info->tp_double),
			  &(clui_info->tp_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "enum",
			  &(clui_info->enum_double),
			  &(clui_info->enum_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ep",
			  &(clui_info->ep_double),
			  &(clui_info->ep_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sin1",
			  &(clui_info->sin1_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ampl",
			  &(clui_info->ampl_double),
			  &(clui_info->ampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sin5",
			  &(clui_info->sin5_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wampl",
			  &(clui_info->wampl_double),
			  &(clui_info->wampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hampl",
			  &(clui_info->hampl_double),
			  &(clui_info->hampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dampl",
			  &(clui_info->dampl_double),
			  &(clui_info->dampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tampl",
			  &(clui_info->tampl_double),
			  &(clui_info->tampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "eampl",
			  &(clui_info->eampl_double),
			  &(clui_info->eampl_flag))))
	{
	    kerror(NULL, "kgsin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate Object Containing Sinusoidal Value Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Constant",
  "-D 1 0 9x1.13636+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kgsin",
  "-H 1  5x1+41+0 'Help' 'help page for kgsin' $DATAMANIP/objects/kroutine/kgsin/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-i 1 0 1 2 1 40x1+1+2 2 2 512 1 1 'Width    ' 'Width size of sinusoidal value data' wsize",
  "-i 1 0 1 2 1 40x1+1+3 2 2 512 1 1 'Height   ' 'Height size of sinusoidal value data' hsize",
  "-i 1 0 1 2 1 40x1+1+4 2 2 1 1 1 'Depth    ' 'Depth size of sinusoidal value data' dsize",
  "-i 1 0 1 2 1 40x1+1+5 2 2 1 1 1 'Time     ' 'Time size of sinusoidal value data' tsize",
  "-i 1 0 1 2 1 39.75x1+1+6 2 2 1 1 1 'Elements ' 'Elements dimension size of sinusoidal value data' esize",
  "-h 1 0 1 2 0 23.25x1+1+16 1 1 1 1 0 0 'Num. along Width    ' 'Number of sine waves along width dimension' wnum",
  "-h 1 0 1 2 0 21.25x1+28+16 -100 100 0 1 0 0 'Width Phase Off.   ' 'Phase offset along width dimension' wp",
  "-h 1 0 1 2 0 23.25x1+1+17 1 1 1 1 0 0 'Num. along Height   ' 'Number of sine waves along height dimension' hnum",
  "-h 1 0 1 2 0 21.25x1+28+17 -100 100 0 1 0 0 'Height Phase Off.  ' 'Phase offset along the height dimension' hp",
  "-h 1 0 1 2 0 23.25x1+1+18 1 1 1 1 0 0 'Num. along Depth    ' 'Number of sine waves along depth dimension' dnum",
  "-h 1 0 1 2 0 21.25x1+28+18 -100 100 0 1 0 0 'Depth Phase Off.   ' 'Phase offset along depth dimension' dp",
  "-h 1 0 1 2 0 23.25x1+1+19 1 1 1 1 0 0 'Num. along Time     ' 'Number of sine waves along time dimension' tnum",
  "-h 1 0 1 2 0 21.25x1+28+19 -100 100 0 1 0 0 'Time Phase Off.    ' 'Phase Offset for time dimension' tp",
  "-h 1 0 1 2 0 23.25x1+1+20 1 1 1 1 0 0 'Num. along Elements ' 'Number of sine waves along Elements Dimension' enum",
  "-h 1 0 1 2 0 21.25x1+28+20 -100 100 0 1 0 0 'Elements Phase Off.' 'Phase Offset in the elements dimension' ep",
  "-x 1 0 1 2 0 45.25x1.13636+1+22 13 1 10 'Select Data Type:  ' 'Data type of sinusoidal value data' type 'bit' 'byte' 'unsigned byte' 'short' 'unsigned short' 'integer' 'unsigned integer' 'long' 'unsigned long' 'float' 'double' 'complex' 'double complex'",
  "-O 1 0 0 1 0 1 52x1+0+24 ' ' 'Output' 'Output file containing sinusoidal value data' o",
  "-C 1",
  "-B 0",
  "-t 1 0 1 1 0 12.875x1+1+8 'sin(w+h+d+t+e)' 'Apply sine function to the sum of coordinates at a point' sin1",
  "-h 1 0 1 1 0 18x1+1+9 0 0 1 1 0 0 'Amplitude ' 'Maximum level of output' ampl",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 27.875x1+24+8 'sin(w)+sin(h)+sin(d)+sin(t)+sin(e)' 'Apply sine to each coordinate and sum up the result' sin5",
  "-h 1 0 1 0 0 24x1+24+9 0 0 1 1 0 0 'Width Amplitude   ' 'Amplitude along the width direction' wampl",
  "-h 1 0 1 0 0 24x1+24+10 0 0 1 1 0 0 'Height Amplitude  ' 'Amplitude along the height direction' hampl",
  "-h 1 0 1 0 0 24x1+24+11 0 0 1 1 0 0 'Depth Amplitude   ' 'Amplitude along the depth direction' dampl",
  "-h 1 0 1 0 0 24x1+24+12 0 0 1 1 0 0 'Time Amplitude    ' 'Amplitude along the time direction' tampl",
  "-h 1 0 1 0 0 24x1+24+13 0 0 1 1 0 0 'Element Amplitude ' 'Amplitude along the element direction' eampl",
  "-E",
  "-E",
  "-b +1+14.75 'Number of sine waves' b1",
  "-b +28+14.75 'Phase Offset (degrees)' b2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kgsin/uis/kgsin.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	45,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


