 /*
  * Khoros: $Id: khisto.h,v 1.15.2.2 1997/05/31 18:52:33 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for khisto
   >>>> 
   >>>>    Written By: Scott Wilson
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _khisto_h_
#define _khisto_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include <kdatamanip/kdatamanip.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input data object (required infile)
 */
char	*i_file;	/* Input data object FILENAME */
int	 i_flag;	/* Input data object FLAG */

/*
 *  histogram output data object (required outfile)
 */
char	*o1_file;	/* histogram output data object FILENAME */
int	 o1_flag;	/* histogram output data object FLAG */

/*
 *  Gating input data object (optional infile)
 */
char	*igate_file;	/* Gating input data object FILENAME */
int	 igate_flag;	/* Gating input data object FLAG */

/*
 *  number of histogram bins (optional integer)
 */
int	 bins_int; 	/* number of histogram bins INT */
int	 bins_flag;	/* number of histogram bins FLAG */

/*
 *  width of histogram bin (optional double)
 */
double	 binwidth_double;	/* width of histogram bin DOUBLE */
int	 binwidth_flag;   	/* width of histogram bin FLAG */

/*
 *  Min side of min histogram bin (optional double)
 */
double	 min_double;	/* Min side of min histogram bin DOUBLE */
int	 min_flag;   	/* Min side of min histogram bin FLAG */

/*
 *  append a pair of bins for out-of-bounds data (optional flag)
 */
int	 oob_flag;  	/* append a pair of bins for out-of-bounds data FLAG */

/*
 *  if map exists, pull the value data through it (optional flag)
 */
int	 map_flag;  	/* if map exists, pull the value data through it FLAG */

/*
 *  normalize integrated histogram to [0..1] (optional flag)
 */
int	 normalize_flag;  	/* normalize integrated histogram to [0..1] FLAG */

/*
 *  integrated histogram output object (optional outfile)
 */
char	*o2_file;	/* integrated histogram output object FILENAME */
int	 o2_flag;	/* integrated histogram output object FLAG */

/*----- optional ME group ----*/
/*
 *  histogram whole data set at one time (optional flag)
 */
int	 whole_flag;  	/* histogram whole data set at one time FLAG */

	/*---- nested optional   group ----*/
/*
 *  include width in histogram unit (optional flag)
 */
int	 w_flag;  	/* include width in histogram unit FLAG */

/*
 *  include height in histogram unit (optional flag)
 */
int	 h_flag;  	/* include height in histogram unit FLAG */

/*
 *  include depth in histogram unit (optional flag)
 */
int	 d_flag;  	/* include depth in histogram unit FLAG */

/*
 *  include time in histogram unit (optional flag)
 */
int	 t_flag;  	/* include time in histogram unit FLAG */

/*
 *  include elements in histogram unit (optional flag)
 */
int	 e_flag;  	/* include elements in histogram unit FLAG */

	/*-- nested optional   group end --*/

/*-- optional ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void khisto_get_args PROTO((kaddr));
void khisto_usage_additions PROTO((void));
void khisto_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
