 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:52:36 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:52:36 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "khisto.h"
/*-----------------------------------------------------------
| 
|  Routine Name: khisto_get_args
| 
|       Purpose: Gets command line args for khisto
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname khisto
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void khisto_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for khisto is out of sync with arguments specified in khisto's *.pane file; please rerun ghostwriter on khisto.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the khisto structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "igate",
			  &(clui_info->igate_file),
			  &(clui_info->igate_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "bins",
			  &(clui_info->bins_int),
			  &(clui_info->bins_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "binwidth",
			  &(clui_info->binwidth_double),
			  &(clui_info->binwidth_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "min",
			  &(clui_info->min_double),
			  &(clui_info->min_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "oob",
			  &(clui_info->oob_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "map",
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "normalize",
			  &(clui_info->normalize_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "whole",
			  &(clui_info->whole_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "w",
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "h",
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "d",
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "t",
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "e",
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "khisto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute Histogram for Data Object' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' khisto",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/khisto",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/khisto/help help",
  "-Q 1 0 5.25x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input ' 'Input data object' i",
  "-I 1 0 1 0 0 1 52x1+0+3 ' ' 'Gating Input' 'Gating input data object' igate",
  "-i 1 0 1 2 1 26.5x1+2+12.5 2 2 256 0 0 'Number of bins ' 'number of histogram bins' bins",
  "-h 1 0 1 2 1 27x1+2+14 0 0 1 10 0 0 'Bin width      ' 'width of histogram bin' binwidth",
  "-h 1 0 1 2 1 27x1+2+15.5 0 0 0 10 0 0 'Starting value ' 'Min side of min histogram bin' min",
  "-t 1 0 1 0 0 21.125x1+2+17 'Append out-of-bounds bins' 'append a pair of bins for out-of-bounds data' oob",
  "-t 1 0 1 1 0 6x1+2+18.5 'If map exists, pull the value data through it' 'if map exists, pull the value data through it' map",
  "-t 1 0 1 0 0 6x1+2+20 'Normalize integrated histogram to [0..1]' 'normalize integrated histogram to [0..1]' normalize",
  "-O 1 0 0 1 0 1 52x1+0+21.5 ' ' 'Histogram output object' 'histogram output data object' o1",
  "-O 1 0 1 0 0 1 52x1+0+23 ' ' 'Integrated histogram object' 'integrated histogram output object' o2",
  "-C 0",
  "-t 1 0 1 0 0 12.125x1+7+8 'Whole dataset' 'histogram whole data set at one time' whole",
  "-K 0",
  "-t 1 0 1 1 0 6.125x1+7+11 'Width' 'include width in histogram unit' w",
  "-t 1 0 1 1 0 8x1+15+11 'Height' 'include height in histogram unit' h",
  "-t 1 0 1 0 0 6.125x1+23+11 'Depth' 'include depth in histogram unit' d",
  "-t 1 0 1 0 0 5.375x1+31+11 'Time' 'include time in histogram unit' t",
  "-t 1 0 1 0 0 8.5x1+38+11 'Elements' 'include elements in histogram unit' e",
  "-E",
  "-E",
  "-b +1+4.5 'Select histogram unit:' blank1",
  "-b +3+5.5 '(an independent histogram will be computed for each such ' blank2",
  "-b +4+6.5 'unit in the data object)' blank3",
  "-b +11+9.5 'or the region formed by the following axes:' blank4",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/khisto/uis/khisto.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	36,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


