 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:52:56 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:52:56 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "khistops.h"
/*-----------------------------------------------------------
| 
|  Routine Name: khistops_get_args
| 
|       Purpose: Gets command line args for khistops
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname khistops
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void khistops_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for khistops is out of sync with arguments specified in khistops's *.pane file; please rerun ghostwriter on khistops.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the khistops structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "invert",
			  &(clui_info->invert_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "equalize",
			  &(clui_info->equalize_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "stretch",
			  &(clui_info->stretch_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "whole",
			  &(clui_info->whole_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "w",
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "h",
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "d",
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "t",
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "e",
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "khistops_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Perform Histogram Equalization and Stretching' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' khistops",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/khistops",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/khistops/help help",
  "-Q 1 0 5.25x1.18182+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input ' 'Input data object' i",
  "-t 1 0 1 0 0 28.625x1+7+10.5 'Invert grey levels after processing' 'invert grey levels after processing' invert",
  "-O 1 0 0 1 0 1 52x1+0+12 ' ' 'Output' 'Resulting output data object' o",
  "-C 1",
  "-t 1 0 1 1 0 8.375x1+7+3 'Equalize' 'perform histogram equalization' equalize",
  "-t 1 0 1 0 0 7.625x1+7+4.5 'Stretch' 'perform linear histogram stretch' stretch",
  "-E",
  "-C 1",
  "-t 1 0 1 0 0 12.125x1+10+7.5 'Whole dataset' 'process whole data set at one time' whole",
  "-K 0",
  "-t 1 0 1 1 0 6.125x1+10+9 'Width' 'include width in processing unit' w",
  "-t 1 0 1 1 0 6.875x1+18+9 'Heigth' 'include height in processing unit' h",
  "-t 1 0 1 0 0 6.125x1+27+9 'Depth' 'include depth in processing unit' d",
  "-t 1 0 1 0 0 5.375x1+35+9 'Time' 'include time in processing unit' t",
  "-t 1 0 1 0 0 8.375x1+42+9 'Elements' 'include elements in processing unit' e",
  "-E",
  "-E",
  "-b +7+6 'Select form of independent histogram units:' b1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/khistops/uis/khistops.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	30,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


