 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:53:18 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:53:18 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kimportasc.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kimportasc_get_args
| 
|       Purpose: Gets command line args for kimportasc
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kimportasc
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kimportasc_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kimportasc is out of sync with arguments specified in kimportasc's *.pane file; please rerun ghostwriter on kimportasc.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kimportasc structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "so",
			  &(clui_info->so_int),
			  &(clui_info->so_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "sf",
			  &(clui_info->sf_int),
			  &(clui_info->sf_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "nr",
			  &(clui_info->nr_int),
			  &(clui_info->nr_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "segment",
			  &(clui_info->segment_string),
			  &(clui_info->segment_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dim",
			  &(clui_info->dim_int),
			  &(clui_info->dim_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "windex", KVF_LIST_LABEL,
			  &(clui_info->windex_label),
			  &(clui_info->windex_flag)) &&
	      kclui_get_value(pane, "windex", KVF_LIST_VAL,
			  &(clui_info->windex_list),
			  &(clui_info->windex_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "hindex", KVF_LIST_LABEL,
			  &(clui_info->hindex_label),
			  &(clui_info->hindex_flag)) &&
	      kclui_get_value(pane, "hindex", KVF_LIST_VAL,
			  &(clui_info->hindex_list),
			  &(clui_info->hindex_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "dindex", KVF_LIST_LABEL,
			  &(clui_info->dindex_label),
			  &(clui_info->dindex_flag)) &&
	      kclui_get_value(pane, "dindex", KVF_LIST_VAL,
			  &(clui_info->dindex_list),
			  &(clui_info->dindex_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "tindex", KVF_LIST_LABEL,
			  &(clui_info->tindex_label),
			  &(clui_info->tindex_flag)) &&
	      kclui_get_value(pane, "tindex", KVF_LIST_VAL,
			  &(clui_info->tindex_list),
			  &(clui_info->tindex_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "eindex", KVF_LIST_LABEL,
			  &(clui_info->eindex_label),
			  &(clui_info->eindex_flag)) &&
	      kclui_get_value(pane, "eindex", KVF_LIST_VAL,
			  &(clui_info->eindex_list),
			  &(clui_info->eindex_flag))))
	{
	    kerror(NULL, "kimportasc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Import ASCII Data File to Data Segment' subform",
  "-P 1 0 52.5x16+0+1 +0+0 ' ' kimportasc",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kimportasc",
  "-H 1  5x1+41+0 'Help' 'help page for kimportasc' $DATAMANIP/objects/kroutine/kimportasc/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'ASCII Input File' 'ASCII input data file containing new data segment' i1",
  "-I 1 0 1 0 0 1 50x1+2+4 ' ' 'Data Object Input' 'data object input to insert the new segment into' i2",
  "-i 1 0 1 2 0 24x1+2+5.5 1 1 0 0 0 'Start Offset    ' 'starting point in ASCII input file to start importing at' so",
  "-i 1 0 1 2 0 24x1+2+6.5 1 1 0 0 0 'Skip Factor     ' 'number of points in ASCII file to skip between reads' sf",
  "-i 1 0 1 2 0 24x1+2+7.5 2 2 1 0 0 'Number of Reads ' 'number of points in ASCII file to read between skips' nr",
  "-y 1 0 1 2 0 31x1+2+11 5 1 'Segment Name' 'The name of the segment to insert the ASCII data into' segment 'Value' 'Map' 'Mask' 'Time ' 'Location '",
  "-i 1 0 1 2 0 31x1+2+12 2 2 5 0 0 'Segment Dimension   ' 'dimension of the segment' dim",
  "-x 1 0 1 2 0 31x1+2+13.5 13 1 11 'Data Type           ' 'data type to store ascii data as' type 'Bit' 'Byte' 'Unsigned Byte' 'Short' 'Unsigned Short' 'Integer' 'Unsigned Integer' 'Long' 'Unsigned Long' 'Float' 'Double' 'Complex' 'Double Complex'",
  "-O 1 0 0 1 0 1 52x1+0+21.5 ' ' 'Output Object' 'output data object' o",
  "-b +0+9.5 'Segment Information:' seginfo",
  "-b +2+3 'Insert Segment in the following Data Object :' blank1",
  "-b +12+15 'Dimension Sizes' blank2",
  "-b +27+15 'Dimension Indices' blank3",
  "-B 0",
  "-i 1 0 1 1 0 20x1+2+16 2 2 1 0 0 'WIDTH     ' 'size of width dimension in index specified' wsize",
  "-x 1 0 1 1 0 12x1+27+16 5 1 1 ' ' 'position in the index order for the width dimension' windex 'First' 'Second' 'Third' 'Fourth ' 'Fifth '",
  "-E",
  "-B 0",
  "-i 1 0 1 1 0 20x1+2+17 2 2 1 0 0 'HEIGHT    ' 'size of height dimension in index specified' hsize",
  "-x 1 0 1 1 0 12x1+27+17 5 1 2 ' ' 'position in the index order for the height dimension' hindex 'First' 'Second' 'Third' 'Fourth ' 'Fifth '",
  "-E",
  "-B 0",
  "-i 1 0 1 1 0 20x1+2+18 2 2 1 0 0 'DEPTH     ' 'size of depth dimension in index specified' dsize",
  "-x 1 0 1 1 0 12x1+27+18 5 1 3 ' ' 'position in the index order for the depth dimension' dindex 'First' 'Second' 'Third' 'Fourth ' 'Fifth '",
  "-E",
  "-B 0",
  "-i 1 0 1 1 0 20x1+2+19 2 2 1 0 0 'TIME      ' 'size of time dimension in index specified' tsize",
  "-x 1 0 1 1 0 12x1+27+19 5 1 4 ' ' 'position in the index order for the time dimension' tindex 'First' 'Second' 'Third' 'Fourth ' 'Fifth '",
  "-E",
  "-B 0",
  "-i 1 0 1 1 0 20x1+2+20 2 2 1 0 0 'ELEMENTS  ' 'size of elements dimension in index specified' esize",
  "-x 1 0 1 1 0 12x1+27+20 5 1 5 ' ' 'position in the index order for the elements dimension' eindex 'First' 'Second' 'Third' 'Fourth ' 'Fifth '",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kimportasc/uis/kimportasc.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	45,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


