 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:53:36 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:53:36 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kimportraw.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kimportraw_get_args
| 
|       Purpose: Gets command line args for kimportraw
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kimportraw
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kimportraw_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kimportraw is out of sync with arguments specified in kimportraw's *.pane file; please rerun ghostwriter on kimportraw.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kimportraw structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "arch", KVF_LIST_LABEL,
			  &(clui_info->arch_label),
			  &(clui_info->arch_flag)) &&
	      kclui_get_value(pane, "arch", KVF_LIST_VAL,
			  &(clui_info->arch_list),
			  &(clui_info->arch_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "skip",
			  &(clui_info->skip_int),
			  &(clui_info->skip_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "segment", KVF_LIST_LABEL,
			  &(clui_info->segment_label),
			  &(clui_info->segment_flag)) &&
	      kclui_get_value(pane, "segment", KVF_LIST_VAL,
			  &(clui_info->segment_list),
			  &(clui_info->segment_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "color", KVF_LIST_LABEL,
			  &(clui_info->color_label),
			  &(clui_info->color_flag)) &&
	      kclui_get_value(pane, "color", KVF_LIST_VAL,
			  &(clui_info->color_list),
			  &(clui_info->color_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kimportraw_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Low level import of raw (binary) data' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' kimport_raw",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kimportraw",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kimportraw/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Raw (binary) input' 'raw (binary) input' i1",
  "-I 1 0 1 0 0 1 52x1+0+3.5 ' ' 'Add-to object' 'Object to which the new data should be added' i2",
  "-x 1 0 1 2 0 37x1+4+6.5 18 1 1 'Architecture  ' 'data source architecture' arch 'Local' 'Intel 80x86' 'SPARC (Sun4,Solbourne)' 'MIPS-EL (DecStation)' 'IBM RT' 'RS6000 (SP-1,SP-2)' 'POWER PC' 'Motorola 680x0 (Mac, Next, Sun3)' 'Motorola 88x00 (DG/Avion, LUNA)' 'MIPS-EB (SGI)' 'PA-RISC (HP9000)' 'Convex' 'Apollo' 'DEC Alpha' 'CDC Cyber' 'Cray' 'DEC VAX' 'Intel Paragon'",
  "-x 1 0 1 2 0 33x1.09091+4+8 13 1 3 'Data type of raw data ' 'data type of raw data' type 'Bit' 'Byte' 'Unsigned Byte' 'Short' 'Unsigned Short' 'Integer' 'Unsigned Integer' 'Long' 'Unsigned Long' 'Float' 'Double' 'Complex' 'Double Complex'",
  "-i 1 0 1 1 0 28x1+4+9.5 2 2 1 0 0 'Width    ' 'Size of width dimension' wsize",
  "-i 1 0 1 1 0 28x1+4+10.5 2 2 1 0 0 'Height   ' 'Size of height dimension' hsize",
  "-i 1 0 1 1 0 28x1+4+11.5 2 2 1 0 0 'Depth    ' 'Size of depth dimension' dsize",
  "-i 1 0 1 1 0 28x1+4+12.5 2 2 1 0 0 'Time     ' 'Size of time dimension' tsize",
  "-i 1 0 1 1 0 28x1+4+13.5 2 2 1 0 0 'Elements ' 'Size of elements dimension' esize",
  "-i 1 0 1 2 0 30x1+4+15 1 1 0 0 0 'Offset or skip (bytes)' 'skip this number of bytes before reading' skip",
  "-x 1 0 1 2 0 35x1+1+16.5 6 1 1 'Destination for incoming data ' 'destination for incoming data ' segment 'Value' 'Mask' 'Map' 'Location ' 'Time ' 'Comment '",
  "-x 1 0 1 2 0 35x1+1+18 15 1 1 'Color space model for data' 'color space model for data' color 'None' 'Grey' 'RGB' 'CMY' 'YIQ' 'HSV' 'HLS' 'IHS' 'XYZ' 'UVW' 'UCSUVW' 'UCSSOW' 'UCSLab' 'UCSLuv' 'User Defined'",
  "-O 1 0 0 1 0 1 52x1+1+19.5 ' ' 'Output object' 'output object' o",
  "-b +1+5 'Raw data storage information: ' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kimportraw/uis/kimportraw.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	26,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


