 /*
  * Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 18:53:57 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 18:53:57 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kimpulse.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kimpulse_get_args
| 
|       Purpose: Gets command line args for kimpulse
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kimpulse
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kimpulse_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kimpulse is out of sync with arguments specified in kimpulse's *.pane file; please rerun ghostwriter on kimpulse.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kimpulse structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wnum",
			  &(clui_info->wnum_int),
			  &(clui_info->wnum_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hnum",
			  &(clui_info->hnum_int),
			  &(clui_info->hnum_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dnum",
			  &(clui_info->dnum_int),
			  &(clui_info->dnum_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tnum",
			  &(clui_info->tnum_int),
			  &(clui_info->tnum_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "enum",
			  &(clui_info->enum_int),
			  &(clui_info->enum_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsp",
			  &(clui_info->wsp_int),
			  &(clui_info->wsp_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "woff",
			  &(clui_info->woff_int),
			  &(clui_info->woff_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsp",
			  &(clui_info->hsp_int),
			  &(clui_info->hsp_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hoff",
			  &(clui_info->hoff_int),
			  &(clui_info->hoff_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsp",
			  &(clui_info->dsp_int),
			  &(clui_info->dsp_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "doff",
			  &(clui_info->doff_int),
			  &(clui_info->doff_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsp",
			  &(clui_info->tsp_int),
			  &(clui_info->tsp_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "toff",
			  &(clui_info->toff_int),
			  &(clui_info->toff_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esp",
			  &(clui_info->esp_int),
			  &(clui_info->esp_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "eoff",
			  &(clui_info->eoff_int),
			  &(clui_info->eoff_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "fgreal",
			  &(clui_info->fgreal_double),
			  &(clui_info->fgreal_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "bgreal",
			  &(clui_info->bgreal_double),
			  &(clui_info->bgreal_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "fgimag",
			  &(clui_info->fgimag_double),
			  &(clui_info->fgimag_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "bgimag",
			  &(clui_info->bgimag_double),
			  &(clui_info->bgimag_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kimpulse_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate Object Containing Impulse Value Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Impulse",
  "-D 1 0 9x1.13636+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kimpulse",
  "-H 1  5x1+41+0 'Help' 'help page for kimpulse' $DATAMANIP/objects/kroutine/kimpulse/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-i 1 0 1 2 0 22x1+1+3 2 2 512 1 1 'Width           ' 'Width of impulse value data' wsize",
  "-i 1 0 1 2 0 23.75x1+28+3 2 2 1 0 0 'Num. along Width    ' 'Number of impulses generated along the width dimension' wnum",
  "-i 1 0 1 2 0 22x1+1+4 2 2 512 1 1 'Height          ' 'Height of impulse value data' hsize",
  "-i 1 0 1 2 0 23.75x1+28+4 2 2 1 0 0 'Num. along Height   ' 'Number of impulses generated along the height dimension' hnum",
  "-i 1 0 1 2 0 22x1+1+5 2 2 1 1 1 'Depth           ' 'Depth of impulse value data' dsize",
  "-i 1 0 1 2 0 23.75x1+28+5 2 2 1 0 0 'Num. along Depth    ' 'Number of impulses generated along the depth dimension' dnum",
  "-i 1 0 1 2 0 22x1+1+6 2 2 1 1 1 'Time            ' 'Time of impulse value data' tsize",
  "-i 1 0 1 2 0 23.75x1+28+6 2 2 1 0 0 'Num. along Time     ' 'Number of impulses generated along the time dimension' tnum",
  "-i 1 0 1 2 0 22x1+1+7 2 2 1 1 1 'Elements        ' 'Element dimension of impulse value data' esize",
  "-i 1 0 1 2 0 23.75x1+28+7 2 2 1 0 0 'Num. along Elements ' 'Number of impulses generated along the element dimension' enum",
  "-i 1 0 1 2 0 22x1+1+10 2 2 256 0 0 'Width Spacing   ' 'Spacing between two impulses along the width dimension' wsp",
  "-i 1 0 1 2 0 23.75x1+28+10 1 1 0 0 0 'Width Offset    ' 'Offset of first impulse along width dimension' woff",
  "-i 1 0 1 2 0 22x1+1+11 2 2 256 0 0 'Height Spacing  ' 'Spacing between two impulses along the height dimension' hsp",
  "-i 1 0 1 2 0 23.75x1+28+11 1 1 0 0 0 'Height Offset   ' 'Offset of first impulse along height dimension' hoff",
  "-i 1 0 1 2 0 22x1+1+12 2 2 1 0 0 'Depth Spacing   ' 'Spacing between two impulses along the depth dimension' dsp",
  "-i 1 0 1 2 0 23.75x1+28+12 1 1 0 0 0 'Depth Offset    ' 'Offset of first impulse along depth dimension' doff",
  "-i 1 0 1 2 0 22x1+1+13 2 2 1 0 0 'Time Spacing    ' 'Spacing between two impulses along the time dimension' tsp",
  "-i 1 0 1 2 0 23.75x1+28+13 1 1 0 0 0 'Time Offset     ' 'Offset of first impulse along time dimension' toff",
  "-i 1 0 1 2 0 22x1+1+14 2 2 1 0 0 'Element Spacing ' 'Spacing between two impulses along the element dimension' esp",
  "-i 1 0 1 2 0 23.75x1+28+14 1 1 0 0 0 'Element Offset  ' 'Offset of the first impulse along the element dimension' eoff",
  "-h 1 0 1 2 0 24.75x1+1+16 0 0 255 1 0 0 'Real Value of Impulse ' 'Real value assigned to the generated impulse' fgreal",
  "-h 1 0 1 2 0 23.75x1+28+16 0 0 0 1 0 0 'Real Background Value ' 'Real value assigned to background value data' bgreal",
  "-h 1 0 1 2 0 24.75x1+1+17 0 0 0 1 0 0 'Imag Value of Impulse ' 'Imaginary value of generated impulse ' fgimag",
  "-h 1 0 1 2 0 23.75x1+28+17 0 0 0 1 0 0 'Imag Background Value ' 'Imaginary value assigned to background' bgimag",
  "-x 1 0 1 2 0 43.25x1.13636+1+19 13 1 3 'Select Data Type:' 'Data type of impulse value data' type 'bit' 'byte' 'unsigned byte' 'short' 'unsigned short' 'integer' 'unsigned integer' 'long' 'unsigned long' 'float' 'double' 'complex' 'double complex'",
  "-O 1 0 0 1 0 1 51.75x1+0+21 ' ' 'Output' 'Output file containing impulse value data' o",
  "-b +1+9 'Impulse spacing along dimensions' b1",
  "-b +28+2 'Impulses along each dimension' b2",
  "-b +28+9 'Impulse offset along dimensions' b3",
  "-b +1+2 'Output object size' b4",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kimpulse/uis/kimpulse.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	42,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


