 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:54:16 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:54:16 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kinsertseg.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kinsertseg_get_args
| 
|       Purpose: Gets command line args for kinsertseg
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kinsertseg
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kinsertseg_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kinsertseg is out of sync with arguments specified in kinsertseg's *.pane file; please rerun ghostwriter on kinsertseg.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kinsertseg structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kinsertseg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kinsertseg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kinsertseg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "val",
			  &(clui_info->val_flag))))
	{
	    kerror(NULL, "kinsertseg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "map",
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "kinsertseg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mask",
			  &(clui_info->mask_flag))))
	{
	    kerror(NULL, "kinsertseg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "loc",
			  &(clui_info->loc_flag))))
	{
	    kerror(NULL, "kinsertseg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "time",
			  &(clui_info->time_flag))))
	{
	    kerror(NULL, "kinsertseg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "segment",
			  &(clui_info->segment_string),
			  &(clui_info->segment_flag))))
	{
	    kerror(NULL, "kinsertseg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Insert Selected Data Segments from Input 1 into Input 2' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kinsertseg",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kinsertseg",
  "-H 1 5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kinsertseg/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input 1' 'Source Input File' i1",
  "-I 1 0 0 1 0 1 52x1+0+2.5 ' ' 'Input 2' 'Destination Input File' i2",
  "-O 1 0 0 1 0 1 52x1+0+8.5 ' ' 'Output ' 'output file' o",
  "-K 1",
  "-t 1 0 1 1 0 9.375x1+3+5.5 'Value' 'If -val flag is selected, operate on Value segment' val",
  "-t 1 0 1 0 0 9.375x1+12+5.5 'Map' 'If -map flag is selected, operate on map segment' map",
  "-t 1 0 1 0 0 9.375x1+21+5.5 'Mask' 'If -mask flag is selected, operate on Mask segment' mask",
  "-t 1 0 1 0 0 9.375x1+30+5.5 'Location' 'If -loc flag is selected, operate on Location segment' loc",
  "-t 1 0 1 0 0 9.375x1+39+5.5 'Time' 'If -time flag is selected, operate on Time segment' time",
  "-y 1 0 1 0 0 47x1+3+7 1 1 'Alternate Segment' 'Perform operation on user specified segment' segment 'Insert All'",
  "-E",
  "-b +1+4 'Select Data Segment(s):' blank2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kinsertseg/uis/kinsertseg.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	24,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


