 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:54:35 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:54:35 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kinset.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kinset_get_args
| 
|       Purpose: Gets command line args for kinset
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kinset
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kinset_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kinset is out of sync with arguments specified in kinset's *.pane file; please rerun ghostwriter on kinset.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kinset structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "insetvalid",
			  &(clui_info->insetvalid_logic),
			  &(clui_info->insetvalid_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "padvalid",
			  &(clui_info->padvalid_logic),
			  &(clui_info->padvalid_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "mapping", KVF_LIST_LABEL,
			  &(clui_info->mapping_label),
			  &(clui_info->mapping_flag)) &&
	      kclui_get_value(pane, "mapping", KVF_LIST_VAL,
			  &(clui_info->mapping_list),
			  &(clui_info->mapping_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "attr",
			  &(clui_info->attr_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "woff",
			  &(clui_info->woff_int),
			  &(clui_info->woff_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hoff",
			  &(clui_info->hoff_int),
			  &(clui_info->hoff_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "doff",
			  &(clui_info->doff_int),
			  &(clui_info->doff_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "toff",
			  &(clui_info->toff_int),
			  &(clui_info->toff_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "eoff",
			  &(clui_info->eoff_int),
			  &(clui_info->eoff_flag))))
	{
	    kerror(NULL, "kinset_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Inset Object 2 into Object 1' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' Insert_Region",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kinset",
  "-H 1  5x1+41+0 'Help' 'man page for kinsert' $DATAMANIP/objects/kroutine/kinset/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input 1' 'Base input image' i1",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Input 2' 'Second (inset) input image' i2",
  "-l 1 0 1 2 0 14.5x1+1+14 1 'If Object has Mask, Only Inset VALID Data ' 'False' 'True' 'If Object has Mask, Only Inset VALID DataIf' insetvalid",
  "-h 1 0 1 2 1 36x1+1+16 0 0 0 0 1 1 'Real Pad Value      ' 'Real constant pad level' real",
  "-h 1 0 1 2 1 36x1+1+17 0 0 0 0 1 1 'Imaginary Pad Value ' 'Imaginary constant pad level' imag",
  "-l 1 0 1 2 0 49x1+1+18 1 'Identify padded data added by this program as  ' 'Invalid' 'Valid' 'Identify padded data added by this program as valid or invalid in mask' padvalid",
  "-x 1 0 1 2 0 44x1+1+20 2 0 0 'When Some Objects Have Maps: ' 'Defines map treatment when some, but not all, objects have maps ' mapping 'Map Data Thru Maps ' 'Use First Map Only'",
  "-O 1 0 0 2 0 1 52x1+0+22 ' ' 'Output' 'Resulting output object' o",
  "-K 0",
  "-t 1 0 1 1 0 46x1+3+6.5 'Use Input 2 Sub-Object Position (unless overridden below)' 'Insert at i2 subobject position (attribute) - w,h,d,t,e will override if specified' attr",
  "-i 1 0 1 0 1 35x1+3+7.5 0 0 0 1 1 'Width Coordinate  ' 'Insert region beginning at this width coordinate' woff",
  "-i 1 0 1 0 1 35x1+3+8.5 0 0 0 1 1 'Height Coordinate ' 'Insert region beginning at this height coordinate' hoff",
  "-i 1 0 1 0 1 35x1+3+9.5 0 0 0 1 1 'Depth Coordinate  ' 'Insert region beginning at this depth coordinate' doff",
  "-i 1 0 1 0 1 35x1+3+10.5 0 0 0 1 1 'Time Coordinate   ' 'Insert region beginning at this time coordinate' toff",
  "-i 1 0 1 0 1 35x1+3+11.5 0 0 0 1 1 'Element Coordinate' 'Insert region beginning at this element coordinate' eoff",
  "-E",
  "-b +1+5 'Inset Input 2 into Input 1 at Following Coordinates:' b",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kinset/uis/kinset.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	29,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


