 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:55:14 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:55:14 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kkmeans.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kkmeans_get_args
| 
|       Purpose: Gets command line args for kkmeans
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kkmeans
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kkmeans_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kkmeans is out of sync with arguments specified in kkmeans's *.pane file; please rerun ghostwriter on kkmeans.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kkmeans structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "map",
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "spectrum",
			  &(clui_info->spectrum_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "k",
			  &(clui_info->k_int),
			  &(clui_info->k_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o3",
			  &(clui_info->o3_file),
			  &(clui_info->o3_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o4",
			  &(clui_info->o4_file),
			  &(clui_info->o4_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o5",
			  &(clui_info->o5_file),
			  &(clui_info->o5_flag))))
	{
	    kerror(NULL, "kkmeans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Perform K-Means Clustering' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kkmeans",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $DATAMANIP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kkmeans",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kkmeans/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input data object' 'input data object' i1",
  "-I 1 0 1 0 0 1 52x1+0+3.5 ' ' 'Cluster center input object' 'cluster center input object' i2",
  "-t 1 0 1 1 0 6x1+6+5 'Generate output map' 'generate output map' map",
  "-t 1 0 1 0 0 25.625x1+25+5 'SPECTRUM compatable map segment' 'SPECTRUM compatable map segment' spectrum",
  "-i 1 0 1 1 0 30x1+6+6.5 0 100000 50000 0 0 'Max number of iterations' 'max number of iterations' n",
  "-i 1 0 1 1 0 30.625x1+6+8 2 2 2 0 0 'Number of clusters' 'number of clusters' k",
  "-O 1 0 0 1 0 1 52x1+0+9.5 ' ' 'Cluster number output object' 'cluster number output object' o1",
  "-O 1 0 1 0 0 1 52x1+0+11 ' ' 'Cluster center output object' 'cluster center output object' o2",
  "-O 1 0 1 0 0 1 52x1+0+12.5 ' ' 'Cluster variance output object' 'cluster variance output object' o3",
  "-O 1 0 1 0 0 1 52x1+0+14 ' ' 'Cluster membership count output' 'Cluster membership count output' o4",
  "-O 1 0 1 0 0 1 52x1+0+15.5 ' ' 'K-means statistics output (ASCII)' 'K-means statistics output (ASCII)' o5",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kkmeans/uis/kkmeans.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	23,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


