 /*
  * Khoros: $Id: klinearop.h,v 1.16.2.2 1997/05/31 18:55:36 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for klinearop
   >>>> 
   >>>>    Written By: Jonio Roberto de Hollanda Cavalcanti, Ramiro Jordan
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _klinearop_h_
#define _klinearop_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include <kdatamanip/kdatamanip.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input object  (required infile)
 */
char	*i1_file;	/* Input object  FILENAME */
int	 i1_flag;	/* Input object  FLAG */

/*
 *  Input kernel (required infile)
 */
char	*i2_file;	/* Input kernel FILENAME */
int	 i2_flag;	/* Input kernel FLAG */

/*
 *  output object (required outfile)
 */
char	*o_file;	/* output object FILENAME */
int	 o_flag;	/* output object FLAG */

/*----- required ME group ----*/
	/*---- nested optional MI group ----*/
/*
 *  If flag is set, handle boundaries by padding (optional flag)
 */
int	 l_flag;  	/* If flag is set, handle boundaries by padding FLAG */

/*
 *  Real part of pad constant (optional double)
 */
double	 real_double;	/* Real part of pad constant DOUBLE */
int	 real_flag;   	/* Real part of pad constant FLAG */

/*
 *  Imaginary part of pad constant (optional double)
 */
double	 imag_double;	/* Imaginary part of pad constant DOUBLE */
int	 imag_flag;   	/* Imaginary part of pad constant FLAG */

	/*-- nested optional MI group end --*/

/*
 *  If flag is set, handle boundaries by wrapping (optional flag)
 */
int	 c_flag;  	/* If flag is set, handle boundaries by wrapping FLAG */

/*-- required ME group end ---*/

/*
 *  Select correlation (default) or convolution (optional logical)
 */
int	 corr_logic;	/* Select correlation (default) or convolution LOGIC */
int	 corr_flag;  	/* Select correlation (default) or convolution FLAG */

/*
 *  Upcast data to double or double complex for processing (optional flag)
 */
int	 upcast_flag;  	/* Upcast data to double or double complex for processing FLAG */

/*
 *  Width coordinate of kernel hotspot (optional integer)
 */
int	 wc_int; 	/* Width coordinate of kernel hotspot INT */
int	 wc_flag;	/* Width coordinate of kernel hotspot FLAG */

/*
 *  Height coordinate of kernel hotspot (optional integer)
 */
int	 hc_int; 	/* Height coordinate of kernel hotspot INT */
int	 hc_flag;	/* Height coordinate of kernel hotspot FLAG */

/*
 *  Depth coordinate of kernel hotspot (optional integer)
 */
int	 dc_int; 	/* Depth coordinate of kernel hotspot INT */
int	 dc_flag;	/* Depth coordinate of kernel hotspot FLAG */

/*
 *  Time coordinate of kernel hotspot (optional integer)
 */
int	 tc_int; 	/* Time coordinate of kernel hotspot INT */
int	 tc_flag;	/* Time coordinate of kernel hotspot FLAG */

/*
 *  Element coordinate of kernel hotspot (optional integer)
 */
int	 ec_int; 	/* Element coordinate of kernel hotspot INT */
int	 ec_flag;	/* Element coordinate of kernel hotspot FLAG */

/*
 *  Width offset for subregion (optional integer)
 */
int	 woff_int; 	/* Width offset for subregion INT */
int	 woff_flag;	/* Width offset for subregion FLAG */

/*
 *  Height size for subregion (optional integer)
 */
int	 hsize_int; 	/* Height size for subregion INT */
int	 hsize_flag;	/* Height size for subregion FLAG */

/*
 *  Height offset for subregion (optional integer)
 */
int	 hoff_int; 	/* Height offset for subregion INT */
int	 hoff_flag;	/* Height offset for subregion FLAG */

/*
 *  Width size for subregion (optional integer)
 */
int	 wsize_int; 	/* Width size for subregion INT */
int	 wsize_flag;	/* Width size for subregion FLAG */

/*
 *  Depth offset for subregion (optional integer)
 */
int	 doff_int; 	/* Depth offset for subregion INT */
int	 doff_flag;	/* Depth offset for subregion FLAG */

/*
 *  Depth size for subregion (optional integer)
 */
int	 dsize_int; 	/* Depth size for subregion INT */
int	 dsize_flag;	/* Depth size for subregion FLAG */

/*
 *  Time offset for subregion (optional integer)
 */
int	 toff_int; 	/* Time offset for subregion INT */
int	 toff_flag;	/* Time offset for subregion FLAG */

/*
 *  Time size for subregion (optional integer)
 */
int	 tsize_int; 	/* Time size for subregion INT */
int	 tsize_flag;	/* Time size for subregion FLAG */

/*
 *  Elements offset for subregion (optional integer)
 */
int	 eoff_int; 	/* Elements offset for subregion INT */
int	 eoff_flag;	/* Elements offset for subregion FLAG */

/*
 *  Elements size for subregion (optional integer)
 */
int	 esize_int; 	/* Elements size for subregion INT */
int	 esize_flag;	/* Elements size for subregion FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void klinearop_get_args PROTO((kaddr));
void klinearop_usage_additions PROTO((void));
void klinearop_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
