 /*
  * Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 18:55:38 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 18:55:38 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "klinearop.h"
/*-----------------------------------------------------------
| 
|  Routine Name: klinearop_get_args
| 
|       Purpose: Gets command line args for klinearop
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname klinearop
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void klinearop_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for klinearop is out of sync with arguments specified in klinearop's *.pane file; please rerun ghostwriter on klinearop.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the klinearop structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "corr",
			  &(clui_info->corr_logic),
			  &(clui_info->corr_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "upcast",
			  &(clui_info->upcast_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wc",
			  &(clui_info->wc_int),
			  &(clui_info->wc_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hc",
			  &(clui_info->hc_int),
			  &(clui_info->hc_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dc",
			  &(clui_info->dc_int),
			  &(clui_info->dc_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tc",
			  &(clui_info->tc_int),
			  &(clui_info->tc_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "ec",
			  &(clui_info->ec_int),
			  &(clui_info->ec_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "woff",
			  &(clui_info->woff_int),
			  &(clui_info->woff_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hoff",
			  &(clui_info->hoff_int),
			  &(clui_info->hoff_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "doff",
			  &(clui_info->doff_int),
			  &(clui_info->doff_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "toff",
			  &(clui_info->toff_int),
			  &(clui_info->toff_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "eoff",
			  &(clui_info->eoff_int),
			  &(clui_info->eoff_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "l",
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "c",
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "klinearop_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Performs linear operations (convolution/correlation)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' 5D_Linear_",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/klinearop",
  "-H 1  5x1+41+0 'Help' 'man page for klinearop' $DATAMANIP/objects/kroutine/klinearop/help help",
  "-Q 1 0 5.25x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input Object ' 'Input object ' i1",
  "-I 1 0 0 1 0 1 52x1+0+2.5 ' ' 'Input Kernel ' 'Input kernel' i2",
  "-l 1 0 1 2 0 20x1+2+4 0 'Mode ' 'Convolution' 'Correlation ' 'Select correlation (default) or convolution' corr",
  "-t 1 0 1 0 0 10.625x1+19+9.5 'Upcast data' 'Upcast data to double or double complex for processing' upcast",
  "-i 1 0 1 0 0 17x1+4+12 1 1 0 1 1 'Width   ' 'Width coordinate of kernel hotspot' wc",
  "-i 1 0 1 0 0 17x1+4+13 1 1 0 1 1 'Height  ' 'Height coordinate of kernel hotspot' hc",
  "-i 1 0 1 0 0 17x1+4+14 1 1 0 1 1 'Depth   ' 'Depth coordinate of kernel hotspot' dc",
  "-i 1 0 1 0 0 17x1+4+15 1 1 0 1 1 'Time    ' 'Time coordinate of kernel hotspot' tc",
  "-i 1 0 1 0 0 17x1+4+16 1 1 0 1 1 'Elements' 'Element coordinate of kernel hotspot' ec",
  "-i 1 0 1 0 0 17x1+6+19.5 0 0 0 0 0 'Width   ' 'Width offset for subregion' woff",
  "-i 1 0 1 0 0 17x1+26+19.5 2 2 1 0 0 'Height  ' 'Height size for subregion' hsize",
  "-i 1 0 1 0 0 17x1+6+20.5 0 0 0 0 0 'Height  ' 'Height offset for subregion' hoff",
  "-i 1 0 1 0 0 17x1+26+20.5 2 2 1 0 0 'Width   ' 'Width size for subregion' wsize",
  "-i 1 0 1 0 0 17x1+6+21.5 0 0 0 0 0 'Depth   ' 'Depth offset for subregion' doff",
  "-i 1 0 1 0 0 17x1+26+21.5 2 2 1 0 0 'Depth   ' 'Depth size for subregion' dsize",
  "-i 1 0 1 0 0 17x1+6+22.5 0 0 0 0 0 'Time    ' 'Time offset for subregion' toff",
  "-i 1 0 1 0 0 17x1+26+22.5 2 2 1 0 0 'Time    ' 'Time size for subregion' tsize",
  "-i 1 0 1 0 0 17x1+6+23.5 0 0 0 0 0 'Elements' 'Elements offset for subregion' eoff",
  "-i 1 0 1 0 0 17x1+26+23.5 2 2 1 0 0 'Elements' 'Elements size for subregion' esize",
  "-O 1 0 0 1 0 1 52x1+0+25 ' ' 'Output Object ' 'output object' o",
  "-b +2+7 'Padding value:' b2",
  "-C 1",
  "-B 0",
  "-t 1 0 1 1 0 8x1+18+5.5 'Linear' 'If flag is set, handle boundaries by padding' l",
  "-h 1 0 1 1 1 23x1+15+7 0 0 0 0 1 1 'Real' 'Real part of pad constant' real",
  "-h 1 0 1 1 1 23x1+15+8 0 0 0 0 1 1 'Imag' 'Imaginary part of pad constant' imag",
  "-E",
  "-t 1 0 1 0 0 8.375x1+29+5.5 'Circular' 'If flag is set, handle boundaries by wrapping' c",
  "-E",
  "-b +2+11 'Kernel hotspot:' blank1",
  "-b +2+17.5 'Constrain operation to subregion in input object:' blank4",
  "-b +25+18.5 'Size:' blank5",
  "-b +4+18.5 'Offset:' blank3",
  "-b +2+5.5 'Boundary handling:' blank6",
  "-b +2+9.5 'Data type handling:' blank7",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/klinearop/uis/klinearop.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	47,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


