 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:56:01 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:56:01 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "klocxform.h"
/*-----------------------------------------------------------
| 
|  Routine Name: klocxform_get_args
| 
|       Purpose: Gets command line args for klocxform
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname klocxform
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void klocxform_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for klocxform is out of sync with arguments specified in klocxform's *.pane file; please rerun ghostwriter on klocxform.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the klocxform structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xrot",
			  &(clui_info->xrot_float),
			  &(clui_info->xrot_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yrot",
			  &(clui_info->yrot_float),
			  &(clui_info->yrot_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "zrot",
			  &(clui_info->zrot_float),
			  &(clui_info->zrot_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "fx",
			  &(clui_info->fx_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xtrans",
			  &(clui_info->xtrans_float),
			  &(clui_info->xtrans_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "fy",
			  &(clui_info->fy_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ytrans",
			  &(clui_info->ytrans_float),
			  &(clui_info->ytrans_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "fz",
			  &(clui_info->fz_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ztrans",
			  &(clui_info->ztrans_float),
			  &(clui_info->ztrans_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "scale",
			  &(clui_info->scale_float),
			  &(clui_info->scale_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xscale",
			  &(clui_info->xscale_float),
			  &(clui_info->xscale_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yscale",
			  &(clui_info->yscale_float),
			  &(clui_info->yscale_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "zscale",
			  &(clui_info->zscale_float),
			  &(clui_info->zscale_flag))))
	{
	    kerror(NULL, "klocxform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Rotate, Translate, and Scale Location Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' klocxform",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $DATAMANIP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/klocxform",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/klocxform/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'the input object to be processed' i",
  "-f 1 0 1 1 1 46x1+3+4.5 -360 360 0 3 1 0 ' X ' 'rotate around x axis' xrot",
  "-f 1 0 1 1 1 46x1+3+5.5 -360 360 0 3 1 0 ' Y ' 'rotate around y axis' yrot",
  "-f 1 0 1 1 1 46x1+3+6.5 -360 360 0 3 1 0 ' Z ' 'rotate around z axis' zrot",
  "-t 1 0 1 0 0 9x1+19+12 'Flip X' 'flip x coordinates' fx",
  "-f 1 0 1 1 1 17x1+34+12 0 0 0 3 0 0 ' X ' 'translate in x direction' xtrans",
  "-t 1 0 1 0 0 9x1+19+13 'Flip Y' 'flip y coordinates' fy",
  "-f 1 0 1 1 1 17x1+34+13 0 0 0 3 0 0 ' Y ' 'translate in y direction' ytrans",
  "-t 1 0 1 0 0 9x1+19+14 'Flip Z' 'flip z coordinates' fz",
  "-f 1 0 1 1 1 17x1+34+14 0 0 0 3 0 0 ' Z ' 'translate in z direction' ztrans",
  "-O 1 0 0 1 0 1 52x1+0+16 ' ' 'Output' 'the output object' o",
  "-b +2+3.5 'Rotation' b1",
  "-b +33+11 'Translation' b2",
  "-b +2+8.5 'Orthogonal Scaling' b3",
  "-b +2+11 'Scaling' b4",
  "-C 0",
  "-f 1 0 1 1 1 27x1+3+9.5 2 2 1 3 0 0 ' XYZ ' 'orthogonal scale factor' scale",
  "-K 0",
  "-f 1 0 1 0 1 16x1+3+12 2 2 1 3 0 0 ' X ' 'scale x coordinates' xscale",
  "-f 1 0 1 0 1 16x1+3+13 2 2 1 3 0 0 ' Y ' 'scale y coordinates' yscale",
  "-f 1 0 1 0 1 16x1+3+14 2 2 1 3 0 0 ' Z ' 'scale z coordinates' zscale",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/klocxform/uis/klocxform.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	35,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


