 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:56:29 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:56:29 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "klogexp.h"
/*-----------------------------------------------------------
| 
|  Routine Name: klogexp_get_args
| 
|       Purpose: Gets command line args for klogexp
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname klogexp
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void klogexp_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for klogexp is out of sync with arguments specified in klogexp's *.pane file; please rerun ghostwriter on klogexp.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the klogexp structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "klogexp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "inv",
			  &(clui_info->inv_flag))))
	{
	    kerror(NULL, "klogexp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "offset",
			  &(clui_info->offset_logic),
			  &(clui_info->offset_flag))))
	{
	    kerror(NULL, "klogexp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "klogexp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "be",
			  &(clui_info->be_flag))))
	{
	    kerror(NULL, "klogexp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "b10",
			  &(clui_info->b10_flag))))
	{
	    kerror(NULL, "klogexp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "b2",
			  &(clui_info->b2_flag))))
	{
	    kerror(NULL, "klogexp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "base",
			  &(clui_info->base_double),
			  &(clui_info->base_flag))))
	{
	    kerror(NULL, "klogexp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute Logarithm and Exponential (Antilogarithm)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Logarithm",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/klogexp",
  "-H 1  5x1+41+0 'Help' 'help page for klogexp' $DATAMANIP/objects/kroutine/klogexp/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input ' 'input data object' i",
  "-t 1 0 1 0 0 25.625x1+2+3 'Compute inverse logarithm (exp)' 'Compute inverse logarithm (exp)' inv",
  "-l 1 0 1 2 0 27x1+2+10.5 1 'Offset ' '  value  ' 'value +/- 1' 'Operate either on value [False] or value+1 for log and value -1 for antilog [True]' offset",
  "-O 1 0 0 1 0 1 52x1+0+14.5 ' ' 'Output' 'resulting output data object' o",
  "-b +2+4.5 'Select Base:' b1",
  "-C 1",
  "-t 1 0 1 0 0 25x1+4+6 'Base e (2.71828...)' 'Compute using base e (2.71828...)' be",
  "-t 1 0 1 1 0 25x1+4+7 'Base 10' 'Compute using base 10' b10",
  "-t 1 0 1 0 0 25x1+4+8 'Base 2' 'Compute using base 2' b2",
  "-h 1 0 1 0 1 24x1+4+9 0 0 2 0 1 1 'Specify Base ' 'User Specified base' base",
  "-E",
  "-b +8+12 '(Logarithm:  can operate on value, or value + 1' b4",
  "-b +8+13 'Antilogarithm:  can return result, or result - 1)' b5",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/klogexp/uis/klogexp.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	25,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


