 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:57:19 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:57:19 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kmsquish.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kmsquish_get_args
| 
|       Purpose: Gets command line args for kmsquish
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kmsquish
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kmsquish_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kmsquish is out of sync with arguments specified in kmsquish's *.pane file; please rerun ghostwriter on kmsquish.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the kmsquish structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kmsquish_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "map",
			  &(clui_info->map_logic),
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "kmsquish_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "kmsquish_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->t_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kmsquish_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compress Map to One Column by Means of Average, RMS, or MAX' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kmsquish",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $DATAMANIP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kmsquish",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kmsquish/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "-l 1 0 1 1 0 31.75x1+7+3.5 1 'Map data after squishing map' 'False' 'True' 'map data after squishing map (1) or leave map with only one column (0)' map",
  "-T 1 0 1 1 0 25x4+7+5 +0+0 1 'Squishing scheme' 'squishing scheme (1)average, (2)RMS, (3)Maximum' t",
  "-i 1 0 1 1 0 10x1+1+1 2 2 1 0 0 'Average of map columns' 'Average of map columns' dummy",
  "-i 1 0 1 0 0 10x1+1+2 2 2 2 0 0 'RMS value of map columns' 'RMS value of map columns' dummy",
  "-i 1 0 1 0 0 10x1+1+3 2 2 3 0 0 'Maximum value of mape columns' 'Maximum value of mape columns' dummy",
  "-E",
  "-O 1 0 0 1 0 1 52x1+0+9.5 ' ' 'Output' 'Resulting output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kmsquish/uis/kmsquish.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


