 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:57:43 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:57:43 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "knoise.h"
/*-----------------------------------------------------------
| 
|  Routine Name: knoise_get_args
| 
|       Purpose: Gets command line args for knoise
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname knoise
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void knoise_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for knoise is out of sync with arguments specified in knoise's *.pane file; please rerun ghostwriter on knoise.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the knoise structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "replace",
			  &(clui_info->replace_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "add",
			  &(clui_info->add_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "gauss",
			  &(clui_info->gauss_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "gmean",
			  &(clui_info->gmean_double),
			  &(clui_info->gmean_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "gvar",
			  &(clui_info->gvar_double),
			  &(clui_info->gvar_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ray",
			  &(clui_info->ray_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "rvar",
			  &(clui_info->rvar_double),
			  &(clui_info->rvar_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "unif",
			  &(clui_info->unif_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "umax",
			  &(clui_info->umax_double),
			  &(clui_info->umax_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "umin",
			  &(clui_info->umin_double),
			  &(clui_info->umin_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "poiss",
			  &(clui_info->poiss_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ptime",
			  &(clui_info->ptime_double),
			  &(clui_info->ptime_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "pvar",
			  &(clui_info->pvar_double),
			  &(clui_info->pvar_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "exp",
			  &(clui_info->exp_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "evar",
			  &(clui_info->evar_double),
			  &(clui_info->evar_flag))))
	{
	    kerror(NULL, "knoise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Introduce Noise in Input Object' subform1",
  "-P 1 0 52x1+0+1 +0+0 '  ' Noise",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/knoise",
  "-H 1  5x1+41+0 'Help' 'help page for knoise' $DATAMANIP/objects/kroutine/knoise/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input File' 'input file' i",
  "-O 1 0 0 1 0 1 52x1+0+17 ' ' 'Output File' 'output file' o",
  "",
  "-C 1",
  "-t 1 0 1 0 0 25.875x1+2+3.5 'Replace Data with Noise' 'Replace existing values with noise' replace",
  "-t 1 0 1 1 0 23.625x1+24+3.5 'Add Noise to Data' 'Add noise to the specified segment' add",
  "-E",
  "",
  "-C 1",
  "-B 0",
  "-t 1 0 1 1 0 15.875x1+2+7 'Gaussian Noise' 'Generate Gaussian noise' gauss",
  "-h 1 0 1 1 1 21.75x1+2+8 0 0 0 10 0 0 'Mean     ' 'Mean for Gaussian noise' gmean",
  "-h 1 0 1 1 1 21.75x1+2+9 2 2 1 10 0 0 'Variance ' 'Variance for Gaussian noise' gvar",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 15.875x1+2+10.5 'Rayleigh Noise' 'Generate Rayleigh Noise' ray",
  "-h 1 0 1 0 1 22.25x1+2+11.5 2 2 1 10 0 0 'Variance ' 'Variance for Rayleigh noise' rvar",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 14.875x1+30+7 'Uniform Noise' 'Generate uniformly distributed noise' unif",
  "-h 1 0 1 0 1 22.25x1+30+8 0 0 1 10 0 0 'Maximum  ' 'Maximum value for uniform distribution' umax",
  "-h 1 0 1 0 1 22.25x1+30+9 0 0 0 10 0 0 'Minimum  ' 'Minimum value for uniform noise' umin",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 15.875x1+2+13 'Poisson Noise' 'Generate Poisson Noise' poiss",
  "-h 1 0 1 0 1 28x1+2+14 2 2 1 1 0 0 'Amount of Time ' 'Amount of time' ptime",
  "-h 1 0 1 0 1 28x1+2+15 2 2 1 1 0 0 'Variance       ' 'Variance for Poisson distribution' pvar",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 18.875x1+30+10.5 'Exponential Noise' 'Generate exponential noise' exp",
  "-h 1 0 1 0 1 22.25x1+30+11.5 2 2 1 10 0 0 'Variance ' 'Variance for exponential distribution' evar",
  "-E",
  "-E",
  "-b +2+5.5 'Select Noise Type:' text1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/knoise/uis/knoise.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	47,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


