 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:58:06 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:58:06 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "knormal.h"
/*-----------------------------------------------------------
| 
|  Routine Name: knormal_get_args
| 
|       Purpose: Gets command line args for knormal
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname knormal
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void knormal_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for knormal is out of sync with arguments specified in knormal's *.pane file; please rerun ghostwriter on knormal.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the knormal structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "lval",
			  &(clui_info->lval_double),
			  &(clui_info->lval_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "uval",
			  &(clui_info->uval_double),
			  &(clui_info->uval_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "whole",
			  &(clui_info->whole_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "w",
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "h",
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "d",
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "t",
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "e",
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dmin",
			  &(clui_info->dmin_double),
			  &(clui_info->dmin_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dmax",
			  &(clui_info->dmax_double),
			  &(clui_info->dmax_flag))))
	{
	    kerror(NULL, "knormal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Normalize Data Regions Using Minimum & Maximum of Each Region' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Normalize_Rgns",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/knormal",
  "-H 1  5x1+41+0 'Help' 'help page for knormal' $DATAMANIP/objects/kroutine/knormal/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input data object' i",
  "-h 1 0 1 2 1 39.5x1+4+5 0 0 0 0 1 1 'Lower Value  ' 'Lower normalization value' lval",
  "-h 1 0 1 2 1 39.5x1+4+6 0 0 255 0 1 1 'Upper Value  ' 'Upper normalization value' uval",
  "-x 1 0 1 2 0 36.375x1+1+15.5 14 0 0 'Convert to Type:  ' 'Data type of Output' type 'Propagate Input Type' 'Bit' 'Byte' 'Unsigned Byte' 'Short' 'Unsigned Short' 'Integer' 'Unsigned Integer' 'Long' 'Unsigned Long' 'Float' 'Double' 'Complex' 'Double Complex'",
  "-O 1 0 0 1 0 1 52x1+0+17.5 ' ' 'Output' 'resulting data object' o",
  "-C 0",
  "-t 1 0 1 0 0 12.875x1+4+12 'Whole Data Set' 'normalize whole data set at one time' whole",
  "-K 0",
  "-t 1 0 1 1 0 6.125x1+4+13.5 'Width' 'include width in normalization unit' w",
  "-t 1 0 1 1 0 6.875x1+12+13.5 'Height' 'include height in normalization unit' h",
  "-t 1 0 1 0 0 6.125x1+21+13.5 'Depth' 'include depth in normalization unit' d",
  "-t 1 0 1 0 0 5.375x1+29+13.5 'Time' 'include time in normalization unit' t",
  "-t 1 0 1 0 0 8.375x1+37+13.5 'Elements' 'include elements in normalization unit' e",
  "-E",
  "-E",
  "-b +1+11 'Define Processing Unit' b6",
  "-b +1+4 'Normalize Data: Minimum -> Lower Value; Maximum -> Upper Value' b1",
  "-B 0",
  "-h 1 0 1 0 1 41x1+3+8 0 0 0 0 0 0 'Predetermined Data Minimum ' 'If specified, this value used as data minimum' dmin",
  "-h 1 0 1 0 1 41x1+3+9 0 0 0 0 0 0 'Predetermined Data Maximum ' 'If specified, this value used as data maximum' dmax",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/knormal/uis/knormal.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	33,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


