 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:58:24 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:58:24 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "korient.h"
/*-----------------------------------------------------------
| 
|  Routine Name: korient_get_args
| 
|       Purpose: Gets command line args for korient
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname korient
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void korient_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for korient is out of sync with arguments specified in korient's *.pane file; please rerun ghostwriter on korient.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the korient structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ww",
			  &(clui_info->ww_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wh",
			  &(clui_info->wh_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "we",
			  &(clui_info->we_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wd",
			  &(clui_info->wd_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wt",
			  &(clui_info->wt_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hw",
			  &(clui_info->hw_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hh",
			  &(clui_info->hh_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "he",
			  &(clui_info->he_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hd",
			  &(clui_info->hd_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ht",
			  &(clui_info->ht_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ew",
			  &(clui_info->ew_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "eh",
			  &(clui_info->eh_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ee",
			  &(clui_info->ee_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ed",
			  &(clui_info->ed_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "et",
			  &(clui_info->et_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dw",
			  &(clui_info->dw_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dh",
			  &(clui_info->dh_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "de",
			  &(clui_info->de_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dd",
			  &(clui_info->dd_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dt",
			  &(clui_info->dt_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tw",
			  &(clui_info->tw_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "th",
			  &(clui_info->th_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "te",
			  &(clui_info->te_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "td",
			  &(clui_info->td_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tt",
			  &(clui_info->tt_flag))))
	{
	    kerror(NULL, "korient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Change Orientation of Data on Dimensions' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Orient",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/korient",
  "-H 1  5x1+41+0 'Help' 'help page for korient' $DATAMANIP/objects/kroutine/korient/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'input data object' i",
  "",
  "-O 1 0 0 1 0 1 52x1+0+14 ' ' 'Output' 'resulting data object' o",
  "-b +1+4 'NEW DIMENSIONS Will Contain Combined Data from the' b0",
  "-b +1+4.8 'Selected OLD DIMENSIONS                           ' b01",
  "-b +1+6 'NEW DIMENSIONS:' b1",
  "-b +1+8 'WIDTH     <==' b2",
  "-b +1+9 'HEIGHT    <==' b3",
  "-b +1+10 'ELEMENTS  <==' b6",
  "-b +1+11 'DEPTH     <==' b4",
  "-b +1+12 'TIME      <==' b5",
  "-b +25+6 'OLD DIMENSIONS:' b11",
  "-b +14+7 'WIDTH' b22",
  "-b +21+7 'HEIGHT' b33",
  "-b +28+7 'ELEMENTS' b66",
  "-b +37+7 'DEPTH' b44",
  "-b +44+7 'TIME' b55",
  "-C 1",
  "-t 1 0 1 1 0 4x1+15+8 ' ' 'orient WIDTH data to be on WIDTH dimension' ww",
  "-t 1 0 1 0 0 4x1+15+9 ' ' 'orient WIDTH data to be on HEIGHT dimension' wh",
  "-t 1 0 1 0 0 4x1+15+10 ' ' 'orient WIDTH data to be on ELEMENTS dimension' we",
  "-t 1 0 1 0 0 4x1+15+11 ' ' 'orient WIDTH data to be on DEPTH dimension' wd",
  "-t 1 0 1 0 0 4x1+15+12 ' ' 'orient WIDTH data to be on TIME dimension' wt",
  "-E",
  "",
  "-C 1",
  "-t 1 0 1 0 0 4x1+22.5+8 ' ' 'orient HEIGHT data to be on WIDTH dimension' hw",
  "-t 1 0 1 1 0 4x1+22.5+9 ' ' 'orient HEIGHT data to be on HEIGHT dimension' hh",
  "-t 1 0 1 0 0 4x1+22.5+10 ' ' 'orient HEIGHT data to be on ELEMENTS dimension' he",
  "-t 1 0 1 0 0 4x1+22.5+11 ' ' 'orient HEIGHT data to be on DEPTH dimension' hd",
  "-t 1 0 1 0 0 4x1+22.5+12 ' ' 'orient HEIGHT data to be on TIME dimension' ht",
  "-E",
  "",
  "-C 1",
  "-t 1 0 1 0 0 4x1+30.5+8 ' ' 'orient ELEMENT data to be on WIDTH dimension' ew",
  "-t 1 0 1 0 0 4x1+30.5+9 ' ' 'orient ELEMENT data to be on HEIGHT dimension' eh",
  "-t 1 0 1 1 0 4x1+30.5+10 ' ' 'orient ELEMENT data to be on ELEMENTS dimension' ee",
  "-t 1 0 1 0 0 4x1+30.5+11 ' ' 'orient ELEMENT data to be on DEPTH dimension' ed",
  "-t 1 0 1 0 0 4x1+30.5+12 ' ' 'orient ELEMENT data to be on TIME dimension' et",
  "-E",
  "",
  "-C 1",
  "-t 1 0 1 0 0 4x1+38.5+8 ' ' 'orient DEPTH data to be on WIDTH dimension' dw",
  "-t 1 0 1 0 0 4x1+38.5+9 ' ' 'orient DEPTH data to be on HEIGHT dimension' dh",
  "-t 1 0 1 0 0 4x1+38.5+10 ' ' 'orient DEPTH data to be on ELEMENTS dimension' de",
  "-t 1 0 1 1 0 4x1+38.5+11 ' ' 'orient DEPTH data to be on DEPTH dimension' dd",
  "-t 1 0 1 0 0 4x1+38.5+12 ' ' 'orient DEPTH data to be on TIME dimension' dt",
  "-E",
  "",
  "-C 1",
  "-t 1 0 1 0 0 4x1+45+8 ' ' 'orient TIME data to be on WIDTH dimension' tw",
  "-t 1 0 1 0 0 4x1+45+9 ' ' 'orient TIME data to be on HEIGHT dimension' th",
  "-t 1 0 1 0 0 4x1+45+10 ' ' 'orient TIME data to be on ELEMENTS dimension' te",
  "-t 1 0 1 0 0 4x1+45+11 ' ' 'orient TIME data to be on DEPTH dimension' td",
  "-t 1 0 1 1 0 4x1+45+12 ' ' 'orient TIME data to be on TIME dimension' tt",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
  61,62,63,64,65,66,67,68,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/korient/uis/korient.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	68,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


