 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:58:43 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:58:43 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kpad.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kpad_get_args
| 
|       Purpose: Gets command line args for kpad
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kpad
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kpad_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kpad is out of sync with arguments specified in kpad's *.pane file; please rerun ghostwriter on kpad.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kpad structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dsize",
			  &(clui_info->dsize_int),
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tsize",
			  &(clui_info->tsize_int),
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "esize",
			  &(clui_info->esize_int),
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "woff",
			  &(clui_info->woff_int),
			  &(clui_info->woff_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hoff",
			  &(clui_info->hoff_int),
			  &(clui_info->hoff_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "doff",
			  &(clui_info->doff_int),
			  &(clui_info->doff_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "toff",
			  &(clui_info->toff_int),
			  &(clui_info->toff_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "eoff",
			  &(clui_info->eoff_int),
			  &(clui_info->eoff_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wrap",
			  &(clui_info->wrap_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "valid",
			  &(clui_info->valid_logic),
			  &(clui_info->valid_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kpad_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Pad Data with a Constant Value' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Pad_Object",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kpad",
  "-H 1  5x1+41+0 'Help' 'help page for kpad' $DATAMANIP/objects/kroutine/kpad/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input data file' i",
  "-i 1 0 1 1 1 35x1+5+5.5 2 2 512 1 1 'Padded Width       ' 'Size of width dimension after padding' wsize",
  "-i 1 0 1 1 1 35x1+5+6.5 2 2 512 1 1 'Padded Height      ' 'Size of height dimension after padding' hsize",
  "-i 1 0 1 0 1 35x1+5+7.5 2 2 1 1 1 'Padded Depth       ' 'Size of depth dimension after padding' dsize",
  "-i 1 0 1 0 1 35x1+5+8.5 2 2 1 1 1 'Padded Time Size   ' 'Size of time dimension after padding' tsize",
  "-i 1 0 1 0 1 35x1+5+9.5 2 2 1 1 1 'Padded Element Size' 'Size of element dimension after padding' esize",
  "-i 1 0 1 2 1 35x1+5+12 0 0 0 1 1 'Width Offset       ' 'Offset of original object in width dimension' woff",
  "-i 1 0 1 2 1 35x1+5+13 0 0 0 1 1 'Height Offset      ' 'Offset of original object in height dimension' hoff",
  "-i 1 0 1 2 1 35x1+5+14 0 0 0 1 1 'Depth Offset       ' 'Offset of original object in depth dimension' doff",
  "-i 1 0 1 2 1 35x1+5+15 0 0 0 1 1 'Time Offset        ' 'Offset of original object in time dimension' toff",
  "-i 1 0 1 2 1 35x1+5+16 0 0 0 1 1 'Element Offset     ' 'Offset of original object in elements dimension' eoff",
  "-h 1 0 1 2 1 35x1+5+18.5 0 0 0 0 1 1 'Real Pad Value     ' 'Real part of pad constant' real",
  "-h 1 0 1 2 1 35x1+5+19.5 0 0 0 0 1 1 'Imaginary Pad Value' 'Imaginary part of pad constant' imag",
  "-t 1 0 1 0 0 30.875x1+5+21.5 'Fill Outside Data Regions by WRAPPING' 'fill outside data regions by WRAPPING' wrap",
  "-l 1 0 1 2 0 50x1+1+23.5 1 'Identify padded data added by this program as  ' 'Invalid' 'Valid' 'Identify data added by kpad as valid/invalid in mask' valid",
  "-O 1 0 0 1 0 1 52x1+0+25 ' ' 'Output' 'Resulting output file' o",
  "-b +1+3.5 'Object Size after Padding: ' b1",
  "-b +1+11 'Offset Applied to Input Object Before Processing:' b3",
  "-b +1+17.5 'Pad Values:' b4",
  "-b +5+4.5 '(object size will not change for unselected dimensions)' b2",
  "-b +5+20.5 '- or -' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kpad/uis/kpad.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	33,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


