 /*
  * Khoros: $Id: kprdata.h,v 1.14.2.2 1997/05/31 18:59:00 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kprdata
   >>>> 
   >>>>    Written By: Donna Koechner
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kprdata_h_
#define _kprdata_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include "kdatamanip/kdatamanip.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input Data Object (required infile)
 */
char	*i_file;	/* Input Data Object FILENAME */
int	 i_flag;	/* Input Data Object FLAG */

/*
 *  Print Object Information & Attributes (optional flag)
 */
int	 attr_flag;  	/* Print Object Information & Attributes FLAG */

/*
 *  Print Location Data (optional flag)
 */
int	 loc_flag;  	/* Print Location Data FLAG */

/*
 *  Print Time Data (optional flag)
 */
int	 time_flag;  	/* Print Time Data FLAG */

/*
 *  Print Value Data (optional flag)
 */
int	 val_flag;  	/* Print Value Data FLAG */

/*
 *  Print Mask Data (optional flag)
 */
int	 mask_flag;  	/* Print Mask Data FLAG */

/*
 *  Print Implicit Indexing (optional flag)
 */
int	 ind_flag;  	/* Print Implicit Indexing FLAG */

/*
 *  Replacement String for Masked Values (optional string)
 */
char	*replace_string;	/* Replacement String for Masked Values STRING */
int	 replace_flag;   	/* Replacement String for Masked Values FLAG */

/*
 *  Resulting Output File (optional outfile)
 */
char	*f_file;	/* Resulting Output File FILENAME */
int	 f_flag;	/* Resulting Output File FLAG */

/*----- optional ME group ----*/
	/*---- nested optional   group ----*/
/*
 *  Print Implicit Map Indexing (optional flag)
 */
int	 mind_flag;  	/* Print Implicit Map Indexing FLAG */

/*
 *  Print Map Data (optional flag)
 */
int	 map_flag;  	/* Print Map Data FLAG */

	/*-- nested optional   group end --*/

/*
 *  Map Value Data Through Map (optional flag)
 */
int	 mval_flag;  	/* Map Value Data Through Map FLAG */

/*-- optional ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void kprdata_get_args PROTO((kaddr));
void kprdata_usage_additions PROTO((void));
void kprdata_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
