 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:59:02 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:59:02 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kprdata.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kprdata_get_args
| 
|       Purpose: Gets command line args for kprdata
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kprdata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kprdata_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kprdata is out of sync with arguments specified in kprdata's *.pane file; please rerun ghostwriter on kprdata.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kprdata structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "attr",
			  &(clui_info->attr_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "loc",
			  &(clui_info->loc_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "time",
			  &(clui_info->time_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "val",
			  &(clui_info->val_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mask",
			  &(clui_info->mask_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ind",
			  &(clui_info->ind_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "replace",
			  &(clui_info->replace_string),
			  &(clui_info->replace_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "f",
			  &(clui_info->f_file),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mind",
			  &(clui_info->mind_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "map",
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mval",
			  &(clui_info->mval_flag))))
	{
	    kerror(NULL, "kprdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Print Data in Formatted ASCII' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Print_Data",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kprdata",
  "-H 1  5x1+41+0 'Help' 'help page for kprdata' $DATAMANIP/objects/kroutine/kprdata/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input Data Object' i",
  "-t 1 0 1 1 0 10x1+5.5+6 'Attributes' 'Print Object Information & Attributes' attr",
  "-t 1 0 1 1 0 8x1+14.5+9.8 ' ' 'Print Location Data' loc",
  "-t 1 0 1 1 0 10x1+23.5+9.8 ' ' 'Print Time Data' time",
  "-t 1 0 1 1 0 10x1+32.5+9.8 ' ' 'Print Value Data' val",
  "-t 1 0 1 1 0 10x1+41.5+9.8 ' ' 'Print Mask Data' mask",
  "-t 1 0 1 1 0 3.5x1+5.5+9.8 ' ' 'Print Implicit Indexing' ind",
  "-s 1 0 1 0 0 49x1+2+16.5 '*' 'Replacement for Masked Values' 'Replacement String for Masked Values' replace",
  "-O 1 0 1 2 0 1 52x1+0+18 ' ' 'Output' 'Resulting Output File' f",
  "-C 0",
  "-K 0",
  "-t 1 0 1 0 0 5.5x1+5.5+13 ' ' 'Print Implicit Map Indexing' mind",
  "-t 1 0 1 0 0 3.125x1+14.5+13 ' ' 'Print Map Data' map",
  "-E",
  "-t 1 0 1 1 0 21.875x1+2+15 'Map Value Data Through Map' 'Map Value Data Through Map' mval",
  "-E",
  "-b +1+4.4 '__________________________' b0",
  "-b +1+4 'Select Data to be Printed:' b01",
  "-b +5+8 'Implicit' b1",
  "-b +5+8.8 'Indexing' b11",
  "-b +14+8 'Location' b2",
  "-b +14+8.8 'Data' b21",
  "-b +23+8 'Time' b3",
  "-b +23+8.8 'Data' b31",
  "-b +32+8 'Value' b4",
  "-b +32+8.8 'Data' b41",
  "-b +41+8 'Mask' b5",
  "-b +41+8.8 'Data' b51",
  "-b +5+11.3 'Map' b6",
  "-b +5+12 'Indexing' b61",
  "-b +14+11.3 'Map' 76",
  "-b +14+12 'Data' b71",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kprdata/uis/kprdata.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	44,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


