 /*
  * Khoros: $Id: kprstats.c,v 1.2.2.2 1997/06/08 15:07:12 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: kprstats.c,v 1.2.2.2 1997/06/08 15:07:12 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for kprstats
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "kprstats.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Print statistics to Cantata variables
|
|       Purpose: main program for kprstats
|
|         Input:
|		char *clui_info->i_file; {First Input data object}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->wmin_var_string; {Name of minimum width variable}
|		int   clui_info->wmin_var_flag; {TRUE if -wmin_var specified}
|
|		char *clui_info->wmax_var_string; {Name of maximum width variable}
|		int   clui_info->wmax_var_flag; {TRUE if -wmax_var specified}
|
|		char *clui_info->hmin_var_string; {Name of minimum height variable}
|		int   clui_info->hmin_var_flag; {TRUE if -hmin_var specified}
|
|		char *clui_info->hmaxvar_string; {Name of maximum height variable}
|		int   clui_info->hmaxvar_flag; {TRUE if -hmaxvar specified}
|
|		char *clui_info->dmin_var_string; {Name of minimum depth variable}
|		int   clui_info->dmin_var_flag; {TRUE if -dmin_var specified}
|
|		char *clui_info->dmax_var_string; {Name of maximum depth variable}
|		int   clui_info->dmax_var_flag; {TRUE if -dmax_var specified}
|
|		char *clui_info->tmin_var_string; {Name of minimum time variable}
|		int   clui_info->tmin_var_flag; {TRUE if -tmin_var specified}
|
|		char *clui_info->tmax_var_string; {Name of maximum time variable}
|		int   clui_info->tmax_var_flag; {TRUE if -tmax_var specified}
|
|		char *clui_info->emin_var_string; {Name of minimum element variable}
|		int   clui_info->emin_var_flag; {TRUE if -emin_var specified}
|
|		char *clui_info->emax_var_string; {Name of maximum element variable}
|		int   clui_info->emax_var_flag; {TRUE if -emax_var specified}
|
|		char *clui_info->minval_var_string; {Name of minimum value variable}
|		int   clui_info->minval_var_flag; {TRUE if -minval_var specified}
|
|		char *clui_info->maxval_var_string; {Name of maximum value variable}
|		int   clui_info->maxval_var_flag; {TRUE if -maxval_var specified}
|
|		char *clui_info->mean_var_string; {Name for mean variable}
|		int   clui_info->mean_var_flag; {TRUE if -mean_var specified}
|
|		char *clui_info->wsize_var_string; {Name of total width variable (KSTATS_WSIZE)}
|		int   clui_info->wsize_var_flag; {TRUE if -wsize_var specified}
|
|		char *clui_info->var_var_string; {Name for variance variable}
|		int   clui_info->var_var_flag; {TRUE if -var_var specified}
|
|		char *clui_info->hsize_var_string; {Name of total height variable (KSTATS_HSIZE)}
|		int   clui_info->hsize_var_flag; {TRUE if -hsize_var specified}
|
|		char *clui_info->sd_var_string; {Name for standard deviation variable}
|		int   clui_info->sd_var_flag; {TRUE if -sd_var specified}
|
|		char *clui_info->dsize_var_string; {Name of total depth variable}
|		int   clui_info->dsize_var_flag; {TRUE if -dsize_var specified}
|
|		char *clui_info->rms_var_string; {Name for rms variable}
|		int   clui_info->rms_var_flag; {TRUE if -rms_var specified}
|
|		char *clui_info->tsize_var_string; {Name of total time variable}
|		int   clui_info->tsize_var_flag; {TRUE if -tsize_var specified}
|
|		char *clui_info->psum_var_string; {Name of positive sum variable}
|		int   clui_info->psum_var_flag; {TRUE if -psum_var specified}
|
|		char *clui_info->esize_var_string; {Name of total element variable}
|		int   clui_info->esize_var_flag; {TRUE if -esize_var specified}
|
|		char *clui_info->nsum_var_string; {Name for negative sum variable}
|		int   clui_info->nsum_var_flag; {TRUE if -nsum_var specified}
|
|		char *clui_info->sum_var_string; {Name for sum variable}
|		int   clui_info->sum_var_flag; {TRUE if -sum_var specified}
|
|		char *clui_info->skew_var_string; {Name for skew variable}
|		int   clui_info->skew_var_flag; {TRUE if -skew_var specified}
|
|		char *clui_info->kur_var_string; {Name for kurtosis variable}
|		int   clui_info->kur_var_flag; {TRUE if -kur_var specified}
|
|		char *clui_info->pts_var_string; {Name for total points variable}
|		int   clui_info->pts_var_flag; {TRUE if -pts_var specified}
|
|		char *clui_info->ppts_var_string; {Name for positive points variable}
|		int   clui_info->ppts_var_flag; {TRUE if -ppts_var specified}
|
|		char *clui_info->npts_var_string; {Name for negative points variable}
|		int   clui_info->npts_var_flag; {TRUE if -npts_var specified}
|
|		char *clui_info->zpts_var_string; {Name for zero-valued points variable}
|		int   clui_info->zpts_var_flag; {TRUE if -zpts_var specified}
|
|        Output:
|       Returns:
|
|    Written By: ghostwriter
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
	char *lib="main", *routine="kprstats";

	kobject in_obj=NULL;		/* input object */
	kobject temp_obj=NULL;		/* temporary output object */
	int limit;
	char *variables[NUMVARS];
	double *data_P;			/* Pointer to preallocated data segment */
	double *data_values;
	int i=0;			/* indexing variable */

	/* region of object for which to get/compute stats.  Always get
	   whole region as this can be specified in another operator. */

	unsigned long stats_region=KSTATS_WIDTH | KSTATS_HEIGHT | KSTATS_DEPTH |
				   KSTATS_TIME | KSTATS_ELEMENT; 

	unsigned long  auxinfo_flag=0;  /* bit pattern flag for auxiliary info to get */
	unsigned long active_stats=0;	/* bit pattern flag for stats to get */
/* -main_variable_list_end */

	khoros_init(argc, argv, "DATAMANIP", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$DATAMANIP/objects/kroutine/kprstats");
	kexit_handler(kprstats_free_args, NULL);

/* -main_get_args_call */
	kclui_init("DATAMANIP", "kprstats", KGEN_KROUTINE,  &clui_uis_spec,
		   kprstats_usage_additions, kprstats_get_args,
 		   kprstats_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
        /* open source object */
        if ((in_obj = kpds_open_input_object(clui_info->i_file))
                 == KOBJECT_INVALID)
        {
           kerror(lib,routine,"unable to open input object %s",clui_info->i_file);
           kexit(KEXIT_FAILURE);
        }
        if ((temp_obj = kpds_create_object()) == KOBJECT_INVALID)
        {
           kerror(lib,routine,"unable to open temporary output object");
           kexit(KEXIT_FAILURE);
        }

	/*
	 * allocate memory for variable[] string array
	 */
	for (i=0; i<NUMVARS; i++)
	{
		if (NULL == (variables[i] = (char *)kmalloc(sizeof(char)*VARLENGTH)))
		{
			kerror(lib, routine, "Unable to allocate memory for variable array");
			kexit(KEXIT_FAILURE);
		}	
	}
	i=0;   /* reset indexing variable */

	/* Combine all flags into active_stats by left shifting and adding.  */

	/*
	 * BE SURE to keep this order the same so the variables[] array is
	 * loaded with variable names in the right order;  otherwise the
	 * data will not correspond to the correct variable name.
	 */

	active_stats |= (clui_info->mean_var_flag)   ? 
		(variables[i++]=clui_info->mean_var_string), 	KSTATS_MEAN    : 0;

	/*
	 * (note to self)
	 * i.e.  OR the value of active_stats with the value of the following
	 * statement:  IF clui_info->mean_var_flag, THEN variables[i]
	 * gets clui_info->mean_var_string, THEN KSTATS_MEAN;  ELSE 0.
	 * Comma operator says the value of the ? statement is KSTATS_MEAN.
	 * Afterward increment i.  Notice that if the flag is not set,
	 * i is not incremented.
	 */

	active_stats |= (clui_info->var_var_flag)    ? 
		(variables[i++]=clui_info->var_var_string), 	KSTATS_VAR     : 0;

	active_stats |= (clui_info->sd_var_flag)     ? 
		(variables[i++]=clui_info->sd_var_string), 		KSTATS_STDDEV  : 0;

	active_stats |= (clui_info->rms_var_flag)    ? 
		(variables[i++]=clui_info->rms_var_string), 	KSTATS_RMS     : 0;

	active_stats |= (clui_info->skew_var_flag)   ? 
		(variables[i++]=clui_info->skew_var_string), 	KSTATS_SKEW    : 0;

	active_stats |= (clui_info->kur_var_flag)    ? 
		(variables[i++]=clui_info->kur_var_string), 	KSTATS_KURT    : 0;

	active_stats |= (clui_info->minval_var_flag) ? 
		(variables[i++]=clui_info->minval_var_string), 	KSTATS_MIN     : 0;

	active_stats |= (clui_info->maxval_var_flag) ? 
		(variables[i++]=clui_info->maxval_var_string), 	KSTATS_MAX     : 0;


	auxinfo_flag |= (clui_info->wmin_var_flag)  ? 
		(variables[i++]=clui_info->wmin_var_string), 	KSTATS_WMIN   : 0;

	auxinfo_flag |= (clui_info->hmin_var_flag)  ? 
		(variables[i++]=clui_info->hmin_var_string), 	KSTATS_HMIN   : 0;

	auxinfo_flag |= (clui_info->dmin_var_flag)  ? 
		(variables[i++]=clui_info->dmin_var_string), 	KSTATS_DMIN   : 0;

	auxinfo_flag |= (clui_info->tmin_var_flag)  ? 
		(variables[i++]=clui_info->tmin_var_string), 	KSTATS_TMIN   : 0;

	auxinfo_flag |= (clui_info->emin_var_flag)  ? 
		(variables[i++]=clui_info->emin_var_string), 	KSTATS_EMIN   : 0;

	auxinfo_flag |= (clui_info->wmax_var_flag)  ? 
		(variables[i++]=clui_info->wmax_var_string), 	KSTATS_WMAX   : 0;

	auxinfo_flag |= (clui_info->hmaxvar_flag)   ? 
		(variables[i++]=clui_info->hmaxvar_string), 	KSTATS_HMAX   : 0;

	auxinfo_flag |= (clui_info->dmax_var_flag)  ? 
		(variables[i++]=clui_info->dmax_var_string), 	KSTATS_DMAX   : 0;

	auxinfo_flag |= (clui_info->tmax_var_flag)  ? 
		(variables[i++]=clui_info->tmax_var_string), 	KSTATS_TMAX   : 0;

	auxinfo_flag |= (clui_info->emax_var_flag)  ? 
		(variables[i++]=clui_info->emax_var_string), 	KSTATS_EMAX   : 0;


	active_stats |= (clui_info->sum_var_flag)    ? 
		(variables[i++]=clui_info->sum_var_string), 	KSTATS_SUM     : 0;

	active_stats |= (clui_info->psum_var_flag)   ? 
		(variables[i++]=clui_info->psum_var_string), 	KSTATS_POSSUM  : 0;

	active_stats |= (clui_info->nsum_var_flag)   ? 
		(variables[i++]=clui_info->nsum_var_string), 	KSTATS_NEGSUM  : 0;

	active_stats |= (clui_info->pts_var_flag)    ? 
		(variables[i++]=clui_info->pts_var_string), 	KSTATS_PTS     : 0;

	active_stats |= (clui_info->ppts_var_flag)   ? 
		(variables[i++]=clui_info->ppts_var_string), 	KSTATS_POSPTS  : 0;

	active_stats |= (clui_info->npts_var_flag)   ?
		(variables[i++]=clui_info-> npts_var_string), 	KSTATS_NEGPTS  : 0;

	active_stats |= (clui_info->zpts_var_flag)   ?
		(variables[i++]=clui_info-> zpts_var_string), 	KSTATS_ZEROPTS : 0;


	auxinfo_flag |= (clui_info->wsize_var_flag) ? 
		(variables[i++]=clui_info->wsize_var_string), 	KSTATS_WSIZE  : 0;

	auxinfo_flag |= (clui_info->hsize_var_flag) ? 
		(variables[i++]=clui_info->hsize_var_string), 	KSTATS_HSIZE  : 0;

	auxinfo_flag |= (clui_info->dsize_var_flag) ? 
		(variables[i++]=clui_info->dsize_var_string), 	KSTATS_DSIZE  : 0;

	auxinfo_flag |= (clui_info->tsize_var_flag) ? 
		(variables[i++]=clui_info->tsize_var_string), 	KSTATS_TSIZE  : 0;

	auxinfo_flag |= (clui_info->esize_var_flag) ? 
		(variables[i++]=clui_info->esize_var_string), 	KSTATS_ESIZE  : 0;
	limit=i;
/* -main_before_lib_call_end */

/* -main_library_call */
	if (!lkstats(in_obj, NULL, temp_obj, active_stats, auxinfo_flag, stats_region,
				  NULL, 0))
        {
           kpds_close_object(in_obj);
		   kerror(lib,routine, "lkstats seems to have failed.  Cannot get statistics.");
           kexit(KEXIT_FAILURE);
        }
/* -main_library_call_end */

/* -main_after_lib_call */
	if (!kpds_query_value(temp_obj)) 
	{
		kerror(lib, routine, "No value segment in temporary output object.");
		kexit(KEXIT_FAILURE);
    }
 
	data_P = (double *) kpds_get_data(temp_obj, KPDS_VALUE_ALL, NULL);

	data_values = data_P;

	/* write out variables to Cantata */

	for (i=0; i<limit; ++i)
	{
		kprintf("%s = %g\n", variables[i], *data_values++);
	}
	kfree(data_P);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: kprstats_usage_additions
| 
|       Purpose: Prints usage additions in kprstats_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kprstats
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kprstats_usage_additions(void)
{
	kfprintf(kstderr, "\tPrint statistics to Cantata variables\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: kprstats_free_args
| 
|       Purpose: Frees CLUI struct allocated in kprstats_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kprstats
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
kprstats_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->wmin_var_string);
		kfree_and_NULL(clui_info->wmax_var_string);
		kfree_and_NULL(clui_info->hmin_var_string);
		kfree_and_NULL(clui_info->hmaxvar_string);
		kfree_and_NULL(clui_info->dmin_var_string);
		kfree_and_NULL(clui_info->dmax_var_string);
		kfree_and_NULL(clui_info->tmin_var_string);
		kfree_and_NULL(clui_info->tmax_var_string);
		kfree_and_NULL(clui_info->emin_var_string);
		kfree_and_NULL(clui_info->emax_var_string);
		kfree_and_NULL(clui_info->minval_var_string);
		kfree_and_NULL(clui_info->maxval_var_string);
		kfree_and_NULL(clui_info->mean_var_string);
		kfree_and_NULL(clui_info->wsize_var_string);
		kfree_and_NULL(clui_info->var_var_string);
		kfree_and_NULL(clui_info->hsize_var_string);
		kfree_and_NULL(clui_info->sd_var_string);
		kfree_and_NULL(clui_info->dsize_var_string);
		kfree_and_NULL(clui_info->rms_var_string);
		kfree_and_NULL(clui_info->tsize_var_string);
		kfree_and_NULL(clui_info->psum_var_string);
		kfree_and_NULL(clui_info->esize_var_string);
		kfree_and_NULL(clui_info->nsum_var_string);
		kfree_and_NULL(clui_info->sum_var_string);
		kfree_and_NULL(clui_info->skew_var_string);
		kfree_and_NULL(clui_info->kur_var_string);
		kfree_and_NULL(clui_info->pts_var_string);
		kfree_and_NULL(clui_info->ppts_var_string);
		kfree_and_NULL(clui_info->npts_var_string);
		kfree_and_NULL(clui_info->zpts_var_string);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
