 /*
  * Khoros: $Id: kprstats.h,v 1.2.2.1 1997/06/08 15:07:14 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kprstats
   >>>> 
   >>>>    Written By: ghostwriter
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kprstats_h_
#define _kprstats_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
#define NUMVARS 40
#define VARLENGTH 25
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  First Input data object (required infile)
 */
char	*i_file;	/* First Input data object FILENAME */
int	 i_flag;	/* First Input data object FLAG */

/*
 *  Name of minimum width variable (optional string)
 */
char	*wmin_var_string;	/* Name of minimum width variable STRING */
int	 wmin_var_flag;   	/* Name of minimum width variable FLAG */

/*
 *  Name of maximum width variable (optional string)
 */
char	*wmax_var_string;	/* Name of maximum width variable STRING */
int	 wmax_var_flag;   	/* Name of maximum width variable FLAG */

/*
 *  Name of minimum height variable (optional string)
 */
char	*hmin_var_string;	/* Name of minimum height variable STRING */
int	 hmin_var_flag;   	/* Name of minimum height variable FLAG */

/*
 *  Name of maximum height variable (optional string)
 */
char	*hmaxvar_string;	/* Name of maximum height variable STRING */
int	 hmaxvar_flag;   	/* Name of maximum height variable FLAG */

/*
 *  Name of minimum depth variable (optional string)
 */
char	*dmin_var_string;	/* Name of minimum depth variable STRING */
int	 dmin_var_flag;   	/* Name of minimum depth variable FLAG */

/*
 *  Name of maximum depth variable (optional string)
 */
char	*dmax_var_string;	/* Name of maximum depth variable STRING */
int	 dmax_var_flag;   	/* Name of maximum depth variable FLAG */

/*
 *  Name of minimum time variable (optional string)
 */
char	*tmin_var_string;	/* Name of minimum time variable STRING */
int	 tmin_var_flag;   	/* Name of minimum time variable FLAG */

/*
 *  Name of maximum time variable (optional string)
 */
char	*tmax_var_string;	/* Name of maximum time variable STRING */
int	 tmax_var_flag;   	/* Name of maximum time variable FLAG */

/*
 *  Name of minimum element variable (optional string)
 */
char	*emin_var_string;	/* Name of minimum element variable STRING */
int	 emin_var_flag;   	/* Name of minimum element variable FLAG */

/*
 *  Name of maximum element variable (optional string)
 */
char	*emax_var_string;	/* Name of maximum element variable STRING */
int	 emax_var_flag;   	/* Name of maximum element variable FLAG */

/*
 *  Name of minimum value variable (optional string)
 */
char	*minval_var_string;	/* Name of minimum value variable STRING */
int	 minval_var_flag;   	/* Name of minimum value variable FLAG */

/*
 *  Name of maximum value variable (optional string)
 */
char	*maxval_var_string;	/* Name of maximum value variable STRING */
int	 maxval_var_flag;   	/* Name of maximum value variable FLAG */

/*
 *  Name for mean variable (optional string)
 */
char	*mean_var_string;	/* Name for mean variable STRING */
int	 mean_var_flag;   	/* Name for mean variable FLAG */

/*
 *  Name of total width variable (KSTATS_WSIZE) (optional string)
 */
char	*wsize_var_string;	/* Name of total width variable (KSTATS_WSIZE) STRING */
int	 wsize_var_flag;   	/* Name of total width variable (KSTATS_WSIZE) FLAG */

/*
 *  Name for variance variable (optional string)
 */
char	*var_var_string;	/* Name for variance variable STRING */
int	 var_var_flag;   	/* Name for variance variable FLAG */

/*
 *  Name of total height variable (KSTATS_HSIZE) (optional string)
 */
char	*hsize_var_string;	/* Name of total height variable (KSTATS_HSIZE) STRING */
int	 hsize_var_flag;   	/* Name of total height variable (KSTATS_HSIZE) FLAG */

/*
 *  Name for standard deviation variable (optional string)
 */
char	*sd_var_string;	/* Name for standard deviation variable STRING */
int	 sd_var_flag;   	/* Name for standard deviation variable FLAG */

/*
 *  Name of total depth variable (optional string)
 */
char	*dsize_var_string;	/* Name of total depth variable STRING */
int	 dsize_var_flag;   	/* Name of total depth variable FLAG */

/*
 *  Name for rms variable (optional string)
 */
char	*rms_var_string;	/* Name for rms variable STRING */
int	 rms_var_flag;   	/* Name for rms variable FLAG */

/*
 *  Name of total time variable (optional string)
 */
char	*tsize_var_string;	/* Name of total time variable STRING */
int	 tsize_var_flag;   	/* Name of total time variable FLAG */

/*
 *  Name of positive sum variable (optional string)
 */
char	*psum_var_string;	/* Name of positive sum variable STRING */
int	 psum_var_flag;   	/* Name of positive sum variable FLAG */

/*
 *  Name of total element variable (optional string)
 */
char	*esize_var_string;	/* Name of total element variable STRING */
int	 esize_var_flag;   	/* Name of total element variable FLAG */

/*
 *  Name for negative sum variable (optional string)
 */
char	*nsum_var_string;	/* Name for negative sum variable STRING */
int	 nsum_var_flag;   	/* Name for negative sum variable FLAG */

/*
 *  Name for sum variable (optional string)
 */
char	*sum_var_string;	/* Name for sum variable STRING */
int	 sum_var_flag;   	/* Name for sum variable FLAG */

/*
 *  Name for skew variable (optional string)
 */
char	*skew_var_string;	/* Name for skew variable STRING */
int	 skew_var_flag;   	/* Name for skew variable FLAG */

/*
 *  Name for kurtosis variable (optional string)
 */
char	*kur_var_string;	/* Name for kurtosis variable STRING */
int	 kur_var_flag;   	/* Name for kurtosis variable FLAG */

/*
 *  Name for total points variable (optional string)
 */
char	*pts_var_string;	/* Name for total points variable STRING */
int	 pts_var_flag;   	/* Name for total points variable FLAG */

/*
 *  Name for positive points variable (optional string)
 */
char	*ppts_var_string;	/* Name for positive points variable STRING */
int	 ppts_var_flag;   	/* Name for positive points variable FLAG */

/*
 *  Name for negative points variable (optional string)
 */
char	*npts_var_string;	/* Name for negative points variable STRING */
int	 npts_var_flag;   	/* Name for negative points variable FLAG */

/*
 *  Name for zero-valued points variable (optional string)
 */
char	*zpts_var_string;	/* Name for zero-valued points variable STRING */
int	 zpts_var_flag;   	/* Name for zero-valued points variable FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void kprstats_get_args PROTO((kaddr));
void kprstats_usage_additions PROTO((void));
void kprstats_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
