 /*
  * Khoros: $Id: usage.c,v 1.2.2.1 1997/06/08 15:07:15 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.2.2.1 1997/06/08 15:07:15 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kprstats.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kprstats_get_args
| 
|       Purpose: Gets command line args for kprstats
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kprstats
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kprstats_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kprstats is out of sync with arguments specified in kprstats's *.pane file; please rerun ghostwriter on kprstats.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kprstats structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "wmin_var",
			  &(clui_info->wmin_var_string),
			  &(clui_info->wmin_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "wmax_var",
			  &(clui_info->wmax_var_string),
			  &(clui_info->wmax_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "hmin_var",
			  &(clui_info->hmin_var_string),
			  &(clui_info->hmin_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "hmaxvar",
			  &(clui_info->hmaxvar_string),
			  &(clui_info->hmaxvar_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "dmin_var",
			  &(clui_info->dmin_var_string),
			  &(clui_info->dmin_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "dmax_var",
			  &(clui_info->dmax_var_string),
			  &(clui_info->dmax_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "tmin_var",
			  &(clui_info->tmin_var_string),
			  &(clui_info->tmin_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "tmax_var",
			  &(clui_info->tmax_var_string),
			  &(clui_info->tmax_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "emin_var",
			  &(clui_info->emin_var_string),
			  &(clui_info->emin_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "emax_var",
			  &(clui_info->emax_var_string),
			  &(clui_info->emax_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "minval_var",
			  &(clui_info->minval_var_string),
			  &(clui_info->minval_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "maxval_var",
			  &(clui_info->maxval_var_string),
			  &(clui_info->maxval_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "mean_var",
			  &(clui_info->mean_var_string),
			  &(clui_info->mean_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "wsize_var",
			  &(clui_info->wsize_var_string),
			  &(clui_info->wsize_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "var_var",
			  &(clui_info->var_var_string),
			  &(clui_info->var_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "hsize_var",
			  &(clui_info->hsize_var_string),
			  &(clui_info->hsize_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "sd_var",
			  &(clui_info->sd_var_string),
			  &(clui_info->sd_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "dsize_var",
			  &(clui_info->dsize_var_string),
			  &(clui_info->dsize_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "rms_var",
			  &(clui_info->rms_var_string),
			  &(clui_info->rms_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "tsize_var",
			  &(clui_info->tsize_var_string),
			  &(clui_info->tsize_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "psum_var",
			  &(clui_info->psum_var_string),
			  &(clui_info->psum_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "esize_var",
			  &(clui_info->esize_var_string),
			  &(clui_info->esize_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "nsum_var",
			  &(clui_info->nsum_var_string),
			  &(clui_info->nsum_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "sum_var",
			  &(clui_info->sum_var_string),
			  &(clui_info->sum_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "skew_var",
			  &(clui_info->skew_var_string),
			  &(clui_info->skew_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "kur_var",
			  &(clui_info->kur_var_string),
			  &(clui_info->kur_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "pts_var",
			  &(clui_info->pts_var_string),
			  &(clui_info->pts_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "ppts_var",
			  &(clui_info->ppts_var_string),
			  &(clui_info->ppts_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "npts_var",
			  &(clui_info->npts_var_string),
			  &(clui_info->npts_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "zpts_var",
			  &(clui_info->zpts_var_string),
			  &(clui_info->zpts_var_flag))))
	{
	    kerror(NULL, "kprstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Print statistics to Cantata variables' subform",
  "-P 1 0 52x25+0+1 +0+0 ' ' kprstats",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 4 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kprstats",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kprstats/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "-s 1 0 1 0 0 24x1+7+5 'width_min' ' ' 'Name of minimum width variable' wmin_var",
  "-s 1 0 1 0 0 24x1+44+5 'width_max' ' ' 'Name of maximum width variable' wmax_var",
  "-s 1 0 1 0 0 24x1+7+6 'height_min' ' ' 'Name of minimum height variable' hmin_var",
  "-s 1 0 1 0 0 24x1+44+6 'height_max' ' ' 'Name of maximum height variable' hmaxvar",
  "-s 1 0 1 0 0 24x1+7+7 'depth_min' ' ' 'Name of minimum depth variable' dmin_var",
  "-s 1 0 1 0 0 24x1+44+7 'depth_max' ' ' 'Name of maximum depth variable' dmax_var",
  "-s 1 0 1 0 0 24x1+7+8 'time_min' ' ' 'Name of minimum time variable' tmin_var",
  "-s 1 0 1 0 0 24x1+44+8 'time_max' ' ' 'Name of maximum time variable' tmax_var",
  "-s 1 0 1 0 0 24x1+7+9 'elem_min' ' ' 'Name of minimum element variable' emin_var",
  "-s 1 0 1 0 0 24x1+44+9 'elem_max' ' ' 'Name of maximum element variable' emax_var",
  "-s 1 0 1 0 0 24x1+7+10 'val_min' ' ' 'Name of minimum value variable' minval_var",
  "-s 1 0 1 0 0 24x1+44+10 'val_max' ' ' 'Name of maximum value variable' maxval_var",
  "-s 1 0 1 0 0 24x1+14+14 'mean' ' ' 'Name for mean variable' mean_var",
  "-s 1 0 1 0 0 24x1+48+14.5 'width_size' ' ' 'Name of total width variable (KSTATS_WSIZE)' wsize_var",
  "-s 1 0 1 0 0 24x1+14+15 'variance' ' ' 'Name for variance variable' var_var",
  "-s 1 0 1 0 0 24x1+48+15.5 'height_size' ' ' 'Name of total height variable (KSTATS_HSIZE)' hsize_var",
  "-s 1 0 1 0 0 24x1+14+16 'std_dev' ' ' 'Name for standard deviation variable' sd_var",
  "-s 1 0 1 0 0 24x1+48+16.5 'depth_size' ' ' 'Name of total depth variable' dsize_var",
  "-s 1 0 1 0 0 24x1+14+17 'rms' ' ' 'Name for rms variable' rms_var",
  "-s 1 0 1 0 0 24x1+48+17.5 'time_size' ' ' 'Name of total time variable' tsize_var",
  "-s 1 0 1 0 0 24x1+14+18 'psum' ' ' 'Name of positive sum variable' psum_var",
  "-s 1 0 1 0 0 24x1+48+18.5 'elem_size' ' ' 'Name of total element variable' esize_var",
  "-s 1 0 1 0 0 24x1+14+19 'nsum' ' ' 'Name for negative sum variable' nsum_var",
  "-s 1 0 1 0 0 24x1+14+20 'sum' ' ' 'Name for sum variable' sum_var",
  "-s 1 0 1 0 0 24x1+14+21 'skew' ' ' 'Name for skew variable' skew_var",
  "-s 1 0 1 0 0 24x1+14+22 'kurtosis' ' ' 'Name for kurtosis variable' kur_var",
  "-s 1 0 1 0 0 24x1+14+23 'total_pts' ' ' 'Name for total points variable' pts_var",
  "-s 1 0 1 0 0 24x1+14+24 'pos_pts' ' ' 'Name for positive points variable' ppts_var",
  "-s 1 0 1 0 0 24x1+14+25 'neg_pts' ' ' 'Name for negative points variable' npts_var",
  "-s 1 0 1 0 0 24x1+14+26 'zero_pts' ' ' 'Name for zero-valued points variable' zpts_var",
  "-b +0+5 'Width' w",
  "-b +0+6 'Height' h",
  "-b +36+6 'Height' h0",
  "-b +36+5 'Width' w1",
  "-b +0+7 'Depth' d",
  "-b +0+8 'Time' t",
  "-b +0+9 'Element' e",
  "-b +0+10 'Value' val",
  "-b +36+8 'Time' t2",
  "-b +36+7 'Depth' d3",
  "-b +36+9 'Element' e4",
  "-b +36+10 'Value' val5",
  "-b +0+4 'Attribute' attr",
  "-b +14+4 'Variable name' varname",
  "-b +36+4 'Attribute' attr6",
  "-b +54+4 'Variable name' varname7",
  "-b +19+13 'Variable name' varname8",
  "-b +0+13 'Calculation' calc",
  "-b +0+18 'Positive sum' psum",
  "-b +0+19 'Negative sum' nsum",
  "-b +0+17 'RMS' rms",
  "-b +0+23 'Total points' total",
  "-b +0+25 'Negative Points' npts",
  "-b +0+24 'Positive Points' ppts",
  "-b +0+14 'Mean' mean",
  "-b +0+15 'Variance' variance",
  "-b +0+21 'Skew' skew",
  "-b +0+22 'Kurtosis' kur",
  "-b +0+20 'Sum' sum",
  "-b +0+11.5 'Calculations:' calc_label",
  "-b +0+3 'Minima:' minima_label",
  "-b +36+3 'Maxima:' maxima_label",
  "-b +39+12 'Size Attributes' size_label",
  "-b +39+13 'Attribute' attr0",
  "-b +58+13 'Variable name' varname71",
  "-b +40+14.5 'Width' w18",
  "-b +40+15.5 'Height' h09",
  "-b +40+16.5 'Depth' d310",
  "-b +40+17.5 'Time' t211",
  "-b +40+18.5 'Element' e412",
  "-b +0+16 'Standard Deviation' std_dev",
  "-b +0+26 'Zero Points' zpts",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
  61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
  81,82,83,84,85,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kprstats/uis/kprstats.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	85,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


