 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:59:37 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:59:37 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kprval.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kprval_get_args
| 
|       Purpose: Gets command line args for kprval
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kprval
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kprval_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kprval is out of sync with arguments specified in kprval's *.pane file; please rerun ghostwriter on kprval.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kprval structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "mapdata",
			  &(clui_info->mapdata_logic),
			  &(clui_info->mapdata_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "woff",
			  &(clui_info->woff_int),
			  &(clui_info->woff_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hoff",
			  &(clui_info->hoff_int),
			  &(clui_info->hoff_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "doff",
			  &(clui_info->doff_int),
			  &(clui_info->doff_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "toff",
			  &(clui_info->toff_int),
			  &(clui_info->toff_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "eoff",
			  &(clui_info->eoff_int),
			  &(clui_info->eoff_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "var",
			  &(clui_info->var_string),
			  &(clui_info->var_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "val",
			  &(clui_info->val_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "map",
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mask",
			  &(clui_info->mask_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "time",
			  &(clui_info->time_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "loc",
			  &(clui_info->loc_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dimoff",
			  &(clui_info->dimoff_int),
			  &(clui_info->dimoff_flag))))
	{
	    kerror(NULL, "kprval_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Print Data Value to Parser and/or Concatenate to File' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kprval",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $DATAMANIP/repos/license/License license",
  "-E",
  "-R 1 0 4 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kprval",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kprval/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input data object' i",
  "-l 1 0 1 2 0 38x1+5+6 0 'If Object has Map, Perform Mapping First ' 'No' 'Yes' 'map value data through the map before processing' mapdata",
  "-i 1 0 1 2 0 44x1+5+10.5 1 1 0 0 0 'Width    ' 'offset of point along width dimension' woff",
  "-i 1 0 1 2 0 44x1+5+11.5 1 1 0 0 0 'Height   ' 'offset of point along height dimension' hoff",
  "-i 1 0 1 2 0 44x1+5+12.5 1 1 0 0 0 'Depth    ' 'offset of point along depth dimension' doff",
  "-i 1 0 1 2 0 44x1+5+13.5 1 1 0 0 0 'Time     ' 'offset of point along time dimension' toff",
  "-i 1 0 1 2 0 44x1+5+14.5 1 1 0 0 0 'Elements ' 'offset of point along elements dimension' eoff",
  "-s 1 0 1 1 0 51.5x1+0+17.5 ' ' 'Variable Name ' 'Name of variable to which output value is assigned' var",
  "-O 1 0 1 0 0 1 51.5x1+0+18.5 ' ' 'Output File' 'Output ASCII in which to append data value' o",
  "-C 1",
  "-t 1 0 1 1 0 6x1+5+5 'Value Data' 'operate on value data' val",
  "-t 1 0 1 0 0 8.25x1+5+7.5 'Map Data' 'operate on map data' map",
  "-t 1 0 1 0 0 9x1+15+7.5 'Mask Data' 'operate on mask data' mask",
  "-t 1 0 1 0 0 9x1+26+7.5 'Time Data' 'operate on time data' time",
  "-B 0",
  "-t 1 0 1 0 0 12x1+37+7.5 'Location Data' 'operate on location data' loc",
  "-i 1 0 1 0 0 44x1+5+15.5 1 1 0 0 0 'Dimension Offset (Location only)' 'offset of point along location dimension' dimoff",
  "-E",
  "-E",
  "-b +2+3.5 'Select Data to be Printed:' blank1",
  "-b +2+9.5 'Specify Position of Data Point:' blank15",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kprval/uis/kprval.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	33,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


