 /*
  * Khoros: $Id: kreal2cmplx.h,v 1.14.2.2 1997/05/31 18:59:51 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for kreal2cmplx
   >>>> 
   >>>>    Written By: Donna Koechner
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _kreal2cmplx_h_
#define _kreal2cmplx_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include <kdatamanip/kdatamanip.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Resulting output data object (required outfile)
 */
char	*o_file;	/* Resulting output data object FILENAME */
int	 o_flag;	/* Resulting output data object FLAG */

/*----- required   group ----*/
/*
 *  Input to be used as real component (optional infile)
 */
char	*i1_file;	/* Input to be used as real component FILENAME */
int	 i1_flag;	/* Input to be used as real component FLAG */

/*
 *  Input to be used as imaginary component (optional infile)
 */
char	*i2_file;	/* Input to be used as imaginary component FILENAME */
int	 i2_flag;	/* Input to be used as imaginary component FLAG */

/*-- required   group end ---*/

/*
 *  Value to be used as real component if no i1, or if padding occurs (optional double)
 */
double	 real_double;	/* Value to be used as real component if no i1, or if padding occurs DOUBLE */
int	 real_flag;   	/* Value to be used as real component if no i1, or if padding occurs FLAG */

/*
 *  Value to be used as imaginary component if no i2, or if padding occurs (optional double)
 */
double	 imag_double;	/* Value to be used as imaginary component if no i2, or if padding occurs DOUBLE */
int	 imag_flag;   	/* Value to be used as imaginary component if no i2, or if padding occurs FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void kreal2cmplx_get_args PROTO((kaddr));
void kreal2cmplx_usage_additions PROTO((void));
void kreal2cmplx_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
