 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:59:53 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:59:53 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kreal2cmplx.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kreal2cmplx_get_args
| 
|       Purpose: Gets command line args for kreal2cmplx
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kreal2cmplx
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kreal2cmplx_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kreal2cmplx is out of sync with arguments specified in kreal2cmplx's *.pane file; please rerun ghostwriter on kreal2cmplx.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kreal2cmplx structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "kreal2cmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "kreal2cmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kreal2cmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "kreal2cmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "kreal2cmplx_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Output = Input 1 + j(Input 2)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kreal2cmplx",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kreal2cmplx",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kreal2cmplx/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-h 1 0 1 0 1 35x1+0+3 0 0 0 0 0 0 ' Real Constant      ' 'Value to be used as real component if no i1, or if padding occurs' real",
  "-h 1 0 1 1 1 35x1+0+5.5 0 0 0 0 0 0 ' Imaginary Constant ' 'Value to be used as imaginary component if no i2, or if padding occurs' imag",
  "-O 1 0 0 1 0 1 52x1+0+7.5 ' ' 'Output' 'Resulting output data object' o",
  "-K 1",
  "-I 1 0 1 1 0 1 52x1+0+2 ' ' 'Real Input      ' 'Input to be used as real component' i1",
  "-I 1 0 1 0 0 1 52x1+0+4.5 ' ' 'Imaginary Input' 'Input to be used as imaginary component' i2",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kreal2cmplx/uis/kreal2cmplx.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


