 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:00:10 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:00:10 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kreplace.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kreplace_get_args
| 
|       Purpose: Gets command line args for kreplace
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kreplace
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kreplace_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kreplace is out of sync with arguments specified in kreplace's *.pane file; please rerun ghostwriter on kreplace.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kreplace structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kreplace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "oval",
			  &(clui_info->oval_double),
			  &(clui_info->oval_flag))))
	{
	    kerror(NULL, "kreplace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "nval",
			  &(clui_info->nval_double),
			  &(clui_info->nval_flag))))
	{
	    kerror(NULL, "kreplace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "utol",
			  &(clui_info->utol_double),
			  &(clui_info->utol_flag))))
	{
	    kerror(NULL, "kreplace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ltol",
			  &(clui_info->ltol_double),
			  &(clui_info->ltol_flag))))
	{
	    kerror(NULL, "kreplace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kreplace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Replace All Occurrences of X with Y' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kreplace",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kreplace",
  "-H 1  5x1+41+0 'Help' 'help page for kreplace' $DATAMANIP/objects/kroutine/kreplace/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input file' i",
  "-h 1 0 0 1 1 38x1+2+4 0 0 0 0 0 0 'Value to be Replaced (X) ' 'Value to be replaced (X)' oval",
  "-h 1 0 0 1 1 38x1+2+5 0 0 0 0 0 0 'Replacement Value    (Y) ' 'New value to be substituted (Y)' nval",
  "-h 1 0 1 0 1 44x1+4+8 0 0 0 0 0 0 'Upper Tolerance Allowed ' 'Upper tolerance allowed in searched value' utol",
  "-h 1 0 1 0 1 44x1+4+9 0 0 0 0 0 0 'Lower Tolerance Allowed ' 'Lower tolerance allowed in searched value' ltol",
  "-O 1 0 0 1 0 1 52x1+0+11 ' ' ' Output ' 'Output file' o",
  "-b +2+7 'Allowed tolerance in searched value' b2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kreplace/uis/kreplace.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


