 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:00:27 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:00:27 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kresample.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kresample_get_args
| 
|       Purpose: Gets command line args for kresample
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kresample
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kresample_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kresample is out of sync with arguments specified in kresample's *.pane file; please rerun ghostwriter on kresample.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kresample structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wmag",
			  &(clui_info->wmag_double),
			  &(clui_info->wmag_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hmag",
			  &(clui_info->hmag_double),
			  &(clui_info->hmag_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dmag",
			  &(clui_info->dmag_double),
			  &(clui_info->dmag_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tmag",
			  &(clui_info->tmag_double),
			  &(clui_info->tmag_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "emag",
			  &(clui_info->emag_double),
			  &(clui_info->emag_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "inter", KVF_LIST_LABEL,
			  &(clui_info->inter_label),
			  &(clui_info->inter_flag)) &&
	      kclui_get_value(pane, "inter", KVF_LIST_VAL,
			  &(clui_info->inter_list),
			  &(clui_info->inter_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "resize",
			  &(clui_info->resize_logic),
			  &(clui_info->resize_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "center",
			  &(clui_info->center_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wc",
			  &(clui_info->wc_int),
			  &(clui_info->wc_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hc",
			  &(clui_info->hc_int),
			  &(clui_info->hc_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dc",
			  &(clui_info->dc_int),
			  &(clui_info->dc_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tc",
			  &(clui_info->tc_int),
			  &(clui_info->tc_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "ec",
			  &(clui_info->ec_int),
			  &(clui_info->ec_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Resample Object Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Resample_Object",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kresample",
  "-H 1  5x1+41+0 'Help' 'man page for kresample' $DATAMANIP/objects/kroutine/kresample/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input Object' i",
  "-h 1 0 1 2 1 37x1+6+5 2 2 1 0 1 0 'Width factor       ' 'Magnification in the width dimension' wmag",
  "-h 1 0 1 2 1 37x1+6+6 2 2 1 0 1 0 'Height factor      ' 'Magnification in the height dimension' hmag",
  "-h 1 0 1 2 1 37x1+6+7 2 2 1 0 1 0 'Depth factor       ' 'Magnification in the depth dimension' dmag",
  "-h 1 0 1 2 1 37x1+6+8 2 2 1 0 1 0 'Time factor        ' 'Magnification in the time dimension' tmag",
  "-h 1 0 1 2 1 37x1+6+9 2 2 1 0 1 0 'Elements factor    ' 'Magnification in the elements dimension' emag",
  "-x 1 0 1 2 0 35x1+1+11 2 0 0 'Interpolation Type ' 'Interpolation Type' inter 'Pixel Replication' 'Bilinear'",
  "-l 1 0 1 2 0 24.5x1+1+13 1 'Resize dimensions? ' 'No' 'Yes' 'resize dimensions of object to the expanded/shrunk size' resize",
  "-t 1 0 1 1 0 46.625x1+3+15.5 'Place COA in middle of dimensions (unless overridden below)' 'center' center",
  "-i 1 0 1 0 1 40x1+3+16.5 1 1 0 0 0 'Width    Coordinate of COA ' 'Width coordinate for the center of action' wc",
  "-i 1 0 1 0 1 40x1+3+17.5 1 1 0 0 0 'Height   Coordinate of COA ' 'Height coordinate for the center of action' hc",
  "-i 1 0 1 0 1 40x1+3+18.5 1 1 0 0 0 'Depth    Coordinate of COA ' 'Depth coordinate for the center of action' dc",
  "-i 1 0 1 0 1 40x1+3+19.5 1 1 0 0 0 'Time     Coordinate of COA ' 'Time coordinate for the center of action' tc",
  "-i 1 0 1 0 1 40x1+3+20.5 1 1 0 0 0 'Elements Coordinate of COA ' 'Elements coordinate for the center of action' ec",
  "-O 1 0 0 1 0 1 52x1+0+22.5 ' ' 'Output' 'Resulting output object' o",
  "-b +1+4 'Magnification factors (>1 is magnify, <1 is reduce):' b4",
  "-b +3+14.5 'If Resize = NO, Specify Center-Of-Action Coordinates:' b2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kresample/uis/kresample.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	29,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


