 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:01:04 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:01:04 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ksampline.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ksampline_get_args
| 
|       Purpose: Gets command line args for ksampline
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ksampline
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ksampline_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ksampline is out of sync with arguments specified in ksampline's *.pane file; please rerun ghostwriter on ksampline.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ksampline structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wc1",
			  &(clui_info->wc1_double),
			  &(clui_info->wc1_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wc2",
			  &(clui_info->wc2_double),
			  &(clui_info->wc2_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hc1",
			  &(clui_info->hc1_double),
			  &(clui_info->hc1_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hc2",
			  &(clui_info->hc2_double),
			  &(clui_info->hc2_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dc1",
			  &(clui_info->dc1_double),
			  &(clui_info->dc1_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dc2",
			  &(clui_info->dc2_double),
			  &(clui_info->dc2_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tc1",
			  &(clui_info->tc1_double),
			  &(clui_info->tc1_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tc2",
			  &(clui_info->tc2_double),
			  &(clui_info->tc2_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ec1",
			  &(clui_info->ec1_double),
			  &(clui_info->ec1_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ec2",
			  &(clui_info->ec2_double),
			  &(clui_info->ec2_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "nc",
			  &(clui_info->nc_int),
			  &(clui_info->nc_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "ksampline_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Sample a data object along an arbitrary line' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' ksampline",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $DATAMANIP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/ksampline",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/ksampline/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'input data object' i",
  "-h 1 0 1 1 0 19.5x1+6+6.5 0 0 0 0 0 0 'Width ' 'coordinate of start of line along W axis' wc1",
  "-h 1 0 1 1 0 20x1+31+6.5 0 0 511 0 0 0 'Width ' 'coordinate of end of line along W axis' wc2",
  "-h 1 0 1 1 0 20x1+6+8 0 0 0 0 0 0 'Height' 'coordinate of start of line along H axis' hc1",
  "-h 1 0 1 1 0 20x1+31+8 0 0 511 0 0 0 'Height' 'coordinate of end of line along H axis' hc2",
  "-h 1 0 1 1 0 20x1+6+9.5 0 0 0 0 0 0 'Depth ' 'coordinate of start of line along D axis' dc1",
  "-h 1 0 1 1 0 20x1+31+9.5 0 0 0 0 0 0 'Depth ' 'coordinate of end of line along D axis' dc2",
  "-h 1 0 1 1 0 20x1+6+11 0 0 0 0 0 0 'Time  ' 'coordinate of start of line along T axis' tc1",
  "-h 1 0 1 1 0 20x1+31+11 0 0 0 0 0 0 'Time  ' 'coordinate of end of line along T axis' tc2",
  "-h 1 0 1 1 0 20x1+6+12.5 0 0 0 0 0 0 'Elements' 'coordinate of start of line along E axis' ec1",
  "-h 1 0 1 1 0 20x1+31+12.5 0 0 0 0 0 0 'Elements' 'coordinate of end of line along E axis' ec2",
  "-i 1 0 1 1 0 44.5x1+2+14 0 0 1000 0 0 'Number of samples (including endpoints)' 'number of samples (including endpoints)' n",
  "-i 1 0 1 1 0 45x1+2+15.5 0 32 0 1 0 'Minimum required neighbor count' 'minimum required neighbor count' nc",
  "-O 1 0 0 1 0 1 51.5x1+0+17 ' ' 'Output' 'output data object' o",
  "-b +4+3.5 'Sampling line endpoint coordinates:' blank1",
  "-b +4+5 'Start:' blank2",
  "-b +29+5 'End:' blank3",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/ksampline/uis/ksampline.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	29,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


