 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:01:32 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:01:32 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ksegcmp.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ksegcmp_get_args
| 
|       Purpose: Gets command line args for ksegcmp
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ksegcmp
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ksegcmp_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ksegcmp is out of sync with arguments specified in ksegcmp's *.pane file; please rerun ghostwriter on ksegcmp.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ksegcmp structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cast",
			  &(clui_info->cast_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tol",
			  &(clui_info->tol_double),
			  &(clui_info->tol_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "sat",
			  &(clui_info->sat_logic),
			  &(clui_info->sat_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "oat",
			  &(clui_info->oat_logic),
			  &(clui_info->oat_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "s",
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "psum",
			  &(clui_info->psum_logic),
			  &(clui_info->psum_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pos",
			  &(clui_info->pos_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "i1val",
			  &(clui_info->i1val_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "i1type",
			  &(clui_info->i1type_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "i2val",
			  &(clui_info->i2val_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "i2type",
			  &(clui_info->i2type_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "rt",
			  &(clui_info->rt_logic),
			  &(clui_info->rt_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "var",
			  &(clui_info->var_string),
			  &(clui_info->var_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "all",
			  &(clui_info->all_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "val",
			  &(clui_info->val_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mask",
			  &(clui_info->mask_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "loc",
			  &(clui_info->loc_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "time",
			  &(clui_info->time_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "map",
			  &(clui_info->map_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "segment",
			  &(clui_info->segment_string),
			  &(clui_info->segment_flag))))
	{
	    kerror(NULL, "ksegcmp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compare Attributes & Data of Input 1 and Input 2' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' ksegcmp",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 3 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/ksegcmp",
  "-H 1  5x1+41+0 'Help' 'man page for segment comparison' $DATAMANIP/objects/kroutine/ksegcmp/help help",
  "-Q 1 0 5.5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input #1' 'first input data object' i1",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Input #2' 'second input data object' i2",
  "-t 1 0 1 1 0 33.125x1+2+12.5 'Cast Data to Common Type before Comparing' 'cast data to common type before comparing' cast",
  "-h 1 0 1 1 0 37.375x1+2+13.5 0 0 0 5 0 0 'Comparison Tolerance  +/-' 'tolerance for data comparison' tol",
  "-l 1 0 1 2 0 33.5x1+2+15 0 'Compare Segment Attributes   ' 'False' 'True' 'compare segment level attributes' sat",
  "-l 1 0 1 2 0 33.5x1+2+16 0 'Compare Object Attributes    ' 'False' 'True' 'compare object level attributes' oat",
  "-t 1 0 1 1 0 30.875x1+2+17.5 'Run Silently' 'silent running - do not print to stdout' s",
  "-l 1 0 1 2 0 31.5x1+3+20.5 1 'Print Difference Summary ' 'False' 'True' 'print difference summary' psum",
  "-t 1 0 1 0 0 10.875x1+23+23.5 '[Position]' 'print the position of differing points' pos",
  "-t 1 0 1 0 0 6.125x1+23+24.5 'Value' 'print value from first input for differing points' i1val",
  "-t 1 0 1 0 0 5.375x1+32+24.5 'Type' 'print data type of first input for differing points' i1type",
  "-t 1 0 1 0 0 6.125x1+23+25.5 'Value' 'print value from second input for differing points' i2val",
  "-t 1 0 1 0 0 5.375x1+32+25.5 'Type' 'print data type of second input for differing points' i2type",
  "-O 1 0 1 1 0 1 52x1+0+27 ' ' 'ASCII Output ' 'output ASCII file for summary' o",
  "-l 1 0 1 1 0 46x1+2+29 1 ' Set Exit Status According to Comparison ' 'False' 'True' 'return results as exit status' rt",
  "-s 1 0 1 0 0 45.75x1+2+31.5 'equal' 'Return Results as Cantata Variable ' 'return results to Cantata ' var",
  "-C 0",
  "-t 1 0 1 0 0 25.625x1+5+5.5 'Compare ALL Data Segments' 'compare all data segments' all",
  "-K 0",
  "-t 1 0 1 1 0 6.625x1+5+8 'Value' 'compare value segments' val",
  "-t 1 0 1 0 0 6.875x1+13+8 'Mask' 'compare mask segments' mask",
  "-t 1 0 1 0 0 8.875x1+21+8 'Location' 'compare location segments' loc",
  "-t 1 0 1 0 0 6.875x1+31+8 'Time' 'compare time segments' time",
  "-t 1 0 1 0 0 6.125x1+39+8 'Map ' 'compare map segments' map",
  "-s 1 0 1 0 0 36.25x1+5+10.5 'value' 'Segment Name' 'explicit segment name to compare' segment",
  "-E",
  "-E",
  "-b +2+4.5 'SELECT SEGMENTS TO COMPARE:' blank1",
  "-b +3+7 'OR Compare only the Polymorphic Segments Selected Below:' blank2",
  "-b +5+9.5 'Compare the Explicitly Named Data Segment:' blank3",
  "-b +5+30 'SUCCESS if identical   FAILURE if different ' blank4",
  "-b +1+19.5 'SELECT CONTENTS OF ASCII OUTPUT' blank5",
  "-b +13+25.5 '> Input #2' blank6",
  "-b +13+24.5 '< Input #1' blank7",
  "-b +6+32.5 'TRUE if identical   FALSE if different' blank8",
  "-b +3+22.5 'Print For Each Differing Data Point:' blank9",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/ksegcmp/uis/ksegcmp.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	48,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


