 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:01:58 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:01:58 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ksetdattr.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ksetdattr_get_args
| 
|       Purpose: Gets command line args for ksetdattr
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ksetdattr
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ksetdattr_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ksetdattr is out of sync with arguments specified in ksetdattr's *.pane file; please rerun ghostwriter on ksetdattr.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ksetdattr structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "maskpres", KVF_LIST_LABEL,
			  &(clui_info->maskpres_label),
			  &(clui_info->maskpres_flag)) &&
	      kclui_get_value(pane, "maskpres", KVF_LIST_VAL,
			  &(clui_info->maskpres_list),
			  &(clui_info->maskpres_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wkernel",
			  &(clui_info->wkernel_int),
			  &(clui_info->wkernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tkernel",
			  &(clui_info->tkernel_int),
			  &(clui_info->tkernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hkernel",
			  &(clui_info->hkernel_int),
			  &(clui_info->hkernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "ekernel",
			  &(clui_info->ekernel_int),
			  &(clui_info->ekernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dkernel",
			  &(clui_info->dkernel_int),
			  &(clui_info->dkernel_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "xbegin",
			  &(clui_info->xbegin_double),
			  &(clui_info->xbegin_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "xend",
			  &(clui_info->xend_double),
			  &(clui_info->xend_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ybegin",
			  &(clui_info->ybegin_double),
			  &(clui_info->ybegin_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "yend",
			  &(clui_info->yend_double),
			  &(clui_info->yend_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "zbegin",
			  &(clui_info->zbegin_double),
			  &(clui_info->zbegin_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "zend",
			  &(clui_info->zend_double),
			  &(clui_info->zend_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wpos",
			  &(clui_info->wpos_int),
			  &(clui_info->wpos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wpsize",
			  &(clui_info->wpsize_double),
			  &(clui_info->wpsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hpos",
			  &(clui_info->hpos_int),
			  &(clui_info->hpos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hpsize",
			  &(clui_info->hpsize_double),
			  &(clui_info->hpsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "dpos",
			  &(clui_info->dpos_int),
			  &(clui_info->dpos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "dpsize",
			  &(clui_info->dpsize_double),
			  &(clui_info->dpsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tpos",
			  &(clui_info->tpos_int),
			  &(clui_info->tpos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "tpsize",
			  &(clui_info->tpsize_double),
			  &(clui_info->tpsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "epos",
			  &(clui_info->epos_int),
			  &(clui_info->epos_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "epsize",
			  &(clui_info->epsize_double),
			  &(clui_info->epsize_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "cspace", KVF_LIST_LABEL,
			  &(clui_info->cspace_label),
			  &(clui_info->cspace_flag)) &&
	      kclui_get_value(pane, "cspace", KVF_LIST_VAL,
			  &(clui_info->cspace_list),
			  &(clui_info->cspace_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alpha", KVF_LIST_LABEL,
			  &(clui_info->alpha_label),
			  &(clui_info->alpha_flag)) &&
	      kclui_get_value(pane, "alpha", KVF_LIST_VAL,
			  &(clui_info->alpha_list),
			  &(clui_info->alpha_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "rmasksub",
			  &(clui_info->rmasksub_double),
			  &(clui_info->rmasksub_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imasksub",
			  &(clui_info->imasksub_double),
			  &(clui_info->imasksub_flag))))
	{
	    kerror(NULL, "ksetdattr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Modify Data Object Attributes' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' ksetdattr",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/ksetdattr",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/ksetdattr/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "-x 1 0 1 0 0 44.625x1+3+4.5 2 0 0 'Present Masked Data Values as  ' 'Set the KPDS_MASKED_VALUE_PRESENTATION attribute' maskpres 'Actual Value' 'Substitute Value'",
  "-i 1 0 1 0 0 14x1+10+10 0 0 0 0 0 ' ' 'integer' wkernel",
  "-i 1 0 1 0 0 14x1+34+10 0 0 0 0 0 ' ' 'integer' tkernel",
  "-i 1 0 1 0 0 14x1+10+11 0 0 0 0 0 ' ' 'integer' hkernel",
  "-i 1 0 1 0 0 14x1+34+11 0 0 0 0 0 ' ' 'integer' ekernel",
  "-i 1 0 1 0 0 14x1+10+12 0 0 0 0 0 ' ' 'integer' dkernel",
  "-h 1 0 1 0 0 14x1+10+15.5 0 0 0 0 0 0 ' ' 'Explicit Location Begin for width dimension' xbegin",
  "-h 1 0 1 0 0 14x1+31+15.5 0 0 1 0 0 0 ' ' 'Explicit Location End for width dimension' xend",
  "-h 1 0 1 0 0 14x1+10+16.5 0 0 0 0 0 0 ' ' 'Explicit Location Begin for height dimension' ybegin",
  "-h 1 0 1 0 0 14x1+31+16.5 0 0 1 0 0 0 ' ' 'Explicit Location End for height dimension' yend",
  "-h 1 0 1 0 0 14x1+10+17.5 0 0 0 0 0 0 ' ' 'Explicit Location Begin for depth dimension' zbegin",
  "-h 1 0 1 0 0 14x1+31+17.5 0 0 1 0 0 0 ' ' 'Explicit Location End for depth dimension' zend",
  "-i 1 0 1 0 0 14x1+10+20.5 0 0 0 0 0 ' ' 'Sub-object width position with respect to parent object' wpos",
  "-h 1 0 1 0 0 14x1+31+20.5 2 2 1 0 0 0 ' ' 'World coordinate point size in width dimension' wpsize",
  "-i 1 0 1 0 0 14x1+10+21.5 0 0 0 0 0 ' ' 'Sub-object height position with respect to parent object' hpos",
  "-h 1 0 1 0 0 14x1+31+21.5 2 2 1 0 0 0 ' ' 'World coordinate point size in height dimension' hpsize",
  "-i 1 0 1 0 0 14x1+10+22.5 0 0 0 0 0 ' ' 'Sub-object depth position with respect to parent object' dpos",
  "-h 1 0 1 0 0 14x1+31+22.5 2 2 1 0 0 0 ' ' 'World coordinate point size in depth dimension' dpsize",
  "-i 1 0 1 0 0 14x1+10+23.5 0 0 0 0 0 ' ' 'Sub-object time position with respect to parent object' tpos",
  "-h 1 0 1 0 0 14x1+31+23.5 2 2 1 0 0 0 ' ' 'World coordinate point size in time dimension' tpsize",
  "-i 1 0 1 0 0 14x1+10+24.5 0 0 0 0 0 ' ' 'Sub-object elements position with respect to parent object' epos",
  "-h 1 0 1 0 0 14x1+31+24.5 2 2 1 0 0 0 ' ' 'World coordinate point size in elements dimension' epsize",
  "-x 1 0 1 0 0 25.75x1+3+27 14 1 3 'Colorspace ' 'Set the KCOLOR_COLORSPACE attribute' cspace 'GREY' 'RGB' 'CMY' 'YIQ ' 'HSV ' 'HLS ' 'IHS ' 'XYZ ' 'UVW ' 'UCSUVW ' 'UCSSOW ' 'UCSLab ' 'UCSLuv ' 'USERDEFINED '",
  "-x 1 0 1 0 0 18.75x1+31+27 2 0 0 'Has Alpha  ' 'Set the KCOLOR_HAS_ALPHA attribute' alpha 'FALSE' 'TRUE'",
  "-O 1 0 0 1 0 1 52x1+0+28.5 ' ' 'Output' 'Resulting output data object' o",
  "-b +1+8 'Data Convolution Kernel Attributes:' b10",
  "-b +5+9 'Kernel Origin Coordinates' b42",
  "-b +3+10 'Width' b20137",
  "-b +3+11 'Height' b21148",
  "-b +3+12 'Depth' b22159",
  "-b +27+10 'Time' b231610",
  "-b +27+11 'Elements' b241711",
  "-b +1+26 'Data Object Color Attributes' b7",
  "-b +1+3.5 'Data Object Mask Attributes:' b1",
  "-K 0",
  "-h 1 0 1 0 0 49x1+3+5.5 0 0 0 0 0 0 'Real substitution value for Masked data      ' 'Set the real component of the KPDS_MASK_SUBSTITUTE_VALUE attribute ' rmasksub",
  "-h 1 0 1 0 0 49x1+3+6.5 0 0 0 0 0 0 'Imaginary substitution value for Masked data ' 'Set the imaginary component of the KPDS_MASK_SUBSTITUTE_VALUE attribute ' imasksub",
  "-E",
  "-b +29+19 'Data Object Point Size:' b3",
  "-b +1+19 'Data Object Sub-Object Position:' b6",
  "-b +10+14.5 'Begin' b4",
  "-b +31+14.5 'End' b5",
  "-b +1+13.5 'Data Object Uniform Location Data Attributes:' b2",
  "-b +6+15.5 'X' b20",
  "-b +6+16.5 'Y' b21",
  "-b +6+17.5 'Z' b22",
  "-b +3+20.5 'Width' b2013",
  "-b +3+21.5 'Height' b2114",
  "-b +3+22.5 'Depth' b2215",
  "-b +3+23.5 'Time' b2316",
  "-b +3+24.5 'Elements' b2417",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
  61,62,63,64,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/ksetdattr/uis/ksetdattr.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	64,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


