 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:02:20 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:02:20 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kshot.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kshot_get_args
| 
|       Purpose: Gets command line args for kshot
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kshot
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kshot_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kshot is out of sync with arguments specified in kshot's *.pane file; please rerun ghostwriter on kshot.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kshot structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kshot_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "spikes",
			  &(clui_info->spikes_double),
			  &(clui_info->spikes_flag))))
	{
	    kerror(NULL, "kshot_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "kshot_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "kshot_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kshot_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Introduce Shot Noise in Input Object' subform",
  "-P 1 0 52x1+0+1 +0+0 '  ' Shot",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/kshot",
  "-H 1  5x1+41+0 'Help' 'help page for kshot' $DATAMANIP/objects/kroutine/kshot/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input File' 'Input File' i",
  "-h 1 0 0 1 1 50.75x1+2+3.5 0 100 10 1 1 0 'Points with Spikes (% of total)' 'Percentage of spikes in the output' spikes",
  "-h 1 0 1 2 1 33x1+2+5.5 0 0 255 1 0 0 'Real Spike value     ' 'Real value of spike ' real",
  "-h 1 0 1 2 1 33x1+2+7 0 0 0 1 0 0 'Imaginary Spike value' 'Imaginary value of spike' imag",
  "-O 1 0 0 1 0 1 52x1+0+9 ' ' 'Output File' 'Output File' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kshot/uis/kshot.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


