 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:02:43 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:02:43 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kstats.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kstats_get_args
| 
|       Purpose: Gets command line args for kstats
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kstats
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kstats_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kstats is out of sync with arguments specified in kstats's *.pane file; please rerun ghostwriter on kstats.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kstats structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "igate",
			  &(clui_info->igate_file),
			  &(clui_info->igate_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "f",
			  &(clui_info->f_file),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "whole",
			  &(clui_info->whole_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "w",
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "h",
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "d",
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "t",
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "e",
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "all",
			  &(clui_info->all_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mean",
			  &(clui_info->mean_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sum",
			  &(clui_info->sum_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "var",
			  &(clui_info->var_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wmin",
			  &(clui_info->wmin_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "psum",
			  &(clui_info->psum_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sd",
			  &(clui_info->sd_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hmin",
			  &(clui_info->hmin_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "nsum",
			  &(clui_info->nsum_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "rms",
			  &(clui_info->rms_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dmin",
			  &(clui_info->dmin_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pts",
			  &(clui_info->pts_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "skew",
			  &(clui_info->skew_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tmin",
			  &(clui_info->tmin_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ppts",
			  &(clui_info->ppts_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "kur",
			  &(clui_info->kur_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "emin",
			  &(clui_info->emin_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "npts",
			  &(clui_info->npts_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "minval",
			  &(clui_info->minval_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "zpts",
			  &(clui_info->zpts_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "maxval",
			  &(clui_info->maxval_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wmax",
			  &(clui_info->wmax_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wsize",
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hmax",
			  &(clui_info->hmax_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hsize",
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dmax",
			  &(clui_info->dmax_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "dsize",
			  &(clui_info->dsize_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tmax",
			  &(clui_info->tmax_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tsize",
			  &(clui_info->tsize_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "emax",
			  &(clui_info->emax_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "esize",
			  &(clui_info->esize_flag))))
	{
	    kerror(NULL, "kstats_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute Statistics of Data Object' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kstats",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation ' $DATAMANIPBIN/kstats",
  "-H 1  5x1+41+0 'Help' 'help page for kstats' $DATAMANIP/objects/kroutine/kstats/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input ' 'Input object' i",
  "-I 1 0 1 0 0 1 52x1+0+2.5 ' ' 'Gating Input' 'Gating input data object' igate",
  "-O 1 0 1 0 0 1 52x1+0+24 ' ' 'ASCII Output ' 'Formatted ASCII output file' f",
  "-O 1 0 1 0 0 1 52x1+0+25 ' ' 'Binary Output' 'Binary output statistics file' o",
  "-C 0",
  "-t 1 0 1 1 0 12.875x1+4+20.5 'Whole Data Set' 'compute single set of statistics for entire data set' whole",
  "-K 0",
  "-t 1 0 1 0 0 7.625x1+4+22 'Width  ' 'include width in processing unit' w",
  "-t 1 0 1 0 0 7.625x1+13+22 'Height ' 'include height in processing unit' h",
  "-t 1 0 1 0 0 7.625x1+22+22 'Depth  ' 'include depth in processing unit' d",
  "-t 1 0 1 0 0 7.625x1+31+22 'Time   ' 'include time in processing unit' t",
  "-t 1 0 1 0 0 7.625x1+39+22 'Element' 'include elements in processing unit' e",
  "-E",
  "-E",
  "-C 0",
  "-t 1 0 1 1 0 29.25x1+1+4 'Calculate ALL Statistics' 'compute and store all statistics information' all",
  "-K 0",
  "-t 1 0 1 0 0 12.125x1+1+6 'mean' 'compute mean' mean",
  "-t 1 0 1 0 0 15.375x1+33+6 'total integral' 'compute total integral' sum",
  "-t 1 0 1 0 0 12.125x1+1+7 'variance' 'compute variance' var",
  "-t 1 0 1 0 0 17x1+14+7 'width coordinate' 'store width coordinate of the minimum value' wmin",
  "-t 1 0 1 0 0 17.375x1+33+7 'pos part of integral' 'compute positive part of integral' psum",
  "-t 1 0 1 0 0 12.125x1+1+8 'std deviation' 'compute standard deviation' sd",
  "-t 1 0 1 0 0 17x1+14+8 'height coordinate' 'store height coordinate of the minimum value' hmin",
  "-t 1 0 1 0 0 17.375x1+33+8 'neg part of integral' 'compute negative part of integral' nsum",
  "-t 1 0 1 0 0 12.125x1+1+9 'rms' 'compute root mean square' rms",
  "-t 1 0 1 0 0 17x1+14+9 'depth coordinate' 'store depth coordinate of the minimum value' dmin",
  "-t 1 0 1 0 0 18.875x1+33+9 'total contributing pts' 'compute total number of contributing points' pts",
  "-t 1 0 1 0 0 12.375x1+1+10 'skewness' 'compute skewness' skew",
  "-t 1 0 1 0 0 17x1+14+10 'time coordinate' 'store time coordinate of the minimum value' tmin",
  "-t 1 0 1 0 0 13.875x1+33+10 'positive points' 'compute number of positive contributing points' ppts",
  "-t 1 0 1 0 0 9.875x1+1+11 'kurtosis' 'compute kurtosis' kur",
  "-t 1 0 1 0 0 16.75x1+14+11 'elements coordinate' 'store elements coordinate of the minimum value' emin",
  "-t 1 0 1 0 0 13.625x1+33+11 'negative points' 'compute number of negative contributing points' npts",
  "-t 1 0 1 0 0 7.5x1+1+12 'minimum' 'compute minimum value' minval",
  "-t 1 0 1 0 0 13.875x1+33+12 'zero points' 'compute number of zero-valued contributing pts' zpts",
  "-t 1 0 1 0 0 7.5x1+1+13 'maximum' 'compute maximum value' maxval",
  "-t 1 0 1 0 0 17x1+14+13.5 'width coordinate' 'store width coordinate of the maximum value' wmax",
  "-t 1 0 1 0 0 9.875x1+33+13.5 'data width' 'store size of objects width dimension' wsize",
  "-t 1 0 1 0 0 17x1+14+14.5 'height coordinate' 'store height coordinate of the maximum value' hmax",
  "-t 1 0 1 0 0 10.625x1+33+14.5 'data height' 'store size of objects height dimension' hsize",
  "-t 1 0 1 0 0 17x1+14+15.5 'depth coordinate' 'store depth coordinate of the maximum value' dmax",
  "-t 1 0 1 0 0 9.875x1+33+15.5 'data depth' 'store size of objects depth dimension' dsize",
  "-t 1 0 1 0 0 17x1+14+16.5 'time coordinate' 'store time coordinate of the maximum value' tmax",
  "-t 1 0 1 0 0 9.125x1+33+16.5 'time size' 'store size of objects time dimension' tsize",
  "-t 1 0 1 0 0 17x1+14+17.5 'elements coordinate' 'store elements coordinate of the maximum value' emax",
  "-t 1 0 1 0 0 12.125x1+33+17.5 'elements size' 'store size of objects elements dimension' esize",
  "-E",
  "-E",
  "-b +1+5 'OR Calculate only the Statistics Selected Below:' blank1",
  "-b +13+6 'Coordinates of Minimum:' blank2",
  "-b +13+12.5 'Coordinates of Maximum:' blank3",
  "-b +1+19.5 'Define Processing Unit: ' blank4",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
  61,62,63,64,65,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kstats/uis/kstats.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	65,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


