 /*
  * Khoros: $Id: ktranspose.h,v 1.1.2.2 1997/05/31 19:03:00 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for ktranspose
   >>>> 
   >>>>    Written By: Steve Kubica
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _ktranspose_h_
#define _ktranspose_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <datamanip.h>

/* -include_includes */
#include "kdatamanip/kdatamanip.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input data object (required infile)
 */
char	*i_file;	/* input data object FILENAME */
int	 i_flag;	/* input data object FLAG */

/*
 *  resulting data object (required outfile)
 */
char	*o_file;	/* resulting data object FILENAME */
int	 o_flag;	/* resulting data object FLAG */

/*----- optional   group ----*/
/*
 *  swap width and one other dimension (optional flag)
 */
int	 w_flag;  	/* swap width and one other dimension FLAG */

/*
 *  swap height with one other dimension (optional flag)
 */
int	 h_flag;  	/* swap height with one other dimension FLAG */

/*
 *  swap elements with one other dimension (optional flag)
 */
int	 e_flag;  	/* swap elements with one other dimension FLAG */

/*
 *  swap depth with one other dimension (optional flag)
 */
int	 d_flag;  	/* swap depth with one other dimension FLAG */

/*
 *  swap time with one other dimension (optional flag)
 */
int	 t_flag;  	/* swap time with one other dimension FLAG */

/*-- optional   group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void ktranspose_get_args PROTO((kaddr));
void ktranspose_usage_additions PROTO((void));
void ktranspose_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
