 /*
  * Khoros: $Id: usage.c,v 1.1.2.2 1997/05/31 19:03:02 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.1.2.2 1997/05/31 19:03:02 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ktranspose.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ktranspose_get_args
| 
|       Purpose: Gets command line args for ktranspose
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ktranspose
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ktranspose_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ktranspose is out of sync with arguments specified in ktranspose's *.pane file; please rerun ghostwriter on ktranspose.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ktranspose structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "ktranspose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "ktranspose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "w",
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "ktranspose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "h",
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "ktranspose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "e",
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "ktranspose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "d",
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "ktranspose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "t",
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "ktranspose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Transpose Data on Dimensions' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Orient",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $DATAMANIPBIN/ktranspose",
  "-H 1  5x1+41+0 'Help' 'help page for ktranspose' $DATAMANIP/objects/kroutine/ktranspose/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'input data object' i",
  "",
  "-O 1 0 0 1 0 1 52x1+0+6.5 ' ' 'Output' 'resulting data object' o",
  "-b +0+3.5 'Select which' b1",
  "-b +0+4 'TWO Dimensions' b2",
  "-b +0+4.5 'should be transposed' b3",
  "-b +16+3.5 'WIDTH' bw",
  "-b +23+3.5 'HEIGHT' bh",
  "-b +30+3.5 'ELEMENTS' be",
  "-b +39+3.5 'DEPTH' bd",
  "-b +46+3.5 'TIME' bt",
  "",
  "-K 0",
  "-t 1 0 1 1 0 3.875x1+17+4.5 ' ' 'swap width and one other dimension' w",
  "-t 1 0 1 0 0 3.875x1+24+4.5 ' ' 'swap height with one other dimension' h",
  "-t 1 0 1 1 0 3.875x1+32+4.5 ' ' 'swap elements with one other dimension' e",
  "-t 1 0 1 0 0 3.875x1+40+4.5 ' ' 'swap depth with one other dimension' d",
  "-t 1 0 1 0 0 3.875x1+47+4.5 ' ' 'swap time with one other dimension' t",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/ktranspose/uis/ktranspose.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	31,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


