 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:03:23 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:03:23 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kunmask.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kunmask_get_args
| 
|       Purpose: Gets command line args for kunmask
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kunmask
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kunmask_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kunmask is out of sync with arguments specified in kunmask's *.pane file; please rerun ghostwriter on kunmask.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kunmask structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "prop",
			  &(clui_info->prop_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "replace",
			  &(clui_info->replace_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "attr",
			  &(clui_info->attr_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "omask",
			  &(clui_info->omask_file),
			  &(clui_info->omask_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mask",
			  &(clui_info->mask_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "val",
			  &(clui_info->val_flag))))
	{
	    kerror(NULL, "kunmask_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Remove Mask from Data Object' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kunmask",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATAMANIPBIN/kunmask",
  "-H 1  5x1+41+0 'Help' 'help page' $DATAMANIP/objects/kroutine/kunmask/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input data object' i",
  "-h 1 0 1 2 0 19x1+10+7 0 0 0 0 0 0 'Real      ' 'If replace selected, replace real data with this value' real",
  "-h 1 0 1 2 0 19x1+10+8 0 0 0 0 0 0 'Imaginary ' 'If replace selected, replace imaginary data with this value' imag",
  "-O 1 0 0 1 0 1 51.75x1+0+11 ' ' 'Output' 'Resulting output data object' o",
  "-C 0",
  "-t 1 0 1 1 0 18.5x1+3+5 'Propagate Original Data' 'Propagate masked (invalid) data to output' prop",
  "-t 1 0 1 0 0 26.5x1+3+6 'Replace Masked Data with Values' 'Replace masked (invalid) data with real/imag values' replace",
  "-t 1 0 1 0 0 5.75x1+3+9 'Process as Defined by Object Mask Attributes' 'Process as defined by the object mask attributes' attr",
  "-E",
  "-B 0",
  "-O 1 0 1 0 0 1 51.75x1+0+12.5 ' ' 'Output Mask' 'Output file containing mask that was removed' omask",
  "-C 0",
  "-t 1 0 1 0 0 9.125x1+36+13.5 'Mask Data' 'If selected, save input mask as mask data in omask object' mask",
  "-t 1 0 1 0 0 9.875x1+36+14.5 'Value Data' 'If selected, save input mask as value data in omask object' val",
  "-E",
  "-E",
  "-b +1+3.5 'What should be done with data under the validity mask?' blank1",
  "-b +3+13.5 'If Storing Mask in an Object, Save Mask as ' blank2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATAMANIP/objects/kroutine/kunmask/uis/kunmask.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	30,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


