/*
 * Khoros: $Id: pres.h,v 1.3 1997/01/20 04:49:49 mirage Exp $
 */
 
 
/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: definitions and prototypes for 
   >>>>		       data services presentation code
   >>>>
   >>>>    Written By: Steve Kubica
   >>>>
   >>>>          Date: October 12, 1995
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kdataccess_present_h_
#define _kdataccess_present_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

#include <bootstrap.h>

	/*-------------------------------------*
	|       #defines
	---------------------------------------*/

/*-- coupling types --*/
#define KUNCOUPLED 0
#define KDEMAND    1
#define KCOUPLED   2

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

   /*----------------------------------------------------------------
   |   kdas_presentation structure
   |   . . . . . . . . . . . . . . 
   |
   |   This is a presentation layer which envelops the 
   |   kdas_segment structure.  Through the public API for data
   |   services, data is always accessed through this structure.
   |   This structure controls the "data pipeline", dictating 
   |   which presentation stages need to be invoked on data access.
   \-----------------------------------------------------------------*/
typedef struct _kdas_presentation 
{
   /*-- tokenized version of the segment name --*/
   ktoken id;

   /*-- coupling of presentation attributes with physical attributes --*/
   int  coupling;

   /*-- presentation attributes --*/
   klist *attributes;

   /*-- actual physical segment we are associated with --*/
   kdas_segment *segment;

   /*-- size and order arrays : keep syncronized with segment->dimension --*/
   int dimension;

   /*-- presentation attributes --*/
   int   datatype;
   int  *size;
   int  *order;
   int   size_interpolate;  /*-- KNONE, KPAD, KWRAP, KZERO_ORDER --*/

   /*-- pipeline control --*/
   int  complex_convert;
   int  access_interpolate; /*-- KNONE, KPAD, KWRAP --*/
   
   double rpad;
   double ipad;

   int    scaling;
   double scale_factor;
   double scale_roffset;
   double scale_ioffset;

   double norm_min;
   double norm_max;
   
} kdas_presentation;

	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/

	/*-------------------------------------*
	|       macros
	---------------------------------------*/

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

#endif /* _kdataccess_present_h_ */
/* Don't add after this point */
