/*
 * Khoros: $Id: transport.h,v 1.4 1997/01/20 04:49:53 mirage Exp $
 */
 
 
/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: definitions and prototypes for 
   >>>>		       data services transport code
   >>>>
   >>>>    Written By: Steve Kubica
   >>>>
   >>>>          Date: October 12, 1995
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kdataccess_transport_h_
#define _kdataccess_transport_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

#include <bootstrap.h>

	/*-------------------------------------*
	|       #defines
	---------------------------------------*/

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

   /*----------------------------------------------------------------
   |   kdas_transport structure
   |   . . . . . . . . . . . . . . . 
   |
   |   This contains all the information needed for a transport, 
   |   which is simply the file id, as well as the relevant reader, writer,
   |   and seeker functions which should be used when accessing the 
   |   transport.
   \-----------------------------------------------------------------*/
typedef struct _kdas_transport
{
   int   id;

   ssize_t  (*reader)         PROTO((int, kaddr, size_t, int));
   ssize_t  (*writer)         PROTO((int, kaddr, size_t, int));
   off_t    (*seeker)         PROTO((int, off_t, int));
   long int (*teller)         PROTO((int));

} kdas_transport;

	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/

	/*-------------------------------------*
	|       macros
	---------------------------------------*/

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

#endif /* _kdataccess_transport_h_ */
/* Don't add after this point */
