/*
 * Khoros: $Id: object.h,v 1.1.2.1 1997/03/18 23:15:12 mirage Exp $
 */
 
 
/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Geometry Object Definition
   >>>>
   >>>>    Written By: Steve Kubica
   >>>>
   >>>>          Date: November 28, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kgeom_object_h_
#define _kgeom_object_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

	/*-------------------------------------*
	|       #defines
	---------------------------------------*/

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

   /*----------------------------------------------------------------
   |   geometry object
   |   . . . . . . . . . . . . . . 
   |   This is the geometry object structure.
   \-----------------------------------------------------------------*/

typedef struct _kgeom_object    
{
   kstring name;
   
   float   ambient_color[3];
   float   diffuse_color[3];
   float   specular_color[3];
   float   specular_exponent;
   
   int     modeling_space;
   int     visible;
   int     layout;
   int     location_dim;
   int     texture_coord_dim;
   
   kubyte  has_bounding_box;
   kubyte  has_center;
   kubyte  has_color;
   kubyte  has_matrix;
   kubyte  has_alpha;

   float   min[3];
   float   max[3];
   float   center[3];
   float   matrix[16];
   float   color[3];
   float   opacity;

   /*   
    *  To support streaming, the primitive list is a NULL terminated
    *  list, with a NULL pointer value indicating the last primitive.
    *  This NULL primitive will be stored as a -1 in the file.
    *  
    *  This has the implication that the list is always one more than
    *  the number of actual primitives.
    *  
    *  The following functions can be used to access this list :
    *    kgeom_number_primitives(kgeom_object);
    *    kgeom_add_primitive(kgeom_object, kgeom_primitive);
    *    kgeom_remove_primitive(kgeom_object, kgeom_primitive);
    *    kgeom_get_primitive(kgeom_object, int);
    *   
    */
   kgeom_primitive **primitives;
   
   int     fid;

   struct _kgeom_object *parent;

} kgeom_object;

	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/

	/*-------------------------------------*
	|       macros
	---------------------------------------*/

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

#endif /* _kgeom_object_h_ */
/* Don't add after this point */
