 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:21:22 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:21:22 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgdbm_dump.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgdbm_dump_get_args
| 
|       Purpose: Gets command line args for kgdbm_dump
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgdbm_dump
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgdbm_dump_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgdbm_dump is out of sync with arguments specified in kgdbm_dump's *.pane file; please rerun ghostwriter on kgdbm_dump.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgdbm_dump structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kgdbm_dump_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "kgdbm_dump_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "all",
			  &(clui_info->all_flag))))
	{
	    kerror(NULL, "kgdbm_dump_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "key",
			  &(clui_info->key_string),
			  &(clui_info->key_flag))))
	{
	    kerror(NULL, "kgdbm_dump_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 10x10+10+20 +0+0 'CANTATA' cantata",
  "-M 1 1 1x1+0+0 +1+0 'KDBM Dump:  Dump out KDBM Information' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' kgdbm_dump",
  "-a 1 0 7x1+0+0 'Options' 'Pull down menu of cantata pane options' options",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DATASERVBIN/kgdbm_dump",
  "-H 1  5x1+41+0 'Help' 'man page for absolute value' $DATASERV/objects/kroutine/kgdbm_dump/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 51.75x1+0+2 ' ' 'Input Data Base' 'Input data base to print information for' i",
  "-i 1 0 1 1 0 44.5x1+3+4 1 1 0 0 0 'Number of Points to Print ' 'Number of Points to Print' n",
  "-t 1 0 1 0 0 5.75x1+3+5.5 'Print All Data' 'Print All Data' all",
  "-s 1 0 1 1 0 45.25x1+3+7 ' ' 'Key ' 'Key to be printed, otherwise all keys are dumped' key",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DATASERV/objects/kroutine/kgdbm_dump/uis/kgdbm_dump.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	14,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


