 /*
  * Khoros: $Id: errors.c,v 1.3.2.2 1997/03/11 17:15:21 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: errors.c,v 1.3.2.2 1997/03/11 17:15:21 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		
   >>>>  Private:
   >>>>                 kpds_init_errors()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

int
   KPDS_EINVALID_PRIMITIVE,
   KPDS_EMAPPING_MODE,
   KPDS_EVALUE_NONEXIST,
   KPDS_EMASK_NONEXIST,
   KPDS_EMAP_NONEXIST,
   KPDS_ETIME_NONEXIST,
   KPDS_ELOCATION_NONEXIST,
   KPDS_ELOCATION_MUST_BE_UNIFORM,
   KPDS_ELOCATION_GRID_ALREADY_SET,
   KPDS_ELOCATION_GRID_INVALID;

static kerrlist pds_errors[] =
{
   {&KPDS_EINVALID_PRIMITIVE,
    "Invalid Primitive"},
   {&KPDS_EMAPPING_MODE,
    "Mapping Mode Hides Map"},
   {&KPDS_EVALUE_NONEXIST,
    "Value Segment Nonexistent"},
   {&KPDS_EMASK_NONEXIST,
    "Mask Segment Nonexistent"},
   {&KPDS_EMAP_NONEXIST,
    "Map Segment Nonexistent"},
   {&KPDS_ETIME_NONEXIST,
    "Time Segment Nonexistent"},
   {&KPDS_ELOCATION_NONEXIST,
    "Location Segment Nonexistent"},
   {&KPDS_ELOCATION_MUST_BE_UNIFORM,
    "Location Segment Must Be Uniform"},
   {&KPDS_ELOCATION_GRID_ALREADY_SET,
    "Location Grid Already Set"},
   {&KPDS_ELOCATION_GRID_INVALID,
    "Location Grid Invalid"},
};

static size_t pds_num_errors = (size_t) knumber(pds_errors);

/*-----------------------------------------------------------
|
|  Routine Name: kpds_init_errors
|
|       Purpose: 
|
|         Input: 
|
|        Output: 
|
|       Returns: nothing
|
|    Written By: 
|          Date: May 11, 1996
| Modifications:
|
------------------------------------------------------------*/
void 
kpds_init_errors(void)
{
   kerrno_init_errors(pds_errors, pds_num_errors);
}
