 /*
  * Khoros: $Id: global.c,v 1.1.2.1 1997/03/18 23:29:33 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: global.c,v 1.1.2.1 1997/03/18 23:29:33 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>         Polymophic Global Internal Variables
   >>>>         
   >>>>   Public:
   >>>>  Private:
   >>>>			kpds_init_segment_tokens()
   >>>>   Static:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/*-- global String Representations of the Polymorphic Segments --*/
char *pds_value_string    = KPDS_SEGMENT_VALUE;
char *pds_mask_string     = KPDS_SEGMENT_MASK;
char *pds_location_string = KPDS_SEGMENT_LOCATION;
char *pds_map_string      = KPDS_SEGMENT_MAP;
char *pds_time_string     = KPDS_SEGMENT_TIME;

/*-- global Token Representations of the Polymorphic Segments --*/
ktoken pds_value_token;
ktoken pds_mask_token;
ktoken pds_location_token;
ktoken pds_time_token;
ktoken pds_map_token;
ktoken pds_width_token;
ktoken pds_height_token;
ktoken pds_depth_token;

/*-- model size syncronization --*/
int sync_sizes = TRUE;

/*-----------------------------------------------------------
|
|  Routine Name: kpds_init_segment_tokens
|
|       Purpose: This routine initializes the segment tokens
|		 representing the polymophic segments.  These
|		 tokens are used globally throughout the 
|		 application services code to 
|
|	 	 To use these, you need to extern the variables
|
|			extern ktoken pds_value_token;
|			extern ktoken pds_mask_token;
|			extern ktoken pds_location_token;
|			extern ktoken pds_time_token;
|			extern ktoken pds_map_token;
|			extern ktoken pds_width_token;
|			extern ktoken pds_height_token;
|			extern ktoken pds_depth_token;
|         Input: none
|
|        Output: none
|
|       Returns: nothing
|
|    Written By: Steve Kubica
|          Date: Jun 08, 1994 11:10
| Modifications:
|
------------------------------------------------------------*/
void
kpds_init_segment_tokens(void)
{
   pds_value_token    = kstring_to_token(KPDS_SEGMENT_VALUE);
   pds_mask_token     = kstring_to_token(KPDS_SEGMENT_MASK);
   pds_location_token = kstring_to_token(KPDS_SEGMENT_LOCATION);
   pds_time_token     = kstring_to_token(KPDS_SEGMENT_TIME);
   pds_map_token      = kstring_to_token(KPDS_SEGMENT_MAP);

   pds_width_token    = kstring_to_token(KPDS_SEGMENT_WIDTH);
   pds_height_token   = kstring_to_token(KPDS_SEGMENT_HEIGHT);
   pds_depth_token    = kstring_to_token(KPDS_SEGMENT_DEPTH);

   return;
}
