 /*
  * Khoros: $Id: utility.c,v 1.5.2.2 1997/03/11 17:15:38 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: utility.c,v 1.5.2.2 1997/03/11 17:15:38 mirage Exp $";

#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */



/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		Polymophic Model Utilities
   >>>>		
   >>>>  Private:
   >>>>                 kaps_current_date()
   >>>>
   >>>>			kstring_append()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/*-----------------------------------------------------------
|
|  Routine Name: kaps_current_date
|
|       Purpose: Creates a string with the current date in it. 
|		 This data is retrieved using strftme calls in a 
|		 "POSIX compliant" way (we checked the book).  If 
|		 it doesn't work on your system, call your OS 
|		 vender and complain ;^)
|
|         Input: buf - buffer to return the date to
|
|        Output: none
|
|       Returns: none
|
|    Written By: Jeremy Worley
|          Date: March 8, 1993
| Modifications:
|
------------------------------------------------------------*/

#define KDMS_DATEFORMAT "%a %b %d %H:%M:%S %Z %Y"

void
kaps_current_date(char *buf)
{
   struct tm *ctm = NULL;
   time_t tt;

   (void)time(&tt);
   ctm = localtime(&tt);
   
   if (ctm == NULL)
      return;

   kstrftime(buf, (size_t) KLENGTH, KDMS_DATEFORMAT, ctm);

   return;
}

/****    =============================================================
 ****    Utility Routines
 ****    =============================================================
 ****/

/*-----------------------------------------------------------
|
|  Routine Name: kstring_append
|
|       Purpose: Append one string to another, allocating space in 
|		 the first string to hold the second.
|
|         Input: str1 - first string
|		 str2 - second string
|
|        Output: none
|
|       Returns: realloced pointer to the first string
|
|    Written By: Steve Kubica
|          Date: March 20, 1996
| Modifications:
|
------------------------------------------------------------*/
char *
kstring_append(char *str1, char *str2)
{
   int   len1 = kstrlen(str1);
   int   len2 = kstrlen(str2);


   if (str1 == NULL)
      return kstrdup(str2);

   else
   {
      str1 = (char *) krealloc(str1, sizeof(char) * (len1+len2+1));

      return kstrcat(str1, str2);
   }
}
