 /*
  * Khoros: $Id: init.c,v 1.5 1997/01/20 04:56:28 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: init.c,v 1.5 1997/01/20 04:56:28 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		
   >>>>  Private:
   >>>>                 kdas_init()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

int
   KDAS_ESEG_UNKNOWN_DIMENSIONALITY,
   KDAS_ESEG_UNKNOWN_SIZE,
   KDAS_ESEG_UNKNOWN_ORDER,
   KDAS_ESEG_UNKNOWN_DATATYPE,
   KDAS_EATTR_UNKNOWN_DATATYPE,
   KDAS_EATTR_UNSET,
   KDAS_EATTR_SET_FAILED,
   KDAS_EATTR_GET_FAILED,
   KDAS_EATTR_COPY_FAILED,
   KDAS_EATTR_QUERY_FAILED,
   KDAS_EATTR_PRINT_FAILED,
   KDAS_EINVALID_NORMALIZATION;

static kerrlist errors[] =
{
   {&KDAS_ESEG_UNKNOWN_DIMENSIONALITY,
    "Unknown Segment Dimensionality"},
   {&KDAS_ESEG_UNKNOWN_SIZE,
    "Unknown Segment Size"},
   {&KDAS_ESEG_UNKNOWN_ORDER,
    "Unknown Segment Order"},
   {&KDAS_ESEG_UNKNOWN_DATATYPE,
    "Unknown Segment Datatype"},
   {&KDAS_EATTR_UNKNOWN_DATATYPE,
    "Unknown Attribute Datatype"},
   {&KDAS_EATTR_UNSET,
    "Unset Attribute"},
   {&KDAS_EATTR_SET_FAILED,
    "Set Attribute Failed"},
   {&KDAS_EATTR_GET_FAILED,
    "Get Attribute Failed"},
   {&KDAS_EATTR_COPY_FAILED,
    "Copy Attribute Failed"},
   {&KDAS_EATTR_QUERY_FAILED,
    "Query Attribute Failed"},
   {&KDAS_EATTR_PRINT_FAILED,
    "Print Attribute Failed"},
   {&KDAS_EINVALID_NORMALIZATION,
    "Invalid Normalization Type"}

};

static size_t num_errors = (size_t) knumber(errors);

/*-----------------------------------------------------------
|
|  Routine Name: kdas_init
|
|       Purpose: This routine initializes all the errno codes
|		 for data access services
|
|         Input: none
|
|        Output: none
|
|       Returns: TRUE on success, FALSE otherwise
|
|    Written By: Steve Kubica
|          Date: August 18, 1995
| Modifications:
|
------------------------------------------------------------*/
void 
kdas_init(void)
{
   kerrno_init_errors(errors, num_errors);
}
