 /*
  * Khoros: $Id: dms_attrib.c,v 1.10.2.2 1997/03/11 17:16:18 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: dms_attrib.c,v 1.10.2.2 1997/03/11 17:16:18 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		Initialization of Data Services
   >>>>		
   >>>>  Private:
   >>>>                 kdms_init_attributes()
   >>>>   Static:
   >>>>                 _get_dimension()
   >>>>                 _set_dimension()
   >>>>                 _match_dimension()
   >>>>                 _copy_dimension()
   >>>>                 _query_dimension()
   >>>>                 _print_dimension()
   >>>>                 _get_size()
   >>>>                 _set_size()
   >>>>                 _match_size()
   >>>>                 _copy_size()
   >>>>                 _query_size()
   >>>>                 _print_size()
   >>>>                 _get_order()
   >>>>                 _set_order()
   >>>>                 _match_order()
   >>>>                 _copy_order()
   >>>>                 _query_order()
   >>>>                 _print_order()
   >>>>                 _get_datatype()
   >>>>                 _set_datatype()
   >>>>                 _match_datatype()
   >>>>                 _copy_datatype()
   >>>>                 _query_datatype()
   >>>>                 _print_datatype()
   >>>>                 _get_complex_convert()
   >>>>                 _set_complex_convert()
   >>>>                 _match_complex_convert()
   >>>>                 _copy_complex_convert()
   >>>>                 _query_complex_convert()
   >>>>                 _print_complex_convert()
   >>>>                 _get_scaling()
   >>>>                 _set_scaling()
   >>>>                 _match_scaling()
   >>>>                 _copy_scaling()
   >>>>                 _query_scaling()
   >>>>                 _print_scaling()
   >>>>                 _get_scale_factor()
   >>>>                 _set_scale_factor()
   >>>>                 _match_scale_factor()
   >>>>                 _copy_scale_factor()
   >>>>                 _query_scale_factor()
   >>>>                 _print_scale_factor()
   >>>>                 _get_scale_offset()
   >>>>                 _set_scale_offset()
   >>>>                 _match_scale_offset()
   >>>>                 _copy_scale_offset()
   >>>>                 _query_scale_offset()
   >>>>                 _print_scale_offset()
   >>>>                 _get_pad_value()
   >>>>                 _set_pad_value()
   >>>>                 _match_pad_value()
   >>>>                 _copy_pad_value()
   >>>>                 _query_pad_value()
   >>>>                 _print_pad_value()
   >>>>                 _get_norm_min()
   >>>>                 _set_norm_min()
   >>>>                 _match_norm_min()
   >>>>                 _copy_norm_min()
   >>>>                 _query_norm_min()
   >>>>                 _print_norm_min()
   >>>>                 _get_norm_max()
   >>>>                 _set_norm_max()
   >>>>                 _match_norm_max()
   >>>>                 _copy_norm_max()
   >>>>                 _query_norm_max()
   >>>>                 _print_norm_max()
   >>>>                 _get_interpolate()
   >>>>                 _set_interpolate()
   >>>>                 _match_interpolate()
   >>>>                 _copy_interpolate()
   >>>>                 _query_interpolate()
   >>>>                 _print_interpolate()
   >>>>                 _get_name()
   >>>>                 _set_name()
   >>>>                 _match_name()
   >>>>                 _copy_name()
   >>>>                 _query_name()
   >>>>                 _print_name()
   >>>>                 _get_flags()
   >>>>                 _set_flags()
   >>>>                 _match_flags()
   >>>>                 _copy_flags()
   >>>>                 _query_flags()
   >>>>                 _print_flags()
   >>>>                 _get_format()
   >>>>                 _set_format()
   >>>>                 _match_format()
   >>>>                 _copy_format()
   >>>>                 _query_format()
   >>>>                 _print_format()
   >>>>                 _get_architecture()
   >>>>                 _set_architecture()
   >>>>                 _match_architecture()
   >>>>                 _copy_architecture()
   >>>>                 _query_architecture()
   >>>>                 _print_architecture()
   >>>>                 _get_coupling()
   >>>>                 _set_coupling()
   >>>>                 _match_coupling()
   >>>>                 _copy_coupling()
   >>>>                 _query_coupling()
   >>>>                 _print_coupling()
   >>>>                 _get_optimal_region()
   >>>>                 _get_physical_size()
   >>>>                 _set_physical_size()
   >>>>                 _get_physical_order()
   >>>>                 _set_physical_order()
   >>>>                 _get_physical_datatype()
   >>>>                 _set_physical_datatype()
   >>>>                 _get_physical_dimension()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

/*
 * Centerline's CLCC doesn't honor the ARGSUSED *standard* so
 * this pragma turns off warnings about unused arguments, which
 * are numerous in this file.
 */
#ifdef __CLCC__
#pragma Warning_level (3)
#endif

#include "internals.h"

/*
 *    ================================================================== 
 *    KDMS Quasi Attribute Methods
 *    ==================================================================
 */

/*********** ---------------------------------------------------------------
 ***********  KDMS_DIMENSION
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_dimension
|       Purpose: get the dimension attribute
|    Written By: Jeremy Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_dimension(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	       kva_list *list)
{
   kdas_presentation *pres;
   int               *args;
   int                dim;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if (!kdas_pres_get_dimension(pres, &dim))
      return FALSE;
   
   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = dim;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_dimension
|       Purpose: set the dimension attribute
|    Written By: Jermey Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_dimension(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	       kva_list *list)
{
   kdas_presentation *pres;
   int args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   args = kva_arg(*list, int);
   
   if (!kdas_pres_set_dimension(pres, args))
      return FALSE;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_dimension
|       Purpose: match the dimension attribute
|    Written By: John M. Salas and Steve Kubica
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_dimension(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		 kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   return (pres1->dimension == pres2->dimension);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_dimension
|       Purpose: copy the dimension attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_dimension(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		 kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;
   int dim;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   if (!kdas_pres_get_dimension(pres1, &dim))
      return FALSE;
   
   if (!kdas_pres_set_dimension(pres2, dim))
      return FALSE;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_dimension
|       Purpose: query the dimension attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_dimension(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		 int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = TRUE;
   if (argsize)
      *argsize = 1;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_dimension
|       Purpose: print the dimension attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_dimension(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		 kfile *outfile)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   kfprintf(outfile, " %d ", pres->dimension);

   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_SIZE
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_size
|       Purpose: get the size attribute
|    Written By: Jeremy Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_size(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	  kva_list *list)
{
   kdas_presentation *pres;
   int              **args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, int **)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (!kdas_pres_get_size(pres, args))
      return FALSE;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_size
|       Purpose: set the size attribute
|    Written By: Jermey Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_size(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	  kva_list *list)
{
   kdas_presentation *pres;
   int *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (!kdas_pres_set_size(pres, args))
      return FALSE;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_size
|       Purpose: match the size attribute
|    Written By: John M. Salas and Steve Kubica
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_size(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	    kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;
   int i;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   if (pres1->dimension <= 0 || pres2->dimension <= 0 ||
       pres1->dimension != pres2->dimension)
      kdas_fail_error(KDAS_ESEG_UNKNOWN_DIMENSIONALITY);

   for (i = 0; i < pres1->dimension; i++)
      if (pres1->size[i] != pres2->size[i])
         return FALSE;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_size
|       Purpose: copy the size attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_size(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	    kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;
   int  *size;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   if (!kdas_pres_get_size(pres1, &size))
      return FALSE;
   
   if (!kdas_pres_set_size(pres2, size))
      return FALSE;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_size
|       Purpose: query the size attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_size(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	    int *numargs, int *argsize, int *datatype, int *permanent)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if (pres->dimension <= 0)
      kdas_fail_error(KDAS_ESEG_UNKNOWN_DIMENSIONALITY);

   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = TRUE;
   if (argsize)
      *argsize = pres->dimension;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_size
|       Purpose: print the size attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_size(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	    kfile *outfile)
{
   kdas_presentation *pres;
   int i;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if (pres->dimension <= 0)
      kdas_fail_error(KDAS_ESEG_UNKNOWN_DIMENSIONALITY);

   for (i = 0; i < pres->dimension; i++)
      kfprintf(outfile, " %d ", pres->size[i]);

   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_INDEX_ORDER
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_order
|       Purpose: get the order attribute
|    Written By: Jeremy Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_order(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	   kva_list *list)
{
   kdas_presentation *pres;
   int              **args;
   int               *order;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if (!kdas_pres_get_order(pres, &order))
      return FALSE;
   
   if ((args = kva_arg(*list, int **)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   *args = order;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_order
|       Purpose: set the order attribute
|    Written By: Jermey Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_order(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	   kva_list *list)
{
   kdas_presentation *pres;
   int *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (!kdas_pres_set_order(pres, args))
      return FALSE;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_order
|       Purpose: match the order attribute
|    Written By: John M. Salas and Steve Kubica
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_order(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	     kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;
   int i;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   if (pres1->dimension <= 0 || pres2->dimension <= 0 ||
       pres1->dimension != pres2->dimension)
      kdas_fail_error(KDAS_ESEG_UNKNOWN_DIMENSIONALITY);

   for (i = 0; i < pres1->dimension; i++)
      if (pres1->order[i] != pres2->order[i])
         return FALSE;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_order
|       Purpose: copy the order attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_order(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	    kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;
   int  *order;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   if (!kdas_pres_get_order(pres1, &order))
      return FALSE;
   
   if (!kdas_pres_set_order(pres2, order))
      return FALSE;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_order
|       Purpose: query the order attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_order(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	     int *numargs, int *argsize, int *datatype, int *permanent)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if (pres->dimension <= 0)
      kdas_fail_error(KDAS_ESEG_UNKNOWN_DIMENSIONALITY);

   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = TRUE;
   if (argsize)
      *argsize = pres->dimension;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_order
|       Purpose: print the order attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_order(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	     kfile *outfile)
{
   kdas_presentation *pres;
   int i;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if (pres->dimension <= 0)
      kdas_fail_error(KDAS_ESEG_UNKNOWN_DIMENSIONALITY);

   if (assoc == kstring_to_token(KDMS_SEGMENT_VALUE) || 
       assoc == kstring_to_token(KDMS_SEGMENT_MASK))
   {
      for (i = 0; i < pres->dimension; i++)
	 switch(pres->order[i])
	 {
	    case KWIDTH: 
	       kfprintf(outfile,"KWIDTH ");
	       break;
	    case KHEIGHT: 
	       kfprintf(outfile,"KHEIGHT ");
	       break;
	    case KDEPTH: 
	       kfprintf(outfile,"KDEPTH ");
	       break;
	    case KTIME: 
	       kfprintf(outfile,"KTIME ");
	       break;
	    case KELEMENTS: 
	       kfprintf(outfile,"KELEMENTS ");
	       break;
	    default:
	       kfprintf(outfile,"Unknown axis (%d) ",pres->order[i]);
	 }
   }
   else if (assoc == kstring_to_token(KDMS_SEGMENT_MAP))
   {
      for (i = 0; i < pres->dimension; i++)
	 switch(pres->order[i])
	 {
	    case KWIDTH: 
	       kfprintf(outfile,"KMAP_WIDTH ");
	       break;
	    case KHEIGHT: 
	       kfprintf(outfile,"KMAP_HEIGHT ");
	       break;
	    case KDEPTH: 
	       kfprintf(outfile,"KMAP_DEPTH ");
	       break;
	    case KTIME: 
	       kfprintf(outfile,"KMAP_TIME ");
	       break;
	    case KELEMENTS: 
	       kfprintf(outfile,"KMAP_ELEMENTS ");
	       break;
	    default:
	       kfprintf(outfile,"Unknown axis (%d) ",pres->order[i]);
	 }
   }
   else if (assoc == kstring_to_token(KDMS_SEGMENT_LOCATION))
   {
      for (i = 0; i < pres->dimension; i++)
	 switch(pres->order[i])
	 {
	    case KWIDTH: 
	       kfprintf(outfile,"KWIDTH ");
	       break;
	    case KHEIGHT: 
	       kfprintf(outfile,"KHEIGHT ");
	       break;
	    case KDEPTH: 
	       kfprintf(outfile,"KDEPTH ");
	       break;
	    case KDIMENSION: 
	       kfprintf(outfile,"KDIMENSION ");
	       break;
	    default:
	       kfprintf(outfile,"Unknown axis (%d) ",pres->order[i]);
	 }
   }
   else if (assoc == kstring_to_token(KDMS_SEGMENT_TIME))
   {
      kfprintf(outfile, "KTIME");
   }
   else 
   {
      for (i = 0; i < pres->dimension; i++)
	 kfprintf(outfile,"%d ",pres->order[i]);
   }
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_DATA_TYPE
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_datatype
|       Purpose: get the datatype attribute
|    Written By: Jeremy Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_datatype(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	      kva_list *list)
{
   kdas_presentation *pres;
   int               *args;
   int                type;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if (!kdas_pres_get_datatype(pres, &type))
      return FALSE;
   
   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = type;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_datatype
|       Purpose: set the datatype attribute
|    Written By: Jermey Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_datatype(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	      kva_list *list)
{
   kdas_presentation *pres;
   int                args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   args = kva_arg(*list, int);

   if (!kdas_pres_set_datatype(pres, args))
      return FALSE;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_datatype
|       Purpose: match the datatype attribute
|    Written By: John M. Salas and Steve Kubica
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_datatype(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   return (pres1->datatype == pres2->datatype);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_datatype
|       Purpose: copy the datatype attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_datatype(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	       kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;
   int  type;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   if (!kdas_pres_get_datatype(pres1, &type))
      return FALSE;
   
   if (!kdas_pres_set_datatype(pres2, type))
      return FALSE;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_datatype
|       Purpose: query the datatype attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_datatype(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = TRUE;
   if (argsize)
      *argsize = 1;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_datatype
|       Purpose: print the datatype attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_datatype(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		kfile *outfile)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   kfprintf(outfile, "%s", kdefine_to_datatype(pres->datatype));
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_COMPLEX_CONVERT
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_complex_convert
|       Purpose: get the complex convert attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_complex_convert(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		     kva_list *list)
{
   kdas_presentation *pres;
   int *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = pres->complex_convert;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_complex_convert
|       Purpose: set the complex convert attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_complex_convert(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		     kva_list *list)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   pres->complex_convert = kva_arg(*list, int);

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_complex_convert
|       Purpose: match the complex convert attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_complex_convert(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		       kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   return (pres1->complex_convert == pres2->complex_convert);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_complex_convert
|       Purpose: copy the complex convert attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_complex_convert(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		      kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   pres2->complex_convert = pres1->complex_convert;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_complex_convert
|       Purpose: query the complex convert attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_complex_convert(kobject obj, ktoken assoc, ktoken attrib, 
		       kaddr client_data, int *numargs, int *argsize, 
		       int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = FALSE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_complex_convert
|       Purpose: print the complex convert attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_complex_convert(kobject obj, ktoken assoc, ktoken attrib, 
		       kaddr client_data, kfile *outfile)
{
   kdas_presentation *pres;
   
   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   switch (pres->complex_convert)
   {
      case KREAL:
	 kfprintf(outfile,"KREAL");
	 break;
      case KIMAGINARY:
	 kfprintf(outfile,"KIMAGINARY");
	 break;
      case KMAGNITUDE:
	 kfprintf(outfile,"KMAGNITUDE");
	 break;
      case KPHASE:
	 kfprintf(outfile,"KPHASE");
	 break;
      case KMAGSQ:
	 kfprintf(outfile,"KMAGSQ");
	 break;
      case KLOGMAGSQ:
	 kfprintf(outfile,"KLOGMAGSQ");
	 break;
      case KLOGMAGSQP1:
	 kfprintf(outfile,"KLOGMAGSQP1");
	 break;
      case KLOGMAG:
	 kfprintf(outfile,"KLOGMAG");
	 break;
      case KLOGMAGP1:
	 kfprintf(outfile,"KLOGMAGP1");
	 break;
      default:
	 kfprintf(outfile,"Invalid value (%d)", pres->complex_convert);
	 break;
   }
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_SCALING
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_scaling
|       Purpose: get the scaling attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_scaling(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	     kva_list *list)
{
   kdas_presentation *pres;
   int *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = pres->scaling;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_scaling
|       Purpose: set the scaling attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_scaling(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	     kva_list *list)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   pres->scaling = kva_arg(*list, int);

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_scaling
|       Purpose: match the scaling attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_scaling(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	       kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   return (pres1->scaling == pres2->scaling);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_scaling
|       Purpose: copy the scaling attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_scaling(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	      kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   pres2->scaling = pres1->scaling;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_scaling
|       Purpose: query the scaling attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_scaling(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	       int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = FALSE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_scaling
|       Purpose: print the scaling attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_scaling(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	       kfile *outfile)
{
   kdas_presentation *pres;
   
   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   switch (pres->scaling)
   {
      case KNONE:
	 kfprintf(outfile,"KNONE");
	 break;
      case KSCALE:
	 kfprintf(outfile,"KSCALE");
	 break;
      case KNORMALIZE:
	 kfprintf(outfile,"KNORMALIZE");
	 break;
      default:
	 kfprintf(outfile,"Invalid value (%d)", pres->scaling);
	 break;
   }
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_SCALE_FACTOR
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_scale_factor
|       Purpose: get the scale factor attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_scale_factor(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		  kva_list *list)
{
   kdas_presentation *pres;
   double *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, double *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = pres->scale_factor;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_scale_factor
|       Purpose: set the scale factor attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_scale_factor(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		  kva_list *list)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   pres->scale_factor = kva_arg(*list, double);

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_scale_factor
|       Purpose: match the scale factor attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_scale_factor(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		    kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   return (pres1->scale_factor == pres2->scale_factor);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_scale_factor
|       Purpose: copy the scale factor attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_scale_factor(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		   kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   pres2->scale_factor = pres1->scale_factor;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_scale_factor
|       Purpose: query the scale factor attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_scale_factor(kobject obj, ktoken assoc, ktoken attrib, 
		    kaddr client_data, int *numargs, int *argsize, 
		    int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KDOUBLE;
   if (permanent)
      *permanent = FALSE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_scale_factor
|       Purpose: print the scale factor attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_scale_factor(kobject obj, ktoken assoc, ktoken attrib, 
		    kaddr client_data, kfile *outfile)
{
   kdas_presentation *pres;
   
   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   kfprintf(outfile, "%g", pres->scale_factor);
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_SCALE_OFFSET
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_scale_offset
|       Purpose: get the scale offset attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_scale_offset(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		  kva_list *list)
{
   kdas_presentation *pres;
   double *r, *i;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   r = kva_arg(*list, double *);
   i = kva_arg(*list, double *);
   
   if (r) *r = pres->scale_roffset;
   if (i) *i = pres->scale_ioffset;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_scale_offset
|       Purpose: set the scale offset attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_scale_offset(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		  kva_list *list)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   pres->scale_roffset = kva_arg(*list, double);
   pres->scale_ioffset = kva_arg(*list, double);

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_scale_offset
|       Purpose: match the scale offset attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_scale_offset(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		    kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   return (pres1->scale_roffset == pres2->scale_roffset &&
	   pres1->scale_ioffset == pres2->scale_ioffset);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_scale_offset
|       Purpose: copy the scale offset attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_scale_offset(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		   kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   pres2->scale_roffset = pres1->scale_roffset;
   pres2->scale_ioffset = pres1->scale_ioffset;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_scale_offset
|       Purpose: query the scale offset attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_scale_offset(kobject obj, ktoken assoc, ktoken attrib, 
		    kaddr client_data, int *numargs, int *argsize, 
		    int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 2;
   if (datatype)
      *datatype = KDOUBLE;
   if (permanent)
      *permanent = FALSE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_scale_offset
|       Purpose: print the scale offset attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_scale_offset(kobject obj, ktoken assoc, ktoken attrib, 
		    kaddr client_data, kfile *outfile)
{
   kdas_presentation *pres;
   
   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   kfprintf(outfile, "(%g, %g)", pres->scale_roffset, pres->scale_ioffset);
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_PAD_VALUE
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_pad_value
|       Purpose: get the pad value attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_pad_value(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	       kva_list *list)
{
   kdas_presentation *pres;
   double *r, *i;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   r = kva_arg(*list, double *);
   i = kva_arg(*list, double *);
   
   if (r) *r = pres->rpad;
   if (i) *i = pres->ipad;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_pad_value
|       Purpose: set the pad value attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_pad_value(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	       kva_list *list)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   pres->rpad = kva_arg(*list, double);
   pres->ipad = kva_arg(*list, double);

   /*-- use this to initialize the segment as well --*/
   pres->segment->rval = pres->rpad;
   pres->segment->ival = pres->ipad;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_pad_value
|       Purpose: match the pad value attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_pad_value(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		 kaddr client_data1, kaddr client_data2) 
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   return (pres1->rpad == pres2->rpad && pres1->ipad == pres2->ipad);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_pad_value
|       Purpose: copy the pad value attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_pad_value(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		kaddr client_data1, kaddr client_data2) 
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   pres2->rpad = pres1->rpad;
   pres2->ipad = pres1->ipad;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_pad_value
|       Purpose: query the pad value attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_pad_value(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		 int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 2;
   if (datatype)
      *datatype = KDOUBLE;
   if (permanent)
      *permanent = FALSE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_pad_value
|       Purpose: print the pad value attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_pad_value(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		 kfile *outfile)
{
   kdas_presentation *pres;
   
   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   kfprintf(outfile, "(%g, %g)", pres->rpad, pres->ipad);
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_NORM_MIN
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_norm_min
|       Purpose: get the normalization min attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_norm_min(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	      kva_list *list)
{
   kdas_presentation *pres;
   double *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, double *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = pres->norm_min;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_norm_min
|       Purpose: set the normalization min attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_norm_min(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	      kva_list *list)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   pres->norm_min = kva_arg(*list, double);

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_norm_min
|       Purpose: match the normalization min attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_norm_min(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   return (pres1->norm_min == pres2->norm_min);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_norm_min
|       Purpose: copy the normalization min attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_norm_min(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	       kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   pres2->norm_min = pres1->norm_min;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_norm_min
|       Purpose: query the normalization min attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_norm_min(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KDOUBLE;
   if (permanent)
      *permanent = FALSE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_norm_min
|       Purpose: print the normalization min attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_norm_min(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		kfile *outfile)
{
   kdas_presentation *pres;
   
   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   kfprintf(outfile, "%g", pres->norm_min);
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_NORM_MAX
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_norm_max
|       Purpose: get the normalization max attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_norm_max(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	      kva_list *list)
{
   kdas_presentation *pres;
   double *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, double *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = pres->norm_max;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_norm_max
|       Purpose: set the normalization max attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_norm_max(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	      kva_list *list)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   pres->norm_max = kva_arg(*list, double);

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_norm_max
|       Purpose: match the normalization max attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_norm_max(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   return (pres1->norm_max == pres2->norm_max);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_norm_max
|       Purpose: copy the normalization max attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_norm_max(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	       kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   pres2->norm_max = pres1->norm_max;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_norm_max
|       Purpose: query the normalization max attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_norm_max(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KDOUBLE;
   if (permanent)
      *permanent = FALSE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_norm_max
|       Purpose: print the normalization max attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_norm_max(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data, 
		kfile *outfile)
{
   kdas_presentation *pres;
   
   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   kfprintf(outfile, "%g", pres->norm_max);
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_INTERPOLATE
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_interpolate
|       Purpose: get the interpolate attribute
|    Written By: Jeremy Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_interpolate(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		 kva_list *list)
{
   kdas_presentation *pres;
   int               *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   /*-- size_interpolate is more canonical --*/
   if (args) *args = pres->size_interpolate; 

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_interpolate
|       Purpose: set the interpolate attribute
|    Written By: Jermey Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_interpolate(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		 kva_list *list)
{
   kdas_presentation *pres;
   int                args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   args = kva_arg(*list, int);

   switch (args)
   {
      case KNONE :
      case KPAD :
      case KWRAP :
	 pres->size_interpolate   = args;
	 pres->access_interpolate = args;
	 break;
      case KZERO_ORDER :  /*-- can't interpolate out-of-bounds data --*/
	 pres->size_interpolate   = KZERO_ORDER;    
	 pres->access_interpolate = KPAD;
	 break;
      default :
	 kdas_set_error(KINVALID_PARAMETER);
   }
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_interpolate
|       Purpose: match the interpolate attribute
|    Written By: John M. Salas and Steve Kubica
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_interpolate(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		   kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   /*-- size interpolation is the most canonical --*/
   return (pres1->size_interpolate == pres2->size_interpolate);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_interpolate
|       Purpose: copy the interpolate attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_interpolate(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		  kaddr client_data1, kaddr client_data2)
{
   kdas_presentation *pres1;
   kdas_presentation *pres2;

   if ((pres1 = kdms_get_segtoken_info(obj1, assoc)) == NULL)
      return FALSE;

   if ((pres2 = kdms_get_segtoken_info(obj2, assoc)) == NULL)
      return FALSE;

   pres2->size_interpolate   = pres1->size_interpolate;
   pres1->access_interpolate = pres1->access_interpolate;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_interpolate
|       Purpose: query the interpolate attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_interpolate(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		   int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = FALSE;
   if (argsize)
      *argsize = 1;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_interpolate
|       Purpose: print the interpolate attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_interpolate(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		   kfile *outfile)
{
   kdas_presentation *pres;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   /*-- size interpolation is the most canonical --*/
   switch (pres->size_interpolate)
   {
      case KNONE:
	 kfprintf(outfile,"KNONE");
	 break;
      case KPAD:
	 kfprintf(outfile,"KPAD");
	 break;
      case KZERO_ORDER:
	 kfprintf(outfile,"KZERO_ORDER");
	 break;
      default:
	 kfprintf(outfile,"Invalid interpolation (%d)", 
		  pres->size_interpolate);
	 break;
   }
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_NAME
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_name
|       Purpose: get the name attribute
|    Written By: Jeremy Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_name(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	  kva_list *list)
{
   static int count = 0;
   char   name[KLENGTH];
   char **args;

   if ((args = kva_arg(*list, char **)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   /*-- generate a unique pretty name for temporary transports --*/
   if (obj->phys->filename == NULL)
   {
      ksprintf(name, "%d", count++);
      if (args) *args = kstring_cat("temporary", name, NULL);
   }
   else
      if (args) *args = obj->phys->filename;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_name
|       Purpose: set the name attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_name(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	  kva_list *list)
{
   char *name = kva_arg(*list, char *);

   /*-- this will only work on output files --*/
   if (obj->phys->flags & KOBJ_READ)
   {
      kdas_set_error(KLIMITATION);
      return FALSE;
   }

   if (obj->phys->flags & KOBJ_WRITE)
   {
      kfree(obj->phys->filename);
      obj->phys->filename = kstrdup(name);
   }

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_name
|       Purpose: match the name attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_name(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	    kaddr client_data1, kaddr client_data2)
{
   if (kstrcmp(obj1->phys->filename, obj2->phys->filename) != 0)
      return FALSE;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_name
|       Purpose: copy the name attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_name(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	   kaddr client_data1, kaddr client_data2)
{
   kdas_set_error(KLIMITATION);
   return FALSE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_name
|       Purpose: query the name attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_name(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	    int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KSTRING;
   if (permanent)
      *permanent = TRUE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_name
|       Purpose: print the name attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_name(kobject obj, ktoken assoc, ktoken attrib, kaddr clientData,
            kfile *outfile)
{
   kfprintf(outfile, "%s", obj->phys->filename);
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_FLAGS
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_flags
|       Purpose: get the flags attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_flags(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	   kva_list *list)
{
   int *args;

   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = obj->phys->flags;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_flags
|       Purpose: set the flags attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_flags(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	   kva_list *list)
{
   kdas_set_error(KLIMITATION);
   return FALSE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_flags
|       Purpose: match the flags attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_flags(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	     kaddr client_data1, kaddr client_data2)
{
   return (obj1->phys->flags == obj2->phys->flags);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_flags
|       Purpose: copy the flags attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_flags(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	    kaddr client_data1, kaddr client_data2)
{
   kdas_set_error(KLIMITATION);
   return FALSE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_flags
|       Purpose: query the flags attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_flags(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	     int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = TRUE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_flags
|       Purpose: print the flags attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_flags(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	     kfile *outfile)
{
   int r = FALSE, w = FALSE, s = FALSE;

   if (obj->phys->flags & KOBJ_READ)
   {
      kfprintf(outfile, "KOBJ_READ");
      r = TRUE;
   }

   if (obj->phys->flags & KOBJ_WRITE)
   {
      if (r) kfprintf(outfile, " | ");
      kfprintf(outfile, "KOBJ_WRITE");
      w = TRUE;
   }

   if (obj->phys->flags & KOBJ_STREAM)
   {
      if (r || w) kfprintf(outfile, " | ");
      kfprintf(outfile, "KOBJ_STREAM");
      s = TRUE;
   }

   if (obj->phys->flags & KOBJ_RAW)
   {
      if (r || w || s) kfprintf(outfile, " | ");
      kfprintf(outfile, "KOBJ_RAW");
   }

   kfprintf(outfile, " (0x%.2x)\n", obj->phys->flags);
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_FORMAT
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_format
|       Purpose: get the format attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_format(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	    kva_list *list)
{
   char **args;

   if ((args = kva_arg(*list, char **)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = obj->phys->format->name;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_format
|       Purpose: set the format attribute
|    Written By: Jermey Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_format(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	    kva_list *list)
{
   kdas_format *format;
   char        *name;
   
   /*-- grab the new file format name --*/
   name = kva_arg(*list, char *);

   /*-- can't set this if we have an input object --*/
   if (obj->phys->flags & KOBJ_READ)
   {
      kdas_set_error(KDMS_EFMT_LOCKED_FOR_READING);
      return FALSE;
   }
   
   /*-- output object, or temp object is okay --*/
   else
   {
      if ((format = kdms_locate_format(name)) == NULL)
	 kdas_fail_error(KDMS_EFMT_UNKNOWN);

      /*-- clean up the old format... --*/
      kfree(obj->phys->format->name);
      kfree(obj->phys->format->description);

      /*-- ... and assign the new one --*/ 
      kmemcpy(obj->phys->format, format, sizeof(kdas_format));
      obj->phys->format->name        = kstrdup(format->name);
      obj->phys->format->description = kstrdup(format->description);
   }

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_format
|       Purpose: match the format attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_format(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	      kaddr client_data1, kaddr client_data2)
{
   if (kstrcmp(obj1->phys->format->name, obj2->phys->format->name) != 0)
      return FALSE;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_format
|       Purpose: copy the format attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_format(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	     kaddr client_data1, kaddr client_data2)
{
   kdas_set_error(KLIMITATION);
   return FALSE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_format
|       Purpose: query the format attribute
|    Written By: Steve Kubica
|          Date: Mar 30, 1994 14:36
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_format(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	      int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KSTRING;
   if (permanent)
      *permanent = TRUE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_format
|       Purpose: print the format attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_format(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
	      kfile *outfile)
{
   kfprintf(obj, "%s", obj->phys->format->name);
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_ARCHITECTURE
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_architecture
|       Purpose: get the architecture attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_architecture(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		  kva_list *list)
{
   int *args;

   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args)
   {
      if (obj->phys->fid == -1)
	 *args = kmach_local();
      else
	 *args = kfile_getmachtype(obj->phys->fid);
   }

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_architecture
|       Purpose: set the architecture attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_architecture(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		  kva_list *list)
{
   if (obj->phys->fid != -1)
      return (kfile_setmachtype(obj->phys->fid, kva_arg(*list, int)) == 0);
   else
      return FALSE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_architecture
|       Purpose: match the architecture attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_architecture(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		    kaddr client_data1, kaddr client_data2)
{
   int a1, a2;
   
   kdms_get_attribute(obj1, NULL, KDMS_ARCHITECTURE, &a1);
   kdms_get_attribute(obj2, NULL, KDMS_ARCHITECTURE, &a2);

   return (a1 == a2);
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_architecture
|       Purpose: copy the architecture attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_architecture(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		   kaddr client_data1, kaddr client_data2)
{
   int type;
   
   kdms_get_attribute(obj1, NULL, KDMS_ARCHITECTURE, &type);
   kdms_set_attribute(obj2, NULL, KDMS_ARCHITECTURE, type);

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_architecture
|       Purpose: query the architecture attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_architecture(kobject obj, ktoken assoc, ktoken attrib, 
		    kaddr client_data, int *numargs, int *argsize, 
		    int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = TRUE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_architecture
|       Purpose: print the architecture attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_architecture(kobject obj, ktoken assoc, ktoken attrib, 
		    kaddr client_data, kfile *outfile)
{
   int type;
   
   kdms_get_attribute(obj, NULL, KDMS_ARCHITECTURE, &type);

   kfprintf(outfile,"%s", kmach_description((unsigned int)type));

   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_COUPLING
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_coupling
|       Purpose: get the coupling attribute
|    Written By: Jeremy Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_coupling(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	      kva_list *list)
{
   kdas_presentation *pres;
   int *args;

   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args == NULL)
      return TRUE;  /*-- not an error --*/

   /*-- global coupling --*/
   if (assoc == kstring_to_token(NULL))
   {
      if (obj->phys->flags & KOBJ_READ)  /*-- read objects are coupled --*/
	 *args = KUNCOUPLED;

      if (obj->phys->flags & KOBJ_WRITE) /*-- write objects are uncoupled --*/
	 *args = KCOUPLED;

      return TRUE;
   }
   
   /*-- presentation coupling --*/
   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
   {
      kdas_set_error(KDMS_ESEG_NONEXIST);
      return FALSE;
   }

   *args = pres->coupling;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_coupling
|       Purpose: set the coupling attribute
|    Written By: Jermey Worley
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_coupling(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
	      kva_list *list)
{
   kdas_presentation *pres;
   int coupling = kva_arg(*list, int);

   /*-- global coupling : set for all segments --*/
   if (assoc == kstring_to_token(NULL))
   {
      klist *l;

      for (l = klist_head(obj->presentations); l != NULL; l = klist_next(l))
      {
	 pres = (kdas_presentation *) l->client_data;
	 pres->coupling = coupling;
      }
   }
   else
   {
      if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      {
	 kdas_set_error(KDMS_ESEG_NONEXIST);
	 return FALSE;
      }
      pres->coupling = coupling;
   }

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _match_coupling
|       Purpose: match the coupling attribute
|    Written By: John M. Salas
|          Date: December 23, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_match_coupling(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
		kaddr client_data1, kaddr client_data2)
{
   kdas_set_error(KLIMITATION);
   return FALSE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _copy_coupling
|       Purpose: copy the coupling attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_copy_coupling(kobject obj1, kobject obj2, ktoken assoc, ktoken attrib,
	       kaddr client_data1, kaddr client_data2)
{
   kdas_set_error(KLIMITATION);
   return FALSE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _query_coupling
|       Purpose: query the coupling attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_query_coupling(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		int *numargs, int *argsize, int *datatype, int *permanent)
{
   /*-- just fill them out --*/
   if (numargs)
      *numargs = 1;
   if (datatype)
      *datatype = KINT;
   if (permanent)
      *permanent = FALSE;
   if (argsize)
      *argsize = 1;
   
   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _print_coupling
|       Purpose: print the coupling attribute
|    Written By: Steve Kubica
|          Date: March 30, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_print_coupling(kobject obj, ktoken assoc, ktoken attrib, kaddr client_data,
		kfile *outfile)
{
   char *segment = ktoken_to_string(assoc);
   int coupling;

   if (!kdms_get_attribute(obj, segment, KDMS_COUPLING, &coupling))
      return FALSE;

   switch (coupling)
   {
      case KUNCOUPLED:
	 kfprintf(outfile,"KUNCOUPLED");
	 break;
      case KCOUPLED:
	 kfprintf(outfile,"KCOUPLED");
	 break;
      case KDEMAND:
	 kfprintf(outfile,"KDEMAND");
	 break;
      default:
	 kfprintf(outfile,"Invalid coupling (%d)", coupling);
	 break;
   }
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  KDMS_OPTIMAL_REGION_SIZE
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_optimal_region
|       Purpose: get the optimal region size attribute
|    Written By: Jeremy Worley and Steve Kubica
|          Date: October 4, 1993
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_optimal_region(kobject obj, ktoken assoc, ktoken attr, kaddr clientData,
		    kva_list *list)
{
   static int         osize[KDMS_MAX_DIM + 1];
   kdas_presentation *pres;
   int              **args;
   int                i;
   int                num = 1;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;

   if ((args = kva_arg(*list, int **)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   kdas_optimal_region_size(pres->dimension, pres->size, pres->datatype, 
			    osize);

   /*-- determine the number of regions --*/
   for (i = 0; i < pres->dimension; i++)
      num *= (int) (kceil((float)pres->size[i]/(float)osize[i]));
   osize[pres->dimension] = num;

   if (args) *args = osize;  /*-- point to our static copy --*/ 
   
   return TRUE;
}

/*********** ---------------------------------------------------------------
 ***********  Physical Layer Attributes
 *********** --------------------------------------------------------------- */

/*-----------------------------------------------------------
|  Routine Name: (static) _get_physical_size
|       Purpose: get the physical size attribute
|    Written By: Jeremy Worley
|          Date: August 13, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_physical_size(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		   kva_list *list)
{
   kdas_presentation *pres;
   int              **args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;
   
   if ((args = kva_arg(*list, int **)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = pres->segment->size;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_physical_size
|       Purpose: set the physical size attribute
|    Written By: Steve Kubica
|          Date: March 7, 1996
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_physical_size(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		   kva_list *list)
{
   kdas_presentation *pres;
   int               *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;
   
   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (!kdas_segment_set_size(pres->segment, args))
      return FALSE;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _get_physical_order
|       Purpose: get the physical order attribute
|    Written By: Jeremy Worley
|          Date: August 13, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_physical_order(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		    kva_list *list)
{
   kdas_presentation *pres;
   int              **args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;
   
   if ((args = kva_arg(*list, int **)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   *args = pres->segment->order;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_physical_order
|       Purpose: set the physical order attribute
|    Written By: Steve Kubica
|          Date: March 7, 1996
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_physical_order(kobject obj, ktoken assoc, ktoken attr, kaddr client_data,
		    kva_list *list)
{
   kdas_presentation *pres;
   int               *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;
   
   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (!kdas_segment_set_order(pres->segment, args))
      return FALSE;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _get_physical_datatype
|       Purpose: get the physical data type attribute
|    Written By: Jeremy Worley
|          Date: August 13, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_physical_datatype(kobject obj, ktoken assoc, ktoken attr, 
		       kaddr client_data, kva_list *list)
{
   kdas_presentation *pres;
   int               *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;
   
   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = pres->segment->datatype;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _set_physical_datatype
|       Purpose: set the physical datatype attribute
|    Written By: Steve Kubica
|          Date: March 7, 1996
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_set_physical_datatype(kobject obj, ktoken assoc, ktoken attr, 
		       kaddr client_data, kva_list *list)
{
   kdas_presentation *pres;
   int                args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;
   
   args = kva_arg(*list, int);

   if (!kdas_segment_set_datatype(pres->segment, args))
      return FALSE;

   return TRUE;
}

/*-----------------------------------------------------------
|  Routine Name: (static) _get_physical_dimension
|       Purpose: get the physical dimension attribute
|    Written By: Jeremy Worley
|          Date: August 13, 1994
-----------------------------------------------------------*/
/*ARGSUSED */
static int
_get_physical_dimension(kobject obj, ktoken assoc, ktoken attr, 
			kaddr client_data, kva_list *list)
{
   kdas_presentation *pres;
   int               *args;

   if ((pres = kdms_get_segtoken_info(obj, assoc)) == NULL)
      return FALSE;
   
   if ((args = kva_arg(*list, int *)) == NULL)
      kdas_fail_error(KDMS_ENULL_ATTR_ARGS);

   if (args) *args = pres->segment->dimension;

   return TRUE;
}

/* 
 *    ================================================================== 
 *    Initialization Routines
 *    ==================================================================
 */

/*-----------------------------------------------------------
|
|  Routine Name: kdms_init_attributes
|
|       Purpose: Initializes all attributes used by data services.
|
|         Input: none
|
|        Output: none
|
|       Returns: TRUE on success, FALSE otherwise
|
|    Written By: Jeremy Worley
|          Date: October 4, 1993
| Modifications:
|
------------------------------------------------------------*/
int
kdms_init_attributes(void)
{
   /*-- segment physical attributes --*/
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_DIMENSION, NULL,
			       _get_dimension, _set_dimension,
			       _match_dimension, _copy_dimension,
			       _query_dimension, _print_dimension);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_SIZE, NULL,
                               _get_size, _set_size, 
			       _match_size, _copy_size, 
			       _query_size, _print_size);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_INDEX_ORDER, NULL,
			       _get_order, _set_order, 
			       _match_order, _copy_order,
			       _query_order, _print_order);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_DATA_TYPE, NULL,
			       _get_datatype, _set_datatype,
			       _match_datatype, _copy_datatype,
			       _query_datatype, _print_datatype);

   /*-- segment presentation attributes --*/
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_COMPLEX_CONVERT, NULL,
			       _get_complex_convert, _set_complex_convert, 
			       _match_complex_convert, _copy_complex_convert,
			       _query_complex_convert, _print_complex_convert);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_SCALING, NULL,
			       _get_scaling, _set_scaling,
			       _match_scaling, _copy_scaling,
			       _query_scaling, _print_scaling);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_SCALE_FACTOR, NULL,
			       _get_scale_factor, _set_scale_factor,
			       _match_scale_factor, _copy_scale_factor,
			       _query_scale_factor, _print_scale_factor);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_SCALE_OFFSET, NULL,
			       _get_scale_offset, _set_scale_offset,
			       _match_scale_offset, _copy_scale_offset,
			       _query_scale_offset, _print_scale_offset);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_PAD_VALUE, NULL,
			       _get_pad_value, _set_pad_value,
			       _match_pad_value, _copy_pad_value,
			       _query_pad_value, _print_pad_value);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_NORM_MIN, NULL,
			       _get_norm_min, _set_norm_min,
			       _match_norm_min, _copy_norm_min,
			       _query_norm_min, _print_norm_min);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_NORM_MAX, NULL,
			       _get_norm_max, _set_norm_max,
			       _match_norm_max, _copy_norm_max,
			       _query_norm_max, _print_norm_max);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_INTERPOLATE, NULL,
			       _get_interpolate, _set_interpolate, 
			       _match_interpolate, _copy_interpolate, 
			       _query_interpolate, _print_interpolate);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_COUPLING, NULL,
			       _get_coupling, _set_coupling, 
			       _match_coupling, _copy_coupling, 
			       _query_coupling, _print_coupling);



   /*-- additional segment attributes --*/
   kdms_define_attribute(KDMS_ALL_SEGMENTS, KDMS_TRANSFERABLE, 1, 1, KINT,
			 TRUE, TRUE, TRUE);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_OPTIMAL_REGION_SIZE,
			       NULL, _get_optimal_region, NULL,
			       NULL, NULL, NULL, NULL);

   /*-- object attributes --*/
   kdms_define_quasi_attribute(KDMS_OBJECT, KDMS_NAME, NULL,
                               _get_name, _set_name, 
			       _match_name, _copy_name, 
			       _query_name, _print_name);
   kdms_define_quasi_attribute(KDMS_OBJECT, KDMS_FLAGS, NULL,
			       _get_flags, _set_flags, 
			       _match_flags, _copy_flags, 
			       _query_flags, _print_flags);
   kdms_define_quasi_attribute(KDMS_OBJECT, KDMS_FORMAT, NULL,
                               _get_format, _set_format, 
			       _match_format, _copy_format, 
			       _query_format, _print_format);
   kdms_define_quasi_attribute(KDMS_OBJECT, KDMS_ARCHITECTURE, NULL,
			       _get_architecture, _set_architecture, 
			       _match_architecture, _copy_architecture, 
			       _query_architecture, _print_architecture);
   kdms_define_attribute(KDMS_OBJECT, "FreeStructuresOnClose", 1, 1,
			 KINT, FALSE, FALSE, TRUE);
   kdms_define_attribute(KDMS_OBJECT, "DuplicateStructuresOnSet", 1, 1,
                         KINT, FALSE, FALSE, TRUE);


   /*-- handy physical attributes --*/
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_PHYSICAL_SIZE,
			       NULL,_get_physical_size, _set_physical_size, 
			       NULL, NULL, NULL, NULL);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_PHYSICAL_INDEX_ORDER, 
			       NULL, _get_physical_order, _set_physical_order,
			       NULL, NULL, NULL, NULL);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_PHYSICAL_DATA_TYPE,
			       NULL, _get_physical_datatype, 
			       _set_physical_datatype, 
			       NULL, NULL, NULL, NULL);
   kdms_define_quasi_attribute(KDMS_ALL_SEGMENTS, KDMS_PHYSICAL_DIMENSION, 
			       NULL, _get_physical_dimension, NULL, NULL,
                               NULL, NULL, NULL);

   /*-- multiple attribute defintions are possible with the format glue --*/
   errno = 0;  /*-- clear this out to avoid problems --*/
   
   return TRUE;
}
