 /*
  * Khoros: $Id: errors.c,v 1.1 1997/02/28 21:41:03 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: errors.c,v 1.1 1997/02/28 21:41:03 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		
   >>>>  Private:
   >>>>                 kgeom_init_errors()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

int
   KGEOM_ENO_PRIMITIVE_LIST,
   KGEOM_EFAILED_PRIMITIVE_LIST_SET,
   KGEOM_ENULL_PRIMITIVE_LIST_PROVIDED,
   KGEOM_EINVALID_NUMBER_PRIMITIVES,
   KGEOM_EINVALID_PRIMITIVE_POSITION,
   KGEOM_EPRIMITIVE_UNDEFINED,
   KGEOM_EPRIMITIVE_REDEFINED,
   KGEOM_EPRIMITIVE_NO_MATCH_POSITION,
   KGEOM_EMISSING_REQUIRED_COMPONENT,
   KGEOM_EINVALID_PRIMITIVE;

static kerrlist kgeom_errors[] = {
  { &KGEOM_ENO_PRIMITIVE_LIST,
    "No Primitive List Present\n"
    "Create using kgeom_create_primitive_list()"},
  { &KGEOM_EFAILED_PRIMITIVE_LIST_SET,
    "Failed to set the primitive list"},
  { &KGEOM_ENULL_PRIMITIVE_LIST_PROVIDED,
    "NULL primitive list provided"},
  { &KGEOM_EINVALID_NUMBER_PRIMITIVES,
    "Invalid Number of Primitives"},
  { &KGEOM_EINVALID_PRIMITIVE_POSITION,
    "Invalid Primitive Position"},
  { &KGEOM_EPRIMITIVE_UNDEFINED,
    "Undefined Primitive"},
  { &KGEOM_EPRIMITIVE_REDEFINED,
    "Primitive Already Defined"},
  { &KGEOM_EPRIMITIVE_NO_MATCH_POSITION,
    "Primitive Mismatch With Primitive at Current Position in Primitive List"},
  { &KGEOM_EMISSING_REQUIRED_COMPONENT,
    "Missing Required Data Component"},
  { &KGEOM_EINVALID_PRIMITIVE,
    "Invalid Primitive"},
};  

static size_t kgeom_number_errors = (size_t) knumber(kgeom_errors);

/*-----------------------------------------------------------
|
|  Routine Name: kgeom_init_errors
|
|       Purpose: Initialize the error messages for errno handling  
|
|         Input: None
|
|        Output: None
|
|       Returns: nothing
|
|    Written By: Steven Kubica 
|          Date: December 4, 1993 
| Modifications:
|
------------------------------------------------------------*/
void 
kgeom_init_errors(void)
{
   kerrno_init_errors(kgeom_errors, kgeom_number_errors);
}
