/*
  * Khoros: $Id: ButtonP.h,v 1.3 1997/01/20 05:10:05 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       label annotation.
   >>>>
   >>>>     Written By: Mark Young
   >>>>
   >>>>          Date: Apr 23, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kwidgets_ButtonP_h_
#define _kwidgets_ButtonP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <kwidgets/ManagerP.h>
#include <kwidgets/Button.h>

    /*-------------------------------------*
    |       defines
    ---------------------------------------*/

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwButtonWidgetClassPart
{
    XtPointer  extension;
} XvwButtonWidgetClassPart;

typedef struct _XvwButtonWidgetClassRec
{
   CoreClassPart	     core_class;
   CompositeClassPart	     composite_class;
   ConstraintClassPart	     constraint_class;
   XvwManagerWidgetClassPart manager_class;
   XvwButtonWidgetClassPart  button_class;
} XvwButtonWidgetClassRec;


typedef struct
{
   Boolean	  selected;
   int	  	  label_justify;
   int	  	  pixmap_justify;
   XtCallbackList arm_callback;
   XtCallbackList select_callback;


   Boolean	  armed;
   xvobject	  label;
   xvobject	  pixmap;
   xvobject	  atext;
   Pixmap  	  tile;
   Boolean	  handler_active;
   int		  select_type;
   int		  unselect_type;
   Boolean	  force_armed;
} XvwButtonPart;


typedef struct _XvwButtonWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwButtonPart  	button;
} XvwButtonWidgetRec;

typedef struct {int empty;} XvwButtonConstraintsPart;

typedef struct _XvwButtonWidgetConstraintsRec {
    XvwManagerConstraintsPart	  manager;
    XvwButtonConstraintsPart	  button;
} XvwButtonWidgetConstraintsRec, *XvwButtonWidgetConstraints;

typedef struct  _XvwButtonWidgetClassRec     *XvwButtonWidgetClass;
typedef struct  _XvwButtonWidgetRec          *XvwButtonWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwButtonWidget
 */
extern XvwButtonWidgetClassRec xvwButtonWidgetClassRec;


#endif /* _kwidgets_ButtonP_h_ */
/* Don't add after this point */
