 /*
  * Khoros: $Id: LabelP.h,v 1.3.2.6 1997/05/24 19:01:07 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       label annotation.
   >>>>
   >>>>     Written By: Mark Young
   >>>>
   >>>>          Date: Mar 2, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kwidgets_LabelP_h_
#define _kwidgets_LabelP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <kwidgets/ManagerObjP.h>
#include <kwidgets/Label.h>


    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwLabelGadgetClassPart
{
    XtPointer  extension;
} XvwLabelGadgetClassPart;

typedef struct _XvwLabelGadgetClassRec
{
    RectObjClassPart          rect_class;
    XvwManagerGadgetClassPart manager_class;
    XvwLabelGadgetClassPart  label_class;
} XvwLabelGadgetClassRec;


typedef struct
{
   int		  justify;
   Boolean	  emphasize;
   String	  string;
   Pixel          pixel;

   String         *lines;
   int            numlines;

   int            string_ascent;
   int            string_descent;
   Dimension      string_width; 
   Dimension      string_height;

   XtCallbackList cursor_callback;
   XtCallbackList paste_callback;

   /* the following are private fields used only to support the text widget */

   Boolean        display_cursor; /* allows cursor blink - when TRUE the
				     cursor is displayed, FALSE it isn't */

   Boolean        selectable;   /* allows cut & paste on label */

   int            cursor_pos;   /* cursor position overall in characters 
				   (eg, character 180) */
   int            cursor_xloc;  /* cursor x position in characters (eg, 4 
				   if cursor is at character 4 of line 8) */
   int            cursor_yloc;  /* cursor y position in characters (eg, 8
				   if cursor is at character 4 of line 8)*/
   int            cursor_x;     /* cursor x position in pixels */
   int            cursor_y;     /* cursor y position in pixels */

   int            x_indx1;      /* when a line is too long to fit in window, */
   int            x_indx2;	/* these are the indices of the first and last
		                   characters in the string to be displayed */
   int            y_indx1;      /* when there are too many lines to fit in  */
   int            y_indx2;      /* window, these are the indices of the first
			           and last lines to be displayed            */
   int            cut_cursor_pos1; /* cut buffer cursor pos 1 in characters */
   int            cut_cursor_pos2; /* cut buffer cursor pos 2 in characters */

   int            ydist;        /* number of pixels between each line of text */
   Boolean        multiline;    /* multiline true or false, only false if
				   set by text widget to false */

   Boolean        select_active;/* actively selecting text or not!!   */
   XtIntervalId   select_id;    /* timeout id for highlight selection */
   int            select_count; /* number of times the user clicked before
                                   the selection timeout is called */
} XvwLabelPart;


typedef struct _XvwLabelGadgetRec
{
    ObjectPart	   	object;
    RectObjPart     	rectobj;
    XvwManagerObjPart	manager;
    XvwLabelPart  	label;
} XvwLabelGadgetRec;


typedef struct  _XvwLabelGadgetClassRec     *XvwLabelGadgetClass;
typedef struct  _XvwLabelGadgetRec          *XvwLabelGadget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwLabelGadget
 */
extern XvwLabelGadgetClassRec xvwLabelGadgetClassRec;

#endif /* _kwidgets_LabelP_h_ */
/* Don't add after this point */
