/*
  * Khoros: $Id: ListP.h,v 1.3.2.1 1997/05/03 18:08:58 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for List object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Jun 15, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kwidgets_ListP_h_
#define _kwidgets_ListP_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

#include <kwidgets/List.h>
#include <kwidgets/ViewportP.h>


	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

typedef struct _XvwListWidgetClassPart
{
    XtPointer  extension;
} XvwListWidgetClassPart;

typedef struct _XvwListWidgetClassRec
{
    CoreClassPart		  core_class;
    CompositeClassPart		  composite_class;
    ConstraintClassPart		  constraint_class;
    XvwManagerWidgetClassPart     manager_class;
    XvwViewportWidgetClassPart    viewport_class;
    XvwListWidgetClassPart	  list_class;
} XvwListWidgetClassRec;

extern  XvwListWidgetClassRec xvwListWidgetClassRec;

typedef struct _XvwListPart
{
   kstring     *strings;
   kstring      string;
   int          size; 
   int          indx;
   XtIntervalId id;

   xvobject     label;

   XtCallbackList select_callback;
   XtCallbackList action_callback;
} XvwListPart;


typedef struct _XvwListWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwViewportPart	viewport;
    XvwListPart		list;
} XvwListWidgetRec;

typedef struct {int empty;} XvwListConstraintsPart;

typedef struct _XvwListWidgetConstraintsRec
{
    XvwManagerConstraintsPart     manager;
    XvwViewportConstraintsPart    viewport;
    XvwListConstraintsPart	  list;
} XvwListWidgetConstraintsRec, *textDisplayConstraints;

typedef struct _XvwListWidgetClassRec *XvwListWidgetClass;
typedef struct _XvwListWidgetRec      *XvwListWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwListWidget
 */
extern XvwListWidgetClassRec xvwListWidgetClassRec;


#endif /* _kwidgets_ListP_h_ */
/* Don't add after this point */
