/*
  * Khoros: $Id: ManagerObjP.h,v 1.5.2.1 1997/04/30 22:43:18 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private definitions for Manager Object
   >>>>
   >>>>     Written By: Mark Young & Danielle Argiro & John Salas
   >>>>
   >>>>          Date: Aug 25, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kwidgets_ManagerObjP_h_
#define _kwidgets_ManagerObjP_h_


        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <X11/RectObjP.h>
#include <xvwidgets/xvwidgetsP.h>
#include <kwidgets/ManagerObj.h>

        /*-------------------------------------*
        |       #defines
        ---------------------------------------*/

/*
 *  general tolerence in picking graphical objects
 */
#define PICK_TOLERANCE        6

#undef XtInheritEraseSel
#undef XtInheritRefreshSel
#define XtInheritEraseSel       ((void (*)(Widget))_XtInherit)
#define XtInheritRefreshSel     ((void (*)(Widget))_XtInherit)
#define XtInheritPicking        ((int  (*)(Widget, int, int))_XtInherit)
#define XtInheritChangeGeometry ((void (*)(Widget))_XtInherit)

        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/


typedef struct _XvwManagerGadgetClassPart
{
   int   (*pick_selection)    (Widget, int, int);
   void  (*erase_selection)   (Widget);
   void  (*refresh_selection) (Widget);
   void  (*change_geometry)   (Widget);
} XvwManagerGadgetClassPart;

typedef struct _XvwManagerGadgetClassRec
{
   RectObjClassPart		rect_class;
   XvwManagerGadgetClassPart	manager_class;
} XvwManagerGadgetClassRec;

extern XvwManagerGadgetClassRec xvwManagerGadgetClassRec;


typedef struct
{
    XtEventTable    event_table;	/* private to event dispatcher      */
    XtTMRec	    tm;                 /* translation management           */
    XtTranslations  accelerators;       /* accelerator translations         */
    Pixel	    border_pixel;	/* window border pixel		    */
    Pixmap          border_pixmap;	/* window border pixmap or NULL     */
    WidgetList      popup_list;         /* list of popups                   */
    Cardinal        num_popups;         /* how many popups                  */
    String          name;		/* widget resource name		    */
    Screen	    *screen;		/* window's screen		    */
    Colormap        colormap;           /* colormap                         */
    Window	    window;		/* window ID			    */
    Cardinal        depth;		/* number of planes in window       */
    Pixel	    background_pixel;	/* window background pixel	    */
    Pixmap          background_pixmap;	/* window background pixmap or NULL */
    Boolean         visible;		/* is window mapped and not ocluded?*/
    Boolean	    mapped_when_managed;/* map window if it's managed?      */
    Boolean	    force_redisplay;	/* force redisplay instead of expose*/
    Pixel           top_shadow;		/* need the top shadow pixel...     */
    Pixel           bottom_shadow;	/* need the bottom shadow pixel...  */

    Pixmap tile;		/* tile pixmap used for insensitive... (sigh) */
    GC	  foreground_gc;	/* general gc used by objects...       (sigh) */
    GC    background_gc;	/* the background gc for background... (sigh) */
    GC    border_gc;		/* the border gc for border...         (sigh) */
    GC    top_shadow_gc;	/* need the top shadow gc...           (sigh) */
    GC    bottom_shadow_gc;	/* need the bottom shadow gc...        (sigh) */
    int   shadow_type;		/* type of shadow to draw...           (sigh) */
    Dimension shadow_thickness; /* the shadow thickness...             (sigh) */

    Boolean mapped;
    Boolean realized;
    Pixel foreground;
    Pixel background;
    XFontStruct *font;
} XvwManagerObjPart;


typedef struct _XvwManagerGadgetRec
{
   ObjectPart	      object;
   RectObjPart        rectobj;
   XvwManagerObjPart  manager;
} XvwManagerGadgetRec;

typedef struct  _XvwManagerGadgetClassRec  *XvwManagerGadgetClass;
typedef struct  _XvwManagerGadgetRec       *XvwManagerGadget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwManagerGadget
 */
extern XvwManagerGadgetClassRec xvwManagerGadgetClassRec;

        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/
 
/* ManagerObj.c */
void ManagerObjForceRedisplay PROTO((Widget, Widget, int, Boolean *));
void ManagerObjChangeGeometry PROTO((WidgetClass, Widget));
void ManagerObjRealize        PROTO((WidgetClass, Widget));

#endif /* _kwidgets_ManagerObjP_h_ */
/* Do not add after this line */
