 /*
  * Khoros: $Id: MenuButton.h,v 1.2 1997/01/20 05:10:25 mirage Exp $
  */
 
 
/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */
 
 
/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Defines for the MenuButton Widget
   >>>>
   >>>>     Written By: Mark Young
   >>>>
   >>>>          Date: Apr 23, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */
 
#ifndef _kwidgets_MenuButton_h_
#define _kwidgets_MenuButton_h_
 
        /*-------------------------------------*
        |       #defines
        ---------------------------------------*/

/*------------------------------------------------------------------------
| Attribute:    XVW_MENUBUTTON_MENU
|
| Description:  This is a read-only attribute that will return the pointer
|		to the xvobject for the menu associated with the menubutton.
|               The menu is actually created by the menubutton object, and
|	        hence can only be used to retrieve rather than set via
|		this resource.
| Type:         xvobject
| Default:      NULL
| Legal Values: valid xvobject
| Resource:     N/A
------------------------------------------------------------------------*/
#define XVW_MENUBUTTON_MENU       "menubuttonMenu"

/*
 *  Define the Class name, by which people should be externally referencing
 *  the MenuButton Object by.
 */
#define MenuButtonWidgetClass	xvwMenuButtonWidgetClass

    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration MenuButtonWidgetClass
 */
extern   WidgetClass     MenuButtonWidgetClass;


        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

/*
 *  Khoros Function Definition for MenuMenuButton Widget
 */
xvobject xvw_create_menubutton PROTO((xvobject, char *));
xvobject xvw_retrieve_menu     PROTO((xvobject));


#endif /* _kwidgets_MenuButton_h_ */
/* Do not add after this line */
