/*
  * Khoros: $Id: ScrollbarP.h,v 1.4.2.1 1997/05/04 16:18:20 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       label annotation.
   >>>>
   >>>>     Written By: Mark Young
   >>>>
   >>>>          Date: Jun 15, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kwidgets_ScrollbarP_h_
#define _kwidgets_ScrollbarP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <kwidgets/ManagerP.h>
#include <kwidgets/Scrollbar.h>

    /*-------------------------------------*
    |       defines
    ---------------------------------------*/

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwScrollbarWidgetClassPart
{
    XtPointer  extension;
} XvwScrollbarWidgetClassPart;

typedef struct _XvwScrollbarWidgetClassRec
{
   CoreClassPart	     core_class;
   CompositeClassPart	     composite_class;
   ConstraintClassPart	     constraint_class;
   XvwManagerWidgetClassPart manager_class;
   XvwScrollbarWidgetClassPart  scrollbar_class;
} XvwScrollbarWidgetClassRec;


typedef struct
{
   double minval;
   double maxval;
   double value;
   double increment;
   int	  orientation;
   XtCallbackList cont_callback;
   XtCallbackList incr_callback;

   xvobject slider;
   xvobject incr;
   xvobject decr;

   int incr_direction;      /* current increment direction for auto-incr */
   XtIntervalId incr_id;    /* timeout id for auto-increment movement */
} XvwScrollbarPart;


typedef struct _XvwScrollbarWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwScrollbarPart  	scrollbar;
} XvwScrollbarWidgetRec;

typedef struct {int empty;} XvwScrollbarConstraintsPart;

typedef struct _XvwScrollbarWidgetConstraintsRec {
    XvwManagerConstraintsPart	  manager;
    XvwScrollbarConstraintsPart	  scrollbar;
} XvwScrollbarWidgetConstraintsRec, *XvwScrollbarWidgetConstraints;

typedef struct  _XvwScrollbarWidgetClassRec     *XvwScrollbarWidgetClass;
typedef struct  _XvwScrollbarWidgetRec          *XvwScrollbarWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwScrollbarWidget
 */
extern XvwScrollbarWidgetClassRec xvwScrollbarWidgetClassRec;


#endif /* _kwidgets_ScrollbarP_h_ */
/* Don't add after this point */
