/*
  * Khoros: $Id: Separator.h,v 1.2 1997/01/20 05:10:33 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Attributes of the Separator object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Apr 15, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kwidgets_Separator_h_
#define _kwidgets_Separator_h_

	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

/*------------------------------------------------------------------------
| Attribute:	XVW_SEPARATOR_TYPE
|
| Description:  This is the type of separator which can be either horizontal
|		or vertical.  Where the style of separator is drawn, such as
|		a solid line, dashed line, or none.
| Type:         int
| Default:      .symbol index KSEPARATOR_TYPE_SOLID
| Legal Values: .symbol index KSEPARATOR_TYPE_NONE
|               .symbol index KSEPARATOR_TYPE_SOLID
|               .symbol index KSEPARATOR_TYPE_DASHED
| Resource:     separatorType

------------------------------------------------------------------------*/
#define XVW_SEPARATOR_TYPE	 	"separatorType"

/*
 *  Separator Types for drawing seperation lines.
 */
#define KSEPARATOR_TYPE_NONE    0
#define KSEPARATOR_TYPE_SOLID   1
#define KSEPARATOR_TYPE_DASHED  2

/*------------------------------------------------------------------------
| Attribute:	XVW_SEPARATOR_ORIENTATION
|
| Description:  This is the type of separator which can be either horizontal
|		or vertical.  Where a horizontal separator draws a seperation
|		line that spans the parent horizontally
|               .symbol noindex KSEPARATOR_ORIENTATION_HORIZ.
|               Use the
|		.symbol index KSEPARATOR_ORIENTATION_VERT
|               for drawing vertical separator lines.
| Type:         int
| Default:      .symbol index KSEPARATOR_ORIENTATION_HORIZ
| Legal Values: .symbol index KSEPARATOR_ORIENTATION_HORIZ
|               .symbol index KSEPARATOR_ORIENTATION_VERT
| Resource:     separatorOrientation

------------------------------------------------------------------------*/
#define XVW_SEPARATOR_ORIENTATION	 	"separatorOrientation"

/*
 *  Separator Orientation for drawing seperation lines.
 */
#define KSEPARATOR_ORIENTATION_HORIZ  1
#define KSEPARATOR_ORIENTATION_VERT   2

/*
 *  Define the Class name, by which people should be externally referencing
 *  the Separator Object by.
 */
#define SeparatorGadgetClass	xvwSeparatorGadgetClass



    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration SeparatorGadgetClass
 */
extern   WidgetClass     SeparatorGadgetClass;


	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/*
 *  Khoros Function Definition for Separator Object
 */
xvobject xvw_create_separator PROTO((xvobject, char *));


#endif /* _kwidgets_Separator_h_ */
/* Don't add after this point */
