/*
  * Khoros: $Id: TextP.h,v 1.3.2.2 1997/04/30 22:43:21 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       label annotation.
   >>>>
   >>>>     Written By: Mark Young
   >>>>
   >>>>          Date: Jun 15, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _kwidgets_TextP_h_
#define _kwidgets_TextP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <kwidgets/ManagerP.h>
#include <kwidgets/Text.h>

    /*-------------------------------------*
    |       defines
    ---------------------------------------*/

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwTextWidgetClassPart
{
    XtPointer  extension;
} XvwTextWidgetClassPart;

typedef struct _XvwTextWidgetClassRec
{
   CoreClassPart	     core_class;
   CompositeClassPart	     composite_class;
   ConstraintClassPart	     constraint_class;
   XvwManagerWidgetClassPart manager_class;
   XvwTextWidgetClassPart    text_class;
} XvwTextWidgetClassRec;


typedef struct
{
   kstring string;
   kstring filename;

   int     edit_type;
   int     wrap_type;

   Boolean multiline;
   Boolean scroll_vert;
   Boolean scroll_horiz;

   int alloc_size;
   int orig_text_end;
   XtIntervalId blink_id;

   xvobject text;

   XtCallbackList enter_callback;

} XvwTextPart;

typedef struct _XvwTextWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwTextPart  	text;
} XvwTextWidgetRec;

typedef struct {int empty;} XvwTextConstraintsPart;

typedef struct _XvwTextWidgetConstraintsRec {
    XvwManagerConstraintsPart	  manager;
    XvwTextConstraintsPart	  text;
} XvwTextWidgetConstraintsRec, *XvwTextWidgetConstraints;

typedef struct  _XvwTextWidgetClassRec     *XvwTextWidgetClass;
typedef struct  _XvwTextWidgetRec          *XvwTextWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwTextWidget
 */
extern XvwTextWidgetClassRec xvwTextWidgetClassRec;

/*
 *  Utility routines
 */
int  CheckStringBufferSize   PROTO((XvwTextWidget, int));
void SetLabelLines           PROTO((XvwTextWidget, int *));
char *DeTabString            PROTO((char *, int *));

#endif /* _kwidgets_TextP_h_ */
/* Don't add after this point */
