 /*
  * Khoros: $Id: xvdbl.h,v 1.5 1997/01/20 05:10:51 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                          <<<<
   >>>>       Purpose: General Attributes for Double selections <<<<
   >>>>                                                          <<<<
   >>>>    Written By: Danielle Argiro                           <<<<
   >>>>                                                          <<<<
   >>>>          Date: Aug 4, 1995                               <<<<
   >>>>                                                          <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvforms_xvdbl_h_
#define _xvforms_xvdbl_h_


/*------------------------------------------------------------------------
| Attribute:    XVF_DOUBLE_DEF
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/DoubleDef.sec
| Type:         double
| Valid Items:  Doubles
| Legal Values: Any double value, within bounds specified by 
|		.symbol index XVF_DOUBLE_LOWER 
|		and 
|		.symbol index XVF_DOUBLE_UPPER
------------------------------------------------------------------------*/
#define XVF_DOUBLE_DEF            KVF_DOUBLE_DEF

/*------------------------------------------------------------------------
| Attribute:    XVF_DOUBLE_LOWER
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/DoubleLower.sec
| Type:         double
| Valid Items:  Doubles
| Legal Values: lower < 
|		.symbol index XVF_DOUBLE_UPPER
------------------------------------------------------------------------*/
#define XVF_DOUBLE_LOWER        KVF_DOUBLE_LOWER

/*------------------------------------------------------------------------
| Attribute:    XVF_DOUBLE_PREC
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/DoublePrec.sec
| Type:         double
| Valid Items:  Doubles
| Legal Values: 0 <= precision <= 10
------------------------------------------------------------------------*/
#define XVF_DOUBLE_PREC         KVF_DOUBLE_PREC

/*------------------------------------------------------------------------
| Attribute:    XVF_DOUBLE_UPPER
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/DoubleUpper.sec
| Type:         double
| Valid Items:  Doubles
| Legal Values: upper > 
|		.symbol index XVF_DOUBLE_LOWER
------------------------------------------------------------------------*/
#define XVF_DOUBLE_UPPER         KVF_DOUBLE_UPPER

/*------------------------------------------------------------------------
| Attribute:    XVF_DOUBLE_VAL
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/DoubleVal.sec
| Type:         double
| Valid Items:  Doubles
| Legal Values: Any double value, within bounds specified by 
|		.symbol index XVF_DOUBLE_LOWER 
|		and 
|		.symbol index XVF_DOUBLE_UPPER
------------------------------------------------------------------------*/
#define XVF_DOUBLE_VAL         KVF_DOUBLE_VAL

/*------------------------------------------------------------------------
| Attribute:    XVF_MECHANISM
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Mechanism.sec
| Type:         int
| Valid Items:  Integers
|               .br
|               Floats
|               .br
|               Doubles
| Legal Values: 0 or 1
------------------------------------------------------------------------*/
/* #define is actually in xvint.h, want entry repeated in table */

/*
 * the following are not public attributes
 */
#define XVF_DOUBLE_GT0_SEL      KVF_DOUBLE_GT0_SEL
#define XVF_DOUBLE_GE0_SEL      KVF_DOUBLE_GE0_SEL
#define XVF_DOUBLE_LT0_SEL      KVF_DOUBLE_LT0_SEL
#define XVF_DOUBLE_LE0_SEL      KVF_DOUBLE_LE0_SEL
#define XVF_DOUBLE_UPPER_SEL    KVF_DOUBLE_UPPER_SEL
#define XVF_DOUBLE_LOWER_SEL    KVF_DOUBLE_LOWER_SEL
#define XVF_DOUBLE_BOUNDS_SEL   KVF_DOUBLE_BOUNDS_SEL
#define XVF_DOUBLE_NOBOUNDS_SEL KVF_DOUBLE_NOBOUNDS_SEL

#endif /* _xvforms_xvdbl_h_ */
/* Don't add after this line */

