 /*
  * Khoros: $Id: xvgen.h,v 1.5 1997/01/20 05:10:55 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                          <<<<
   >>>>       Purpose: General Attributes for GUI selections     <<<<
   >>>>                                                          <<<<
   >>>>    Written By: Danielle Argiro                           <<<<
   >>>>                                                          <<<<
   >>>>          Date: Aug 4, 1995                               <<<<
   >>>>                                                          <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvforms_xvgen_h_
#define _xvforms_xvgen_h_


/*------------------------------------------------------------------------
| Attribute:    XVF_ACTIVATE
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Activate.sec
| Type:         int
| Valid Items:  Any GUI items \fIexcept\fP:
|               .br
|               Blanks
|               .br
|               Workspaces
| Legal Values: TRUE/FALSE
------------------------------------------------------------------------*/
#define XVF_ACTIVATE            KVF_ACTIVATE

/*------------------------------------------------------------------------
| Attribute:    XVF_BUTTONHEIGHT
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/ButtonHeight.sec
| Type:         float
| Valid Items:  Any GUI button, including:
|               .br
|               ActionButtons
|               .br
|               GuideButtons (panes)
|               .br
|               HelpButtons
|               .br
|               QuitButtons
|               .br
|               RoutineButtons
|               .br
|               SubformButtons (subforms)
| Legal Values: height > 0.0 (in characters)
------------------------------------------------------------------------*/
#define XVF_BUTTONHEIGHT        KVF_BUTTONHEIGHT

/*------------------------------------------------------------------------
| Attribute:    XVF_BUTTONTITLE
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/ButtonTitle.sec
| Type:         char *
| Valid Items:  Any GUI button, including:
|               .br
|               ActionButtons
|               .br
|               GuideButtons (panes)
|               .br
|               HelpButtons
|               .br
|               QuitButtons
|               .br
|               RoutineButtons
|               .br
|               SubformButtons (subforms)
| Legal Values: any string
------------------------------------------------------------------------*/
#define XVF_BUTTONTITLE         KVF_BUTTONTITLE

/*------------------------------------------------------------------------
| Attribute:    XVF_BUTTONWIDTH
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/ButtonWidth.sec
| Type:         float
| Valid Items:  Any GUI button, including:
|               .br
|               ActionButtons
|               .br
|               GuideButtons (panes)
|               .br
|               HelpButtons
|               .br
|               QuitButtons
|               .br
|               RoutineButtons
|               .br
|               SubformButtons (subforms)
| Legal Values: width > 0.0 (in characters)
------------------------------------------------------------------------*/
#define XVF_BUTTONWIDTH         KVF_BUTTONWIDTH

/*------------------------------------------------------------------------
| Attribute:    XVF_BUTTONX
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/ButtonX.sec
| Type:         float
| Valid Items:  Any GUI button, including:
|               .br
|               ActionButtons
|               .br
|               GuideButtons (panes)
|               .br
|               HelpButtons
|               .br
|               QuitButtons
|               .br
|               RoutineButtons
|               .br
|               SubformButtons (subforms)
| Legal Values: x > 0.0 (in characters)
------------------------------------------------------------------------*/
#define XVF_BUTTONX             KVF_BUTTONX

/*------------------------------------------------------------------------
| Attribute:    XVF_BUTTONY
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/ButtonY.sec
| Type:         float
| Valid Items:  Any GUI button, including:
|               .br
|               ActionButtons
|               .br
|               GuideButtons (panes)
|               .br
|               HelpButtons
|               .br
|               QuitButtons
|               .br
|               RoutineButtons
|               .br
|               SubformButtons (subforms)
| Legal Values: y > 0.0 (in characters)
------------------------------------------------------------------------*/
#define XVF_BUTTONY  KVF_BUTTONY

/*------------------------------------------------------------------------
| Attribute:    XVF_CLIENTDATA
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Clientdata.sec
| Type:         kaddr
| Valid Items:  Any GUI item \fIexcept\fP Form
| Legal Values: pointer to desired client_data 
------------------------------------------------------------------------*/
#define XVF_CLIENTDATA  KVF_CLIENTDATA

/*------------------------------------------------------------------------
| Attribute:    XVF_DELETE
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Delete.sec
| Type:         int
| Valid Items:  Any GUI items \fIexcept\fP:
|               .br
|               Forms
|               .br
|               GuidePanes
| Legal Values: TRUE (Action Attribute)
------------------------------------------------------------------------*/
#define XVF_DELETE  KVF_DELETE

/*
 * This is a private attribute used internally w/ menuforms
 */
#define XVF_DELETE_INTERACTIVE  "forms_delete_interactive"


/*------------------------------------------------------------------------
| Attribute:    XVF_DESCRIPTION
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Desc.sec
| Type:         char *
| Valid Items: 	ActionButtons
|               .br
|               Cycles
|               .br
|               DisplayLists
|               .br
|               Doubles
|               .br
|               Flags
|               .br
|               Floats
|               .br
|               HelpButtons
|               .br
|               InputFiles
|               .br
|               Integers
|               .br
|               Lists
|               .br
|               Logicals
|               .br
|               OutputFiles
|               .br
|               RoutineButtons
|               .br
|               Strings
|               .br
|               StringLists
|               .br
|               Toggles
|               .br
|               Workspaces
|               .br
| Legal Values: any string
------------------------------------------------------------------------*/
#define XVF_DESCRIPTION         KVF_DESCRIPTION

/*------------------------------------------------------------------------
| Attribute:    XVF_GUIDEPANE_TITLE
|
| Description: 	.include $DESIGN/manual/shared/xvforms/attribs/GuidePaneTitle.sec 
| Type:        	char *
| Valid Items: 	Subforms having a Guidepane
| Legal Values: any string
------------------------------------------------------------------------*/
#define XVF_GUIDEPANE_TITLE      KVF_GUIDEPANE_TITLE

/*------------------------------------------------------------------------
| Attribute:    XVF_GUIDEPANE_TITLE_XPOS
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/GuidePaneTitleXPos.sec
| Type:         float
| Valid Items:  Subforms having a Guidepane
| Legal Values: x >= 0.0
------------------------------------------------------------------------*/
#define XVF_GUIDEPANE_TITLE_XPOS     KVF_GUIDEPANE_TITLE_XPOS

/*------------------------------------------------------------------------
| Attribute:    XVF_GUIDEPANE_TITLE_YPOS
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/GuidePaneTitleYPos.sec
| Type:         float
| Valid Items:  Subforms having a Guidepane
| Legal Values: y >= 0.0
------------------------------------------------------------------------*/
#define XVF_GUIDEPANE_TITLE_YPOS      KVF_GUIDEPANE_TITLE_YPOS

/*------------------------------------------------------------------------
| Attribute:    XVF_HEIGHT
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Height.sec
| Type:         int
| Valid Items:  Any GUI items \fIexcept\fP:
|               .br
|               Blanks
| Legal Values: height > 0.0 (in characters)
------------------------------------------------------------------------*/
#define XVF_HEIGHT              KVF_HEIGHT

/*
 *  not for public consumption, for menuforms only
 */
#define XVF_HEIGHT_SEL		KVF_HEIGHT_SEL

/*------------------------------------------------------------------------
| Attribute:    XVF_HEIGHT_TACKED_SEL
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/HeightTacked.sec
| Type:         int
| Valid Items:  Any GUI items \fIexcept\fP:
|               .br
|               Blanks
| Legal Values: TRUE/FALSE
------------------------------------------------------------------------*/
#define XVF_HEIGHT_TACKED_SEL       KVF_HEIGHT_TACKED_SEL

/*------------------------------------------------------------------------
| Attribute:    XVF_LITERAL
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Literal.sec
| Type:         int
| Valid Items:  Doubles
|		.br
|		Floats
|		.br
|		InputFiles
|		.br
|		Integers
|		.br
|		OutputFiles
|		.br
|		Strings
|		.br
|		StringLists
|		.br
|		Toggles
| Legal Values: any string
------------------------------------------------------------------------*/
#define XVF_LITERAL             KVF_LITERAL

/*------------------------------------------------------------------------
| Attribute:    XVF_LIVE
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/Live.sec
| Type:         int
| Valid Items:  Cycles
|               .br
|               DisplayLists
|               .br
|               Doubles
|               .br
|               Flags
|               .br
|               Floats
|               .br
|               InputFiles
|               .br
|               Integers
|               .br
|               Lists
|               .br
|               Logicals
|               .br
|               OutputFiles
|               .br
|               Strings
|               .br
|               StringLists
|               .br
|               Toggles
|               .br
| Legal Values: TRUE/FALSE
------------------------------------------------------------------------*/
#define XVF_LIVE                KVF_LIVE

/*
 *  This is not a public attribute
 */
#define XVF_MODIFIED            KVF_MODIFIED

/*------------------------------------------------------------------------
| Attribute:    XVF_OPTIONAL
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/Optional.sec
| Type:         int
| Valid Items:  Cycles
|               .br
|               DisplayLists
|               .br
|               Doubles
|               .br
|               Flags
|               .br
|               Floats
|               .br
|               InputFiles
|               .br
|               Integers
|               .br
|               Lists
|               .br
|               Logicals
|               .br
|               OutputFiles
|               .br
|               Strings
|               .br
|               StringLists
|               .br
|               Toggles
|               .br
| Legal Values: TRUE/FALSE
------------------------------------------------------------------------*/
#define XVF_OPTIONAL            KVF_OPTIONAL

/*------------------------------------------------------------------------
| Attribute:    XVF_OPTSEL
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/OptSel.sec
| Type:         int
| Valid Items:  Cycles
|               .br
|               DisplayLists
|               .br
|               Doubles
|               .br
|               Flags
|               .br
|               Floats
|               .br
|               InputFiles
|               .br
|               Integers
|               .br
|               Lists
|               .br
|               Logicals
|               .br
|               OutputFiles
|               .br
|               Strings
|               .br
|               StringLists
|               .br
|               Toggles
|               .br
| Legal Values: TRUE/FALSE
------------------------------------------------------------------------*/
#define XVF_OPTSEL              KVF_OPTSEL

/*
 * this was created specially for use by guise
 */
#define XVF_PANE_GROUPRESIZE  KVF_PANE_GROUPRESIZE

/*
 * this is not a public attribute
 */
#define XVF_SELECTED            KVF_SELECTED

/*------------------------------------------------------------------------
| Attribute:    XVF_TITLE
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Title.sec
| Type:         char *
| Valid Items:  Any GUI item
| Legal Values: any string 
------------------------------------------------------------------------*/
#define XVF_TITLE               KVF_TITLE

/*------------------------------------------------------------------------
| Attribute:    XVF_VARIABLE
|
| Description: .include $DESIGN/manual/shared/xvforms/attribs/Variable.sec
| Type:         int
| Valid Items:  Any GUI item
| Legal Values: any string that will not cause C compiler syntax errors
------------------------------------------------------------------------*/
#define XVF_VARIABLE            KVF_VARIABLE


/*------------------------------------------------------------------------
| Attribute:    XVF_WIDTH
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Width.sec
| Type:         float
| Valid Items:  Any GUI items \fIexcept\fP:
|               .br
|               Blanks
| Legal Values: width > 0.0 (in characters)
------------------------------------------------------------------------*/
#define XVF_WIDTH               KVF_WIDTH

/*
 *  not for public consumption, for menuforms only
 */
#define XVF_WIDTH_SEL		KVF_WIDTH_SEL

/*------------------------------------------------------------------------
| Attribute:    XVF_WIDTH_TACKED_SEL
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/WidthTacked.sec
| Type:         int
| Valid Items:  Any GUI items \fIexcept\fP:
|               .br
|               Blanks
| Legal Values: TRUE/FALSE
------------------------------------------------------------------------*/
#define XVF_WIDTH_TACKED_SEL       KVF_WIDTH_TACKED_SEL

/*------------------------------------------------------------------------
| Attribute:    XVF_X
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/X.sec
| Type:         float
| Valid Items:  Any GUI items \fIexcept\fP:
|               .br
|               Blanks
| Legal Values: x >= 0.0 (in characters)
------------------------------------------------------------------------*/
#define XVF_X                   KVF_X

/*------------------------------------------------------------------------
| Attribute:    XVF_XPOS
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/XOffset.sec
| Type:         float
| Valid Items:  Forms
|               .br
|               GuidePanes
|               .br
|               Panes
|               .br
|               Subforms
|               .br
|               Toggles
|               .br
|               Blanks
| Legal Values: xpos >= 0.0
------------------------------------------------------------------------*/
#define XVF_XPOS                KVF_XPOS

/*------------------------------------------------------------------------
| Attribute:    XVF_Y
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Y.sec
| Type:         float
| Valid Items:  Any GUI items \fIexcept\fP:
|               .br
|               Blanks
| Legal Values: y >= 0.0 (in characters)
------------------------------------------------------------------------*/

#define XVF_Y                   KVF_Y

/*------------------------------------------------------------------------
| Attribute:    XVF_YPOS
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/YOffset.sec
| Type:         float
| Valid Items:  Any GUI items \fIexcept\fP:
|               .br
|               Blanks
| Legal Values: ypos >= 0.0 (in characters)
------------------------------------------------------------------------*/
#define XVF_YPOS                KVF_YPOS

#endif /* _xvforms_xvgen_h_ */
/* Don't add after this line */

