 /*
  * Khoros: $Id: xvint.h,v 1.5 1997/01/20 05:10:56 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                          <<<<
   >>>>       Purpose: Attributes for Integer selections         <<<<
   >>>>                                                          <<<<
   >>>>    Written By: Danielle Argiro                           <<<<
   >>>>                                                          <<<<
   >>>>          Date: Aug 4, 1995                               <<<<
   >>>>                                                          <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvforms_xvint_h_
#define _xvforms_xvint_h_


/*------------------------------------------------------------------------
| Attribute:    XVF_INT_DEF
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/IntDef.sec
| Type:         int
| Valid Items:  Integers
| Legal Values: Any integer value, within bounds specified by 
|		.symbol index XVF_INT_LOWER 
|		and 
|		.symbol index XVF_INT_UPPER
------------------------------------------------------------------------*/
#define XVF_INT_DEF            KVF_INT_DEF

/*------------------------------------------------------------------------
| Attribute:    XVF_INT_LOWER
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/IntLower.sec
| Type:         int
| Valid Items:  Integers
| Legal Values: lower < 
|		.symbol index XVF_INT_UPPER
------------------------------------------------------------------------*/
#define XVF_INT_LOWER        KVF_INT_LOWER

/*------------------------------------------------------------------------
| Attribute:    XVF_INT_UPPER
|
| Description:	.include $DESIGN/manual/shared/xvforms/attribs/IntUpper.sec
| Type:         int
| Valid Items:  Integers
| Legal Values: upper > 
|		.symbol index XVF_INT_LOWER
------------------------------------------------------------------------*/
#define XVF_INT_UPPER         KVF_INT_UPPER

/*------------------------------------------------------------------------
| Attribute:    XVF_INT_VAL
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/IntVal.sec
| Type:         int
| Valid Items:  Integers
| Legal Values: Any integer value, within bounds specified by 
|		.symbol index XVF_INT_LOWER 
|		and 
|		.symbol index XVF_INT_UPPER
------------------------------------------------------------------------*/
#define XVF_INT_VAL         KVF_INT_VAL

/*------------------------------------------------------------------------
| Attribute:    XVF_MECHANISM
|
| Description:  .include $DESIGN/manual/shared/xvforms/attribs/Mechanism.sec
| Type:         int
| Valid Items:  Integers
|		.br
|		Floats
|		.br
|		Doubles
| Legal Values: 0 or 1
------------------------------------------------------------------------*/
#define XVF_MECHANISM         KVF_MECHANISM

/*
 *  the following are not public attributes
 */
#define XVF_INT_GT0_SEL         KVF_INT_GT0_SEL
#define XVF_INT_GE0_SEL         KVF_INT_GE0_SEL
#define XVF_INT_LT0_SEL         KVF_INT_LT0_SEL
#define XVF_INT_LE0_SEL         KVF_INT_LE0_SEL
#define XVF_INT_UPPER_SEL       KVF_INT_UPPER_SEL
#define XVF_INT_LOWER_SEL       KVF_INT_LOWER_SEL
#define XVF_INT_BOUNDS_SEL      KVF_INT_BOUNDS_SEL
#define XVF_INT_NOBOUNDS_SEL    KVF_INT_NOBOUNDS_SEL


#endif /* _xvforms_xvint_h_ */
/* Don't add after this line */

