 /*
  * Khoros: $Id: AnimateP.h,v 1.6 1997/01/20 05:11:11 mirage Exp $
  */

 /*
  * $Log: AnimateP.h,v $
  * Revision 1.6  1997/01/20 05:11:11  mirage
  * Make gw, html added and copyright changes
  *
  * Revision 1.5  1996/04/19 09:34:01  mirage
  * update for cantata
  *
  * Revision 1.3  1996/02/17 20:48:58  fas
  * Copyright updated
  *
  * Revision 1.2  1995/12/06 01:30:22  mirage
  * Placing mirage under cvs
  *
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the animate
   >>>>		       animate display widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Oct 05, 1992 15:00
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_AnimateP_h_
#define _xvisual_AnimateP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ImageP.h>
#include <xvisual/Animate.h>


    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwAnimateWidgetClass
{
    XtPointer  extension;
} XvwAnimateWidgetClassPart;


typedef struct _XvwAnimateWidgetClassRec
{
    CoreClassPart		core_class;
    CompositeClassPart		composite_class;
    ConstraintClassPart		constraint_class;
    XvwManagerWidgetClassPart	manager_class;
    XvwGraphicsWidgetClassPart	graphics_class;
    XvwColorWidgetClassPart	color_class;
    XvwImageWidgetClassPart	image_class;
    XvwAnimateWidgetClassPart	animate_class;
} XvwAnimateWidgetClassRec;


typedef struct
{
    double  update_time;
    int     mode;
    int     control;
    int     direction;
    Boolean continous;
    XtIntervalId time_id;   /* Time interval Id for the XtTimeout */
    XtCallbackList update_callback;
} XvwAnimatePart;


typedef struct _XvwAnimateWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwImagePart	image;
    XvwAnimatePart	animate;
} XvwAnimateWidgetRec;


typedef struct  _XvwAnimateWidgetClassRec  *XvwAnimateWidgetClass;
typedef struct  _XvwAnimateWidgetRec       *XvwAnimateWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwAnimateWidget
 */
extern  XvwAnimateWidgetClassRec	xvwAnimateWidgetClassRec;


#endif /* _xvisual_AnimateP_h_ */
/* Don't add after this point */
