/*
  * Khoros: $Id: AreaP.h,v 1.6 1997/01/20 05:11:13 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       area manager.
   >>>>
   >>>>    Written By: John Salas and Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 11:21
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_AreaP_h_
#define _xvisual_AreaP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/GraphicsP.h>
#include <xvisual/Area.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwAreaWidgetClassPart
{
    XtPointer  extension;
} XvwAreaWidgetClassPart;


typedef struct _XvwAreaWidgetClassRec
{
    CoreClassPart		core_class;
    CompositeClassPart		composite_class;
    ConstraintClassPart		constraint_class;
    XvwManagerWidgetClassPart	manager_class;
    XvwGraphicsWidgetClassPart	graphics_class;
    XvwAreaWidgetClassPart	area_class;
} XvwAreaWidgetClassRec;

typedef struct
{
    Boolean	display_date;
    Boolean	display_title;
    Boolean	display_legend;

    xvobject	legend;
    xvobject	date;
    xvobject	title;

} XvwAreaPart;


typedef struct _XvwAreaWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwAreaPart		area;
} XvwAreaWidgetRec;

typedef struct
{
    Widget attach;		/* the widget in which to associate */
    klist  *list;		/* the widget in which to associate */
} XvwAreaConstraintsPart;

typedef struct _XvwAreaWidgetConstraintsRec {
    XvwManagerConstraintsPart	manager;
    XvwAreaConstraintsPart	area;
} XvwAreaWidgetConstraintsRec, *XvwAreaWidgetConstraints;

typedef struct  _XvwAreaWidgetClassRec     *XvwAreaWidgetClass;
typedef struct  _XvwAreaWidgetRec          *XvwAreaWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwAreaWidget
 */
extern  XvwAreaWidgetClassRec xvwAreaWidgetClassRec;

#endif /* _xvisual_AreaP_h_ */
/* Don't add after this point */
