/*
  * Khoros: $Id: Axis2DP.h,v 1.5 1997/01/20 05:11:17 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       2D Axis object.
   >>>>
   >>>>    Written By: John Salas and Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 11:26
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_Axis2DP_h_
#define _xvisual_Axis2DP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/AxisP.h>
#include <xvisual/Axis2D.h>


    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwAxis2DGadgetClassPart
{
    XtPointer  extension;
} XvwAxis2DGadgetClassPart;

typedef struct _XvwAxis2DGadgetClassRec
{
    RectObjClassPart	       rect_class;
    XvwManagerGadgetClassPart  manager_class;
    XvwGraphicsGadgetClassPart graphics_class;
    XvwAxis2DGadgetClassPart   axis2d_class;
} XvwAxis2DGadgetClassRec;

typedef struct
{
    XVGraphicsID id;
    xvobject	 axis_x; 
    xvobject	 axis_y;
    Boolean      show_axis_x; 
    Boolean      show_axis_y;
    Boolean      show_axis_x_label; 
    Boolean      show_axis_y_label;
    Boolean      show_axis_x_tic_labels; 
    Boolean      show_axis_y_tic_labels;
} XvwAxis2DPart;

typedef struct _XvwAxis2DGadgetRec {
    ObjectPart		object;
    RectObjPart		rectobj;
    XvwManagerObjPart	manager;
    XvwGraphicsPart	graphics;
    XvwAxis2DPart	axis2d;
} XvwAxis2DGadgetRec;

typedef struct  _XvwAxis2DGadgetClassRec     *XvwAxis2DGadgetClass;
typedef struct  _XvwAxis2DGadgetRec          *XvwAxis2DGadget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwAxis2DGadget
 */
extern XvwAxis2DGadgetClassRec xvwAxis2DGadgetClassRec;


#endif /* _xvisual_Axis2DP_h_ */
/* Don't add after this point */
