/*
  * Khoros: $Id: ColorCellP.h,v 1.5 1997/01/20 05:11:29 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the color colorcell
   >>>>		       widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 15:05
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_ColorCellP_h_
#define _xvisual_ColorCellP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ColorP.h>
#include <xvisual/ColorCell.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwColorCellWidgetClass
{
    XtPointer extension;
} XvwColorCellWidgetClassPart;


typedef struct _XvwColorCellWidgetClassRec
{
    CoreClassPart		core_class;
    CompositeClassPart          composite_class;
    ConstraintClassPart         constraint_class;
    XvwManagerWidgetClassPart   manager_class;
    XvwGraphicsWidgetClassPart  graphics_class;
    XvwColorWidgetClassPart	color_class;
    XvwColorCellWidgetClassPart	colorcell_class;
} XvwColorCellWidgetClassRec;


typedef struct
{
    /*  resources  */
    int      red;
    int	     green;
    int	     blue;
    int      index;
    kaddr    *maps;
    xvobject value;
    Boolean  show_index;
    Boolean  update_onadd;
    Boolean  restore_ondelete;
    Boolean  save_color;
    int      num, *indexes;

} XvwColorCellPart;


typedef struct _XvwColorCellWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwColorCellPart	colorcell;
} XvwColorCellWidgetRec;


typedef struct  _XvwColorCellWidgetClassRec  *XvwColorCellWidgetClass;
typedef struct  _XvwColorCellWidgetRec       *XvwColorCellWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwColorCellWidget
 */
extern  XvwColorCellWidgetClassRec xvwColorCellWidgetClassRec;


#endif /* _xvisual_ColorCellP_h_ */
/* Don't add after this point */
