/*
  * Khoros: $Id: Date.h,v 1.5 1997/01/20 05:11:31 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: #defines and #includes for creating a
   >>>>		       graphical date annotation.
   >>>>
   >>>>    Written By: Steven Kubica, John Salas, and Mark Young
   >>>>
   >>>>          Date: Aug 06, 1992 06:53
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_Date_h_
#define _xvisual_Date_h_

	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

/*
 *  Attribute definitions for Date Visual Object
 */

/*------------------------------------------------------------------------
| Attribute:    XVW_DATE_FORMAT
| Description:  The format in which the date is displayed.  Formatting strings 
|		may use any of the following field descriptors, which are 
|		taken directly from the \fHstrftime\fP man page 
|		(\f(CW% man strftime\fP for more information):
|		.nf
|		%%      same as %
|		%a      day of week, using locale's abbreviated weekday names
|		%A      day of week, using locale's full weekday names
|		%b      month, using locale's abbreviated month names
|		%B      month, using locale's full month names
|		%c      date and time as %x %X
|		%C      date and time, in locale's long-format representation
|		%d      day of month (01-31)
|		%D      date as %m/%d/%y
|		%e      day of month (1-31; single digits are preceded by a blank)
|		%H      hour (00-23)
|		%I      hour (00-12)
|		%j      day number of year (001-366)
|		%k      hour (0-23; single digits are preceded by a blank)
|		%l      hour (1-12; single digits are preceded by a blank)
|		%m      month number (01-12)
|		%M      minutes (0-59)
|		%n      carriage return
|		%p      locale's equivalent of AM or PM
|		%r      time as %I:%M:%S %p
|		%R      time as %H:%M
|		%S      seconds (00-59)
|		%t      tab
|		%T      time as %H:%M:%S
|		%U      week number of year (01-52), Sunday is the first day of the week
|		%w      day of week; Sunday is day 0
|		%W      week number of year (01-52), Monday is the first day of the week
|		%x      date, using locale's date format
|		%X      time, using locale's time format
|		%y      year within century (00-99)
|		%Y      year, including century (for example, 1988)
|		%Z      time zone abbreviation
|		.fi
|		The difference between %U  and  %W  lies  in  which  day  is
|		counted as the first day of the week.  Week number 01 is the
|		first week with four or more January days in it.

| Type:         char *
| Default:      \f(CW%h %d, 19%y %H:%M\fP
| Legal Values: see description
| Resource:     dateFormat
------------------------------------------------------------------------*/
#define XVW_DATE_FORMAT       "dateFormat"

/*------------------------------------------------------------------------
| Attribute:    XVW_DATE_UPDATETIME
| Description:  This integer value specifies how often, in seconds, that the 
|		date is updated.  The default is to update the date every 
|		second.
| Type:         int
| Default:      1
| Legal Values: values > 0
| Resource:     dateUpdatetime
------------------------------------------------------------------------*/
#define XVW_DATE_UPDATETIME   "dateUpdatetime"

/*
 *  Define the Class name, by which people should be externally referencing
 *  the Date Object by.
 */
#define DateGadgetClass	xvwDateGadgetClass

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/*
 *  Function definitions for Date Visual Object
 */
xvobject xvw_create_date PROTO((xvobject, char *));


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit WidgetClass Declaration DateGadgetClass
 */
extern   WidgetClass     DateGadgetClass;


#endif /* _xvisual_Date_h_ */
/* Don't add after this point */
