/*
  * Khoros: $Id: DateP.h,v 1.5 1997/01/20 05:11:32 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       date annotation.
   >>>>
   >>>>    Written By: Steven Kubica, John Salas, and Mark Young
   >>>>
   >>>>          Date: Aug 06, 1992 06:24
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_DateP_h_
#define _xvisual_DateP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/StringP.h>
#include <xvisual/Date.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwDateGadgetClassPart
{
    XtPointer  extension;
} XvwDateGadgetClassPart;

typedef struct _XvwDateGadgetClassRec
{
    RectObjClassPart		rect_class;
    XvwManagerGadgetClassPart   manager_class;
    XvwGraphicsGadgetClassPart  graphics_class;
    XvwStringGadgetClassPart    string_class;
    XvwDateGadgetClassPart      date_class;
} XvwDateGadgetClassRec;


typedef struct
{
    int	         update_time;
    String       format;
    XtIntervalId time_id;   /* Time interval Id for the XtTimeout */
} XvwDatePart;


typedef struct _XvwDateGadgetRec
{
    ObjectPart	   	object;
    RectObjPart     	rectobj;
    XvwManagerObjPart	manager;
    XvwGraphicsPart	graphics;
    XvwStringPart  	string;
    XvwDatePart		date;
} XvwDateGadgetRec;


typedef struct  _XvwDateGadgetClassRec     *XvwDateGadgetClass;
typedef struct  _XvwDateGadgetRec          *XvwDateGadget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwDateGadget
 */
extern XvwDateGadgetClassRec xvwDateGadgetClassRec;


#endif /* _xvisual_DateP_h_ */
/* Don't add after this point */
