/*
  * Khoros: $Id: EllipseP.h,v 1.4 1997/01/20 05:11:34 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       ellipse annotation.
   >>>>
   >>>>    Written By: Danielle Argiro & Steve Kubica
   >>>>
   >>>>          Date: January 8, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_EllipseP_h_
#define _xvisual_EllipseP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/GraphicsP.h>
#include <xvisual/Ellipse.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwEllipseGadgetClassPart
{
    XtPointer  extension;
} XvwEllipseGadgetClassPart;


typedef struct _XvwEllipseGadgetClassRec
{
    RectObjClassPart		rect_class;
    XvwManagerGadgetClassPart   manager_class;
    XvwGraphicsGadgetClassPart  graphics_class;
    XvwEllipseGadgetClassPart   ellipse_class;
} XvwEllipseGadgetClassRec;

typedef struct
{
  Coord     center;
  double    width;
  double    height;
} XvwEllipsePart;


typedef struct _XvwEllipseGadgetRec
{
    ObjectPart		object;
    RectObjPart  	rectobj;
    XvwManagerObjPart	manager;
    XvwGraphicsPart	graphics;
    XvwEllipsePart	ellipse;
} XvwEllipseGadgetRec;

typedef struct  _XvwEllipseGadgetClassRec  *XvwEllipseGadgetClass;
typedef struct  _XvwEllipseGadgetRec       *XvwEllipseGadget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwEllipseGadget
 */
extern XvwEllipseGadgetClassRec xvwEllipseGadgetClassRec;


#endif /* _xvisual_EllipseP_h_ */
/* Don't add after this point */
