/*
  * Khoros: $Id: GraphicsSymmetry.h,v 1.5 1997/01/20 05:11:43 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: #defines for graphics attributes that
   >>>>                control symmetry.
   >>>>
   >>>>    Written By: John Salas, Danielle Argiro, Mark Young
   >>>>
   >>>>          Date: Aug 20, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_GraphicsSymmetry_h_
#define _xvisual_GraphicsSymmetry_h_

	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_SYMMETRIC_X
| Description:  When TRUE, this attribute specifies that world coordinates 
|               are symmetric in the X direction.  
| Type:         int
| Default:      FALSE
| Legal Values: TRUE/FALSE
| Resource:     graphicsSymmetricX
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_SYMMETRIC_X        "graphicsSymmetricX"

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_SYMMETRIC_Y
| Description:  When TRUE, this attribute specifies that world coordinates 
|               are symmetric in the Y direction.  
| Type:         int
| Default:      FALSE
| Legal Values: TRUE/FALSE
| Resource:     graphicsSymmetricY
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_SYMMETRIC_Y        "graphicsSymmetricY"

/*------------------------------------------------------------------------
| Attribute:    XVW_GRAPHICS_SYMMETRIC_Z
| Description:  When TRUE, this attribute specifies that world coordinates 
|               are symmetric in the Z direction.  
| Type:         int
| Default:      FALSE
| Legal Values: TRUE/FALSE
| Resource:     graphicsSymmetricZ
------------------------------------------------------------------------*/
#define XVW_GRAPHICS_SYMMETRIC_Z        "graphicsSymmetricZ"

#endif /* _xvisual_GraphicsSymmetry_h_ */
/* Don't add after this point */
