/*
  * Khoros: $Id: ImageIcon.h,v 1.5 1997/01/20 05:11:47 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: #defines and #includes for creating a
   >>>>		       ImageIcon widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Nov 17, 1993
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_ImageIcon_h_
#define _xvisual_ImageIcon_h_

    /*-------------------------------------*
    |       #defines 
    ---------------------------------------*/

/*
 *  Attribute definitions for Image Icon Visual Object
 */

/*------------------------------------------------------------------------
| Attribute:    XVW_IMAGEICON_SIZE
| Description:  This integer value specifies the size of the icon in pixels.  
|		The image icon size should always be used rather than setting 
|		width and height separately; otherwise, the image may not be 
|		proportionally correct.
| Type:         int
| Default:      100
| Legal Values: value > 0
| Resource:     imageiconSize
------------------------------------------------------------------------*/
#define  XVW_IMAGEICON_SIZE	 "imageiconSize"

/*
 *  Define the Class name, by which people should be externally referencing
 *  the ImageIcon Object by.
 */
#define ImageIconWidgetClass	xvwImageIconWidgetClass

    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration for ImageIconWidgetClass
 */
extern   WidgetClass     ImageIconWidgetClass;


    /*-------------------------------------*
    |       routine definitions
    ---------------------------------------*/

/*
 *  Function definitions for Image Icon Visual Object
 */
xvobject xvw_create_imageicon  PROTO((xvobject, char *));

#endif /* _xvisual_ImageIcon_h_ */
/* Don't add after this point */
