/*
  * Khoros: $Id: ImageP.h,v 1.8 1997/01/20 05:11:50 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the image
   >>>>		       display widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 14:17
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_ImageP_h_
#define _xvisual_ImageP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ColorP.h>
#include <xvisual/Image.h>

#ifdef KMITSHM_DEF
#include <X11/extensions/XShm.h>
#endif /* KMITSHM_DEF */


    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwImageWidgetClass
{
    XtPointer  extension;
} XvwImageWidgetClassPart;


typedef struct _XvwImageWidgetClassRec
{
    CoreClassPart		core_class;
    CompositeClassPart		composite_class;
    ConstraintClassPart		constraint_class;
    XvwManagerWidgetClassPart	manager_class;
    XvwGraphicsWidgetClassPart	graphics_class;
    XvwColorWidgetClassPart	color_class;
    XvwImageWidgetClassPart	image_class;
} XvwImageWidgetClassRec;


typedef struct
{
    /*  resources  */
    kobject	iobject;
    kobject	cobject;
    kobject	mobject;
    Pixel	pixel;
    double	value;
    Boolean	backing;
    int		xoffset;
    int		yoffset;
    int		xposition;
    int		yposition;

    kaddr	shminfo;
    XImage	*ximage;
    XImage	*xclip;
    XImage	*xcolormap;
    XImage	*xoverlay;
    Pixmap	pixmap;

    int		band_number;
    int		band_maxnum;
    int		complex_convert;
    int		band_dimensions;
    int		image_depth;
    int		wsize, hsize, esize, dsize, tsize;
    int		roi_shape;
    int         roi_policy;
    int		roi_presentation;
    int		max_width, max_height;
    Boolean     roi_multiband;
    Boolean     multiple_roi;
    double	xmag, ymag;

    Boolean     reload;
    Boolean     redisplay;
    Boolean     recolor;
    Boolean     resize;
    Boolean	has_alpha;
    int		reload_type;
    XtCallbackList  update_callback;

    kaddr	idata;
    kaddr	cdata;
    kaddr	mdata;
    kaddr	ldata;
    kaddr	alpha;
    double	alpha_offset;
    double	alpha_factor;
} XvwImagePart;


typedef struct _XvwImageWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwImagePart	image;
} XvwImageWidgetRec;


typedef struct  _XvwImageWidgetClassRec    *XvwImageWidgetClass;
typedef struct  _XvwImageWidgetRec         *XvwImageWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwImageWidget
 */
extern  XvwImageWidgetClassRec xvwImageWidgetClassRec;

        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/
 
/* ImageUtil.c */
void ImageInit		 PROTO((Widget));
void ImageReloadXData    PROTO((Widget, int, int, int, int, int));
void ImageReload         PROTO((Widget, kdms_callback *));
void ImageSetPosition    PROTO((Widget, int, int, int));
void ImageUpdatePosition PROTO((xvobject, kaddr, XEvent *, int *));
int ImageGetRoi 	 PROTO((xvobject, char *, kaddr));
int ImageSetRoi 	 PROTO((xvobject, char *, kaddr));
int ImageGetName         PROTO((xvobject, char *, kaddr));
int ImageSetName         PROTO((xvobject, char *, kaddr));


#endif /* _xvisual_ImageP_h_ */
/* Don't add after this point */
