/*
  * Khoros: $Id: IndicatorP.h,v 1.5 1997/01/20 05:11:52 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       indicator annotation.
   >>>>
   >>>>    Written By: John Salas & Mark Young
   >>>>
   >>>>          Date: Feb 05, 1993 13:54
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_IndicatorP_h_
#define _xvisual_IndicatorP_h_

    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/MarkerP.h>
#include <xvisual/Indicator.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwIndicatorGadgetClassPart
{
    XtPointer  extension;
} XvwIndicatorGadgetClassPart;


typedef struct _XvwIndicatorGadgetClassRec
{
    RectObjClassPart         rect_class;
    XvwManagerGadgetClassPart   manager_class;
    XvwGraphicsGadgetClassPart  graphics_class;
    XvwMarkerGadgetClassPart    marker_class;
    XvwIndicatorGadgetClassPart indicator_class;
} XvwIndicatorGadgetClassRec;

typedef struct
{
    int	     constraint;
    xvobject xpos;
    xvobject ypos;
    xvobject xline;
    xvobject yline;
    double   xpos_value;
    double   ypos_value;
    int      indicator_line;
    Boolean  show_xpos;
    Boolean  show_ypos;
} XvwIndicatorPart;


typedef struct _XvwIndicatorGadgetRec
{
    ObjectPart		object;
    RectObjPart  	rectobj;
    XvwManagerObjPart	manager;
    XvwGraphicsPart	graphics;
    XvwMarkerPart	marker;
    XvwIndicatorPart	indicator;
} XvwIndicatorGadgetRec;


typedef struct  _XvwIndicatorGadgetClassRec  *XvwIndicatorGadgetClass;
typedef struct  _XvwIndicatorGadgetRec       *XvwIndicatorGadget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwIndicatorGadget
 */
extern XvwIndicatorGadgetClassRec xvwIndicatorGadgetClassRec;


#endif /* _xvisual_IndicatorP_h_ */
/* Don't add after this point */
