/*
  * Khoros: $Id: PaletteP.h,v 1.5 1997/01/20 05:11:58 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the color palette
   >>>>		       widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 15:05
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_PaletteP_h_
#define _xvisual_PaletteP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ColorP.h>
#include <xvisual/Palette.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwPaletteWidgetClass
{
    XtPointer extension;
} XvwPaletteWidgetClassPart;


typedef struct _XvwPaletteWidgetClassRec
{
    CoreClassPart		core_class;
    CompositeClassPart          composite_class;
    ConstraintClassPart         constraint_class;
    XvwManagerWidgetClassPart   manager_class;
    XvwGraphicsWidgetClassPart  graphics_class;
    XvwColorWidgetClassPart	color_class;
    XvwPaletteWidgetClassPart	palette_class;
} XvwPaletteWidgetClassRec;


typedef struct
{
   /*  resources  */
   int    type;
   GC	  gc1, gc2;
   int    indexnum;
   int    *indexes;

   Boolean  select;
   int	    index1, index2;
   int	    *old_indexes, old_indexnum;
   XtCallbackList update_callback;


} XvwPalettePart;


typedef struct _XvwPaletteWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwPalettePart	palette;
} XvwPaletteWidgetRec;


typedef struct  _XvwPaletteWidgetClassRec  *XvwPaletteWidgetClass;
typedef struct  _XvwPaletteWidgetRec       *XvwPaletteWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwPaletteWidget
 */
extern  XvwPaletteWidgetClassRec	xvwPaletteWidgetClassRec;


#endif /* _xvisual_PaletteP_h_ */
/* Don't add after this point */
