/*
  * Khoros: $Id: Plot2DP.h,v 1.9 1997/01/20 05:12:04 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       plot2d object.
   >>>>
   >>>>    Written By: John Salas and Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 14:30
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_Plot2DP_h_
#define _xvisual_Plot2DP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ColorP.h>
#include <xvisual/Plot2D.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwPlot2DGadgetClassPart
{
    XtPointer  extension;
} XvwPlot2DGadgetClassPart;


typedef struct _Plot2DObjClassRec
{
    RectObjClassPart            rect_class;
    XvwManagerGadgetClassPart   manager_class;
    XvwGraphicsGadgetClassPart  graphics_class;
    XvwColorGadgetClassPart     color_class;
    XvwPlot2DGadgetClassPart    plot2d_class;
} XvwPlot2DGadgetClassRec;


typedef struct
{
    String  plot_name;

    Boolean reset_wc;

    double  data_max_x;
    double  data_max_y;
    double  data_min_x;
    double  data_min_y;

    kobject pobject;

    Coord   *points;

    int	    plot_type;
    int	    plot_size;

    int     roi_shape;
    int     roi_policy;

    char    *highlight_color;

    int     color_origination;
    int     x_orientation;
    int     width_offset;
    int     height_offset;
    int     depth_offset;
    int     time_offset;
    int     elements_offset;
    int     extract_size;

} XvwPlot2DPart;


typedef struct _XvwPlot2DGadgetRec
{
    ObjectPart		object;
    RectObjPart		rectangle;
    XvwManagerObjPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwPlot2DPart	plot2d;
} XvwPlot2DGadgetRec;


typedef struct  _XvwPlot2DGadgetClassRec   *XvwPlot2DGadgetClass;
typedef struct  _XvwPlot2DGadgetRec        *XvwPlot2DGadget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwPlot2DGadget
 */
extern XvwPlot2DGadgetClassRec xvwPlot2DGadgetClassRec;

/*
 *  prototype for 2D Plot ROI extraction
 */
int  Plot2DGetRoi      PROTO((xvobject, char *, kaddr));

/*
 *  prototypes for utilities in Plot2Dutil.c 
 */
int  Plot2DDeletePtsInteractively PROTO((xvobject, char *, kaddr));
int  Plot2DColorPtsInteractively  PROTO((xvobject, char *, kaddr));
void Plot2DFindMinMax             PROTO((XvwPlot2DGadget));
int  Plot2DCheckOffset            PROTO((Widget, Widget));



#endif /* _xvisual_Plot2DP_h_ */
/* Don't add after this point */
