/*
  * Khoros: $Id: PolylineP.h,v 1.5 1997/01/20 05:12:08 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       polyline annotation.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Nov 11, 1993
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_PolylineP_h_
#define _xvisual_PolylineP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/GraphicsP.h>
#include <xvisual/Polyline.h>


    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwPolylineGadgetClassPart
{
    XtPointer  extension;
} XvwPolylineGadgetClassPart;

typedef struct _XvwPolylineGadgetClassRec
{
    RectObjClassPart        rect_class;
    XvwManagerGadgetClassPart  manager_class;
    XvwGraphicsGadgetClassPart graphics_class;
    XvwPolylineGadgetClassPart     line_class;
} XvwPolylineGadgetClassRec;


typedef struct
{
    int	    numpts;
    Coord   *points;
} XvwPolylinePart;


typedef struct _XvwPolylineGadgetRec
{
    ObjectPart	   	object;
    RectObjPart     	rectobj;
    XvwManagerObjPart	manager;
    XvwGraphicsPart	graphics;
    XvwPolylinePart  	polyline;
} XvwPolylineGadgetRec;


typedef struct  _XvwPolylineGadgetClassRec     *XvwPolylineGadgetClass;
typedef struct  _XvwPolylineGadgetRec          *XvwPolylineGadget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwPolylineGadget
 */
extern XvwPolylineGadgetClassRec xvwPolylineGadgetClassRec;


#endif /* _xvisual_PolylineP_h_ */
/* Don't add after this point */
