/*
  * Khoros: $Id: PositionP.h,v 1.5 1997/01/20 05:12:10 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the graphical
   >>>>		       position annotation.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Nov 17, 1992 10:20
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_PositionP_h_
#define _xvisual_PositionP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/StringP.h>
#include <xvisual/Position.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwPositionGadgetClassPart
{
    XtPointer  extension;
} XvwPositionGadgetClassPart;

typedef struct _XvwPositionGadgetClassRec
{
    RectObjClassPart         rect_class;
    XvwManagerGadgetClassPart   manager_class;
    XvwGraphicsGadgetClassPart  graphics_class;
    XvwStringGadgetClassPart    string_class;
    XvwPositionGadgetClassPart  position_class;
} XvwPositionGadgetClassRec;


typedef struct
{
    kobject object;
    Boolean show_value;
    int     update_mode;

    /* internal resources */
    Boolean rgb;
    Boolean complex;

} XvwPositionPart;


typedef struct _XvwPositionGadgetRec
{
    ObjectPart	   	object;
    RectObjPart     	rectobj;
    XvwManagerObjPart	manager;
    XvwGraphicsPart	graphics;
    XvwStringPart  	string;
    XvwPositionPart	position;
} XvwPositionGadgetRec;


typedef struct  _XvwPositionGadgetClassRec *XvwPositionGadgetClass;
typedef struct  _XvwPositionGadgetRec      *XvwPositionGadget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwPositionGadget
 */
extern XvwPositionGadgetClassRec xvwPositionGadgetClassRec;


#endif /* _xvisual_PositionP_h_ */
/* Don't add after this point */
