/*
  * Khoros: $Id: PrintMapValP.h,v 1.6 1997/01/20 05:12:13 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the color printmapval
   >>>>		       widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 15:05
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_PrintMapValP_h_
#define _xvisual_PrintMapValP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ColorP.h>
#include <xvisual/PrintMapVal.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwPrintMapValWidgetClass
{
    XtPointer extension;
} XvwPrintMapValWidgetClassPart;


typedef struct _XvwPrintMapValWidgetClassRec
{
    CoreClassPart		 core_class;
    CompositeClassPart		 composite_class;
    ConstraintClassPart		 constraint_class;
    XvwManagerWidgetClassPart	 manager_class;
    XvwGraphicsWidgetClassPart	 graphics_class;
    XvwColorWidgetClassPart	 color_class;
    XvwPrintMapValWidgetClassPart printmapval_class;
} XvwPrintMapValWidgetClassRec;


typedef struct
{
    /*  resources  */
    int     width;
    int     height;
    int     xposition;
    int     yposition;
    int     rgb;
    Boolean editable;
    Boolean showcolor;
    kobject object;
    int     update_mode;
    int     policy;

    /* internal resources */
    xvobject  title;
    xvobject  r_title;
    xvobject *r_labels;
    xvobject  r_parent;
    xvobject  r_none_label;
    xvobject  g_title;
    xvobject *g_labels;
    xvobject  g_parent;
    xvobject  g_none_label;
    xvobject  b_title;
    xvobject *b_labels;
    xvobject  b_parent;
    xvobject  b_none_label;

    int       val_datatype;
    int       map_datatype;
    int       mapwidth;
    int       mapheight;
    double    *mapdata;
    int       labelsize;

    Pixel    black;
    Pixel    white;

    kobject   clipmask;

} XvwPrintMapValPart;


typedef struct _XvwPrintMapValWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwPrintMapValPart	printmapval;
} XvwPrintMapValWidgetRec;


typedef struct  _XvwPrintMapValWidgetClassRec  *XvwPrintMapValWidgetClass;
typedef struct  _XvwPrintMapValWidgetRec       *XvwPrintMapValWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwPrintMapValWidget
 */
extern  XvwPrintMapValWidgetClassRec xvwPrintMapValWidgetClassRec;


#endif /* _xvisual_PrintMapValP_h_ */
/* Don't add after this point */
