/*
  * Khoros: $Id: PrintPixelP.h,v 1.6 1997/01/20 05:12:15 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private declarations for the color printpixel
   >>>>		       widget.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 05, 1992 15:05
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvisual_PrintPixelP_h_
#define _xvisual_PrintPixelP_h_


    /*-------------------------------------*
    |       #include 
    ---------------------------------------*/

#include <xvisual/ColorP.h>
#include <xvisual/PrintPixel.h>

    /*-------------------------------------*
    |       typedefs
    ---------------------------------------*/

typedef struct _XvwPrintPixelWidgetClass
{
    XtPointer extension;
} XvwPrintPixelWidgetClassPart;


typedef struct _XvwPrintPixelWidgetClassRec
{
    CoreClassPart		 core_class;
    CompositeClassPart		 composite_class;
    ConstraintClassPart		 constraint_class;
    XvwManagerWidgetClassPart	 manager_class;
    XvwGraphicsWidgetClassPart	 graphics_class;
    XvwColorWidgetClassPart	 color_class;
    XvwPrintPixelWidgetClassPart printpixel_class;
} XvwPrintPixelWidgetClassRec;


typedef struct
{
    /*  resources  */
    int       width;
    int       height;
    int       xposition;
    int       yposition;
    Boolean   editable;
    Boolean   showcolor;
    kobject   object;
    int       update_mode;

    /* internal resources */
    xvobject *labels;
    xvobject  parent;

    xvobject *r_labels;
    xvobject  r_parent;
    xvobject *g_labels;
    xvobject  g_parent;
    xvobject *b_labels;
    xvobject  b_parent;

    int       labelsize;

    Pixel     black;
    Pixel     white;

    Boolean   rgb;
    int       val_datatype;

    kobject   clipmask;
	
    int       depth_offset;
    int       time_offset;
    int       elements_offset;

} XvwPrintPixelPart;


typedef struct _XvwPrintPixelWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwGraphicsPart	graphics;
    XvwColorPart	color;
    XvwPrintPixelPart	printpixel;
} XvwPrintPixelWidgetRec;


typedef struct  _XvwPrintPixelWidgetClassRec  *XvwPrintPixelWidgetClass;
typedef struct  _XvwPrintPixelWidgetRec       *XvwPrintPixelWidget;


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwPrintPixelWidget
 */
extern  XvwPrintPixelWidgetClassRec xvwPrintPixelWidgetClassRec;


#endif /* _xvisual_PrintPixelP_h_ */
/* Don't add after this point */
