 /*
  * Khoros: $Id: CommandBarP.h,v 1.12 1997/01/20 05:12:57 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for CommandBar object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Nov 05, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvlang_CommandBarP_h_
#define _xvlang_CommandBarP_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <xvlang/CommandBar.h>
#include <kwidgets/RowColP.h>


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

typedef struct _XvwCommandBarWidgetClassPart
{
     XtPointer  extension;
} XvwCommandBarWidgetClassPart;

typedef struct _XvwCommandBarWidgetClassRec
{
   CoreClassPart		 core_class;
   CompositeClassPart		 composite_class;
   ConstraintClassPart		 constraint_class;
   XvwManagerWidgetClassPart	 manager_class;
   XvwRowColWidgetClassPart	 rowcol_class;
   XvwCommandBarWidgetClassPart commandbar_class;
} XvwCommandBarWidgetClassRec;

extern  XvwCommandBarWidgetClassRec xvwCommandBarWidgetClassRec;

typedef struct
{
   Boolean  show_run;
   Boolean  show_runmode;
   Boolean  show_stop;
   Boolean  show_reset;
   Boolean  show_remote;
   Boolean  show_clear;
   Boolean  show_check;
   Boolean  show_redraw;
   Boolean  show_info;
   Boolean  show_procedure;
   Boolean  show_countloop;
   Boolean  show_whileloop;
   Boolean  show_clipboard;
   Boolean  show_cut;
   Boolean  show_copy;
   Boolean  show_paste;
   Boolean  show_duplicate;
   Boolean  show_delete;
   Boolean  show_undo;
   Boolean  show_selectall;
   Boolean  show_unselectall;
   Boolean  show_open;
   Boolean  show_save;
   Boolean  show_saveas;
   Boolean  show_new;

   Boolean  largeicons;
   xvobject workspace;
   int      run_indx;
   int      stop_indx;
   int      runmode_indx;

} XvwCommandBarPart;


typedef struct _XvwCommandBarWidgetRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XvwManagerPart	manager;
  XvwRowColPart		rowcol;
  XvwCommandBarPart	commandbar;

} XvwCommandBarWidgetRec;

typedef struct {int empty;} XvwCommandBarConstraintsPart;

typedef struct _XvwCommandBarWidgetConstraintsRec {
    XvwManagerConstraintsPart	  manager;
    XvwRowColConstraintsPart	  rowcol;
    XvwCommandBarConstraintsPart commandbar;
} XvwCommandBarWidgetConstraintsRec, *XvwCommandBarWidgetConstraints;

typedef struct  _XvwCommandBarWidgetClassRec  *XvwCommandBarWidgetClass;
typedef struct  _XvwCommandBarWidgetRec       *XvwCommandBarWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwCommandBarWidget
 */
extern XvwCommandBarWidgetClassRec xvwCommandBarWidgetClassRec;


#endif /* _xvlang_CommandBarP_h_ */
/* Do not add after this line */
