 /*
  * Khoros: $Id: ExtPortP.h,v 1.8 1997/01/20 05:13:01 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for External Port object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: July 31, 1995
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvlang_ExtPortP_h_
#define _xvlang_ExtPortP_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <xvlang/ExtPort.h>
#include <xvlang/NodeP.h>


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

typedef struct _XvwExtPortWidgetClassPart
{
   XtPointer  extension;

} XvwExtPortWidgetClassPart;

typedef struct _XvwExtPortWidgetClassRec
{
   CoreClassPart		core_class;
   CompositeClassPart		composite_class;
   ConstraintClassPart		constraint_class;
   XvwManagerWidgetClassPart	manager_class;
   XvwNodeWidgetClassPart	node_class;
   XvwExtPortWidgetClassPart	extport_class;
} XvwExtPortWidgetClassRec;

extern  XvwExtPortWidgetClassRec xvwExtPortWidgetClassRec;

typedef struct
{
   kform_struct *selection;	/* the input/output kform selection	      */
   xvobject port;
   xvobject ifeed;

} XvwExtPortPart;


typedef struct _XvwExtPortWidgetRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XvwManagerPart	manager;
  XvwNodePart		node;
  XvwExtPortPart	extport;

} XvwExtPortWidgetRec;

typedef struct {int empty;} XvwExtPortConstraintsPart;

typedef struct _XvwExtPortWidgetConstraintsRec {
    XvwManagerConstraintsPart	manager;
    XvwNodeConstraintsPart	node;
    XvwExtPortConstraintsPart	extport;
} XvwExtPortWidgetConstraintsRec, *XvwExtPortWidgetConstraints;

typedef struct  _XvwExtPortWidgetClassRec  *XvwExtPortWidgetClass;
typedef struct  _XvwExtPortWidgetRec       *XvwExtPortWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwExtPortWidget
 */
extern XvwExtPortWidgetClassRec xvwExtPortWidgetClassRec;


#endif /* _xvlang_ExtPortP_h_ */
/* Do not add after this line */
