 /*
  * Khoros: $Id: NodeP.h,v 1.16.2.1 1997/04/29 22:27:04 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for Node object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 25, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvlang_NodeP_h_
#define _xvlang_NodeP_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <xvlang/Node.h>
#include <kwidgets/ManagerP.h>


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

#define XtInheritCheckNode     ((int (*)(Widget))_XtInherit)
#define XtInheritExecNode      ((void (*)(Widget, int))_XtInherit)
#define XtInheritSaveNode      ((void (*)(xvobject, kfile *, int))_XtInherit)
#define XtInheritRestoreNode   ((int (*)(xvobject, xvobject, kfile *, char *, int, int, int *))_XtInherit)
#define XtInheritBuildCommand  ((int (*)(Widget, char *))_XtInherit)

typedef struct _XvwNodeWidgetClassPart
{
   int  (*check_node)    (Widget);
   void (*exec_node)     (Widget, int);
   void (*save_node)     (xvobject, kfile *, int);
   int  (*restore_node)  (xvobject, xvobject, kfile *, char *, int, int, int *);
   int  (*build_command) (Widget, char *);
   XtPointer  extension;

} XvwNodeWidgetClassPart;

typedef struct _XvwNodeWidgetClassRec
{
   CoreClassPart		core_class;
   CompositeClassPart		composite_class;
   ConstraintClassPart		constraint_class;
   XvwManagerWidgetClassPart	manager_class;
   XvwNodeWidgetClassPart	node_class;
} XvwNodeWidgetClassRec;

extern  XvwNodeWidgetClassRec xvwNodeWidgetClassRec;

typedef struct
{
   int     exectype;
   int     nodesize;
   Boolean placement;
   Boolean leave;
   Boolean modified;
   Boolean remote_enable;
   XtCallbackList run_callback;
   XtCallbackList modified_callback;

   Pixmap   pixmap;
   xvobject label;
   xvobject icon;
   xvobject remote;
   Pixmap   modified_pixmap;

   pid_t    pid;
   String   name;
   String   machine;
   Boolean  contrun;
   Boolean  running;
   Boolean  runnable;
   Boolean  khoros_routine;
   Boolean  status;

   int      isize;
   int      osize;
   xvobject *iports;
   xvobject *oports;
   xvobject cflow_in;		/* the input control flow object 	      */
   xvobject cflow_out;		/* the output control flow object 	      */
} XvwNodePart;


typedef struct _XvwNodeWidgetRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XvwManagerPart	manager;
  XvwNodePart		node;

} XvwNodeWidgetRec;

typedef struct {int empty;} XvwNodeConstraintsPart;

typedef struct _XvwNodeWidgetConstraintsRec {
    XvwManagerConstraintsPart	manager;
    XvwNodeConstraintsPart	node;
} XvwNodeWidgetConstraintsRec, *XvwNodeWidgetConstraints;

typedef struct  _XvwNodeWidgetClassRec  *XvwNodeWidgetClass;
typedef struct  _XvwNodeWidgetRec       *XvwNodeWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwNodeWidget
 */
extern XvwNodeWidgetClassRec xvwNodeWidgetClassRec;


#endif /* _xvlang_NodeP_h_ */
/* Do not add after this line */
