 /*
  * Khoros: $Id: ToolboxListP.h,v 1.9 1997/01/20 05:13:17 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for ToolboxList object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Jul 02, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvlang_ToolboxListP_h_
#define _xvlang_ToolboxListP_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <xvlang/ToolboxList.h>
#include <kwidgets/ManagerP.h>


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

typedef struct _XvwToolboxListWidgetClassPart
{
     XtPointer  extension;
} XvwToolboxListWidgetClassPart;

typedef struct _XvwToolboxListWidgetClassRec
{
   CoreClassPart		 core_class;
   CompositeClassPart		 composite_class;
   ConstraintClassPart		 constraint_class;
   XvwManagerWidgetClassPart	 manager_class;
   XvwToolboxListWidgetClassPart toolboxlist_class;
} XvwToolboxListWidgetClassRec;

extern  XvwToolboxListWidgetClassRec xvwToolboxListWidgetClassRec;

typedef struct
{
   XtCallbackList select_callback;
   XtCallbackList create_callback;

   xvobject catobj, cat_listobj;
   xvobject subobj, sub_listobj;
   xvobject iconobj, icon_listobj;
   klist    *sublist;
   klist    *iconlist;
   xvw_program_info selected;

} XvwToolboxListPart;


typedef struct _XvwToolboxListWidgetRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XvwManagerPart	manager;
  XvwToolboxListPart	toolboxlist;

} XvwToolboxListWidgetRec;

typedef struct {int empty;} XvwToolboxListConstraintsPart;

typedef struct _XvwToolboxListWidgetConstraintsRec {
    XvwManagerConstraintsPart	  manager;
    XvwToolboxListConstraintsPart toolboxlist;
} XvwToolboxListWidgetConstraintsRec, *XvwToolboxListWidgetConstraints;

typedef struct  _XvwToolboxListWidgetClassRec  *XvwToolboxListWidgetClass;
typedef struct  _XvwToolboxListWidgetRec       *XvwToolboxListWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwToolboxListWidget
 */
extern XvwToolboxListWidgetClassRec xvwToolboxListWidgetClassRec;


#endif /* _xvlang_ToolboxListP_h_ */
/* Do not add after this line */
