/*
  * Khoros: $Id: Notebook.h,v 1.2 1997/01/20 05:14:05 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: #defines and #includes for creating a
   >>>>		       graphical notebook manager.
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Apr 15, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvobjects_Notebook_h_
#define _xvobjects_Notebook_h_


    /*-------------------------------------*
    |       #defines 
    ---------------------------------------*/

/*
 *  Attribute definitions for Notebook Visual Object
 */

/*------------------------------------------------------------------------
| Attribute:	XVW_NOTEBOOK_BUFFER_SIZE
| Description:  This attribute specifies the distance between area objects, 
|		in pixels.  
| Type:         int
| Default:      5
| Legal Values: values >= 0 
| Resource:	notebookBufferSize
------------------------------------------------------------------------*/
#define XVW_NOTEBOOK_BUFFER_SIZE 	        "notebookBufferSize"

/*------------------------------------------------------------------------
| Attribute:	XVW_NOTEBOOK_SELECTED_CHILD
| Description:  Specifies which area object is currently selected;  
|		the selected area object will be displayed.  The 
|		default is NULL.
| Type:         xvobject
| Default:      NULL
| Legal Values: valid xvobject
| Resource:	N/A
------------------------------------------------------------------------*/
#define XVW_NOTEBOOK_SELECTED_CHILD	"notebookSelectedChild"

/*------------------------------------------------------------------------
| Attribute:	XVW_NOTEBOOK_CALLBACK

| Description:  If desired, \fIxvw_add_callback()\fP may be used to install
|               a callback on the notebook object which will be fired when the 
|		user selects the notebook object by clicking on it.
|               When calling \fIxvw_add_callback()\fP, pass this attribute
|               directly, as in
|               .begin code
|               xvw_add_callback(notebook, XVW_NOTEBOOK_CALLBACK,
|                                notebook_cb, client_data);
|               .end code
|
| Type:         kfunc_void
| Default:      NULL
| Legal Values: callback function, in the form:
|		.begin code
|		void callback_function
|		   xvobject object,
|		   kaddr client_data,
|		   kaddr call_data)
|		.end code
| Resource:	N/A
------------------------------------------------------------------------*/
#define XVW_NOTEBOOK_CALLBACK	"notebookCallback"

/*
 *  Define the Class name, by which people should be externally referencing
 *  the Notebook Object by.
 */
#define NotebookWidgetClass	xvwNotebookWidgetClass

/*------------------------------------------------------------------------
| Attribute:     XVW_NOTEBOOK_TAB_PIXMAP
| Description:   The pixmap that is used to indicate a tab for the different
|		 notebook pages (or tabbed area).
| Type:          Pixmap
| Default:       xvobjects/misc/glyph/notebook_tab.xpm
| Legal Values:  any bitmap or pixmap
| Resource:      notebookTabPixmap
------------------------------------------------------------------------*/
#define XVW_NOTEBOOK_TAB_PIXMAP    "notebookTabPixmap"

    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration for NotebookWidgetClass
 */
extern   WidgetClass     NotebookWidgetClass;


    /*-------------------------------------*
    |       routine definitions
    ---------------------------------------*/

/*
 *  Function definitions for Notebook Visual Object
 */
xvobject xvw_create_notebook PROTO((xvobject, char *));


#endif /* _xvobjects_Notebook_h_ */
/* Don't add after this point */
