/*
  * Khoros: $Id: NotifyWindowP.h,v 1.6 1997/01/20 05:14:09 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for NotifyWindow object
   >>>>
   >>>>    Written By: Neil Bowers & Mark Young
   >>>>
   >>>>          Date: Aug 25, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvobjects_NotifyWindowP_h_
#define _xvobjects_NotifyWindowP_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <xvobjects/NotifyWindow.h>
#include <kwidgets/ManagerP.h>


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

typedef struct _XvwNotifyWindowWidgetClassPart
{
     XtPointer  extension;
} XvwNotifyWindowWidgetClassPart;

typedef struct _XvwNotifyWindowWidgetClassRec
{
   CoreClassPart		core_class;
   CompositeClassPart		composite_class;
   ConstraintClassPart		constraint_class;
   XvwManagerWidgetClassPart	manager_class;
   XvwNotifyWindowWidgetClassPart notifywindow_class;
} XvwNotifyWindowWidgetClassRec;

extern  XvwNotifyWindowWidgetClassRec xvwNotifyWindowWidgetClassRec;

typedef struct
{
   xvobject icon;
   xvobject label;
   xvobject text;

   Boolean  visible;
   Boolean  toplevel;
   xvobject notifyfor;
   Pixmap   notify_pixmap;

   String label_string;
   String text_string;
   String title_string;

} XvwNotifyWindowPart;


typedef struct _XvwNotifyWindowWidgetRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XvwManagerPart	manager;
  XvwNotifyWindowPart	notifywindow;

} XvwNotifyWindowWidgetRec;

typedef struct {int empty;} XvwNotifyWindowConstraintsPart;

typedef struct _XvwNotifyWindowWidgetConstraintsRec {
    XvwManagerConstraintsPart	   manager;
    XvwNotifyWindowConstraintsPart notifywindow;
} XvwNotifyWindowWidgetConstraintsRec, *XvwNotifyWindowWidgetConstraints;

typedef struct  _XvwNotifyWindowWidgetClassRec  *XvwNotifyWindowWidgetClass;
typedef struct  _XvwNotifyWindowWidgetRec       *XvwNotifyWindowWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwNotifyWindowWidget
 */
extern XvwNotifyWindowWidgetClassRec xvwNotifyWindowWidgetClassRec;


#endif /* _xvobjects_NotifyWindowP_h_ */
/* Do not add after this line */
