/*
  * Khoros: $Id: Sash.h,v 1.3 1997/01/20 05:14:16 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Attributes of the Sash object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Apr 15, 1996
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvobjects_Sash_h_
#define _xvobjects_Sash_h_

	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

/*------------------------------------------------------------------------
| Attribute:     XVW_SASH_GRIP_OBJECT
| Description:   The object that is used as the grip for allowing the
|                user to interactively move the sash.
| Type:          xvobject
| Default:       NULL
| Legal Values:  any legal object
| Resource:      sashGripObject
------------------------------------------------------------------------*/
#define XVW_SASH_GRIP_OBJECT    "sashGripObject"

/*------------------------------------------------------------------------
| Attribute:     XVW_SASH_GRIP_PIXMAP
| Description:   The pixmap that is used to indicate that shows the sash
|                grip pixmap.
| Type:          Pixmap
| Default:       xvobjects/misc/glyph/sash_grip.xpm
| Legal Values:  any bitmap or pixmap
| Resource:      sashGripPixmap
------------------------------------------------------------------------*/
#define XVW_SASH_GRIP_PIXMAP    "sashGripPixmap"

/*
 *  Define the Class name, by which people should be externally referencing
 *  the Sash Object by.
 */
#define SashGadgetClass	xvwSashGadgetClass


    /*-------------------------------------*
    |       global variable declarations
    ---------------------------------------*/

/*
 *  XToolkit Widget Declaration SashGadgetClass
 */
extern   WidgetClass     SashGadgetClass;


	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/*
 *  Khoros Function Definition for Sash Object
 */
xvobject xvw_create_sash PROTO((xvobject, char *));


#endif /* _xvobjects_Sash_h_ */
/* Don't add after this point */
