/*
  * Khoros: $Id: TextDisplayP.h,v 1.7.2.1 1997/05/04 16:27:46 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for TextDisplay object
   >>>>
   >>>>    Written By: Mark Young
   >>>>
   >>>>          Date: Aug 25, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvobjects_TextDisplayP_h_
#define _xvobjects_TextDisplayP_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/

#include <xvobjects/TextDisplay.h>
#include <kwidgets/ViewportP.h>


	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

typedef struct _XvwTextDisplayWidgetClassPart
{
    XtPointer  extension;
} XvwTextDisplayWidgetClassPart;

typedef struct _XvwTextDisplayWidgetClassRec
{
    CoreClassPart		  core_class;
    CompositeClassPart		  composite_class;
    ConstraintClassPart		  constraint_class;
    XvwManagerWidgetClassPart     manager_class;
    XvwViewportWidgetClassPart    viewport_class;
    XvwTextDisplayWidgetClassPart textdisplay_class;
} XvwTextDisplayWidgetClassRec;

extern  XvwTextDisplayWidgetClassRec xvwTextDisplayWidgetClassRec;

typedef struct _XvwTextDisplayPart
{
    kfile	 *file;
    Dimension    indent;
    Boolean      roff;
    XFontStruct	 *ascii;
    XFontStruct	 *roman;
    XtCallbackList textdisplay_callbacks;

    char     *text;
    xvobject label;
    xvobject notifywindow;
} XvwTextDisplayPart;


typedef struct _XvwTextDisplayWidgetRec
{
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    XvwManagerPart	manager;
    XvwViewportPart	viewport;
    XvwTextDisplayPart  textdisplay;
} XvwTextDisplayWidgetRec;

typedef struct {int empty;} XvwTextDisplayConstraintsPart;

typedef struct _XvwTextDisplayWidgetConstraintsRec
{
    XvwManagerConstraintsPart     manager;
    XvwViewportConstraintsPart    viewport;
    XvwTextDisplayConstraintsPart textdisplay;
} XvwTextDisplayWidgetConstraintsRec, *textDisplayConstraints;

typedef struct _XvwTextDisplayWidgetClassRec *XvwTextDisplayWidgetClass;
typedef struct _XvwTextDisplayWidgetRec      *XvwTextDisplayWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwTextDisplayWidget
 */
extern XvwTextDisplayWidgetClassRec xvwTextDisplayWidgetClassRec;


#endif /* _xvobjects_TextDisplayP_h_ */
/* Don't add after this point */
