/*
  * Khoros: $Id: TextInputP.h,v 1.6 1997/01/20 05:14:23 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for TextInput object
   >>>>
   >>>>    Written By: Mark Young and Danielle Argiro
   >>>>
   >>>>          Date: Aug 25, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvobjects_TextInputP_h_
#define _xvobjects_TextInputP_h_

        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <xvobjects/TextInput.h>
#include <kwidgets/ManagerP.h>


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

typedef struct _XvwTextInputWidgetClassPart
{
     XtPointer  extension;
} XvwTextInputWidgetClassPart;

typedef struct _XvwTextInputWidgetClassRec
{
   CoreClassPart		core_class;
   CompositeClassPart		composite_class;
   ConstraintClassPart		constraint_class;
   XvwManagerWidgetClassPart	manager_class;
   XvwTextInputWidgetClassPart	textinput_class;
} XvwTextInputWidgetClassRec;

extern  XvwTextInputWidgetClassRec xvwTextInputWidgetClassRec;

typedef struct
{
   xvobject label;
   xvobject crlabel;
   xvobject text;
   XtCallbackList textinput_callback;

} XvwTextInputPart;


typedef struct _XvwTextInputWidgetRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XvwManagerPart	manager;
  XvwTextInputPart	textinput;

} XvwTextInputWidgetRec;

typedef struct {int empty;} XvwTextInputConstraintsPart;

typedef struct _XvwTextInputWidgetConstraintsRec {
    XvwManagerConstraintsPart	manager;
    XvwTextInputConstraintsPart	textinput;
} XvwTextInputWidgetConstraintsRec, *XvwTextInputWidgetConstraints;

typedef struct  _XvwTextInputWidgetClassRec  *XvwTextInputWidgetClass;
typedef struct  _XvwTextInputWidgetRec       *XvwTextInputWidget;


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit Widget Declaration XvwTextInputWidget
 */
extern XvwTextInputWidgetClassRec xvwTextInputWidgetClassRec;


#endif /* _xvobjects_TextInputP_h_ */
/* Do not add after this line */
