 /*
  * Khoros: $Id: ToolTips.h,v 1.3 1997/01/20 05:14:27 mirage Exp $
  */


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Attributes of  ToolTips Widget
   >>>>
   >>>>    Written By: Neil Bowers & Mark Young
   >>>>
   >>>>          Date: Aug 25, 1994
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvobjects_ToolTips_h_
#define _xvobjects_ToolTips_h_

        /*-------------------------------------*
        |       #defines
        ---------------------------------------*/


/*------------------------------------------------------------------------
| Attribute:	XVW_TOOLTIPS_MESSAGE
|
| Description:  This is the message that appears in the tool tips window while
|		it is displayed;  users are expected to read it while they
|		are waiting for the window to go away.  The 
|		message is typically used to indicate what the program is doing
|		that is forcing the user to wait. With programs such as
|		\fHcantata\fP, for example, the message might inform the user
|		as to the functionality of each of the icons on the commandbar.
|
| Type:         char *
| Default:      NULL
| Legal Values: any printable text. 
| Resource:	N/A
------------------------------------------------------------------------*/
#define XVW_TOOLTIPS_MESSAGE	"tooltipsMessage"

/*
 *  Define the Class name, by which people should be externally referencing
 *  the ToolTips Object by.
 */
#define ToolTipsWidgetClass	xvwToolTipsWidgetClass


        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/

/*
 *  XToolkit WidgetClass Declaration ToolTipsWidgetClass
 */
extern   WidgetClass     ToolTipsWidgetClass;


        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/

/*
 *  Khoros Function Definition for ToolTips Object
 */
xvobject xvw_create_tooltips PROTO((xvobject, char *));


#endif /* _xvobjects_ToolTips_h_ */
/* Do not add after this line */
