 /*
  * Khoros: $Id: Conditional.c,v 1.24.2.2 1997/04/29 22:31:40 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: Conditional.c,v 1.24.2.2 1997/04/29 22:31:40 mirage Exp $";
#endif


/*
 * Copyright (C) 1993
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		Khoros Conditional Widget
   >>>>   Static:
   >>>>                 ClassInitialize()
   >>>>                 SetValues()
   >>>>                 ConditionalExec()
   >>>>                 ConditionalCheck()
   >>>>   Public:
   >>>>                 xvw_create_conditional()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"
#include <xvlang/ConditionalP.h>
#include <xvlang/WorkspaceP.h>

static void ClassInitialize PROTO((void));
static Boolean SetValues    PROTO((Widget, Widget, Widget, ArgList,Cardinal *));

static void ConditionalExec	    PROTO((Widget, int));
static int  ConditionalCheck	    PROTO((Widget));


/*-------------------------------------------------------------------*
|
|   Full class attributes
|
--------------------------------------------------------------------*/

static xvattribute attributes[] = {
{XVW_CONDITIONAL_TYPE,   NULL,   XtRInt,  NULL},
};


/*-------------------------------------------------------------------*
|
|   Full class record constant
|
--------------------------------------------------------------------*/

#define offset(field) XtOffsetOf(XvwConditionalWidgetRec, conditional.field)

static XtResource resources[] = { 
{XVW_CONDITIONAL_TYPE, NULL, XtRInt, sizeof(int),
        offset(type), XtRImmediate, (XtPointer) 0},

{XVW_FOREGROUND_PIXEL, NULL, XtRPixel, sizeof(Pixel),
        XtOffsetOf(XvwConditionalWidgetRec, manager.foreground_pixel),
        XtRString, (XtPointer) "#979797"},
};
#undef offset


/*-------------------------------------------------------------------*
|
|   Class Declaration for Conditional Widget
|
--------------------------------------------------------------------*/

#define superclass (&xvwGlyphWidgetClassRec)

XvwConditionalWidgetClassRec xvwConditionalWidgetClassRec =
{
  {
    (WidgetClass) superclass,		/* superclass		  */	
    "Conditional",			/* class_name		  */
    sizeof(XvwConditionalWidgetRec),	/* size			  */
    ClassInitialize,			/* class_initialize	  */
    NULL,				/* class_part_initialize  */
    FALSE,				/* class_inited		  */
    NULL,				/* initialize		  */
    NULL,				/* initialize_hook	  */
    XtInheritRealize,			/* realize		  */
    NULL,				/* actions		  */
    0,					/* num_actions		  */
    resources,				/* resources		  */
    XtNumber(resources),		/* resource_count	  */
    NULLQUARK,				/* xrm_class		  */
    TRUE,				/* compress_motion	  */
    XtExposeCompressMaximal,		/* compress_exposure	  */
    TRUE,				/* compress_enterleave    */
    FALSE,				/* visible_interest	  */
    NULL,				/* destroy		  */
    NULL,				/* resize		  */
    XtInheritExpose,			/* expose		  */
    SetValues,				/* set_values		  */
    NULL,				/* set_values_hook	  */
    XtInheritSetValuesAlmost,		/* set_values_almost	  */
    NULL,				/* get_values_hook	  */
    NULL,				/* accept_focus		  */
    XtVersion,				/* version		  */
    NULL,				/* callback_private	  */
    NULL,				/* tm_table		  */
    XtInheritQueryGeometry,		/* query_geometry	  */
    XtInheritDisplayAccelerator,	/* display_accelerator	  */
    NULL				/* extension		  */
  },  /* CoreClass fields initialization */
  {
    NULL,                    		/* geometry_manager	  */
    XtInheritChangeManaged,		/* change_managed	  */
    XtInheritInsertChild,		/* insert_child	  	  */
    XtInheritDeleteChild,		/* delete_child	  	  */
    NULL,				/* extension	 	  */
  },  /* CompositeClass fields initialization */
  {
    NULL,				    /* subresources	  */
    0,					    /* subresources_count */
    sizeof(XvwConditionalWidgetConstraintsRec),/* constraint_size	  */
    NULL,				    /* initialize	  */
    NULL,				    /* destroy		  */
    NULL,				    /* set_values	  */
    NULL,				    /* extension	  */
  },  /* ConstraintClass fields initialization */
  {
    XtInheritLayout,			    /* pre-layout routine     */
    XtInheritLayout,			    /* post-layout routine    */
    XtInheritChangeSel,			    /* change selected proc   */
    XtInheritEraseSel,			    /* erase selected proc    */
    XtInheritRefreshSel,		    /* refresh selection proc */
    XtInheritResize,			    /* resize		      */
    XtInheritGeometryManager,		    /* geometry_manager	      */
  },  /* XvwManagerWidgetClass fields initialization */
  {
    ConditionalCheck,	                    /* firing rule check  */
    ConditionalExec,	                    /* execute node       */
    XtInheritSaveNode,	                    /* save node          */
    XtInheritRestoreNode,	            /* restore node       */
    NULL,	 	                    /* build command      */
    NULL, 		                    /* extension          */
  },  /* XvwNodeWidgetClass fields initialization */
  {
    NULL,  		                    /* extension           */
  },  /* XvwGlyphWidgetClass fields initialization */
  {
    NULL,  		                    /* extension          */
  },  /* XvwConditionalWidgetClass fields initialization */
};
#undef superclass

  /* for public consumption */
WidgetClass xvwConditionalWidgetClass = (WidgetClass) &xvwConditionalWidgetClassRec;


/*-------------------------------------------------------------------*
|
|   Miscelleanous defines for Class and Constraint Declarations
|
--------------------------------------------------------------------*/

#define kwidget(widget)	    (XvwConditionalWidget) (widget)


/*-----------------------------------------------------------
|
|  Routine Name: ClassInitialize
|
|       Purpose: This method is called the first time an
|                instance of a XvwConditionalWidget class has been created.
|                This is where the attributes for the class are
|		 initialized. 
|
|    Written By: Mark Young
|          Date: Oct 19, 1993
|
------------------------------------------------------------*/

static void ClassInitialize(void)
{
	xvlang_cache_pixmaps();
	xvw_init_attributes(xvwConditionalWidgetClass, attributes,
		XtNumber(attributes), NULL, 0, 
		"$DESIGN/objects/library/xvlang/uis/Conditional.pane");
	xvw_load_resources("$DESIGN/objects/library/xvlang/app-defaults/Conditional");
}

/*-----------------------------------------------------------
|
|  Routine Name: SetValues
|
|       Purpose: This method is used to set the public values
|                of a XvwConditionalWidget instance.  The public values
|                which can be changed are all related to the display
|		 of the conditional.
|
|         Input: current - the widget containing current settings
|                request - the widget containing requested settings
|                new1     - the widget processed through all set values methods
|       Returns: TRUE (1) if redisplay is required, FALSE (0) otherwise
|    Written By: Mark Young
|          Date: Aug 19, 1993
|
------------------------------------------------------------*/
/* ARGSUSED */
static Boolean SetValues (
   Widget   current,
   Widget   request,
   Widget   new1,
   ArgList  args,
   Cardinal *num)
{
	XvwConditionalWidget cxwid = kwidget(current);
	XvwConditionalWidget nxwid = kwidget(new1);

	char *icon = NULL, *file = NULL;

	if (cxwid->glyph.oname != nxwid->glyph.oname)
	{
	   if (kstrcmp(nxwid->glyph.oname, "if_else") == 0)
	      nxwid->conditional.type = KCONDITIONAL_TYPE_IF_ELSE;
	   else if (kstrcmp(nxwid->glyph.oname, "switch") == 0)
	      nxwid->conditional.type = KCONDITIONAL_TYPE_SWITCH;
	   else if (kstrcmp(nxwid->glyph.oname, "expr") == 0)
	      nxwid->conditional.type = KCONDITIONAL_TYPE_EXPRESSION;
	   else if (kstrcmp(nxwid->glyph.oname, "trigger") == 0)
	      nxwid->conditional.type = KCONDITIONAL_TYPE_TRIGGER;
	   else if (kstrcmp(nxwid->glyph.oname, "merge") == 0)
	      nxwid->conditional.type = KCONDITIONAL_TYPE_MERGE;
	   else if (kstrcmp(nxwid->glyph.oname, "break") == 0)
	      nxwid->conditional.type = KCONDITIONAL_TYPE_BREAK;
	   else if (kstrcmp(nxwid->glyph.oname, "continue") == 0)
	      nxwid->conditional.type = KCONDITIONAL_TYPE_CONTINUE;
	}

	if (cxwid->conditional.type != nxwid->conditional.type)
	{
	   if (nxwid->conditional.type == KCONDITIONAL_TYPE_IF_ELSE)
	   {
	      icon = "$DESIGN/objects/library/xvlang/pixmaps/control/ifthen.xpm";
	      file = "$DESIGN/objects/library/xvlang/uis/control/if_else.pane";
	   }
	   else if (nxwid->conditional.type == KCONDITIONAL_TYPE_SWITCH)
	   {
	      icon = "$DESIGN/objects/library/xvlang/pixmaps/control/switch.xpm";
	      file = "$DESIGN/objects/library/xvlang/uis/control/switch.pane";
	   }
	   else if (nxwid->conditional.type == KCONDITIONAL_TYPE_EXPRESSION)
	   {
	      icon = "$DESIGN/objects/library/xvlang/pixmaps/control/expr.xpm";
	      file = "$DESIGN/objects/library/xvlang/uis/control/expr.pane";
	   }
	   else if (nxwid->conditional.type == KCONDITIONAL_TYPE_TRIGGER)
	   {
	      icon = "$DESIGN/objects/library/xvlang/pixmaps/control/trigger.xpm";
	      file = "$DESIGN/objects/library/xvlang/uis/control/trigger.pane";
	   }
	   else if (nxwid->conditional.type == KCONDITIONAL_TYPE_MERGE)
	   {
	      icon = "$DESIGN/objects/library/xvlang/pixmaps/control/merge.xpm";
	      file = "$DESIGN/objects/library/xvlang/uis/control/merge.pane";
	   }
	   else if (nxwid->conditional.type == KCONDITIONAL_TYPE_BREAK)
	   {
	      icon = "$DESIGN/objects/library/xvlang/pixmaps/control/break.xpm";
	      file = "$DESIGN/objects/library/xvlang/uis/control/break.pane";
	   }
	   else if (nxwid->conditional.type == KCONDITIONAL_TYPE_CONTINUE)
	   {
	      icon ="$DESIGN/objects/library/xvlang/pixmaps/control/continue.xpm";
	      file ="$DESIGN/objects/library/xvlang/uis/control/continue.pane";
	   }

	   if (icon != NULL)
	      xvw_set_attribute(xvw_object(new1), XVW_NODE_PIXMAPFILE, icon);

	   if (file != NULL && nxwid->glyph.form == NULL)
	      xvw_set_attribute(xvw_object(new1), XVW_GLYPH_FORMFILE, file);
	}
	return(FALSE);
}

/*-----------------------------------------------------------
|
|  Routine Name: ConditionalCheck
|
|       Purpose: This routine will check to see if a glyph is ready to run.
|         Input: widget      - the glyph widget to be checked
|
|    Written By: Mark Young
|          Date: Jul 30, 1994
|
------------------------------------------------------------*/
/* ARGSUSED */ 
static int ConditionalCheck(
   Widget   widget)
{
        XvwConditionalWidget xwid = (XvwConditionalWidget) widget;

	int i, selected = FALSE, test = FALSE;


	if (xwid->conditional.type == KCONDITIONAL_TYPE_MERGE)
	{
	   if (xwid->glyph.last_iport == NULL)
	      return(FALSE);
	}
	else
	{
	   for (i = 0; i < xwid->node.isize; i++)
	   {
	      xvw_get_attributes(xwid->node.iports[i],
			XVW_PORT_DAV, &test,
			XVW_PORT_SELECTED, &selected,
			NULL);
	      if (test == FALSE && selected == TRUE)
	         return(FALSE);
	   }
	}
	xvw_get_attributes(xwid->node.cflow_in,
			XVW_PORT_DAV, &test,
			XVW_PORT_SELECTED, &selected,
			NULL);
	if (test == FALSE && selected == TRUE)
	   return(FALSE);
	else
	   return(TRUE);
}

/*-----------------------------------------------------------
|
|  Routine Name: ConditionalExec
|
|       Purpose: This routine will exec the command to run for the conditional.
|         Input: widget      - the conditional widget to build the command for.
|                command     - the command to be run.
|
|    Written By: Mark Young
|          Date: Apr 13, 1996
|
------------------------------------------------------------*/
/* ARGSUSED */ 
static void ConditionalExec(
   Widget widget,
   int    exec)
{
	XvwConditionalWidget xwid = kwidget(widget);
	long id = (long) xwid->glyph.expression_id;

	int	   value;
	kselection *selection;
	xvobject   iport = NULL, oport = NULL;
	char       expand_infile[KLENGTH], expand_outfile[KLENGTH];
	char	   temp[KLENGTH], *text, *infile = NULL, *outfile = NULL;

	if (exec == FALSE)
	{
	   xvl_stopcopy(xvw_object(widget));
	   return;
	}

	if (xwid->conditional.type == KCONDITIONAL_TYPE_IF_ELSE)
	{
	   selection = kvf_variable_sel_search(xwid->glyph.form, "condition");
	   if (selection == NULL)
	      return;

	   iport = xwid->node.iports[0];
	   xvf_get_attribute(selection->back_kformstruct,XVF_STRING_VAL, &text);
	   (void) kexpr_evaluate_int(id, text, &value, NULL); kfree(text);
	   xvl_expr_call_callback(id, XVL_EXPR_UPDATE);
	   if (value)
	      oport = xwid->node.oports[0];
	   else
	      oport = xwid->node.oports[1];
	}
	else if (xwid->conditional.type == KCONDITIONAL_TYPE_SWITCH)
	{
	   selection = kvf_variable_sel_search(xwid->glyph.form, "condition");
	   if (selection == NULL)
	      return;

	   oport = xwid->node.oports[0];
	   xvf_get_attribute(selection->back_kformstruct,XVF_STRING_VAL, &text);
	   (void) kexpr_evaluate_int(id, text, &value, NULL); kfree(text);
	   xvl_expr_call_callback(id, XVL_EXPR_UPDATE);
	   if (value)
	      iport = xwid->node.iports[0];
	   else
	      iport = xwid->node.iports[1];
	}
	else if (xwid->conditional.type == KCONDITIONAL_TYPE_EXPRESSION)
	{
	   selection = kvf_variable_sel_search(xwid->glyph.form, "expression");
	   if (selection == NULL)
	      return;

	   oport = xwid->node.oports[0];
	   iport = xwid->node.iports[0];
	   xvf_get_attribute(selection->back_kformstruct,XVF_STRING_VAL, &text);
	   (void) kexpr_evaluate_int(id, text, &value, NULL); kfree(text);
	   xvl_expr_call_callback(id, XVL_EXPR_UPDATE);
	}
	else if (xwid->conditional.type == KCONDITIONAL_TYPE_TRIGGER)
	{
	   oport = xwid->node.oports[0];
	   iport = xwid->node.iports[0];
	}
	else if (xwid->conditional.type == KCONDITIONAL_TYPE_MERGE)
	{
	   oport = xwid->node.oports[0];
	   iport = xwid->glyph.last_iport;
	}

	if (!iport || !oport)
	   return;

	xvw_get_attribute(iport, XVW_PORT_FILENAME, &infile);
	if (kstrchr(infile, '$') != NULL &&
	    kexpr_evaluate_generic(id, infile, KSTRING, expand_infile, temp))
	{
	   infile = expand_infile;
	}

	xvw_get_attribute(oport, XVW_PORT_FILENAME, &outfile);
	if (kstrchr(outfile, '$') != NULL &&
	    kexpr_evaluate_generic(id, outfile, KSTRING, expand_outfile, temp))
	{
	   outfile = expand_outfile;
	}
	xvl_copydata(xvw_object(widget), infile, outfile, oport);
}


/************************************************************
*
*  Routine Name: xvw_create_conditional - create a conditional object
*
*       Purpose: The purpose of the Conditional GUI object is to provide a
*		 visual programming component in which to implement
*		 conditional flow constructs.  Conditional flow constructs
*		 include such configurations as "if then else", "switch", etc.
*
*         Input: parent - the parent object; NULL will cause a
*			  default toplevel to be created automatically
*                name   - the name with which to reference the object
*        Output: none
*       Returns: The image object on success, NULL on failure
*
*  Restrictions:
*    Written By: Mark Young
*          Date: Jan 14, 1994
*      Verified:
*  Side Effects:
* Modifications:
*
*******************************************************************/

xvobject xvw_create_conditional(
   xvobject parent,
   char     *name)
{
	xvobject conditional;


	conditional = xvw_create(parent, FALSE, TRUE, name,
			ConditionalWidgetClass);
	xvw_set_attributes(conditional,
		XVW_SELECTABLE, TRUE,
		XVW_RESIZABLE, FALSE,
		XVW_MENUABLE, FALSE,
		NULL);
	return(conditional);
}
