 /* Khoros: $Id: internals.h,v 1.23.2.2 1997/05/24 19:04:41 mirage Exp $ */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for xvlang library
   >>>>
   >>>>    Written By: Mark Young and John Salas
   >>>>
   >>>>          Date: Mar 28, 1993 15:04
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvlang_internals_h_
#define _xvlang_internals_h_


	/*-------------------------------------*
	|       #include 
	---------------------------------------*/

#include <design.h>
#include <xvinclude.h>
#include <X11/IntrinsicP.h>
#include <X11/Xmu/Xmu.h>
#include <X11/Xmu/Drawing.h>

#include <xvlang/xvlang.h>


	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

#define XVLANG "xvlang"

#define WORKSPACE_VERSION 2.1

	/*-------------------------------------*
	|       #macros 
	---------------------------------------*/


	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/


	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/


	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/*
 *  Glyph.c
 */
void MessageCallback  PROTO((kfile *, kaddr, char *));

/*
 *  GlyphUtil.c
 */
void GlyphCreateCli	        PROTO((Widget));
void GlyphStartDebugger	        PROTO((Widget, int));
void GlyphUpdateForm 	        PROTO((Widget));
void GlyphInitForm   	        PROTO((kaddr));
void GlyphHandler    	        PROTO((xvobject, kaddr, XEvent *, int *));
int  GlyphSetFormfile     	PROTO((xvobject, char *, kaddr));
int  GlyphGetFormfile     	PROTO((xvobject, char *, kaddr));
void GlyphDestroyCallback       PROTO((xvobject, kaddr, kaddr));
int  GlyphCreateConnection      PROTO((xvobject, xvobject));
void GlyphFormCallback          PROTO((kform *, ksubform *, kaddr));
void GlyphInputFilenameCallback PROTO((xvobject, kaddr, kaddr));
void GlyphInputDavCallback      PROTO((xvobject, kaddr, kaddr));
void GlyphOutputDavCallback     PROTO((xvobject, kaddr, kaddr));
void GlyphRunCallback	        PROTO((kaddr));
int  GlyphFormExpression    PROTO((kform *, kaddr, char *, int, kaddr, char *));

/*
 *  WorkspaceUtil.c
 */
void WorkspaceRun	    PROTO((kaddr));
void WorkspaceInitClipboard PROTO((void));
int  WorkspaceActions	    PROTO((xvobject, char *, kaddr));
int  WorkspaceInfo	    PROTO((xvobject, char *, kaddr));
int  WorkspaceRestore 	    PROTO((Widget, kfile *, int, int));
int  WorkspaceSave 	    PROTO((Widget, kfile *, int, int, int));
void WorkspaceAnnounce	    PROTO((xvobject, kaddr, XEvent *, int *));
xvobject *WorkspaceChildren PROTO((xvobject, int, size_t *));
void WorkspaceCallbacks     PROTO((xvobject, kaddr, kaddr));
void WorkspaceGlyphRunCallback      PROTO((xvobject, kaddr, kaddr));
void WorkspaceGlyphModifiedCallback PROTO((xvobject, kaddr, kaddr));
void WorkspaceActive 	    PROTO((xvobject, int));

void WorkspaceClipboardInit       PROTO((void));
void WorkspaceClipboardCreate     PROTO((Widget));
void WorkspaceProcedureCreate     PROTO((Widget));
void WorkspaceClipboardClear      PROTO((xvobject, kaddr, kaddr));
void WorkspaceClipboardClose      PROTO((xvobject, kaddr, kaddr));
void WorkspaceClipboardDelete     PROTO((xvobject, kaddr, kaddr));
void ClipboardUndoDelete PROTO((xvobject, kaddr, kaddr));


/*
 *  Port.c
 */
int  PortCreateConnection PROTO((xvobject, xvobject));
int  PortGetInfo PROTO((xvobject, char **, char **, int *, int *, int *,
			int *, int *, xvobject **));
/*
 *  Procedure.c
 */
xvobject ProcedureLocate     PROTO((Widget));
void     ProcedureShowClosed PROTO((xvobject));


/*
 *  Node.c
 */
void     NodeSave        PROTO((xvobject, kfile *, int));
xvobject NodeRestore     PROTO((xvobject, kfile *, char *, int, int,int *));
void     NodeIpcCallback PROTO((kfile *, char *, char *, kaddr));

/*
 *  callback.c
 */
void xvl_expr_call_callback PROTO((long, int));

/*
 *  copydata.c
 */
int  xvl_copydata PROTO((xvobject, char *, char *, xvobject));
void xvl_stopcopy PROTO((xvobject));

/*
 *  utilities.c
 */
kform_struct *xvl_create_selection PROTO((kform *, int, char *));
int  xvl_excluded_selection        PROTO((kselection *));
void xvl_delete_selections  PROTO((xvobject));
void xvl_export_selections  PROTO((xvobject, xvobject));
void xvl_copy_pane          PROTO((xvobject, xvobject));
void xvl_copy_selection	    PROTO((xvobject, xvobject, kselection *, char *));
void xvl_report		    PROTO((int, char *, kvalist));
xvobject xvl_locate_port    PROTO((xvobject, int, char *, kform_struct *));
void xvl_set_extport_davs   PROTO((xvobject, xvobject *, int));
void xvl_clear_extport_davs PROTO((xvobject, xvobject *, int));
void xvl_trace		    PROTO((Widget, int, char *, kvalist));
void xvl_set_trace_flags    PROTO((int));

#define XVLANG_TRACE_EXEC	1
#define XVLANG_TRACE_IPC	2
#define XVLANG_TRACE_PROCS	4

#endif /* _xvlang_internals_h_ */
/* Don't add after this point */
