/*
  * Khoros: $Id: Float.c,v 1.17.2.2 1997/04/29 22:32:44 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: Float.c,v 1.17.2.2 1997/04/29 22:32:44 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>	              Khoros Float GUI Widget
   >>>>  Private:
   >>>>   Static:
   >>>> 		ClassInitialize()
   >>>>			Initialize()
   >>>> 		SetValues()
   >>>> 		ActionCallback()
   >>>> 		ScrollbarCallback()
   >>>>   Public:
   >>>>			xvw_create_float()
   >>>>	
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"
#include <xvobjects/FloatP.h>

static Boolean	SetValues       PROTO((Widget, Widget, Widget, ArgList,
				       Cardinal *));
static void     ClassInitialize PROTO((void));
static void	Initialize	PROTO((Widget, Widget, ArgList, Cardinal *));
static void	ActionCallback  PROTO((xvobject, kaddr, XEvent *));
static void     ScrollbarCallback PROTO((xvobject, kaddr, kaddr));



/*-------------------------------------------------------------------*
|
|   Full class attributes
|
--------------------------------------------------------------------*/

static xvattribute attributes[] = {
{XVW_FLOAT_LABEL_OBJECT,     NULL,   XtRPointer,  NULL},
{XVW_FLOAT_CRLABEL_OBJECT,   NULL,   XtRPointer,  NULL},
{XVW_FLOAT_SCROLLBAR_OBJECT, NULL,   XtRPointer,  NULL},
{XVW_FLOAT_TEXT_OBJECT,      NULL,   XtRPointer,  NULL},
{XVW_FLOAT_VALUE,            NULL,   XtRFloat,    NULL},
{XVW_FLOAT_INCREMENT,        NULL,   XtRFloat,    NULL},
{XVW_FLOAT_MINVALUE,         NULL,   XtRFloat,    NULL},
{XVW_FLOAT_MAXVALUE,         NULL,   XtRFloat,    NULL},
{XVW_FLOAT_CALLBACK,	     NULL,   XtRCallback, NULL},
};


/*-------------------------------------------------------------------*
|
|   Full class record constant
|
--------------------------------------------------------------------*/

#define offset(field) XtOffsetOf(XvwFloatWidgetRec, floatpart.field)

static XtResource resources[] = { 
{XVW_FLOAT_VALUE, NULL, XtRFloat, sizeof(float),
        offset(value), XtRString, (XtPointer) "0.0"},
{XVW_FLOAT_MINVALUE, NULL, XtRFloat, sizeof(float),
        offset(minvalue), XtRString, (XtPointer) "0.0"},
{XVW_FLOAT_MAXVALUE, NULL, XtRFloat, sizeof(float),
        offset(maxvalue), XtRString, (XtPointer) "1.0"},
{XVW_FLOAT_INCREMENT, NULL, XtRFloat, sizeof(float),
        offset(increment), XtRString, (XtPointer) "0.1"},
{XVW_FLOAT_LABEL_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(label), XtRImmediate, (XtPointer) NULL},
{XVW_FLOAT_TEXT_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(text), XtRImmediate, (XtPointer) NULL},
{XVW_FLOAT_SCROLLBAR_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(scrollbar), XtRImmediate, (XtPointer) NULL},
{XVW_FLOAT_CRLABEL_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(crlabel), XtRImmediate, (XtPointer) NULL},
{XVW_FLOAT_CALLBACK, NULL, XtRCallback, sizeof(XtPointer),
      offset(float_callback), XtRCallback, (XtPointer) NULL},

{XVW_PREFERRED_WIDTH, NULL, XtRDimension, sizeof(Dimension),
        XtOffsetOf(XvwFloatWidgetRec, manager.preferred_width),
        XtRImmediate, (XtPointer) 300},
{XVW_BORDER_WIDTH, NULL, XtRDimension, sizeof(Dimension),
        XtOffsetOf(XvwFloatWidgetRec, core.border_width),
        XtRImmediate, (XtPointer) 0 },
{XVW_BUFFER_DIST, NULL, XtRDimension, sizeof(Dimension),
        XtOffsetOf(XvwFloatWidgetRec, manager.buffer_dist),
        XtRImmediate, (XtPointer) 0 },
};
#undef offset


/*-------------------------------------------------------------------*
|
|   Class Declaration for Float Widget
|
--------------------------------------------------------------------*/

#define superclass (&xvwManagerWidgetClassRec)

XvwFloatWidgetClassRec xvwFloatWidgetClassRec =
{
  {
    (WidgetClass) superclass,		/* superclass		  */	
    "Float",				/* class_name		  */
    sizeof(XvwFloatWidgetRec),		/* size			  */
    ClassInitialize,			/* class_initialize	  */
    NULL,				/* class_part_initialize  */
    FALSE,				/* class_inited		  */
    Initialize,				/* initialize		  */
    NULL,				/* initialize_hook	  */
    XtInheritRealize,			/* realize		  */
    NULL,				/* actions		  */
    0,					/* num_actions		  */
    resources,				/* resources		  */
    XtNumber(resources),		/* resource_count	  */
    NULLQUARK,				/* xrm_class		  */
    TRUE,				/* compress_motion	  */
    XtExposeCompressMaximal,		/* compress_exposure	  */
    TRUE,				/* compress_enterleave    */
    FALSE,				/* visible_interest	  */
    NULL,				/* destroy		  */
    NULL,				/* resize		  */
    XtInheritExpose,			/* expose		  */
    SetValues,				/* set_values		  */
    NULL,				/* set_values_hook	  */
    XtInheritSetValuesAlmost,		/* set_values_almost	  */
    NULL,				/* get_values_hook	  */
    NULL,				/* accept_focus		  */
    XtVersion,				/* version		  */
    NULL,				/* callback_private	  */
    NULL,				/* tm_table		  */
    XtInheritQueryGeometry,		/* query_geometry	  */
    XtInheritDisplayAccelerator,	/* display_accelerator	  */
    NULL				/* extension		  */
  },  /* CoreClass fields initialization */
  {
    NULL,				/* geometry_manager	  */
    XtInheritChangeManaged,		/* change_managed	  */
    XtInheritInsertChild,		/* insert_child	  	  */
    XtInheritDeleteChild,		/* delete_child	  	  */
    NULL,				/* extension	 	  */
  },  /* CompositeClass fields initialization */
  {
    NULL,				    /* subresources	  */
    0,					    /* subresources_count */
    sizeof(XvwFloatWidgetConstraintsRec),  /* constraint_size	  */
    NULL,				    /* initialize	  */
    NULL,				    /* destroy		  */
    NULL,				    /* set_values	  */
    NULL,				    /* extension	  */
  },  /* ConstraintClass fields initialization */
  {
    XtInheritLayout,			    /* pre-layout routine     */
    XtInheritLayout,			    /* post-layout routine    */
    XtInheritChangeSel,			    /* change selected proc   */
    XtInheritEraseSel,			    /* erase selected proc    */
    XtInheritRefreshSel,		    /* refresh selection proc */
    XtInheritResize,			    /* resize		      */
    XtInheritGeometryManager,		    /* geometry_manager	      */
  },  /* XvwManagerWidgetClass fields initialization */
  {
    NULL,  		                    /* extension          */
  },  /* XvwFloatWidgetClass fields initialization */
};
#undef superclass

  /* for public consumption */
WidgetClass xvwFloatWidgetClass = (WidgetClass) &xvwFloatWidgetClassRec;


/*-------------------------------------------------------------------*
|
|   Miscelleanous defines for widget definition
|
--------------------------------------------------------------------*/

#undef  kwidget
#define kwidget(widget)	     (XvwFloatWidget) (widget)


/*-----------------------------------------------------------
|
|  Routine Name: ClassInitialize
|
|       Purpose: This method is called the first time an
|                instance of a XvwFloatWidget class has been created.
|                This is where the attributes for the class are
|		 initialized. 
|
|    Written By: Mark Young
|          Date: Nov 01, 1993
|
------------------------------------------------------------*/
/* ARGSUSED */
static void ClassInitialize(void)
{
        xvobjects_cache_pixmaps();
	xvw_init_attributes(xvwFloatWidgetClass, attributes,
		XtNumber(attributes), NULL, 0, NULL);
	xvw_load_resources("$DESIGN/objects/library/xvobjects/app-defaults/Float");
}


/*-----------------------------------------------------------
|
|  Routine Name: Initialize
|
|	Purpose: This method will set up the initial float widget instance.
|
|	  Input: request - not used
|                new1     - widget instance after initialization
|    Written By: Mark Young
|          Date: Nov 01, 1993
|
------------------------------------------------------------*/
/* ARGSUSED */
static void Initialize(
   Widget   request,
   Widget   new1,
   ArgList  args,
   Cardinal *num_args)
{
	XvwFloatWidget xwid = kwidget(new1);
	xvobject object = xvw_object(new1);

	char temp[KLENGTH];

	xvw_set_attributes(object,
		XVW_CHAR_MIN_HEIGHT, 1.0,
		XVW_BORDER_WIDTH,    0,
		NULL);

	xwid->floatpart.label = xvw_create_label(object, "label");
	xvw_set_attributes(xwid->floatpart.label,
		XVW_LABEL,	      "Float:",
		XVW_LABEL_JUSTIFY,    KLABEL_JUSTIFY_LEFT,
		XVW_BORDER_WIDTH,     0,
		XVW_RIGHT_OF,	      NULL,
		XVW_ABOVE,	      NULL,
		XVW_BELOW,	      NULL,
		NULL);

	xwid->floatpart.crlabel = xvw_create_pixmap(object, "live_pixmap");
	xvw_set_attributes(xwid->floatpart.crlabel,
		XVW_BORDER_WIDTH,     0,
		XVW_LEFT_OF,	      NULL,
		XVW_ABOVE,	      NULL,
		XVW_BELOW,	      NULL,
		XVW_PIXMAP_FILENAME,  LIVE_PIXMAP,
		NULL);

	(void) ksprintf(temp, "%g", xwid->floatpart.value);
	xwid->floatpart.text = xvw_create_text(object, "text");
	xvw_set_attributes(xwid->floatpart.text,
		XVW_TEXT_STRING,      temp,
		XVW_TEXT_MULTILINE,   FALSE,
		XVW_CHAR_WIDTH,	      10.0,
		XVW_BORDER_WIDTH,     2,
		XVW_LEFT_OF,	      xwid->floatpart.crlabel,
		XVW_ABOVE,	      NULL,
		XVW_BELOW,	      NULL,
		XVW_TACK_EDGE,	      KMANAGER_TACK_VERT,
		NULL);

	xwid->floatpart.scrollbar = xvw_create_scrollbar(object, "scrollbar");
	xvw_set_attributes(xwid->floatpart.scrollbar,
		XVW_SCROLL_VALUE,     (double) xwid->floatpart.value,
		XVW_SCROLL_MIN,       (double) xwid->floatpart.minvalue,
		XVW_SCROLL_MAX,	      (double) xwid->floatpart.maxvalue,
		XVW_SCROLL_INCR,      (double) xwid->floatpart.increment,
		XVW_LEFT_OF,	      xwid->floatpart.text,
		XVW_RIGHT_OF,	      xwid->floatpart.label,
		XVW_TACK_EDGE,	      KMANAGER_TACK_ALL,
		XVW_ABOVE,	      NULL,
		XVW_BELOW,	      NULL,
		NULL);

	xvw_add_action(xwid->floatpart.text, "<Key>Return", ActionCallback,
		object, TRUE);
	xvw_insert_callback(xwid->floatpart.scrollbar, XVW_SCROLL_CONT_MOTION,
			 FALSE, ScrollbarCallback, (XtPointer) object);
	xvw_insert_callback(xwid->floatpart.scrollbar, XVW_SCROLL_INCR_MOTION,
			 FALSE, ScrollbarCallback, (XtPointer) object);
}

/*-----------------------------------------------------------
|
|  Routine Name: SetValues
|
|       Purpose: This method is used to set the public values
|                of a XvwFloatWidget instance.  The public values
|                which can be changed are all related to the display
|		 of the float.
|
|         Input: current - the widget containing current settings
|                request - the widget containing requested settings
|                new1     - the widget processed through all set values methods
|       Returns: TRUE (1) if redisplay is required, FALSE (0) otherwise
|    Written By: Mark Young
|          Date: Nov 01, 1993
|
------------------------------------------------------------*/
/* ARGSUSED */
static Boolean SetValues (
   Widget   current,
   Widget   request,
   Widget   new1,
   ArgList  args,
   Cardinal *num)
{
	XvwFloatWidget cxwid = kwidget(current);
	XvwFloatWidget nxwid = kwidget(new1);

	char temp[KLENGTH];

	if (cxwid->floatpart.value    != nxwid->floatpart.value ||
	    cxwid->floatpart.minvalue != nxwid->floatpart.minvalue ||
	    cxwid->floatpart.maxvalue != nxwid->floatpart.maxvalue)
	{
	   xvw_set_attributes(nxwid->floatpart.scrollbar,
		XVW_SCROLL_MIN,    (double) nxwid->floatpart.minvalue,
		XVW_SCROLL_VALUE,  (double) nxwid->floatpart.value,
		XVW_SCROLL_MAX,    (double) nxwid->floatpart.maxvalue,
		NULL);

	   ksprintf(temp, "%g", nxwid->floatpart.value);
	   xvw_set_attribute(nxwid->floatpart.text, XVW_TEXT_STRING, temp);

           /* no increment specified, default to 1/10 of scrollbar size */
           if (cxwid->floatpart.increment == nxwid->floatpart.increment)
           {
                double incr = ((double) nxwid->floatpart.maxvalue -
                               (double) nxwid->floatpart.minvalue)/10.0;
                           
                 xvw_set_attribute(nxwid->floatpart.scrollbar,
                                   XVW_SCROLL_INCR, incr); 
           }

	}

	if (cxwid->floatpart.increment != nxwid->floatpart.increment)
	{
	   xvw_set_attributes(nxwid->floatpart.scrollbar,
		XVW_SCROLL_INCR, (double) nxwid->floatpart.increment,
		NULL);
	}
	return(FALSE);
}

/*-----------------------------------------------------------
|
|  Routine Name: ActionCallback
|
|       Purpose: This routine will be called when the user presses return
|		 within the text window.
|
|         Input: text      - which text being manipulated
|                client_data - the float gui object
|    Written By: Mark Young
|          Date: Nov 01, 1993
|
------------------------------------------------------------*/
/* ARGSUSED */
static void ActionCallback(
   xvobject text,
   kaddr    client_data,
   XEvent   *event)
{
	xvobject object = (xvobject) client_data;
	XvwFloatWidget xwid = (XvwFloatWidget) xvw_widget(object);

	float value;
	char  *tmp = NULL;
	char  temp[KLENGTH];

	xvw_get_attribute(text, XVW_TEXT_STRING, &tmp);

	if (kstrlen(tmp) == 0)
        {
            value = xwid->floatpart.value;
            ksprintf(temp, "%g", xwid->floatpart.value);
            xvw_set_attribute(text, XVW_TEXT_STRING, temp);
        }
	else (void) ksscanf(tmp, "%g", &value);

	xvw_set_attribute(object, XVW_FLOAT_VALUE, value);
	XtCallCallbacks(xvw_widget(object), XVW_FLOAT_CALLBACK,
		&xwid->floatpart.value);
}

/*-----------------------------------------------------------
|
|  Routine Name: ScrollbarCallback
|
|       Purpose: This routine will change the text and update the
|	 	 scrollbar according to the value paased in.
|
|         Input: scrollbar      - which scrollbar being manipulated
|		 client_data - the float gui object
|		 call_data   - float representing the scroll position
|    Written By: Mark Young 
|          Date: Jun 06, 1993 10:58
|
------------------------------------------------------------*/
/* ARGSUSED */
static void ScrollbarCallback(
   xvobject scrollbar,
   kaddr    client_data,
   kaddr    call_data)
{
	xvobject object = (xvobject) client_data;
	XvwFloatWidget xwid = (XvwFloatWidget) xvw_widget(object);
	double value = *((double *) call_data);


	xvw_set_attribute(object, XVW_FLOAT_VALUE, (float) value);
	XtCallCallbacks(xvw_widget(object), XVW_FLOAT_CALLBACK,
		&xwid->floatpart.value);
}

/************************************************************
*
*  Routine Name: xvw_create_float - create a float object
*
*       Purpose: The float GUI object 
*                allows the user to enter a float precision value.
*                It features a text box in which the user may explicitly 
*                enter the float value;  the float value is registered 
*                when the user hits <cr>.  The float value may be bounded 
*                by a minimum and maximum value, if desired.
*
*                A scroll bar provides an alternate way for the user to 
*                specify the float value.  The float object consists of 
*                a manager object with four children: a label object, a 
*                text object, a scrollbar, and a pixmap object.  
*
*                A callback can be installed on the float object, which
*                will be fired when the user enters a new float value.
*
*         Input: parent - parent of the float object; NULL will cause
*                         a default toplevel to be created automatically
*                name   - a name for this particular instance of the object
*                         (for use in app-defaults files, etc)
*        Output:
*       Returns: The float GUI object on success, NULL on failure
*
*  Restrictions:
*    Written By: Mark Young
*          Date: Nov 01, 1993
*      Verified: 
*  Side Effects:
* Modifications:
*
*******************************************************************/

xvobject xvw_create_float(
   xvobject parent,
   char     *name)
{
	xvobject object;


	object = xvw_create(parent, FALSE, TRUE, name, FloatWidgetClass);
	return(object);
}
