 /*
  * Khoros: $Id: TitleBar.c,v 1.9.2.1 1997/04/29 22:33:00 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: TitleBar.c,v 1.9.2.1 1997/04/29 22:33:00 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>	              Khoros TitleBar GUI Widget
   >>>>  Private:
   >>>>   Static:
   >>>> 		ClassInitialize()
   >>>>			Initialize()
   >>>>			Realize()
   >>>>			Destroy()
   >>>> 		TitleBarHandler()
   >>>>   Public:
   >>>>			xvw_create_titlebar()
   >>>>	
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"
#include <xvobjects/TitleBarP.h>

static void ClassInitialize PROTO((void));
static void Initialize	  PROTO((Widget, Widget, ArgList, Cardinal *));
static void Realize       PROTO((Widget, XtValueMask *,XSetWindowAttributes *));
static void Destroy       PROTO((Widget));
static void TitleBarHandler  PROTO((xvobject, kaddr, XEvent *, int *));

#define ICONIFY_PIXMAP "$DESIGN/objects/library/xvobjects/pixmaps/iconify.xpm"
#define DETACH_PIXMAP  "$DESIGN/objects/library/xvobjects/pixmaps/detach.xpm"

/*-------------------------------------------------------------------*
|
|   Full class attributes
|
--------------------------------------------------------------------*/

static xvattribute attributes[] = {
{XVW_TITLEBAR_ICONIFY_OBJECT,  NULL, XtRPointer,  NULL},
{XVW_TITLEBAR_DETACH_OBJECT,   NULL, XtRPointer,  NULL},
{XVW_TITLEBAR_TITLE_OBJECT,    NULL, XtRPointer,  NULL},
{XVW_TITLEBAR_ICON_OBJECT,     NULL, XtRPointer,  NULL},
{XVW_TITLEBAR_CALLBACK,	       NULL, XtRCallback, NULL},
};


/*-------------------------------------------------------------------*
|
|   Full class record constant
|
--------------------------------------------------------------------*/

#define offset(field) XtOffsetOf(XvwTitleBarWidgetRec, titlebar.field)

static XtResource resources[] = { 
{XVW_TITLEBAR_DETACH_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(detach), XtRImmediate, (XtPointer) NULL},
{XVW_TITLEBAR_ICONIFY_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(iconify), XtRImmediate, (XtPointer) NULL},
{XVW_TITLEBAR_TITLE_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(title), XtRImmediate, (XtPointer) NULL},
{XVW_TITLEBAR_ICON_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(icon), XtRImmediate, (XtPointer) NULL},
{XVW_TITLEBAR_CALLBACK, NULL, XtRCallback, sizeof(XtPointer),
      offset(titlebar_callback), XtRCallback, (XtPointer) NULL},

{XVW_SHADOW_TYPE, NULL, XtRInt, sizeof(int),
        XtOffsetOf(XvwTitleBarWidgetRec, manager.shadow_type),
        XtRImmediate, (XtPointer) KSHADOW_OUT},
{XVW_DEF_HORIZ_DIST, NULL, XtRPosition, sizeof(Position),
        XtOffsetOf(XvwTitleBarWidgetRec, manager.horiz_offset),
        XtRImmediate, (XtPointer) 0},
{XVW_DEF_VERT_DIST, NULL, XtRPosition, sizeof(Position),
        XtOffsetOf(XvwTitleBarWidgetRec, manager.vert_offset),
        XtRImmediate, (XtPointer) 0},
{XVW_BORDER_WIDTH, NULL, XtRDimension, sizeof(Dimension),
        XtOffsetOf(XvwTitleBarWidgetRec, core.border_width),
        XtRImmediate, (XtPointer) 0},
};
#undef offset


/*-------------------------------------------------------------------*
|
|   Class Declaration for TitleBar Widget
|
--------------------------------------------------------------------*/

#define superclass (&xvwManagerWidgetClassRec)

XvwTitleBarWidgetClassRec xvwTitleBarWidgetClassRec =
{
  {
    (WidgetClass) superclass,		/* superclass		  */	
    "TitleBar",			/* class_name		  */
    sizeof(XvwTitleBarWidgetRec),	/* size			  */
    ClassInitialize,			/* class_initialize	  */
    NULL,				/* class_part_initialize  */
    FALSE,				/* class_inited		  */
    Initialize,				/* initialize		  */
    NULL,				/* initialize_hook	  */
    Realize,				/* realize		  */
    NULL,				/* actions		  */
    0,					/* num_actions		  */
    resources,				/* resources		  */
    XtNumber(resources),		/* resource_count	  */
    NULLQUARK,				/* xrm_class		  */
    TRUE,				/* compress_motion	  */
    XtExposeCompressMaximal,		/* compress_exposure	  */
    TRUE,				/* compress_enterleave    */
    FALSE,				/* visible_interest	  */
    Destroy,				/* destroy		  */
    NULL,				/* resize		  */
    XtInheritExpose,			/* expose		  */
    NULL,				/* set_values		  */
    NULL,				/* set_values_hook	  */
    XtInheritSetValuesAlmost,		/* set_values_almost	  */
    NULL,				/* get_values_hook	  */
    NULL,				/* accept_focus		  */
    XtVersion,				/* version		  */
    NULL,				/* callback_private	  */
    NULL,				/* tm_table		  */
    XtInheritQueryGeometry,		/* query_geometry	  */
    XtInheritDisplayAccelerator,	/* display_accelerator	  */
    NULL				/* extension		  */
  },  /* CoreClass fields initialization */
  {
    NULL,                    		/* geometry_manager	  */
    XtInheritChangeManaged,		/* change_managed	  */
    XtInheritInsertChild,		/* insert_child	  	  */
    XtInheritDeleteChild,		/* delete_child	  	  */
    NULL,				/* extension	 	  */
  },  /* CompositeClass fields initialization */
  {
    NULL,				    /* subresources	  */
    0,					    /* subresources_count */
    sizeof(XvwTitleBarWidgetConstraintsRec),  /* constraint_size	  */
    NULL,				    /* initialize	  */
    NULL,				    /* destroy		  */
    NULL,				    /* set_values	  */
    NULL,				    /* extension	  */
  },  /* ConstraintClass fields initialization */
  {
    XtInheritLayout,			    /* pre-layout routine     */
    XtInheritLayout,			    /* post-layout routine    */
    XtInheritChangeSel,			    /* change selected proc   */
    XtInheritEraseSel,			    /* erase selected proc    */
    XtInheritRefreshSel,		    /* refresh selection proc */
    XtInheritResize,			    /* resize		      */
    XtInheritGeometryManager,		    /* geometry_manager	      */
  },  /* XvwManagerWidgetClass fields initialization */
  {
    NULL,  		                    /* extension          */
  },  /* XvwTitleBarWidgetClass fields initialization */
};
#undef superclass

  /* for public consumption */
WidgetClass xvwTitleBarWidgetClass = (WidgetClass) &xvwTitleBarWidgetClassRec;


/*-------------------------------------------------------------------*
|
|   Miscelleanous defines for widget definition
|
--------------------------------------------------------------------*/

#undef  kwidget
#define kwidget(widget)	     (XvwTitleBarWidget) (widget)


/*-----------------------------------------------------------
|
|  Routine Name: ClassInitialize
|
|       Purpose: This method is called the first time an
|                instance of a XvwTitleBarWidget class has been created.
|                This is where the attributes for the class are
|		 initialized. 
|
|    Written By: Mark Young
|          Date: Dec 17, 1994
|
------------------------------------------------------------*/
/* ARGSUSED */
static void ClassInitialize(void)
{
	xvobjects_cache_pixmaps();
	xvw_init_attributes(xvwTitleBarWidgetClass, attributes,
		XtNumber(attributes), NULL, 0, NULL);
	xvw_load_resources("$DESIGN/objects/library/xvobjects/app-defaults/TitleBar");
}


/*-----------------------------------------------------------
|
|  Routine Name: Initialize
|
|	Purpose: This method will set up the initial titlebar widget instance.
|
|	  Input: request - not used
|                new1     - widget instance after initialization
|    Written By: Mark Young
|          Date: Dec 17, 1994
|
------------------------------------------------------------*/
/* ARGSUSED */
static void Initialize(
   Widget   request,
   Widget   new1,
   ArgList  args,
   Cardinal *num_args)
{
	unsigned long mask;
	XvwTitleBarWidget xwid   = kwidget(new1);
	xvobject          object = xvw_object(new1);

	xwid->titlebar.detached = FALSE;
	xwid->titlebar.iconify = xvw_create_pixmap(object, "iconify");
	xvw_set_attributes(xwid->titlebar.iconify,
	     XVW_PIXMAP_FILENAME, ICONIFY_PIXMAP,
	     XVW_RIGHT_OF,        NULL,
	     XVW_ABOVE,           NULL,
	     XVW_BELOW,           NULL,
	     NULL);

	xwid->titlebar.detach = xvw_create_pixmap(object, "detach");
	xvw_set_attributes(xwid->titlebar.detach,
	     XVW_PIXMAP_FILENAME, DETACH_PIXMAP,
	     XVW_LEFT_OF,         NULL,
	     XVW_ABOVE,           NULL,
	     XVW_BELOW,           NULL,
	     NULL);

	xwid->titlebar.title = xvw_create_label(object, "title");
	xvw_set_attributes(xwid->titlebar.title,
	     XVW_LABEL,    "TitleBar",
	     XVW_RIGHT_OF, xwid->titlebar.iconify,
	     XVW_LEFT_OF,  xwid->titlebar.detach,
	     XVW_ABOVE,    NULL,
	     XVW_BELOW,    NULL,
	     NULL);

	xwid->titlebar.genwindow = xvw_create_genericwindow(NULL, "toplevel");
	xvw_unmanage(xwid->titlebar.genwindow);

	mask = ButtonPressMask | ButtonReleaseMask;
	xvw_add_event(xwid->titlebar.iconify, mask, TitleBarHandler, object);
	xvw_add_event(xwid->titlebar.detach,  mask, TitleBarHandler, object);
}

/*-----------------------------------------------------------
|
|  Routine Name: Destroy 
|
|       Purpose: This method will destroy the generic window object.
|
|         Input: widget - the titlebar widget being destroyed
|    Written By: Mark Young
|          Date: Apr 08, 1996
|
------------------------------------------------------------*/
/* ARGSUSED */
static void Destroy(
   Widget widget)
{
	XvwTitleBarWidget xwid = kwidget(widget);


	if (xwid->titlebar.genwindow != NULL)
	   xvw_destroy(xwid->titlebar.genwindow);
}

/*-----------------------------------------------------------
|
|  Routine Name: Realize
|
|       Purpose: This method will set up the window attributes
|                and create a window for the XvwTitleBaridget.  It will
|                resize it's children to guarantee that they will
|                correctly fit into its initial size.   The desired
|                initial window attributes are passed in via
|                a mask and list of specification attributes.
|
|         Input: widget     - the widget to realize
|                valuemask  - determines the window attributes being passed in
|                attributes - the list of window attributes to be set
|    Written By: Mark Young
|          Date: Mar 31, 1996
|
------------------------------------------------------------*/
/* ARGSUSED */
static void Realize(
   Widget               widget,
   XtValueMask          *valuemask,
   XSetWindowAttributes *winattrib)
{
	XvwTitleBarWidget xwid = (XvwTitleBarWidget) kwidget(widget);

	Window window;

        /*
         *  Now do the important thing.  Realize the TitleBar so that we can
         *  get on with it.
         */
        (*xvwTitleBarWidgetClass->core_class.superclass->core_class.realize)
                (widget, valuemask, winattrib);

	window = XtWindow(XtParent(widget));
	xvw_set_attribute(xwid->titlebar.genwindow, XVW_GENERIC_WINDOW, window);
}

/*-----------------------------------------------------------
|
|  Routine Name: TitleBarHandler
|
|       Purpose: This routine will change the text and update the
|	 	 scrollbar according to the value paased in.
|
|         Input: object      - the object which is calling us
|		 call_data   - none
|		 client_data - the titlebar gui object
|    Written By: Mark Young 
|          Date: Jun 06, 1993
|
------------------------------------------------------------*/
/* ARGSUSED */
static void TitleBarHandler(
   xvobject object,
   kaddr    client_data,
   XEvent   *event,
   int      *dispatch)
{
	xvobject titlebar = (xvobject) client_data;
	Widget   widget   = xvw_widget(titlebar);
	XvwTitleBarWidget xwid = (XvwTitleBarWidget) kwidget(widget);

        int      status, x, y;
	xvobject parent    = xvw_parent(titlebar);
	Widget   pwidget   = xvw_widget(parent);
	xvobject genwindow = xwid->titlebar.genwindow;


	*dispatch = FALSE;
	if (event->type == ButtonPress)
	   return;

        if (object == xwid->titlebar.iconify)
        {
           xvw_unmap(parent);
	   if (xwid->titlebar.icon != NULL)
	      xvw_map(xwid->titlebar.icon);

	   status = KTITLEBAR_ICONIFIED;
	   XtCallCallbacks((Widget) xwid, XVW_TITLEBAR_CALLBACK, &status);
        }
        else if (object == xwid->titlebar.detach && !xwid->titlebar.detached)
        {
	   if (xvw_check_managed(xwid->titlebar.genwindow) == FALSE)
	      xvw_manage(xwid->titlebar.genwindow);

	   xwid->titlebar.xpos = pwidget->core.x;
	   xwid->titlebar.ypos = pwidget->core.y;

	   xwid->titlebar.detached = TRUE;
	   XReparentWindow(xvw_display(parent), xvw_window(parent),
			xvw_window(xvw_parent(genwindow)), 0, 0);
	   xvw_set_toplevel(parent, xvw_parent(genwindow));
	   xvw_set_attribute(parent, XVW_MANAGER_RELAYOUT, TRUE);
	   xvw_map(genwindow);

	   status = KTITLEBAR_DETACHED;
	   XtCallCallbacks((Widget) xwid, XVW_TITLEBAR_CALLBACK, &status);
        }
        else if (object == xwid->titlebar.detach && xwid->titlebar.detached)
        {
	   x = xwid->titlebar.xpos;
	   y = xwid->titlebar.ypos;

	   xwid->titlebar.detached = FALSE;
	   xvw_unmap(parent);
	   XReparentWindow(xvw_display(parent), xvw_window(parent),
			xvw_window(xvw_parent(parent)), x, y);
	   xvw_set_toplevel(parent, NULL);
	   xvw_map(parent);

	   status = KTITLEBAR_REATTACHED;
	   XtCallCallbacks((Widget) xwid, XVW_TITLEBAR_CALLBACK, &status);
        }
}


/************************************************************
*
*  Routine Name: xvw_create_titlebar - create a titlebar GUI object
*
*       Purpose: The titlebar GUI object allows the program to place a
*		 standard titlebar in order to manipulate some kind of
*		 manager.  Typically the type of object to be manipulated
*		 is some kind of canvas which needs a more intuitative
*		 direct manipulation interface for moving and resizing
*		 the parent window.
*                
*                The titlebar GUI object consists of a manager object 
*                with four children: three button object, and a label object.
*
*                A callback can be installed on the titlebar object, which
*                will be fired when the user closes or iconifies the
*		 parent window.
*
*         Input: parent - parent of the titlebar object; NULL will cause
*                         a default toplevel to be created automatically
*                name   - name with which to reference titlebar object
*
*        Output:
*       Returns: The titlebar object on success, NULL on failure
*
*  Restrictions:
*    Written By: Mark Young
*          Date: Dec 17, 1994
*      Verified: 
*  Side Effects:
* Modifications:
*
*******************************************************************/

xvobject xvw_create_titlebar(
   xvobject parent,
   char     *name)
{
	xvobject object;


	object = xvw_create(parent, TRUE, TRUE, name, TitleBarWidgetClass);
	return(object);
}
