/*
  * Khoros: $Id: Warn.c,v 1.15.2.1 1997/04/29 22:33:03 mirage Exp $
  */
 
#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: Warn.c,v 1.15.2.1 1997/04/29 22:33:03 mirage Exp $";
#endif
 
 
/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		Khoros Warn Widget
   >>>>   Static:
   >>>>                 ClassInitialize()
   >>>>                 Initialize()
   >>>>                 ButtonCallback()
   >>>>   Public:
   >>>>                 xvw_create_warn()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"
#include <xvobjects/WarnP.h>

static void     ClassInitialize PROTO((void));
static void	Initialize	PROTO((Widget, Widget, ArgList, Cardinal *));
static void	ButtonCallback  PROTO((xvobject, kaddr, kaddr));



/*-------------------------------------------------------------------*
|
|   Define Default Pixmap Paths
|
--------------------------------------------------------------------*/
 
#define WARN_PIXMAP "$DESIGN/objects/library/xvobjects/pixmaps/warn.xpm"

/*-------------------------------------------------------------------*
|
|   Full class attributes
|
--------------------------------------------------------------------*/

static xvattribute attributes[] = {
{XVW_WARN_LABEL_OBJECT,   NULL,   XtRPointer,  NULL},
{XVW_WARN_BUTTON_OBJECT,  NULL,   XtRPointer,  NULL},
{XVW_WARN_TEXT_OBJECT,    NULL,   XtRPointer,  NULL},
{XVW_WARN_CALLBACK,	  NULL,   XtRCallback, NULL},

{XVW_WARN_PIXMAP,	  NULL,   XtRPixmap,   NULL},
{XVW_WARN_PIXMAPFILE,	  XVW_WARN_PIXMAP, XtRString, XtRPixmap},
};


/*-------------------------------------------------------------------*
|
|   Full class record constant
|
--------------------------------------------------------------------*/

#define offset(field) XtOffsetOf(XvwWarnWidgetRec, warn.field)

static XtResource resources[] = { 
{XVW_WARN_LABEL_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(label), XtRImmediate, (XtPointer) NULL},
{XVW_WARN_BUTTON_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(button), XtRImmediate, (XtPointer) NULL},
{XVW_WARN_TEXT_OBJECT, NULL, XtRPointer, sizeof(XtPointer),
        offset(text), XtRImmediate, (XtPointer) NULL},
{XVW_WARN_CALLBACK, NULL, XtRCallback, sizeof(XtPointer),
      offset(warn_callback), XtRCallback, (XtPointer) NULL},

{XVW_WARN_PIXMAP, XVW_WARN_PIXMAPFILE,  XtRPixmap, sizeof(Pixmap),
        offset(warn_pixmap), XtRString, (XtPointer) WARN_PIXMAP},
};
#undef offset


/*-------------------------------------------------------------------*
|
|   Class Declaration for Warn Widget
|
--------------------------------------------------------------------*/

#define superclass (&xvwManagerWidgetClassRec)

XvwWarnWidgetClassRec xvwWarnWidgetClassRec =
{
  {
    (WidgetClass) superclass,		/* superclass		  */	
    "Warn",				/* class_name		  */
    sizeof(XvwWarnWidgetRec),		/* size			  */
    ClassInitialize,			/* class_initialize	  */
    NULL,				/* class_part_initialize  */
    FALSE,				/* class_inited		  */
    Initialize,				/* initialize		  */
    NULL,				/* initialize_hook	  */
    XtInheritRealize,			/* realize		  */
    NULL,				/* actions		  */
    0,					/* num_actions		  */
    resources,				/* resources		  */
    XtNumber(resources),		/* resource_count	  */
    NULLQUARK,				/* xrm_class		  */
    TRUE,				/* compress_motion	  */
    XtExposeCompressMaximal,		/* compress_exposure	  */
    TRUE,				/* compress_enterleave    */
    FALSE,				/* visible_interest	  */
    NULL,				/* destroy		  */
    NULL,				/* resize		  */
    XtInheritExpose,			/* expose		  */
    NULL,				/* set_values		  */
    NULL,				/* set_values_hook	  */
    XtInheritSetValuesAlmost,		/* set_values_almost	  */
    NULL,				/* get_values_hook	  */
    NULL,				/* accept_focus		  */
    XtVersion,				/* version		  */
    NULL,				/* callback_private	  */
    NULL,				/* tm_table		  */
    XtInheritQueryGeometry,		/* query_geometry	  */
    XtInheritDisplayAccelerator,	/* display_accelerator	  */
    NULL				/* extension		  */
  },  /* CoreClass fields initialization */
  {
    NULL,                    		/* geometry_manager	  */
    XtInheritChangeManaged,		/* change_managed	  */
    XtInheritInsertChild,		/* insert_child	  	  */
    XtInheritDeleteChild,		/* delete_child	  	  */
    NULL,				/* extension	 	  */
  },  /* CompositeClass fields initialization */
  {
    NULL,				    /* subresources	  */
    0,					    /* subresources_count */
    sizeof(XvwWarnWidgetConstraintsRec),  /* constraint_size	  */
    NULL,				    /* initialize	  */
    NULL,				    /* destroy		  */
    NULL,				    /* set_values	  */
    NULL,				    /* extension	  */
  },  /* ConstraintClass fields initialization */
  {
    XtInheritLayout,			    /* pre-layout routine     */
    XtInheritLayout,			    /* post-layout routine    */
    XtInheritChangeSel,			    /* change selected proc   */
    XtInheritEraseSel,			    /* erase selected proc    */
    XtInheritRefreshSel,		    /* refresh selection proc */
    XtInheritResize,			    /* resize		      */
    XtInheritGeometryManager,		    /* geometry_manager	      */
  },  /* XvwManagerWidgetClass fields initialization */
  {
    NULL,  		                    /* extension          */
  },  /* XvwWarnWidgetClass fields initialization */
};
#undef superclass

  /* for public consumption */
WidgetClass xvwWarnWidgetClass = (WidgetClass) &xvwWarnWidgetClassRec;


/*-------------------------------------------------------------------*
|
|   Miscelleanous defines for widget definition
|
--------------------------------------------------------------------*/

#undef  kwidget
#define kwidget(widget)	     (XvwWarnWidget) (widget)


/*-----------------------------------------------------------
|
|  Routine Name: ClassInitialize
|
|       Purpose: This method is called the first time an
|                instance of a XvwWarnWidget class has been created.
|                This is where the attributes for the class are
|		 initialized. 
|
|    Written By: Mark Young
|          Date: Oct 19, 1992 9:54
|
------------------------------------------------------------*/
/* ARGSUSED */
static void ClassInitialize(void)
{
        xvobjects_cache_pixmaps();
	xvw_init_attributes(xvwWarnWidgetClass, attributes,
		XtNumber(attributes), NULL, 0, NULL);
	xvw_load_resources("$DESIGN/objects/library/xvobjects/app-defaults/Warn");
}


/*-----------------------------------------------------------
|
|  Routine Name: Initialize
|
|	Purpose: This method will set up the initial warn widget instance.
|
|	  Input: request - not used
|                new1     - widget instance after initialization
|    Written By: Mark Young
|          Date: May 26, 1993 13:28
|
------------------------------------------------------------*/
/* ARGSUSED */
static void Initialize(
   Widget   request,
   Widget   new1,
   ArgList  args,
   Cardinal *num_args)
{
	XvwWarnWidget xwid = kwidget(new1);
	xvobject warn_pixmap, separator, object = xvw_object(new1);


	warn_pixmap = xvw_create_pixmap(object, "pixmap");
	xvw_set_attributes(warn_pixmap,
		XVW_PIXMAP,	      xwid->warn.warn_pixmap,
		XVW_BELOW,            NULL,
		XVW_RIGHT_OF,         NULL,
		XVW_VERT_DIST,        8,
		XVW_HORIZ_DIST,       8,
		XVW_BORDER_WIDTH,     0,
		NULL);

	xwid->warn.button = xvw_create_button(object, "button");
	xvw_set_attributes(xwid->warn.button,
		XVW_LABEL,		"Ok",
		XVW_CHAR_HEIGHT,	1.25,
		XVW_CHAR_WIDTH,		7.0,
		XVW_LABEL_JUSTIFY,      KLABEL_JUSTIFY_CENTER,
		XVW_ABOVE,		NULL,
		XVW_LEFT_OF,		NULL,
		XVW_RIGHT_OF,		NULL,
		XVW_VERT_DIST,		8,
		NULL);

	separator = xvw_create_separator(object, "separator");
	xvw_set_attributes(separator, 
			   XVW_ABOVE,	   xwid->warn.button,
			   XVW_VERT_DIST,  8,
                           NULL);

	xwid->warn.text = xvw_create_text(object, "text");
	xvw_set_attributes(xwid->warn.text,
		XVW_TEXT_MULTILINE,   TRUE,
		XVW_TACK_EDGE,        KMANAGER_TACK_ALL,
		XVW_TEXT_WRAP,        KTEXT_WRAP_WORD,
		XVW_TEXT_EDIT_TYPE,   KTEXT_READ,
		XVW_ABOVE,	      separator,
	        XVW_VERT_DIST,        8,
		XVW_BELOW,	      warn_pixmap,
		XVW_RIGHT_OF,	      NULL,
		XVW_LEFT_OF,	      NULL,
	        XVW_HORIZ_DIST,       8,
		NULL);

	xwid->warn.label = xvw_create_label(object, "label");
	xvw_set_attributes(xwid->warn.label,
		XVW_BORDER_WIDTH,	0,
		XVW_LABEL,		"Error:",
		XVW_LABEL_JUSTIFY,      KLABEL_JUSTIFY_LEFT,
		XVW_LABEL_SELECTABLE,   TRUE,
		XVW_ABOVE,		xwid->warn.text,
		XVW_BELOW,		NULL,
		XVW_RIGHT_OF,		warn_pixmap,
	        XVW_HORIZ_DIST,         8,
	        XVW_VERT_DIST,          8,
		NULL);

	xvw_set_attributes(object,
		XVW_CHAR_WIDTH,     42.0,
		XVW_CHAR_HEIGHT,     9.0,
		NULL);

	xvw_insert_callback(xwid->warn.button, XVW_BUTTON_SELECT, TRUE,
			ButtonCallback, object);
}

/*-----------------------------------------------------------
|
|  Routine Name: ButtonCallback
|
|       Purpose: This routine will be called when the button callback is
|                activated.
|
|         Input: object      - which button being manipulated
|                client_data - the button widget
|                call_data   - int representing the index
|    Written By: Mark Young
|          Date: Jun 06, 1993 10:58
|
------------------------------------------------------------*/
/* ARGSUSED */
static void ButtonCallback(
   xvobject object,
   kaddr    client_data,
   kaddr    call_data)
{
	xvobject warn = (xvobject) client_data;


	XtCallCallbacks(xvw_widget(warn), XVW_WARN_CALLBACK, NULL);
	xvw_unmap(xvw_toplevel(warn));
	xvw_destroy(warn);
}


/************************************************************
*
*  Routine Name: xvw_create_warn - create a warning object
*
*       Purpose: Creates a warning object.  The warning object is
*                a pop-up window that displays a warning message.
*                A warn icon on the upper left hand side of
*                the warning object draws the attention of the user;
*                a single button on the upper right hand side of
*                the warning object allows the user to acknowledge
*                the warning.
*
*                After the user clicks on the acknowledgment button,
*                the warning object is destroyed.
*
*                A callback can be installed on the warning object, which
*                will be fired when the user clicks on the acknowledgment
*                button.
*
*         Input: parent - parent of the warn object; NULL will cause
*                         a default toplevel to be created automatically
*                name   - a name for this particular instance of the object
*                         (for use in app-defaults files, etc)
*
*        Output:
*       Returns: The warn widget on success, NULL on failure
*
*  Restrictions:
*    Written By: Mark Young
*          Date: Oct 27, 1993
*      Verified: 
*  Side Effects:
* Modifications:
*
*******************************************************************/

xvobject xvw_create_warn(
   xvobject parent,
   char     *name)
{
	xvobject object;


	object = xvw_create(parent, TRUE, TRUE, name, WarnWidgetClass);
	return(object);
}
