 /* Khoros: $Id: internals.h,v 1.11 1997/01/20 05:27:31 mirage Exp $ */
 /* $Log: internals.h,v $
  * Revision 1.11  1997/01/20 05:27:31  mirage
  * Make gw, html added and copyright changes
  *
  * Revision 1.10  1996/06/11 17:25:19  mirage
  * Fixed xvutils_initialized problem.
  *
  * Revision 1.9  1996/05/04 14:50:43  mirage
  * new look/feel, removed xvu_list_wait and xvu_text_wait
  *
  * Revision 1.8  1996/04/25 15:55:23  mirage
  * Updated object
  *
  * Revision 1.7  1996/04/17 23:14:31  mirage
  * changed xvu_select_wait to xvu_choose_wait, added xvu_save_wait and xvu_quit_wait
  *
  * Revision 1.6  1996/04/16 20:51:34  mirage
  * rewrote exit dialog box
  *
  * Revision 1.5  1996/04/16 05:30:02  mirage
  * Big cantata update #2
  *
  * Revision 1.3  1996/02/17 20:55:48  fas
  * Copyright updated
  *
  * Revision 1.2  1995/12/06 01:43:35  mirage
  * Placing mirage under cvs
  * */ 

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */



/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for xvutils library
   >>>>
   >>>>    Written By: Danielle Argiro
   >>>>
   >>>>          Date: Jul 16, 1992
   >>>>
   >>>> Modifications: Updated to Khoros 2.0 (DA)
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvutils_internals_h_
#define _xvutils_internals_h_


        /*-------------------------------------*
        |       #include
        ---------------------------------------*/

#include <design.h>
#include <xvinclude.h>


        /*-------------------------------------*
        |       #defines
        ---------------------------------------*/

#define XVU_LEFT_MARGIN     6

#define XVU_BOGUS_PATH      0
#define XVU_DIRECTORY_PATH  1
#define XVU_FILE_PATH       2

#define XVU_MAXFILENUM      50


        /*-------------------------------------*
        |       typedefs
        ---------------------------------------*/

/*
 *    xvu_list_entry maintains items in list	
 *    where only one item can be selected
 */
typedef struct _xvu_list_entry {

        int count;
        xvw_list_struct *entry;
        struct _xvu_list_entry *next; 
	struct _xvu_list_entry *prev;

} xvu_list_entry;

/*
 *    xvu_multlist_entry maintains items in list	
 *    where more than one item can be selected
 */
typedef struct _xvu_multlist_entry {

        xvobject button;
        xvobject list_back;
        char   *filename;
        char   **items;
        int    currently_mapped;
        int   numitems;
        struct _xvu_multlist_entry *next;
} xvu_multlist_entry;

typedef struct {

        xvobject toplevel;
        xvobject back;
        xvobject label;
        char *path;
        int duplicate_entries;
        xvu_multlist_entry *multlist;
} List_Data;

        /*-------------------------------------*
        |       global variable declarations
        ---------------------------------------*/


        /*-------------------------------------*
        |       routine definitions
        ---------------------------------------*/


/* choose.c */
int xvu_create_choose  PROTO((char *, char **, int, int, int));

/* quit.c */
int xvu_create_quit PROTO((char *, char *, char *));

/* help.c */
void xvu_display_online_help PROTO((xvobject, kaddr, kaddr));

/* list_util.c */
xvu_list_entry *xvu_add_list_entry    PROTO((void));
void            xvu_delete_list_entry PROTO((xvu_list_entry *));

/* prompt.c */
int xvu_create_prompt PROTO((char *, char *, char *, char *));

/* query.c */
xvobject xvu_create_query PROTO((char *, char **, char *, char **, int, int));

/* save.c */
int xvu_create_save PROTO((char *, char *, char *, char *, char *));

/* utilities.c */
int  xvu_figure_width       PROTO((char *));
int  xvu_figure_height      PROTO((char *, int));
void xvu_initialize         PROTO((void));

/* warn.c */
int xvu_create_warn PROTO((char *, char *, char *, char *));

#endif /* _xvutils_internals_h_ */
/* Don't add after the endif */
