 /* Khoros: $Id: internals.h,v 1.17.2.2 1997/05/24 19:05:50 mirage Exp $ */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Private include file for xvwidgets library
   >>>>
   >>>>    Written By: Mark Young & Danielle Argiro
   >>>>
   >>>>          Date: Jul 14, 1993
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _xvwidgets_internals_h_
#define _xvwidgets_internals_h_


	/*-------------------------------------*
	|       #include 
	---------------------------------------*/

#include <design.h>
#include <kutils/kvarargs.h>
#include <xvinclude.h>
#include <xvwidgets/xvwidgetsP.h>
#include <X11/IntrinsicP.h>
#include <X11/Xresource.h>
#include <X11/CoreP.h>

/*
 *  includes for sundry X11 Calls
 */
#include <X11/keysym.h>
#include <X11/Xmu/Xmu.h>
#include <X11/Xmu/WinUtil.h>


	/*-------------------------------------*
	|       #defines 
	---------------------------------------*/

	/*-------------------------------------*
	|       #macros 
	---------------------------------------*/

#define widname(value) (((value)->widname != NULLQUARK) ? \
			 (value)->widname : (value)->xvwname)
#define xvwname(value) (((value)->xvwname != NULLQUARK) ? \
			 (value)->xvwname : (value)->widname)
#define widres(value)  (((value)->widres != NULLQUARK) ? \
			 (value)->widres : (value)->xvwres)
#define xvwres(value)  (((value)->xvwres != NULLQUARK)  ? \
		         (value)->xvwres : (value)->widres)


	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/

typedef struct
{
	XrmQuark  xvwname;
	XrmQuark  widname;
	XrmQuark  xvwres;
	XrmQuark  widres;
	int       (*setroutine)(xvobject, char *, kaddr);
	int       (*getroutine)(xvobject, char *, kaddr);
} CompiledAttribute;

typedef struct
{
        xvclass     object_class;
        int         num_attributes;
        xvattribute *attributes;
        CompiledAttribute **compiled;
} CompiledList;

/*
 *  definition for local _xvobject structure which is the xvobject
 */
struct _xvobject
{
	Widget   widget;
	xvobject busy;
	xvobject toplevel;

	klist  *events;
	klist  *callbacks;
	klist  *actions;
	klist  *detectfile;
	klist  *detectfid;
	klist  *timeouts;

	XtIntervalId id;
};

	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/

/*
 *  initialize the resources quarks...
 */
extern XrmQuark XtQstring;
extern XrmQuark XtQfont;
extern XrmQuark XtQfontStruct;
extern XrmQuark XtQpixmap;
extern XrmQuark XtQdouble;
extern XrmQuark XtQfloat;

/*
 *  temporary hack for xvobjects globals...
 *  see "globals.c" for definitions
 */
extern klist *xvw_toplevels;

	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

/* compiled.c */
CompiledAttribute *xvw_findcompiled PROTO((xvclass, xvclass, XrmQuark));

int xvw_addcompiled_attributes     PROTO((xvclass, xvattribute *, int));
int xvw_addcompiled_constraints    PROTO((xvclass, xvattribute *, int));
int xvw_definecompiled_attributes  PROTO((xvclass, kstring, kstring, 
                                         kfunc_int, kfunc_int));
int xvw_definecompiled_constraints PROTO((xvclass, kstring, kstring, 
                                         kfunc_int, kfunc_int));
int xvw_copy_attributes		   PROTO((xvobject, Arg *, int *));

/* chargeom.c */
int  xvw_get_chargeom       PROTO((xvobject, char *, kaddr));
int  xvw_set_chargeom       PROTO((xvobject, char *, kaddr));

/* convert.c */
int xvw_convert_resource PROTO((xvobject, char *, kaddr, char *, kaddr));

/* error.c */
void xvw_init_errors      PROTO((void));

/* handlers.c */
void xvw_init_handlers    PROTO((void));

/* journal.c */
void xvw_record_journal	  PROTO((XEvent *));
void xvw_start_journal    PROTO((char *, char *));
void xvw_stop_journal     PROTO((void));

/* general.c */
void xvw_manage_handler      PROTO((XtPointer, XtIntervalId *));
xvobject xvw_check_widget    PROTO((Widget));

/* utilities.c */
Pixel xvw_widget_color   PROTO((Widget, char *));
int  xvw_get_mapped      PROTO((xvobject, char *, kaddr));
int  xvw_set_mapped      PROTO((xvobject, char *, kaddr));

#endif /* _xvwidgets_internals_h_ */
/* Don't add after this point */
