 /*
  * Khoros: $Id: cantata.h,v 1.31.2.4 1997/05/31 18:31:48 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for cantata
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _cantata_h_
#define _cantata_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <design.h>
#include <xvinclude.h>
#include "form_info.h"

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
#define CANTATA_TRANSPORT_FILE    1
#define CANTATA_TRANSPORT_MMAP    2
#define CANTATA_TRANSPORT_SHM     3
#define CANTATA_TRANSPORT_STREAM  4
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Alternate UIS file (optional infile)
 */
char	*form_file;	/* Alternate UIS file FILENAME */
int	 form_flag;	/* Alternate UIS file FLAG */

/*
 *  (x,y) position for automatic GUI placement */

int	 x_int;		/* x position INT */
int	 x_flag;	/* x position FLAG */

int	 y_int;		/* y position INT */
int	 y_flag;	/* y position FLAG */

/*
 *  Create A Miniaturized version of Cantata (optional flag)
 */
int	 mini_flag;  	/* Create A Miniaturized version of Cantata FLAG */

/*
 *  Create Cantata Pulldown Toolbox Menus (optional logical)
 */
int	 tbmenus_logic;	/* Create Cantata Pulldown Toolbox Menus LOGIC */
int	 tbmenus_flag;  	/* Create Cantata Pulldown Toolbox Menus FLAG */

/*
 *  Create Cantata Command Bar Menus (optional logical)
 */
int	 commandbar_logic;	/* Create Cantata Command Bar Menus LOGIC */
int	 commandbar_flag;  	/* Create Cantata Command Bar Menus FLAG */

/*
 *  Create Cantata Console (optional logical)
 */
int	 console_logic;	/* Create Cantata Console LOGIC */
int	 console_flag;  	/* Create Cantata Console FLAG */

/*----- optional ME group ----*/
/*
 *  file for restoring cantata workspace (optional infile)
 */
char	*wksp_file;	/* file for restoring cantata workspace FILENAME */
int	 wksp_flag;	/* file for restoring cantata workspace FLAG */

	/*---- nested optional MI group ----*/
/*
 *  the toolbox in which the encapsulated workspace (optional string)
 */
char	*tb_string;	/* the toolbox in which the encapsulated workspace STRING */
int	 tb_flag;   	/* the toolbox in which the encapsulated workspace FLAG */

/*
 *  The encapsulated workspace object name (optional string)
 */
char	*oname_string;	/* The encapsulated workspace object name STRING */
int	 oname_flag;   	/* The encapsulated workspace object name FLAG */

	/*-- nested optional MI group end --*/

/*-- optional ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
extern gui_info_struct *gui_info;

extern uis_struct gui_uis_spec;
/* -include_variables */
/*
 * global variables: see "globals.c" for definitions
 */
extern xvobject notebook; 
extern xvobject main_workspace; 
extern xvobject active_workspace;
extern xvobject routines; 
extern xvobject finder; 
extern xvobject tbmenu; 
extern xvobject commandbar; 
extern xvobject statusobj; 
extern xvobject tooltips; 
extern xvobject sash; 
extern xvobject console; 
extern xvobject active_indicator;
extern xvobject gui_parent;
extern xvobject notifier;
extern kform    *cantata_form;
extern xvobject *workspace_list;
extern xvobject selected_workspace; 
extern int	clipboard_shown;
extern int	cantata_size_mini;
extern int   pref_def_griddisplay;
extern char *pref_def_gridcolor;
extern int   pref_def_gridsize;
extern int   pref_def_connecttype;
extern int   pref_def_connectredraw;
extern int   pref_def_glyphplacement;
extern int   pref_def_glyphdisplay;
extern pref_def_glyphreport;
extern int   pref_def_remoteexec;
extern int   pref_def_echoexec;
extern char *pref_def_backgroundcolor;
extern char *pref_def_backpixmaps;
extern int   pref_def_runwksp;
extern int   pref_def_stopwksp;
extern int   pref_def_runmode;
extern int   pref_def_resetwksp;
extern int   pref_def_clearwksp;
extern int   pref_def_checkwksp;
extern int   pref_def_redrawwksp;
extern int   pref_def_wkspinfo;
extern int   pref_def_cut;
extern int   pref_def_copy;
extern int   pref_def_paste;
extern int   pref_def_showclipboard;
extern int   pref_def_duplicate;
extern int   pref_def_selectall;
extern int   pref_def_unselectall;
extern int   pref_def_delete;
extern int   pref_def_undodelete;
extern int   pref_def_createprocedure;
extern int   pref_def_createcount;
extern int   pref_def_createwhile;
extern int   pref_def_openwksp;
extern int   pref_def_savewksp;
extern int   pref_def_savewkspas;
extern int   pref_def_remote;
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void cantata_get_args PROTO((kaddr));
void cantata_usage_additions PROTO((void));
void cantata_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
void update_distcomp_info  PROTO((kaddr));
void create_glyph          PROTO((xvobject, kaddr, kaddr));
void status_callback       PROTO((xvobject, kaddr, kaddr));
int  update_status         PROTO((char *, char *, char *, char *, char *));
void create_workspace      PROTO((void));
void change_workspace      PROTO((xvobject, kaddr, kaddr));
void save_workspace        PROTO((char *, int));
void restore_workspace     PROTO((char *));
void change_procedure      PROTO((xvobject, kaddr, kaddr));
void initialize_cantata    PROTO((void));
void cantata_exit          PROTO((kaddr));
void update_varval_displaylist   PROTO((void));
void update_vardef_displaylist   PROTO((void));
void update_varscope_displaylist PROTO((xvobject));
void update_variables_subform_cb PROTO((xvobject, int, kaddr));
xvobject find_selected_workspace_from_name PROTO((char *));
void initialize_preferences_subform PROTO((kform_struct *));
void init_pref_values PROTO((void));
void init_menu_icons  PROTO((void));
void init_encap_wksp  PROTO((kaddr));
void init_pref_subform PROTO((kaddr));
void notify_unmap      PROTO((xvobject, kaddr, int *));
void create_finder_display  PROTO((void));
/* -include_routines_end */

#endif
