 /*
  * Khoros: $Id: form_drv.c,v 1.27.2.2 1997/05/31 18:31:50 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: form_drv.c,v 1.27.2.2 1997/05/31 18:31:50 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	GUI Drivers for 'cantata'
   >>>> 
   >>>>  Private: 
   >>>> 	run_cantata
   >>>> 	run_find
   >>>> 	run_finder
   >>>> 	run_var
   >>>> 	run_variables
   >>>> 	run_distcomp
   >>>> 	run_dist
   >>>> 	run_pref
   >>>> 	run_grid
   >>>> 	run_encapsulate
   >>>> 	run_program
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "cantata.h"

/*-----------------------------------------------------------
| 
|  Routine Name: run_cantata
| 
|       Purpose: Main GUI Driver for cantata
| 
|         Input: None
| 
|        Output: Returns TRUE on success, FALSE on failure
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void run_cantata(
     kform    *form,
     ksubform *subform,
     kaddr    client_data)
{
	/*
	 * GUI info structure passed in as client_data 
	 */
	gui_info_struct *master_info = (gui_info_struct *) client_data;

	/*
	 * Get information from the forms
	 */
	_xvf_get_cantata(master_info);

	if (form->quit)
	{
	    xvf_destroy_allforms();
	    _xvf_free_cantata(master_info);
	    return;
	}

	    /*
	     * user clicked on master action button selection 'create'
	     */
	    if (master_info->create)
	        cantata_create(master_info);
	    /*
	     * user clicked on master action button selection 'open'
	     */
	    else if (master_info->open)
	        cantata_open(master_info);
	    /*
	     * user clicked on master action button selection 'resave'
	     */
	    else if (master_info->resave)
	        cantata_resave(master_info);
	    /*
	     * user clicked on master action button selection 'save'
	     */
	    else if (master_info->save)
	        cantata_save(master_info);
	    /*
	     * user clicked on master action button selection 'close'
	     */
	    else if (master_info->close)
	        cantata_close(master_info);
	    /*
	     * user clicked on master action button selection 'cut'
	     */
	    else if (master_info->cut)
	        cantata_cut(master_info);
	    /*
	     * user clicked on master action button selection 'copy'
	     */
	    else if (master_info->copy)
	        cantata_copy(master_info);
	    /*
	     * user clicked on master action button selection 'paste'
	     */
	    else if (master_info->paste)
	        cantata_paste(master_info);
	    /*
	     * user clicked on master action button selection 'clipboard'
	     */
	    else if (master_info->clipboard)
	        cantata_clipboard(master_info);
	    /*
	     * user clicked on master action button selection 'duplicate'
	     */
	    else if (master_info->duplicate)
	        cantata_duplicate(master_info);
	    /*
	     * user clicked on master action button selection 'del'
	     */
	    else if (master_info->del)
	        cantata_del(master_info);
	    /*
	     * user clicked on master action button selection 'undo'
	     */
	    else if (master_info->undo)
	        cantata_undo(master_info);
	    /*
	     * user clicked on master action button selection 'select'
	     */
	    else if (master_info->select)
	        cantata_select(master_info);
	    /*
	     * user clicked on master action button selection 'unselect'
	     */
	    else if (master_info->unselect)
	        cantata_unselect(master_info);
	    /*
	     * user clicked on master action button selection 'run'
	     */
	    else if (master_info->run)
	        cantata_run(master_info);
	    /*
	     * user clicked on master action button selection 'stop'
	     */
	    else if (master_info->stop)
	        cantata_stop(master_info);
	    /*
	     * user clicked on master action button selection 'runonce'
	     */
	    else if (master_info->runonce)
	        cantata_runonce(master_info);
	    /*
	     * user clicked on master action button selection 'reset'
	     */
	    else if (master_info->reset)
	        cantata_reset(master_info);
	    /*
	     * user clicked on master action button selection 'clear'
	     */
	    else if (master_info->clear)
	        cantata_clear(master_info);
	    /*
	     * user clicked on master action button selection 'check'
	     */
	    else if (master_info->check)
	        cantata_check(master_info);
	    /*
	     * user clicked on master action button selection 'redraw'
	     */
	    else if (master_info->redraw)
	        cantata_redraw(master_info);
	    /*
	     * user clicked on master action button selection 'info'
	     */
	    else if (master_info->info)
	        cantata_info(master_info);
	    /*
	     * user clicked on master action button selection 'commandbar'
	     */
	    else if (master_info->commandbar)
	        cantata_commandbar(master_info);
	    /*
	     * user clicked on master action button selection 'console'
	     */
	    else if (master_info->console)
	        cantata_console(master_info);
	    /*
	     * user clicked on master action button selection 'size'
	     */
	    else if (master_info->size)
	        cantata_size(master_info);
	    /*
	     * user clicked on master action button selection 'clearconsole'
	     */
	    else if (master_info->clearconsole)
	        cantata_clearconsole(master_info);
	    /*
	     * user clicked on master action button selection 'create_procedure'
	     */
	    else if (master_info->create_procedure)
	        cantata_create_procedure(master_info);
	    /*
	     * user clicked on master action button selection 'create_countloop'
	     */
	    else if (master_info->create_countloop)
	        cantata_create_countloop(master_info);
	    /*
	     * user clicked on master action button selection 'create_whileloop'
	     */
	    else if (master_info->create_whileloop)
	        cantata_create_whileloop(master_info);
	    /*
	     * user clicked on master action button selection 'create_expression'
	     */
	    else if (master_info->create_expression)
	        cantata_create_expression(master_info);
	    /*
	     * user clicked on master action button selection 'create_ifelse'
	     */
	    else if (master_info->create_ifelse)
	        cantata_create_ifelse(master_info);
	    /*
	     * user clicked on master action button selection 'create_merge'
	     */
	    else if (master_info->create_merge)
	        cantata_create_merge(master_info);
	    /*
	     * user clicked on master action button selection 'create_switch'
	     */
	    else if (master_info->create_switch)
	        cantata_create_switch(master_info);
	    /*
	     * user clicked on master action button selection 'create_trigger'
	     */
	    else if (master_info->create_trigger)
	        cantata_create_trigger(master_info);
	    /*
	     * user clicked on master action button selection 'panel'
	     */
	    else if (master_info->panel)
	        cantata_panel(master_info);
	    /*
	     * user clicked on master action button selection 'export'
	     */
	    else if (master_info->export)
	        cantata_export(master_info);
	    /*
	     * user clicked on master action button selection 'tooltips'
	     */
	    else if (master_info->tooltips)
	        cantata_tooltips(master_info);
	/*
	 * action came from the 'find' subform
	 */
	if (master_info->find_selected)
	    run_find(master_info->find);
	/*
	 * action came from the 'var' subform
	 */
	if (master_info->var_selected)
	    run_var(master_info->var);
	/*
	 * action came from the 'distcomp' subform
	 */
	if (master_info->distcomp_selected)
	    run_distcomp(master_info->distcomp);
	/*
	 * action came from the 'pref' subform
	 */
	if (master_info->pref_selected)
	    run_pref(master_info->pref);
	/*
	 * action came from the 'encapsulate' subform
	 */
	if (master_info->encapsulate_selected)
	    run_encapsulate(master_info->encapsulate);

	xvf_clear_selections(form);

}

/*-----------------------------------------------------------
| 
|  Routine Name: run_find
| 
|       Purpose: GUI Driver for subform 'find'
| 
|         Input: form      - pointer to the form tree
|                find_info - pointer to cantata_find struct
| 
|        Output: None
|    Written By: conductor -program_name cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_find(
     cantata_find *find_info)
{

	/*
	 * user clicked on pane action button selection 'openglyph'
	 */
	if (find_info->openglyph)
	{
	    find_openglyph(find_info);
	    find_info->openglyph = FALSE;
	}
	/*
	 * action came from the 'finder' pane
	 */
	else if (find_info->finder_selected)
	    run_finder(find_info->finder);


}   /* end run_find */



/*-----------------------------------------------------------
| 
|  Routine Name: run_finder
| 
|       Purpose: GUI Driver for pane 'finder'
| 
|         Input: form - pointer to the form tree
|                finder_info - pointer to find_finder struct
| 
|        Output: None
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_finder(
     find_finder *finder_info)

{

	/*
	 * user selected 'live' string selection 'expr'
	 */
	if (finder_info->expr_selected)
	{
	    finder_expr(finder_info);
	    finder_info->expr_selected = FALSE;
	}


}


/*-----------------------------------------------------------
| 
|  Routine Name: run_var
| 
|       Purpose: GUI Driver for subform 'var'
| 
|         Input: form      - pointer to the form tree
|                var_info - pointer to cantata_var struct
| 
|        Output: None
|    Written By: conductor -program_name cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_var(
     cantata_var *var_info)
{

	/*
	 * action came from the 'variables' pane
	 */
	if (var_info->variables_selected)
	    run_variables(var_info->variables);


}   /* end run_var */



/*-----------------------------------------------------------
| 
|  Routine Name: run_variables
| 
|       Purpose: GUI Driver for pane 'variables'
| 
|         Input: form - pointer to the form tree
|                variables_info - pointer to var_variables struct
| 
|        Output: None
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_variables(
     var_variables *variables_info)

{

	/*
	 * user selected 'live' string selection 'expression'
	 */
	if (variables_info->expression_selected)
	{
	    variables_expression(variables_info);
	    variables_info->expression_selected = FALSE;
	}
	/*
	 * user selected 'live' list selection 'scope'
	 */
	else if (variables_info->scope_selected)
	{
	    variables_scope(variables_info);
	    variables_info->scope_selected = FALSE;
	}
	/*
	 * user selected 'live' list selection 'varorig'
	 */
	else if (variables_info->varorig_selected)
	{
	    variables_varorig(variables_info);
	    variables_info->varorig_selected = FALSE;
	}
	/*
	 * user selected 'live' list selection 'varval'
	 */
	else if (variables_info->varval_selected)
	{
	    variables_varval(variables_info);
	    variables_info->varval_selected = FALSE;
	}
	/*
	 * user clicked on pane action button selection 'deletevar'
	 */
	else if (variables_info->deletevar)
	{
	    variables_deletevar(variables_info);
	    variables_info->deletevar = FALSE;
	}


}


/*-----------------------------------------------------------
| 
|  Routine Name: run_distcomp
| 
|       Purpose: GUI Driver for subform 'distcomp'
| 
|         Input: form      - pointer to the form tree
|                distcomp_info - pointer to cantata_distcomp struct
| 
|        Output: None
|    Written By: conductor -program_name cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_distcomp(
     cantata_distcomp *distcomp_info)
{

	/*
	 * action came from the 'dist' pane
	 */
	if (distcomp_info->dist_selected)
	    run_dist(distcomp_info->dist);


}   /* end run_distcomp */



/*-----------------------------------------------------------
| 
|  Routine Name: run_dist
| 
|       Purpose: GUI Driver for pane 'dist'
| 
|         Input: form - pointer to the form tree
|                dist_info - pointer to distcomp_dist struct
| 
|        Output: None
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_dist(
     distcomp_dist *dist_info)

{

	/*
	 * user selected 'live' toggle selection 'remote_exec'
	 */
	if (dist_info->remote_exec_selected)
	{
	    dist_remote_exec(dist_info);
	    dist_info->remote_exec_selected = FALSE;
	}
	/*
	 * user clicked on pane action button selection 'start_daemon'
	 */
	else if (dist_info->start_daemon)
	{
	    dist_start_daemon(dist_info);
	    dist_info->start_daemon = FALSE;
	}
	/*
	 * user clicked on pane action button selection 'stop_daemon'
	 */
	else if (dist_info->stop_daemon)
	{
	    dist_stop_daemon(dist_info);
	    dist_info->stop_daemon = FALSE;
	}
	/*
	 * user clicked on pane action button selection 'save'
	 */
	else if (dist_info->save)
	{
	    dist_save(dist_info);
	    dist_info->save = FALSE;
	}
	/*
	 * user clicked on pane action button selection 'delete_remote'
	 */
	else if (dist_info->delete_remote)
	{
	    dist_delete_remote(dist_info);
	    dist_info->delete_remote = FALSE;
	}
	/*
	 * user selected 'live' string selection 'add_name'
	 */
	else if (dist_info->add_name_selected)
	{
	    dist_add_name(dist_info);
	    dist_info->add_name_selected = FALSE;
	}


}


/*-----------------------------------------------------------
| 
|  Routine Name: run_pref
| 
|       Purpose: GUI Driver for subform 'pref'
| 
|         Input: form      - pointer to the form tree
|                pref_info - pointer to cantata_pref struct
| 
|        Output: None
|    Written By: conductor -program_name cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_pref(
     cantata_pref *pref_info)
{

	/*
	 * user clicked on pane action button selection 'apply_changes'
	 */
	if (pref_info->apply_changes)
	{
	    pref_apply_changes(pref_info);
	    pref_info->apply_changes = FALSE;
	}
	/*
	 * user clicked on pane action button selection 'restore_defaults'
	 */
	else if (pref_info->restore_defaults)
	{
	    pref_restore_defaults(pref_info);
	    pref_info->restore_defaults = FALSE;
	}
	/*
	 * action came from the 'grid' pane
	 */
	else if (pref_info->grid_selected)
	    run_grid(pref_info->grid);


}   /* end run_pref */



/*-----------------------------------------------------------
| 
|  Routine Name: run_grid
| 
|       Purpose: GUI Driver for pane 'grid'
| 
|         Input: form - pointer to the form tree
|                grid_info - pointer to pref_grid struct
| 
|        Output: None
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_grid(
     pref_grid *grid_info)

{

	/*
	 * user selected 'live' toggle selection 'griddisplay'
	 */
	if (grid_info->griddisplay_selected)
	{
	    grid_griddisplay(grid_info);
	    grid_info->griddisplay_selected = FALSE;
	}


}


/*-----------------------------------------------------------
| 
|  Routine Name: run_encapsulate
| 
|       Purpose: GUI Driver for subform 'encapsulate'
| 
|         Input: form      - pointer to the form tree
|                encapsulate_info - pointer to cantata_encapsulate struct
| 
|        Output: None
|    Written By: conductor -program_name cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_encapsulate(
     cantata_encapsulate *encapsulate_info)
{

	/*
	 * action came from the 'program' pane
	 */
	if (encapsulate_info->program_selected)
	    run_program(encapsulate_info->program);


}   /* end run_encapsulate */



/*-----------------------------------------------------------
| 
|  Routine Name: run_program
| 
|       Purpose: GUI Driver for pane 'program'
| 
|         Input: form - pointer to the form tree
|                program_info - pointer to encapsulate_program struct
| 
|        Output: None
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_program(
     encapsulate_program *program_info)

{

	/*
	 * user clicked on pane action button selection 'create'
	 */
	if (program_info->create)
	{
	    program_create(program_info);
	    program_info->create = FALSE;
	}
	/*
	 * user selected 'live' list selection 'toolboxes'
	 */
	else if (program_info->toolboxes_selected)
	{
	    program_toolboxes(program_info);
	    program_info->toolboxes_selected = FALSE;
	}
	/*
	 * user selected 'live' list selection 'objects'
	 */
	else if (program_info->objects_selected)
	{
	    program_objects(program_info);
	    program_info->objects_selected = FALSE;
	}
	/*
	 * user selected 'live' string selection 'category'
	 */
	else if (program_info->category_selected)
	{
	    program_category(program_info);
	    program_info->category_selected = FALSE;
	}


}


