 /*
  * Khoros: $Id: form_info.c,v 1.29.2.2 1997/05/31 18:31:53 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: form_info.c,v 1.29.2.2 1997/05/31 18:31:53 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	FormInfo Extraction Routines
   >>>> 
   >>>>  Private: 
   >>>> 	_xvf_get_cantata
   >>>> 
   >>>>   Static: 
   >>>> 	_xvf_get_find
   >>>> 	_xvf_get_routines
   >>>> 	_xvf_get_finder
   >>>> 	_xvf_get_var
   >>>> 	_xvf_get_variables
   >>>> 	_xvf_get_distcomp
   >>>> 	_xvf_get_dist
   >>>> 	_xvf_get_pref
   >>>> 	_xvf_get_grid
   >>>> 	_xvf_get_glyph
   >>>> 	_xvf_get_workspace
   >>>> 	_xvf_get_commandbar
   >>>> 	_xvf_get_encapsulate
   >>>> 	_xvf_get_program
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "cantata.h"


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_cantata
| 
|       Purpose: Extracts information from GUI
| 
|         Input: forminfo - pointer to gui_info_struct
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_cantata(
     gui_info_struct *forminfo)
{
	kselection *selection;
	ksubform   *subform;
	if (forminfo->workspace_struct != NULL)
	{
	    selection = forminfo->workspace_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_WORKSPACE,
	                    &(forminfo->workspace));
	    }

	}

	if (forminfo->create_struct != NULL)
	{
	    selection = forminfo->create_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->create));

	}

	if (forminfo->open_struct != NULL)
	{
	    selection = forminfo->open_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->open));

	}

	if (forminfo->resave_struct != NULL)
	{
	    selection = forminfo->resave_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->resave));

	}

	if (forminfo->save_struct != NULL)
	{
	    selection = forminfo->save_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->save));

	}

	if (forminfo->close_struct != NULL)
	{
	    selection = forminfo->close_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->close));

	}

	if (forminfo->quit_struct != NULL)
	{
	    selection = forminfo->quit_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->quit));

	}

	if (forminfo->cut_struct != NULL)
	{
	    selection = forminfo->cut_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->cut));

	}

	if (forminfo->copy_struct != NULL)
	{
	    selection = forminfo->copy_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->copy));

	}

	if (forminfo->paste_struct != NULL)
	{
	    selection = forminfo->paste_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->paste));

	}

	if (forminfo->clipboard_struct != NULL)
	{
	    selection = forminfo->clipboard_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->clipboard));

	}

	if (forminfo->duplicate_struct != NULL)
	{
	    selection = forminfo->duplicate_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->duplicate));

	}

	if (forminfo->del_struct != NULL)
	{
	    selection = forminfo->del_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->del));

	}

	if (forminfo->undo_struct != NULL)
	{
	    selection = forminfo->undo_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->undo));

	}

	if (forminfo->select_struct != NULL)
	{
	    selection = forminfo->select_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->select));

	}

	if (forminfo->unselect_struct != NULL)
	{
	    selection = forminfo->unselect_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->unselect));

	}

	if (forminfo->run_struct != NULL)
	{
	    selection = forminfo->run_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->run));

	}

	if (forminfo->stop_struct != NULL)
	{
	    selection = forminfo->stop_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->stop));

	}

	if (forminfo->runonce_struct != NULL)
	{
	    selection = forminfo->runonce_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->runonce));

	}

	if (forminfo->reset_struct != NULL)
	{
	    selection = forminfo->reset_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->reset));

	}

	if (forminfo->clear_struct != NULL)
	{
	    selection = forminfo->clear_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->clear));

	}

	if (forminfo->check_struct != NULL)
	{
	    selection = forminfo->check_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->check));

	}

	if (forminfo->redraw_struct != NULL)
	{
	    selection = forminfo->redraw_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->redraw));

	}

	if (forminfo->info_struct != NULL)
	{
	    selection = forminfo->info_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->info));

	}

	if (forminfo->commandbar_struct != NULL)
	{
	    selection = forminfo->commandbar_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->commandbar));

	}

	if (forminfo->console_struct != NULL)
	{
	    selection = forminfo->console_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->console));

	}

	if (forminfo->size_struct != NULL)
	{
	    selection = forminfo->size_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->size));

	}

	if (forminfo->clearconsole_struct != NULL)
	{
	    selection = forminfo->clearconsole_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->clearconsole));

	}

	if (forminfo->create_procedure_struct != NULL)
	{
	    selection = forminfo->create_procedure_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->create_procedure));

	}

	if (forminfo->create_countloop_struct != NULL)
	{
	    selection = forminfo->create_countloop_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->create_countloop));

	}

	if (forminfo->create_whileloop_struct != NULL)
	{
	    selection = forminfo->create_whileloop_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->create_whileloop));

	}

	if (forminfo->create_expression_struct != NULL)
	{
	    selection = forminfo->create_expression_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->create_expression));

	}

	if (forminfo->create_ifelse_struct != NULL)
	{
	    selection = forminfo->create_ifelse_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->create_ifelse));

	}

	if (forminfo->create_merge_struct != NULL)
	{
	    selection = forminfo->create_merge_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->create_merge));

	}

	if (forminfo->create_switch_struct != NULL)
	{
	    selection = forminfo->create_switch_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->create_switch));

	}

	if (forminfo->create_trigger_struct != NULL)
	{
	    selection = forminfo->create_trigger_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->create_trigger));

	}

	if (forminfo->panel_struct != NULL)
	{
	    selection = forminfo->panel_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->panel));

	}

	if (forminfo->export_struct != NULL)
	{
	    selection = forminfo->export_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->export));

	}

	if (forminfo->tooltips_struct != NULL)
	{
	    selection = forminfo->tooltips_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->tooltips));

	}

	if (forminfo->find_struct != NULL)
	{
	    subform = forminfo->find_struct->Subformptr;
	    kvf_get_attribute(subform->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->find_selected));
	    _xvf_get_find(forminfo->find);

	}
	if (forminfo->var_struct != NULL)
	{
	    subform = forminfo->var_struct->Subformptr;
	    kvf_get_attribute(subform->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->var_selected));
	    _xvf_get_var(forminfo->var);

	}
	if (forminfo->distcomp_struct != NULL)
	{
	    subform = forminfo->distcomp_struct->Subformptr;
	    kvf_get_attribute(subform->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->distcomp_selected));
	    _xvf_get_distcomp(forminfo->distcomp);

	}
	if (forminfo->pref_struct != NULL)
	{
	    subform = forminfo->pref_struct->Subformptr;
	    kvf_get_attribute(subform->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->pref_selected));
	    _xvf_get_pref(forminfo->pref);

	}
	if (forminfo->encapsulate_struct != NULL)
	{
	    subform = forminfo->encapsulate_struct->Subformptr;
	    kvf_get_attribute(subform->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->encapsulate_selected));
	    _xvf_get_encapsulate(forminfo->encapsulate);

	}

}

/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_find
| 
|       Purpose: Extracts information from find subform
| 
|         Input: subforminfo - pointer to cantata_find structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_find(
     cantata_find *subforminfo)
{
	kselection *selection;
	kcontrol   *pane;
	if (subforminfo->openglyph_struct != NULL)
	{
	    selection = subforminfo->openglyph_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->openglyph));

	}

	if (subforminfo->quit_struct != NULL)
	{
	    selection = subforminfo->quit_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->quit));

	}

	if (subforminfo->routines_struct != NULL)
	{
	    pane = subforminfo->routines_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->routines_selected));
	    _xvf_get_routines(subforminfo->routines);
	}

	if (subforminfo->finder_struct != NULL)
	{
	    pane = subforminfo->finder_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->finder_selected));
	    _xvf_get_finder(subforminfo->finder);
	}


}



/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_routines
| 
|       Purpose: Extracts information from routines pane
| 
|         Input: paneinfo - pointer to find_routines structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_routines(
     find_routines *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'cantata->find->routines' Pane Info structure
	 */

	if (paneinfo->rlists_struct != NULL)
	{
	    selection = paneinfo->rlists_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_WORKSPACE,
	                    &(paneinfo->rlists));
	    }

	}

}


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_finder
| 
|       Purpose: Extracts information from finder pane
| 
|         Input: paneinfo - pointer to find_finder structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_finder(
     find_finder *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'cantata->find->finder' Pane Info structure
	 */

	if (paneinfo->flist_struct != NULL)
	{
	    selection = paneinfo->flist_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_WORKSPACE,
	                    &(paneinfo->flist));
	    }

	}

	if (paneinfo->expr_struct != NULL)
	{
	    selection = paneinfo->expr_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->expr != NULL) kfree_and_NULL(paneinfo->expr);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->expr));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->expr_selected));
	    }

	}

}


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_var
| 
|       Purpose: Extracts information from var subform
| 
|         Input: subforminfo - pointer to cantata_var structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_var(
     cantata_var *subforminfo)
{
	kcontrol   *pane;
	if (subforminfo->variables_struct != NULL)
	{
	    pane = subforminfo->variables_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->variables_selected));
	    _xvf_get_variables(subforminfo->variables);
	}


}



/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_variables
| 
|       Purpose: Extracts information from variables pane
| 
|         Input: paneinfo - pointer to var_variables structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_variables(
     var_variables *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'cantata->var->variables' Pane Info structure
	 */

	if (paneinfo->expression_struct != NULL)
	{
	    selection = paneinfo->expression_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->expression != NULL) kfree_and_NULL(paneinfo->expression);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->expression));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->expression_selected));
	    }

	}

	if (paneinfo->scope_struct != NULL)
	{
	    selection = paneinfo->scope_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->scope));
	    if (paneinfo->scope_label != NULL) kfree_and_NULL(paneinfo->scope_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->scope_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->scope_selected));
	    }

	}

	if (paneinfo->varorig_struct != NULL)
	{
	    selection = paneinfo->varorig_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->varorig));
	    if (paneinfo->varorig_label != NULL) kfree_and_NULL(paneinfo->varorig_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->varorig_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->varorig_selected));
	    }

	}

	if (paneinfo->varval_struct != NULL)
	{
	    selection = paneinfo->varval_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->varval));
	    if (paneinfo->varval_label != NULL) kfree_and_NULL(paneinfo->varval_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->varval_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->varval_selected));
	    }

	}

	if (paneinfo->deletevar_struct != NULL)
	{
	    selection = paneinfo->deletevar_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->deletevar));

	}

	if (paneinfo->quit_struct != NULL)
	{
	    selection = paneinfo->quit_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->quit));

	}

}


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_distcomp
| 
|       Purpose: Extracts information from distcomp subform
| 
|         Input: subforminfo - pointer to cantata_distcomp structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_distcomp(
     cantata_distcomp *subforminfo)
{
	kcontrol   *pane;
	if (subforminfo->dist_struct != NULL)
	{
	    pane = subforminfo->dist_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->dist_selected));
	    _xvf_get_dist(subforminfo->dist);
	}


}



/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_dist
| 
|       Purpose: Extracts information from dist pane
| 
|         Input: paneinfo - pointer to distcomp_dist structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_dist(
     distcomp_dist *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'cantata->distcomp->dist' Pane Info structure
	 */

	if (paneinfo->remote_exec_struct != NULL)
	{
	    char *value_string;
	    selection = paneinfo->remote_exec_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_NUM,
	                    &(paneinfo->remote_exec_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_VAL,
	                    &(value_string));
	    paneinfo->remote_exec_val = atoi(value_string);
	    kfree_and_NULL(value_string);
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->remote_exec_selected));
	    }

	}

	if (paneinfo->remote_hosts_struct != NULL)
	{
	    selection = paneinfo->remote_hosts_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->remote_hosts));
	    if (paneinfo->remote_hosts_label != NULL) kfree_and_NULL(paneinfo->remote_hosts_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->remote_hosts_label));
	    }

	}

	if (paneinfo->start_daemon_struct != NULL)
	{
	    selection = paneinfo->start_daemon_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->start_daemon));

	}

	if (paneinfo->stop_daemon_struct != NULL)
	{
	    selection = paneinfo->stop_daemon_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->stop_daemon));

	}

	if (paneinfo->save_struct != NULL)
	{
	    selection = paneinfo->save_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->save));

	}

	if (paneinfo->delete_remote_struct != NULL)
	{
	    selection = paneinfo->delete_remote_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->delete_remote));

	}

	if (paneinfo->add_name_struct != NULL)
	{
	    selection = paneinfo->add_name_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->add_name != NULL) kfree_and_NULL(paneinfo->add_name);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->add_name));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->add_name_selected));
	    }

	}

	if (paneinfo->quit_struct != NULL)
	{
	    selection = paneinfo->quit_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->quit));

	}

}


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_pref
| 
|       Purpose: Extracts information from pref subform
| 
|         Input: subforminfo - pointer to cantata_pref structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_pref(
     cantata_pref *subforminfo)
{
	kselection *selection;
	kcontrol   *pane;
	if (subforminfo->apply_changes_struct != NULL)
	{
	    selection = subforminfo->apply_changes_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->apply_changes));

	}

	if (subforminfo->restore_defaults_struct != NULL)
	{
	    selection = subforminfo->restore_defaults_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->restore_defaults));

	}

	if (subforminfo->quit_struct != NULL)
	{
	    selection = subforminfo->quit_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->quit));

	}

	if (subforminfo->grid_struct != NULL)
	{
	    pane = subforminfo->grid_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->grid_selected));
	    _xvf_get_grid(subforminfo->grid);
	}

	if (subforminfo->glyph_struct != NULL)
	{
	    pane = subforminfo->glyph_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->glyph_selected));
	    _xvf_get_glyph(subforminfo->glyph);
	}

	if (subforminfo->workspace_struct != NULL)
	{
	    pane = subforminfo->workspace_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->workspace_selected));
	    _xvf_get_workspace(subforminfo->workspace);
	}

	if (subforminfo->commandbar_struct != NULL)
	{
	    pane = subforminfo->commandbar_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->commandbar_selected));
	    _xvf_get_commandbar(subforminfo->commandbar);
	}


}



/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_grid
| 
|       Purpose: Extracts information from grid pane
| 
|         Input: paneinfo - pointer to pref_grid structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_grid(
     pref_grid *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'cantata->pref->grid' Pane Info structure
	 */

	if (paneinfo->griddisplay_struct != NULL)
	{
	    char *value_string;
	    selection = paneinfo->griddisplay_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_NUM,
	                    &(paneinfo->griddisplay_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_VAL,
	                    &(value_string));
	    paneinfo->griddisplay_val = atoi(value_string);
	    kfree_and_NULL(value_string);
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->griddisplay_selected));
	    }

	}

	if (paneinfo->gridsize_struct != NULL)
	{
	    selection = paneinfo->gridsize_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_INT_VAL,
	                    &(paneinfo->gridsize));
	    }
	}

	if (paneinfo->gridcolor_struct != NULL)
	{
	    selection = paneinfo->gridcolor_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->gridcolor != NULL) kfree_and_NULL(paneinfo->gridcolor);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->gridcolor));
	    }

	}

}


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_glyph
| 
|       Purpose: Extracts information from glyph pane
| 
|         Input: paneinfo - pointer to pref_glyph structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_glyph(
     pref_glyph *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'cantata->pref->glyph' Pane Info structure
	 */

	if (paneinfo->connecttype_struct != NULL)
	{
	    char *value_string;
	    selection = paneinfo->connecttype_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_NUM,
	                    &(paneinfo->connecttype_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_VAL,
	                    &(value_string));
	    paneinfo->connecttype_val = atoi(value_string);
	    kfree_and_NULL(value_string);
	    }

	}

	if (paneinfo->connectredraw_struct != NULL)
	{
	    char *value_string;
	    selection = paneinfo->connectredraw_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_NUM,
	                    &(paneinfo->connectredraw_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_VAL,
	                    &(value_string));
	    paneinfo->connectredraw_val = atoi(value_string);
	    kfree_and_NULL(value_string);
	    }

	}

	if (paneinfo->glyphplacement_struct != NULL)
	{
	    char *value_string;
	    selection = paneinfo->glyphplacement_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_NUM,
	                    &(paneinfo->glyphplacement_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_VAL,
	                    &(value_string));
	    paneinfo->glyphplacement_val = atoi(value_string);
	    kfree_and_NULL(value_string);
	    }

	}

	if (paneinfo->glyphdisplay_struct != NULL)
	{
	    char *value_string;
	    selection = paneinfo->glyphdisplay_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_NUM,
	                    &(paneinfo->glyphdisplay_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_VAL,
	                    &(value_string));
	    paneinfo->glyphdisplay_val = atoi(value_string);
	    kfree_and_NULL(value_string);
	    }

	}

	if (paneinfo->glyphreport_struct != NULL)
	{
	    char *value_string;
	    selection = paneinfo->glyphreport_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_NUM,
	                    &(paneinfo->glyphreport_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_VAL,
	                    &(value_string));
	    paneinfo->glyphreport_val = atoi(value_string);
	    kfree_and_NULL(value_string);
	    }

	}

}


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_workspace
| 
|       Purpose: Extracts information from workspace pane
| 
|         Input: paneinfo - pointer to pref_workspace structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_workspace(
     pref_workspace *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'cantata->pref->workspace' Pane Info structure
	 */

	if (paneinfo->echoexec_struct != NULL)
	{
	    char *value_string;
	    selection = paneinfo->echoexec_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_NUM,
	                    &(paneinfo->echoexec_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_VAL,
	                    &(value_string));
	    paneinfo->echoexec_val = atoi(value_string);
	    kfree_and_NULL(value_string);
	    }

	}

	if (paneinfo->transport_struct != NULL)
	{
	    char *value_string;
	    selection = paneinfo->transport_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_NUM,
	                    &(paneinfo->transport_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_TOGGLE_VAL,
	                    &(value_string));
	    paneinfo->transport_val = atoi(value_string);
	    kfree_and_NULL(value_string);
	    }

	}

	if (paneinfo->backgroundcolor_struct != NULL)
	{
	    selection = paneinfo->backgroundcolor_struct->Selptr;
	    if (selection->modified || selection->back_group->modified)
	    {
	    if (paneinfo->backgroundcolor != NULL) kfree_and_NULL(paneinfo->backgroundcolor);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->backgroundcolor));
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->backgroundcolor_optsel));
	    }

	}

	if (paneinfo->backpixmaps_struct != NULL)
	{
	    selection = paneinfo->backpixmaps_struct->Selptr;
	    if (selection->modified || selection->back_group->modified)
	    {
	    if (paneinfo->backpixmaps != NULL) kfree_and_NULL(paneinfo->backpixmaps);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->backpixmaps));
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->backpixmaps_optsel));
	    }

	}

}


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_commandbar
| 
|       Purpose: Extracts information from commandbar pane
| 
|         Input: paneinfo - pointer to pref_commandbar structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_commandbar(
     pref_commandbar *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'cantata->pref->commandbar' Pane Info structure
	 */

	if (paneinfo->runwksp_struct != NULL)
	{
	   selection = paneinfo->runwksp_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->runwksp));
	    }

	}

	if (paneinfo->cut_struct != NULL)
	{
	   selection = paneinfo->cut_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->cut));
	    }

	}

	if (paneinfo->undodelete_struct != NULL)
	{
	   selection = paneinfo->undodelete_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->undodelete));
	    }

	}

	if (paneinfo->stopwksp_struct != NULL)
	{
	   selection = paneinfo->stopwksp_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->stopwksp));
	    }

	}

	if (paneinfo->copy_struct != NULL)
	{
	   selection = paneinfo->copy_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->copy));
	    }

	}

	if (paneinfo->createprocedure_struct != NULL)
	{
	   selection = paneinfo->createprocedure_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->createprocedure));
	    }

	}

	if (paneinfo->runmode_struct != NULL)
	{
	   selection = paneinfo->runmode_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->runmode));
	    }

	}

	if (paneinfo->paste_struct != NULL)
	{
	   selection = paneinfo->paste_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->paste));
	    }

	}

	if (paneinfo->createcount_struct != NULL)
	{
	   selection = paneinfo->createcount_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->createcount));
	    }

	}

	if (paneinfo->resetwksp_struct != NULL)
	{
	   selection = paneinfo->resetwksp_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->resetwksp));
	    }

	}

	if (paneinfo->showclipboard_struct != NULL)
	{
	   selection = paneinfo->showclipboard_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->showclipboard));
	    }

	}

	if (paneinfo->createwhile_struct != NULL)
	{
	   selection = paneinfo->createwhile_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->createwhile));
	    }

	}

	if (paneinfo->clearwksp_struct != NULL)
	{
	   selection = paneinfo->clearwksp_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->clearwksp));
	    }

	}

	if (paneinfo->duplicate_struct != NULL)
	{
	   selection = paneinfo->duplicate_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->duplicate));
	    }

	}

	if (paneinfo->openwksp_struct != NULL)
	{
	   selection = paneinfo->openwksp_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->openwksp));
	    }

	}

	if (paneinfo->checkwksp_struct != NULL)
	{
	   selection = paneinfo->checkwksp_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->checkwksp));
	    }

	}

	if (paneinfo->selectall_struct != NULL)
	{
	   selection = paneinfo->selectall_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->selectall));
	    }

	}

	if (paneinfo->savewksp_struct != NULL)
	{
	   selection = paneinfo->savewksp_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->savewksp));
	    }

	}

	if (paneinfo->redrawwksp_struct != NULL)
	{
	   selection = paneinfo->redrawwksp_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->redrawwksp));
	    }

	}

	if (paneinfo->unselectall_struct != NULL)
	{
	   selection = paneinfo->unselectall_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->unselectall));
	    }

	}

	if (paneinfo->savewkspas_struct != NULL)
	{
	   selection = paneinfo->savewkspas_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->savewkspas));
	    }

	}

	if (paneinfo->wkspinfo_struct != NULL)
	{
	   selection = paneinfo->wkspinfo_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->wkspinfo));
	    }

	}

	if (paneinfo->del_struct != NULL)
	{
	   selection = paneinfo->del_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->del));
	    }

	}

}


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_encapsulate
| 
|       Purpose: Extracts information from encapsulate subform
| 
|         Input: subforminfo - pointer to cantata_encapsulate structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_encapsulate(
     cantata_encapsulate *subforminfo)
{
	kcontrol   *pane;
	if (subforminfo->program_struct != NULL)
	{
	    pane = subforminfo->program_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->program_selected));
	    _xvf_get_program(subforminfo->program);
	}


}



/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_program
| 
|       Purpose: Extracts information from program pane
| 
|         Input: paneinfo - pointer to encapsulate_program structure
| 
|        Output: none
|    Written By: conductor -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_program(
     encapsulate_program *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'cantata->encapsulate->program' Pane Info structure
	 */

	if (paneinfo->create_struct != NULL)
	{
	    selection = paneinfo->create_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->create));

	}

	if (paneinfo->quit_struct != NULL)
	{
	    selection = paneinfo->quit_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->quit));

	}

	if (paneinfo->toolboxes_struct != NULL)
	{
	    selection = paneinfo->toolboxes_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->toolboxes));
	    if (paneinfo->toolboxes_label != NULL) kfree_and_NULL(paneinfo->toolboxes_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->toolboxes_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->toolboxes_selected));
	    }

	}

	if (paneinfo->objects_struct != NULL)
	{
	    selection = paneinfo->objects_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->objects));
	    if (paneinfo->objects_label != NULL) kfree_and_NULL(paneinfo->objects_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->objects_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->objects_selected));
	    }

	}

	if (paneinfo->tbname_struct != NULL)
	{
	    selection = paneinfo->tbname_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->tbname != NULL) kfree_and_NULL(paneinfo->tbname);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->tbname));
	    }

	}

	if (paneinfo->oname_struct != NULL)
	{
	    selection = paneinfo->oname_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->oname != NULL) kfree_and_NULL(paneinfo->oname);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->oname));
	    }

	}

	if (paneinfo->category_struct != NULL)
	{
	    selection = paneinfo->category_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->category != NULL) kfree_and_NULL(paneinfo->category);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->category));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->category_selected));
	    }

	}

	if (paneinfo->subcategory_struct != NULL)
	{
	    selection = paneinfo->subcategory_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->subcategory != NULL) kfree_and_NULL(paneinfo->subcategory);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->subcategory));
	    }

	}

	if (paneinfo->icon_name_struct != NULL)
	{
	    selection = paneinfo->icon_name_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->icon_name != NULL) kfree_and_NULL(paneinfo->icon_name);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->icon_name));
	    }

	}

}


