 /*
  * Khoros: $Id: form_info.h,v 1.28.2.2 1997/05/31 18:31:56 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Form Info Structure for cantata Form
   >>>> 
   >>>>    Written By: conductor -oname cantata
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _form_info_h_
#define _form_info_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

/*
 * Pane Info Struct for 'routines' Pane
 */
typedef struct _find_routines{

xvobject     rlists;          /* address of workspace 'rlists'*/
kform_struct *rlists_struct;  /* pass to xvf_set_attributes() */

} find_routines;

/*
 * Pane Info Struct for 'finder' Pane
 */
typedef struct _find_finder{

xvobject     flist;          /* address of workspace 'flist'*/
kform_struct *flist_struct;  /* pass to xvf_set_attributes() */

char         *expr;         /* string for 'expr'*/
kform_struct *expr_struct;  /* pass to xvf_set_attributes() */
int          expr_selected; /* TRUE on <cr> for 'expr' */

} find_finder;

/*
 * Subform Info Struct for 'find' Subform
 */
typedef struct _cantata_find {

int          openglyph;          /* TRUE when user clicks on 'openglyph'*/
kform_struct *openglyph_struct;  /* pass to xvf_set_attributes() */

int          quit;         /* TRUE when user clicks on 'Close' button */
kform_struct *quit_struct; /* pass to xvf_set_attributes() */

kform_struct *help_struct; /* pass to xvf_set_attributes() */

find_routines  *routines;          /* ptr to Pane Info struct for pane 'routines' */
int           routines_selected;          /* TRUE if input was from pane 'routines' */
kform_struct  *routines_struct;          /* pass to xvf_set_attributes() */

find_finder  *finder;          /* ptr to Pane Info struct for pane 'finder' */
int         finder_selected;          /* TRUE if input was from pane 'finder' */
kform_struct *finder_struct;          /* pass to xvf_set_attributes() */

}  cantata_find;

/*
 * Pane Info Struct for 'variables' Pane
 */
typedef struct _var_variables{

char         *expression;         /* string for 'expression'*/
kform_struct *expression_struct;  /* pass to xvf_set_attributes() */
int          expression_selected; /* TRUE on <cr> for 'expression' */

int          scope;          /* int value of 'scope'*/
char         *scope_label;   /* label representing int value of 'scope'*/
kform_struct *scope_struct;  /* pass to xvf_set_attributes() */
int          scope_selected; /* TRUE on <cr> for 'scope' */

int          varorig;          /* int value of 'varorig'*/
char         *varorig_label;   /* label representing int value of 'varorig'*/
kform_struct *varorig_struct;  /* pass to xvf_set_attributes() */
int          varorig_selected; /* TRUE on <cr> for 'varorig' */

int          varval;          /* int value of 'varval'*/
char         *varval_label;   /* label representing int value of 'varval'*/
kform_struct *varval_struct;  /* pass to xvf_set_attributes() */
int          varval_selected; /* TRUE on <cr> for 'varval' */

int          deletevar;          /* TRUE when user clicks on 'deletevar'*/
kform_struct *deletevar_struct;  /* pass to xvf_set_attributes() */

int          quit;         /* TRUE when user clicks on 'Close' button */
kform_struct *quit_struct; /* pass to xvf_set_attributes() */

kform_struct *help_struct; /* pass to xvf_set_attributes() */

kform_struct *blank1_struct; /* pass to xvf_set_attributes() */

kform_struct *blank2_struct; /* pass to xvf_set_attributes() */

} var_variables;

/*
 * Subform Info Struct for 'var' Subform
 */
typedef struct _cantata_var {

var_variables  *variables;          /* ptr to Pane Info struct for pane 'variables' */
int           variables_selected;          /* TRUE if input was from pane 'variables' */
kform_struct  *variables_struct;          /* pass to xvf_set_attributes() */

}  cantata_var;

/*
 * Pane Info Struct for 'dist' Pane
 */
typedef struct _distcomp_dist{

int          remote_exec_val;      /* value of toggle 'remote_exec'*/
int          remote_exec_num;      /* number of toggle member selected (1-N) */
kform_struct *remote_exec_struct;  /* pass to xvf_set_attributes() */
int          remote_exec_selected; /* TRUE on <cr> for 'remote_exec' */

int          remote_hosts;          /* int value of 'remote_hosts'*/
char         *remote_hosts_label;   /* label representing int value of 'remote_hosts'*/
kform_struct *remote_hosts_struct;  /* pass to xvf_set_attributes() */

int          start_daemon;          /* TRUE when user clicks on 'start_daemon'*/
kform_struct *start_daemon_struct;  /* pass to xvf_set_attributes() */

int          stop_daemon;          /* TRUE when user clicks on 'stop_daemon'*/
kform_struct *stop_daemon_struct;  /* pass to xvf_set_attributes() */

int          save;          /* TRUE when user clicks on 'save'*/
kform_struct *save_struct;  /* pass to xvf_set_attributes() */

int          delete_remote;          /* TRUE when user clicks on 'delete_remote'*/
kform_struct *delete_remote_struct;  /* pass to xvf_set_attributes() */

char         *add_name;         /* string for 'add_name'*/
kform_struct *add_name_struct;  /* pass to xvf_set_attributes() */
int          add_name_selected; /* TRUE on <cr> for 'add_name' */

int          quit;         /* TRUE when user clicks on 'Close' button */
kform_struct *quit_struct; /* pass to xvf_set_attributes() */

kform_struct *help_struct; /* pass to xvf_set_attributes() */

} distcomp_dist;

/*
 * Subform Info Struct for 'distcomp' Subform
 */
typedef struct _cantata_distcomp {

distcomp_dist  *dist;          /* ptr to Pane Info struct for pane 'dist' */
int           dist_selected;          /* TRUE if input was from pane 'dist' */
kform_struct  *dist_struct;          /* pass to xvf_set_attributes() */

}  cantata_distcomp;

/*
 * Pane Info Struct for 'grid' Pane
 */
typedef struct _pref_grid{

kform_struct *blank1_struct; /* pass to xvf_set_attributes() */

int          griddisplay_val;      /* value of toggle 'griddisplay'*/
int          griddisplay_num;      /* number of toggle member selected (1-N) */
kform_struct *griddisplay_struct;  /* pass to xvf_set_attributes() */
int          griddisplay_selected; /* TRUE on <cr> for 'griddisplay' */

int          gridsize;          /* int for 'gridsize'*/
kform_struct *gridsize_struct;  /* pass to xvf_set_attributes() */

char         *gridcolor;         /* string for 'gridcolor'*/
kform_struct *gridcolor_struct;  /* pass to xvf_set_attributes() */

} pref_grid;

/*
 * Pane Info Struct for 'glyph' Pane
 */
typedef struct _pref_glyph{

kform_struct *blank1_struct; /* pass to xvf_set_attributes() */

int          connecttype_val;      /* value of toggle 'connecttype'*/
int          connecttype_num;      /* number of toggle member selected (1-N) */
kform_struct *connecttype_struct;  /* pass to xvf_set_attributes() */

int          connectredraw_val;      /* value of toggle 'connectredraw'*/
int          connectredraw_num;      /* number of toggle member selected (1-N) */
kform_struct *connectredraw_struct;  /* pass to xvf_set_attributes() */

int          glyphplacement_val;      /* value of toggle 'glyphplacement'*/
int          glyphplacement_num;      /* number of toggle member selected (1-N) */
kform_struct *glyphplacement_struct;  /* pass to xvf_set_attributes() */

int          glyphdisplay_val;      /* value of toggle 'glyphdisplay'*/
int          glyphdisplay_num;      /* number of toggle member selected (1-N) */
kform_struct *glyphdisplay_struct;  /* pass to xvf_set_attributes() */

int          glyphreport_val;      /* value of toggle 'glyphreport'*/
int          glyphreport_num;      /* number of toggle member selected (1-N) */
kform_struct *glyphreport_struct;  /* pass to xvf_set_attributes() */

} pref_glyph;

/*
 * Pane Info Struct for 'workspace' Pane
 */
typedef struct _pref_workspace{

kform_struct *blank1_struct; /* pass to xvf_set_attributes() */

int          echoexec_val;      /* value of toggle 'echoexec'*/
int          echoexec_num;      /* number of toggle member selected (1-N) */
kform_struct *echoexec_struct;  /* pass to xvf_set_attributes() */

int          transport_val;      /* value of toggle 'transport'*/
int          transport_num;      /* number of toggle member selected (1-N) */
kform_struct *transport_struct;  /* pass to xvf_set_attributes() */

kform_struct *blank3_struct; /* pass to xvf_set_attributes() */

kform_struct *backgroundpixmap_struct; /* pass to xvf_set_attributes() */

char         *backgroundcolor;         /* string for 'backgroundcolor'*/
kform_struct *backgroundcolor_struct;  /* pass to xvf_set_attributes() */
int          backgroundcolor_optsel;   /* TRUE if optional box of 'backgroundcolor' is ON */

char         *backpixmaps;         /* string for 'backpixmaps'*/
kform_struct *backpixmaps_struct;  /* pass to xvf_set_attributes() */
int          backpixmaps_optsel;   /* TRUE if optional box of 'backpixmaps' is ON */

} pref_workspace;

/*
 * Pane Info Struct for 'commandbar' Pane
 */
typedef struct _pref_commandbar{

int           runwksp;         /* TRUE if the box for 'runwksp' is ON */
kform_struct *runwksp_struct;  /* pass to xvf_set_attributes() */

int           cut;         /* TRUE if the box for 'cut' is ON */
kform_struct *cut_struct;  /* pass to xvf_set_attributes() */

int           undodelete;         /* TRUE if the box for 'undodelete' is ON */
kform_struct *undodelete_struct;  /* pass to xvf_set_attributes() */

int           stopwksp;         /* TRUE if the box for 'stopwksp' is ON */
kform_struct *stopwksp_struct;  /* pass to xvf_set_attributes() */

int           copy;         /* TRUE if the box for 'copy' is ON */
kform_struct *copy_struct;  /* pass to xvf_set_attributes() */

int           createprocedure;         /* TRUE if the box for 'createprocedure' is ON */
kform_struct *createprocedure_struct;  /* pass to xvf_set_attributes() */

int           runmode;         /* TRUE if the box for 'runmode' is ON */
kform_struct *runmode_struct;  /* pass to xvf_set_attributes() */

int           paste;         /* TRUE if the box for 'paste' is ON */
kform_struct *paste_struct;  /* pass to xvf_set_attributes() */

int           createcount;         /* TRUE if the box for 'createcount' is ON */
kform_struct *createcount_struct;  /* pass to xvf_set_attributes() */

int           resetwksp;         /* TRUE if the box for 'resetwksp' is ON */
kform_struct *resetwksp_struct;  /* pass to xvf_set_attributes() */

int           showclipboard;         /* TRUE if the box for 'showclipboard' is ON */
kform_struct *showclipboard_struct;  /* pass to xvf_set_attributes() */

int           createwhile;         /* TRUE if the box for 'createwhile' is ON */
kform_struct *createwhile_struct;  /* pass to xvf_set_attributes() */

int           clearwksp;         /* TRUE if the box for 'clearwksp' is ON */
kform_struct *clearwksp_struct;  /* pass to xvf_set_attributes() */

int           duplicate;         /* TRUE if the box for 'duplicate' is ON */
kform_struct *duplicate_struct;  /* pass to xvf_set_attributes() */

int           openwksp;         /* TRUE if the box for 'openwksp' is ON */
kform_struct *openwksp_struct;  /* pass to xvf_set_attributes() */

int           checkwksp;         /* TRUE if the box for 'checkwksp' is ON */
kform_struct *checkwksp_struct;  /* pass to xvf_set_attributes() */

int           selectall;         /* TRUE if the box for 'selectall' is ON */
kform_struct *selectall_struct;  /* pass to xvf_set_attributes() */

int           savewksp;         /* TRUE if the box for 'savewksp' is ON */
kform_struct *savewksp_struct;  /* pass to xvf_set_attributes() */

int           redrawwksp;         /* TRUE if the box for 'redrawwksp' is ON */
kform_struct *redrawwksp_struct;  /* pass to xvf_set_attributes() */

int           unselectall;         /* TRUE if the box for 'unselectall' is ON */
kform_struct *unselectall_struct;  /* pass to xvf_set_attributes() */

int           savewkspas;         /* TRUE if the box for 'savewkspas' is ON */
kform_struct *savewkspas_struct;  /* pass to xvf_set_attributes() */

int           wkspinfo;         /* TRUE if the box for 'wkspinfo' is ON */
kform_struct *wkspinfo_struct;  /* pass to xvf_set_attributes() */

int           del;         /* TRUE if the box for 'del' is ON */
kform_struct *del_struct;  /* pass to xvf_set_attributes() */

kform_struct *blank1_struct; /* pass to xvf_set_attributes() */

kform_struct *blank3_struct; /* pass to xvf_set_attributes() */

kform_struct *blank4_struct; /* pass to xvf_set_attributes() */

kform_struct *blank5_struct; /* pass to xvf_set_attributes() */

kform_struct *blank6_struct; /* pass to xvf_set_attributes() */

kform_struct *blank8_struct; /* pass to xvf_set_attributes() */

kform_struct *blank18_struct; /* pass to xvf_set_attributes() */

kform_struct *blank19_struct; /* pass to xvf_set_attributes() */

kform_struct *blank20_struct; /* pass to xvf_set_attributes() */

kform_struct *blank12_struct; /* pass to xvf_set_attributes() */

kform_struct *blank9_struct; /* pass to xvf_set_attributes() */

kform_struct *blank11_struct; /* pass to xvf_set_attributes() */

kform_struct *blank13_struct; /* pass to xvf_set_attributes() */

kform_struct *blank16_struct; /* pass to xvf_set_attributes() */

kform_struct *blank17_struct; /* pass to xvf_set_attributes() */

kform_struct *blank14_struct; /* pass to xvf_set_attributes() */

kform_struct *blank15_struct; /* pass to xvf_set_attributes() */

kform_struct *blank21_struct; /* pass to xvf_set_attributes() */

kform_struct *blank22_struct; /* pass to xvf_set_attributes() */

kform_struct *blank2_struct; /* pass to xvf_set_attributes() */

kform_struct *blank10_struct; /* pass to xvf_set_attributes() */

kform_struct *blank7_struct; /* pass to xvf_set_attributes() */

kform_struct *blank23_struct; /* pass to xvf_set_attributes() */

kform_struct *blank24_struct; /* pass to xvf_set_attributes() */

} pref_commandbar;

/*
 * Subform Info Struct for 'pref' Subform
 */
typedef struct _cantata_pref {

int          apply_changes;          /* TRUE when user clicks on 'apply_changes'*/
kform_struct *apply_changes_struct;  /* pass to xvf_set_attributes() */

int          restore_defaults;          /* TRUE when user clicks on 'restore_defaults'*/
kform_struct *restore_defaults_struct;  /* pass to xvf_set_attributes() */

kform_struct *help_struct; /* pass to xvf_set_attributes() */

kform_struct *blank1_struct; /* pass to xvf_set_attributes() */

int          quit;         /* TRUE when user clicks on 'Close' button */
kform_struct *quit_struct; /* pass to xvf_set_attributes() */

pref_grid   *grid;          /* ptr to Pane Info struct for pane 'grid' */
int        grid_selected;          /* TRUE if input was from pane 'grid' */
kform_struct *grid_struct;          /* pass to xvf_set_attributes() */

pref_glyph  *glyph;          /* ptr to Pane Info struct for pane 'glyph' */
int        glyph_selected;          /* TRUE if input was from pane 'glyph' */
kform_struct *glyph_struct;          /* pass to xvf_set_attributes() */

pref_workspace  *workspace;          /* ptr to Pane Info struct for pane 'workspace' */
int            workspace_selected;          /* TRUE if input was from pane 'workspace' */
kform_struct   *workspace_struct;          /* pass to xvf_set_attributes() */

pref_commandbar  *commandbar;          /* ptr to Pane Info struct for pane 'commandbar' */
int             commandbar_selected;          /* TRUE if input was from pane 'commandbar' */
kform_struct    *commandbar_struct;          /* pass to xvf_set_attributes() */

}  cantata_pref;

/*
 * Pane Info Struct for 'program' Pane
 */
typedef struct _encapsulate_program{

int          create;          /* TRUE when user clicks on 'create'*/
kform_struct *create_struct;  /* pass to xvf_set_attributes() */

kform_struct *help_struct; /* pass to xvf_set_attributes() */

int          quit;         /* TRUE when user clicks on 'Close' button */
kform_struct *quit_struct; /* pass to xvf_set_attributes() */

int          toolboxes;          /* int value of 'toolboxes'*/
char         *toolboxes_label;   /* label representing int value of 'toolboxes'*/
kform_struct *toolboxes_struct;  /* pass to xvf_set_attributes() */
int          toolboxes_selected; /* TRUE on <cr> for 'toolboxes' */

int          objects;          /* int value of 'objects'*/
char         *objects_label;   /* label representing int value of 'objects'*/
kform_struct *objects_struct;  /* pass to xvf_set_attributes() */
int          objects_selected; /* TRUE on <cr> for 'objects' */

char         *tbname;         /* string for 'tbname'*/
kform_struct *tbname_struct;  /* pass to xvf_set_attributes() */

char         *oname;         /* string for 'oname'*/
kform_struct *oname_struct;  /* pass to xvf_set_attributes() */

char         *category;         /* string for 'category'*/
kform_struct *category_struct;  /* pass to xvf_set_attributes() */
int          category_selected; /* TRUE on <cr> for 'category' */

char         *subcategory;         /* string for 'subcategory'*/
kform_struct *subcategory_struct;  /* pass to xvf_set_attributes() */

char         *icon_name;         /* string for 'icon_name'*/
kform_struct *icon_name_struct;  /* pass to xvf_set_attributes() */

} encapsulate_program;

/*
 * Subform Info Struct for 'encapsulate' Subform
 */
typedef struct _cantata_encapsulate {

encapsulate_program  *program;          /* ptr to Pane Info struct for pane 'program' */
int                 program_selected;          /* TRUE if input was from pane 'program' */
kform_struct        *program_struct;          /* pass to xvf_set_attributes() */

}  cantata_encapsulate;

/*
 * Form Info Struct for 'cantata' form
 */
typedef struct _gui_info_struct {

xvobject     workspace;          /* address of workspace 'workspace'*/
kform_struct *workspace_struct;  /* pass to xvf_set_attributes() */

kform_struct *workspace_file_struct; /* submenu button, pass to xvf_set_attributes() */

int          create;          /* TRUE when user clicks on 'create'*/
kform_struct *create_struct;  /* pass to xvf_set_attributes() */

int          open;          /* TRUE when user clicks on 'open'*/
kform_struct *open_struct;  /* pass to xvf_set_attributes() */

int          resave;          /* TRUE when user clicks on 'resave'*/
kform_struct *resave_struct;  /* pass to xvf_set_attributes() */

int          save;          /* TRUE when user clicks on 'save'*/
kform_struct *save_struct;  /* pass to xvf_set_attributes() */

int          close;          /* TRUE when user clicks on 'close'*/
kform_struct *close_struct;  /* pass to xvf_set_attributes() */

int          quit;         /* TRUE when user clicks on 'Exit' button */
kform_struct *quit_struct; /* pass to xvf_set_attributes() */

kform_struct *edit_menu_struct; /* submenu button, pass to xvf_set_attributes() */

int          cut;          /* TRUE when user clicks on 'cut'*/
kform_struct *cut_struct;  /* pass to xvf_set_attributes() */

int          copy;          /* TRUE when user clicks on 'copy'*/
kform_struct *copy_struct;  /* pass to xvf_set_attributes() */

int          paste;          /* TRUE when user clicks on 'paste'*/
kform_struct *paste_struct;  /* pass to xvf_set_attributes() */

int          clipboard;          /* TRUE when user clicks on 'clipboard'*/
kform_struct *clipboard_struct;  /* pass to xvf_set_attributes() */

kform_struct *b1_struct; /* pass to xvf_set_attributes() */

int          duplicate;          /* TRUE when user clicks on 'duplicate'*/
kform_struct *duplicate_struct;  /* pass to xvf_set_attributes() */

kform_struct *b2_struct; /* pass to xvf_set_attributes() */

int          del;          /* TRUE when user clicks on 'del'*/
kform_struct *del_struct;  /* pass to xvf_set_attributes() */

int          undo;          /* TRUE when user clicks on 'undo'*/
kform_struct *undo_struct;  /* pass to xvf_set_attributes() */

kform_struct *b3_struct; /* pass to xvf_set_attributes() */

int          select;          /* TRUE when user clicks on 'select'*/
kform_struct *select_struct;  /* pass to xvf_set_attributes() */

int          unselect;          /* TRUE when user clicks on 'unselect'*/
kform_struct *unselect_struct;  /* pass to xvf_set_attributes() */

kform_struct *b4_struct; /* pass to xvf_set_attributes() */

kform_struct *workspace_menu_struct; /* submenu button, pass to xvf_set_attributes() */

int          run;          /* TRUE when user clicks on 'run'*/
kform_struct *run_struct;  /* pass to xvf_set_attributes() */

int          stop;          /* TRUE when user clicks on 'stop'*/
kform_struct *stop_struct;  /* pass to xvf_set_attributes() */

kform_struct *b5_struct; /* pass to xvf_set_attributes() */

int          runonce;          /* TRUE when user clicks on 'runonce'*/
kform_struct *runonce_struct;  /* pass to xvf_set_attributes() */

kform_struct *b7_struct; /* pass to xvf_set_attributes() */

int          reset;          /* TRUE when user clicks on 'reset'*/
kform_struct *reset_struct;  /* pass to xvf_set_attributes() */

int          clear;          /* TRUE when user clicks on 'clear'*/
kform_struct *clear_struct;  /* pass to xvf_set_attributes() */

int          check;          /* TRUE when user clicks on 'check'*/
kform_struct *check_struct;  /* pass to xvf_set_attributes() */

int          redraw;          /* TRUE when user clicks on 'redraw'*/
kform_struct *redraw_struct;  /* pass to xvf_set_attributes() */

int          info;          /* TRUE when user clicks on 'info'*/
kform_struct *info_struct;  /* pass to xvf_set_attributes() */

kform_struct *b8_struct; /* pass to xvf_set_attributes() */

kform_struct *options_menu_struct; /* submenu button, pass to xvf_set_attributes() */

kform_struct *b9_struct; /* pass to xvf_set_attributes() */

int          commandbar;          /* TRUE when user clicks on 'commandbar'*/
kform_struct *commandbar_struct;  /* pass to xvf_set_attributes() */

int          console;          /* TRUE when user clicks on 'console'*/
kform_struct *console_struct;  /* pass to xvf_set_attributes() */

int          size;          /* TRUE when user clicks on 'size'*/
kform_struct *size_struct;  /* pass to xvf_set_attributes() */

kform_struct *b20_struct; /* pass to xvf_set_attributes() */

int          clearconsole;          /* TRUE when user clicks on 'clearconsole'*/
kform_struct *clearconsole_struct;  /* pass to xvf_set_attributes() */

kform_struct *control_menu_struct; /* submenu button, pass to xvf_set_attributes() */

int          create_procedure;          /* TRUE when user clicks on 'create_procedure'*/
kform_struct *create_procedure_struct;  /* pass to xvf_set_attributes() */

int          create_countloop;          /* TRUE when user clicks on 'create_countloop'*/
kform_struct *create_countloop_struct;  /* pass to xvf_set_attributes() */

int          create_whileloop;          /* TRUE when user clicks on 'create_whileloop'*/
kform_struct *create_whileloop_struct;  /* pass to xvf_set_attributes() */

kform_struct *b10_struct; /* pass to xvf_set_attributes() */

int          create_expression;          /* TRUE when user clicks on 'create_expression'*/
kform_struct *create_expression_struct;  /* pass to xvf_set_attributes() */

int          create_ifelse;          /* TRUE when user clicks on 'create_ifelse'*/
kform_struct *create_ifelse_struct;  /* pass to xvf_set_attributes() */

int          create_merge;          /* TRUE when user clicks on 'create_merge'*/
kform_struct *create_merge_struct;  /* pass to xvf_set_attributes() */

int          create_switch;          /* TRUE when user clicks on 'create_switch'*/
kform_struct *create_switch_struct;  /* pass to xvf_set_attributes() */

int          create_trigger;          /* TRUE when user clicks on 'create_trigger'*/
kform_struct *create_trigger_struct;  /* pass to xvf_set_attributes() */

kform_struct *b11_struct; /* pass to xvf_set_attributes() */

int          panel;          /* TRUE when user clicks on 'panel'*/
kform_struct *panel_struct;  /* pass to xvf_set_attributes() */

int          export;          /* TRUE when user clicks on 'export'*/
kform_struct *export_struct;  /* pass to xvf_set_attributes() */

kform_struct *b12_struct; /* pass to xvf_set_attributes() */

kform_struct *help_menu_struct; /* submenu button, pass to xvf_set_attributes() */

kform_struct *help1_struct; /* pass to xvf_set_attributes() */

int          tooltips;          /* TRUE when user clicks on 'tooltips'*/
kform_struct *tooltips_struct;  /* pass to xvf_set_attributes() */

kform_struct *b16_struct; /* pass to xvf_set_attributes() */

kform_struct *license_struct; /* pass to xvf_set_attributes() */

kform_struct *bugs_struct; /* pass to xvf_set_attributes() */

cantata_find  *find;
int find_selected;
kform_struct *find_struct;

cantata_var  *var;
int var_selected;
kform_struct *var_struct;

cantata_distcomp  *distcomp;
int distcomp_selected;
kform_struct *distcomp_struct;

cantata_pref  *pref;
int pref_selected;
kform_struct *pref_struct;

cantata_encapsulate  *encapsulate;
int encapsulate_selected;
kform_struct *encapsulate_struct;


kform_struct *cantata_struct;


 } gui_info_struct; 

        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void cantata_create	PROTO((gui_info_struct *));
void cantata_open	PROTO((gui_info_struct *));
void cantata_resave	PROTO((gui_info_struct *));
void cantata_save	PROTO((gui_info_struct *));
void cantata_close	PROTO((gui_info_struct *));
void cantata_cut	PROTO((gui_info_struct *));
void cantata_copy	PROTO((gui_info_struct *));
void cantata_paste	PROTO((gui_info_struct *));
void cantata_clipboard	PROTO((gui_info_struct *));
void cantata_duplicate	PROTO((gui_info_struct *));
void cantata_del	PROTO((gui_info_struct *));
void cantata_undo	PROTO((gui_info_struct *));
void cantata_select	PROTO((gui_info_struct *));
void cantata_unselect	PROTO((gui_info_struct *));
void cantata_run	PROTO((gui_info_struct *));
void cantata_stop	PROTO((gui_info_struct *));
void cantata_runonce	PROTO((gui_info_struct *));
void cantata_reset	PROTO((gui_info_struct *));
void cantata_clear	PROTO((gui_info_struct *));
void cantata_check	PROTO((gui_info_struct *));
void cantata_redraw	PROTO((gui_info_struct *));
void cantata_info	PROTO((gui_info_struct *));
void cantata_commandbar	PROTO((gui_info_struct *));
void cantata_console	PROTO((gui_info_struct *));
void cantata_size	PROTO((gui_info_struct *));
void cantata_clearconsole	PROTO((gui_info_struct *));
void cantata_create_procedure	PROTO((gui_info_struct *));
void cantata_create_countloop	PROTO((gui_info_struct *));
void cantata_create_whileloop	PROTO((gui_info_struct *));
void cantata_create_expression	PROTO((gui_info_struct *));
void cantata_create_ifelse	PROTO((gui_info_struct *));
void cantata_create_merge	PROTO((gui_info_struct *));
void cantata_create_switch	PROTO((gui_info_struct *));
void cantata_create_trigger	PROTO((gui_info_struct *));
void cantata_panel	PROTO((gui_info_struct *));
void cantata_export	PROTO((gui_info_struct *));
void cantata_tooltips	PROTO((gui_info_struct *));
void _xvf_free_cantata PROTO((gui_info_struct *));
void _xvf_get_cantata  PROTO((gui_info_struct *));

int  _xvf_init_cantata PROTO((kform *, gui_info_struct *));
void run_cantata       PROTO((kform *, ksubform *, kaddr));

void run_find      PROTO((cantata_find *));
void _xvf_get_find PROTO((cantata_find *));
void find_openglyph	PROTO((cantata_find *));

void run_routines      PROTO((find_routines *));
void _xvf_get_routines PROTO((find_routines *));

void run_finder      PROTO((find_finder *));
void _xvf_get_finder PROTO((find_finder *));
void finder_expr	PROTO((find_finder *));

void run_var      PROTO((cantata_var *));
void _xvf_get_var PROTO((cantata_var *));

void run_variables      PROTO((var_variables *));
void _xvf_get_variables PROTO((var_variables *));
void variables_expression	PROTO((var_variables *));
void variables_scope	PROTO((var_variables *));
void variables_varorig	PROTO((var_variables *));
void variables_varval	PROTO((var_variables *));
void variables_deletevar	PROTO((var_variables *));

void run_distcomp      PROTO((cantata_distcomp *));
void _xvf_get_distcomp PROTO((cantata_distcomp *));

void run_dist      PROTO((distcomp_dist *));
void _xvf_get_dist PROTO((distcomp_dist *));
void dist_remote_exec	PROTO((distcomp_dist *));
void dist_start_daemon	PROTO((distcomp_dist *));
void dist_stop_daemon	PROTO((distcomp_dist *));
void dist_save	PROTO((distcomp_dist *));
void dist_delete_remote	PROTO((distcomp_dist *));
void dist_add_name	PROTO((distcomp_dist *));

void run_pref      PROTO((cantata_pref *));
void _xvf_get_pref PROTO((cantata_pref *));
void pref_apply_changes	PROTO((cantata_pref *));
void pref_restore_defaults	PROTO((cantata_pref *));

void run_grid      PROTO((pref_grid *));
void _xvf_get_grid PROTO((pref_grid *));
void grid_griddisplay	PROTO((pref_grid *));

void run_glyph      PROTO((pref_glyph *));
void _xvf_get_glyph PROTO((pref_glyph *));

void run_workspace      PROTO((pref_workspace *));
void _xvf_get_workspace PROTO((pref_workspace *));

void run_commandbar      PROTO((pref_commandbar *));
void _xvf_get_commandbar PROTO((pref_commandbar *));

void run_encapsulate      PROTO((cantata_encapsulate *));
void _xvf_get_encapsulate PROTO((cantata_encapsulate *));

void run_program      PROTO((encapsulate_program *));
void _xvf_get_program PROTO((encapsulate_program *));
void program_create	PROTO((encapsulate_program *));
void program_toolboxes	PROTO((encapsulate_program *));
void program_objects	PROTO((encapsulate_program *));
void program_category	PROTO((encapsulate_program *));




#endif /* _form_info_h_ */ 
/* Don't add after this point */
