 /*
  * Khoros: $Id: globals.c,v 1.19 1997/01/20 05:34:31 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: globals.c,v 1.19 1997/01/20 05:34:31 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Global variables for cantata
   >>>> 
   >>>>  Private: 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "cantata.h"

/*
 * Various xvobjects that are used globally
 */
xvobject notebook	  = NULL; /* The notebook containing all workspaces   */
xvobject main_workspace   = NULL; /* The main cantata workspace               */
xvobject active_workspace = NULL; /* Workspace that is currently open         */
xvobject routines         = NULL; /* ToolboxList object on "Routines" subform */
xvobject finder           = NULL; /* FinderList object on "Finder" subform    */
xvobject tbmenu           = NULL; /* ToolboxMenu object on main cantata form  */
xvobject commandbar       = NULL; /* CommandBar object on main cantata form   */
xvobject statusobj        = NULL; /* StringList object used with kannounce    */
xvobject tooltips         = NULL; /* ToolTips object used with kannounce      */
xvobject sash             = NULL; /* The sash between the workspace & console */
xvobject console          = NULL; /* Console object used to echo info         */
xvobject active_indicator = NULL; /* Active workspace indicater at lower left */
xvobject gui_parent       = NULL; /* The main gui parent for the console, etc */
xvobject notifier         = NULL; /* popup notifier for when we're working    */

/* 
 * Form tree for cantata GUI 
 */
kform *cantata_form      = NULL; 

/* 
 * Array of xvobjects corresponding to workspaces whose names appear in the 
 * varscope list of the Variables subform.  First item in array is NULL, 
 * meaning "Global Variables".  Second item in array is the "MainWorkspace".
 * Next items correspond to any procedures, loops, etc. 
 */ 
xvobject *workspace_list    = NULL; 

/*
 * Xvobject corresponding to workspace which is currently selected from
 * the varscope list on the Variables subform.  A value of NULL implies that 
 * "Global Varialbes" is selected from the list.
 */
xvobject selected_workspace = NULL;

/*
 * Logical variable used to keep track of whether the current version of
 * cantata is of minimum or maximum size.  The startup default depends
 * on the command line specification.
 */
int	cantata_size_mini = FALSE;

/*
 * Preference variables that are used to store default values
 */
int   pref_def_griddisplay;
char *pref_def_gridcolor;
int   pref_def_gridsize;
int   pref_def_connecttype;
int   pref_def_connectredraw;
int   pref_def_glyphplacement;
int   pref_def_glyphdisplay;
int   pref_def_glyphreport;
int   pref_def_remoteexec;
int   pref_def_echoexec;
char *pref_def_backgroundcolor;
char *pref_def_backpixmaps;
int   pref_def_runwksp;
int   pref_def_stopwksp;
int   pref_def_runmode;
int   pref_def_resetwksp;
int   pref_def_clearwksp;
int   pref_def_checkwksp;
int   pref_def_redrawwksp;
int   pref_def_wkspinfo;
int   pref_def_cut;
int   pref_def_copy;
int   pref_def_paste;
int   pref_def_showclipboard;
int   pref_def_duplicate;
int   pref_def_selectall;
int   pref_def_unselectall;
int   pref_def_delete;
int   pref_def_undodelete;
int   pref_def_createprocedure;
int   pref_def_createcount;
int   pref_def_createwhile;
int   pref_def_openwksp;
int   pref_def_savewksp;
int   pref_def_savewkspas;


