 /*
  * Khoros: $Id: usage.c,v 1.23.2.4 1997/05/31 18:32:05 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.23.2.4 1997/05/31 18:32:05 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "cantata.h"
/*-----------------------------------------------------------
| 
|  Routine Name: cantata_get_args
| 
|       Purpose: Gets command line args for cantata
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname cantata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void cantata_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for cantata is out of sync with arguments specified in cantata's *.pane file; please rerun ghostwriter on cantata.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the cantata structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_flag(pane, "mini",
			  &(clui_info->mini_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "tbmenus",
			  &(clui_info->tbmenus_logic),
			  &(clui_info->tbmenus_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "commandbar",
			  &(clui_info->commandbar_logic),
			  &(clui_info->commandbar_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "console",
			  &(clui_info->console_logic),
			  &(clui_info->console_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "wksp",
			  &(clui_info->wksp_file),
			  &(clui_info->wksp_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "cantata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'The visual programming language for Khoros' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' pane",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute cantata' $DESIGNBIN/cantata",
  "-H 1  5x1+41+0 'Help' 'help page for cantata' $DESIGN/objects/xvroutine/cantata/help/cantata.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-t 1 0 1 0 0 16.5x1+0+5.5 'Miniaturize Cantata' 'Create A Miniaturized version of Cantata' mini",
  "-l 1 0 1 0 1 35x1+0+6.5 1 'Create Toolbox Menus' 'False' 'True' 'Create Cantata Pulldown Toolbox Menus' tbmenus",
  "-l 1 0 1 0 1 35x1+0+7.5 1 'Create Command Bar Menus' 'False' 'True' 'Create Cantata Command Bar Menus' commandbar",
  "-l 1 0 1 0 1 35x1+0+8.5 1 'Create Console' 'False' 'True' 'Create Cantata Console' console",
  "-C 0",
  "-I 1 0 1 0 0 1 52x1+0+2 ' ' 'Cantata workspace file' 'file for restoring cantata workspace' wksp",
  "-B 0",
  "-s 1 0 1 0 0 52x1+0+3 ' ' 'Toolbox Name' 'the toolbox in which the encapsulated workspace' tb",
  "-s 1 0 1 0 0 52x1+0+4 ' ' 'Object Name ' 'The encapsulated workspace object name' oname",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DESIGN/objects/xvroutine/cantata/uis/cantata.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	23,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 0 50x10+10+20 +0+0 'Cantata: Visual Programming Language for the KHOROS System' cantata",
  "-S 1 0",
  "-w 450x350+0+0 'workspace widget' workspace",
  "",
  "-D 1 0 10x0.5+0+0 'File' workspace_file",
  "-n 1 0 12x1.2+0+16.5 'New' 'create a new workspace' create",
  "-n 1 0 12x1.2+0+16.5 'Open...' 'open an existing workspace' open",
  "-n 1 0 12x1.2+0+16.5 'Save' 'save existing workspace' resave",
  "-n 1 0 12x1.2+0+16.5 'Save As...' 'save existing workspace to a different one' save",
  "-n 1 0 12x1.2+0+16.5 'Close...' 'close current workspace' close",
  "-Q 1 0 6x1+120+0 'Exit'",
  "-E",
  "-D 1 0 10x0.5+0+0 'Edit' edit_menu",
  "-n 1 0 10x2+25+2 'Cut' 'delete current selected glyphs from the clipboard' cut",
  "-n 1 0 10x2+25+1 'Copy' 'copy selected glyphs into the clipboard' copy",
  "-n 1 0 10x2+25+3 'Paste' 'paste glyphs from the clipboard into the current workspace' paste",
  "-n 1 0 12x1.2+0+9.5 'Show Clipboard' 'hides the clipboard' clipboard",
  "-b +1+9 '' b1",
  "-n 1 0 10x2+25+4 'Duplicate' 'duplicate current selected glyphs from the clipboard' duplicate",
  "-b +1+9 '' b2",
  "-n 1 0 10x2+25+7 'Delete' 'delete selected glyphs in the current clipboard' del",
  "-n 1 0 10x2+15+8 'Undo Delete' 'undo the last delete' undo",
  "-b +1+9 '' b3",
  "-n 1 0 10x2+25+10 'Select All' 'select all glyphs' select",
  "-n 1 0 10x2+25+11 'Unselect All' 'unselect all glyphs' unselect",
  "-b +1+9 '' b4",
  "-d 1 0 10x2+25+3 'Find...' find",
  "-E",
  "",
  "-D 1 0 10x0.5+0+0 'Workspace' workspace_menu",
  "-n 1 0 11x1.4+1+6.5 'Run' 'runs the pipeline in order' run",
  "-n 1 0 11x1.4+1+6.5 'Stop' 'stops the pipeline' stop",
  "-b +1+9 '' b5",
  "-n 1 0 11x1.4+1+8 'Run Once' 'run workspace once .vs. continuous' runonce",
  "-b +1+9 '' b7",
  "-n 1 0 11x1.4+1+8 'Reset' 'give information about the workspace' reset",
  "-n 1 0 10x2+15+4 'Clear...' 'clear workspace' clear",
  "-n 1 0 10x2+15+4 'Check' 'verify network in the workspace' check",
  "-n 1 0 10x2+15+4 'Redraw' 'redraw the workspace' redraw",
  "-n 1 0 10x2+15+4 'Information...' 'give information about the workspace' info",
  "-b +1+9 '' b8",
  "-d 1 0 12x1.2+0+9.5 'Variables...' var",
  "-d 1 0 12x1.2+0+9.5 'Configure Remote Hosts...' distcomp",
  "-E",
  "-D 1 0 10x0.5+0+0 'Options' options_menu",
  "-d 1 0 12x1.2+0+9.5 'Preferences...' pref",
  "-b +1+9 '' b9",
  "-n 1 0 12x1.2+0+9.5 'Hide Command Bar' 'hides the commandbar' commandbar",
  "-n 1 0 12x1.2+0+9.5 'Hide Console' 'hides the console' console",
  "-n 1 0 12x1.2+0+9.5 'Small Size' 'changes the size of the GUI' size",
  "-b +1+9 '' b20",
  "-n 1 0 12x1.2+0+9.5 'Clear Console' 'clears the console' clearconsole",
  "-E",
  "-D 1 0 10x0.5+0+0 'Control' control_menu",
  "-n 1 0 10x2+25+17 'Create Procedure' 'create a procedure from selected glyphs' create_procedure",
  "-n 1 0 10x2+25+17 'Create Count Loop' 'create a count loop procedure fromselected glyphs' create_countloop",
  "-n 1 0 10x2+25+17 'Create While Loop' 'create a while loop procedure from selected glyphs' create_whileloop",
  "-b +1+9 '' b10",
  "-n 1 0 10x2+25+17 'Create Expression' 'create a conditional expression' create_expression",
  "-n 1 0 10x2+25+17 'Create If Else' 'create a conditional if/else' create_ifelse",
  "-n 1 0 10x2+25+17 'Create Merge Paths' 'create a merge path' create_merge",
  "-n 1 0 10x2+25+17 'Create Switch' 'create a conditional switch' create_switch",
  "-n 1 0 10x2+25+17 'Create Trigger' 'create a conditional trigger' create_trigger",
  "-b +1+9 '' b11",
  "-n 1 0 11x1.2+1+20 'Workspace GUI' 'activate workspace gui' panel",
  "-n 1 0 11x1.2+1+20 'Export Selections' 'export selections to workspace gui' export",
  "-d 1 0 11x1.2+1+21 'Encapsulate Workspace' encapsulate",
  "-b +1+3 '' b12",
  "",
  "-E",
  "-D 1 0 10x0.5+0+0 'Help' help_menu",
  "-H 1  6x1+114.375+0 'On Cantata' 'guide help' $DESIGN/objects/xvroutine/cantata/help/01.introduction.doc help1",
  "-n 1 0 12x1.2+0+9.5 'Activate ToolTips' 'activates the tool tips window' tooltips",
  "-b +1+9 '' b16",
  "-H 1  9x1+105+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-H 1  10x1+1+0.5 'Known Bugs' 'Cantata bugs and todo files' $DESIGN/objects/xvroutine/cantata/info/cantata.todo bugs",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/cantata/uis/find.subform",
  "@-F 4.3 1 0 128x32.5+10+20 +14+0 'Cantata: Visual Programming Language for the KHOROS System' cantata",
  "-M 1 1 66.6x11.6+0+0 +2+0.5 'Finder' find",
  "-G 1 15x10+0+1 +1+0 ' '",
  "-a 1 0 10x1.2+2+16 'Open' 'Open a glyph based on a selection from routines or from the finder' openglyph",
  "-Q 1 0 10x1.2+30+16 'Close'",
  "-H 1  10x1.2+56+16 'Help' 'display online help' $DESIGN/objects/xvroutine/cantata/help/create/finder.doc help",
  "-g 1 0 10x1.2+1+0.5 'Routines' routines",
  "-g 1 1 10x1.2+11+0.5 'Finder' finder",
  "-E",
  "-P 1 0 65x13.5+1+2 +3+0.2 'Accelerated Routines List' routines",
  "-w 508x200+0+1.5 'Routine lists' rlists",
  "-E",
  "-P 1 0 65x13.5+1+2 +3+0.2 ' ' finder",
  "-w 500x210+0+1.5 'Routine lists' flist",
  "-s 1 0 0 1 1 63x1+0+11.5 ' ' 'Finder Expression' 'expression to search for ' expr",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/cantata/uis/variables.subform",
  "@-F 4.3 1 0 170x5+10+10 +35+1 'CANTATA Visual Programming Environment for the KHOROS System' Cantata",
  "-M 1 1 10x5+0+0 +16+0 'Variables' var",
  "-P 1 0 79x16+0+0 +3+0.5 'Define Variables / Evaluate Expressions' variables",
  "-s 1 0 0 1 1 75x1+2+1.5 ' ' ' ' 'expression to be evaluated' expression",
  "-z 1 0 0 1 1 25x10+2+3.5 0 1 0 0 'Workspace Defining Scope:' 'workspace defining scope' scope",
  "-z 1 0 0 1 1 25x10+27+3.5 0 1 0 0 'Variable Definitions:' 'original definition of variables' varorig",
  "-z 1 0 0 1 1 25x10+52+3.5 0 1 0 0 'Current Values:' 'current values of variables ' varval",
  "-a 1 0 9x1.19231+7+14 'Delete' 'delete variable(s)' deletevar",
  "-Q 1 0 9x1.19231+33+14 'Close'",
  "-H 1  9x1.19231+60+14 'Help' 'display online help' $DESIGN/objects/xvroutine/cantata/help/09.variables.doc help",
  "-b +3+2.5 'Result of Evaluation:' blank1",
  "-b +21+2.5 ' ' blank2",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/cantata/uis/distcomp.subform",
  "@-F 4.3 1 0 30x30+10+20 +0+0 ' ' form",
  "-M 1 1 30x5+0+0 +20+0 'Distributed Computing' distcomp",
  "-P 1 0 58x14.5+0+0 +18+0 'Remote Host Control Panel' dist",
  "-T 1 0 0 1 1 50x1+2+1 +0+0 2 'Remote Execution:' 'Enable or disable remote execution' remote_exec",
  "-t 1 0 1 0 0 10x1+20+0 'Enabled' 'Enable remote execution' dummy",
  "-t 1 0 1 1 0 10x1+35+0 'Disabled' 'Disable remote execution' dummy",
  "-E",
  "-z 1 0 0 1 0 55x7+1+2.5 0 1 0 0 '             Available Remote Hosts                               ' 'list of remote hosts' remote_hosts",
  "-a 1 0 10.5x1+1+10 'Start Daemon' 'Start remote daemon' start_daemon",
  "-a 1 0 10x1+14+10 'Stop Daemon' 'Stop remote daemon' stop_daemon",
  "-a 1 0 9x1+34+10 'Save' 'save current list of remote hosts' save",
  "-a 1 0 10x1+46+10 'Delete' 'Delete remote host from list' delete_remote",
  "-s 1 0 0 1 1 54x1+2+11.5 ' ' 'Add & Start Remote Host' 'user-supplied remote machine name' add_name",
  "-Q 1 0 8x1.19231+2+13 'Close'",
  "-H 1  8x1.19231+47+13 'Help' 'online help page' $DESIGN/objects/xvroutine/cantata/help/workspace/wkspremotehosts.doc help",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/cantata/uis/preferences.subform",
  "@-F 4.3 1 0 30x30+10+20 +0+0 ' ' form",
  "-M 1 1 30x5+0+0 +20+0 'Preferences' pref",
  "-G 1 15x10+0+1 +2+0 ' '",
  "-a 1 0 12.75x1.26923+1+12.5 'Apply Changes' 'Apply preference changes' apply_changes",
  "-a 1 0 14.75x1.26923+16+12.5 'Restore Defaults' 'Set all preferences to the default value' restore_defaults",
  "-H 1  9x1.3+50+12.5 'Help' 'display online help' $DESIGN/objects/xvroutine/cantata/help/08.attributes.doc help",
  "-b +2+0 'Preferences:' blank1",
  "-Q 1 0 9.75x1.26923+61+12.5 'Close'",
  "-g 1 0 13x1.3+17+0 'Canvas Grid' grid",
  "-g 1 0 13x1.3+31+0 'Glyphs' glyph",
  "-g 1 1 13x1.3+45+0 'Workspace' workspace",
  "-g 1 0 13x1.3+59+0 'Command Bar' commandbar",
  "-E",
  "-P 1 0 70.25x10.5769+1+1.5 +20+0 ' ' grid",
  "-b +2+1.5 'Canvas Grid' blank1",
  "-T 1 0 0 1 1 39.125x1+2+3.5 +0+0 1 'Set Canvas Grid To:' 'canvas grid visibility' griddisplay",
  "-i 1 0 1 1 0 0x0+16+0 0 1 0 0 0 'Invisible' 'set canvas grid to invisible' dummy",
  "-i 1 0 1 0 0 0x0+30+0 0 1 1 1 1 'Visible' 'set canvas grid to visible' dummy",
  "-E",
  "-i 0 0 0 1 0 44x1+2+5 5 200 20 0 0 'Canvas Grid Size:    ' 'Set size of workspace canvas grid' gridsize",
  "-y 0 0 0 1 0 44x1+2+6.5 21 1 'Grid Color' 'Specifies the workspace canvas grid color' gridcolor 'black' 'blue' 'coral' 'forestgreen ' 'green ' 'lightgrey ' 'limegreen ' 'magenta ' 'orange ' 'orangered ' 'pink ' 'plum ' 'red ' 'salmon ' 'seagreen ' 'thistle ' 'turquoise ' 'violet ' 'white ' 'wheat ' 'yellow '",
  "-E",
  "-P 1 0 70.25x10.5769+1+1.5 +20+0 ' ' glyph",
  "-b +0+0 'Glyphs' blank1",
  "-T 1 0 0 1 0 66.375x1+0+1 +0+0 2 'Set Connection Type To:' 'Set glyph connection type' connecttype",
  "-t 1 0 1 0 0 10x1+21+0 'Direct Line' 'Set glyph connection to direct line' dummy",
  "-t 1 0 1 1 0 10x1+31+0 'Manhattan' 'Set glyph connection to manhattan' dummy",
  "-t 1 0 1 0 0 10x1+42.5+0 'Spline' 'Set glyph connection to spline' dummy",
  "-t 1 0 1 0 0 10x1+50+0 'Hexagon' 'Set glyph connection to hexagon' dummy",
  "-t 1 0 1 0 0 0x1+58+0 'Diamond' 'Set glyph connection to diamond' dummy",
  "-E",
  "-T 1 0 0 1 0 60.625x1+0+2.5 +0+0 2 'Redraw Glyph Connections:' 'Specifies how connections are redrawn' connectredraw",
  "-i 1 0 1 0 0 10x1+21+0 0 0 0 0 0 'After Glyph Movement' 'Redraw glyph connections after glyph is moved' dummy",
  "-i 1 0 1 1 0 10x1+42.5+0 0 1 1 0 0 'During Glyph Movement' 'Redraw glyph connections as glyph is moved' dummy",
  "-E",
  "-T 1 0 0 1 0 55.375x1+0+4 +0+0 2 'Place Glyph:' 'Specifies how glyphs are placed on the workspace' glyphplacement",
  "-i 1 0 1 0 0 10x1+42.5+0 0 0 0 0 0 'Automatically' 'Place glyphs automatically' dummy",
  "-i 1 0 1 1 0 10x1+21+0 0 1 1 0 0 'Interactively' 'Place glyphs interactively' dummy",
  "-E",
  "-T 1 0 0 1 0 59.875x1+0+5.5 +0+0 2 'Display Glyph:' 'Specifies when glyphs are displayed' glyphdisplay",
  "-i 1 0 1 0 0 16.625x1+42.5+0 0 0 0 0 0 'When Pane Is Closed' 'Display glyphs only when pane access is closed' dummy",
  "-i 1 0 1 1 0 10x1+21+0 0 1 1 0 0 'Always' 'Always display the glyphs' dummy",
  "-E",
  "-T 1 0 0 1 0 52.5x1+0+7 +0+0 2 'Set Glyph Reporting:' 'Specifies whether glyph reporting is enabled or disabled' glyphreport",
  "-i 1 0 1 0 0 10x1+42.5+0 0 0 0 0 0 'Disabled' 'Disables glyph reporting' dummy",
  "-i 1 0 1 1 0 10x1+21+0 0 1 1 0 0 'Enabled' 'Enables glyph reporting' dummy",
  "-E",
  "-E",
  "-P 1 0 70.5x10.5+1+1.5 +12+0 ' ' workspace",
  "-b +1+0 'Workspace' blank1",
  "-T 1 0 0 1 0 66.125x2+1+1 +0+0 2 'Echo Execution:' 'Specifies if execution echoing is enabled or disabled' echoexec",
  "-i 1 0 1 0 0 10x1+21+0 0 3 0 0 0 'No Echoing' 'Disables execution echoing' dummy",
  "-i 1 0 1 1 0 10x1+42+0 0 3 1 0 0 'Echo To Console' 'Enables execution echoing' dummy",
  "-i 1 0 1 0 0 10x1+21+1 0 3 2 0 0 'Echo To Log' 'Enables execution echoing' dummy",
  "-i 1 0 1 0 0 10x1+42+1 0 3 3 0 0 'Echo To both Console and Log' 'Enables execution echoing' dummy",
  "-E",
  "-T 1 0 0 1 0 66x2+1+6.5 +0+0 1 'Data Transport Type (For New Connections Only)' 'data transport type' transport",
  "-i 1 0 1 1 0 22.625x1+1+1  2 2 1 0 0 'Standard Unix Files (file)' '1' dummy",
  "-i 1 0 1 0 0 22.625x1+25+1 2 2 2 0 0 'Memory Mapped Files (mmap)' '2' dummy",
  "-i 1 0 1 0 0 21.875x1+1+2  2 2 3 0 0 'Shared Memory Files (shm)' '3' dummy",
  "-i 1 0 1 0 0 21.875x1+25+2 2 2 4 0 0 'Standard Stream FIFO (stream)' '4' dummy",
  "-E",
  "-b +1+3.5 'Set Background Color:' blank3",
  "-b +1+5 'Set Background Pixmap:' backgroundpixmap",
  "-C 0",
  "-y 1 0 1 1 0 45x1+22+3.5 22 1 'Available Colors  ' 'Specifies background color for workspace' backgroundcolor 'default' 'black' 'blue' 'coral' 'forestgreen' 'green' 'lightgrey' 'limegreen' 'magenta' 'orange' 'orangered' 'pink' 'plum' 'red' 'salmon' 'seagreen' 'thistle' 'turquoise' 'violet' 'white' 'wheat' 'yellow'",
  "-y 1 0 1 0 0 45x1+22+5 11 2 'Available Pixmaps ' 'Specifies background pixmapr for workspace' backpixmaps 'backgrounds:hex_grid' 'backgrounds:esher_grid' 'backgrounds:purple_maze' 'backgrounds:black_marble' 'backgrounds:brown_marble' 'backgrounds:purple_marble' 'backgrounds:gravel_marble' 'backgrounds:bw_marble' 'backgrounds:wood_pulp' 'backgrounds:paper_gray' 'backgrounds:paper_wheat'",
  "-E",
  "-E",
  "-P 1 0 70.25x10.5769+1+1.5 +19+1 ' ' commandbar",
  "-t 1 0 1 0 0 4.375x1+0+1.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/run.xpm' 'Run the workspace' runwksp",
  "-t 1 0 1 0 0 4.375x1+22+1.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/cut.xpm' 'Cut selected glyphs' cut",
  "-t 1 0 1 0 0 4.375x1+47+1.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/undelete.xpm' 'Undo deletion of selected glyphs' undodelete",
  "-t 1 0 1 0 0 5x1+0+2.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/stop.xpm' 'Stop the workspace' stopwksp",
  "-t 1 0 1 0 0 4.375x1+22+2.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/copy.xpm' 'Copy selected glyphs' copy",
  "-t 1 0 1 0 0 4.375x1+47+2.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/proc.xpm' 'Create a procedure from selected glyphs' createprocedure",
  "-t 1 0 1 0 0 4.375x1+0+3.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/runconti.xpm' 'Specify run mode as run once or run continuous' runmode",
  "-t 1 0 1 0 0 4.375x1+22+3.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/paste.xpm' 'Paste selected glyphs' paste",
  "-t 1 0 1 0 0 4.375x1+47+3.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/count.xpm' 'Create a count loop from selected glyphs' createcount",
  "-t 1 0 1 0 0 4.375x1+0+4.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/reset.xpm' 'Reset the workspace' resetwksp",
  "-t 1 0 1 0 0 4.375x1+22+4.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/showclip.xpm' 'Workspace clipboard mode' showclipboard",
  "-t 1 0 1 0 0 4.375x1+47+4.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/while.xpm' 'Create while loop from selected glyphs' createwhile",
  "-t 1 0 1 0 0 4.375x1+0+5.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/clear.xpm' 'Clear the workspace' clearwksp",
  "-t 1 0 1 0 0 4.375x1+22+5.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/dupe.xpm' 'Duplicate selected glyphs' duplicate",
  "-t 1 0 1 0 0 4.375x1+47+5.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/open.xpm' 'Open an existing workspace' openwksp",
  "-t 1 0 1 0 0 4.375x1+0+6.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/check.xpm' 'Check the workspace' checkwksp",
  "-t 1 0 1 0 0 4.375x1+22+6.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/select.xpm' 'Select all glyphs' selectall",
  "-t 1 0 1 0 0 4.375x1+47+6.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/save.xpm' 'Save the current workspace' savewksp",
  "-t 1 0 1 0 0 4.375x1+0+7.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/redraw.xpm' 'Redraw the workspace' redrawwksp",
  "-t 1 0 1 0 0 5x1+22+7.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/unselect.xpm' 'Unselect all glyphs' unselectall",
  "-t 1 0 1 0 0 4.375x1+47+7.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/saveas.xpm' 'Save the current workspace as a new file' savewkspas",
  "-t 1 0 1 0 0 4.375x1+0+8.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/info.xpm' 'Obtain workspace information' wkspinfo",
  "-t 1 0 1 0 0 4.375x1+22+8.5 'pixmap:$DESIGN/objects/library/xvlang/pixmaps/commandbar/small/delete.xpm' 'Delete selected glyphs' del",
  "-b +5+1.5 'Run' blank1",
  "-b +5+3.5 'Run Mode' blank3",
  "-b +5+4.5 'Reset Workspace' blank4",
  "-b +5+5.5 'Clear Workspace' blank5",
  "-b +5+6.5 'Check Workspace' blank6",
  "-b +5+8.5 'Workspace Information' blank8",
  "-b +52+2.5 'Create Procedure' blank18",
  "-b +52+3.5 'Create Count Loop' blank19",
  "-b +52+4.5 'Create While Loop' blank20",
  "-b +27+4.5 'Show Clipboard' blank12",
  "-b +27+1.5 'Cut Selected Glyphs' blank9",
  "-b +27+3.5 'Paste Selected Glyphs' blank11",
  "-b +27+5.5 'Duplicate Selected Glyphs' blank13",
  "-b +27+8.5 'Delete Selected Glyphs' blank16",
  "-b +52+1.5 'Undo Deletion' blank17",
  "-b +27+6.5 'Select All Glyphs' blank14",
  "-b +27+7.5 'Unselect All Glyphs' blank15",
  "-b +52+5.5 'Open Workspace' blank21",
  "-b +52+6.5 'Save Workspace' blank22",
  "-b +5+2.5 'Stop' blank2",
  "-b +27+2.5 'Copy Selected Glyphs' blank10",
  "-b +5+7.5 'Redraw Workspace' blank7",
  "-b +52+7.5 'Save Workspace As' blank23",
  "-b +0+0 'Command Bar Icons' blank24",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/cantata/uis/encap.subform",
  "@-F 4.3 1 0 170x7+10+20 +35+1 'CANTATA Visual Programming Environment for the KHOROS System' Cantata",
  "-M 1 1 51x8+10+5 +15+0.5 'Encapsulate Workspace' encapsulate",
  "-P 1 0 50x13.8636+0+0 +4+0 'Encapsulate Workspace' program",
  "-a 1 0 7x1+28+0 'Create' ' ' create",
  "-H 1  6x1+36+0 'Help' 'help' $DESIGN/objects/xvroutine/cantata/help/12.encapwksp.doc help",
  "-Q 1 0 6x1+43+0 'Close'",
  "-z 1 0 0 1 1 22.5x7.5+1+1.5 0 1 1 0 'Toolbox Object List' 'List of toolboxes' toolboxes",
  "-z 1 0 0 1 1 22.5x7.5+26+1.5 0 1 1 0 'Workspace Object List' 'Workspace object list' objects",
  "-s 1 0 0 1 0 22.5x1+1+9 ' ' 'Toolbox Name' 'the toolbox name to use' tbname",
  "-s 1 0 0 1 0 22.5x1+26+9 ' ' 'Object Name' 'object name' oname",
  "-y 1 0 0 1 1 47.875x1+1+10.5 0 1 '  Category ' 'category' category",
  "-y 1 0 0 1 0 48x1+1+11.5 0 1 'Subcategory' 'subcategory' subcategory",
  "-s 1 0 0 1 0 48x1+1+12.5 ' ' 'Icon Name ' 'icon or glyph name of object' icon_name",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
  61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,0,1,
  2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,0,1,2,3,
  4,5,6,7,8,9,10,11,12,13,14,0,1,2,3,4,5,6,7,8,
  9,10,11,12,13,14,15,16,17,0,1,2,3,4,5,6,7,8,9,10,
  11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,
  31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,
  51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,
  71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,
  91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,
  111,112,113,114,115,116,117,118,119,0,1,2,3,4,5,6,7,8,9,10,
  11,12,13,14,15,84,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,
  3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,
  4,4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$DESIGN/objects/xvroutine/cantata/uis/cantata.form",
  "$DESIGN/objects/xvroutine/cantata/uis/find.subform",
  "$DESIGN/objects/xvroutine/cantata/uis/variables.subform",
  "$DESIGN/objects/xvroutine/cantata/uis/distcomp.subform",
  "$DESIGN/objects/xvroutine/cantata/uis/preferences.subform",
  "$DESIGN/objects/xvroutine/cantata/uis/encap.subform",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	266,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	6,
	512};


