 /*
  * Khoros: $Id: composer.c,v 1.19.2.2 1997/05/31 18:32:21 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: composer.c,v 1.19.2.2 1997/05/31 18:32:21 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for composer
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "composer.h"

clui_info_struct *clui_info = NULL;

gui_info_struct *gui_info;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Software object creation and management
|
|       Purpose: main program for composer
|
|         Input:
|		char *clui_info->tb_string; {toolbox name}
|		int   clui_info->tb_flag; {TRUE if -tb specified}
|
|		char *clui_info->oname_string; {object name}
|		int   clui_info->oname_flag; {TRUE if -oname specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

	kform  *form;            /* form tree representing UIS        */
	char   *form_fullpath;   /* for use when [-form] is specified */
/* -main_variable_list */
   char *opath;
   char *bpath;
/* -main_variable_list_end */

	khoros_init(argc, argv, "DESIGN", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$DESIGN/objects/xvroutine/composer");
	kexit_handler(composer_free_args, NULL);

/* -main_get_args_call */
	kclui_init("DESIGN", "composer", KGEN_XVROUTINE,  &clui_uis_spec,
		   composer_usage_additions, composer_get_args,
 		   composer_free_args);
/* -main_get_args_call_end */

	/*
	 * Initialize xvwidgets lib
	 */
	if (!(xvw_initialize(XVW_MENUS_XVFORMS)))
	{
	     kinfo(KSTANDARD, "Could not open connection to server");
	     kexit(KEXIT_FAILURE);
	}

	/*
	 * Allocate the GUI Info structure 
	 */
	gui_info = (gui_info_struct *)
				kcalloc ((size_t) 1, sizeof(gui_info_struct));
	/*
	 * Create the forms for composer 
	 */
	if (clui_info->form_flag)
	{
	    form_fullpath   = kfullpath(clui_info->form_file, NULL, NULL);
	    form = xvf_create_form(form_fullpath, KNONE, run_composer, gui_info,
				clui_info->x_int, clui_info->y_int,
				XVF_PARTIAL_EDIT);
	    kfree_and_NULL(form_fullpath);
	}
	else
	{
	    form = xvf_build_form(&gui_uis_spec, KNONE, run_composer, gui_info,
				clui_info->x_int, clui_info->y_int,
				XVF_PARTIAL_EDIT);
	}
	if (form == NULL)
	   kexit(KEXIT_FAILURE);

	/*
	 * Initialize the GUI Info structure 
	 */
	if (!(_xvf_init_composer(form, gui_info)))
	    kexit(KEXIT_FAILURE);

/* -main_before_lib_call */
   if ((cmsToolbox = kcms_open_toolbox(clui_info->tb_string)) == NULL)
   {
      kerror(NULL, "Open Toolbox", "Unable to open toolbox `%s'.",
             clui_info->tb_string);
      kexit(KEXIT_FAILURE);
   }

   cmsObject = kcms_open_cmobj(cmsToolbox, clui_info->oname_string);
   if (cmsObject == NULL)
   {
      kcms_close(cmsToolbox);
      kerror(NULL, "Open Object",
             "Unable to open object `%s' in toolbox `%s'.",
             clui_info->oname_string,
             clui_info->tb_string);
      kexit(KEXIT_FAILURE);
   }

   kcms_get_attributes(cmsObject, KCMS_CMOBJ_OPATH, &opath,
                       KCMS_CMOBJ_BUILDPATH, &bpath, NULL);
   cmobj_opath = kstrdup(opath);
   cmobj_buildpath = kstrdup(bpath);

   if (!initialize())
   {
      kinfo(KSTANDARD, "initialize failed for composer");
      kexit(KEXIT_FAILURE);
   }
   /* Ignore SIGCHLD signals.  On most systems, this will
      prevent child processes from becoming zombies when they
      exit and are not waited on.  The exception is 4.3+BSD.
   */
   ksignal(SIGCHLD, SIG_IGN);
/* -main_before_lib_call_end */

/* -main_library_call */
   xvf_run_form();
/* -main_library_call_end */

/* -main_after_lib_call */
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: composer_usage_additions
| 
|       Purpose: Prints usage additions in composer_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname composer
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void composer_usage_additions(void)
{
	kfprintf(kstderr, "\tSoftware object creation and management\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: composer_free_args
| 
|       Purpose: Frees CLUI struct allocated in composer_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname composer
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
composer_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->tb_string);
		kfree_and_NULL(clui_info->oname_string);
		kfree_and_NULL(clui_info->form_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
