/*
 * Khoros: $Id: do_add_pane.c,v 1.6 1997/01/20 05:36:12 mirage Exp $
 */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: do_add_pane.c,v 1.6 1997/01/20 05:36:12 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>         Routine for adding a new file to an object
   >>>> 
   >>>>  Private: 
   >>>>         add_pane_add()
   >>>>         add_pane_add_file()
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "composer.h"

/*-----------------------------------------------------------
| Routine Name:	add_pane_add
| 
| Purpose:	Do routine which is called when
|		pane action button add is used
| 
| Input:	add_pane_info - ptr to PaneInfo struct for add_pane pane
| Written By:	Neil Bowers
| Date:		19-dec-93
------------------------------------------------------------*/
void
add_pane_add(
   addfile_add_pane * add_pane_info)
{
   if(add_pane_info->new_file_optsel){
    add_file_object(add_pane_info->new_file);
  } else {
    add_existing_file_object(add_pane_info->existing_file);
  }
}

/*-----------------------------------------------------------
|
|  Routine Name: add_pane_new_file
|
|       Purpose: Do routine which is called when
|                  string selection new_file is used
|
|         Input: add_pane_info - ptr to PaneInfo struct for add_pane pane
|
|        Output: None
|    Written By: Neil Bowers
|          Date: 19-dec-93
|
------------------------------------------------------------*/
/* ARGSUSED */
void add_pane_new_file(
     addfile_add_pane *add_pane_info)
{
   add_file_object(add_pane_info->new_file);
}

/*-----------------------------------------------------------
|
|  Routine Name: add_pane_existing_file
|
|       Purpose: Do routine which is called when
|                  input selection existing_file is used
|
|         Input: add_pane_info - ptr to PaneInfo struct for add_pane pane
|
|        Output: None
|    Written By: George Ruban
|          Date: Oct 03, 1995
| Modifications:
|
------------------------------------------------------------*/
/* ARGSUSED */
void add_pane_existing_file(
     addfile_add_pane *add_pane_info)
{
   add_existing_file_object(add_pane_info->existing_file);
}
 
/*-----------------------------------------------------------
| Routine Name:	add_pane_add_file
| 
| Purpose:	Do routine which is called when
|		string selection add_file is used
| 
| Input:	add_pane_info - ptr to PaneInfo struct for add_pane pane
| 
| Written By:	Neil Bowers
| Date:		19-dec-93
------------------------------------------------------------*/
void
add_pane_add_file(
   addfile_add_pane * add_pane_info)
{
   add_file_object(add_pane_info->new_file);
}
