/*
 * Khoros: $Id: do_printpane.c,v 1.6 1997/01/20 05:36:21 mirage Exp $
 */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: do_printpane.c,v 1.6 1997/01/20 05:36:21 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Functionality routines for pane printpane
   >>>> 
   >>>>  Private: 
   >>>> 	printpane_print
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "composer.h"

/*-----------------------------------------------------------
| Routine Name:	printpane_print - handler routine for Print button
| 
| Purpose:	This function is called when the user hits the Print
|		button on the "Print File" subform.
| 
| Input:	printpane_info - ptr to PaneInfo struct for printpane pane
| 
| Written By:	Neil Bowers
| Date:		17-oct-94
------------------------------------------------------------*/
void
printpane_print(
   printfile_printpane *printpane_info)
{
   kstring  routine = "Print File";
   char     buffer[KLENGTH];
   char *   filepath = NULL;
   char     fullpath[KLENGTH];
   char     dirpath[KLENGTH];
   char     fbasename[KLENGTH];


   if (cur_fileobj == NULL)
      kerror(NULL, routine,
	     "No file selected.  You shouldn't see this error.");
   else if (printpane_info->printcmd_optsel)
   {
      /*-- export PRINTER variable before running command --*/
      if (printpane_info->printer != NULL)
      {
	 ksprintf(buffer, "PRINTER=%s", printpane_info->printer);
	 if (kputenv(buffer) != 0)
	    kwarn(NULL, "Print File",
		  "Failed to set the PRINTER variable "
		  "File may appear in a strange place.");
      }
      
      if (!kcms_get_attribute(cur_fileobj, KCMS_FOBJ_FULLNAME, &filepath)
	  || filepath == NULL)
	 return;

      if (kfullpath(filepath, NULL, fullpath) == NULL)
	 return;

      if (kdirname(fullpath, dirpath) == NULL ||
	  kbasename(fullpath, fbasename) == NULL)
	 return;

      ksprintf(buffer, "cd %s; %s %s", dirpath,
	       printpane_info->printcmd, fbasename);
      if (xvw_system(buffer) != 0)
      {
	 kinfo(KFORCE, "Attempt to print file failed. Command used:\n"
	       "\n\t%s\n\n"
	       "You may want to check the print queue.", buffer);
      }
      else
      {
	 kinfo(KFORCE, "File printed successfully.");
      } 
   }
   else
   {
      print_file_object(cur_fileobj);
   }
}


