 /*
  * Khoros: $Id: usage.c,v 1.15.2.3 1997/05/31 18:32:34 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.3 1997/05/31 18:32:34 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "composer.h"
/*-----------------------------------------------------------
| 
|  Routine Name: composer_get_args
| 
|       Purpose: Gets command line args for composer
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname composer
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void composer_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for composer is out of sync with arguments specified in composer's *.pane file; please rerun ghostwriter on composer.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the composer structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "composer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "composer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "composer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "composer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "composer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 10x10+10+20 +0+0 'CANTATA' cantata",
  "-M 1 1 1x1+0+0 +1+0 'Software object creation and management' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' composer",
  "-a 1 0 7x1+0+0 'Options' 'Pull down menu of cantata pane options' options",
  "-R 1 0 1 5x1+38+0 'Run' 'execute composer' $DESIGNBIN/composer",
  "-H 1  5x1+45+0 'Help' 'help page for composer' $DESIGN/objects/xvroutine/composer/help/composer.hlp help",
  "-Q 1 0 5.5x1+51+0 'Close'",
  "-s 1 0 0 1 0 54.5x1+2+2 ' ' 'Toolbox Name' 'toolbox name' tb",
  "-s 1 0 0 1 0 54.5x1+2+3.5 ' ' 'Object Name' 'object name' oname",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DESIGN/objects/xvroutine/composer/uis/composer.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	12,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 49x13+10+15 +17+-1 'Composer: software object editor' composer",
  "-S 1 0",
  "-b +1+12 'Editing software object ...' status",
  "-D 1 0 9.25x1+1+0.5 'Options' options",
  "-H 1  11x1+1+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-H 1  6x1+34+0.5 'Help' 'COMPOSER Overview Help' $DESIGN/objects/xvroutine/composer/help/Overview.doc help",
  "-Q 1 0 6x1+42+0.5 'Quit'",
  "-T 1 0 0 1 1 7.75x8+2+2 +0+0 1 'List Files' 'comment' file_type",
  "-t 1 0 1 1 0 6.125x1+1+1 'UIS' 'uis files' uis",
  "-t 1 0 1 0 0 6.125x1+1+2 'SOURCE' 'src files' src",
  "-t 1 0 1 0 0 6.125x1+1+3 'DOC' 'doc files' doc",
  "-t 1 0 1 0 0 6.125x1+1+4 'CONFIG' 'config files' config",
  "-t 1 0 1 0 0 6.125x1+1+5 'INFO' 'info files' info",
  "-t 1 0 1 0 0 6.125x1+1+6 'APP-DEFAULTS' 'app-defaults files' appdefaults",
  "-t 1 0 1 0 0 6.125x1+1+7 'PIXMAPS' 'pixmap files' pixmaps",
  "-t 1 0 1 0 0 6.125x1+1+8 'MISC' 'misc files' misc",
  "-t 1 0 1 0 0 6.125x1+1+9 'ALL' 'all files' all",
  "-E",
  "-z 1 0 0 1 1 23x9+15+2 0 1 0 1 'Files' 'scrolled list for files in object' filelist",
  "-a 1 0 13x1+39+3 'Save' 'save software object (sync)' save",
  "-a 1 0 13x1+39+7.5 'Shell' 'spawn a shell in tty' spawntty",
  "-D 1 0 22.5x1+15+11 'File Operations' fileops",
  "-a 1 0 13x1+0+0 '           ' 'spawn a special editor' interactive",
  "-a 1 0 13x1+0+1 '           ' 'invoke an ascii editor' edit",
  "-a 1 0 13x1+0+2 '           ' 'view the file as ascii text, read only' view",
  "-d 1 0 28x1+0+3 'Add File to Object' addfile",
  "-d 1 0 28x1+0+4 'Copy Selected File' copyfile",
  "-a 1 0 11x1.5+0+4 'Delete Selected File' 'delete currently selected file' rmfile",
  "-d 1 0 28x1+0+5 'Rename Selected File' renamefile",
  "-d 1 0 28x1+0+6 'Print Selected File' printfile",
  "-E",
  "-b +17+0 'pixmap:$DESIGN/objects/xvroutine/composer/pixmaps/composer.xpm' pixmap",
  "-d 1 0 13x1+39+4.5 'Attributes' obj_attributes",
  "-d 1 0 13x1+39+6 'Commands' logform",
  "-E",
  "@-k $DESIGN/objects/xvroutine/composer/uis/addfile.subform",
  "@-F 4.3 1 1 55x7.5+10+15 +14+0.5 'Composer: Khoros Object Editor' composer",
  "-M 1 1 50x7.5+0+0 +25+0.5 'File Utilities' addfile",
  "-P 1 0 50.25x7.5+0+0 +1+2 'Create a new file or copy an existing file to object' add_pane",
  "-H 1  6x1+35+0.5 'Help' 'display online help' $DESIGN/objects/xvroutine/composer/help/FileUtilities/add.doc help",
  "-Q 1 0 6x1+43+0.5 'Close'",
  "-a 1 0 8x1.5+41+5.5 'Add File' 'add file' add",
  "-C 1",
  "-s 1 0 1 1 1 48x1+1+3.5 ' ' 'File To Add' 'file to add' new_file",
  "-I 1 0 1 0 0 0 48x1+1+4.5 ' ' 'Existing File' 'already existing file to add' existing_file",
  "-E",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/composer/uis/copy.subform",
  "@-F 4.3 1 1 55x14.5+10+15 +14+0.5 'Composer: Khoros Object Editor' composer",
  "-M 1 1 50x8+0+0 +25+0.5 'File Utilities' copyfile",
  "-P 1 0 50x6+0+0 +2+1 'Copy currently selected file within object' copy_pane",
  "-H 1  6x1+35+1 'Help' 'display online help' $DESIGN/objects/xvroutine/composer/help/FileUtilities/copy.doc help",
  "-Q 1 0 6x1+43+1 'Close'",
  "-s 1 0 0 1 1 44.75x1+2+4 ' ' 'New Name' 'copy to' copy_to",
  "-a 1 0 11x1.5+38+6 'Copy File' 'copy the file' copy",
  "-b +2+2.5 'File :' fileblank",
  "-b +8+2.5 ' ' filename",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/composer/uis/rename.subform",
  "@-F 4.3 1 1 55x14.5+10+15 +14+0.5 'Composer: Khoros Object Editor' composer",
  "-M 1 1 50x8+0+0 +25+0.5 'File Utilities' renamefile",
  "-P 1 0 50x8+0+0 +6+0.5 'Rename currently selected file' rename_pane",
  "-H 1  6x1+35+0.5 'Help' 'display online help' $DESIGN/objects/xvroutine/composer/help/FileUtilities/rename.doc help",
  "-Q 1 0 6x1+43+0.5 'Close'",
  "-s 1 0 0 1 1 44.75x1+2+4 ' ' 'New Name' 'rename to' rename_to",
  "-a 1 0 11x1.5+38+6 'Rename File' 'rename file' rename",
  "-b +2+2.5 'File :' fileblank",
  "-b +8+2.5 ' ' filename",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/composer/uis/print.subform",
  "@-F 4.3 1 1 55x14.5+10+15 +14+0.5 'Composer: Khoros Object Editor' composer",
  "-M 1 1 52x10.5+0+0 +25+0.5 'File Utilities' printfile",
  "-P 1 0 52x10.5+0+0 +20+0.5 'Print File' printpane",
  "-H 1  6x1+37+0.5 'Help' 'display online help' $DESIGN/objects/xvroutine/composer/help/FileUtilities/print.doc help",
  "-Q 1 0 6x1+45+0.5 'Close'",
  "-s 1 0 0 1 0 30.75x1+2+4.5 ' ' 'Printer' 'name of printer' printer",
  "-s 1 0 1 0 0 49.25x1+2+6.5 ' ' 'Print Command' 'command to use for printing' printcmd",
  "-a 1 0 10x1.5+41+8.5 'Print File' 'invoke printing command' print",
  "-b +2+2 'File :' baselabel",
  "-b +2+3 'Path :' pathlabel",
  "-b +8+2 'basename' basename",
  "-b +8+3 'fullpath' fullpath",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/composer/uis/attributes.subform",
  "@-F 4.3 1 1 50x17.5+10+15 +14+0.5 'Craftsman: Khoros Object Editor' objAttributes",
  "-M 1 1 4x5+17.5+5 +21+0.5 'Software Object Attributes' obj_attributes",
  "-G 1 15x14+0+1 +21+0.5 ' '",
  "-H 1  6x1+52+0.5 'Help' 'display online help' $DESIGN/objects/xvroutine/composer/help/change-attributes.doc help",
  "-Q 1 0 6x1+60+0.5 'Close'",
  "-g 1 1 10x1+1+2 'Strings' obj_attrs",
  "-g 1 0 10x1+1+3.5 'Keywords' obj_keywords",
  "-g 1 0 10x1+1+5 'Pane' paneattrs",
  "-E",
  "-P 1 0 55.75x19.5769+12+2 +14+0.5 'Change Object Attributes' obj_attrs",
  "-H 1  6x1+48+0.5 'Help' 'Help for Change Object' $DESIGN/objects/xvroutine/composer/help/strings.doc help",
  "-s 1 0 0 1 0 50.75x1+2+6.5 ' ' ' ' 'short description of object' description",
  "-y 1 0 0 1 0 43.5x1+2+8 0 1 ' Category  ' 'category' category",
  "-y 1 0 0 1 0 43.5x1+2+9 0 1 'Subcategory' 'subcategory' subcategory",
  "-s 1 0 0 1 0 43.5x1+2+10.5 ' ' 'Icon Name  ' 'name for icon or glyph' icon_name",
  "-s 1 0 0 1 0 43.5x1+2+11.5 ' ' 'Binary Name' 'binary name for software object' binary_name",
  "-s 1 0 0 1 0 40.25x1+4+14 ' ' 'Name    ' 'name of object author' name",
  "-s 1 0 0 1 0 40.25x1+4+15 ' ' 'Email   ' 'email address of object author' email",
  "-T 1 0 0 1 0 35.375x1+2+16.5 +0+0 1 'Install in Cantata?' 'install in cantata' install_in_cantata",
  "-t 1 0 1 1 0 4.5x1+24+0 'No' 'not installed' notin",
  "-t 1 0 1 0 0 5x1+30+0 'Yes' 'installed' in",
  "-E",
  "-a 1 0 13x1.5+41+17.5 'Apply Changes' ' ' apply",
  "-b +2+2 'Toolbox     :' tblabel",
  "-b +2+3 'Object      :' onamelabel",
  "-b +13+2 ' ' tb",
  "-b +13+3 ' ' oname",
  "-b +2+13 'Point of Contact:' authlabel",
  "-b +2+4 'Object Type :' otypelabel",
  "-b +13+4 ' ' otype",
  "-b +2+5.5 'Short Description of Object:' descblank",
  "-E",
  "-P 1 0 55x19.5+12+2 +0+0 ' ' obj_keywords",
  "-z 1 0 0 1 1 38.5x13+2+0.5 0 1 0 0 'Keyword List' 'display list containing toolbox keywords' keylist",
  "-H 1  5x1+49+0.5 'Help' 'online help page' $DESIGN/objects/xvroutine/composer/help/keywords.doc help",
  "-a 0 0 20x1+2+14 'Delete Selected Keyword' 'button to delete selected keyword' del",
  "-s 1 0 0 1 1 51x1+2+15.5 ' ' 'Add a new Keyword      ' 'string selection for keyword to add' addkey",
  "-s 0 0 0 1 1 51x1+2+17 ' ' 'Change Selected Keyword' 'change selected keyword' chkey",
  "-E",
  "-P 1 0 55x19.5+12+2 +17+0.5 'Attributes of Pane Objects' paneattrs",
  "-H 1  6x1+48+0.5 'Help' 'online help page' $DESIGN/objects/xvroutine/composer/help/pane-attributes.doc help",
  "-s 1 0 0 1 0 22x1+4+4 ' ' 'Toolbox:' 'name of toolbox' tbname",
  "-s 1 0 0 1 0 22x1+27+4 ' ' 'Object: ' 'name of object in toolbox' oname",
  "-s 1 0 0 1 0 45x1+4+5.5 ' ' 'Args:   ' 'name of object in toolbox' args",
  "-T 1 0 0 1 0 35x1+2+7.5 +0+0 1 'Generate Executable?' 'generate a script for the pane object?' genexec",
  "-t 1 0 1 1 0 5x1+24+0 'No' 'not installed' notin",
  "-t 1 0 1 0 0 5x1+30+0 'Yes' 'installed' in",
  "-E",
  "-a 1 0 12x1.5+42+17.5 'Apply Changes' ' ' apply",
  "-b +2+3 'Associated Kroutine:' assoclabel",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/composer/uis/logging.subform",
  "@-F 4.3 1 1 50x17.5+10+15 +14+0.5 'Composer: Khoros Object Editor' composer",
  "-M 1 1 70x17.5+0+0 +28+0 'Commands' logform",
  "-P 1 0 58x17.5+0+0 +28+0 'Commands ' logging",
  "-a 1 0 6x1+40+0 'Clear' 'clear the output log' clear",
  "-H 1  6x1+47+0 'Help' 'display online help' $DESIGN/objects/xvroutine/composer/help/commands.doc help",
  "-Q 1 0 6x1+54+0 'Close'",
  "-a 1 0 22x1+0+1.5 'Generate Code' ' ' gen_code",
  "-t 1 0 1 1 0 6.875x1+23+1.5 'Force?' 'force code generation -- no prompting' force",
  "-D 1 0 11x1+34+1.5 'Make ...' make",
  "-n 1 0 12x1.5+1+15 'make' ' ' make_target",
  "-n 1 0 12x1.5+1+16 'make install' ' ' make_install",
  "-n 1 0 12x1.5+1+17 'make Imakefile' ' ' make_Imakefile",
  "-n 1 0 12x1.5+1+18 'make Makefile' ' ' make_Makefile",
  "-n 1 0 12x1.5+1+19 'make klint' ' ' make_klint",
  "-n 1 0 12x1.5+1+20 'make struct' ' ' make_kgenstruct",
  "-n 1 0 12x1.5+1+21 'make clean' ' ' make_clean",
  "-E",
  "-D 1 0 11x1+46+1.5 'Make Library' make_lib",
  "-n 1 0 12x1.5+1+15 'make' ' ' lib_make_target",
  "-n 1 0 12x1.5+1+16 'make install' ' ' lib_make_install",
  "-n 1 0 12x1.5+1+17 'make Imakefile' ' ' lib_make_Imakefile",
  "-n 1 0 12x1.5+1+18 'make Makefile' ' ' lib_make_Makefile",
  "-n 1 0 12x1.5+1+19 'make klint' ' ' lib_make_klint",
  "-n 1 0 12x1.5+1+20 'make struct' ' ' lib_make_kgenstruct",
  "-n 1 0 12x1.5+1+21 'make clean' ' ' lib_make_clean",
  "-E",
  "-w 480x297+0+3 'general-purpose workspace' workspace",
  "-s 1 0 0 1 1 60x1+0+17 ' ' 'Grep:' 'enter text to grep for' grep",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,0,1,2,3,
  4,5,6,7,8,9,10,11,12,0,1,2,3,4,5,6,7,8,9,10,
  11,0,1,2,3,4,5,6,7,8,9,10,11,0,1,2,3,4,5,6,
  7,8,9,10,11,12,13,14,0,1,2,3,4,5,6,7,8,9,10,11,
  12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
  32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,
  52,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,
  19,20,21,22,23,24,25,26,27,28,29,30,43,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,
  1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,
  2,3,3,3,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,
  4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,6,6,6,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$DESIGN/objects/xvroutine/composer/uis/composer.form",
  "$DESIGN/objects/xvroutine/composer/uis/addfile.subform",
  "$DESIGN/objects/xvroutine/composer/uis/copy.subform",
  "$DESIGN/objects/xvroutine/composer/uis/rename.subform",
  "$DESIGN/objects/xvroutine/composer/uis/print.subform",
  "$DESIGN/objects/xvroutine/composer/uis/attributes.subform",
  "$DESIGN/objects/xvroutine/composer/uis/logging.subform",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	173,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	7,
	512};


