 /*
  * Khoros: $Id: do_dependencies.c,v 1.2.2.3 1997/04/29 22:43:16 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: do_dependencies.c,v 1.2.2.3 1997/04/29 22:43:16 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	$DESIGN/objects/xvroutine/craftsman/src/do_dependencies.c
   >>>> 
   >>>>  Private: 
   >>>> 	dependencies_deplist
   >>>> 	dependencies_del
   >>>> 	dependencies_adddep
   >>>>         dependencies_add
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "craftsman.h"
#include "kcms/private.h" /* for kcms_*_tb_dependency */

/*-----------------------------------------------------------
| 
|  Routine Name: dependencies_deplist
| 
|       Purpose: Do routine which is called when
|                  displaylist selection deplist is used
| 
|         Input: dependencies_info - ptr to PaneInfo struct for dependencies pane
| 
|        Output: None
|    Written By: Kevin Sullivan
|          Date: Jan 23, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void dependencies_deplist(
     tbattrs_dependencies *dependencies_info)
{
   xvf_set_attribute(dependencies_info->del_struct, XVF_ACTIVATE, TRUE);
}


/*-----------------------------------------------------------
| 
|  Routine Name: dependencies_del
| 
|       Purpose: Do routine which is called when
|                  pane action button delete is used
| 
|         Input: dependencies_info - ptr to PaneInfo struct for dependencies pane
| 
|        Output: None
|    Written By: Kevin Sullivan
|          Date: Jan 23, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void dependencies_del(
     tbattrs_dependencies *dependencies_info)
{
   int      selected;
   kstring  dependency;
 
   if (cmsToolbox == NULL)
      kerror(NULL, "dependencies_del", "You have not selected a toolbox.");
   else if ((selected = gui_info->tbattrs->dependencies->deplist) >= 0)
   {
      dependency = dependencies_info->deplist_label;
      kcms_delete_tb_dependency(cmsToolbox, dependency, FALSE);
      update_dependencies(cmsToolbox, NULL);
      xvf_set_attribute(dependencies_info->del_struct, XVF_ACTIVATE, FALSE);
      update_adddeplist();
   }
}


/*-----------------------------------------------------------
| 
|  Routine Name: dependencies_adddep
| 
|       Purpose: Do routine which is called when
|                  string selection adddep is used
| 
|         Input: dependencies_info - ptr to PaneInfo struct for dependencies pane
| 
|        Output: None
|    Written By: Kevin Sullivan
|          Date: Jan 23, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void dependencies_adddep(
     tbattrs_dependencies *dependencies_info)
{
   xvf_set_attribute(dependencies_info->add_struct, XVF_ACTIVATE, TRUE);
}

/*-----------------------------------------------------------
| 
|  Routine Name: dependencies_add
| 
|       Purpose: Do routine which is called when
|                  pane action button add is used
| 
|         Input: dependencies_info - ptr to PaneInfo struct for dependencies pane
| 
|        Output: None
|    Written By: 
|          Date: Feb 05, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void dependencies_add(
     tbattrs_dependencies *dependencies_info)
{
   kcms_add_tb_dependency(cmsToolbox, dependencies_info->adddep_label, FALSE);
   update_dependencies(cmsToolbox, NULL);
   update_adddeplist();
   xvf_set_attribute(dependencies_info->add_struct, XVF_ACTIVATE, FALSE);
}
