/* 
 * Khoros: $Id: do_move.c,v 1.8 1997/02/07 18:59:06 mirage Exp $
 */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: do_move.c,v 1.8 1997/02/07 18:59:06 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>         Functionality routines for pane move
   >>>> 
   >>>>  Private: 
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "craftsman.h"


/*-----------------------------------------------------------
| Routine Name:	move_domove - move software object to new toolbox
| 
| Purpose:	Do routine which is called when
|		pane action button domove is used
| 
| Input:	move_info - ptr to PaneInfo struct for move pane
| 
| Output:	None
| Written By:	Neil Bowers
| Date:		May 06, 1994
------------------------------------------------------------*/
/* ARGSUSED */
void
move_domove(
   mvobject_move * move_info)
{
   kstring       routine     = "Move Object";
   kobject       destination = NULL;
   kobject       object      = NULL;
   kobject       newobject   = NULL;
   char          desttbupper[KLENGTH];
   unsigned long otype;


   if (move_info->desttb_label != NULL)
      kstring_upper(move_info->desttb_label, desttbupper);

   if (strObject == NULL)
      kerror(NULL, routine,
	     "You have not selected a software object to move.");

   else if (move_info->desttb_label == NULL)
      kerror(NULL, routine, "You must specify a destination "
	     "toolbox to move the object into.");

   else if ((destination = kcms_open_toolbox(move_info->desttb_label)) == NULL)
      kerror(NULL, routine,
	     "Failed to open the destination toolbox `%s'.",
	     move_info->desttb_label);

   else if (!kprompt(KFORCE, "Yes", "No", FALSE,
		     "Operation: move software object to new toolbox\n\n"
		     "\tToolbox             : %s\n"
		     "\tObject              : %s\n"
		     "\tDestination Toolbox : %s\n\n"
		     "Do you want to continue?",
		     strToolbox, strObject, desttbupper))
   {
      kcms_close(destination);
      return;
   }
   else if ((object = kcms_open_cmobj(cmsToolbox, strObject)) == NULL)
      kerror(NULL, routine, "Can't open object \"%s\" in "
	     "toolbox \"%s\".", strObject, strToolbox);

   else if (kcms_get_attribute(object, KCMS_CMOBJ_PROGTYPE, &otype))
   {
      xvw_set_attribute(xvoNotifier, XVW_NOTIFYWINDOW_VISIBLE, TRUE);
      xvw_format_attribute(xvoNotifier, XVW_NOTIFYWINDOW_MESSAGE,
		     "Moving object `%s' from toolbox `%s' to toolbox `%s'",
			   strObject, strToolbox, desttbupper);

      if ((newobject = kcms_duplicate(object, destination)) != NULL
	  && kcms_close(newobject)
	  && kcms_set_bit(object, KCMS_CMOBJ_FLAGS, KCMS_BIT_CMOBJ_FORCE)
	  && kcms_destroy(object)
	  && kcms_sync(cmsToolbox))
      {
	 update_categories();

	 if (otype == KCMS_LIBRARY)
	    change_lib_list();
	 update_object_list();
	 select_object(NULL);
      }
      xvw_set_attribute(xvoNotifier, XVW_NOTIFYWINDOW_VISIBLE, FALSE);
   }

   if (destination != NULL)
      kcms_close(destination);
}
/*-----------------------------------------------------------
| 
|  Routine Name: move_desttb
| 
|       Purpose: Do routine which is called when
|                  displaylist selection desttb is used
| 
|         Input: move_info - ptr to PaneInfo struct for move pane
| 
|        Output: None
|    Written By: 
|          Date: Feb 06, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void move_desttb(
     mvobject_move *move_info)
{
	/* PUT YOUR CODE HERE ! */
}


