 /*
  * Khoros: $Id: usage.c,v 1.19.2.5 1997/05/31 18:33:06 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.19.2.5 1997/05/31 18:33:06 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "craftsman.h"
/*-----------------------------------------------------------
| 
|  Routine Name: craftsman_get_args
| 
|       Purpose: Gets command line args for craftsman
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname craftsman
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void craftsman_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for craftsman is out of sync with arguments specified in craftsman's *.pane file; please rerun ghostwriter on craftsman.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the craftsman structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "craftsman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "craftsman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "craftsman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "craftsman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "craftsman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 10x10+10+20 +0+0 'CANTATA' craftsman",
  "-M 1 1 1x1+0+0 +1+0 'Toolbox object creation and management' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' craftsman",
  "-a 1 0 7x1+0+0 'Options' 'Pull down menu of cantata pane options' options",
  "-R 1 0 1 5x1+35+0 'Run' 'execute craftsman' $DESIGNBIN/craftsman",
  "-H 1  5x1+41+0 'Help' 'help page for craftsman' $DESIGN/objects/xvroutine/craftsman/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 1 0 54.75x1+2+2 ' ' 'Toolbox Name' 'toolbox name' tb",
  "-s 1 0 1 1 0 54.75x1+2+3 ' ' 'Object Name' 'object name' oname",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DESIGN/objects/xvroutine/craftsman/uis/craftsman.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	12,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 49x13+0+0 +0+-1 'Craftsman: Software Development Environment' craftsman",
  "-S 1 0",
  "-D 1 0 9.25x1+1+0.5 'Options' options",
  "-H 1  10x1+1+0.5 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-d 1 0 10x1.5+84+1.5 'Preferences' preferences",
  "-d 1 0 10x1+50+4 'Console' console",
  "-E",
  "-H 1  6x1+34+0.5 'Help' 'help' $DESIGN/objects/xvroutine/craftsman/help/Overview.doc help",
  "-Q 1 0 6x1+42+0.5 'Quit'",
  "-z 1 0 0 1 1 22x9.2+1+2 0 0 -1 0 'Toolboxes' 'list of toolbox names' tblist",
  "-z 1 0 0 1 1 21.75x9.2+27+2 0 0 -1 1 '(no toolbox selected)' 'objects in toolbox' objlist",
  "-D 1 0 22x1+1+11.5 'Toolbox Operations' tbops",
  "-d 1 0 9x16+1+1 'Create Toolbox' newtb",
  "-d 1 0 23x1+1+2 'Add Toolbox Reference' tbaddref",
  "-d 0 0 20x1+1+3 'Toolbox Attributes' tbattrs",
  "-n 0 0 9x1+1+4 'Create Toolbox Manual' 'create manual' mkmanual",
  "-n 0 0 9x1+1+5 'Remove Toolbox Reference' 'remove tb from toolbox file(s)' dereftb",
  "-n 0 0 9x1+1+6 'Klint Toolbox' 'run klint on toolbox' klinttb",
  "-n 0 0 9x1+1+7 'Delete Toolbox' 'delete' rmtb",
  "-E",
  "-D 1 0 22x1+27+11.5 'Object Operations' objops",
  "-d 0 0 6x1+1+1 'Create Object' template1",
  "-n 0 0 5x1+1+2 'Edit Object (Composer)' 'open' open",
  "-d 0 0 5x1+1+3 'Object Attributes' obj_attributes",
  "-d 0 0 6x1+1+4 'Copy Object' copyobject",
  "-d 0 0 6x1+1+5 'Move Object' mvobject",
  "-d 0 0 6x1+1+7 'Rename Object' rename_obj",
  "-d 0 0 6x1+1+8 'Info Files' objinfo",
  "-n 0 0 9x1+1+9 'Klint Object' 'run klint on object' klintobj",
  "-n 0 0 6x1+1+10 'Delete Object' 'delete' del",
  "-E",
  "-b +17+0 'pixmap:$DESIGN/objects/xvroutine/craftsman/pixmaps/craftsman.xpm' pixmap",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/preferences.subform",
  "@-F 4.3 1 1 55x5+0+0 +0+-1 'Craftsman: Software Development Environment' craftsman",
  "-M 1 1 34x9+0+0 +0+0 'Preferences' preferences",
  "-P 1 0 34x9+0+0 +0+0.5 ' ' types",
  "-H 1  6x1.03846+19+0 'Help' 'online help page' $DESIGN/objects/xvroutine/craftsman/help/preferences.doc help",
  "-Q 1 0 6x1.03846+26+0 'Close'",
  "-T 1 0 0 1 1 14x7+1+1.5 +0+0 1 'Show Object Types' 'object type to show in objects list' objtypes",
  "-l 1 0 1 1 0 4.75x1+2+1 0 'all' 'False' 'TRUE' 'choice6' dummy",
  "-l 1 0 1 0 0 8.5x1+2+2 0 'kroutine' 'False' 'TRUE' 'choice1' dummy",
  "-l 1 0 1 0 0 9.125x1+2+3 0 'xvroutine' 'False' 'TRUE' 'choice2' dummy",
  "-l 1 0 1 0 0 5.5x1+2+4 0 'pane' 'False' 'TRUE' 'choice3' dummy",
  "-l 1 0 1 0 0 7.625x1+2+5 0 'library' 'False' 'TRUE' 'choice4' dummy",
  "-l 1 0 1 0 0 6.875x1+2+6 0 'script' 'False' 'TRUE' 'choice5' dummy",
  "-E",
  "-T 1 0 0 1 1 16.375x3+16+1.5 +0+0 1 '(Sub)Categories from' 'object type to show in objects list' cattype",
  "-l 1 0 1 1 0 4.75x1+2+1 0 'current toolbox' 'False' 'TRUE' 'choice6' dummy",
  "-l 1 0 1 0 0 8.5x1+2+2 0 'all toolboxes' 'False' 'TRUE' 'choice1' dummy",
  "-E",
  "-b +1+0 'Preferences' blank1",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/console.subform",
  "@-F 4.3 1 1 49x13+0+0 +0+-1 'Craftsman: Software Development Environment' craftsman",
  "-M 1 1 65x15+0+0 +15+0 'Console Window' console",
  "-P 1 0 -1x-1+0+0 +1+0 'Console Window  ' conspane",
  "-a 1 0 7x1.03846+40+0 'Clear' 'clear the console text widget' clear",
  "-H 1  6x1.03846+48+0 'Help' 'online help page' $DESIGN/objects/xvroutine/craftsman/help/console.doc help",
  "-Q 1 0 6x1.03846+55+0 'Close'",
  "-w 1x1+0+1.5 'general-purpose workspace' workspace",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/newtb.subform",
  "@-F 4.3 1 1 4x16.5+10+5 +1+1 'Creating a new toolbox' newToolbox",
  "-M 1 1 56.75x15+10+5 +23+0.5 'Create a New Toolbox' newtb",
  "-P 1 0 56.75x15+0+0 +1+0 'Create a New Toolbox' mktb",
  "-H 1  6x1+42+0 'Help' 'display online help' $DESIGN/objects/xvroutine/craftsman/help/toolbox/create.doc help",
  "-Q 1 0 6x1+49+0 'Close'",
  "-s 1 0 0 1 0 52x1+3+2.5 ' ' 'Toolbox Name ' 'name of new toolbox' tbname",
  "-s 1 0 0 1 0 52x1+3+3.5 ' ' 'Toolbox Path ' 'full path to top directory of new toolbox' tbpath",
  "-s 1 0 0 1 0 52x1+3+6 ' ' 'Toolbox Title' 'title string for new toolbox' tbtitle",
  "-s 1 0 0 1 0 52x1+3+8.5 ' ' 'Name      ' 'name of owner of new toolbox' name",
  "-s 1 0 0 1 0 52x1+3+9.5 ' ' 'Email     ' 'email address of owner of toolbox' email",
  "-T 1 0 0 1 0 41.625x2+1+11 +0+0 3 'Toolbox Status' 'comment' tbstatus",
  "-t 1 0 1 0 0 7.625x1+3+1 'Scratch' 'scratch toolbox' scratch",
  "-t 1 0 1 0 0 6.125x1+12+1 'Work' 'work toolbox' work",
  "-t 1 0 1 1 0 10.625x1+19+1 'Development' 'development toolbox' development",
  "-t 1 0 1 0 0 9.875x1+31+1 'Production' 'production toolbox' production",
  "-E",
  "-a 1 0 15x1+40+13.5 'Create Toolbox' 'button to invoke toolbox creation process' createtb",
  "-b +1+1.5 'Required Attributes' blank1",
  "-b +1+5 'Optional Attributes' blank2",
  "-b +1+7.5 'Toolbox Author' tbauthor",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/toolbox-addref.subform",
  "@-F 4.3 1 1 4x14+10+5 +1+1 'Toolbox Properties' tbAddReference",
  "-M 1 1 4x7.5+10+5 +20+0.5 'Add Toolbox Reference' tbaddref",
  "-P 1 0 48.25x7.15385+0+0 +1+0 'Add Toolbox Reference' addref",
  "-H 1  5x1.03846+35+0 'Help' 'display online help' $DESIGN/objects/xvroutine/craftsman/help/toolbox/attributes.doc help",
  "-Q 1 0 5.25x1.03846+41+0 'Close'",
  "-s 1 0 0 1 0 23x1+1+2.5 ' ' 'Name' 'name of toolbox to be added' tbname",
  "-s 1 0 0 1 0 45x1+1+4 ' ' 'Path' 'toolbox path' tbpath",
  "-a 1 0 21x1.11538+25+5.5 'Add Toolbox Reference' 'add reference to specified toolbox' addit",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/toolbox-attributes.subform",
  "@-F 4.3 1 1 4x10+10+5 +1+1 'Toolbox Properties' tbAttributes",
  "-M 1 1 4x10+10+5 +1+0 'Toolbox Attributes' tbattrs",
  "-G 1 15x13.5+0+1 +3+0.5 ' '",
  "-H 1  6x1+60+0 'Help' 'display online help' $DESIGN/objects/xvroutine/craftsman/help/toolbox/change-attributes.doc help",
  "-Q 1 0 6x1+67+0 'Close'",
  "-g 1 1 11x1.03846+0+2 'Strings' strings",
  "-g 1 0 11x1.03846+0+3.5 'Keywords' keywords",
  "-g 1 0 11x1.03846+0+5 'Dependencies' dependencies",
  "-g 1 0 11x1.03846+0+6.5 'Flags' flags",
  "-g 1 0 11x1.03846+0+8 'Copyright' copyright",
  "-g 1 0 11x1.03846+0+9.5 'Files' files",
  "-E",
  "-P 1 0 60x9+12+1.5 +1+0 'String Attributes' strings",
  "-H 1  6x1+53+0 'Help' 'display online help' $DESIGN/objects/xvroutine/craftsman/help/toolbox/attributes.doc help",
  "-s 1 0 0 1 0 57x1+1+2.5 ' ' 'Title      ' 'One-line title for the toolbox' tbtitle",
  "-s 1 0 0 1 0 55x1+3+4.5 ' ' 'Name    ' 'Real life name of toolbox author' authname",
  "-s 1 0 0 1 0 55x1+3+5.5 ' ' 'Email   ' 'email address of toolbox author' authemail",
  "-a 1 0 13x1+46+8 'Apply Changes' 'update toolbox properties' apply",
  "-b +1+3.5 'Toolbox Author' tbauthor",
  "-b +1+1.5 'Path:' pathlabel",
  "-b +13+1.5 '<toolbox-path>' tbpath",
  "-E",
  "-P 1 0 60x9+12+1.5 +1+0 'Toolbox Keywords' keywords",
  "-H 1  6x1+53+0 'Help' 'online help page' $DESIGN/objects/xvroutine/craftsman/help/toolbox/keywords.doc help",
  "-z 1 0 0 1 1 21x6.5+1+1 0 1 0 0 ' ' 'display list containing toolbox keywords' keylist",
  "-s 1 0 0 1 1 35x1+23+3 ' ' 'Add New Keyword' 'string selection for keyword to add' addkey",
  "-s 0 0 0 1 1 35x1+23+4.5 ' ' 'Change Selected' 'change selected keyword' chkey",
  "-a 0 0 21x1+1+8 'Delete Selected Keyword' 'button to delete selected keyword' del",
  "-E",
  "-P 1 0 60x9+12+1.5 +1+0 'Toolbox Dependencies' dependencies",
  "-H 1  6x1+53+0 'Help' 'online help page' $DESIGN/objects/xvroutine/craftsman/help/toolbox/dependencies.doc help",
  "-z 1 0 0 1 1 21x7+25+0.5 0 1 0 0 'Add New Dependency' 'string selection for keyword to add' adddep",
  "-z 1 0 0 1 1 21x6.5+1+1 0 1 0 0 ' ' 'display list containing toolbox dependencies' deplist",
  "-a 0 0 21x1+1+8 'Delete Selected Dependency' 'button to delete selected dependency' del",
  "-a 0 0 21x1+25+8 'Add Selected Dependency' 'button to add selected dependency' add",
  "-E",
  "-P 1 0 60x9+12+1.5 +1+0 'Toolbox Flags' flags",
  "-H 1  6x1+53+0 'Help' 'online help page' $DESIGN/objects/xvroutine/craftsman/help/toolbox/flags.doc help",
  "-T 1 0 0 1 0 16x1.5+1+1.5 +0+0 1 'Toolbox Status' 'comment' tbstatus",
  "-t 1 0 1 1 0 11x1+3+1 'Scratch' 'scratch toolbox' scratch",
  "-t 1 0 1 0 0 11x1+3+2 'Work' 'work toolbox' work",
  "-t 1 0 1 0 0 11x1+3+3 'Development' 'development toolbox' development",
  "-t 1 0 1 0 0 11x1+3+4 'Production' 'production toolbox' production",
  "-E",
  "-a 1 0 13x1+46+8 'Apply Changes' 'save changes to toolbox' flags_apply",
  "-E",
  "-P 1 0 60x9+12+1.5 +1+0 'Toolbox Copyright Statements' copyright",
  "-H 1  6x1+53+0 'Help' 'online help page' $DESIGN/objects/xvroutine/craftsman/help/toolbox/copyright.doc help",
  "-s 1 0 0 1 0 57x1+1+2.5 ' ' ' ' 'short copyright notice' short_copyright",
  "-s 1 0 0 1 0 57x3+1+4.5 ' ' ' ' 'long copyright notice' long_copyright",
  "-a 1 0 13x1+46+8 'Apply Changes' 'update toolbox properties' copyright_apply",
  "-b +1+1.5 'Short Copyright:' scblank",
  "-b +1+3.5 'Long Copyright:' lcblank",
  "-E",
  "-P 1 0 60x9.5+12+1.5 +1+0 'Toolbox Files' files",
  "-H 1  6x1+53+0 'Help' 'online help page' $DESIGN/objects/xvroutine/craftsman/help/toolbox/files.doc help",
  "-a 1 0 9x1+1+1.5 'Create' 'toolbox imake config file' config",
  "-a 1 0 9x1+1+2.5 'Create' 'create or edit toolbox include file' tbinclude",
  "-a 1 0 9x1+1+3.5 'Create' 'create or edit toolbox C++ include file' tbcppinclude",
  "-a 1 0 9x1+1+4.5 'Create' 'create or edit toolbox info file' tbinfo",
  "-a 1 0 9x1+1+5.5 'Create' 'create or edit toolbox aliases file' tbaliases",
  "-a 1 0 9x1+1+6.5 'Create' 'create or edit toolbox todo file' tbtodo",
  "-a 1 0 9x1+1+7.5 'Create' 'create or edit toolbox changelog file' tbchangelog",
  "-b +12+1.5 'Toolbox Imake configuration file' configblank",
  "-b +12+2.5 'Toolbox include file' incblank",
  "-b +12+3.5 'Toolbox C++ include file' inccppblank",
  "-b +12+4.5 'Toolbox description file' infoblank",
  "-b +12+5.5 'Toolbox aliases file' aliasblank",
  "-b +12+6.5 'Toolbox ToDo file' todoblank",
  "-b +12+7.5 'Toolbox ChangeLog file' changelogblank",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/template.subform",
  "@-F 4.3 1 1 50x20+15+3.5 +1+1 'Creating a new Software object' newObject",
  "-M 1 1 50x20+10+5 +15+15 'Create a New Object' template1",
  "-G 1 50x5+0+0 +0+0 ' '",
  "-H 1  6x1.03846+37+0 'Help' 'help' $DESIGN/objects/xvroutine/craftsman/help/object/create.doc help",
  "-Q 1 0 6x1.03846+44+0 'Close'",
  "-s 1 0 0 1 0 47x1+2+3 ' ' 'Object Name   ' 'object name' obj_name",
  "-s 1 0 0 1 0 47x1+2+4 ' ' 'Binary Name   ' 'binary name of the object' bname",
  "-s 1 0 0 1 0 47x1+2+5 ' ' 'Icon Name     ' 'icon or glyph name of object' icon_name",
  "-s 1 0 0 1 0 47x1+2+6 ' ' 'Author        ' 'name of object author' author",
  "-s 1 0 0 1 0 47x1+2+7 ' ' 'Email Address ' 'email address of object author' email",
  "-y 1 0 0 1 0 47x1+2+8 0 1 ' Category  ' 'category' category",
  "-y 1 0 0 1 0 47x1+2+9 0 1 'Subcategory' 'subcategory' subcategory",
  "-s 1 0 0 1 0 47x1+2+11 ' ' ' ' 'short description of object' description",
  "-b +1+0 'Creating new object in toolbox' blank2",
  "-b +2+10 'Short Description of Object:' descblank",
  "-g 1 1 9x1.03846+1+1.5 'Kroutine' kroutine",
  "-g 1 0 9x1.03846+11+1.5 'Xvroutine' xvroutine",
  "-g 1 0 9x1.03846+31+1.5 'Library' library",
  "-g 1 0 9x1.03846+41+1.5 'Script' script",
  "-g 1 0 9x1.03846+21+1.5 'Pane' pane",
  "-E",
  "@-p $DESIGN/objects/xvroutine/craftsman/uis/kroutine.pane",
  "@-F 4.3 1 1 52x24.5+15+3.5 +1+1 'Creating a new Kroutine object' newKroutine",
  "@-M 1 1 52x24.5+10+5 +7+0.5 ' ' template1",
  "-P 1 0 50.25x9.11539+0+12.5 +1+0 'Create a new Kroutine object' kroutine",
  "-H 1  6x1.03846+42+0 'Help' 'Help for Create Object' $DESIGN/objects/xvroutine/craftsman/help/object/create-kroutine.doc help",
  "-T 1 0 0 1 0 46.375x1+1+1.5 +0+0 1 'Generated Language?' 'what language is this routine written in?' lang",
  "-t 1 0 1 1 0 4x1+36+0 'C' 'Kroutine is in C' dummy",
  "-t 1 0 1 0 0 4.625x1+41+0 'C++' 'Kroutine is in C++' dummy",
  "-E",
  "-T 1 0 0 1 0 46.375x1+1+3 +0+0 1 'Install in Cantata?' 'install in cantata' incantata",
  "-t 1 0 1 1 0 4.375x1+36+0 'No' 'not installed' notin",
  "-t 1 0 1 0 0 5.125x1+41+0 'Yes' 'installed' in",
  "-E",
  "-T 1 0 0 1 1 46.375x1+1+4.5 +0+0 1 'Create Library Routine?' 'create associated library routine' lib_routine",
  "-t 1 0 1 1 0 4.5x1+36+0 'No' 'not installed' libno",
  "-t 1 0 1 0 0 5.125x1+41+0 'Yes' 'installed' libyes",
  "-E",
  "-y 0 0 0 1 1 33.25x1+2+6 1 1 'Library Name' 'library list' lib_list 'dummy'",
  "-a 1 0 15x1.03846+33+7.5 'Create KROUTINE' ' ' create_kroutine",
  "-E",
  "@-p $DESIGN/objects/xvroutine/craftsman/uis/xvroutine.pane",
  "@-F 4.3 1 1 52x24.5+15+3.5 +1+1 'Creating a new Xvroutine object' newXvroutine",
  "@-M 1 1 52x24.5+10+5 +6+0.5 ' ' template1",
  "-P 1 0 50x9.07692+0+12.5 +1+0 'Create a new Xvroutine object' xvroutine",
  "-H 1  6x1.03846+42+0 'Help' 'Help for Create Object' $DESIGN/objects/xvroutine/craftsman/help/object/create-xvroutine.doc help",
  "-T 1 0 0 1 0 46.375x1+1+1.5 +0+0 1 'Generated Language?' 'what language is this routine written in?' lang",
  "-t 1 0 1 1 0 4x1+36+0 'C' 'Kroutine is in C' dummy",
  "-t 1 0 1 0 0 4.625x1+41+0 'C++' 'Kroutine is in C++' dummy",
  "-E",
  "-T 1 0 0 1 0 46.375x1+1+3 +0+0 1 'Install in Cantata?' 'install in cantata' incantata",
  "-t 1 0 1 1 0 4.5x1+36+0 'No' 'not installed' notin",
  "-t 1 0 1 0 0 5.125x1+41+0 'Yes' 'installed' in",
  "-E",
  "-T 1 0 0 1 0 46.375x1+1+4.5 +0+0 2 'Graphical user interface?' 'Do you want a form with this xvroutine?' useform",
  "-t 1 0 1 0 0 4.5x1+36+0 'No' 'not installed' gui_no",
  "-t 1 0 1 1 0 5.125x1+41+0 'Yes' 'installed' gui_yes",
  "-E",
  "-a 1 0 15x1.03846+33+7.5 'Create XVROUTINE' ' ' create_xvroutine",
  "-E",
  "@-p $DESIGN/objects/xvroutine/craftsman/uis/library.pane",
  "@-F 4.3 1 1 52x24.5+15+3.5 +1+1 'Creating a new Library object' newLibrary",
  "@-M 1 1 52x24.5+10+5 +8+0.5 ' ' template1",
  "-P 1 0 50x9.07692+0+12.5 +1+0 'Create a new Library object' library",
  "-H 1  6x1.03846+42+0 'Help' 'Help for Create Object' $DESIGN/objects/xvroutine/craftsman/help/object/create-library.doc help",
  "-T 1 0 0 1 0 47x1+1+1.5 +0+0 1 'Language Dependency?' 'what language is this library written in?' lang",
  "-t 1 0 1 1 0 4x1+26+0 'C' 'Library is in C' dummy",
  "-t 1 0 1 0 0 4.625x1+32+0 'C++' 'Library is in C++' dummy",
  "-t 1 0 1 0 0 6x1+38+0 'Fortran' 'Library is in Fortran' dummy",
  "-E",
  "-a 1 0 15x1.03846+33+7.5 'Create LIBRARY' ' ' create_library",
  "-E",
  "@-p $DESIGN/objects/xvroutine/craftsman/uis/script.pane",
  "@-F 4.3 1 1 52x24.5+15+3.5 +1+1 'Creating a new script object' newScript",
  "@-M 1 1 52x24.5+10+5 +7+0.5 ' ' template1",
  "-P 1 0 50x9.07692+0+12.5 +1+0 'Create a new Script object' script",
  "-H 1  6x1.03846+42+0 'Help' 'Help for Create Object' $DESIGN/objects/xvroutine/craftsman/help/object/create-script.doc help",
  "-T 1 0 0 1 0 44.125x1+1+1.5 +0+0 1 'Scripting Language' 'what language is script written in?' lang",
  "-t 1 0 1 1 0 5.125x1+20+0 'csh' 'csh' csh",
  "-t 1 0 1 0 0 5.125x1+26+0 'sh' 'sh' sh",
  "-t 1 0 1 0 0 5.125x1+32+0 'ksh' 'ksh' ksh",
  "-t 1 0 1 0 0 5.375x1+38+0 'perl' 'perl' perl",
  "-E",
  "-T 1 0 0 1 0 31.375x1+1+3 +0+0 1 'Command-line UIS file?' 'do we create a .pane?' wantpane",
  "-t 1 0 1 1 0 4x1+20+0 'No' 'no UIS pane file' no",
  "-t 1 0 1 0 0 4.625x1+26+0 'Yes' 'we want a UIS pane file' yes",
  "-E",
  "-T 1 0 0 1 0 31.375x1+1+4.5 +0+0 1 'Install in Cantata?' 'install in cantata' incantata",
  "-t 1 0 1 1 0 4x1+20+0 'No' 'not installed' notin",
  "-t 1 0 1 0 0 4.625x1+26+0 'Yes' 'installed' in",
  "-E",
  "-a 1 0 15x1.03846+33+7.5 'Create SCRIPT' ' ' create_script",
  "-E",
  "@-p $DESIGN/objects/xvroutine/craftsman/uis/pane.pane",
  "@-F 4.3 1 1 52x24.5+15+3.5 +1+1 'Creating a new Pane object' newPane",
  "@-M 1 1 52x24.5+10+5 +7+0.5 ' ' template1",
  "-P 1 0 50x9+0+12.5 +1+0 'Create a new Pane object' pane",
  "-H 1  6x1.03846+42+0 'Help' 'Help for Create Pane' $DESIGN/objects/xvroutine/craftsman/help/object/create-pane.doc help",
  "-T 1 0 0 1 0 35.375x1+1+1.5 +0+0 1 'Install in Cantata?' 'install in cantata' incantata",
  "-t 1 0 1 1 0 5x1+24+0 'No' 'not installed' notin",
  "-t 1 0 1 0 0 5.125x1+30+0 'Yes' 'installed' in",
  "-E",
  "-T 1 0 0 1 0 35.375x1+1+2.5 +0+0 1 'Generate Executable?' 'generate a script for the pane object?' genexec",
  "-t 1 0 1 1 0 5x1+24+0 'No' 'not installed' notin",
  "-t 1 0 1 0 0 5x1+30+0 'Yes' 'installed' in",
  "-E",
  "-s 1 0 0 1 0 22x1+2+4.5 ' ' 'Toolbox:' 'name of toolbox' tbname",
  "-s 1 0 0 1 0 22x1+25+4.5 ' ' 'Object: ' 'name of object in toolbox' oname",
  "-s 1 0 0 1 0 45x1+2+6 ' ' 'Args:   ' 'name of object in toolbox' args",
  "-a 1 0 15x1.03846+33+7.5 'Create PANE' ' ' create_pane",
  "-b +1+3.5 'Associated Kroutine:' assoclabel",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/object-attributes.subform",
  "@-F 4.3 1 1 50x17.5+10+15 +14+0.5 'Craftsman: Khoros Object Editor' objAttributes",
  "-M 1 1 4x5+17.5+5 +1+0 'Software Object Attributes' obj_attributes",
  "-G 1 15x14+0+1 +0+0 ' '",
  "-H 1  6x1.03846+48+0 'Help' 'display online help' $DESIGN/objects/xvroutine/craftsman/help/object/change-attributes.doc help",
  "-Q 1 0 6x1.03846+55+0 'Close'",
  "-g 1 1 10x1.03846+1+2 'Strings' obj_attrs",
  "-g 1 0 10x1.03846+1+3.5 'Keywords' obj_keywords",
  "-g 1 0 10x1.03846+1+5 'Pane' paneattrs",
  "-E",
  "-P 1 0 49x18.6154+12+1.5 +1+0 'Change Object Attributes' obj_attrs",
  "-H 1  6x1+41+0 'Help' 'Help for Change Object' $DESIGN/objects/xvroutine/composer/help/strings.doc help",
  "-s 1 0 0 1 0 43x1+1+5.5 ' ' ' ' 'short description of object' description",
  "-y 1 0 0 1 0 43x1+1+7 0 1 ' Category  ' 'category' category",
  "-y 1 0 0 1 0 43x1+1+8 0 1 'Subcategory' 'subcategory' subcategory",
  "-s 1 0 0 1 0 43x1+1+9.5 ' ' 'Icon Name    ' 'name for icon or glyph' icon_name",
  "-s 1 0 0 1 0 43x1+1+10.5 ' ' 'Binary Name  ' 'binary name for software object' binary_name",
  "-s 1 0 0 1 0 42x1+2+13 ' ' 'Name    ' 'name of object author' name",
  "-s 1 0 0 1 0 42x1+2+14 ' ' 'Email   ' 'email address of object author' email",
  "-T 1 0 0 1 0 34x1+1+15.5 +0+0 1 'Install in Cantata?' 'install in cantata' install_in_cantata",
  "-t 1 0 1 1 0 4.5x1+24+0 'No' 'not installed' notin",
  "-t 1 0 1 0 0 5x1+30+0 'Yes' 'installed' in",
  "-E",
  "-a 1 0 13x1+34+17 'Apply Changes' ' ' apply",
  "-b +1+1.5 'Toolbox     :' tblabel",
  "-b +1+2.5 'Object      :' onamelabel",
  "-b +13+1.5 ' ' tb",
  "-b +13+2.5 ' ' oname",
  "-b +1+12 'Point of Contact:' authlabel",
  "-b +1+3.5 'Object Type :' otypelabel",
  "-b +13+3.5 ' ' otype",
  "-b +1+4.5 'Short Description of Object:' descblank",
  "-E",
  "-P 1 0 49x18.6154+12+1.5 +1+0 'Keyword List' obj_keywords",
  "-H 1  6x1+41+0 'Help' 'online help page' $DESIGN/objects/xvroutine/composer/help/keywords.doc help",
  "-z 1 0 0 1 1 30x12+1+1 0 1 0 0 ' ' 'display list containing toolbox keywords' keylist",
  "-a 0 0 30x1+1+13.5 'Delete Selected Keyword' 'button to delete selected keyword' del",
  "-s 1 0 0 1 1 45x1+1+15.5 ' ' 'Add a new Keyword      ' 'string selection for keyword to add' addkey",
  "-s 0 0 0 1 1 45x1+1+17 ' ' 'Change Selected Keyword' 'change selected keyword' chkey",
  "-E",
  "-P 1 0 49x18.6154+12+1.5 +1+0 'Attributes of Pane Objects' paneattrs",
  "-H 1  6x1+41+0 'Help' 'online help page' $DESIGN/objects/xvroutine/composer/help/pane-attributes.doc help",
  "-s 1 0 0 1 0 22x1+2+2.5 ' ' 'Toolbox:' 'name of toolbox' tbname",
  "-s 1 0 0 1 0 22x1+25+2.5 ' ' 'Object: ' 'name of object in toolbox' oname",
  "-s 1 0 0 1 0 45x1+2+3.5 ' ' 'Args:   ' 'name of object in toolbox' args",
  "-T 1 0 0 1 0 35x1+1+5 +0+0 1 'Generate Executable?' 'generate a script for the pane object?' genexec",
  "-t 1 0 1 1 0 5x1+24+0 'No' 'not installed' notin",
  "-t 1 0 1 0 0 5x1+30+0 'Yes' 'installed' in",
  "-E",
  "-a 1 0 13x1+34+17 'Apply Changes' ' ' apply",
  "-b +1+1.5 'Associated Kroutine:' assoclabel",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/copy-object.subform",
  "@-F 4.3 1 1 48x14.5+0+0 +0+-1 'Craftsman: Software Development Environment' craftsman",
  "-M 1 1 43x10+0+0 +0+0 'Copy' copyobject",
  "-P 1 0 43x10+0+0 +1+0 'Copy Object' copy",
  "-H 1  6x1+28+0 'Help' 'display online help' $DESIGN/objects/xvroutine/craftsman/help/object/copying.doc help",
  "-Q 1 0 6x1+35+0 'Close'",
  "-z 1 0 0 1 1 20x6.5+21+1.5 0 1 0 0 'Destination toolbox' 'which toolbox to copy to' desttb",
  "-a 1 0 20x1+21+8.5 'Copy Object' 'action button to do the copy' docopy",
  "-b +1+4 'Toolbox :' tblabel",
  "-b +1+5 'Object  :' olabel",
  "-b +9+4 '<toolbox-name>' tbname",
  "-b +9+5 '<object-name>' oname",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/move-object.subform",
  "@-F 4.3 1 1 58x14.5+0+0 +0+-1 'Craftsman: Software Development Environment' craftsman",
  "-M 1 1 43x10+0+0 +0+0 'Move' mvobject",
  "-P 1 0 43x10+0+0 +1+0 'Move Object' move",
  "-H 1  6x1.03846+28+0 'Help' 'display online help' $DESIGN/objects/xvroutine/craftsman/help/object/move.doc help",
  "-Q 1 0 6x1.03846+35+0 'Close'",
  "-z 1 0 0 1 1 20x6.5+21+1.5 0 1 0 0 'Destination toolbox' 'which toolbox to move object to' desttb",
  "-a 1 0 20x1+21+8.5 'Move Object' 'action button to do the move' domove",
  "-b +1+4 'Toolbox :' tblabel",
  "-b +1+5 'Object  :' olabel",
  "-b +9+4 '<toolbox-name>' tbname",
  "-b +9+5 '<object-name>' oname",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/rename-object.subform",
  "@-F 4.3 1 1 58x14.5+0+0 +0+-1 'Craftsman: Software Development Environment' craftsman",
  "-M 1 1 43x8+0+0 +0+0 'Rename' rename_obj",
  "-P 1 0 43x8.07692+0+0 +1+0 'Rename Software Object' rename",
  "-H 1  6x1.03846+28+0 'Help' 'display online help' $DESIGN/objects/xvroutine/craftsman/help/object/rename.doc help",
  "-Q 1 0 6x1.03846+35+0 'Close'",
  "-s 1 0 0 1 0 40x1+1+5 ' ' 'New Name' 'new name for object' newname",
  "-a 1 0 11.25x1.03846+30+6.5 'Rename Object' 'action button to do the move' dorename",
  "-b +1+2 'Toolbox :' tblabel",
  "-b +1+3 'Object  :' olabel",
  "-b +10+2 '<toolbox-name>' tbname",
  "-b +10+3 '<object-name>' oname",
  "-E",
  "-E",
  "@-k $DESIGN/objects/xvroutine/craftsman/uis/object-info.subform",
  "@-F 4.3 1 1 36x9+0+0 +0+-1 'Craftsman: Software Development Environment' craftsman",
  "-M 1 1 36x9+0+0 +0+0 'Info Files' objinfo",
  "-P 1 0 43x9.07692+0+0 +1+0 'Object information files' infopane",
  "-H 1  6x1.03846+28+0 'Help' 'display online help' $DESIGN/objects/xvroutine/craftsman/help/object/info.doc help",
  "-Q 1 0 6x1.03846+35+0 'Close'",
  "-a 1 0 8x1.03846+1+4.5 'Edit' 'edit the object todo file' todo",
  "-a 1 0 8x1.03846+31+4.5 'Create' 'create/delete the object todo file' crtodo",
  "-a 1 0 8x1.03846+1+5.5 'Edit' 'edit the object bugs file' bugs",
  "-a 1 0 8x1.03846+31+5.5 'Create' 'create/delete the object bugs file' crbugs",
  "-a 1 0 8x1.03846+1+6.5 'Edit' 'edit the object done file' done",
  "-a 1 0 8x1.03846+31+6.5 'Create' 'create/delete the object done file' crdone",
  "-a 1 0 8x1.03846+1+7.5 'Edit' 'edit the object changelog file' changelog",
  "-a 1 0 8x1.03846+31+7.5 'Create' 'create/delete the object changelog file' crchangelog",
  "-b +1+2 'Toolbox :' tblabel",
  "-b +1+3 'Object  :' olabel",
  "-b +11+2 '<toolbox-name>' tbname",
  "-b +11+3 '<object-name>' oname",
  "-b +12+4.5 'To Do File' todo_blank",
  "-b +12+5.5 'Bugs outstanding' bugs_blank",
  "-b +12+6.5 'Done' done_blank",
  "-b +12+7.5 'Change Log' changelog_blank",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,0,1,2,3,4,5,6,
  7,8,9,10,11,12,13,14,15,16,17,18,19,20,0,1,2,3,4,5,
  6,7,8,9,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
  16,17,18,19,20,21,22,0,1,2,3,4,5,6,7,8,9,10,0,1,
  2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,
  22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,
  42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,
  62,63,64,65,66,67,68,69,70,71,72,0,1,2,3,4,5,6,7,8,
  9,10,11,12,13,14,15,16,17,18,19,20,21,1,1,2,3,4,5,6,
  7,8,9,10,11,12,13,14,15,16,17,18,19,1,1,2,3,4,5,6,
  7,8,9,10,11,12,13,14,15,16,17,18,1,1,2,3,4,5,6,7,
  8,9,10,11,1,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
  16,17,18,19,20,1,1,2,3,4,5,6,7,8,9,10,11,12,13,14,
  15,16,17,18,27,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,
  15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,
  35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,0,1,
  2,3,4,5,6,7,8,9,10,11,12,13,0,1,2,3,4,5,6,7,
  8,9,10,11,12,13,0,1,2,3,4,5,6,7,8,9,10,11,12,13,
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,
  20,21,22,23,45,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,
  2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,
  3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
  5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
  6,6,6,6,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
  7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
  7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,8,8,
  8,8,8,8,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9,
  9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,10,10,
  11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,
  11,11,11,11,11,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$DESIGN/objects/xvroutine/craftsman/uis/craftsman.form",
  "$DESIGN/objects/xvroutine/craftsman/uis/preferences.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/console.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/newtb.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/toolbox-addref.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/toolbox-attributes.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/template.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/object-attributes.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/copy-object.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/move-object.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/rename-object.subform",
  "$DESIGN/objects/xvroutine/craftsman/uis/object-info.subform",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	405,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	12,
	512};


