 /*
  * Khoros: $Id: guise.h,v 1.15.2.2 1997/05/31 18:33:42 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for guise
   >>>> 
   >>>>    Written By: Danielle Argiro
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _guise_h_
#define _guise_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <design.h>
#include <xvinclude.h>
#include "form_info.h"

/* -include_includes */
#include "kcms/kcms.h"
#include "kutils/ksignal.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
#define EDITOR "vi"

#define TMPL_I  3 
#define TMPL_O  4 
#define TMPL_s  5 
#define TMPL_f  6 
#define TMPL_i  7 
#define TMPL_y  8 
#define TMPL_l  9 
#define TMPL_c  10
#define TMPL_x  11
#define TMPL_t  12
#define TMPL_a  13
#define TMPL_R  14
#define TMPL_Q  15
#define TMPL_H  16

#define EMPTY_FORM_UIS "$DESIGN/objects/library/xvforms/uis/xvf_edit/empty.form"
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Alternate UIS file (optional infile)
 */
char	*form_file;	/* Alternate UIS file FILENAME */
int	 form_flag;	/* Alternate UIS file FLAG */

/*
 *  (x,y) position for automatic GUI placement */

int	 x_int;		/* x position INT */
int	 x_flag;	/* x position FLAG */

int	 y_int;		/* y position INT */
int	 y_flag;	/* y position FLAG */

/*
 *  force output (optional flag)
 */
int	 force_flag;  	/* force output FLAG */

/*
 *  output UIS file (optional outfile)
 */
char	*o_file;	/* output UIS file FILENAME */
int	 o_flag;	/* output UIS file FLAG */

/*----- optional ME group ----*/
/*
 *  initial UIS file (optional infile)
 */
char	*i_file;	/* initial UIS file FILENAME */
int	 i_flag;	/* initial UIS file FLAG */

	/*---- nested optional MI group ----*/
/*
 *  toolbox (optional string)
 */
char	*tb_string;	/* toolbox STRING */
int	 tb_flag;   	/* toolbox FLAG */

/*
 *  object name (optional string)
 */
char	*oname_string;	/* object name STRING */
int	 oname_flag;   	/* object name FLAG */

/*
 *  UIS file to edit (do not include path) (optional string)
 */
char	*uis_string;	/* UIS file to edit (do not include path) STRING */
int	 uis_flag;   	/* UIS file to edit (do not include path) FLAG */

	/*-- nested optional MI group end --*/

/*-- optional ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
extern gui_info_struct *gui_info;

extern uis_struct gui_uis_spec;
/* -include_variables */
/* see globals.c */
extern int     editor_up;
extern int     force_output;
extern int     editor_pid;
extern int     save_needed;
extern char    *output_filename;
extern kform   *display_form;
extern int     save_control_dest;
extern kobject display_toolbox;
extern kobject display_program;
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void guise_get_args PROTO((kaddr));
void guise_usage_additions PROTO((void));
void guise_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* 
 * compare.c 
 */
int identical_output_file PROTO((char *));
int identical_forms       PROTO((kform *,      kform *));
int identical_subforms    PROTO((ksubform *,   ksubform *));
int identical_guides      PROTO((kguide *,     kguide *));
int identical_selections  PROTO((kselection *, kselection *));

/* 
 * create_util.c 
 */
kselection *create_new_selection   PROTO((kcontrol *, char *));
int         add_item_to_submenu    PROTO((kselection *, kform_struct *));
float       calculate_gb_position  PROTO((kcontrol *));
int         find_subform_num       PROTO((kform *));
char       *compose_pane_name      PROTO((void));
char       *compose_subform_name   PROTO((void));
char       *compose_sel_name       PROTO((kcontrol *, char *));

/* 
 * displayed.c 
 */
kcontrol *find_displayed_pane        PROTO((kform *));
kcontrol *find_displayed_control     PROTO((char *, char *, int, ksubform **,
					    kguide **, kcontrol **));
ksubform *find_displayed_subform     PROTO((kform *));

/* 
 * do_control.c 
 */
void run_display PROTO((kform *, ksubform *, kaddr));

/* 
 * gui_util.c 
 */
void set_save_needed                 PROTO((kform_struct *, char *,
                                            kaddr, kaddr));
void set_save_notneeded              PROTO((kform_struct *));
void adjust_gui_from_infile          PROTO((char *, options_create *));
void add_uis_misc_file               PROTO((kform_struct *, char *,
                                            kaddr, kaddr));
void add_save_needed_callback        PROTO((kform_struct *));
void install_gui_attribute_callbacks PROTO((void));

/* 
 * init.c 
 */
void guise_initialize     PROTO((void));
void put_gui_in_edit_mode PROTO((void));
void set_uis_directory    PROTO((char *));

/* 
 * run_guise.c 
 */
void run_guise PROTO((kform *, ksubform *, kaddr));

/* 
 * utilities.c 
 */
int       update_form                PROTO((xvobject, char *, kaddr)); 
int       display_empty_form         PROTO((char *));
int       output_display_form        PROTO((char *, int, char *));
void      reload_form                PROTO((char *, char *));
xvobject *get_selected_gui_items     PROTO((int *, kcontrol **, int*));
char     *check_all_variables        PROTO((void));
void 	  set_groupresize            PROTO((int));
/* -include_routines_end */

#endif
