 /*
  * Khoros: $Id: usage.c,v 1.16.2.3 1997/05/31 18:33:44 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.16.2.3 1997/05/31 18:33:44 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "guise.h"
/*-----------------------------------------------------------
| 
|  Routine Name: guise_get_args
| 
|       Purpose: Gets command line args for guise
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname guise
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void guise_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for guise is out of sync with arguments specified in guise's *.pane file; please rerun ghostwriter on guise.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the guise structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_flag(pane, "force",
			  &(clui_info->force_flag))))
	{
	    kerror(NULL, "guise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "guise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "guise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "guise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "guise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "uis",
			  &(clui_info->uis_string),
			  &(clui_info->uis_flag))))
	{
	    kerror(NULL, "guise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "guise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "guise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "guise_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Direct manipulation GUI design tool' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' create",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute guise' $DESIGNBIN/guise",
  "-H 1  5x1+41+0 'Help' 'display online help' $DESIGN/objects/xvroutine/guise/help/guise.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-t 1 0 1 0 0 15.125x1+22+8.5 'Force Over-Write?' 'force output' force",
  "-O 1 0 1 1 0 1 52x1+0+10.5 'new.pane' 'Output  UIS File' 'output UIS file' o",
  "-C 0",
  "-I 1 0 1 1 0 1 61.25x1+1+2 ' ' 'Initial UIS File' 'initial UIS file' i",
  "-B 0",
  "-s 1 0 1 0 0 61x1+1+3 ' ' 'Toolbox' 'toolbox' tb",
  "-s 1 0 1 0 0 61x1+1+4 ' ' 'Object Name' 'object name' oname",
  "-s 1 0 1 0 0 61x1+1+5 ' ' 'UIS file' 'UIS file to edit (do not include path)' uis",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DESIGN/objects/xvroutine/guise/uis/guise.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	22,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 70x3+0+0 +38+1 ' ' guise",
  "-M 1 1 70x10+0+0 +2+0 'Graphical User Interface Specification Editor (GUISE)' options",
  "-P 1 0 69x10+0+0 +29.5+0 ' ' create",
  "-b +17+0 'pixmap:$DESIGN/objects/xvroutine/guise/pixmaps/guise.xpm' pixmap",
  "-D 1 0 10x1+1+0 'Options' standard_options",
  "-H 1  10x1+0+0 'License' 'License' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-H 1  6x1+64+0 'Help' 'help' $DESIGN/objects/xvroutine/guise/help/guise.doc help",
  "",
  "-Q 1 0 6x1+71+0 'Quit'",
  "-I 1 0 0 1 1 1 77x1+0+1.5 ' ' 'Input UIS File  ' 'input UIS file' i",
  "-a 1 0 12.25x1.5+0+3 'Save' 'save' save",
  "-a 1 0 9x1.5+13+3 'Reload' 'reload' reload",
  "-a 1 0 13x1.5+23+3 'Edit Manually' 'edit manually' edit",
  "-a 1 0 10x1.5+37+3 'Start Fresh' 'start new gui' new1",
  "-D 1 0 11x1.5+49+3 'Options' options",
  "-a 1 0 10x1+78+8.5 'Copy' 'copy' copy",
  "-a 1 0 10x1+78+9.5 'Edit' 'display menuform' menuform",
  "-a 1 0 10x1+78+10.5 'Delete' 'delete' del",
  "-E",
  "-D 1 0 16x1.5+61+3 'Submenus, Groups' grouping",
  "-a 1 0 10x1+78+11.5 'Create Submenu' 'submenu' submenu",
  "-a 1 0 10x1+78+12.5 'Create ME Group (required)' 'create required ME group' me_group_req",
  "-a 1 0 10x1+78+13.5 'Create ME Group (optional)' 'create optional ME group' me_group_opt",
  "-a 1 0 10x1+78+14.5 'Create MI Group' 'group' mi_group",
  "-a 1 0 10x1+78+15.5 'Create Loose Group' 'group' ls_group",
  "-E",
  "-O 1 0 0 1 1 1 77x1+0+5 'new.form' 'Output  UIS File' 'output UIS file' o",
  "-l 1 0 0 1 1 29x1+0+6.5 1 'Force Over-Write?     ' 'No' 'Yes' 'force overwrite' force",
  "-l 1 0 0 1 1 38x1+39+6.5 1 'Move/Resize Multiple Panes Together?' 'False' 'True' 'resize multiple panes together' groupresize",
  "-T 1 0 0 1 1 45x1+0+8 +0+0 1 'Create Selection On:' 'selection dest' control_dest",
  "-i 1 0 1 1 0 5x1+18+0 0 0 8 0 0 'Pane' 'pane' dummy",
  "-i 1 0 1 0 0 10x1+25+0 0 0 7 0 0 'GuidePane' 'guidepane' dummy",
  "-i 1 0 1 0 0 10x1+35+0 0 0 6 0 0 'Master' 'master' dummy",
  "-E",
  "",
  "-D 1 0 19x1.5+0+9.5 'Simple Variables' simples",
  "-a 1 0 20x1+1+1 'Integer ' 'integer sel' int_sel",
  "-a 1 0 20x1+1+2 'Float   ' 'float sel' float_sel",
  "-a 1 0 20x1+1+3 'Double  ' 'double sel' double_sel",
  "-a 1 0 20x1+1+4 'String  ' 'string sel' string_sel",
  "-a 1 0 20x1+1+5 'Flag    ' 'flag sel' flag_sel",
  "-a 1 0 20x1+1+6 'Logical ' 'logical sel' logic_sel",
  "-E",
  "-D 1 0 19x1.5+21+9.5 'File Variables' files",
  "-a 1 0 20x1+1+1 'Input  File    ' 'infile sel' infile_sel",
  "-a 1 0 20x1+2+2 'Output File    ' 'outfile sel' outfile_sel",
  "-a 1 0 20x1+2+2 'Standard Input  ' 'stdin sel' stdin_sel",
  "-a 1 0 20x1+2+2 'Standard Output ' 'stdout sel' stdout_sel",
  "-E",
  "",
  "-D 1 0 20x1.5+42+9.5 'Buttons' buttons",
  "-a 1 0 20x1+1+1 'Action Button ' 'action button' action_button",
  "-a 1 0 20x1+1+2 'Routine Button' 'routine button' routine_button",
  "-a 1 0 20x1+1+3 'Help Button  ' 'help button' help_button",
  "-a 1 0 20x1+1+4 'Quit Button  ' 'quit button' quit_button",
  "-E",
  "-a 1 0 14x1.5+63+9.5 'New Pane' 'guide button' guide_button",
  "-D 1 0 19x1.5+0+11 'List Variables' lists",
  "-a 1 0 20x1+1+1 'Cycle     ' 'cycle sel' cycle_sel",
  "-a 1 0 20x1+1+2 'List      ' 'list sel' list_sel",
  "-a 1 0 20x1+1+3 'DisplayList' 'displaylist sel' displaylist_sel",
  "-a 1 0 20x1+1+4 'StringList' 'strlist sel' strlist_sel",
  "-E",
  "-D 1 0 19x1.5+21+11 'Toggle Variables' toggles",
  "-a 1 0 20x1+43+1 'Flag      ' 'flag toggle' flag_toggle",
  "-a 1 0 20x1+43+2 'Logical   ' 'logical toggle' logical_toggle",
  "-a 1 0 20x1+43+3 'Integer   ' 'integer toggle' int_toggle",
  "-a 1 0 20x1+43+4 'Float     ' 'float toggle' flt_toggle",
  "-a 1 0 20x1+43+5 'Double    ' 'double toggle' dbl_toggle",
  "-a 1 0 20x1+43+6 'String    ' 'string toggle' str_toggle",
  "-a 1 0 20x1+43+7 'InputFile ' 'inputfile toggle' infile_toggle",
  "-a 1 0 20x1+43+8 'OutputFile' 'outputfile toggle' outfile_toggle",
  "-E",
  "-a 1 0 10x1.5+42+11 'Workspace' 'workspace sel' wksp_sel",
  "-a 1 0 10x1.5+52+11 'Label  ' 'blank sel' blank_sel",
  "-a 1 0 14x1.5+63+11 'Create Master' 'subform button' subform_button",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
  61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$DESIGN/objects/xvroutine/guise/uis/guise.form",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	80,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	1,
	512};


