 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:34:15 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:34:15 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "khelp.h"
/*-----------------------------------------------------------
| 
|  Routine Name: khelp_get_args
| 
|       Purpose: Gets command line args for khelp
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname khelp
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void khelp_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for khelp is out of sync with arguments specified in khelp's *.pane file; please rerun ghostwriter on khelp.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the khelp structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "khelp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x",
			  &(clui_info->x_int),
			  &(clui_info->x_flag))))
	{
	    kerror(NULL, "khelp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "width",
			  &(clui_info->width_int),
			  &(clui_info->width_flag))))
	{
	    kerror(NULL, "khelp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y",
			  &(clui_info->y_int),
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "khelp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "height",
			  &(clui_info->height_int),
			  &(clui_info->height_flag))))
	{
	    kerror(NULL, "khelp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Display a Text File or Directory of Text Files' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' khelp",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation in foreground' $DESIGNBIN/khelp",
  "-H 1  5x1+41+0 'Help' 'man page for khelp' $DESIGN/objects/xvroutine/khelp/help/khelp.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input File (Dir)' 'input file (or dir)' i",
  "-i 1 0 1 0 0 22.5x1+0+4 -1 1000 -1 0 1 'X Window Placement' 'x location of GUI' x",
  "-i 1 0 1 0 0 22x1+26+4 -1 1000 512 0 1 'Window Width ' 'The window width' width",
  "-i 1 0 1 0 0 22.5x1+0+5 -1 1000 -1 0 1 'Y Window Placement' 'y location of GUI' y",
  "-i 1 0 1 0 0 22x1+26+5 -1 1000 512 0 1 'Window Height' 'The window height' height",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DESIGN/objects/xvroutine/khelp/uis/khelp.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


