 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:34:41 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:34:41 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "preview.h"
/*-----------------------------------------------------------
| 
|  Routine Name: preview_get_args
| 
|       Purpose: Gets command line args for preview
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname preview
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void preview_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for preview is out of sync with arguments specified in preview's *.pane file; please rerun ghostwriter on preview.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the preview structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "preview_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "noform",
			  &(clui_info->noform_flag))))
	{
	    kerror(NULL, "preview_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "preview_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "preview_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "preview_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'GUI display tool' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' preview",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute preview' $DESIGNBIN/preview",
  "-H 1  5x1+41+0 'Help' 'help page for preview' $DESIGN/objects/xvroutine/preview/help/preview.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 1 0 0 1 52x1+0+2 ' ' 'Input UIS File' 'input UIS file' i",
  "-t 1 0 1 0 0 8x1+0+3.5 'No Form' 'display GUI of specified UIS file only, not preview\\'s GUI' noform",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DESIGN/objects/xvroutine/preview/uis/preview.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	14,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 50x10+0+0 +7+1 'Preview a Graphical User Interface based on a UIS file' preview",
  "-M 1 1 55x7+0+0 +5+0 'Preview a Graphical User Interface based on a UIS file' show",
  "-P 1 0 50x7+0+1 +0+0 ' ' view",
  "-H 1  10x1+1+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-H 1  5x1+49+0 'Help' 'help' $DESIGN/objects/xvroutine/preview/help help",
  "-Q 1 0 5x1+55+0 'Quit'",
  "-I 1 0 0 1 1 1 56x1+1+2 ' ' 'Show UIS File' 'user interface specification file' i",
  "-a 1 0 10x1+1+4 'SHOW' 'Revisit the specified file' revisit",
  "-a 1 0 10x1+14+4 'EDIT' 'Edit the specified file' edit",
  "-O 1 0 0 1 1 1 55.5x1+1+6 ' ' 'Output UIS File' 'output UIS file' print",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$DESIGN/objects/xvroutine/preview/uis/preview.form",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	13,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	1,
	512};


