 /*
  * Khoros: $Id: runwksp.h,v 1.17.2.2 1997/05/31 18:35:04 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for runwksp
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _runwksp_h_
#define _runwksp_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <design.h>
#include <xvinclude.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Arguments to be passed to the encapsulated workspace (optional string)
 */
char	*args_string;	/* Arguments to be passed to the encapsulated workspace STRING */
int	 args_flag;   	/* Arguments to be passed to the encapsulated workspace FLAG */

/*
 *  hide workspace; just run it (optional flag)
 */
int	 hidden_flag;  	/* hide workspace; just run it FLAG */

/*
 *  Do not echo commands to tty (optional flag)
 */
int	 silent_flag;  	/* Do not echo commands to tty FLAG */

/*
 *  whether the display workspace gui is initially shown (optional flag)
 */
int	 showgui_flag;  	/* whether the display workspace gui is initially shown FLAG */

/*
 *  enable checkpoint/debug reporting (optional flag)
 */
int	 report_flag;  	/* enable checkpoint/debug reporting FLAG */

/*
 *  run application on root window (optional flag)
 */
int	 rootwindow_flag;  	/* run application on root window FLAG */

/*
 *  x location of GUI (optional integer)
 */
int	 x_int; 	/* x location of GUI INT */
int	 x_flag;	/* x location of GUI FLAG */

/*
 *  The window width (optional integer)
 */
int	 width_int; 	/* The window width INT */
int	 width_flag;	/* The window width FLAG */

/*
 *  y location of GUI (optional integer)
 */
int	 y_int; 	/* y location of GUI INT */
int	 y_flag;	/* y location of GUI FLAG */

/*
 *  The window height (optional integer)
 */
int	 height_int; 	/* The window height INT */
int	 height_flag;	/* The window height FLAG */

/*----- optional ME group ----*/
/*
 *  Input workspace file to be run (optional infile)
 */
char	*wksp_file;	/* Input workspace file to be run FILENAME */
int	 wksp_flag;	/* Input workspace file to be run FLAG */

	/*---- nested optional MI group ----*/
/*
 *  the toolbox in which the encapsulated workspace (optional string)
 */
char	*tb_string;	/* the toolbox in which the encapsulated workspace STRING */
int	 tb_flag;   	/* the toolbox in which the encapsulated workspace FLAG */

/*
 *  The encapsulated workspace object name (optional string)
 */
char	*oname_string;	/* The encapsulated workspace object name STRING */
int	 oname_flag;   	/* The encapsulated workspace object name FLAG */

	/*-- nested optional MI group end --*/

/*-- optional ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void runwksp_get_args PROTO((kaddr));
void runwksp_usage_additions PROTO((void));
void runwksp_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
void create_workspace PROTO((void));
/* -include_routines_end */

#endif
