 /*
  * Khoros: $Id: usage.c,v 1.17.2.2 1997/05/31 18:35:06 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.17.2.2 1997/05/31 18:35:06 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "runwksp.h"
/*-----------------------------------------------------------
| 
|  Routine Name: runwksp_get_args
| 
|       Purpose: Gets command line args for runwksp
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname runwksp
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void runwksp_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for runwksp is out of sync with arguments specified in runwksp's *.pane file; please rerun ghostwriter on runwksp.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the runwksp structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "args",
			  &(clui_info->args_string),
			  &(clui_info->args_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hidden",
			  &(clui_info->hidden_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "silent",
			  &(clui_info->silent_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "showgui",
			  &(clui_info->showgui_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "report",
			  &(clui_info->report_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "rootwindow",
			  &(clui_info->rootwindow_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x",
			  &(clui_info->x_int),
			  &(clui_info->x_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "width",
			  &(clui_info->width_int),
			  &(clui_info->width_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y",
			  &(clui_info->y_int),
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "height",
			  &(clui_info->height_int),
			  &(clui_info->height_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "wksp",
			  &(clui_info->wksp_file),
			  &(clui_info->wksp_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "runwksp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Execute a saved cantata workspace, with or without GUI' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' runwksp",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DESIGNBIN/runwksp",
  "-H 1  5x1+41+0 'Help' 'help page' $DESIGN/objects/xvroutine/runwksp/help/runwksp.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 1 0 50x1+1+4 ' ' 'Encapsulated Workspace Arguments' 'Arguments to be passed to the encapsulated workspace' args",
  "-t 1 0 1 0 0 12.875x1+0+6 'Hide Workspace' 'hide workspace; just run it' hidden",
  "-t 1 0 1 0 0 12.875x1+26+6 'Suppress Echo' 'Do not echo commands to tty' silent",
  "-t 1 0 1 0 0 18x1+0+7 'Display Workspace GUI' 'whether the display workspace gui is initially shown' showgui",
  "-t 1 0 1 0 0 18.125x1+26+7 'Checkpoint Reporting' 'enable checkpoint/debug reporting' report",
  "-t 1 0 1 0 0 18.125x1+0+8 'Run Application on RootWindow' 'run application on root window' rootwindow",
  "-i 1 0 1 0 0 22.5x1+1+9.5 -1 1000 -1 0 1 'X Window Placement' 'x location of GUI' x",
  "-i 1 0 1 0 0 22x1+27+9.5 -1 1000 512 0 1 'Window Width ' 'The window width' width",
  "-i 1 0 1 0 0 22.5x1+1+10.5 -1 1000 -1 0 1 'Y Window Placement' 'y location of GUI' y",
  "-i 1 0 1 0 0 22x1+27+10.5 -1 1000 512 0 1 'Window Height' 'The window height' height",
  "-C 0",
  "-I 1 0 1 1 0 1 52x1+0+2 ' ' 'Workspace File' 'Input workspace file to be run' wksp",
  "-B 0",
  "-s 1 0 1 0 0 52x1+0+3 ' ' 'Toolbox Name' 'the toolbox in which the encapsulated workspace' tb",
  "-s 1 0 1 0 0 52x1+0+4 ' ' 'Object Name ' 'The encapsulated workspace object name' oname",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DESIGN/objects/xvroutine/runwksp/uis/runwksp.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	29,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


