/*
 * Khoros: $Id: create_ui.c,v 1.9.2.3 1997/04/21 22:28:46 mirage Exp $
 */
 
#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: create_ui.c,v 1.9.2.3 1997/04/21 22:28:46 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>            File Title
   >>>>
   >>>>  Static:
   >>>>             xvreg_create_gui()
   >>>>             xvreg_create_manager()
   >>>>             xvreg_create_license()
   >>>>             xvreg_create_help()
   >>>>             xvreg_create_pixmap()
   >>>>             xvreg_create_viewport()
   >>>>             xvreg_create_label()
   >>>>             xvreg_create_intro_labels()
   >>>>             xvreg_create_name()
   >>>>             xvreg_create_company()
   >>>>             xvreg_create_address()
   >>>>             xvreg_create_city()
   >>>>             xvreg_create_state()
   >>>>             xvreg_create_zip()
   >>>>             xvreg_create_country()
   >>>>             xvreg_create_phone()
   >>>>             xvreg_create_fax()
   >>>>             xvreg_create_email()
   >>>>             xvreg_create_newslabel()
   >>>>             xvreg_create_upgrade()
   >>>>             xvreg_create_mailinglist()
   >>>>             xvreg_create_question1()
   >>>>             xvreg_create_question2()
   >>>>             xvreg_create_question3()
   >>>>             xvreg_create_register_button()
   >>>>             xvreg_create_noregister_button()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "xvregister.h"

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_gui - Create the GUI
|
|       Purpose: Create the GUI for the application by calling appropriate
|                function calls for each component of the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
void xvreg_create_gui()
{
   if (xvreg_create_manager() == FALSE)
   {
      kerror("main", "xvregister", "Unable to create manager object");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_license() == FALSE)
   {
      kerror("main", "xvregister", "Unable to create license object");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_help() == FALSE)
   {
      kerror("main", "xvregister", "Unable to create help object");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_viewport() == FALSE)
   {
      kerror("main", "xvregister", "Unable to create viewport object");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_pixmap() == FALSE)
   {
      kerror("main", "xvregister", "Unable to create pixmap object");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_intro_labels() == FALSE)
   {
      kerror("main", "xvregister", "Unable to create text labels");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_name() == FALSE)
   {
      kerror("main", "xvregister", "Unable to create text object for 'Name'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_company() == FALSE)
   {
      kerror("main", "xvregister", 
		     "Unable to create text object for 'Company'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_address() == FALSE)
   {
      kerror("main", "xvregister", 
		     "Unable to create text object for 'Address'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_city() == FALSE)
   {
      kerror("main", "xvregister", 
		     "Unable to create text object for 'City'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_state() == FALSE)
   {
      kerror("main", "xvregister", 
		     "Unable to create text object for 'State'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_zip() == FALSE)
   {
      kerror("main", "xvregister", 
		     "Unable to create text object for 'Zip Code'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_country() == FALSE)
   {
      kerror("main", "xvregister", 
		     "Unable to create text object for 'Country'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_phone() == FALSE)
   {
      kerror("main", "xvregister", 
		     "Unable to create text object for 'Phone'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_fax() == FALSE)
   {
      kerror("main", "xvregister", 
		     "Unable to create text object for 'Fax'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_email() == FALSE)
   {
      kerror("main", "xvregister", 
		     "Unable to create text object for 'Email'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_newsletter() == FALSE)
   {
      kerror("main", "xvregister", 
	     "Unable to create button & label objects for 'Newsletter'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_upgrade() == FALSE)
   {
      kerror("main", "xvregister", 
	     "Unable to create button & label objects for 'Upgrade'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_mailinglist() == FALSE)
   {
      kerror("main", "xvregister", 
	     "Unable to create button & label objects for 'Mailing List'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_question1() == FALSE)
   {
      kerror("main", "xvregister", 
	     "Unable to create button & label objects for 'Question 1'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_question2() == FALSE)
   {
      kerror("main", "xvregister", 
	     "Unable to create button & label objects for 'Question 2'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_question3() == FALSE)
   {
      kerror("main", "xvregister", 
	     "Unable to create button & label objects for 'Question 3'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_register_button() == FALSE)
   {
      kerror("main", "xvregister", 
	     "Unable to create button & label objects for 'Register'");
      kexit(KEXIT_FAILURE);
   }
   if (xvreg_create_noregister_button() == FALSE)
   {
      kerror("main", "xvregister", 
	     "Unable to create button & label objects for 'Do Not Register'");
      kexit(KEXIT_FAILURE);
   }
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_manager - Create a manager object for GUI
|
|       Purpose: A manager is needed to layout the graphical user interface
|                so this routine creates a manager and sets appropriate
|                size attributes.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_manager()
{
   if ((xvreg_gui_info->manager = xvw_create_manager(NULL, "manager")) == NULL)
      return FALSE;

   if ((xvreg_gui_info->toplevel = 
		xvw_toplevel(xvreg_gui_info->manager)) == NULL)
      return FALSE;
   if (xvw_set_attributes(xvreg_gui_info->manager,
                      XVW_MINIMUM_WIDTH,	512,
		      XVW_MINIMUM_HEIGHT,	512,
		      NULL) == FALSE)
      return FALSE;
   if ((xvreg_gui_info->toplevel = 
		xvw_toplevel(xvreg_gui_info->manager)) == NULL)
      return FALSE;
   if (xvw_set_attribute(xvreg_gui_info->toplevel, 
			 XVW_SHELL_TITLE, "xvregister") == FALSE)
      return FALSE;
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_license - Create a license button object for GUI
|
|       Purpose: Create a button which when selected displays the K2 Free
|                Access License.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_license()
{
   xvobject menubutton_object;
   xvobject menu_object;
   xvobject button;

   if ((menubutton_object = 
	   xvw_create_menubutton(xvreg_gui_info->manager, "options")) == NULL)
      return FALSE;

   if ((menu_object = 
	   xvw_retrieve_menu(menubutton_object)) == NULL)
      return FALSE;

   if ((xvreg_gui_info->license = 
	   xvw_create_button(menu_object, "license")) == NULL)
      return FALSE;

   if ((button = 
	   xvw_create_button(menu_object, "register")) == NULL)
      return FALSE;

   xvw_set_attributes(button,
                      XVW_LABEL,	"Register",
		      NULL);
   xvw_add_callback(button,
		    XVW_BUTTON_SELECT, select_register_button, NULL);

   if ((button = 
	   xvw_create_button(menu_object, "no register")) == NULL)
      return FALSE;

   xvw_set_attributes(button,
                      XVW_LABEL,	"Do Not Register",
		      NULL);
   xvw_add_callback(button,
		    XVW_BUTTON_SELECT, select_noregister_button, NULL);

   xvw_set_attributes(menubutton_object,
		      XVW_MINIMUM_WIDTH,  70,
		      XVW_MINIMUM_HEIGHT, 25,
                      XVW_LABEL,	"Options",
                      XVW_RIGHT_OF,	NULL,
		      XVW_BELOW, 	NULL,
		      NULL);

   xvw_set_attributes(xvreg_gui_info->license,
                      XVW_LABEL,	"License",
		      NULL);

   xvw_add_callback(xvreg_gui_info->license, XVW_BUTTON_SELECT,
		    license_xvregister, NULL);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_help - Create a help button object for GUI
|
|       Purpose: Create a button which when selected displays the on-line
|                help page for the application.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_help()
{
   if ((xvreg_gui_info->help = 
		xvw_create_button(xvreg_gui_info->manager, "help")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->help,
		      XVW_MINIMUM_WIDTH,  50,
		      XVW_MINIMUM_HEIGHT, 25,
                      XVW_LABEL,	"Help",
                      XVW_LEFT_OF,	NULL,
		      XVW_BELOW, 	NULL,
		      NULL);
   xvw_add_callback(xvreg_gui_info->help, XVW_BUTTON_SELECT,
		    help_xvregister, NULL);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_pixmap - Create an application pixmap for GUI
|
|       Purpose: Create a label object which displays the K2 pixmap for
|                the application.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_pixmap()
{
   char	*tbpath;
   char *pixpath;

   if ((xvreg_gui_info->pixmap_label = 
	xvw_create_pixmap(xvreg_gui_info->viewport, "pixmap label")) == NULL)
      return FALSE;

   tbpath = ktoolbox_path("tomk");
   pixpath = kstring_cat(tbpath, 
		"$DESIGN/objects/xvroutine/xvregister/pixmaps/xvregister.xpm", 
                 NULL);

   xvw_set_attributes(xvreg_gui_info->pixmap_label,
                      XVW_RIGHT_OF,	    NULL,
		      XVW_LEFT_OF,	    NULL,
	 	      XVW_BELOW,	    NULL,
	 	      XVW_PIXMAP_FILENAME,  pixpath,
	              XVW_VERT_DIST,	    20,
		      NULL);
   kfree(pixpath);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_viewport - Create a viewport object for the GUI
|
|       Purpose: Create a viewport with a scrollbar so that the GUI remains
|                a fixed size but still enables display of all GUI selections.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_viewport()
{
   if ((xvreg_gui_info->viewport = 
	   xvw_create_viewport(xvreg_gui_info->manager, "viewport")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->viewport,
                      XVW_VP_ALLOW_VERT,	TRUE,
                      XVW_VP_FORCE_VERT,	TRUE,
                      XVW_VP_USE_RIGHT,		TRUE,
                      XVW_BELOW,		xvreg_gui_info->help,
                      XVW_VERT_DIST,		15,
                      XVW_MINIMUM_WIDTH,	500,
                      XVW_MINIMUM_HEIGHT,	500,
                      XVW_TACK_EDGE,		KMANAGER_TACK_ALL,
		      NULL);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_label - Create a label object for the GUI
|
|       Purpose: Create a label object for the GUI.
|
|         Input: char *label_string - String containing label
|                char *label_title  - Title for label object
|                int  label_type    - Type of label object to create.
|
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_label(char *label_string, char *label_title, int label_type)
{
   if (label_type == LABEL_INTRO_LABEL1)
   {
      if ((xvreg_gui_info->intro_label1 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label1,
			    XVW_BELOW, 	        xvreg_gui_info->pixmap_label,
			    XVW_VERT_DIST, 	25,
			    XVW_LABEL,		label_string,
			    XVW_LABEL_JUSTIFY,	KLABEL_JUSTIFY_LEFT,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL2)
   {
      if ((xvreg_gui_info->intro_label2 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label2,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label1,
			    XVW_LABEL,		label_string,
			    XVW_RIGHT_OF,	NULL,
			    XVW_HORIZ_DIST, 	25,
			    XVW_VERT_DIST, 	15,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL3)
   {
      if ((xvreg_gui_info->intro_label3 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label3,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label2,
			    XVW_LABEL,		label_string,
			    XVW_RIGHT_OF,	NULL,
			    XVW_HORIZ_DIST, 	25,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL4)
   {
      if ((xvreg_gui_info->intro_label4 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label4,
			    XVW_LABEL,		label_string,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label3,
			    XVW_RIGHT_OF,	NULL,
			    XVW_HORIZ_DIST, 	25,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL5)
   {
      if ((xvreg_gui_info->intro_label5 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label5,
			    XVW_LABEL,		label_string,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label4,
			    XVW_RIGHT_OF,	NULL,
			    XVW_HORIZ_DIST, 	25,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL6)
   {
      if ((xvreg_gui_info->intro_label6 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label6,
			    XVW_LABEL,		label_string,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label5,
			    XVW_RIGHT_OF,	NULL,
			    XVW_HORIZ_DIST, 	25,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL7)
   {
      if ((xvreg_gui_info->intro_label7 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label7,
			    XVW_LABEL,		label_string,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label6,
			    XVW_LABEL_JUSTIFY,	KLABEL_JUSTIFY_LEFT,
			    XVW_VERT_DIST, 	15,
			    NULL);
   }

   else if (label_type == LABEL_INTRO_LABEL8)
   {
      if ((xvreg_gui_info->intro_label8 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label8,
			    XVW_LABEL,		label_string,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label7,
			    XVW_RIGHT_OF,	NULL,
			    XVW_LABEL_JUSTIFY,	KLABEL_JUSTIFY_LEFT,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL9)
   {
      if ((xvreg_gui_info->intro_label9 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label9,
			    XVW_LABEL,		label_string,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label8,
			    XVW_LABEL_JUSTIFY,	KLABEL_JUSTIFY_LEFT,
			    XVW_VERT_DIST, 	15,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL10)
   {
      if ((xvreg_gui_info->intro_label10 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label10,
			    XVW_LABEL,		label_string,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label9,
			    XVW_LABEL_JUSTIFY,	KLABEL_JUSTIFY_LEFT,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL11)
   {
      if ((xvreg_gui_info->intro_label11 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label11,
			    XVW_LABEL,		label_string,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label10,
			    XVW_LABEL_JUSTIFY,	KLABEL_JUSTIFY_LEFT,
			    NULL);
   }
   else if (label_type == LABEL_INTRO_LABEL12)
   {
      if ((xvreg_gui_info->intro_label12 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->intro_label12,
			    XVW_LABEL,		label_string,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label11,
			    XVW_LABEL_JUSTIFY,	KLABEL_JUSTIFY_LEFT,
			    XVW_VERT_DIST, 	15,
			    NULL);
   }

   else if (label_type == LABEL_NAME)
   {
      if ((xvreg_gui_info->name_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->name_label,
			    XVW_VERT_DIST,	15,
			    XVW_BELOW, 	        xvreg_gui_info->intro_label12,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_COMPANY)
   {
      if ((xvreg_gui_info->company_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->company_label,
			    XVW_BELOW, 	        xvreg_gui_info->name,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_ADDRESS)
   {
      if ((xvreg_gui_info->address_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->address_label,
			    XVW_BELOW, 	        xvreg_gui_info->company,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_CITY)
   {
      if ((xvreg_gui_info->city_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->city_label,
			    XVW_BELOW, 	        xvreg_gui_info->address,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_STATE)
   {
      if ((xvreg_gui_info->state_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->state_label,
			    XVW_BELOW, 	        xvreg_gui_info->address,
			    XVW_RIGHT_OF,       xvreg_gui_info->city,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_ZIP)
   {
      if ((xvreg_gui_info->zip_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->zip_label,
			    XVW_BELOW, 	        xvreg_gui_info->city,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_COUNTRY)
   {
      if ((xvreg_gui_info->country_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->country_label,
			    XVW_BELOW, 	        xvreg_gui_info->state,
			    XVW_RIGHT_OF, 	xvreg_gui_info->zip,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_PHONE)
   {
      if ((xvreg_gui_info->phone_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->phone_label,
			    XVW_BELOW, 	        xvreg_gui_info->zip,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_FAX)
   {
      if ((xvreg_gui_info->fax_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->fax_label,
			    XVW_BELOW, 	        xvreg_gui_info->country,
			    XVW_RIGHT_OF, 	xvreg_gui_info->phone,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_EMAIL)
   {
      if ((xvreg_gui_info->email_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->email_label,
			    XVW_BELOW, 	        xvreg_gui_info->phone,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_NEWSLETTER)
   {
      if ((xvreg_gui_info->newsletter_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->newsletter_label,
			    XVW_VERT_DIST, 	15,
			    XVW_BELOW, 	        xvreg_gui_info->email,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_UPGRADE)
   {
      if ((xvreg_gui_info->upgrade_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->upgrade_label,
			    XVW_VERT_DIST,   15,
			    XVW_BELOW,       xvreg_gui_info->newsletter_label,
			    XVW_LABEL,	     label_string,
			    NULL);
   }
   else if (label_type == LABEL_MAILINGLIST1)
   {
      if ((xvreg_gui_info->mailinglist_label1 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->mailinglist_label1,
			    XVW_VERT_DIST, 	15,
			    XVW_BELOW, 	        xvreg_gui_info->upgrade_label,
			    XVW_LABEL,		label_string,
			    NULL);
   }
   else if (label_type == LABEL_MAILINGLIST2)
   {
      if ((xvreg_gui_info->mailinglist_label2 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->mailinglist_label2,
			    XVW_BELOW, 	   xvreg_gui_info->mailinglist_label1,
			    XVW_LABEL,	   label_string,
			    NULL);
   }
   else if (label_type == LABEL_MAILINGLIST3)
   {
      if ((xvreg_gui_info->mailinglist_label3 = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->mailinglist_label3,
			    XVW_VERT_DIST, 15,
			    XVW_BELOW, 	   xvreg_gui_info->mailinglist_label2,
			    XVW_LABEL,	   label_string,
			    NULL);
   }
   else if (label_type == LABEL_BUSINESS)
   {
      if ((xvreg_gui_info->business_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->business_label,
			    XVW_VERT_DIST, 25,
			    XVW_BELOW, 	   xvreg_gui_info->mailinglist_label3,
			    XVW_LABEL,	   label_string,
			    NULL);
   }
   else if (label_type == LABEL_ORGANIZATION)
   {
      if ((xvreg_gui_info->org_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_label,
			    XVW_VERT_DIST, 20,
			    XVW_BELOW, 	   xvreg_gui_info->business_label,
			    XVW_LABEL,	   label_string,
			    NULL);
   }
   else if (label_type == LABEL_ORG_AEROSPACE)
   {
      if ((xvreg_gui_info->org_aerospace_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_aerospace_label,
		  XVW_VERT_DIST,  5,
		  XVW_HORIZ_DIST, 10,
		  XVW_BELOW,      xvreg_gui_info->org_label,
	          XVW_RIGHT_OF,   xvreg_gui_info->org_aerospace.toggle_button,
	          XVW_LABEL,	  label_string,
	          NULL);
   }
   else if (label_type == LABEL_ORG_ENGINEERING)
   {
      if ((xvreg_gui_info->org_engineering_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_engineering_label,
	       XVW_BELOW,      xvreg_gui_info->org_aerospace.toggle_button,
	       XVW_RIGHT_OF,   xvreg_gui_info->org_engineering.toggle_button,
	       XVW_VERT_DIST,  5,
	       XVW_HORIZ_DIST, 10,
	       XVW_LABEL,      label_string,
	       NULL);
   }
   else if (label_type == LABEL_ORG_COMPUTER)
   {
      if ((xvreg_gui_info->org_computer_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_computer_label,
		 XVW_BELOW,      xvreg_gui_info->org_engineering.toggle_button,
	         XVW_RIGHT_OF,   xvreg_gui_info->org_computer.toggle_button,
		 XVW_VERT_DIST,  5,
		 XVW_HORIZ_DIST, 10,
		 XVW_LABEL,	 label_string,
		 NULL);
   }
   else if (label_type == LABEL_ORG_EDUCATION)
   {
      if ((xvreg_gui_info->org_education_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_education_label,
		 XVW_BELOW,      xvreg_gui_info->org_computer.toggle_button,
	         XVW_RIGHT_OF,   xvreg_gui_info->org_education.toggle_button,
		 XVW_VERT_DIST,  5,
		 XVW_HORIZ_DIST, 10,
		 XVW_LABEL,	 label_string,
		 NULL);
   }
   else if (label_type == LABEL_ORG_GIS)
   {
      if ((xvreg_gui_info->org_gis_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_gis_label,
		 XVW_BELOW,      xvreg_gui_info->org_education.toggle_button,
	         XVW_RIGHT_OF,   xvreg_gui_info->org_gis.toggle_button,
		 XVW_VERT_DIST,  5,
		 XVW_HORIZ_DIST, 10,
		 XVW_LABEL,	 label_string,
		 NULL);
   }
   else if (label_type == LABEL_ORG_MEDICAL)
   {
      if ((xvreg_gui_info->org_medical_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_medical_label,
		    XVW_BELOW, 	    xvreg_gui_info->org_gis.toggle_button,
		    XVW_RIGHT_OF,   xvreg_gui_info->org_medical.toggle_button,
		    XVW_VERT_DIST,  5,
		    XVW_HORIZ_DIST, 10,
		    XVW_LABEL,	    label_string,
		    NULL);
   }
   else if (label_type == LABEL_ORG_MANUFACTURING)
   {
      if ((xvreg_gui_info->org_manufacturing_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_manufacturing_label,
	       XVW_BELOW,      xvreg_gui_info->org_medical.toggle_button,
	       XVW_RIGHT_OF,   xvreg_gui_info->org_manufacturing.toggle_button,
	       XVW_VERT_DIST,  5,
	       XVW_HORIZ_DIST, 10,
	       XVW_LABEL,      label_string,
	       NULL);
   }
   else if (label_type == LABEL_ORG_MILITARY)
   {
      if ((xvreg_gui_info->org_military_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_military_label,
	      XVW_BELOW,      xvreg_gui_info->org_manufacturing.toggle_button,
	      XVW_RIGHT_OF,   xvreg_gui_info->org_military.toggle_button,
	      XVW_VERT_DIST,  5,
	      XVW_HORIZ_DIST, 10,
	      XVW_LABEL,      label_string,
	      NULL);
   }
   else if (label_type == LABEL_ORG_TRANSPORTATION)
   {
      if ((xvreg_gui_info->org_transportation_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_transportation_label,
	      XVW_BELOW,      xvreg_gui_info->org_military.toggle_button,
	      XVW_RIGHT_OF,   xvreg_gui_info->org_transportation.toggle_button,
	      XVW_VERT_DIST,  5,
	      XVW_HORIZ_DIST, 10,
	      XVW_LABEL,      label_string,
	      NULL);
   }
   else if (label_type == LABEL_ORG_OTHER)
   {
      if ((xvreg_gui_info->org_other_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_other_label,
	    XVW_BELOW, 	    xvreg_gui_info->org_transportation.toggle_button,
	    XVW_RIGHT_OF,   xvreg_gui_info->org_other.toggle_button,
	    XVW_VERT_DIST,  5,
	    XVW_HORIZ_DIST, 10,
	    XVW_LABEL,	    label_string,
	    NULL);
   }
   else if (label_type == LABEL_ORG_OTHER_SPECIFY)
   {
      if ((xvreg_gui_info->org_other_specify_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->org_other_specify_label,
		    XVW_BELOW,      xvreg_gui_info->org_other.toggle_button,
		    XVW_RIGHT_OF,   NULL,
		    XVW_HORIZ_DIST, 30,
		    XVW_VERT_DIST,  5,
		    XVW_LABEL,	    label_string,
		    NULL);
   }
   else if (label_type == LABEL_FUNCTION)
   {
      if ((xvreg_gui_info->func_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->func_label,
			    XVW_BELOW, 	    xvreg_gui_info->org_other_specify,
			    XVW_VERT_DIST,  25,
			    XVW_LABEL,	    label_string,
			    NULL);
   }
   else if (label_type == LABEL_FUNC_EDUCATOR)
   {
      if ((xvreg_gui_info->func_educator_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->func_educator_label,
		 XVW_BELOW, 	  xvreg_gui_info->func_label,
	         XVW_RIGHT_OF,    xvreg_gui_info->func_educator.toggle_button,
		 XVW_VERT_DIST,   5,
		 XVW_HORIZ_DIST,  10,
		 XVW_LABEL,	  label_string,
		 NULL);
   }
   else if (label_type == LABEL_FUNC_ENGINEER)
   {
      if ((xvreg_gui_info->func_engineer_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->func_engineer_label,
	        XVW_BELOW,       xvreg_gui_info->func_educator.toggle_button,
	        XVW_RIGHT_OF,    xvreg_gui_info->func_engineer.toggle_button,
	        XVW_HORIZ_DIST,  10,
	        XVW_VERT_DIST,   5,
	        XVW_LABEL,	 label_string,
	        NULL);
   }
   else if (label_type == LABEL_FUNC_MIS)
   {
      if ((xvreg_gui_info->func_mis_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->func_mis_label,
		  XVW_BELOW,       xvreg_gui_info->func_engineer.toggle_button,
		  XVW_RIGHT_OF,    xvreg_gui_info->func_mis.toggle_button,
		  XVW_HORIZ_DIST,  10,
		  XVW_VERT_DIST,   5,
		  XVW_LABEL,       label_string,
		  NULL);
   }
   else if (label_type == LABEL_FUNC_RND)
   {
      if ((xvreg_gui_info->func_rnd_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->func_rnd_label,
		      XVW_BELOW,       xvreg_gui_info->func_mis.toggle_button,
		      XVW_RIGHT_OF,    xvreg_gui_info->func_rnd.toggle_button,
		      XVW_HORIZ_DIST,  10,
		      XVW_VERT_DIST,   5,
		      XVW_LABEL,       label_string,
		      NULL);
   }

   else if (label_type == LABEL_FUNC_OTHER)
   {
      if ((xvreg_gui_info->func_other_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->func_other_label,
		    XVW_BELOW, 	     xvreg_gui_info->func_rnd.toggle_button,
		    XVW_RIGHT_OF,    xvreg_gui_info->func_other.toggle_button,
		    XVW_HORIZ_DIST,  10,
		    XVW_VERT_DIST,   5,
		    XVW_LABEL,	     label_string,
		    NULL);
   }
   else if (label_type == LABEL_FUNC_OTHER_SPECIFY)
   {
      if ((xvreg_gui_info->func_other_specify_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->func_other_specify_label,
		    XVW_BELOW, 	     xvreg_gui_info->func_other.toggle_button,
		    XVW_RIGHT_OF,    NULL,
		    XVW_HORIZ_DIST,  30,
		    XVW_VERT_DIST,   5,
		    XVW_LABEL,	    label_string,
		    NULL);
   }
   else if (label_type == LABEL_USE)
   {
      if ((xvreg_gui_info->use_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->use_label,
			    XVW_BELOW, 	    xvreg_gui_info->func_other_specify,
			    XVW_VERT_DIST,  25,
			    XVW_LABEL,	    label_string,
			    NULL);
   }
   else if (label_type == LABEL_USE_VISUALIZATION)
   {
      if ((xvreg_gui_info->use_visualization_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->use_visualization_label,
	       XVW_BELOW,      xvreg_gui_info->use_label,
	       XVW_RIGHT_OF,   xvreg_gui_info->use_visualization.toggle_button,
	       XVW_VERT_DIST,  5,
	       XVW_HORIZ_DIST, 10,
	       XVW_LABEL,      label_string,
	       NULL);
   }
   else if (label_type == LABEL_USE_PROTOTYPING)
   {
      if ((xvreg_gui_info->use_prototyping_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->use_prototyping_label,
	       XVW_BELOW,      xvreg_gui_info->use_visualization.toggle_button,
	       XVW_RIGHT_OF,   xvreg_gui_info->use_prototyping.toggle_button,
	       XVW_VERT_DIST,  5,
	       XVW_HORIZ_DIST, 10,
	       XVW_LABEL,      label_string,
	       NULL);
   }
   else if (label_type == LABEL_USE_SWD)
   {
      if ((xvreg_gui_info->use_swd_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->use_swd_label,
	       XVW_BELOW,      xvreg_gui_info->use_prototyping.toggle_button,
	       XVW_RIGHT_OF,   xvreg_gui_info->use_swd.toggle_button,
	       XVW_VERT_DIST,  5,
	       XVW_HORIZ_DIST, 10,
	       XVW_LABEL,      label_string,
	       NULL);
   }
   else if (label_type == LABEL_USE_RND)
   {
      if ((xvreg_gui_info->use_rnd_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->use_rnd_label,
		      XVW_BELOW,      xvreg_gui_info->use_swd.toggle_button,
		      XVW_RIGHT_OF,   xvreg_gui_info->use_rnd.toggle_button,
		      XVW_VERT_DIST,  5,
		      XVW_HORIZ_DIST, 10,
		      XVW_LABEL,      label_string,
		      NULL);
   }
   else if (label_type == LABEL_USE_OTHER)
   {
      if ((xvreg_gui_info->use_other_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->use_other_label,
		    XVW_BELOW, 	    xvreg_gui_info->use_rnd.toggle_button,
		    XVW_RIGHT_OF,   xvreg_gui_info->use_other.toggle_button,
		    XVW_VERT_DIST,  5,
		    XVW_HORIZ_DIST, 10,
		    XVW_LABEL,	    label_string,
		    NULL);
   }
   else if (label_type == LABEL_USE_OTHER_SPECIFY)
   {
      if ((xvreg_gui_info->use_other_specify_label = 
	   xvw_create_label(xvreg_gui_info->viewport, label_title)) == NULL)
         return FALSE;
      xvw_set_attributes(xvreg_gui_info->use_other_specify_label,
			    XVW_BELOW, 	    xvreg_gui_info->use_other_label,
			    XVW_RIGHT_OF,   NULL,
			    XVW_VERT_DIST,  5,
			    XVW_HORIZ_DIST, 30,
			    XVW_LABEL,	    label_string,
			    NULL);
   }
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_intro_labels - Create intro labels for the GUI
|
|       Purpose: Create introductory labels for the GUI which describe
|		 the registration process.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_intro_labels()
{
   char temp[KLENGTH];
   char *intro_label1;
   char *intro_label2;
   char *intro_label3;
   char *intro_label4;
   char *intro_label5;
   char *intro_label6;
   char *intro_label7;
   char *intro_label8;
   char *intro_label9;
   char *intro_label10;
   char *intro_label11;
   char *intro_label12;
   char *label_tag;

   ksprintf(temp, "Take 5 minutes to register %s %d.%d.%d, and you get:",
            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR);
   intro_label1 = kstrdup(temp);
   intro_label2 = kstrdup("*  Regular notice of Khoros upgrades, training sessions, and new products");
   intro_label3 = kstrdup("*  A subscription to the Khoros Knews, our quarterly newsletter filled with");
   intro_label4 = kstrdup("   tips on using Khoros and information about KRI");
   intro_label5 = kstrdup("*  Our promise that we will never pester you, nor give your name to any");
   intro_label6 = kstrdup("   other mailing list without your permission!");
   intro_label7 = kstrdup("So how can you lose?  Tell us who you are and what you need - we'll keep");
   intro_label8 = kstrdup("bringing you the best Khoros!  Thanks!");
   intro_label9 = kstrdup("Registering is easy.  You can register via the internet for free.  If you don't");
   intro_label10 = kstrdup("have an internet connection, you can still register electronically then fax or");
   intro_label11 = kstrdup("mail your printed form to Khoral Research Inc.");
   intro_label12 = kstrdup("Please complete the following information");

   label_tag = kstrdup("intro");

   if (xvreg_create_label
		(intro_label1, label_tag, LABEL_INTRO_LABEL1) == FALSE)
   {
      kfree(intro_label1);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label2, label_tag, LABEL_INTRO_LABEL2) == FALSE)
   {
      kfree(intro_label2);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label3, label_tag, LABEL_INTRO_LABEL3) == FALSE)
   {
      kfree(intro_label3);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label4, label_tag, LABEL_INTRO_LABEL4) == FALSE)
   {
      kfree(intro_label4);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label5, label_tag, LABEL_INTRO_LABEL5) == FALSE)
   {
      kfree(intro_label5);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label6, label_tag, LABEL_INTRO_LABEL6) == FALSE)
   {
      kfree(intro_label6);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label7, label_tag, LABEL_INTRO_LABEL7) == FALSE)
   {
      kfree(intro_label7);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label8, label_tag, LABEL_INTRO_LABEL8) == FALSE)
   {
      kfree(intro_label8);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label9, label_tag, LABEL_INTRO_LABEL9) == FALSE)
   {
      kfree(intro_label9);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label10, label_tag, LABEL_INTRO_LABEL10) == FALSE)
   {
      kfree(intro_label10);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label11, label_tag, LABEL_INTRO_LABEL11) == FALSE)
   {
      kfree(intro_label11);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label
		(intro_label12, label_tag, LABEL_INTRO_LABEL12) == FALSE)
   {
      kfree(intro_label12);
      kfree(label_tag);
      return FALSE;
   }
   kfree(intro_label1);
   kfree(intro_label2);
   kfree(intro_label3);
   kfree(intro_label4);
   kfree(intro_label5);
   kfree(intro_label6);
   kfree(intro_label7);
   kfree(intro_label8);
   kfree(intro_label9);
   kfree(intro_label10);
   kfree(intro_label11);
   kfree(intro_label12);
   kfree(label_tag);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_name - Create a text object for displaying name
|
|       Purpose: Create a text object for displaying the registree's name
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_name()
{
   char	*name_label;
   char *label_tag;

   name_label = kstrdup("            Name");
   label_tag  = kstrdup("name label");

   if (xvreg_create_label(name_label, label_tag, LABEL_NAME) == FALSE)
   {
      kfree(name_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(name_label);
   kfree(label_tag);

   if ((xvreg_gui_info->name = 
	   xvw_create_text(xvreg_gui_info->viewport, "name")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->name,
		      XVW_VERT_DIST,        15,
		      XVW_MINIMUM_WIDTH,    364,
		      XVW_BELOW,            xvreg_gui_info->intro_label12,
		      XVW_RIGHT_OF,         xvreg_gui_info->name_label,
 		      XVW_TEXT_MULTILINE,   FALSE,
		      NULL);
   xvw_add_action(xvreg_gui_info->name, "<Key>Return", 
                  xvreg_return_cr, NULL, TRUE);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_company - Create a text object for displaying company
|
|       Purpose: Create a text object for displaying the registree's company
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_company()
{
   char	*company_label;
   char *label_tag;

   company_label = kstrdup("         Company");
   label_tag  = kstrdup("company label");

   if (xvreg_create_label(company_label, label_tag, LABEL_COMPANY) == FALSE)
   {
      kfree(company_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(company_label);
   kfree(label_tag);

   if ((xvreg_gui_info->company = 
	   xvw_create_text(xvreg_gui_info->viewport, "company")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->company,
		      XVW_MINIMUM_WIDTH,    364,
		      XVW_BELOW,            xvreg_gui_info->name,
		      XVW_RIGHT_OF,         xvreg_gui_info->company_label,
 		      XVW_TEXT_MULTILINE,   FALSE,
		      NULL);
   xvw_add_action(xvreg_gui_info->company, "<Key>Return", 
                  xvreg_return_cr, NULL, TRUE);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_address - Create a text object for displaying address
|
|       Purpose: Create a text object for displaying the registree's address
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_address()
{
   char	*address_label;
   char *label_tag;

   address_label = kstrdup("  Street Address");
   label_tag  = kstrdup("address label");

   if (xvreg_create_label(address_label, label_tag, LABEL_ADDRESS) == FALSE)
   {
      kfree(address_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(address_label);
   kfree(label_tag);

   if ((xvreg_gui_info->address = 
	   xvw_create_text(xvreg_gui_info->viewport, "address")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->address,
		      XVW_MINIMUM_HEIGHT,   50,
		      XVW_MINIMUM_WIDTH,    364,
		      XVW_BELOW,            xvreg_gui_info->company,
		      XVW_RIGHT_OF,         xvreg_gui_info->address_label,
		      XVW_TEXT_MULTILINE,   TRUE,
		      NULL);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_city - Create a text object for displaying city
|
|       Purpose: Create a text object for displaying the registree's city
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_city()
{
   char	*city_label;
   char *label_tag;

   city_label = kstrdup("            City");
   label_tag  = kstrdup("city label");

   if (xvreg_create_label(city_label, label_tag, LABEL_CITY) == FALSE)
   {
      kfree(city_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(city_label);
   kfree(label_tag);

   if ((xvreg_gui_info->city = 
	   xvw_create_text(xvreg_gui_info->viewport, "city")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->city,
		      XVW_MINIMUM_WIDTH,    221,
		      XVW_BELOW,            xvreg_gui_info->address,
		      XVW_RIGHT_OF,         xvreg_gui_info->city_label,
 		      XVW_TEXT_MULTILINE,   FALSE,
		      NULL);
   xvw_add_action(xvreg_gui_info->city, "<Key>Return", 
                  xvreg_return_cr, NULL, TRUE);
   return TRUE;
}
/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_state - Create a text object for displaying state
|
|       Purpose: Create a text object for displaying the registree's state
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_state()
{
   char	*state_label;
   char *label_tag;

   state_label = kstrdup(" State/Province");
   label_tag  = kstrdup("state label");

   if (xvreg_create_label(state_label, label_tag, LABEL_STATE) == FALSE)
   {
      kfree(state_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(state_label);
   kfree(label_tag);

   if ((xvreg_gui_info->state = 
	   xvw_create_text(xvreg_gui_info->viewport, "state")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->state,
		      XVW_WIDTH,            47,
		      XVW_BELOW,            xvreg_gui_info->address,
		      XVW_RIGHT_OF,         xvreg_gui_info->state_label,
 		      XVW_TEXT_MULTILINE,   FALSE,
		      NULL);
   xvw_add_action(xvreg_gui_info->state, "<Key>Return", 
                  xvreg_return_cr, NULL, TRUE);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_zip - Create a text object for displaying zip code
|
|       Purpose: Create a text object for displaying the registree's zip code
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_zip()
{
   char	*zip_label;
   char *label_tag;

   zip_label = kstrdup(" Zip/Postal Code");
   label_tag  = kstrdup("zip label");

   if (xvreg_create_label(zip_label, label_tag, LABEL_ZIP) == FALSE)
   {
      kfree(zip_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(zip_label);
   kfree(label_tag);

   if ((xvreg_gui_info->zip = 
	   xvw_create_text(xvreg_gui_info->viewport, "zip")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->zip,
		      XVW_WIDTH,    	    155,
		      XVW_BELOW,            xvreg_gui_info->city,
		      XVW_RIGHT_OF,         xvreg_gui_info->zip_label,
 		      XVW_TEXT_MULTILINE,   FALSE,
		      NULL);
   xvw_add_action(xvreg_gui_info->zip, "<Key>Return", 
                  xvreg_return_cr, NULL, TRUE);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_country - Create a text object for displaying country 
|
|       Purpose: Create a text object for displaying the registree's country
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_country()
{
   char	*country_label;
   char *label_tag;

   country_label = kstrdup(" Country");
   label_tag  = kstrdup("country label");

   if (xvreg_create_label(country_label, label_tag, LABEL_COUNTRY) == FALSE)
   {
      kfree(country_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(country_label);
   kfree(label_tag);

   if ((xvreg_gui_info->country = 
	   xvw_create_text(xvreg_gui_info->viewport, "country")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->country,
		      XVW_WIDTH,    	    155,
		      XVW_BELOW,            xvreg_gui_info->state,
		      XVW_RIGHT_OF,         xvreg_gui_info->country_label,
 		      XVW_TEXT_MULTILINE,   FALSE,
		      NULL);
   xvw_add_action(xvreg_gui_info->country, "<Key>Return", 
                  xvreg_return_cr, NULL, TRUE);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_phone - Create a text object for displaying phone 
|
|       Purpose: Create a text object for displaying the registree's phone
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_phone()
{
   char	*phone_label;
   char *label_tag;

   phone_label = kstrdup("           Phone");
   label_tag  = kstrdup("phone label");

   if (xvreg_create_label(phone_label, label_tag, LABEL_PHONE) == FALSE)
   {
      kfree(phone_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(phone_label);
   kfree(label_tag);

   if ((xvreg_gui_info->phone = 
	   xvw_create_text(xvreg_gui_info->viewport, "phone")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->phone,
		      XVW_WIDTH,    	    155,
		      XVW_BELOW,            xvreg_gui_info->zip,
		      XVW_RIGHT_OF,         xvreg_gui_info->phone_label,
 		      XVW_TEXT_MULTILINE,   FALSE,
		      NULL);
   xvw_add_action(xvreg_gui_info->phone, "<Key>Return", 
                  xvreg_return_cr, NULL, TRUE);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_fax - Create a text object for displaying fax 
|
|       Purpose: Create a text object for displaying the registree's fax
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_fax()
{
   char	*fax_label;
   char *label_tag;

   fax_label = kstrdup("     Fax");
   label_tag  = kstrdup("fax label");

   if (xvreg_create_label(fax_label, label_tag, LABEL_FAX) == FALSE)
   {
      kfree(fax_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(fax_label);
   kfree(label_tag);

   if ((xvreg_gui_info->fax = 
	   xvw_create_text(xvreg_gui_info->viewport, "fax")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->fax,
		      XVW_WIDTH,    	    155,
		      XVW_BELOW,            xvreg_gui_info->country,
		      XVW_RIGHT_OF,         xvreg_gui_info->fax_label,
 		      XVW_TEXT_MULTILINE,   FALSE,
		      NULL);
   xvw_add_action(xvreg_gui_info->fax, "<Key>Return", 
                  xvreg_return_cr, NULL, TRUE);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_email - Create a text object for displaying email 
|
|       Purpose: Create a text object for displaying the registree's email
|                in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_email()
{
   char	*email_label;
   char *label_tag;

   email_label = kstrdup("Internet Address");
   label_tag  = kstrdup("email label");

   if (xvreg_create_label(email_label, label_tag, LABEL_EMAIL) == FALSE)
   {
      kfree(email_label);
      kfree(label_tag);
      return FALSE;
   }
   kfree(email_label);
   kfree(label_tag);

   if ((xvreg_gui_info->email = 
	   xvw_create_text(xvreg_gui_info->viewport, "email")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->email,
		      XVW_WIDTH,    	    367,
		      XVW_BELOW,            xvreg_gui_info->phone,
		      XVW_RIGHT_OF,         xvreg_gui_info->email_label,
 		      XVW_TEXT_MULTILINE,   FALSE,
		      NULL);
   xvw_add_action(xvreg_gui_info->email, "<Key>Return", 
                  xvreg_return_cr, NULL, TRUE);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_newslabel - Create a label object for displaying a newsletter label 
|
|       Purpose: Create a label object for displaying a newsletter label and
|                button in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_newsletter()
{
   char	*newsletter_label;
   char *label_tag;

   newsletter_label = kstrdup("Send me a free subscription to the Khoros Knews quarterly newsletter?");
   label_tag  = kstrdup("news label");

   if (xvreg_create_label(newsletter_label, 
		          label_tag, LABEL_NEWSLETTER) == FALSE)
   {
      kfree(newsletter_label);
      kfree(label_tag);
      return FALSE;
   }

   if ((xvreg_gui_info->newsletter = 
	   xvw_create_button(xvreg_gui_info->viewport, "newsletter")) == NULL)
   {
      kfree(newsletter_label);
      kfree(label_tag);
      return FALSE;
   }

   xvw_add_callback(xvreg_gui_info->newsletter, XVW_BUTTON_SELECT,
		    select_newsletter_button, NULL);

   xvw_set_attributes(xvreg_gui_info->newsletter,
		      XVW_LABEL,	    "Yes",
		      XVW_LABEL_JUSTIFY,    KLABEL_JUSTIFY_CENTER,
		      XVW_MINIMUM_WIDTH,    40,
		      XVW_HORIZ_DIST,	    10,
		      XVW_VERT_DIST,	    15,
		      XVW_RIGHT_OF,	    xvreg_gui_info->newsletter_label,
		      XVW_BELOW,	    xvreg_gui_info->email,
		      NULL);
   kfree(newsletter_label);
   kfree(label_tag);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_upgrade - Create a label object for displaying an upgrade label 
|
|       Purpose: Create a label object for displaying an upgrade label and
|                button in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_upgrade()
{
   char	*upgrade_label;
   char *label_tag;

   upgrade_label = kstrdup("Notify me of new releases, patches, and upgrades");
   label_tag  = kstrdup("upgrade label");

   if (xvreg_create_label(upgrade_label, label_tag, LABEL_UPGRADE) == FALSE)
   {
      kfree(upgrade_label);
      kfree(label_tag);
      return FALSE;
   }

   if ((xvreg_gui_info->upgrade = 
	   xvw_create_button(xvreg_gui_info->viewport, "upgrade")) == NULL)
   {
      kfree(upgrade_label);
      kfree(label_tag);
      return FALSE;
   }

   xvw_add_callback(xvreg_gui_info->upgrade, XVW_BUTTON_SELECT,
		    select_upgrade_button, NULL);

   xvw_set_attributes(xvreg_gui_info->upgrade,
		      XVW_LABEL,	    "Yes",
		      XVW_LABEL_JUSTIFY,    KLABEL_JUSTIFY_CENTER,
		      XVW_MINIMUM_WIDTH,    40,
		      XVW_HORIZ_DIST,	    136,
		      XVW_VERT_DIST,	    15,
		      XVW_RIGHT_OF,	    xvreg_gui_info->upgrade_label,
		      XVW_BELOW,	    xvreg_gui_info->newsletter_label,
		      NULL);
   kfree(upgrade_label);
   kfree(label_tag);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_mailinglist - Create a label object for displaying an mailinglist label 
|
|       Purpose: Create a label object for displaying an mailinglist label and
|                button in the GUI.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_mailinglist()
{
   char	*mailinglist_label1;
   char	*mailinglist_label2;
   char	*mailinglist_label3;
   char	*business_label;
   char *label_tag;
   char *business_label_tag;

   mailinglist_label1 = kstrdup("Occasionally, we make our mailing list available to companies offering related");
   mailinglist_label2 = kstrdup("services.  If you do not want your name included, please indicate so.");
   mailinglist_label3 = kstrdup("You may publish my name");

   label_tag  = kstrdup("mailing list intro label");

   if (xvreg_create_label(mailinglist_label1, 
			  label_tag, LABEL_MAILINGLIST1) == FALSE)
   {
      kfree(mailinglist_label1);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label(mailinglist_label2, 
			  label_tag, LABEL_MAILINGLIST2) == FALSE)
   {
      kfree(mailinglist_label2);
      kfree(label_tag);
      return FALSE;
   }
   if (xvreg_create_label(mailinglist_label3, 
			  label_tag, LABEL_MAILINGLIST3) == FALSE)
   {
      kfree(mailinglist_label3);
      kfree(label_tag);
      return FALSE;
   }


   if ((xvreg_gui_info->mailinglist = 
	 xvw_create_button(xvreg_gui_info->viewport, "mailing list")) == NULL)
   {
      kfree(mailinglist_label1);
      kfree(mailinglist_label2);
      kfree(mailinglist_label3);
      kfree(label_tag);
      return FALSE;
   }

   xvw_add_callback(xvreg_gui_info->mailinglist, XVW_BUTTON_SELECT,
		    select_mailinglist_button, NULL);

   xvw_set_attributes(xvreg_gui_info->mailinglist,
		      XVW_LABEL,	    "No",
		      XVW_LABEL_JUSTIFY,    KLABEL_JUSTIFY_CENTER,
		      XVW_MINIMUM_WIDTH,    40,
		      XVW_RIGHT_OF,	    xvreg_gui_info->mailinglist_label3,
		      XVW_BELOW,	    xvreg_gui_info->mailinglist_label2,
		      XVW_HORIZ_DIST,	    40,
		      XVW_VERT_DIST,	    13,
		      NULL);

   business_label = kstrdup("Please help us understand your needs by answering the following questions.");
   business_label_tag = kstrdup("business label");
   
   if (xvreg_create_label(business_label, business_label_tag, 
                          LABEL_BUSINESS) == FALSE)
   {
      kfree(business_label);
      kfree(business_label_tag);
      return FALSE;
   }

   kfree(mailinglist_label1);
   kfree(mailinglist_label2);
   kfree(mailinglist_label3);
   kfree(business_label);
   kfree(business_label_tag);
   kfree(label_tag);
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_question1 - Create label & button objects for 
|                displaying question one of the registration
|
|       Purpose: Create label & button objects for displaying all question
|	         one of the user registration.  Question one is specific
|		 to the type of work done in the registree's current
|		 organization.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_question1()
{
   char	*org_label;
   char	*aerospace_label;
   char	*engineering_label;
   char	*computer_label;
   char	*education_label;
   char	*gis_label;
   char	*medical_label;
   char	*manufacturing_label;
   char	*military_label;
   char	*transportation_label;
   char	*other_org_label;
   char	*other_org_specify_label;
   char *org_label_tag;
   char *aerospace_label_tag;
   char *engineering_label_tag;
   char *computer_label_tag;
   char *education_label_tag;
   char *gis_label_tag;
   char	*medical_label_tag;
   char	*manufacturing_label_tag;
   char	*military_label_tag;
   char	*transportation_label_tag;
   char	*other_org_label_tag;
   char	*other_org_specify_label_tag;

   org_label = kstrdup("What is your organization's primary business?");

   org_label_tag  = kstrdup("org label");

   if (xvreg_create_label(org_label, org_label_tag, 
			  LABEL_ORGANIZATION) == FALSE)
   {
      kfree(org_label);
      kfree(org_label_tag);
      return FALSE;
   }
   kfree(org_label);
   kfree(org_label_tag);

   if ((xvreg_gui_info->org_aerospace.toggle_button = 
	 xvw_create_button(xvreg_gui_info->viewport, "org aerospace")) == NULL)
   {
      return FALSE;
   }

   xvw_add_callback(xvreg_gui_info->org_aerospace.toggle_button,
		    XVW_BUTTON_SELECT, select_org_aerospace_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_aerospace.toggle_button,
		      XVW_LABEL,	    "",
		      XVW_RIGHT_OF,	    NULL,
		      XVW_HORIZ_DIST,	    30,
		      XVW_BELOW,	    xvreg_gui_info->org_label,
		      XVW_WIDTH,	    18,
		      XVW_HEIGHT,	    18,
		      NULL);
   xvreg_gui_info->org_aerospace.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   aerospace_label = kstrdup("Aerospace");
   aerospace_label_tag = kstrdup("aerospace label");

   if (xvreg_create_label(aerospace_label, aerospace_label_tag, 
                          LABEL_ORG_AEROSPACE) == FALSE)
   {
      kfree(aerospace_label);
      kfree(aerospace_label_tag);
      return FALSE;
   }
   kfree(aerospace_label);
   kfree(aerospace_label_tag);

   if ((xvreg_gui_info->org_engineering.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "org engineering")) == NULL)
   {
      return FALSE;
   }

   xvw_add_callback(xvreg_gui_info->org_engineering.toggle_button,
		    XVW_BUTTON_SELECT, select_org_engineering_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_engineering.toggle_button,
	     XVW_LABEL,	    "",
	     XVW_RIGHT_OF,      NULL,
             XVW_HORIZ_DIST,    30,
             XVW_BELOW,	        xvreg_gui_info->org_aerospace.toggle_button,
             XVW_WIDTH,	        18,
	     XVW_HEIGHT,        18,
	     NULL);

   xvreg_gui_info->org_engineering.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   engineering_label = kstrdup("Architecture/Engineering");
   engineering_label_tag = kstrdup("engineering label");

   if (xvreg_create_label(engineering_label, engineering_label_tag, 
                          LABEL_ORG_ENGINEERING) == FALSE)
   {
      kfree(engineering_label);
      kfree(engineering_label_tag);
      return FALSE;
   }
   kfree(engineering_label);
   kfree(engineering_label_tag);

   if ((xvreg_gui_info->org_computer.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "org computer")) == NULL)
   {
      return FALSE;
   }

   xvw_add_callback(xvreg_gui_info->org_computer.toggle_button,
		    XVW_BUTTON_SELECT, select_org_computer_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_computer.toggle_button,
	 XVW_LABEL,	    "",
	 XVW_RIGHT_OF,	    NULL,
	 XVW_HORIZ_DIST,    30,
         XVW_BELOW,	    xvreg_gui_info->org_engineering.toggle_button,
	 XVW_WIDTH,	    18,
	 XVW_HEIGHT,	    18,
	 NULL);

   xvreg_gui_info->org_computer.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   computer_label = kstrdup("Computer Hardware/Software");
   computer_label_tag = kstrdup("computer label");

   if (xvreg_create_label(computer_label, computer_label_tag, 
                          LABEL_ORG_COMPUTER) == FALSE)
   {
      kfree(computer_label);
      kfree(computer_label_tag);
      return FALSE;
   }
   kfree(computer_label);
   kfree(computer_label_tag);

   if ((xvreg_gui_info->org_education.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "org education")) == NULL)
   {
      return FALSE;
   }

   xvw_add_callback(xvreg_gui_info->org_education.toggle_button,
		    XVW_BUTTON_SELECT, select_org_education_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_education.toggle_button,
	     XVW_LABEL,	    "",
	     XVW_RIGHT_OF,	  NULL,
	     XVW_HORIZ_DIST,	  30,
	     XVW_BELOW,	          xvreg_gui_info->org_computer.toggle_button,
	     XVW_WIDTH,	          18,
	     XVW_HEIGHT,	  18,
	     NULL);

   xvreg_gui_info->org_education.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   education_label = kstrdup("Education");
   education_label_tag = kstrdup("education label");

   if (xvreg_create_label(education_label, education_label_tag, 
                          LABEL_ORG_EDUCATION) == FALSE)
   {
      kfree(education_label);
      kfree(education_label_tag);
      return FALSE;
   }
   kfree(education_label);
   kfree(education_label_tag);

   if ((xvreg_gui_info->org_gis.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "org gis")) == NULL)
   {
      return FALSE;
   }

   xvw_add_callback(xvreg_gui_info->org_gis.toggle_button,
		    XVW_BUTTON_SELECT, select_org_gis_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_gis.toggle_button,
	     XVW_LABEL,	    "",
	     XVW_RIGHT_OF,	  NULL,
	     XVW_HORIZ_DIST,	  30,
	     XVW_BELOW,	          xvreg_gui_info->org_education.toggle_button,
	     XVW_WIDTH,	          18,
	     XVW_HEIGHT,	  18,
	     NULL);

   xvreg_gui_info->org_gis.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   gis_label = kstrdup("Graphical Information Systems");
   gis_label_tag = kstrdup("gis label");

   if (xvreg_create_label(gis_label, gis_label_tag, 
                          LABEL_ORG_GIS) == FALSE)
   {
      kfree(gis_label);
      kfree(gis_label_tag);
      return FALSE;
   }
   kfree(gis_label);
   kfree(gis_label_tag);

   if ((xvreg_gui_info->org_medical.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "org medical")) == NULL)
   {
      return FALSE;
   }

   xvw_add_callback(xvreg_gui_info->org_medical.toggle_button,
		    XVW_BUTTON_SELECT, select_org_medical_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_medical.toggle_button,
      	        XVW_LABEL,	    "",
      	        XVW_RIGHT_OF,    NULL,
                XVW_HORIZ_DIST,  30,
                XVW_BELOW,       xvreg_gui_info->org_gis.toggle_button,
      	        XVW_WIDTH,       18,
      	        XVW_HEIGHT,      18,
      	        NULL);

   xvreg_gui_info->org_medical.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   medical_label = kstrdup("Health/Medical Services");
   medical_label_tag = kstrdup("medical label");

   if (xvreg_create_label(medical_label, medical_label_tag, 
                          LABEL_ORG_MEDICAL) == FALSE)
   {
      kfree(medical_label);
      kfree(medical_label_tag);
      return FALSE;
   }
   kfree(medical_label);
   kfree(medical_label_tag);

   if ((xvreg_gui_info->org_manufacturing.toggle_button =
     xvw_create_button(xvreg_gui_info->viewport, "org manufacturing")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->org_manufacturing.toggle_button,
		    XVW_BUTTON_SELECT, select_org_manufacturing_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_manufacturing.toggle_button,
	      XVW_LABEL,	    "",
	      XVW_RIGHT_OF,	    NULL,
	      XVW_HORIZ_DIST,	    30,
	      XVW_BELOW,	    xvreg_gui_info->org_medical.toggle_button,
	      XVW_WIDTH,	    18,
	      XVW_HEIGHT,	    18,
	      NULL);

   xvreg_gui_info->org_manufacturing.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   manufacturing_label = kstrdup("Manufacturing");
   manufacturing_label_tag = kstrdup("manufacturing label");

   if (xvreg_create_label(manufacturing_label, manufacturing_label_tag, 
                          LABEL_ORG_MANUFACTURING) == FALSE)
   {
      kfree(manufacturing_label);
      kfree(manufacturing_label_tag);
      return FALSE;
   }
   kfree(manufacturing_label);
   kfree(manufacturing_label_tag);

   if ((xvreg_gui_info->org_military.toggle_button =
     xvw_create_button(xvreg_gui_info->viewport, "org military")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->org_military.toggle_button,
		    XVW_BUTTON_SELECT, select_org_military_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_military.toggle_button,
      XVW_LABEL,	    "",
      XVW_RIGHT_OF,	    NULL,
      XVW_HORIZ_DIST,	    30,
      XVW_BELOW,	    xvreg_gui_info->org_manufacturing.toggle_button,
      XVW_WIDTH,	    18,
      XVW_HEIGHT,	    18,
      NULL);

   xvreg_gui_info->org_military.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   military_label = kstrdup("Military");
   military_label_tag = kstrdup("military label");

   if (xvreg_create_label(military_label, military_label_tag, 
                          LABEL_ORG_MILITARY) == FALSE)
   {
      kfree(military_label);
      kfree(military_label_tag);
      return FALSE;
   }
   kfree(military_label);
   kfree(military_label_tag);

   if ((xvreg_gui_info->org_transportation.toggle_button =
     xvw_create_button(xvreg_gui_info->viewport, "org transportation")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->org_transportation.toggle_button,
		    XVW_BUTTON_SELECT, select_org_transportation_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_transportation.toggle_button,
	      XVW_LABEL,	    "",
	      XVW_RIGHT_OF,	    NULL,
	      XVW_HORIZ_DIST,	    30,
              XVW_BELOW,	    xvreg_gui_info->org_military.toggle_button,
	      XVW_WIDTH,	    18,
	      XVW_HEIGHT,	    18,
	      NULL);

   xvreg_gui_info->org_transportation.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   transportation_label = kstrdup("Transportation/Utilities");
   transportation_label_tag = kstrdup("transportation label");

   if (xvreg_create_label(transportation_label, transportation_label_tag, 
                          LABEL_ORG_TRANSPORTATION) == FALSE)
   {
      kfree(transportation_label);
      kfree(transportation_label_tag);
      return FALSE;
   }
   kfree(transportation_label);
   kfree(transportation_label_tag);

   if ((xvreg_gui_info->org_other.toggle_button =
     xvw_create_button(xvreg_gui_info->viewport, "other org")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->org_other.toggle_button,
		    XVW_BUTTON_SELECT, select_org_other_button, NULL);

   xvw_set_attributes(xvreg_gui_info->org_other.toggle_button,
      XVW_LABEL,	    "",
      XVW_RIGHT_OF,	    NULL,
      XVW_HORIZ_DIST,	    30,
      XVW_BELOW,	    xvreg_gui_info->org_transportation.toggle_button,
      XVW_WIDTH,	    18,
      XVW_HEIGHT,	    18,
      NULL);

   xvreg_gui_info->org_other.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   other_org_label = kstrdup("Other");
   other_org_label_tag = kstrdup("other org label");

   if (xvreg_create_label(other_org_label, other_org_label_tag, 
                          LABEL_ORG_OTHER) == FALSE)
   {
      kfree(other_org_label);
      kfree(other_org_label_tag);
      return FALSE;
   }
   kfree(other_org_label);
   kfree(other_org_label_tag);

   other_org_specify_label = kstrdup("Please Specify");
   other_org_specify_label_tag = kstrdup("other org specify label");

   if (xvreg_create_label(other_org_specify_label, other_org_specify_label_tag, 
                          LABEL_ORG_OTHER_SPECIFY) == FALSE)
   {
      kfree(other_org_specify_label);
      kfree(other_org_specify_label_tag);
      return FALSE;
   }
   kfree(other_org_specify_label);
   kfree(other_org_specify_label_tag);

   if ((xvreg_gui_info->org_other_specify = xvw_create_text(
		xvreg_gui_info->viewport, "other org specify text")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->org_other_specify,
		      XVW_BELOW,    xvreg_gui_info->org_other_label,
		      XVW_RIGHT_OF, xvreg_gui_info->org_other_specify_label,
		      XVW_HORIZ_DIST,	    10,
		      XVW_TEXT_MULTILINE,   TRUE,
		      XVW_MINIMUM_HEIGHT,   25,
		      XVW_MINIMUM_WIDTH,    264,
		      NULL);
   
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_question2 - Create label & button objects for 
|                displaying question two of the registration
|
|       Purpose: Create label & button objects for displaying all question
|	         two of the user registration.  Question two is specific
|		 to the prime function of the registree's current organization.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_question2()
{
   char	*function_label;
   char	*educator_label;
   char	*engineer_label;
   char	*mis_label;
   char	*rnd_label;
   char	*other_func_label;
   char	*other_func_specify_label;
   char *function_label_tag;
   char *educator_label_tag;
   char *engineer_label_tag;
   char *mis_label_tag;
   char *rnd_label_tag;
   char	*other_func_label_tag;
   char	*other_func_specify_label_tag;

   function_label = kstrdup("What is your prime function?");
   function_label_tag  = kstrdup("function label");

   if (xvreg_create_label(function_label, function_label_tag, 
                          LABEL_FUNCTION) == FALSE)
   {
      kfree(function_label);
      kfree(function_label_tag);
      return FALSE;
   }
   kfree(function_label);
   kfree(function_label_tag);

   if ((xvreg_gui_info->func_educator.toggle_button = xvw_create_button(
		xvreg_gui_info->viewport, "function educator")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->func_educator.toggle_button,
		    XVW_BUTTON_SELECT, select_func_educator_button, NULL);

   xvw_set_attributes(xvreg_gui_info->func_educator.toggle_button,
		      XVW_LABEL,	    "",
		      XVW_RIGHT_OF,	    NULL,
		      XVW_HORIZ_DIST,	    30,
		      XVW_BELOW,	    xvreg_gui_info->func_label,
		      XVW_WIDTH,	    18,
		      XVW_HEIGHT,	    18,
		      NULL);

   xvreg_gui_info->func_educator.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   educator_label = kstrdup("Educator");
   educator_label_tag = kstrdup("educator label");

   if (xvreg_create_label(educator_label, educator_label_tag, 
                          LABEL_FUNC_EDUCATOR) == FALSE)
   {
      kfree(educator_label);
      kfree(educator_label_tag);
      return FALSE;
   }
   kfree(educator_label);
   kfree(educator_label_tag);

   if ((xvreg_gui_info->func_engineer.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "func engineer")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->func_engineer.toggle_button,
		    XVW_BUTTON_SELECT, select_func_engineer_button, NULL);

   xvw_set_attributes(xvreg_gui_info->func_engineer.toggle_button,
	      XVW_LABEL,	 "",
	      XVW_RIGHT_OF,	 NULL,
	      XVW_HORIZ_DIST,	 30,
              XVW_BELOW,	 xvreg_gui_info->func_educator.toggle_button,
	      XVW_WIDTH,	 18,
	      XVW_HEIGHT,	 18,
	      NULL);

   xvreg_gui_info->func_engineer.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   engineer_label = kstrdup("Engineer");
   engineer_label_tag = kstrdup("engineer label");

   if (xvreg_create_label(engineer_label, engineer_label_tag, 
                          LABEL_FUNC_ENGINEER) == FALSE)
   {
      kfree(engineer_label);
      kfree(engineer_label_tag);
      return FALSE;
   }
   kfree(engineer_label);
   kfree(engineer_label_tag);

   if ((xvreg_gui_info->func_mis.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "func mis")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->func_mis.toggle_button,
		    XVW_BUTTON_SELECT, select_func_mis_button, NULL);

   xvw_set_attributes(xvreg_gui_info->func_mis.toggle_button,
	      XVW_LABEL,       "",
	      XVW_RIGHT_OF,    NULL,
              XVW_BELOW,       xvreg_gui_info->func_engineer.toggle_button,
	      XVW_HORIZ_DIST,  30,
	      XVW_WIDTH,       18,
	      XVW_HEIGHT,      18,
	     NULL);

   xvreg_gui_info->func_mis.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   mis_label = kstrdup("MIS");
   mis_label_tag = kstrdup("mis label");

   if (xvreg_create_label(mis_label, mis_label_tag, LABEL_FUNC_MIS) == FALSE)
   {
      kfree(mis_label);
      kfree(mis_label_tag);
      return FALSE;
   }
   kfree(mis_label);
   kfree(mis_label_tag);

   if ((xvreg_gui_info->func_rnd.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "func rnd")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->func_rnd.toggle_button,
		    XVW_BUTTON_SELECT, select_func_rnd_button, NULL);

   xvw_set_attributes(xvreg_gui_info->func_rnd.toggle_button,
	      XVW_LABEL,	    "",
	      XVW_RIGHT_OF,	    NULL,
	      XVW_HORIZ_DIST,	    30,
	      XVW_BELOW,	    xvreg_gui_info->func_mis.toggle_button,
	      XVW_WIDTH,	    18,
	      XVW_HEIGHT,	    18,
	      NULL);

   xvreg_gui_info->func_rnd.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   rnd_label = kstrdup("R&D");
   rnd_label_tag = kstrdup("rnd label");

   if (xvreg_create_label(rnd_label, rnd_label_tag, LABEL_FUNC_RND) == FALSE)
   {
      kfree(rnd_label);
      kfree(rnd_label_tag);
      return FALSE;
   }
   kfree(rnd_label);
   kfree(rnd_label_tag);

   if ((xvreg_gui_info->func_other.toggle_button =
     xvw_create_button(xvreg_gui_info->viewport, "other func")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->func_other.toggle_button,
		    XVW_BUTTON_SELECT, select_func_other_button, NULL);

   xvw_set_attributes(xvreg_gui_info->func_other.toggle_button,
		     XVW_LABEL,	      "",
		     XVW_RIGHT_OF,    NULL,
		     XVW_HORIZ_DIST,  30,
		     XVW_BELOW,	      xvreg_gui_info->func_rnd.toggle_button,
		     XVW_WIDTH,	      18,
		     XVW_HEIGHT,      18,
		     NULL);

   xvreg_gui_info->func_other.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   other_func_label = kstrdup("Other");
   other_func_label_tag = kstrdup("other func label");

   if (xvreg_create_label(other_func_label, other_func_label_tag, 
                          LABEL_FUNC_OTHER) == FALSE)
   {
      kfree(other_func_label);
      kfree(other_func_label_tag);
      return FALSE;
   }
   kfree(other_func_label);
   kfree(other_func_label_tag);

   other_func_specify_label = kstrdup("Please Specify");
   other_func_specify_label_tag = kstrdup("other func specify label");

   if (xvreg_create_label(other_func_specify_label, 
                          other_func_specify_label_tag, 
                          LABEL_FUNC_OTHER_SPECIFY) == FALSE)
   {
      kfree(other_func_specify_label);
      kfree(other_func_specify_label_tag);
      return FALSE;
   }
   kfree(other_func_specify_label);
   kfree(other_func_specify_label_tag);

   if ((xvreg_gui_info->func_other_specify = xvw_create_text(
		xvreg_gui_info->viewport, "other func specify text")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->func_other_specify,
		      XVW_BELOW,    xvreg_gui_info->func_other_label,
		      XVW_RIGHT_OF, xvreg_gui_info->func_other_specify_label,
		      XVW_HORIZ_DIST,	    10,
		      XVW_TEXT_MULTILINE,   TRUE,
		      XVW_MINIMUM_HEIGHT,   25,
		      XVW_MINIMUM_WIDTH,    264,
		      NULL);

   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_question3 - Create label & button objects for 
|                displaying question three of the registration
|
|       Purpose: Create label & button objects for displaying all question
|	         three of the user registration.  Question three is specific
|		 to the use of Khoros withing the registree's current 
|                organization.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_question3()
{
   char	*use_label;
   char	*visualization_label;
   char	*prototyping_label;
   char	*swd_label;
   char	*rnd_label;
   char	*other_use_label;
   char	*other_use_specify_label;
   char *use_label_tag;
   char *visualization_label_tag;
   char *prototyping_label_tag;
   char *swd_label_tag;
   char *rnd_label_tag;
   char	*other_use_label_tag;
   char	*other_use_specify_label_tag;

   use_label = kstrdup("What do you use Khoros for?");
   use_label_tag  = kstrdup("use label");

   if (xvreg_create_label(use_label, use_label_tag, LABEL_USE) == FALSE)
   {
      kfree(use_label);
      kfree(use_label_tag);
      return FALSE;
   }
   kfree(use_label);
   kfree(use_label_tag);

   if ((xvreg_gui_info->use_visualization.toggle_button = xvw_create_button(
		xvreg_gui_info->viewport, "use visualization")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->use_visualization.toggle_button,
		    XVW_BUTTON_SELECT, select_use_visualization_button, NULL);

   xvw_set_attributes(xvreg_gui_info->use_visualization.toggle_button,
		      XVW_LABEL,	    "",
		      XVW_RIGHT_OF,	    NULL,
		      XVW_HORIZ_DIST,	    30,
		      XVW_BELOW,	    xvreg_gui_info->use_label,
		      XVW_WIDTH,	    18,
		      XVW_HEIGHT,	    18,
		      NULL);

   xvreg_gui_info->use_visualization.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   visualization_label = kstrdup("Data Analysis/Visualization");
   visualization_label_tag = kstrdup("visualization label");

   if (xvreg_create_label(visualization_label, visualization_label_tag, 
                          LABEL_USE_VISUALIZATION) == FALSE)
   {
      kfree(visualization_label);
      kfree(visualization_label_tag);
      return FALSE;
   }
   kfree(visualization_label);
   kfree(visualization_label_tag);

   if ((xvreg_gui_info->use_prototyping.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "use prototyping")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->use_prototyping.toggle_button,
		    XVW_BUTTON_SELECT, select_use_prototyping_button, NULL);

   xvw_set_attributes(xvreg_gui_info->use_prototyping.toggle_button,
      XVW_LABEL,	    "",
      XVW_RIGHT_OF,	    NULL,
      XVW_HORIZ_DIST,	    30,
      XVW_BELOW,	    xvreg_gui_info->use_visualization.toggle_button,
      XVW_WIDTH,	    18,
      XVW_HEIGHT,	    18,
      NULL);

   xvreg_gui_info->use_prototyping.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   prototyping_label = kstrdup("Prototyping");
   prototyping_label_tag = kstrdup("prototyping label");

   if (xvreg_create_label(prototyping_label, prototyping_label_tag, 
                          LABEL_USE_PROTOTYPING) == FALSE)
   {
      kfree(prototyping_label);
      kfree(prototyping_label_tag);
      return FALSE;
   }
   kfree(prototyping_label);
   kfree(prototyping_label_tag);

   if ((xvreg_gui_info->use_swd.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "use swd")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->use_swd.toggle_button,
		    XVW_BUTTON_SELECT, select_use_swd_button, NULL);

   xvw_set_attributes(xvreg_gui_info->use_swd.toggle_button,
      XVW_LABEL,	    "",
      XVW_RIGHT_OF,	    NULL,
      XVW_HORIZ_DIST,	    30,
      XVW_BELOW,	    xvreg_gui_info->use_prototyping.toggle_button,
      XVW_WIDTH,	    18,
      XVW_HEIGHT,	    18,
      NULL);

   xvreg_gui_info->use_swd.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   swd_label = kstrdup("Software Development");
   swd_label_tag = kstrdup("swd label");

   if (xvreg_create_label(swd_label, swd_label_tag, LABEL_USE_SWD) == FALSE)
   {
      kfree(swd_label);
      kfree(swd_label_tag);
      return FALSE;
   }
   kfree(swd_label);
   kfree(swd_label_tag);

   if ((xvreg_gui_info->use_rnd.toggle_button =
      xvw_create_button(xvreg_gui_info->viewport, "use rnd")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->use_rnd.toggle_button,
		    XVW_BUTTON_SELECT, select_use_rnd_button, NULL);

   xvw_set_attributes(xvreg_gui_info->use_rnd.toggle_button,
	      XVW_LABEL,	    "",
	      XVW_RIGHT_OF,	    NULL,
	      XVW_HORIZ_DIST,	    30,
	      XVW_BELOW,	    xvreg_gui_info->use_swd.toggle_button,
	      XVW_WIDTH,	    18,
	      XVW_HEIGHT,	    18,
	      NULL);

   xvreg_gui_info->use_rnd.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   rnd_label = kstrdup("Research & Development");
   rnd_label_tag = kstrdup("rnduse label");

   if (xvreg_create_label(rnd_label, rnd_label_tag, LABEL_USE_RND) == FALSE)
   {
      kfree(rnd_label);
      kfree(rnd_label_tag);
      return FALSE;
   }
   kfree(rnd_label);
   kfree(rnd_label_tag);

   if ((xvreg_gui_info->use_other.toggle_button =
     xvw_create_button(xvreg_gui_info->viewport, "other use")) == NULL)
      return FALSE;

   xvw_add_callback(xvreg_gui_info->use_other.toggle_button,
		    XVW_BUTTON_SELECT, select_use_other_button, NULL);

   xvw_set_attributes(xvreg_gui_info->use_other.toggle_button,
	      XVW_LABEL,	    "",
	      XVW_RIGHT_OF,	    NULL,
	      XVW_HORIZ_DIST,	    30,
	      XVW_BELOW,	    xvreg_gui_info->use_rnd.toggle_button,
	      XVW_WIDTH,	    18,
	      XVW_HEIGHT,	    18,
	      NULL);
   xvreg_gui_info->use_other.toggle_button_highlighted = 
			TOGGLE_BUTTON_NOT_SELECTED;

   other_use_label = kstrdup("Other");
   other_use_label_tag = kstrdup("other use label");

   if (xvreg_create_label(other_use_label, other_use_label_tag, 
                          LABEL_USE_OTHER) == FALSE)
   {
      kfree(other_use_label);
      kfree(other_use_label_tag);
      return FALSE;
   }
   kfree(other_use_label);
   kfree(other_use_label_tag);

   other_use_specify_label = kstrdup("Please Specify");
   other_use_specify_label_tag = kstrdup("other use specify label");

   if (xvreg_create_label(other_use_specify_label, 
                          other_use_specify_label_tag, 
                          LABEL_USE_OTHER_SPECIFY) == FALSE)
   {
      kfree(other_use_specify_label);
      kfree(other_use_specify_label_tag);
      return FALSE;
   }
   kfree(other_use_specify_label);
   kfree(other_use_specify_label_tag);

   if ((xvreg_gui_info->use_other_specify = xvw_create_text(
		xvreg_gui_info->viewport, "other use specify text")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->use_other_specify,
		      XVW_BELOW,    xvreg_gui_info->use_other_label,
		      XVW_RIGHT_OF, xvreg_gui_info->use_other_specify_label,
		      XVW_HORIZ_DIST,	    10,
		      XVW_TEXT_MULTILINE,   TRUE,
		      XVW_MINIMUM_HEIGHT,   25,
		      XVW_MINIMUM_WIDTH,    264,
		      NULL);
   
   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_register_button - Create a button object for
|			submitting registration 
|
|       Purpose: Create a button which when selected extracts all information
|                filled out and writes out a file registering the user.
|		 In addition to writing out the registration information
|		 to a file, it also updates the mechanism which marks the
|		 registree as registered with the current version.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_register_button()
{
   if ((xvreg_gui_info->register_button = 
	  xvw_create_button(xvreg_gui_info->viewport, "register")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->register_button,
                      XVW_LABEL,	"Register",
		      XVW_MINIMUM_WIDTH,  120,
		      XVW_MINIMUM_HEIGHT, 35,
                      XVW_LEFT_OF,	NULL,
		      XVW_BELOW, 	xvreg_gui_info->use_other_specify,
		      XVW_VERT_DIST,    20,
		      NULL);

   xvw_add_callback(xvreg_gui_info->register_button,
		    XVW_BUTTON_SELECT, select_register_button, NULL);

   return TRUE;
}

/*-----------------------------------------------------------
|
|  Routine Name: xvreg_create_noregister_button - Create a button object for
|			declining registration submitting
|
|       Purpose: Create a button which when selected does not register
|                the user and updates the mechanism which marks the
|		 registree as NOT registered with the current version.
|
|         Input: None
|
|        Output: None
|
|       Returns: TRUE on success
|		 FALSE on failure
|
|    Written By: Becky Bishop
|          Date: March 12, 1996
| Modifications:
|
------------------------------------------------------------*/
int xvreg_create_noregister_button()
{
   if ((xvreg_gui_info->no_register_button = 
	  xvw_create_button(xvreg_gui_info->viewport, "no register")) == NULL)
      return FALSE;

   xvw_set_attributes(xvreg_gui_info->no_register_button,
                      XVW_LABEL,	"Do Not Register",
		      XVW_MINIMUM_WIDTH,  120,
		      XVW_MINIMUM_HEIGHT, 35,
                      XVW_LEFT_OF,	xvreg_gui_info->register_button,
		      XVW_BELOW, 	xvreg_gui_info->use_other_specify,
		      XVW_VERT_DIST,    20,
		      NULL);

   xvw_add_callback(xvreg_gui_info->no_register_button,
		    XVW_BUTTON_SELECT, select_noregister_button, NULL);
   return TRUE;
}
