 /*
  * Khoros: $Id: usage.c,v 1.10.2.2 1997/05/31 18:35:20 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.10.2.2 1997/05/31 18:35:20 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "xvregister.h"
/*-----------------------------------------------------------
| 
|  Routine Name: xvregister_get_args
| 
|       Purpose: Gets command line args for xvregister
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname xvregister
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void xvregister_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for xvregister is out of sync with arguments specified in xvregister's *.pane file; please rerun ghostwriter on xvregister.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the xvregister structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_flag(pane, "dummy",
			  &(clui_info->dummy_flag))))
	{
	    kerror(NULL, "xvregister_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 ' ' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kregisternew",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $DESIGNBIN/xvregister",
  "-H 1  5x1+41+0 'Help' 'help page' $DESIGN/objects/xvroutine/xvregister/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-t 1 0 1 0 0 6x1+1+1.5 'Dummy Flag Variable' 'A dummy variable since the CLUI cannot be empty' dummy",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DESIGN/objects/xvroutine/xvregister/uis/xvregister.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	13,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


