 /*
  * Khoros: $Id: xvregister.c,v 1.12.2.2 1997/05/31 18:35:22 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: xvregister.c,v 1.12.2.2 1997/05/31 18:35:22 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for xvregister
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "xvregister.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - <short description not found>
|
|       Purpose: main program for xvregister
|
|         Input:
|		int clui_info->dummy_flag; {TRUE if -dummy specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
   int          license_status = FALSE;
   int          registration_status = FALSE;
   int          agreed_to_license = FALSE;
   int		set_registration = FALSE;
   int		set_license = FALSE;
   int		xvregister_status = FALSE;
/* -main_variable_list_end */

	khoros_init(argc, argv, "DESIGN", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$DESIGN/objects/xvroutine/xvregister");
	kexit_handler(xvregister_free_args, NULL);

/* -main_get_args_call */
	kclui_init("DESIGN", "xvregister", KGEN_KROUTINE,  &clui_uis_spec,
		   xvregister_usage_additions, xvregister_get_args,
 		   xvregister_free_args);
/* -main_get_args_call_end */

	/*
	 * Initialize xvwidgets lib
	 */
	if (!(xvw_initialize(XVW_MENUS_XVFORMS)))
	{
	     kinfo(KSTANDARD, "Could not open connection to server");
	     kexit(KEXIT_FAILURE);
	}

/* -main_before_lib_call */
        if (verify_khoros_dotfile() == -1)
        {
             license_status = FALSE;
             registration_status = FALSE;
        }
        else
        {
             registration_status = verify_registration();
             license_status = verify_licensed();
        }

        if (registration_status == TRUE && license_status == TRUE)
        {
             kinfo(KFORCE, "Your version of Khoros has already been registered "
                       "and licensed.  Thank you!!");
             kexit(KEXIT_SUCCESS);
        }
        else if (registration_status == TRUE && license_status != TRUE)
        {
             set_registration = KEEP_OLD_REG_FIELD;

             kinfo(KFORCE, "Your version of Khoros has already been registered "
                "but has not been licensed.");

             agreed_to_license = show_license();

             if (agreed_to_license == TRUE)
                set_license = LICENSED;
             else if (license_status == NOT_CURRENT_VERSION)
                set_license = KEEP_OLD_LIC_FIELD;
             else set_license = UNLICENSED;

             xvregister_status =
                update_khoros_dotfile(set_license, set_registration);

	     if (inform_user(xvregister_status))
	        kexit(KEXIT_SUCCESS);
	     else
		kexit(KEXIT_FAILURE);
        }

        xvreg_gui_info = (xvreg_gui_info_struct *) 
		    kmalloc(sizeof(xvreg_gui_info_struct));

        xvreg_create_gui();
/* -main_before_lib_call_end */

/* -main_library_call */
	xvf_run_form();
/* -main_library_call_end */

/* -main_after_lib_call */
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: xvregister_usage_additions
| 
|       Purpose: Prints usage additions in xvregister_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname xvregister
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void xvregister_usage_additions(void)
{

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: xvregister_free_args
| 
|       Purpose: Frees CLUI struct allocated in xvregister_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname xvregister
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
xvregister_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
