 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:35:41 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:35:41 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "xvrun.h"
/*-----------------------------------------------------------
| 
|  Routine Name: xvrun_get_args
| 
|       Purpose: Gets command line args for xvrun
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname xvrun
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void xvrun_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for xvrun is out of sync with arguments specified in xvrun's *.pane file; please rerun ghostwriter on xvrun.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the xvrun structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "xvrun_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "xvrun_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "args",
			  &(clui_info->args_string),
			  &(clui_info->args_flag))))
	{
	    kerror(NULL, "xvrun_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 1 45x10+10+15 +38+1 ' ' form",
  "-M 1 1 45x3+10+5 +17+0 'GUI display & process execution tool' subform",
  "-P 1 0 46x3+0+1 +17+0 'xvrun' pane",
  "-s 1 0 0 1 0 45x1+1+1 ' ' 'Program To Execute' 'program to execute' oname",
  "-s 1 0 1 1 0 45x1+1+3 ' ' 'Toolbox in which to Find Program ' 'toolbox in which to find program' tb",
  "-s 1 0 1 1 0 45x1+1+8 ' ' 'Arguments' 'command line arguments' args",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$DESIGN/objects/xvroutine/xvrun/uis/xvrun.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	9,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


