 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:50:33 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:50:33 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kautocolor.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kautocolor_get_args
| 
|       Purpose: Gets command line args for kautocolor
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kautocolor
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kautocolor_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kautocolor is out of sync with arguments specified in kautocolor's *.pane file; please rerun ghostwriter on kautocolor.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the kautocolor structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kautocolor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "autocolor", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->autocolor_flag))))
	{
	    kerror(NULL, "kautocolor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->autocolor_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kautocolor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Automatically Color Data Object by Manipulating the Color Map' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kautocolor",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $ENVISIONBIN/kautocolor",
  "-H 1  5x1+41+0 'Help' 'help page' $ENVISION/objects/kroutine/kautocolor/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 1 1 0 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "-T 1 0 0 1 1 51x11.5+1+3.5 +4+0 1 'Apply Automatic Colormap:' 'autocolor by' autocolor",
  "-i 1 0 1 1 0 19.5x1+1+1.5 1 1 0 1 1 'Original Colormap' 'Original Colormap' dummy",
  "-i 1 0 1 0 0 19.5x1+1+2.5 1 1 1 1 1 'RGB Cube' 'rgb cube' dummy",
  "-i 1 0 1 0 0 19.5x1+1+3.5 1 1 2 1 1 'RGB Triangle' 'rgb triangle' dummy",
  "-i 1 0 1 0 0 19.5x1+1+4.5 1 1 3 1 1 'RGB Spiral' 'rgb spiral' dummy",
  "-i 1 0 1 0 0 19.5x1+1+5.5 1 1 4 1 1 'HLS Spiral' 'hls spiral' dummy",
  "-i 1 0 1 0 0 19.5x1+1+6.5 1 1 5 1 1 'HSV Rings' 'hsv rings' dummy",
  "-i 1 0 1 0 0 19.5x1+1+7.5 1 1 6 1 1 'HLS Rings' 'hls rings' dummy",
  "-i 0 0 1 0 0 19.5x1+1+8.5 1 1 7 1 1 'RGB Distance' 'rgb distance' dummy",
  "-i 1 0 1 0 0 19.5x1+1+9.5 1 1 8 1 1 'CIE Diagram' 'cie diagram' dummy",
  "-i 0 0 1 0 0 19.5x1+1+10.5 1 1 9 1 1 'Density Slice' 'density slice' dummy",
  "-i 1 0 1 0 0 19.5x1+25+1.5 1 1 10 1 1 'Grey Scale' 'grey scale' dummy",
  "-i 1 0 1 0 0 19.5x1+25+2.5 1 1 11 1 1 'Equalize' 'Equalize each column component globally' dummy",
  "-i 1 0 1 0 0 19.5x1+25+3.5 1 1 12 1 1 'Stretch' 'Stretch each column component independently' dummy",
  "-i 0 0 1 0 0 19.5x1+25+4.5 1 1 13 1 1 'Standard Deviation' 'Normalize according to Standard Deviation' dummy",
  "-i 1 0 1 0 0 19.5x1+25+5.5 1 1 14 1 1 'SA PSeudo' 'Scientific American pseudocolor' dummy",
  "-i 1 0 1 0 0 19.5x1+25+6.5 1 1 15 1 1 'Rainbow' 'rainbow' dummy",
  "-i 1 0 1 0 0 19.5x1+25+7.5 1 1 16 1 1 'Disjoint Greycode' 'disjoint greycode' dummy",
  "-i 1 0 1 0 0 19.5x1+25+8.5 1 1 17 1 1 'Greycode' 'greycode' dummy",
  "-i 1 0 1 0 0 19.5x1+25+9.5 1 1 18 1 1 '3-3-2 Map' '3-3-2 Filter' dummy",
  "-i 1 0 1 0 0 19.5x1+25+10.5 1 1 19 1 1 'Random' 'Random Map' dummy",
  "-E",
  "-O 1 0 0 1 0 1 51.5x1+0+15.5 ' ' 'Output' 'Resulting output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/kroutine/kautocolor/uis/kautocolor.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	36,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


