 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:50:52 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:50:52 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kcolorspace.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kcolorspace_get_args
| 
|       Purpose: Gets command line args for kcolorspace
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kcolorspace
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kcolorspace_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kcolorspace is out of sync with arguments specified in kcolorspace's *.pane file; please rerun ghostwriter on kcolorspace.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the kcolorspace structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kcolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kcolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->type_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kcolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Change the color space attribute on a data object' subform",
  "-P 1 0 53.25x4.59091+0+1 +0+0 ' ' kcolorspace",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $ENVISIONBIN/kcolorspace",
  "-H 1  5x1+41+0 'Help' 'man page for absolute value' $ENVISION/objects/kroutine/kcolorspace/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "-T 1 0 0 1 1 45.125x17+4+3.5 +0+0 1 'Image Colorspace' 'Type of colorspace to be applied to the input image' type",
  "-t 1 0 1 1 0 10x1+1+1 'Greyscale' 'Greyscale' dummy",
  "-t 1 0 1 0 0 10x1+1+2 'RGB Colorspace' 'RGB Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+3 'CMY Colorspace' 'CMY Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+4 'YIQ Colorspace' 'YIQ Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+5 'HSV Colorspace' 'HSV Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+6 'HLS Colorspace' 'HLS Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+7 'IHS Colorspace' 'IHS Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+8 'XYZ Colorspace' 'XYZ Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+9 'UVW Colorspace' 'UVW Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+10 'UCSUVW Colorspace' 'UCSUVW Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+11 'UCSSOW Colorspace' 'UCSSOW Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+12 'UCSLab Colorspace' 'UCSLab Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+13 'UCSLuv Colorspace' 'UCSLuv Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+14 'User Defined Colorspace' 'User Defined Colorspace' dummy",
  "-E",
  "-O 1 0 0 1 0 1 51.75x1+0+22 ' ' 'Output' 'Resulting output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/kroutine/kcolorspace/uis/kcolorspace.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	30,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


