 /*
  * Khoros: $Id: animate.h,v 1.17.2.2 1997/05/31 18:52:24 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for animate
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _animate_h_
#define _animate_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <envision.h>
#include <xvinclude.h>
#include "form_info.h"

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Alternate UIS file (optional infile)
 */
char	*form_file;	/* Alternate UIS file FILENAME */
int	 form_flag;	/* Alternate UIS file FLAG */

/*
 *  (x,y) position for automatic GUI placement */

int	 x_int;		/* x position INT */
int	 x_flag;	/* x position FLAG */

int	 y_int;		/* y position INT */
int	 y_flag;	/* y position FLAG */

/*----- optional ME group ----*/
/*
 *  File containing multiple image frames (optional infile)
 */
char	*i_file;	/* File containing multiple image frames FILENAME */
int	 i_flag;	/* File containing multiple image frames FLAG */

/*
 *  Basename for a set of image frames in different files (optional string)
 */
char	*base_string;	/* Basename for a set of image frames in different files STRING */
int	 base_flag;   	/* Basename for a set of image frames in different files FLAG */

/*-- optional ME group end ---*/

/*
 *  File containing alternate colormap (optional infile)
 */
char	*cmap_file;	/* File containing alternate colormap FILENAME */
int	 cmap_flag;	/* File containing alternate colormap FLAG */

/*
 *  File containing clip mask (optional infile)
 */
char	*clip_file;	/* File containing clip mask FILENAME */
int	 clip_flag;	/* File containing clip mask FLAG */

/*
 *  animation speed (optional float)
 */
float	 speed_float;	/* animation speed FLOAT */
int	 speed_flag;   	/* animation speed FLAG */

/*
 *  Use private colormap? (optional logical)
 */
int	 priv_logic;	/* Use private colormap? LOGIC */
int	 priv_flag;  	/* Use private colormap? FLAG */

/*
 *  Color allocation policy (Optional cycle)
 */
int	 alloc_cycle;	/* Color allocation policy CYCLE INDEX */
char	 *alloc_label;	/* Color allocation policy CYCLE LABEL */
int	 alloc_flag;	/* Color allocation policy FLAG */

/*
 *  How often to check input file for modification (optional float)
 */
float	 update_float;	/* How often to check input file for modification FLOAT */
int	 update_flag;   	/* How often to check input file for modification FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
extern gui_info_struct *gui_info;

extern uis_struct gui_uis_spec;
/* -include_variables */
extern xvobject animate;
extern xvobject panicon;
extern xvobject framenum;
extern xvobject framelabel;
extern xvobject position;

extern int     numimages;
extern kobject *images, current_image;
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void animate_get_args PROTO((kaddr));
void animate_usage_additions PROTO((void));
void animate_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
void input_newimage        PROTO((char *));
void input_newbasename     PROTO((char *));
void startup_from_clui     PROTO((void));
void update_framenum       PROTO((xvobject, kaddr, kaddr));
void init_colormap_display PROTO((kobject));
void update_animate_list   PROTO((int));
void update_band_list	   PROTO((void));
int  detectfile_handler	   PROTO((xvobject, char *, kaddr));
/* -include_routines_end */

#endif
