 /*
  * Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 18:52:37 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 18:52:37 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "animate.h"
/*-----------------------------------------------------------
| 
|  Routine Name: animate_get_args
| 
|       Purpose: Gets command line args for animate
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname animate
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void animate_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for animate is out of sync with arguments specified in animate's *.pane file; please rerun ghostwriter on animate.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the animate structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "base",
			  &(clui_info->base_string),
			  &(clui_info->base_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "cmap",
			  &(clui_info->cmap_file),
			  &(clui_info->cmap_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "clip",
			  &(clui_info->clip_file),
			  &(clui_info->clip_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "speed",
			  &(clui_info->speed_float),
			  &(clui_info->speed_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "priv",
			  &(clui_info->priv_logic),
			  &(clui_info->priv_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alloc", KVF_LIST_LABEL,
			  &(clui_info->alloc_label),
			  &(clui_info->alloc_flag)) &&
	      kclui_get_value(pane, "alloc", KVF_LIST_VAL,
			  &(clui_info->alloc_cycle),
			  &(clui_info->alloc_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "update",
			  &(clui_info->update_float),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "animate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Interactive Animation of Image Sequence' subform",
  "-P 1 0 57.5x13.5+0+1 +0+0 ' ' Animate",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+36+0 'Run' 'do operation in foreground' $ENVISIONBIN/animate",
  "-H 1  6x1+42+0 'Help' 'man page for putimage' $ENVISION/objects/xvroutine/animate/help/animate.hlp help",
  "-Q 1 0 6x1+49+0 'Close'",
  "-C 0",
  "-I 1 0 1 1 0 1 55x1+0+2.5 ' ' 'Input File' 'File containing multiple image frames' i",
  "-s 1 0 1 0 0 55x1+0+3.5 ' ' 'Basename     ' 'Basename for a set of image frames in different files' base",
  "-E",
  "-I 1 0 1 0 0 0 55x1+0+5 ' ' 'Input Colormap' 'File containing alternate colormap' cmap",
  "-I 1 0 1 0 0 0 55x1+0+6 ' ' 'Input Clip Gate' 'File containing clip mask' clip",
  "-f 1 0 1 0 0 48x1+0+7.5 0 5 0.25 0 1 1 'Animation Speed' 'animation speed' speed",
  "-l 1 0 1 2 0 25x1+0+9.5 0 'Use private colormap?' 'No' 'Yes' 'Use private colormap?' priv",
  "-c 1 0 1 2 0 29x1+25+9.5 2 1 1 'Color Allocation Policy' 'Color allocation policy' alloc 'Read Only' 'Read Write'",
  "-i 1 0 1 2 0 26x1+0+11 -1 1000 -1 0 1 'X Placement' 'X location for GUI autoplacement' x",
  "-i 1 0 1 2 0 26x1+0+12 -1 1000 -1 0 1 'Y Placement' 'Y location for GUI autoplacement' y",
  "-f 1 0 1 2 0 26x1+28+12 1 1 1 0 1 1 'Update time' 'How often to check input file for modification' update",
  "-b +0+1.5 'Select a Multi-Frame Input Object or File Basename:' b0",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/xvroutine/animate/uis/animate.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	25,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 38x1+10+10 +3+0.0 'ANIMATE' animate",
  "-S 1 0 ",
  "",
  "-H 1  11x1+1+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-H 1  6x1+30+0 'Help' 'ANIMATE Overview Help' $ENVISION/objects/xvroutine/animate/help/Overview.doc help",
  "-Q 1 0 6x1+37+0 'Quit'",
  "-n 1 0 4x1+12+1.73077 'pixmap:$ENVISION/objects/xvroutine/animate/pixmaps/run_bkd.xpm' 'Sequentially display next bands' reverse",
  "-n 1 0 4x1+17+1.73077 'pixmap:$ENVISION/objects/xvroutine/animate/pixmaps/frame_bkd.xpm' 'Display previous band' previous",
  "-n 1 0 4x1+22+1.73077 'pixmap:$ENVISION/objects/xvroutine/animate/pixmaps/stop.xpm' 'Stop Sequential display' stop",
  "-n 1 0 4x1+27+1.73077 'pixmap:$ENVISION/objects/xvroutine/animate/pixmaps/frame_fwd.xpm' 'Display next band' next",
  "-n 1 0 4x1+32+1.73077 'pixmap:$ENVISION/objects/xvroutine/animate/pixmaps/run_fwd.xpm' 'Sequentially display previous bands' forward",
  "-w 192x74+12+3 'Main Workspace Object' object",
  "-b +17+0 'pixmap:$ENVISION/objects/xvroutine/animate/pixmaps/animate.xpm' b0",
  "",
  "-d 1 0 9x1.5+1+3 'File' File",
  "-d 1 0 9x1.5+1+5 'Options' options",
  "-E",
  "@-k $ENVISION/objects/xvroutine/animate/uis/files.subform",
  "@-F 4.3 1 0 30x12+10+20 +35+1 ' ' form",
  "-M 1 0 30x12+10+8 +28+0 'File' File",
  "-P 1 0 30x12+0.2+0 +1+0 ' Files: Input' file",
  "-H 1  6x1+46+0 'Help' 'Help for Animation Input subform' $ENVISION/objects/xvroutine/animate/help/Files.doc help",
  "-Q 1 0 6x1+53+0 'Close'",
  "-I 1 0 0 1 1 1 58x1+1+7.5 ' ' 'Filename ' 'bit image to be used to clip the image to' clip",
  "-I 1 0 0 1 1 1 58x1+1+10 ' ' 'Filename' 'file w/ alternate colormap' cmap",
  "-O 1 0 0 1 1 1 58x1+1+13 ' ' 'Output File' 'output file' o",
  "-C 0",
  "-I 1 0 1 1 1 1 58x1+1+2.5 ' ' 'Filename' 'multi-band image to be animated' i",
  "-s 1 0 1 0 1 58x1+1+5 ' ' 'Basename' 'basename to a set of images' b",
  "-E",
  "-b +1+1.5 'Multiframe Input File:' blk1",
  "",
  "-b +1+4 'Basename for Input Files:' blk2",
  "",
  "-b +1+6.5 'Clip Mask Input File:' blk3",
  "-b +1+9 'Colormap Input File' blk4",
  "-b +1+12 'Multiframe Output File:' blk5",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/animate/uis/options.subform",
  "@-F 4.3 1 0 20x10+10+20 +35+1 ' ' form ",
  "-M 1 0 72x21+0+0 +3+0 'Options' options",
  "-G 1 15x3+0+1 +21+0 ' '",
  "-H 1  8x1+50+0 'Help' 'display online help' $ENVISION/objects/xvroutine/animate/help/Options.doc help",
  "-Q 1 0 8x1+60+0 'Close'",
  "-g 1 1 10.5x1.2+1+2 'Attributes' attributes",
  "-g 1 0 10.5x1.2+1+4 'Display' display",
  "-g 1 0 10.5x1.2+1+6 'Animate List' lists",
  "-g 1 0 10.5x1.2+1+8 'Colormaps' colormap",
  "-g 1 0 10.5x1.2+1+10 'Function' function",
  "-E",
  "@-p $ENVISION/objects/xvroutine/animate/uis/attributes.pane",
  "@-F 4.3 1 0 20x10+10+20 +35+1 ' ' form ",
  "@-M 1 1 20x9+0+0 +0+0 'Attributes' Attributes",
  "-P 1 0 -1x-1+13+2 +13+0 'Animation Attributes' attributes",
  "-H 1  5x1+48+0 'Help' 'Help for Animation Attributes pane' $ENVISION/objects/xvroutine/animate/help/Attributes.doc help",
  "-T 1 0 0 1 1 41x2+1+1.5 +0+0 1 'Animation Control' 'Animation control when running' control",
  "-l 1 0 1 1 0 10x1+1+1 1 'Loop ' 'False' 'True' 'Loop thru the images continously' loop",
  "-l 1 0 1 0 0 9.5x1+14+1 0 'Single ' 'False' 'True' 'Pass thru the images once' single",
  "-l 1 0 1 0 0 11.375x1+26+1 0 'Autoreverse ' 'False' 'True' 'Autoreverse thru the images continously' autoreverse",
  "-E",
  "-t 1 0 1 1 1 11x1+2+5.5 'Elements' 'Use elements in computing the image bands' elements",
  "-t 1 0 1 1 1 9x1+15+5.5 'Depth' 'Use depth in computing the image bands' depth",
  "-t 1 0 1 1 1 8x1+27+5.5 'Time' 'Use time in computing the image bands' time",
  "-l 1 0 0 1 1 32.5x1+1+8 1 'Show Band Number    ' '  False  ' 'True' 'shows the band number in the upper left corner' show_framenum",
  "-f 1 0 0 1 1 41x1+1+9.5 0 5 0.25 0 1 1 'Animation Speed ' 'animation speed' speed",
  "-b +1+4.5 'Animate Down:' image_band_label",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/display.pane",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' editimage",
  "@-M 1 1 10x4+0+0 +0+0 'Display' Display",
  "-P 1 0 -1x-1+13+2 +13+0 'Colormap Display Control' display",
  "-H 1  5x1+48+0 'Help' 'Help for Image object' $ENVISION/objects/xvroutine/editimage/help/Display.doc help",
  "-l 1 0 0 1 1 31x1+1+2 0 'Use Private Colormap?  ' 'False' 'True' 'Use private colormap?' priv",
  "-c 1 0 0 1 1 31x1+1+3 2 1 1 'Color Allocation Policy' 'Color allocation policy' alloc 'Read Only' 'Read Write'",
  "-x 1 0 0 1 1 53x1+1+4.5 9 1 5 'Complex Data Conversion Type:' 'the complex image conversion type' cmplx_convert 'Real' 'Imaginary' 'Phase' 'Magnitude ' 'Log Magnitude + 1 ' 'Log Magnitude ' 'Log Magnitude Sqrt + 1 ' 'Log Magnitude Sqrt ' 'Magnitude Sqrt'",
  "-c 1 0 0 1 1 31x1+23+6.5 2 1 2 'Type Of Normalization' 'normalization type' norm_type 'Global' 'Local'",
  "-T 1 0 0 1 1 31.125x5+23+8 +0+0 1 'Normalization Method' 'normalization method' norm_method",
  "-i 1 0 1 1 0 10x1+1+1 1 1 1 0 0 '0 <= values <= Max Colors' '0 <= values <= Max Colors' dummy",
  "-i 1 0 1 0 0 10x1+1+2 1 1 2 0 0 '-1*(std.dev) <= values <= 1*(std.dev)' '-1*(std.dev) <= values <= 1*(std.dev)' dummy",
  "-i 1 0 1 0 0 10x1+1+3 1 1 3 0 0 '-2*(std.dev) <= values <= 2*(std.dev)' '-2*(std.dev) <= values <= 2*(std.dev)' dummy",
  "-i 1 0 1 0 0 10x1+1+4 1 1 4 0 0 '-3*(std.dev) <= values <= 3*(std.dev)' '-3*(std.dev) <= values <= 3*(std.dev)' dummy",
  "-E",
  "-a 1 0 20x1.09091+2+9 'Change Red Map Col' 'change map column displayed as Red' red_mapcol",
  "-a 1 0 20x1+2+10.5 'Change Green Map Col' 'change map column displayed as Green' green_mapcol",
  "-a 1 0 20x1+2+12 'Change Blue Map Col' 'change map column displayed as Blue' blue_mapcol",
  "-s 1 0 0 1 1 46.75x1+2+14.5 ' ' ' RED ' 'function defining red' red_function",
  "-s 1 0 0 1 1 46.75x1+2+15.5 ' ' 'GREEN' 'function defining green' green_function",
  "-s 1 0 0 1 1 46.75x1+2+16.5 ' ' 'BLUE ' 'function defining blue' blue_function",
  "-b +6+13.5 'Define Functions Dictating Colormap:' blank2",
  "-E",
  "@-p $ENVISION/objects/xvroutine/animate/uis/lists.pane",
  "@-F 4.3 1 0 32x5+10+20 +0+0 ' ' form",
  "@-M 1 0 32x8+0+0 +0+0 'Lists' Lists",
  "-P 1 0 -1x-1+13+2 +16+0.5 'Change Animation' lists",
  "-H 1  5x1+49+0 'Help' 'display online help' $ENVISION/objects/xvroutine/animate/help/AnimateList.doc help",
  "-z 1 0 0 1 1 19x11.5+3+2 0 1 0 0 'Animate List' 'list of sequences' animate_list",
  "-z 1 0 0 1 1 19x11.5+27+2 0 1 0 0 'Band List' 'list of bands' band_list",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/colormap.pane",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form ",
  "@-M 1 1 20x10+10+8 +0+0 'Colormap' Colormap",
  "-P 1 0 -1x-1+13+2 +0+0 ' ' colormap",
  "-H 1  5x1+48+0 'Help' 'Help for Colormap subform' $ENVISION/objects/xvroutine/editimage/help/Colormaps.doc help",
  "-w 176x220+1+2.5 'general-purpose workspace' wksp1",
  "-w 176x220+26+2.5 'general-purpose workspace' wksp2",
  "-b +5+1.5 'Autocolor Procedures' b1",
  "-b +29+1.5 'Colormap Operations' b2",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/function.pane",
  "@-F 4.3 1 0 20x10+10+20 +35+1 ' ' form ",
  "@-M 1 1 20x9+10+8 +0+0 ' ' options",
  "-P 1 0 -1x-1+13+2 +19+0 'Create Image from Function' function",
  "-H 1  5x1+48+0 'Help' 'documentation for function' $ENVISION/objects/xvroutine/editimage/help/Functions.doc help",
  "-s 1 0 0 1 0 51x3.81818+1+1.5 'w + h' 'f(w,h,d,t,e)  =' 'function expression' expr",
  "-h 1 0 1 2 0 13x1+11+7 0 0 0 0 0 0 ' ' 'Beginning width value' wbegin",
  "-h 1 0 1 2 0 13x1+25+7 0 0 349 0 0 0 ' ' 'Ending width value' wend",
  "-i 1 0 1 2 0 12x1+39+7 2 2 350 0 0 ' ' 'Width size of value data' wsize",
  "-h 1 0 1 2 0 13x1+11+8 0 0 0 0 0 0 ' ' 'Beginning height value' hbegin",
  "-h 1 0 1 2 0 13x1+25+8 0 0 349 0 0 0 ' ' 'Ending height value' hend",
  "-i 1 0 1 2 0 12x1+39+8 2 2 350 0 0 ' ' 'Height size of value data' hsize",
  "-h 1 0 1 2 0 13x1+11+9 0 0 0 0 0 0 ' ' 'Beginning depth value' dbegin",
  "-h 1 0 1 2 0 13x1+25+9 0 0 0 0 0 0 ' ' 'Ending depth value' dend",
  "-i 1 0 1 2 0 12x1+39+9 2 2 1 0 0 ' ' 'Depth size of value data' dsize",
  "-h 1 0 1 2 0 13x1+11+10 0 0 0 0 0 0 ' ' 'Beginning time value' tbegin",
  "-h 1 0 1 2 0 13x1+25+10 0 0 0 0 0 0 ' ' 'Ending time value' tend",
  "-i 1 0 1 2 0 12x1+39+10 2 2 1 0 0 ' ' 'Time size of value data' tsize",
  "-h 1 0 1 2 0 13x1+11+11 0 0 0 0 0 0 ' ' 'Beginning elements value' ebegin",
  "-h 1 0 1 2 0 13x1+25+11 0 0 0 0 0 0 ' ' 'Ending elements value' eend",
  "-i 1 0 1 2 0 12x1+39+11 2 2 1 0 0 ' ' 'Elements size of value data' esize",
  "-x 1 0 1 2 0 31x1.07692+1+12.5 13 1 10 'Select Data Type:  ' 'Data type of sinusoidal value data' type 'bit' 'byte' 'unsigned byte' 'short' 'unsigned short' 'integer' 'unsigned integer' 'long' 'unsigned long' 'float' 'double' 'complex' 'double complex'",
  "-a 1 0 13.5x1.57692+38+12.5 'Create Data' 'creates the actual data set' create",
  "-b +1+7 'Width    (w)' blank1",
  "-b +1+8 'Height   (h)' blank2",
  "-b +1+9 'Depth    (d)' blank3",
  "-b +1+10 'Time     (t)' blank4",
  "-b +1+11 'Elements (e)' blank5",
  "-b +13+6 'Start Value:' blank6",
  "-b +28+6 'End Value:' blank7",
  "-b +39+6 'Number of Points:' blank8",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,0,1,2,
  3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,0,
  1,2,3,4,5,6,7,8,9,10,11,1,1,2,3,4,5,6,7,8,
  9,10,11,12,13,14,15,16,1,1,2,3,4,5,6,7,8,9,10,11,
  12,13,14,15,16,17,18,19,20,21,22,1,1,2,3,4,5,6,7,1,
  1,2,3,4,5,6,7,8,9,1,1,2,3,4,5,6,7,8,9,10,
  11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,
  31,17,20,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$ENVISION/objects/xvroutine/animate/uis/animate.form",
  "$ENVISION/objects/xvroutine/animate/uis/files.subform",
  "$ENVISION/objects/xvroutine/animate/uis/options.subform",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	143,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	3,
	512};


