 /*
  * Khoros: $Id: usage.c,v 1.14.2.3 1997/05/31 18:52:57 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.3 1997/05/31 18:52:57 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "editcmap.h"
/*-----------------------------------------------------------
| 
|  Routine Name: editcmap_get_args
| 
|       Purpose: Gets command line args for editcmap
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname editcmap
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void editcmap_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for editcmap is out of sync with arguments specified in editcmap's *.pane file; please rerun ghostwriter on editcmap.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the editcmap structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pseudo",
			  &(clui_info->pseudo_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "thresh",
			  &(clui_info->thresh_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cmap_only",
			  &(clui_info->cmap_only_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "priv",
			  &(clui_info->priv_logic),
			  &(clui_info->priv_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alloc", KVF_LIST_LABEL,
			  &(clui_info->alloc_label),
			  &(clui_info->alloc_flag)) &&
	      kclui_get_value(pane, "alloc", KVF_LIST_VAL,
			  &(clui_info->alloc_cycle),
			  &(clui_info->alloc_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x",
			  &(clui_info->x_int),
			  &(clui_info->x_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y",
			  &(clui_info->y_int),
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "width",
			  &(clui_info->width_int),
			  &(clui_info->width_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "height",
			  &(clui_info->height_int),
			  &(clui_info->height_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "update",
			  &(clui_info->update_float),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "editcmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Interactively Edit Image Colormap' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' editcmap",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 2 5x1+35+0 'Run' 'do operation in foreground' $ENVISIONBIN/editcmap",
  "-H 1  5x1+41+0 'Help' 'man page for editcmap' $ENVISION/objects/xvroutine/editcmap/help/editcmap.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+3.5 ' ' 'Input File   ' 'File containing colormap' i",
  "-C 1",
  "-t 1 0 1 1 0 12x1+11+2 'PseudoColor' 'Use pseudoColor method for editing colormap' pseudo",
  "-t 1 0 1 0 0 15x1+24+2 'Threshold' 'Use threshold method for editing colormap' thresh",
  "-E",
  "-t 1 0 1 0 0 18.125x1+0+5 'Output Colormap Only?' 'Output edited colormap only (not value data, etc)' cmap_only",
  "-O 1 0 1 1 0 1 51x1+0+6 ' ' 'Output File' 'File in which to store the modified colormap' o",
  "-l 1 0 1 2 0 22x1+0+8 0 'Use private colormap?' 'No' 'Yes' 'Use private colormap?' priv",
  "-c 1 0 1 2 0 29x1+23+8 2 1 1 'Color Allocation Policy' 'Color allocation policy' alloc 'Read Only' 'Read Write'",
  "-i 1 0 1 2 0 25x1+0+9.5 -1 1000 -1 0 1 'X Placement' 'X location for GUI autoplacement' x",
  "-i 1 0 1 2 0 25x1+0+10.5 -1 1000 -1 0 1 'Y Placement' 'Y location for GUI autoplacement' y",
  "-i 1 0 1 2 0 22x1+26+9.5 -1 1000 512 0 1 'Window Width ' 'Window width' width",
  "-i 1 0 1 2 0 22x1+26+10.5 -1 1000 512 0 1 'Window Height' 'Window height' height",
  "-f 1 0 1 2 0 25x1+0+12 1 1 1 0 1 1 'Update time' 'How often to check input file for modification' update",
  "-b +10+1 'Method for Editing Colormap:' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/xvroutine/editcmap/uis/editcmap.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	27,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


