/*
  * Khoros: $Id: do_mapvals.c,v 1.5 1997/01/20 06:47:16 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: do_mapvals.c,v 1.5 1997/01/20 06:47:16 mirage Exp $";
#endif


/* 
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Functionality routines for pane mapvals
   >>>> 
   >>>>  Private: 
   >>>> 	mapvals_update_mode
   >>>> 	mapvals_policy
   >>>> 	mapvals_width
   >>>> 	mapvals_height
   >>>> 	mapvals_show_color
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "editimage.h"

/*-----------------------------------------------------------
| 
|  Routine Name: mapvals_update_mode
| 
|       Purpose: Do routine which is called when
|                  logical selection update_mode is used
| 
|         Input: mapvals_info - ptr to PaneInfo struct for mapvals pane
| 
|        Output: None
|    Written By: Danielle Argiro
|          Date: Jun 26, 1994
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void mapvals_update_mode(
     MapValues_mapvals *mapvals_info)
{
	int update_mode;

	if (!mapvals_info->update_mode)
	   update_mode = KPRINTMAPVAL_UM_CONTINUOUS;
	else update_mode = KPRINTMAPVAL_UM_BUTTON_PRESS;

	xvw_set_attribute(printmapval, XVW_PRINTMAPVAL_UPDATEMODE, update_mode);
}
/*-----------------------------------------------------------
| 
|  Routine Name: mapvals_policy
| 
|       Purpose: Do routine which is called when
|                  cycle selection policy is used
| 
|         Input: mapvals_info - ptr to PaneInfo struct for mapvals pane
| 
|        Output: None
|    Written By: Danielle Argiro
|          Date: Oct 27, 1994
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void mapvals_policy(
     MapValues_mapvals *mapvals_info)
{
	xvw_set_attribute(printmapval, XVW_PRINTMAPVAL_POLICY, 
			  mapvals_info->policy);
}


/*-----------------------------------------------------------
| 
|  Routine Name: mapvals_width
| 
|       Purpose: Do routine which is called when
|                  integer selection width is used
| 
|         Input: mapvals_info - ptr to PaneInfo struct for mapvals pane
| 
|        Output: None
|    Written By: Danielle Argiro
|          Date: Oct 27, 1994
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void mapvals_width(
     MapValues_mapvals *mapvals_info)
{
	xvw_set_attribute(printmapval, XVW_PRINTMAPVAL_WIDTH, 
			  mapvals_info->width);
}


/*-----------------------------------------------------------
| 
|  Routine Name: mapvals_height
| 
|       Purpose: Do routine which is called when
|                  integer selection height is used
| 
|         Input: mapvals_info - ptr to PaneInfo struct for mapvals pane
| 
|        Output: None
|    Written By: Danielle Argiro
|          Date: Oct 27, 1994
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void mapvals_height(
     MapValues_mapvals *mapvals_info)
{
	xvw_set_attribute(printmapval, XVW_PRINTMAPVAL_HEIGHT, 
			  mapvals_info->height);
}

/*-----------------------------------------------------------
| 
|  Routine Name: mapvals_show_color
| 
|       Purpose: Do routine which is called when
|                  logical selection show_color is used
| 
|         Input: mapvals_info - ptr to PaneInfo struct for mapvals pane
| 
|        Output: None
|    Written By: 
|          Date: May 26, 1995
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void mapvals_show_color(
     MapValues_mapvals *mapvals_info)
{
	xvw_set_attribute(printmapval, XVW_PRINTMAPVAL_SHOWCOLOR, 
			  mapvals_info->show_color);
}


