/*
  * Khoros: $Id: do_pixel.c,v 1.5 1997/01/20 06:47:17 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: do_pixel.c,v 1.5 1997/01/20 06:47:17 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Functionality routines for pane pixel
   >>>> 
   >>>>  Private: 
   >>>> 	pixel_update_mode
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "editimage.h"


/*-----------------------------------------------------------
| 
|  Routine Name: pixel_update_mode
| 
|       Purpose: Do routine which is called when
|                  logical selection update_mode is used
| 
|         Input: pixel_info - ptr to PaneInfo struct for pixel pane
| 
|        Output: None
|    Written By: 
|          Date: Oct 11, 1993
| Modifications: 
| 
------------------------------------------------------------*/
void pixel_update_mode(
     Pixel_pixel *pixel_info)
{
	int update_mode;

	if (!pixel_info->update_mode)
	   update_mode = KPRINTPIXEL_UM_CONTINUOUS;
	else update_mode = KPRINTPIXEL_UM_BUTTON_PRESS;

	xvw_set_attribute(printpixel, XVW_PRINTPIXEL_UPDATEMODE, update_mode);
}
/*-----------------------------------------------------------
| 
|  Routine Name: pixel_width
| 
|       Purpose: Do routine which is called when
|                  integer selection width is used
| 
|         Input: pixel_info - ptr to PaneInfo struct for pixel pane
| 
|        Output: None
|    Written By: 
|          Date: May 22, 1995
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void pixel_width(
     Pixel_pixel *pixel_info)
{
        xvw_set_attribute(printpixel, XVW_PRINTPIXEL_WIDTH, 
			  pixel_info->width);
}


/*-----------------------------------------------------------
| 
|  Routine Name: pixel_showcolor
| 
|       Purpose: Do routine which is called when
|                  logical selection showcolor is used
| 
|         Input: pixel_info - ptr to PaneInfo struct for pixel pane
| 
|        Output: None
|    Written By: 
|          Date: May 22, 1995
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void pixel_showcolor(
     Pixel_pixel *pixel_info)
{
        xvw_set_attribute(printpixel, XVW_PRINTPIXEL_SHOWCOLOR, 
			  pixel_info->showcolor);
}


/*-----------------------------------------------------------
| 
|  Routine Name: pixel_height
| 
|       Purpose: Do routine which is called when
|                  integer selection height is used
| 
|         Input: pixel_info - ptr to PaneInfo struct for pixel pane
| 
|        Output: None
|    Written By: 
|          Date: May 22, 1995
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void pixel_height(
     Pixel_pixel *pixel_info)
{
        xvw_set_attribute(printpixel, XVW_PRINTPIXEL_HEIGHT, 
			  pixel_info->height);
}


