/*
  * Khoros: $Id: do_thresh.c,v 1.5 1997/01/20 06:47:20 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: do_thresh.c,v 1.5 1997/01/20 06:47:20 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Functionality routines for pane thresh
   >>>> 
   >>>>  Private: 
   >>>> 	thresh_thresholding
   >>>> 	thresh_accept
   >>>> 	thresh_invert
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "editimage.h"

/*-----------------------------------------------------------
| 
|  Routine Name: thresh_thresholding
| 
|       Purpose: Do routine which is called when
|                  toggle selection thresholding is used
| 
|         Input: thresh_info - ptr to PaneInfo struct for thresh pane
| 
|        Output: None
|    Written By: Mark Young and Danielle Argiro
|          Date: Oct 11, 1993
| Modifications: 
| 
------------------------------------------------------------*/
void thresh_thresholding(
     Thresh_thresh *thresh_info)
{
	xvw_set_attribute(threshold, XVW_THRESHOLD_POLICY,
		          thresh_info->thresholding_val);
	if (thresh_info->thresholding_val == KTHRESHOLD_POLICY_WINDOWED)	
	{
	    if (thresh_info->invert)
	    {
		xvw_set_attribute(threshold, XVW_THRESHOLD_INVERT, 0);
	        xvf_set_attribute(thresh_info->invert_struct,
	    		          XVF_LOGIC_VAL, 0);
	        thresh_info->invert = 0;
	    }
	    xvf_set_attribute(thresh_info->invert_struct,
			      XVF_ACTIVATE, 0);
	}
	else xvf_set_attribute(thresh_info->invert_struct,
                              XVF_ACTIVATE, 1);

}

/*-----------------------------------------------------------
| 
|  Routine Name: thresh_invert
| 
|       Purpose: Do routine which is called when
|                  logical selection invert is used
| 
|         Input: thresh_info - ptr to PaneInfo struct for thresh pane
| 
|        Output: None
|    Written By: Mark Young and Danielle Argiro
|          Date: Oct 11, 1993
| Modifications: 
| 
------------------------------------------------------------*/
void thresh_invert(
     Thresh_thresh *thresh_info)
{
	xvw_set_attribute(threshold, XVW_THRESHOLD_INVERT,
		          thresh_info->invert);
}
/*-----------------------------------------------------------
| 
|  Routine Name: thresh_reset
| 
|       Purpose: Do routine which is called when
|                  pane action button reset is used
| 
|         Input: thresh_info - ptr to PaneInfo struct for thresh pane
| 
|        Output: None
|    Written By: 
|          Date: Jun 06, 1995
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void thresh_reset(
     Thresh_thresh *thresh_info)
{
	xvw_set_attribute(threshold, XVW_THRESHOLD_RESET,
		          TRUE);
}


