 /*
  * Khoros: $Id: editimage.h,v 1.15.2.3 1997/05/31 18:53:17 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for editimage
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _editimage_h_
#define _editimage_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <envision.h>
#include <xvinclude.h>
#include "form_info.h"

/* -include_includes */
#include <datamanip.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
#define EXTRACT_W_MOUSE 1
#define EXTRACT_W_KEYBD 2
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Alternate UIS file (optional infile)
 */
char	*form_file;	/* Alternate UIS file FILENAME */
int	 form_flag;	/* Alternate UIS file FLAG */

/*
 *  (x,y) position for automatic GUI placement */

int	 x_int;		/* x position INT */
int	 x_flag;	/* x position FLAG */

int	 y_int;		/* y position INT */
int	 y_flag;	/* y position FLAG */

/*
 *  File containing image (optional infile)
 */
char	*i_file;	/* File containing image FILENAME */
int	 i_flag;	/* File containing image FLAG */

/*
 *  File containing alternate colormap file (optional infile)
 */
char	*cmap_file;	/* File containing alternate colormap file FILENAME */
int	 cmap_flag;	/* File containing alternate colormap file FLAG */

/*
 *  File containing clip mask (optional infile)
 */
char	*clip_file;	/* File containing clip mask FILENAME */
int	 clip_flag;	/* File containing clip mask FLAG */

/*
 *  Use private colormap? (optional logical)
 */
int	 priv_logic;	/* Use private colormap? LOGIC */
int	 priv_flag;  	/* Use private colormap? FLAG */

/*
 *  Color allocation policy (Optional cycle)
 */
int	 alloc_cycle;	/* Color allocation policy CYCLE INDEX */
char	 *alloc_label;	/* Color allocation policy CYCLE LABEL */
int	 alloc_flag;	/* Color allocation policy FLAG */

/*
 *  How often to check input file for modification (optional float)
 */
float	 update_float;	/* How often to check input file for modification FLOAT */
int	 update_flag;   	/* How often to check input file for modification FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
extern gui_info_struct *gui_info;

extern uis_struct gui_uis_spec;
/* -include_variables */
extern xvobject image;	     /* the image wksp on main editimage GUI        */
extern xvobject position;    /* position object under image wksp            */
extern xvobject panicon;     /* panicon appears for large images            */
extern xvobject printpixel;  /* printpixel object for PrintPixel subform    */
extern xvobject printmapval; /* printmapval object for PrintMapVal subform  */
extern xvobject zoom;        /* zoom object for Zoom subform                */
extern xvobject pseudo;      /* pseudocolor object for Pseudo subform       */
extern xvobject threshold;   /* threshold object for Threshold subform      */
extern xvobject imageinfo;   /* textdisplay object for Info subform         */

extern xvobject disp_roi;    /* toplevel of popup ROI extraction display    */
extern xvobject disp_area;   /* area for popup ROI display (signal ROI)     */
extern xvobject disp_plot2d; /* plot for popup ROI display (signal ROI)     */
extern xvobject disp_plot3d; /* plot for popup ROI display (signal ROI)     */
extern xvobject disp_axis2d; /* plot for popup ROI display (signal ROI)     */
extern xvobject disp_image;  /* image for popup ROI display (all other ROI) */

extern xvobject autocolor_list; /* list object for autocolor procedurees    */ 
extern xvobject cmap_op_list;   /* list object for colormap operations      */
extern xvobject notifier;       /* notifier                                 */

extern int     numimages;
extern int     dimensions;
extern kobject *images; 
extern kobject current_image;
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void editimage_get_args PROTO((kaddr));
void editimage_usage_additions PROTO((void));
void editimage_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* autocolor.c */
void edimg_init_autocolor_display PROTO((kobject));

/* utilities.c */
void edimg_input_newimage        PROTO((void));
void edimg_startup_from_clui     PROTO((void));
void edimg_update_image_list     PROTO((int));
void edimg_update_band_list      PROTO((void));
void adjust_gui_from_roi_shape   PROTO((kaddr));
void adjust_gui_from_roi_mode    PROTO((void));
void set_current_image_object    PROTO((void));
void set_alternate_colormap      PROTO((char *));
void set_clipmask                PROTO((char *));
int  detectfile_handler          PROTO((xvobject, char *, kaddr));

/* create.c */
void edimg_create_image       PROTO((void));
void edimg_create_panicon     PROTO((void));
void edimg_create_position    PROTO((void));
void edimg_create_printpixel  PROTO((void));
void edimg_create_printmapval PROTO((void));
void edimg_create_zoom        PROTO((void));
void edimg_create_pseudo      PROTO((void));
void edimg_create_threshold   PROTO((void));
void edimg_create_imageinfo   PROTO((void));
void edimg_create_notifier    PROTO((void));

/* getinfo.c */
void get_image_info PROTO((kaddr));

/* do_file.c */
int output_image PROTO((kobject, char *, char *));
/* -include_routines_end */

#endif
