 /*
  * Khoros: $Id: usage.c,v 1.14.2.3 1997/06/07 20:32:29 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.3 1997/06/07 20:32:29 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "editimage.h"
/*-----------------------------------------------------------
| 
|  Routine Name: editimage_get_args
| 
|       Purpose: Gets command line args for editimage
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname editimage
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void editimage_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for editimage is out of sync with arguments specified in editimage's *.pane file; please rerun ghostwriter on editimage.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the editimage structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "editimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "cmap",
			  &(clui_info->cmap_file),
			  &(clui_info->cmap_flag))))
	{
	    kerror(NULL, "editimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "clip",
			  &(clui_info->clip_file),
			  &(clui_info->clip_flag))))
	{
	    kerror(NULL, "editimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "priv",
			  &(clui_info->priv_logic),
			  &(clui_info->priv_flag))))
	{
	    kerror(NULL, "editimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alloc", KVF_LIST_LABEL,
			  &(clui_info->alloc_label),
			  &(clui_info->alloc_flag)) &&
	      kclui_get_value(pane, "alloc", KVF_LIST_VAL,
			  &(clui_info->alloc_cycle),
			  &(clui_info->alloc_flag))))
	{
	    kerror(NULL, "editimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "update",
			  &(clui_info->update_float),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "editimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "editimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "editimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "editimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Interactive Image Display and Manipulation' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Edit_Image",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+37+0 'Run' 'do operation in foreground' $ENVISIONBIN/editimage",
  "-H 1  5x1+43+0 'Help' 'man page for editimage' $ENVISION/objects/xvroutine/editimage/help/editimage.hlp help",
  "-Q 1 0 6x1+49+0 'Close'",
  "-I 1 0 1 0 0 1 55x1+0+2 'image:khoros' 'Input File' 'File containing image' i",
  "-I 1 0 1 0 0 1 55x1+0+3.5 ' ' 'Input Colormap ' 'File containing alternate colormap file' cmap",
  "-I 1 0 1 0 0 1 55x1+0+4.5 ' ' 'Input Clip Gate' 'File containing clip mask' clip",
  "-l 1 0 1 2 0 22x1+1+6 0 'Use private colormap?' 'No' 'Yes' 'Use private colormap?' priv",
  "-c 1 0 1 2 0 28x1+27+6 2 1 1 'Color Allocation Policy' 'Color allocation policy' alloc 'Read Only' 'Read Write'",
  "-i 1 0 1 2 0 24x1+1+8 -1 1000 -1 0 1 'X placement' 'X location for GUI autoplacement' x",
  "-i 1 0 1 2 0 24x1+1+9 -1 1000 -1 0 1 'Y placement' 'Y location for GUI autoplacement' y",
  "-f 1 0 1 2 0 24x1+31+9 1 1 1 0 1 1 'Update time' 'How often to check input file for modification' update",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/xvroutine/editimage/uis/editimage.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 50x15+10+15 +19+0.5 'EDITIMAGE' editimage",
  "-S 1 0 ",
  "-H 1  11x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-H 1  6x1+36+0 'Help' 'EDITIMAGE Overview Help' $ENVISION/objects/xvroutine/editimage/help/Overview.doc help",
  "-Q 1 0 6.5x1+43+0 'Quit'",
  "-w 10x10+13+2 'main workspace' workspace",
  "-b +16+0 'pixmap:$ENVISION/objects/xvroutine/editimage/pixmaps/editimage.xpm' b0",
  "-d 1 0 12x1.25+0+2 'Files' File",
  "-d 1 0 12x1.25+0+3.5 'Options' options",
  "-d 1 0 12x1+0+6 'Zoom' Zoom",
  "-d 1 0 12x1+0+7.5 'Pixel Values' Pixel",
  "-d 1 0 12x1+0+9 'Map Values' MapValues",
  "-d 1 0 12x1+0+10.5 'Pseudo Color' Pseudo",
  "-d 1 0 12x1+0+12 'Threshold' Thresh",
  "-E",
  "@-k $ENVISION/objects/xvroutine/editimage/uis/file.subform",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form ",
  "-M 1 1 20x9+10+8 +0+0 'Files' File",
  "-P 1 0 66x13+0+0 +1+0.48 'Input and Output Files' file",
  "-H 1  6x1+51+0 'Help' 'Guide pane help' $ENVISION/objects/xvroutine/editimage/help/File.doc help",
  "-Q 1 0 6x1+58+0 'Close'",
  "-I 1 0 0 1 1 1 65x1+1+2 ' ' 'Input Image    ' 'Input File for Data Object' i",
  "-I 1 0 0 1 1 1 65x1+1+3 ' ' 'Input Clip Mask' 'Input File for Clip Mask' clip",
  "-I 1 0 0 1 1 1 65x1+1+4 ' ' 'Input Colormap ' 'file with alternate colormap' cmap",
  "-z 1 0 0 1 0 32x5.36364+1+6 0 1 0 0 'Output File Format' 'output file format' format",
  "-O 1 0 0 1 1 1 64.75x1+1+12 ' ' 'Output Image     ' 'Output File for Data Object' o",
  "-O 1 0 0 1 1 1 65x1+1+13 ' ' 'Output Colormap  ' 'output file' out_cmap",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/editimage/uis/options.subform",
  "@-F 4.3 1 1 50x15+10+15 +19+0.5 'EDITIMAGE' editimage",
  "-M 1 0 72x21+0+0 +3+0 'Options' options",
  "-G 1 15x3+0+1 +0+0 ' '",
  "-H 1  8x1+50+0.5 'Help' 'online help' $ENVISION/objects/xvroutine/editimage/help/Options.doc help",
  "-Q 1 0 8x1+60+0.5 'Close'",
  "-g 1 1 10.5x1.2+1+2 'Image List' lists",
  "-g 1 0 10.5x1.2+1+4 'Capture' capture",
  "-g 1 0 10.5x1.2+1+6 'Display' display",
  "-g 1 0 10.5x1.2+1+8 'Comment' comment",
  "-g 1 0 10.5x1.2+1+10 'Info' information",
  "-g 1 0 10.5x1.2+1+12 'Colormaps' colormap",
  "-g 1 0 10.5x1.2+1+14 'Extract ROI' roi",
  "-g 1 0 10.5x1.2+1+16 'Function' function",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/lists.pane",
  "@-F 4.3 1 0 32x5+10+20 +0+0 ' ' form",
  "@-M 1 0 32x8+0+0 +0+0 'Lists' Lists",
  "-P 1 0 -1x-1+13+2 +16+0.5 'Change Image / Bands' lists",
  "-H 1  5x1+49+0 'Help' 'display online help' $ENVISION/objects/xvroutine/editimage/help/ImageList.doc help",
  "-z 1 0 0 1 1 19x11.5+3+2 0 1 0 0 'Image List' 'list of images' image_list",
  "-z 1 0 0 1 1 18x11.5+27+2 0 1 0 0 'Band List' 'list of bands' band_list",
  "-t 1 0 1 1 1 11x1+29+14.5 'Elements' 'use elements in computing the image bands' elements",
  "-t 1 0 1 1 1 9x1+29+15.5 'Depth' 'use depth in computing the image bands' depth",
  "-t 1 0 1 1 1 8x1+29+16.5 'Time' 'use time in computing the image bands' time",
  "-b +28+13.5 'Use the following Image Band: ' image_band_label",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/capture.pane",
  "@-F 4.3 1 0 20x10+10+20 +35+1 ' ' form ",
  "@-M 1 1 20x9+10+8 +0+0 'Capture' options",
  "-P 1 0 -1x-1+13+2 +19+0 'Capture Image' capture",
  "-H 1  5x1+49+0 'Help' 'help' $ENVISION/objects/xvroutine/editimage/help/Capture.doc help",
  "-t 1 0 1 0 0 25x1+0+5.5 'Capture ALL of window or screen?' 'Capture ALL of window or screen?' all",
  "-t 1 0 1 0 0 30x1+0+7 'Grab the window manager decoration?' 'Grab the window manager decoration?' decor",
  "-t 1 0 1 0 0 30x1+0+8 'Output image in bitmap format?' 'Output image in bitmap format?' b",
  "-a 1 0 14x1.5+39+8 'Capture' 'capture image' capture",
  "-z 1 0 0 1 0 33x5+0+9.5 0 1 0 0 'Output File format' 'output file format' format",
  "-O 1 0 0 1 0 1 51x1+0+15 ' ' 'Capture to File:' 'output file' o",
  "-C 1",
  "-t 1 0 1 1 0 22.625x1+0+2.5 'Use entire screen as source' 'Use entire screen as source' screen",
  "-t 1 0 1 0 0 24.125x1+0+3.5 'Use specific window as source' 'Use window as source' win",
  "-E",
  "-b +0+1.5 'Select source area for capture:' blank1",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/display.pane",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' editimage",
  "@-M 1 1 10x4+0+0 +0+0 'Display' Display",
  "-P 1 0 -1x-1+13+2 +13+0 'Colormap Display Control' display",
  "-H 1  5x1+48+0 'Help' 'Help for Image object' $ENVISION/objects/xvroutine/editimage/help/Display.doc help",
  "-l 1 0 0 1 1 31x1+1+2 0 'Use Private Colormap?  ' 'False' 'True' 'Use private colormap?' priv",
  "-c 1 0 0 1 1 31x1+1+3 2 1 1 'Color Allocation Policy' 'Color allocation policy' alloc 'Read Only' 'Read Write'",
  "-x 1 0 0 1 1 53x1+1+4.5 9 1 5 'Complex Data Conversion Type:' 'the complex image conversion type' cmplx_convert 'Real' 'Imaginary' 'Phase' 'Magnitude ' 'Log Magnitude + 1 ' 'Log Magnitude ' 'Log Magnitude Sqrt + 1 ' 'Log Magnitude Sqrt ' 'Magnitude Sqrt'",
  "-c 1 0 0 1 1 31x1+23+6.5 2 1 2 'Type Of Normalization' 'normalization type' norm_type 'Global' 'Local'",
  "-T 1 0 0 1 1 31.125x5+23+8 +0+0 1 'Normalization Method' 'normalization method' norm_method",
  "-i 1 0 1 1 0 10x1+1+1 1 1 1 0 0 '0 <= values <= Max Colors' '0 <= values <= Max Colors' dummy",
  "-i 1 0 1 0 0 10x1+1+2 1 1 2 0 0 '-1*(std.dev) <= values <= 1*(std.dev)' '-1*(std.dev) <= values <= 1*(std.dev)' dummy",
  "-i 1 0 1 0 0 10x1+1+3 1 1 3 0 0 '-2*(std.dev) <= values <= 2*(std.dev)' '-2*(std.dev) <= values <= 2*(std.dev)' dummy",
  "-i 1 0 1 0 0 10x1+1+4 1 1 4 0 0 '-3*(std.dev) <= values <= 3*(std.dev)' '-3*(std.dev) <= values <= 3*(std.dev)' dummy",
  "-E",
  "-a 1 0 20x1.09091+2+9 'Change Red Map Col' 'change map column displayed as Red' red_mapcol",
  "-a 1 0 20x1+2+10.5 'Change Green Map Col' 'change map column displayed as Green' green_mapcol",
  "-a 1 0 20x1+2+12 'Change Blue Map Col' 'change map column displayed as Blue' blue_mapcol",
  "-s 1 0 0 1 1 46.75x1+2+14.5 ' ' ' RED ' 'function defining red' red_function",
  "-s 1 0 0 1 1 46.75x1+2+15.5 ' ' 'GREEN' 'function defining green' green_function",
  "-s 1 0 0 1 1 46.75x1+2+16.5 ' ' 'BLUE ' 'function defining blue' blue_function",
  "-b +6+13.5 'Define Functions Dictating Colormap:' blank2",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/comment.pane",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form ",
  "@-M 1 1 20x10+10+8 +0+0 'Comment' Comment",
  "-P 1 0 -1x-1+13+2 +2+0 'Change Comment of Data Object' comment",
  "-H 1  5x1+48+0 'Help' 'Guide pane help' $ENVISION/objects/xvroutine/editimage/help/Comment.doc help",
  "-s 1 0 0 1 0 51x12+0+2 ' ' ' ' ' ' comment_string",
  "-a 1 0 15x1+1+14.5 'CHANGE COMMENT' 'change comment' change_comment",
  "-b +2+1 'Edit Comment :' comment_label",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/info.pane",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form ",
  "@-M 1 1 20x10+10+8 +0+0 'Info' Info",
  "-P 1 0 -1x-1+13+2 +2+0 'Current Image Object Information' information",
  "-H 1  5x1+48+0 'Help' 'Guide pane help' $ENVISION/objects/xvroutine/editimage/help/Info.doc help",
  "-w 420x220+0+3 'imageinfo workspace' imageinfo_object",
  "-b +1+1.5 'Filename: ' name_blk",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/colormap.pane",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form ",
  "@-M 1 1 20x10+10+8 +0+0 'Colormap' Colormap",
  "-P 1 0 -1x-1+13+2 +0+0 ' ' colormap",
  "-H 1  5x1+48+0 'Help' 'Help for Colormap subform' $ENVISION/objects/xvroutine/editimage/help/Colormaps.doc help",
  "-w 176x220+1+2.5 'general-purpose workspace' wksp1",
  "-w 176x220+26+2.5 'general-purpose workspace' wksp2",
  "-b +5+1.5 'Autocolor Procedures' b1",
  "-b +29+1.5 'Colormap Operations' b2",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/roi.pane",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form ",
  "@-M 1 1 20x10+10+8 +0+0 'Extract ROI' Roi",
  "-P 1 0 -1x-1+13+2 +1+0 'Extract Regions of Interest' roi",
  "-H 1  5x1+48+0 'Help' 'Guide pane help' $ENVISION/objects/xvroutine/editimage/help/ROI.doc help",
  "-O 1 0 0 1 1 1 51x1+1+1.5 ' ' 'Output Displayed ROI' 'extract ROI file' o",
  "-x 1 0 0 1 1 36x1+1+3 3 1 1 'ROI Extraction Policy: ' 'ROI extraction policy' policy 'Inside Shape' 'Shape Outline' 'Outside Shape'",
  "-l 1 0 0 1 1 36x1+1+4 1 'Display Extracted ROI: ' 'False' 'True' 'display extracted ROI' disp",
  "-l 1 0 0 1 1 36x1+1+5 0 'Extract Multiple ROIs: ' 'False' 'True' 'extract multiple ROIs' mult",
  "-x 1 0 0 1 1 36x1+1+6 3 1 2 'ROI Presentation:      ' 'ROI presentation' pres '  Signal     ' '  Image     ' '  Surface    '",
  "-T 1 0 0 1 1 20.5x4+30+7 +6+0 1 'ROI Shape:' 'specifies desired shape for ROI' shape",
  "-t 1 0 1 1 0 10x1+1+1 'Rectangle' 'Rectangle' dummy",
  "-t 1 0 1 0 0 9.5x1+11+1 'Polyline' 'Polyline' dummy",
  "-t 1 0 1 0 0 9x1+1+2 'Circle' 'Circle' dummy",
  "-t 1 0 1 0 0 9.25x1+11+2 'Ellipse' 'Ellipse' dummy",
  "-t 1 0 1 0 0 9x1+1+3 'Line' 'Line' dummy",
  "-t 1 0 1 0 0 8.5x1+11+3 'Freehand' 'Freehand' dummy",
  "-E",
  "-T 1 0 0 1 1 25x3+0+8 +0+0 1 'Extraction Mode:' 'How to extract' mode",
  "-l 1 0 1 1 0 6x1+2+1 0 'ROI Specified by Mouse' 'False' 'True' 'ROI specified by mouse' mouse",
  "-l 1 0 1 0 0 6x1+2+2 0 'ROI Specified by Keyboard' 'False' 'True' 'ROI specified from keyboard' keyboard",
  "-E",
  "-i 1 0 0 1 0 19.5x1+2+11.5 0 9999 0 0 1 'Begin X ' ' ' line_x1",
  "-i 1 0 0 1 0 19.5x1+2+11.5 0 9999 0 0 1 'Center X ' ' ' circle_x",
  "-i 1 0 0 1 0 19.5x1+2+11.5 0 9999 0 0 1 'Center X ' ' ' ellipse_x",
  "-i 1 0 0 1 0 19.5x1+2+11.5 0 9999 0 0 1 'Upper Left X ' ' ' rect_x",
  "-i 1 0 0 1 0 19.5x1+23+11.5 0 9999 0 0 1 'End X' ' ' line_x2",
  "-i 1 0 0 1 0 14.5x1+23+11.5 0 9999 0 0 1 'Radius ' ' ' circle_radius",
  "-i 1 0 0 1 0 19.5x1+23+11.5 0 9999 0 0 1 'A' ' ' ellipse_a",
  "-i 1 0 0 1 0 20x1+23+11.5 0 9999 0 0 1 'Width  ' ' ' rect_width",
  "-a 1 0 8x1.5+44+11.5 'EXTRACT' 'initiate keyboard extraction' extract_roi",
  "-i 1 0 0 1 0 19.5x1+2+12.5 0 9999 0 0 1 'Begin Y ' ' ' line_y1",
  "-i 1 0 0 1 0 19.5x1+2+12.5 0 9999 0 0 1 'Center Y ' ' ' circle_y",
  "-i 1 0 0 1 0 19.5x1+2+12.5 0 9999 0 0 1 'Center Y ' ' ' ellipse_y",
  "-i 1 0 0 1 0 19.5x1+2+12.5 0 9999 0 0 1 'Upper Left Y ' ' ' rect_y",
  "-i 1 0 0 1 0 19.5x1+23+12.5 0 9999 0 0 1 'End Y' ' ' line_y2",
  "-i 1 0 0 1 0 19.5x1+23+12.5 0 9999 0 0 1 'B' ' ' ellipse_b",
  "-i 1 0 0 1 0 20x1+23+12.5 0 9999 0 0 1 'Height ' ' ' rect_height",
  "-E",
  "@-p $ENVISION/objects/xvroutine/editimage/uis/function.pane",
  "@-F 4.3 1 0 20x10+10+20 +35+1 ' ' form ",
  "@-M 1 1 20x9+10+8 +0+0 ' ' options",
  "-P 1 0 -1x-1+13+2 +19+0 'Create Image from Function' function",
  "-H 1  5x1+48+0 'Help' 'documentation for function' $ENVISION/objects/xvroutine/editimage/help/Functions.doc help",
  "-s 1 0 0 1 0 51x3.81818+1+1.5 'w + h' 'f(w,h,d,t,e)  =' 'function expression' expr",
  "-h 1 0 1 2 0 13x1+11+7 0 0 0 0 0 0 ' ' 'Beginning width value' wbegin",
  "-h 1 0 1 2 0 13x1+25+7 0 0 349 0 0 0 ' ' 'Ending width value' wend",
  "-i 1 0 1 2 0 12x1+39+7 2 2 350 0 0 ' ' 'Width size of value data' wsize",
  "-h 1 0 1 2 0 13x1+11+8 0 0 0 0 0 0 ' ' 'Beginning height value' hbegin",
  "-h 1 0 1 2 0 13x1+25+8 0 0 349 0 0 0 ' ' 'Ending height value' hend",
  "-i 1 0 1 2 0 12x1+39+8 2 2 350 0 0 ' ' 'Height size of value data' hsize",
  "-h 1 0 1 2 0 13x1+11+9 0 0 0 0 0 0 ' ' 'Beginning depth value' dbegin",
  "-h 1 0 1 2 0 13x1+25+9 0 0 0 0 0 0 ' ' 'Ending depth value' dend",
  "-i 1 0 1 2 0 12x1+39+9 2 2 1 0 0 ' ' 'Depth size of value data' dsize",
  "-h 1 0 1 2 0 13x1+11+10 0 0 0 0 0 0 ' ' 'Beginning time value' tbegin",
  "-h 1 0 1 2 0 13x1+25+10 0 0 0 0 0 0 ' ' 'Ending time value' tend",
  "-i 1 0 1 2 0 12x1+39+10 2 2 1 0 0 ' ' 'Time size of value data' tsize",
  "-h 1 0 1 2 0 13x1+11+11 0 0 0 0 0 0 ' ' 'Beginning elements value' ebegin",
  "-h 1 0 1 2 0 13x1+25+11 0 0 0 0 0 0 ' ' 'Ending elements value' eend",
  "-i 1 0 1 2 0 12x1+39+11 2 2 1 0 0 ' ' 'Elements size of value data' esize",
  "-x 1 0 1 2 0 31x1.07692+1+12.5 13 1 10 'Select Data Type:  ' 'Data type of sinusoidal value data' type 'bit' 'byte' 'unsigned byte' 'short' 'unsigned short' 'integer' 'unsigned integer' 'long' 'unsigned long' 'float' 'double' 'complex' 'double complex'",
  "-a 1 0 13.5x1.57692+38+12.5 'Create Data' 'creates the actual data set' create",
  "-b +1+7 'Width    (w)' blank1",
  "-b +1+8 'Height   (h)' blank2",
  "-b +1+9 'Depth    (d)' blank3",
  "-b +1+10 'Time     (t)' blank4",
  "-b +1+11 'Elements (e)' blank5",
  "-b +13+6 'Start Value:' blank6",
  "-b +28+6 'End Value:' blank7",
  "-b +39+6 'Number of Points:' blank8",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/editimage/uis/zoom.subform",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form",
  "-M 1 1 41x16+0+0 +0+0 'Zoom ' Zoom",
  "-P 1 0 41x16+0+0 +3+0 'Zoom' zoom",
  "-H 1  6x1+24+0 'Help' 'Help for zoom subform' $ENVISION/objects/xvroutine/editimage/help/Zoom.doc help",
  "-Q 1 0 6x1+31+0 'Close'",
  "-f 1 0 0 1 1 33x1+1+1.5 1e-05 200 8 0 0 0 'Zoom Factor:  ' 'zoomfactor' zoomfactor",
  "-l 1 0 0 1 1 33x1+1+2.5 0 'Update mode:  ' 'Continuous' 'Button Press' 'update mode' update_mode",
  "-x 1 0 0 1 1 33x1+1+3.5 5 0 2 'Location Marker Type:        ' 'location marker type' lmtype 'None' 'Cross' 'Box' 'Dot' 'Circle'",
  "-w 256x256+1+5 'zoom object' zoom_object",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/editimage/uis/pixel.subform",
  "@-F 4.3 1 1 50x15+10+15 +28+0.5 'EDITIMAGE' editimage",
  "-M 1 1 37x11+0+0 +0+0 'Pixel Values' Pixel",
  "-P 1 0 37x11+0+0 +2+0 'Pixel Values' pixel",
  "-H 1  6x1+21+0 'Help' 'Help for Print Pixel subform' $ENVISION/objects/xvroutine/editimage/help/Pixels.doc help",
  "-Q 1 0 6x1+28+0 'Close'",
  "-i 1 0 0 1 1 14x1+1+1.5 1 30 7 0 0 'Width ' 'width of display' width",
  "-l 1 0 0 1 1 18x1+16+1.5 1 'Show Color?' 'False' 'True' 'show color as background?' showcolor",
  "-i 1 0 0 1 1 14x1+1+2.5 1 30 9 0 0 'Height' 'height of display ' height",
  "-l 1 0 0 1 1 30x1+1+4 0 'Update mode:' ' Continuous ' 'Button Press' 'Update Mode' update_mode",
  "-w 230x180+1+5.5 'Pixel object' pixel_object",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/editimage/uis/mapvals.subform",
  "@-F 4.3 1 1 50x15+10+15 +28+0.5 'EDITIMAGE' editimage",
  "-M 1 1 37x33+0+0 +0+0 'Map Values' MapValues",
  "-P 1 0 37x33+0+0 +1+0 'Map Values' mapvals",
  "-H 1  6x1+21+0 'Help' 'Help for Print Map Values subform' $ENVISION/objects/xvroutine/editimage/help/MapValues.doc help",
  "-Q 1 0 6x1+28+0 'Close'",
  "-i 1 0 0 1 1 15x1+1+1 2 2 7 0 0 'Width ' 'display width' width",
  "-i 1 0 0 1 1 15x1+1+2 2 2 9 0 0 'Height' 'display height' height",
  "-l 1 0 0 1 1 17x1+17+2 1 'Show Color' 'False' 'True' 'show background color?' show_color",
  "-c 1 0 0 1 1 34x1+0+4.5 2 1 1 ' ' 'display policy' policy 'Values Associated With Displayed Color' 'Actual Values from Map Data'",
  "-l 1 0 0 1 1 33x1+1+6 0 'Update mode:' ' Continuous ' 'Button Press' 'Update Mode' update_mode",
  "-w 256x450+1+7.5 'MapValue object' mapval_object",
  "-b +1+3.5 'Display Policy:' blank1",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/editimage/uis/pseudo.subform",
  "@-F 4.3 1 1 50x15+10+15 +19+0.5 'EDITIMAGE' editimage",
  "-M 1 1 38x18+0+0 +0+0 'Pseudo Color' Pseudo",
  "-P 1 0 35x17+0+0 +0+0 'Pseudo Color ' pseudo",
  "-H 1  6x1+21+0 'Help' 'Help for PseudoColor subform' $ENVISION/objects/xvroutine/editimage/help/Pseudo.doc help",
  "-Q 1 0 6x1+28+0 'Close'",
  "-T 1 0 0 1 1 34x2+0+1.5 +0+0 2 'Palette Type' 'palette type' palette_type",
  "-t 1 0 1 0 0 10x1+1+1 'Color Bar' 'Color Bar' dummy",
  "-t 1 0 1 1 0 9.5x1+11+1 'Color Cell' 'Color Cell' dummy",
  "-t 1 0 1 0 0 9.5x1+23+1 'Color Wheel' 'Color Wheel' dummy",
  "-E",
  "-w 276x286+0+4 'Pseudo object' pseudo_object",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/editimage/uis/thresh.subform",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form",
  "-M 1 1 63x11.75+0+0 +0+0 'Threshold' Thresh",
  "-P 1 0 63x11.75+0+0 +3+0 'Threshold: Image Window & Thresholding' thresh",
  "-H 1  6x1+45+0 'Help' 'Help for thresholding & windowing subform' $ENVISION/objects/xvroutine/editimage/help/Thresh.doc help",
  "-Q 1 0 6x1+52+0 'Close'",
  "-a 1 0 8x1+0+1.5 'Reset (undo thresholding)' 'reset' reset",
  "",
  "-l 1 0 0 1 1 23x1+24+1.5 0 'Invert Region?' 'False' 'True' 'accept or reject windowed area' invert",
  "-T 1 0 0 1 1 56.625x1+0+3 +0+0 1 ' ' 'thresholding vs windowing' thresholding",
  "-l 1 0 1 1 0 15x1+0+0 1 'Pixel Clipping' 'false' 'true' 'Pixel Clipping' window",
  "-l 1 0 1 0 0 15.875x1+16+0 1 'Pixel Thresholding' 'false' 'true' 'Pixel Thresholding' threshold",
  "-l 1 0 1 0 0 22.625x1+34+0 0 'Window Contrast Enhancement' 'False' 'TRUE' 'Window Contrast Enhancement' dummy",
  "-E",
  "",
  "-w 512x84+0+4.5 'threshold workspace' thresh_object",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,0,1,2,3,4,
  5,6,7,8,9,10,11,12,13,0,1,2,3,4,5,6,7,8,9,10,
  11,12,13,14,1,1,2,3,4,5,6,7,8,9,10,11,1,1,2,3,
  4,5,6,7,8,9,10,11,12,13,14,15,16,1,1,2,3,4,5,6,
  7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,1,1,2,3,
  4,5,6,7,8,1,1,2,3,4,5,6,7,1,1,2,3,4,5,6,
  7,8,9,1,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,
  17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,
  37,38,1,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,
  18,19,20,21,22,23,24,25,26,27,28,29,30,31,23,0,1,2,3,4,
  5,6,7,8,9,10,11,0,1,2,3,4,5,6,7,8,9,10,11,12,
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,0,1,2,3,4,
  5,6,7,8,9,10,11,12,13,0,1,2,3,4,5,6,7,8,9,10,
  11,12,13,14,15,16,17,23,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,
  3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,
  5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,
  6,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7,7,7,7,
  7,7,7,7,7,7,7,7,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$ENVISION/objects/xvroutine/editimage/uis/editimage.form",
  "$ENVISION/objects/xvroutine/editimage/uis/file.subform",
  "$ENVISION/objects/xvroutine/editimage/uis/options.subform",
  "$ENVISION/objects/xvroutine/editimage/uis/zoom.subform",
  "$ENVISION/objects/xvroutine/editimage/uis/pixel.subform",
  "$ENVISION/objects/xvroutine/editimage/uis/mapvals.subform",
  "$ENVISION/objects/xvroutine/editimage/uis/pseudo.subform",
  "$ENVISION/objects/xvroutine/editimage/uis/thresh.subform",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	268,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	8,
	512};


