 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:53:46 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:53:46 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "extractor.h"
/*-----------------------------------------------------------
| 
|  Routine Name: extractor_get_args
| 
|       Purpose: Gets command line args for extractor
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname extractor
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void extractor_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for extractor is out of sync with arguments specified in extractor's *.pane file; please rerun ghostwriter on extractor.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the extractor structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "policy", KVF_LIST_LABEL,
			  &(clui_info->policy_label),
			  &(clui_info->policy_flag)) &&
	      kclui_get_value(pane, "policy", KVF_LIST_VAL,
			  &(clui_info->policy_list),
			  &(clui_info->policy_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "disp",
			  &(clui_info->disp_logic),
			  &(clui_info->disp_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "mult",
			  &(clui_info->mult_logic),
			  &(clui_info->mult_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "pres", KVF_LIST_LABEL,
			  &(clui_info->pres_label),
			  &(clui_info->pres_flag)) &&
	      kclui_get_value(pane, "pres", KVF_LIST_VAL,
			  &(clui_info->pres_list),
			  &(clui_info->pres_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "shape", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->shape_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->shape_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_logical(pane, "priv",
			  &(clui_info->priv_logic),
			  &(clui_info->priv_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alloc", KVF_LIST_LABEL,
			  &(clui_info->alloc_label),
			  &(clui_info->alloc_flag)) &&
	      kclui_get_value(pane, "alloc", KVF_LIST_VAL,
			  &(clui_info->alloc_cycle),
			  &(clui_info->alloc_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "update",
			  &(clui_info->update_float),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "extractor_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Interactive image Region of Interest (ROI) extraction' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' extractor",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+36+0 'Run' 'execute operation' $ENVISIONBIN/extractor",
  "-H 1  5x1+42+0 'Help' 'help page' $ENVISION/objects/xvroutine/extractor/help/extractor.hlp help",
  "-Q 1 0 5x1+48+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input File' 'File containing image from which to extract ROI' i",
  "-O 1 0 1 0 0 1 52x1+0+3.5 ' ' 'Output ROI ' 'Output image in which to save ROI' o",
  "-x 1 0 1 2 0 34x1+1+5.5 3 1 1 'ROI Extraction Policy: ' 'ROI extraction policy' policy 'Inside Shape' 'Shape Outline' 'Outside Shape'",
  "-l 1 0 1 2 1 37x1+1+6.5 1 'Display Extracted ROI  ' 'False' 'True' 'Display extracted ROI in separate window?' disp",
  "-l 1 0 1 2 1 37x1+1+7.5 0 'Extract Multiple ROIs  ' 'False' 'True' 'Extract multiple ROIs from the same window?' mult",
  "-x 1 0 1 2 1 37x1+1+8.5 3 1 2 'ROI Presentation:      ' 'ROI presentation' pres 'Signal' 'Image' 'Surface'",
  "-T 1 0 1 2 0 53x2.5+0+10 +19+0 1 'ROI Shape:' 'Desired shape for ROI' shape",
  "-t 1 0 1 1 0 10x1+1+1 'Rectangle' 'Rectangle' dummy",
  "-t 1 0 1 0 0 10x1+11+1 'Polyline' 'Polyline' dummy",
  "-t 1 0 1 0 0 10x1+20+1 'Circle' 'Circle' dummy",
  "-t 1 0 1 0 0 10x1+29+1 'Ellipse' 'Ellipse' dummy",
  "-t 1 0 1 0 0 10x1+37+1 'Line' 'Line' dummy",
  "-t 1 0 1 0 0 10x1+43+1 'Freehand' 'Freehand' dummy",
  "-E",
  "-l 1 0 1 2 0 23x1+1+13 0 'Use private colormap?' 'No' 'Yes' 'Use private colormap?' priv",
  "-c 1 0 1 2 0 29x1+24+13 2 1 1 'Color Allocation Policy' 'Color allocation policy' alloc 'Read Only' 'Read Write'",
  "-i 1 0 1 2 0 25x1+1+14.5 -1 1000 -1 0 1 'X Placement' 'X location for GUI autoplacement' x",
  "-i 1 0 1 2 0 25x1+1+15.5 -1 1000 -1 0 1 'Y Placement' 'Y location for GUI autoplacement' y",
  "-f 1 0 1 2 0 23x1+29+15.5 1 1 1 0 1 1 'Update time' 'How often to check input file for modification' update",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/xvroutine/extractor/uis/extractor.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	31,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 30x7+10+15 +12+0 'EXTRACTOR' form",
  "-S 1 1",
  "-H 1  9x1+42+0 'License' 'display license' $BOOTSTRAP/repos/license/License license",
  "-H 1  6x1+52+0 'Help' 'display online help' $ENVISION/objects/xvroutine/extractor/help/Overview.doc help",
  "-Q 1 0 6x1+59+0 'Quit'",
  "-w 200x200+1+1.5 'image display workspace' wksp",
  "-b +12+0 'pixmap:$ENVISION/objects/xvroutine/extractor/pixmaps/extractor.xpm' blank1",
  "-d 1 0 10x1+1+0 'Options' subform",
  "-E",
  "-M 1 0 63x18+10+5 +30+0 'Options' subform",
  "-P 1 0 -1x-1+0+0 +1+0 'Options' pane",
  "-H 1  6x1+43+0 'Help' 'help page' $ENVISION/objects/xvroutine/extractor/help/Options.doc help",
  "-Q 1 0 6x1+51+0 'Close'",
  "-I 1 0 0 1 1 1 54x1+1+1.5 ' ' 'Input File' 'input file' i",
  "-O 1 0 0 1 1 1 53.5x1+1+3 ' ' 'Output File' 'output file' o",
  "-x 1 0 0 1 1 33.5x1+1+4.5 3 1 1 'ROI Extraction Policy: ' 'ROI extraction policy' policy 'Inside Shape' 'Shape Outline' 'Outside Shape'",
  "-l 1 0 0 1 1 36x1+1+5.5 1 'Display Extracted ROI: ' 'False' 'True' 'display extracted ROI' disp",
  "-l 1 0 0 1 1 36x1+1+6.5 0 'Extract Multiple ROIs: ' 'False' 'True' 'extract multiple ROIs' mult",
  "-x 1 0 0 1 1 36x1+1+7.5 3 1 2 'ROI Presentation:      ' 'ROI presentation' pres '  Signal     ' '  Image     ' '  Surface    '",
  "-T 1 0 0 1 1 59.5x2.5+1+9 +22+0 1 'ROI Shape:' 'specifies desired shape for ROI' shape",
  "-t 1 0 1 1 0 10x1+1+1 'Rectangle' 'Rectangle' dummy",
  "-t 1 0 1 0 0 9x1+11+1 'Polyline' 'Polyline' dummy",
  "-t 1 0 1 0 0 9.5x1+21+1 'Circle' 'Circle' dummy",
  "-t 1 0 1 0 0 9.25x1+31+1 'Ellipse' 'Ellipse' dummy",
  "-t 1 0 1 0 0 9x1+41+1 'Line' 'Line' dummy",
  "-t 1 0 1 0 0 8.5x1+51+1 'Freehand' 'Freehand' dummy",
  "-E",
  "-T 1 0 0 1 1 40x3+2+11.5 +0+0 1 'Extraction Mode:' 'How to extract' mode",
  "-l 1 0 1 1 0 6x1+2+1 0 'ROI Specified by Mouse' 'False' 'True' 'ROI specified by mouse' mouse",
  "-l 1 0 1 0 0 6x1+2+2 0 'ROI Specified by Keyboard' 'False' 'True' 'ROI specified from keyboard' keyboard",
  "-E",
  "-i 1 0 0 1 0 19.5x1+6+15 0 9999 0 0 1 'Begin X ' ' ' line_x1",
  "-i 1 0 0 1 0 19.5x1+6+15 0 9999 0 0 1 'Center X ' ' ' circle_x",
  "-i 1 0 0 1 0 19.5x1+6+15 0 9999 0 0 1 'Center X ' ' ' ellipse_x",
  "-i 1 0 0 1 0 19.5x1+6+15 0 9999 0 0 1 'Upper Left X ' ' ' rect_x",
  "-i 1 0 0 1 0 19.5x1+27+15 0 9999 0 0 1 'End X' ' ' line_x2",
  "-i 1 0 0 1 0 14.5x1+27+15 0 9999 0 0 1 'Radius ' ' ' circle_radius",
  "-i 1 0 0 1 0 19.5x1+27+15 0 9999 0 0 1 'A' ' ' ellipse_a",
  "-i 1 0 0 1 0 20x1+27+15 0 9999 0 0 1 'Width  ' ' ' rect_width",
  "-a 1 0 8x2+50+15 'EXTRACT' 'initiate keyboard extraction' extract",
  "-i 1 0 0 1 0 19.5x1+6+16 0 9999 0 0 1 'Begin Y ' ' ' line_y1",
  "-i 1 0 0 1 0 19.5x1+6+16 0 9999 0 0 1 'Center Y ' ' ' circle_y",
  "-i 1 0 0 1 0 19.5x1+6+16 0 9999 0 0 1 'Center Y ' ' ' ellipse_y",
  "-i 1 0 0 1 0 19.5x1+6+16 0 9999 0 0 1 'Upper Left Y ' ' ' rect_y",
  "-i 1 0 0 1 0 19.5x1+27+16 0 9999 0 0 1 'End Y' ' ' line_y2",
  "-i 1 0 0 1 0 19.5x1+27+16 0 9999 0 0 1 'B' ' ' ellipse_b",
  "-i 1 0 0 1 0 20x1+27+16 0 9999 0 0 1 'Height ' ' ' rect_height",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$ENVISION/objects/xvroutine/extractor/uis/extractor.form",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	50,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	1,
	512};


