 /*
  * Khoros: $Id: getimage.h,v 1.15.2.2 1997/05/31 18:54:02 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for getimage
   >>>> 
   >>>>    Written By: Mark Young
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _getimage_h_
#define _getimage_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <envision.h>
#include <xvinclude.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Output filename (required outfile)
 */
char	*o_file;	/* Output filename FILENAME */
int	 o_flag;	/* Output filename FLAG */

/*----- required ME group ----*/
/*
 *  Use screen as source (optional flag)
 */
int	 screen_flag;  	/* Use screen as source FLAG */

/*
 *  Use (interactively indicated) window as source (optional flag)
 */
int	 win_flag;  	/* Use (interactively indicated) window as source FLAG */

/*
 *  Name/ID of source window (optional string)
 */
char	*wname_string;	/* Name/ID of source window STRING */
int	 wname_flag;   	/* Name/ID of source window FLAG */

/*-- required ME group end ---*/

/*
 *  Save ALL of window or screen? (optional flag)
 */
int	 all_flag;  	/* Save ALL of window or screen? FLAG */

/*
 *  Grab the window manager decoration? (optional flag)
 */
int	 decor_flag;  	/* Grab the window manager decoration? FLAG */

/*
 *  Output image in bitmap format? (optional flag)
 */
int	 b_flag;  	/* Output image in bitmap format? FLAG */

/*----- optional ME group ----*/
/*
 *  Output in ASCII format (optional flag)
 */
int	 ascii_flag;  	/* Output in ASCII format FLAG */

/*
 *  Output as KDF (Khoros 2.0 Format) (optional flag)
 */
int	 kdf_flag;  	/* Output as KDF (Khoros 2.0 Format) FLAG */

/*
 *  Output in Application Visualization System (AVS) format (optional flag)
 */
int	 avs_flag;  	/* Output in Application Visualization System (AVS) format FLAG */

/*
 *  Output in X11 Bitmap (XBM) format (optional flag)
 */
int	 xbm_flag;  	/* Output in X11 Bitmap (XBM) format FLAG */

/*
 *  Output in Portable Any Map (PNM) format (optional flag)
 */
int	 pnm_flag;  	/* Output in Portable Any Map (PNM) format FLAG */

/*
 *  Output as VIFF (Khoros 1.0 Format) (xvimage) (optional flag)
 */
int	 viff_flag;  	/* Output as VIFF (Khoros 1.0 Format) (xvimage) FLAG */

/*
 *  Output in Encapsulated PostScript Format (optional flag)
 */
int	 eps_flag;  	/* Output in Encapsulated PostScript Format FLAG */

/*
 *  Output in X11 Window Dump (XWD) format (optional flag)
 */
int	 xwd_flag;  	/* Output in X11 Window Dump (XWD) format FLAG */

/*
 *  Output in Raw (headerless) format (optional flag)
 */
int	 raw_flag;  	/* Output in Raw (headerless) format FLAG */

/*
 *  Output in X Window Pixmap (XPM) format (optional flag)
 */
int	 xpm_flag;  	/* Output in X Window Pixmap (XPM) format FLAG */

/*
 *  Output in Sun Raster format (optional flag)
 */
int	 rast_flag;  	/* Output in Sun Raster format FLAG */

/*-- optional ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void getimage_get_args PROTO((kaddr));
void getimage_usage_additions PROTO((void));
void getimage_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
void capture_image PROTO((void));
/* -include_routines_end */

#endif
