 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:54:04 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 18:54:04 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "getimage.h"
/*-----------------------------------------------------------
| 
|  Routine Name: getimage_get_args
| 
|       Purpose: Gets command line args for getimage
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname getimage
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void getimage_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for getimage is out of sync with arguments specified in getimage's *.pane file; please rerun ghostwriter on getimage.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the getimage structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_flag(pane, "all",
			  &(clui_info->all_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "decor",
			  &(clui_info->decor_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "b",
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "screen",
			  &(clui_info->screen_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "win",
			  &(clui_info->win_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "wname",
			  &(clui_info->wname_string),
			  &(clui_info->wname_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ascii",
			  &(clui_info->ascii_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "kdf",
			  &(clui_info->kdf_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "avs",
			  &(clui_info->avs_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "xbm",
			  &(clui_info->xbm_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pnm",
			  &(clui_info->pnm_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "viff",
			  &(clui_info->viff_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "eps",
			  &(clui_info->eps_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "xwd",
			  &(clui_info->xwd_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "raw",
			  &(clui_info->raw_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "xpm",
			  &(clui_info->xpm_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "rast",
			  &(clui_info->rast_flag))))
	{
	    kerror(NULL, "getimage_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Capture image from screen to Khoros 2.1 KDF ' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Get_Image",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'Execute getimage' $ENVISIONBIN/getimage",
  "-H 1  5x1+41+0 'Help' 'Man page for getimage' $ENVISION/objects/xvroutine/getimage/help/getimage.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-t 1 0 1 0 0 25x1+0+5.5 'Save ALL of window or screen?' 'Save ALL of window or screen?' all",
  "-t 1 0 1 0 0 41x1+0+7.5 'Grab the window manager decoration?' 'Grab the window manager decoration?' decor",
  "-t 1 0 1 0 0 41x1+0+8.5 'Output image in bitmap format?' 'Output image in bitmap format?' b",
  "-O 1 0 0 1 0 1 52x1+0+10.5 ' ' 'Output filename' 'Output filename' o",
  "-C 1",
  "-t 1 0 1 1 0 18x1+0+2 'Use screen as source' 'Use screen as source' screen",
  "-t 1 0 1 0 0 38x1+0+3 'Use (interactively indicated) window as source' 'Use (interactively indicated) window as source' win",
  "-s 1 0 1 0 0 52x1+0+4 ' ' 'Name/ID of source window (use % xwininfo)' 'Name/ID of source window' wname",
  "-E",
  "-C 0",
  "-t 1 0 1 0 0 11x1+1+12 'ASCII' 'Output in ASCII format' ascii",
  "-t 1 0 1 1 0 22.75x1+24+12 'Output in KDF (Khoros 2.1) format' 'Output as KDF (Khoros 2.0 Format)' kdf",
  "-t 1 0 1 0 0 11x1+1+13 'AVS' 'Output in Application Visualization System (AVS) format' avs",
  "-t 1 0 1 0 0 10.75x1+24+13 'XBM' 'Output in X11 Bitmap (XBM) format' xbm",
  "-t 1 0 1 0 0 5.5x1+1+14 'PNM' 'Output in Portable Any Map (PNM) format' pnm",
  "-t 1 0 1 0 0 22.75x1+24+14 'VIFF (Khoros 1.0 Format--xvimage)' 'Output as VIFF (Khoros 1.0 Format) (xvimage)' viff",
  "-t 1 0 1 0 0 19.625x1+1+15 'Encapsulated Postscript' 'Output in Encapsulated PostScript Format' eps",
  "-t 1 0 1 0 0 10.75x1+24+15 'XWD' 'Output in X11 Window Dump (XWD) format' xwd",
  "-t 1 0 1 0 0 10.75x1+1+16 'Raw' 'Output in Raw (headerless) format' raw",
  "-t 1 0 1 0 0 10.75x1+24+16 'XPM' 'Output in X Window Pixmap (XPM) format' xpm",
  "-t 1 0 1 0 0 10.75x1+1+17 'Sun Raster' 'Output in Sun Raster format' rast",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/xvroutine/getimage/uis/getimage.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	34,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


