 /*
  * Khoros: $Id: usage.c,v 1.16.2.5 1997/06/07 20:35:13 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.16.2.5 1997/06/07 20:35:13 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "putdata.h"
/*-----------------------------------------------------------
| 
|  Routine Name: putdata_get_args
| 
|       Purpose: Gets command line args for putdata
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname putdata
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void putdata_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for putdata is out of sync with arguments specified in putdata's *.pane file; please rerun ghostwriter on putdata.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the putdata structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "priv",
			  &(clui_info->priv_logic),
			  &(clui_info->priv_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alloc", KVF_LIST_LABEL,
			  &(clui_info->alloc_label),
			  &(clui_info->alloc_flag)) &&
	      kclui_get_value(pane, "alloc", KVF_LIST_VAL,
			  &(clui_info->alloc_cycle),
			  &(clui_info->alloc_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "cmap",
			  &(clui_info->cmap_file),
			  &(clui_info->cmap_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x",
			  &(clui_info->x_int),
			  &(clui_info->x_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "width",
			  &(clui_info->width_int),
			  &(clui_info->width_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "clip",
			  &(clui_info->clip_file),
			  &(clui_info->clip_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y",
			  &(clui_info->y_int),
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "height",
			  &(clui_info->height_int),
			  &(clui_info->height_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "update",
			  &(clui_info->update_float),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "xoffset",
			  &(clui_info->xoffset_int),
			  &(clui_info->xoffset_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "yoffset",
			  &(clui_info->yoffset_int),
			  &(clui_info->yoffset_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "image",
			  &(clui_info->image_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "complex", KVF_LIST_LABEL,
			  &(clui_info->complex_label),
			  &(clui_info->complex_flag)) &&
	      kclui_get_value(pane, "complex", KVF_LIST_VAL,
			  &(clui_info->complex_list),
			  &(clui_info->complex_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "normaltype", KVF_LIST_LABEL,
			  &(clui_info->normaltype_label),
			  &(clui_info->normaltype_flag)) &&
	      kclui_get_value(pane, "normaltype", KVF_LIST_VAL,
			  &(clui_info->normaltype_cycle),
			  &(clui_info->normaltype_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "normalmethod", KVF_LIST_LABEL,
			  &(clui_info->normalmethod_label),
			  &(clui_info->normalmethod_flag)) &&
	      kclui_get_value(pane, "normalmethod", KVF_LIST_VAL,
			  &(clui_info->normalmethod_list),
			  &(clui_info->normalmethod_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "redcol", KVF_LIST_LABEL,
			  &(clui_info->redcol_label),
			  &(clui_info->redcol_flag)) &&
	      kclui_get_value(pane, "redcol", KVF_LIST_VAL,
			  &(clui_info->redcol_list),
			  &(clui_info->redcol_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "greencol", KVF_LIST_LABEL,
			  &(clui_info->greencol_label),
			  &(clui_info->greencol_flag)) &&
	      kclui_get_value(pane, "greencol", KVF_LIST_VAL,
			  &(clui_info->greencol_list),
			  &(clui_info->greencol_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "bluecol", KVF_LIST_LABEL,
			  &(clui_info->bluecol_label),
			  &(clui_info->bluecol_flag)) &&
	      kclui_get_value(pane, "bluecol", KVF_LIST_VAL,
			  &(clui_info->bluecol_list),
			  &(clui_info->bluecol_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "redfn",
			  &(clui_info->redfn_string),
			  &(clui_info->redfn_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "greenfn",
			  &(clui_info->greenfn_string),
			  &(clui_info->greenfn_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "bluefn",
			  &(clui_info->bluefn_string),
			  &(clui_info->bluefn_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "imageicon",
			  &(clui_info->imageicon_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "iconsize",
			  &(clui_info->iconsize_int),
			  &(clui_info->iconsize_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "zoom",
			  &(clui_info->zoom_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "zoomx",
			  &(clui_info->zoomx_int),
			  &(clui_info->zoomx_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "zoomy",
			  &(clui_info->zoomy_int),
			  &(clui_info->zoomy_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "zoomfactor",
			  &(clui_info->zoomfactor_double),
			  &(clui_info->zoomfactor_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "animate",
			  &(clui_info->animate_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "dir", KVF_LIST_LABEL,
			  &(clui_info->dir_label),
			  &(clui_info->dir_flag)) &&
	      kclui_get_value(pane, "dir", KVF_LIST_VAL,
			  &(clui_info->dir_list),
			  &(clui_info->dir_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "control", KVF_LIST_LABEL,
			  &(clui_info->control_label),
			  &(clui_info->control_flag)) &&
	      kclui_get_value(pane, "control", KVF_LIST_VAL,
			  &(clui_info->control_list),
			  &(clui_info->control_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "speed",
			  &(clui_info->speed_double),
			  &(clui_info->speed_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "pixel",
			  &(clui_info->pixel_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "valuewidth",
			  &(clui_info->valuewidth_int),
			  &(clui_info->valuewidth_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "valueheight",
			  &(clui_info->valueheight_int),
			  &(clui_info->valueheight_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "showcolorvalue",
			  &(clui_info->showcolorvalue_logic),
			  &(clui_info->showcolorvalue_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "mapval",
			  &(clui_info->mapval_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "mapwidth",
			  &(clui_info->mapwidth_int),
			  &(clui_info->mapwidth_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "mapheight",
			  &(clui_info->mapheight_int),
			  &(clui_info->mapheight_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "showcolormap",
			  &(clui_info->showcolormap_logic),
			  &(clui_info->showcolormap_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "displaypolicy", KVF_LIST_LABEL,
			  &(clui_info->displaypolicy_label),
			  &(clui_info->displaypolicy_flag)) &&
	      kclui_get_value(pane, "displaypolicy", KVF_LIST_VAL,
			  &(clui_info->displaypolicy_cycle),
			  &(clui_info->displaypolicy_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "palette",
			  &(clui_info->palette_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "palettetype", KVF_LIST_LABEL,
			  &(clui_info->palettetype_label),
			  &(clui_info->palettetype_flag)) &&
	      kclui_get_value(pane, "palettetype", KVF_LIST_VAL,
			  &(clui_info->palettetype_list),
			  &(clui_info->palettetype_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "plot2d",
			  &(clui_info->plot2d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "axis2d",
			  &(clui_info->axis2d_logic),
			  &(clui_info->axis2d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "ptype2d", KVF_LIST_LABEL,
			  &(clui_info->ptype2d_label),
			  &(clui_info->ptype2d_flag)) &&
	      kclui_get_value(pane, "ptype2d", KVF_LIST_VAL,
			  &(clui_info->ptype2d_list),
			  &(clui_info->ptype2d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "ltype2d", KVF_LIST_LABEL,
			  &(clui_info->ltype2d_label),
			  &(clui_info->ltype2d_flag)) &&
	      kclui_get_value(pane, "ltype2d", KVF_LIST_VAL,
			  &(clui_info->ltype2d_list),
			  &(clui_info->ltype2d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "mtype2d", KVF_LIST_LABEL,
			  &(clui_info->mtype2d_label),
			  &(clui_info->mtype2d_flag)) &&
	      kclui_get_value(pane, "mtype2d", KVF_LIST_VAL,
			  &(clui_info->mtype2d_list),
			  &(clui_info->mtype2d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "pcolor2d",
			  &(clui_info->pcolor2d_string),
			  &(clui_info->pcolor2d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "plot3d",
			  &(clui_info->plot3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "ptype3d", KVF_LIST_LABEL,
			  &(clui_info->ptype3d_label),
			  &(clui_info->ptype3d_flag)) &&
	      kclui_get_value(pane, "ptype3d", KVF_LIST_VAL,
			  &(clui_info->ptype3d_list),
			  &(clui_info->ptype3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "ltype3d", KVF_LIST_LABEL,
			  &(clui_info->ltype3d_label),
			  &(clui_info->ltype3d_flag)) &&
	      kclui_get_value(pane, "ltype3d", KVF_LIST_VAL,
			  &(clui_info->ltype3d_list),
			  &(clui_info->ltype3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "mtype3d", KVF_LIST_LABEL,
			  &(clui_info->mtype3d_label),
			  &(clui_info->mtype3d_flag)) &&
	      kclui_get_value(pane, "mtype3d", KVF_LIST_VAL,
			  &(clui_info->mtype3d_list),
			  &(clui_info->mtype3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "stype3d", KVF_LIST_LABEL,
			  &(clui_info->stype3d_label),
			  &(clui_info->stype3d_flag)) &&
	      kclui_get_value(pane, "stype3d", KVF_LIST_VAL,
			  &(clui_info->stype3d_list),
			  &(clui_info->stype3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "pcolor3d",
			  &(clui_info->pcolor3d_string),
			  &(clui_info->pcolor3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "fcolor3d",
			  &(clui_info->fcolor3d_string),
			  &(clui_info->fcolor3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xrot3d",
			  &(clui_info->xrot3d_float),
			  &(clui_info->xrot3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "zrot3d",
			  &(clui_info->zrot3d_float),
			  &(clui_info->zrot3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "edist3d",
			  &(clui_info->edist3d_float),
			  &(clui_info->edist3d_flag))))
	{
	    kerror(NULL, "putdata_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +10+0 'General Non-Interactive Data Display Functions' subform",
  "-P 1 0 47x38.3636+0+1 +0+0 ' ' putdata",
  "-D 1 0 8x1+1+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+90+0 'Run' 'do operation in foreground' $ENVISIONBIN/putdata",
  "-H 1  5x1+96+0 'Help' 'man page for putdata' $ENVISION/objects/xvroutine/putdata/help/putdata.hlp help",
  "-Q 1 0 5x1+102+0 'Close'",
  "-I 1 0 0 1 0 1 53x1+0+3.5 ' ' 'Input File            ' 'File containing data' i",
  "-l 1 0 1 2 0 22x1+55+3.5 0 'Use private colormap?' 'No' 'Yes' 'Use private colormap?' priv",
  "-c 1 0 1 2 0 29x1+79+3.5 2 1 1 'Color Allocation Policy' 'Color allocation policy' alloc 'Read Only' 'Read Write'",
  "-I 1 0 1 0 0 0 53x1+0+4.5 ' ' 'Input Colormap ' 'File containing alternate colormap' cmap",
  "-i 1 0 1 2 0 24x1+55+5 -1 1000 -1 0 1 'X Placement' 'X location for GUI autoplacement' x",
  "-i 1 0 1 2 0 23x1+84+5 -1 1000 512 0 1 'Window Width ' 'Window width' width",
  "-I 1 0 1 0 0 0 53x1+0+5.5 ' ' 'Input Clip Gate' 'File containing clip mask' clip",
  "-i 1 0 1 2 0 24x1+55+6 -1 1000 -1 0 1 'Y Placement' 'Y location for GUI autoplacement' y",
  "-i 1 0 1 2 0 23x1+84+6 -1 1000 512 0 1 'Window Height' 'Window height' height",
  "-f 1 0 1 2 0 24x1+55+7.5 1 1 2 0 1 1 'Update time' 'How often to check input file for modification' update",
  "",
  "-b +11+7.5 'Image Display Options' blank1",
  "-b +69+23.5 'Map Values Display Options' blank2",
  "-b +9+30.5 'Palette Display Options' blank3",
  "-b +10+25.5 'Pixel Display Options' blank4",
  "-C 1",
  "-B 0",
  "-i 1 0 1 1 0 41x1+0+9 0 10000 0 1 0 'Image X Offset' 'Specifies the horizontal offset within the image display' xoffset",
  "-i 1 0 1 1 0 41x1+0+10 0 10000 0 1 0 'Image Y Offset' 'Specifies the vertical offset within the image display' yoffset",
  "-t 1 0 1 1 0 12.125x1+55+10.5 'Image Display' 'Displays the image, given image data' image",
  "-x 1 0 1 1 0 41x1+0+11 9 1 5 'Complex Data Conversion Type' 'Specifies the conversion type for complex data' complex 'Real' 'Imaginary' 'Phase' 'Magnitude ' 'Log Mangnitude + 1 ' 'Log Magnitude ' 'Log Magnitude Sqrt + 1 ' 'Log Magnitude Sqrt ' 'Magnitude Sqrt '",
  "-c 1 0 1 1 0 41x1+0+12 2 1 1 'Type Of Normalization       ' 'Specifies how data is normalized for display' normaltype 'Global' 'Local'",
  "-x 1 0 1 1 0 41x1+0+13 4 1 1 'Normalization Method        ' 'Defines the algorithm used in data normalization' normalmethod 'Range: Maximum' 'Range: +/- 1 Std. Dev.' 'Range: +/- 2 Std. Dev.' 'Range: +/- 3 Std. Dev '",
  "-x 1 0 1 1 0 41x1+0+14 3 1 1 'Change Red Map Column       ' 'Specify which column in a map is to be displayed as red' redcol 'Map Column 0' 'Map Column 1' 'Map Column 2'",
  "-x 1 0 1 1 0 41x1+0+15 3 1 2 'Change Green Map Column     ' 'Specify which column in a map is to be displayed as green' greencol 'Map Column 0' 'Map Column 1' 'Map Column 2'",
  "-x 1 0 1 1 0 41x1+0+16 3 1 3 'Change Blue Map Column      ' 'Specify which column in a map is to be displayed as blue' bluecol 'Map Column 0' 'Map Column 1' 'Map Column 2'",
  "-s 1 0 1 1 0 41x1+0+17 'M0' 'Define Map Function For Red   ' 'Provides an equation that specifies the red map column ' redfn",
  "-s 1 0 1 1 0 41x1+0+18 'M1' 'Define Map Function For Green ' 'Provides an equation that specifies the green map column ' greenfn",
  "-s 1 0 1 1 0 41x1+0+19 'M2' 'Define Map Function For Blue  ' 'Provides an equation that specifies the blue map column ' bluefn",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 15.125x1+55+11.5 'ImageIcon Display' 'Displays an icon image, given image data' imageicon",
  "-i 1 0 1 0 0 39x1+55+16.5 0 512 100 1 0 'Image Icon Size' 'Controls the size of the icon in pixels' iconsize",
  "-E",
  "",
  "-B 0",
  "-t 1 0 1 0 0 11.375x1+55+12.5 'Zoom Display' 'Zooms in on image data' zoom",
  "-i 1 0 1 0 0 39x1+0+22 1 1 0 0 0 'X Position ' 'Specifies the x position where the zoom window is focused' zoomx",
  "-i 1 0 1 0 0 39x1+0+23 1 1 0 0 0 'X Position ' 'Specifies the y position in the which where the zoom window is focused' zoomy",
  "-h 1 0 1 0 0 39x1+0+24 0.001 100 8 0 0 0 'Zoom Factor' 'Specifies the zoom factor' zoomfactor",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 13.625x1+55+13.5 'Animate Display' 'Animates an image, given sequenced image data' animate",
  "-x 1 0 1 0 0 39x1+55+20 5 1 5 'Animate Direction' 'Controls the direction in which images are sequenced' dir '<< (Sequence Backward)' '<  (Backward 1 Frame)' 'Stop' '>  (Forward 1 Frame) ' '>> (Sequence Forward) '",
  "-x 1 0 1 0 0 39x1+55+21 3 1 1 'Animate Control  ' 'Controls how animation sequencing is performed' control 'Loop' 'Single' 'Autoreverse'",
  "-h 1 0 1 0 0 39x1+55+22 0 5 1 0 1 0 'Frame Speed         ' 'Controls the frame speed' speed",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 12.125x1+71+10.5 'Pixel Display' 'Displays the value data of the object' pixel",
  "-i 1 0 1 0 0 41x1+0+27 1 1 7 0 0 'Width of Pixel Value Display ' 'Specifies the number of pixel values along width' valuewidth",
  "-i 1 0 1 0 0 41x1+0+28 1 1 9 0 0 'Height of Pixel Value Display' 'Specifies the number of pixel values along height' valueheight",
  "-l 1 0 1 0 0 41x1+0+29 1 'Show Color Of Pixel as Cell Background?' 'No' 'Yes' 'Specifies the background color of the pixel' showcolorvalue",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 15.125x1+71+11.5 'Map Value Display' 'Displays the map value data of the object' mapval",
  "-i 1 0 1 0 0 41x1+55+25 1 1 7 0 0 'Width of Map Display ' 'Specifies the number of map values along width' mapwidth",
  "-i 1 0 1 0 0 41x1+55+26 1 1 9 0 0 'Height of Map Display' 'Specifies the number of map values along height' mapheight",
  "-l 1 0 1 0 0 41x1+55+27 1 'Show Color Of Pixel as Cell Background?' 'No' 'Yes' 'Specifies the background color of the pixel' showcolormap",
  "-c 1 0 1 0 0 41x1+55+28 2 1 1 'Display Policy' 'Specifies whether to display normalized or un-normalized map values' displaypolicy 'Display Normalized Values' 'Display Actual Values'",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 13.625x1+71+12.5 'Palette Display' 'Displays the colormap of the object' palette",
  "-x 1 0 1 0 0 41x1+0+32 3 1 1 'Palette Type  ' 'Specifies how the color palette is presented' palettetype 'Color Bar' 'Color Cell' 'Color Wheel'",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 12.875x1+89+10.5 'Plot2D Display' 'Creates a 2D plot of the data' plot2d",
  "-l 1 0 1 0 0 41x1+0+35.5 1 'Display Axis (2D)       ' 'No' 'Yes' 'Display 2D axes with 2D plot' axis2d",
  "-x 1 0 1 0 0 41x1+0+36.5 5 1 1 'Plot Type (2D)          ' 'Specifies the plot type for 2D plots' ptype2d 'Line' 'Discrete' 'Bar Graph' 'Poly Marker' 'Line Marker'",
  "-x 1 0 1 0 0 41x1+0+37.5 7 1 7 'Line Type (2D)          ' 'Specifies the line type for 2D plots' ltype2d 'Solid' 'Dotted' 'Dot Dash' 'Short Dash ' 'Long Dash ' 'Odd Dashed ' 'Grid Dotted '",
  "-x 1 0 1 0 0 41x1+0+38.5 16 1 12 'Marker Type (2D)        ' 'Specifies the marker type for 2D plots' mtype2d 'Arc' 'Bow Tie' 'Box' 'Caret ' 'Circle ' 'Cross ' 'Dagger ' 'Diamond ' 'Dot ' 'Hexagon ' 'Point ' 'Square ' 'Triangle ' 'V ' 'X ' 'Pixel '",
  "-y 1 0 1 0 0 41x1+0+39.5 21 6 'Plot Color (2D)' 'Specifies the plot color for 2D plots' pcolor2d 'Black' 'Blue' 'Green' 'Orange' 'Pink' 'Red' 'White' 'Yellow' 'Coral' 'Forest Green' 'Light Grey' 'Lime Green' 'Magenta' 'Orange Red' 'Plum' 'Salmon' 'Sea Green' 'Thistle' 'Turquoise' 'Violet' 'Wheat'",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 12.875x1+89+11.5 'Plot3D Display' 'Creates a 3D plot of the data' plot3d",
  "-x 1 0 1 0 0 41x1+55+31 9 20 20 'Plot Type (3D)          ' 'Specifies the plot type for 3D plots' ptype3d 'Line' 'Wire Frame' 'Mesh' 'Horizon' 'Scatter' 'Impulse' 'Contour 2D' 'Contour 3D' 'Constant Shade'",
  "-x 1 0 1 0 0 41x1+55+32 7 1 1 'Line Type (3D)          ' 'Specifies the line type for 3D plots' ltype3d 'Solid' 'Dotted' 'Dot Dash' 'Short Dash' 'Long Dash' 'Odd Dashed' 'Grid Dotted'",
  "-x 1 0 1 0 0 41x1+55+33 16 1 12 'Marker Type (3D)        ' 'Specifies the marker type for 3D plots' mtype3d 'Arc' 'Bow Tie' 'Box' 'Caret' 'Circle' 'Cross' 'Dagger' 'Diamond' 'Dot' 'Hexagon' 'Point' 'Square' 'Triangle' 'V' 'X' 'Pixel '",
  "-x 1 0 1 0 0 41x1+55+34 3 1 1 'Surface Shade Type (3D) ' 'Specifies the surface shade type for 3D plots' stype3d 'Imagery' 'Elevation' 'Normals'",
  "-y 1 0 1 0 0 41x1+55+35 21 6 'Plot Color (3D)' 'Specifies the plot color for 3D plots' pcolor3d 'Black' 'Blue' 'Green' 'Orange' 'Pink' 'Red' 'White' 'Yellow' 'Coral' 'Forest Green' 'Light Grey' 'Lime Green' 'Magenta' 'Orange Red' 'Plum' 'Salmon' 'Sea Green' 'Thistle' 'Turquoise' 'Violet' 'Wheat'",
  "-y 1 0 1 0 0 41x1+55+36 21 7 'Fill Color (3D)' 'Specifies the fill color for 3D plots' fcolor3d 'Black' 'Blue' 'Green' 'Orange' 'Pink' 'Red' 'White' 'Yellow' 'Coral' 'Forest Green' 'Light Grey' 'Lime Green' 'Magenta' 'Orange Red' 'Plum' 'Salmon' 'Sea Green' 'Thistle' 'Turquoise' 'Violet' 'Wheat'",
  "-f 1 0 1 0 0 41x1+55+37 0 360 100 7 0 0 'Rotation About X        ' 'Specifies the rotation angle about the X axis' xrot3d",
  "-f 1 0 1 0 0 41x1+55+38 0 360 100 7 0 0 'Rotation About Z        ' 'Specifies the rotation angle about the Z axis' zrot3d",
  "-f 1 0 1 0 0 41x1+55+39 -50 50 0 7 0 0 'Eye Distance            ' 'Specifies the eye distance' edist3d",
  "-E",
  "-E",
  "",
  "-b +66+9 'Select Data Display Operation:' blank5",
  "-b +9+34 '2D Plot Display Options:' blank6",
  "-b +68+29.5 '3D Plot Display Options:' blank7",
  "-b +18+2 'Input File Options:' blank8",
  "-b +69+18.5 'Animate Display Options' blank9",
  "-b +69+15 'Icon Display Options' blank10",
  "-b +10+20.5 'Zoom Display Options' blank11",
  "-b +71+2 'Visualization Display Options:' blank12",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
  61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
  81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,
  101,102,103,104,105,106,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/xvroutine/putdata/uis/putdata.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	106,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


