/*
  * Khoros: $Id: do_contents.c,v 1.7 1997/01/20 06:48:48 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: do_contents.c,v 1.7 1997/01/20 06:48:48 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Functionality routines for pane contents
   >>>> 
   >>>>  Private: 
   >>>> 	contents_o
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "spectrum.h"

/*-----------------------------------------------------------
| 
|  Routine Name: contents_o
| 
|       Purpose: Do routine which is called when
|                  output selection o is used
| 
|         Input: contents_info - ptr to PaneInfo struct for contents pane
| 
|        Output: None
|    Written By: 
|          Date: Mar 30, 1995
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void contents_o(
     Contents_contents *contents_info)
{
        LegendEntry *legend_ptr;
	char        *contents;
	kfile       *file;
	char        *date;

	if (contents_info->o == NULL)
	{
            errno = SPC_USER_ERROR;
	    kerror(NULL, "contents_o", 
                   "Please provide the name of an output file!");
	    kinfo(KHOSTILE, "doofus!");

	}

        /* see if legend file already exists/prompt to over-write*/
        if ((file = kfopen(contents_info->o, "r")) != NULL)
        {
           if (!(koverwrite(KSTANDARD, contents_info->o)))
           {
               kfclose(file);
               return;
           }
           kfclose(file);
        }

	if ((file = kfopen(contents_info->o, "w")) == NULL)
	{
            errno = SPC_FILE_ACCESS;
	    kerror(NULL, "contents_o", 
	           "Unable to open output file %s", contents_info->o);
	    return;
	}

	kfprintf(file, "\n---- Summary of Class Contents ----\n\n");
	if (gui_info->Files->files->in_image != NULL)
	   kfprintf(file, "Input Image:  %s\n",
		    gui_info->Files->files->in_image);
	if (gui_info->Files->files->in_legend != NULL)
	   kfprintf(file, "Input Legend: %s\n", 
		    gui_info->Files->files->in_legend);

	date = spc_get_date();
	if (date != NULL)
	{
	   kfprintf(file, "Date:         %s\n", date);
	   kfree_and_NULL(date);
	}
	
	kfprintf(file, "\n\n");

        legend_ptr = spc_legend_list;
        while (legend_ptr != NULL)
        {
            contents = spc_set_classcontents_label(legend_ptr);
	    kfprintf(file, "%s\n\n", contents);
	    kfree_and_NULL(contents);
            legend_ptr = legend_ptr->next;
        }
	kfclose(file);

	kinfo(KSTANDARD, "Class contents written to ascii file %s", 
	      contents_info->o);
}

