 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:54:50 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:54:50 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "spectrum.h"
/*-----------------------------------------------------------
| 
|  Routine Name: spectrum_get_args
| 
|       Purpose: Gets command line args for spectrum
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname spectrum
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void spectrum_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for spectrum is out of sync with arguments specified in spectrum's *.pane file; please rerun ghostwriter on spectrum.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the spectrum structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "l",
			  &(clui_info->l_file),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "t",
			  &(clui_info->t_file),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "p",
			  &(clui_info->p_file),
			  &(clui_info->p_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "method", KVF_LIST_LABEL,
			  &(clui_info->method_label),
			  &(clui_info->method_flag)) &&
	      kclui_get_value(pane, "method", KVF_LIST_VAL,
			  &(clui_info->method_cycle),
			  &(clui_info->method_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "priv",
			  &(clui_info->priv_logic),
			  &(clui_info->priv_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "alloc", KVF_LIST_LABEL,
			  &(clui_info->alloc_label),
			  &(clui_info->alloc_flag)) &&
	      kclui_get_value(pane, "alloc", KVF_LIST_VAL,
			  &(clui_info->alloc_cycle),
			  &(clui_info->alloc_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "update",
			  &(clui_info->update_float),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "spectrum_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Interactive Image Classification System' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' spectrum",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+38+0 'Run' 'execute spectrum' $ENVISIONBIN/spectrum",
  "-H 1  5x1+44+0 'Help' 'help page for spectrum' $ENVISION/objects/xvroutine/spectrum/help help",
  "-Q 1 0 5x1+50+0 'Close'",
  "-I 1 0 1 1 0 0 55x1+0+2 ' ' 'Input File     ' 'File containing input image' i",
  "-I 1 0 1 1 0 0 55x1+0+3 ' ' 'Input Legend   ' 'File containing input legend' l",
  "-I 1 0 1 1 0 1 55x1+0+4 ' ' 'Input Disp File' 'File containing input display environment file' t",
  "-I 1 0 1 1 0 1 55x1+0+5 ' ' 'Input Pre Class' 'File containing input predetermined classification file' p",
  "-c 1 0 1 1 0 35x1+1+7 2 1 1 'Add/Delete Cluster method ' 'Add/delete cluster method' method 'Paint' 'Polygon'",
  "-l 1 0 1 2 0 23x1+1+9 0 'Use private colormap?' 'No' 'Yes' 'Use private colormap?' priv",
  "-c 1 0 1 2 0 29x1+26+9 2 1 1 'Color Allocation Policy' 'Color allocation policy' alloc 'Read Only' 'Read Write'",
  "-i 1 0 1 2 0 25x1+1+10.5 -1 1000 -1 0 1 'X placement' 'X location for GUI autoplacement' x",
  "-i 1 0 1 2 0 25x1+1+11.5 -1 1000 -1 0 1 'Y placement' 'Y location for GUI autoplacement' y",
  "-f 1 0 1 2 0 25x1+28+11.5 1 1 1 0 1 1 'Update time' 'How often to check input file for modification' update",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/xvroutine/spectrum/uis/spectrum.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	22,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 70x3+10+15 +36+0 'S P E C T R U M' spectrum",
  "-S 1 0",
  "-H 1  10x1+1+0.5 'License' 'Spectrum license' $BOOTSTRAP/repos/license/License license",
  "-H 1  6x1+69+0.5 'Help' 'online introduction' $ENVISION/objects/xvroutine/spectrum/help/01.Intro.doc help",
  "-Q 1 0 6x1+76+0.5 'Quit'",
  "-w 256x256+23+4 'workspace widget' image_workspace",
  "-a 1 0 17x1+3+21 'Create Class' 'add a new class' add_class",
  "-a 1 0 17x1+3+22 'Delete Class' 'delete a class' delete_class",
  "-a 1 0 17x1+3+23 'Select  Class' 'select current class' select",
  "-T 1 0 0 1 1 15.75x3+2+24.5 +0+0 1 'Cluster Operation:' 'Flag toggle selection' cluster_operation",
  "-t 1 0 1 1 0 10x1+1+1 '   ' '   ' dummy",
  "-t 1 0 1 0 0 10x1+1+2 '   ' '   ' dummy",
  "-E",
  "-a 1 0 15x1+5+25.5 'Add Cluster' 'add cluster manually' add_cluster_manually",
  "-a 1 0 15x1+5+26.5 'Delete Cluster' 'delete cluster manually' delete_cluster_manually",
  "-a 1 0 15x1+5+27.5 'Transfer Cluster' 'transfer cluster from one class to another' trans",
  "-a 1 0 17x1.13636+3+29 'Reassign Cluster' 'reassign cluster number' reassign",
  "-a 1 0 17x1.13636+3+30.5 'AutoClassify' 'auto classify the remainder of the clusters' autoclass",
  "-b +36+0 'pixmap:$ENVISION/objects/xvroutine/spectrum/pixmaps/spectrum.xpm' b0",
  "-b +3+20 'Class Operation:' cl_blk",
  "-b +1+18.5 'Select Cluster From Image' select_blk",
  "-b +23+1.5 'Current Class:' label_blk",
  "-b +23+2.5 'none' currclass_blk",
  "-d 1 0 17x1.5+3+2 'Files' Files",
  "-d 1 0 17x1.5+3+4 'Display' Disp",
  "-d 1 0 17x1.5+3+12 'Spectral Curve' Curve",
  "-d 1 0 17x1.5+3+6 'Legend Control' Legend",
  "-d 1 0 17x1.5+3+8 'Zoom On Image' Zoom",
  "-d 1 0 17x1.5+3+10 'Scatter Plot' Scatter",
  "-d 1 0 17x1.5+3+14 'Cluster Stats' Stats",
  "-d 1 0 17x1.5+3+16 'Class Contents' Contents",
  "-E",
  "@-k $ENVISION/objects/xvroutine/spectrum/uis/files.subform",
  "@-F 4.3 1 1 70x3+10+15 +19+0.5 'S P E C T R U M' form",
  "-M 1 1 50x13+0+0 +0+0 'Files' Files",
  "-P 1 0 50x13+0+0 +1+0 'Files: Input and Output' files",
  "-H 1  5x1+43+0 'Help' 'online help for Files' $ENVISION/objects/xvroutine/spectrum/help/05.Files.doc help",
  "-Q 1 0 6x1+50+0 'Close'",
  "-I 1 0 0 1 1 1 58x1+0+2.5 ' ' '        Image' 'filename of new image' in_image",
  "-I 1 0 0 1 1 1 58x1+0+3.5 ' ' '       Legend' 'input legend filename' in_legend",
  "-I 1 0 0 1 1 1 58x1+0+4.5 ' ' 'Display Environment' 'input ascii file contining display environment info' in_environ",
  "-I 1 0 0 1 1 1 58x1+0+5.5 ' ' 'Classification File' 'class file' in_classes",
  "-O 1 0 0 1 1 1 58x1+0+8.5 ' ' '        Image' 'output image filename' out_image",
  "-O 1 0 0 1 1 1 58x1+0+9.5 ' ' '       Legend' 'output legend filename' out_legend",
  "-O 1 0 0 1 1 1 58x1+0+10.5 ' ' 'Grouped Image' 'output VIFF file containing grouped image' out_group",
  "-O 1 0 0 1 1 1 58x1+0+11.5 ' ' 'Colormap Only' 'output maps only' out_maps",
  "-b +14+1.5 'INPUT FILES:' blk1",
  "-b +14+7.5 'OUTPUT FILES:' blk10",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/spectrum/uis/disp.subform",
  "@-F 4.3 1 1 70x3+10+15 +19+0.5 'S P E C T R U M' form",
  "-M 1 1 50x15+0+0 +0+0 'Display' Disp",
  "-P 1 0 50x17+0+0 +1+0.5 'Display: Control Over Display of Image' disp",
  "-H 1  6x1+36+0 'Help' 'online help for display subform' $ENVISION/objects/xvroutine/spectrum/help/06.Display.doc help",
  "-Q 1 0 6x1+43+0 'Close'",
  "-c 1 0 1 2 1 50x1+0+2 2 1 1 'Color Allocation Policy' 'Color allocation policy' alloc 'Read Only' 'Read Write'",
  "-c 1 0 0 1 1 47x1+3+3.5 2 1 2 'Type Of Normalization' 'normalization type ' norm_type 'Global' 'Local'",
  "",
  "-T 1 0 0 1 1 31.125x5+19+4.5 +3+0 3 'Normalization Method' 'normalization method' norm_method",
  "-i 1 0 1 0 0 10x1+1+1 1 1 1 0 0 '0 <= values <= Max Colors' '0 <= values <= Max Colors' dummy",
  "-i 1 0 1 0 0 10x1+1+2 1 1 4 0 0 '-3*(std.dev) <= values <= 3*(std.dev)' '-3*(std.dev) <= values <= 3*(std.dev)' dummy",
  "-i 1 0 1 1 0 10x1+1+3 1 1 3 0 0 '-2*(std.dev) <= values <= 2*(std.dev)' '-2*(std.dev) <= values <= 2*(std.dev)' dummy",
  "-i 1 0 1 0 0 10x1+1+4 1 1 2 0 0 '-1*(std.dev) <= values <= 1*(std.dev)' '-1*(std.dev) <= values <= 1*(std.dev)' dummy",
  "-E",
  "",
  "-a 1 0 12x1.5+3+6.5 'Change Names' 'change band names' change_mapcol_names",
  "-a 1 0 12x1.5+3+8 'List   Names' 'list band names' list_mapcol_names",
  "-a 0 0 14.5x1.68182+2+10.5 'Transformations' 'apply transformation defined in display environment file' t",
  "-a 1 0 10x1+20+12.5 'RED' 'red band' red",
  "-a 1 0 10x1+20+13.5 'GREEN' 'green band' green",
  "-a 1 0 10x1+20+14.5 'BLUE' 'blue band' blue",
  "-s 1 0 0 1 1 48.75x1+1+17 'M0' ' RED ' 'function defining red' red_func",
  "-s 1 0 0 1 1 48.75x1+1+18 'M1' 'GREEN' 'function defining green' green_func",
  "-s 1 0 0 1 1 48.75x1+1+19 'M2' 'BLUE ' 'function defining blue' blue_func",
  "-b +1+5.5 'Names Assoc. w/ Bands' blank3A",
  "-b +20+10.5 'Change Bands Currently' blank4A",
  "-b +20+11.5 'Displayed as Red, Green, Blue:' blank4B",
  "-b +31+12.5 'Band 1 ' redcol",
  "-b +31+13.5 'Band 2 ' grcol",
  "-b +31+14.5 'Band 3 ' blcol",
  "-b +5+16 'Define Red, Green & Blue as Functions of Bands:' blank7",
  "-b +3+12.5 'Current Transform:' blank1A",
  "-b +3+13.5 'none' curr_trans",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/spectrum/uis/curve.subform",
  "@-F 4.3 1 1 70x3+10+15 +19+0.5 'S P E C T R U M' form",
  "-M 1 0 68x13+0+0 +0+0 'Spectral Curve' Curve",
  "-P 1 0 68x13+0+0 +1+0 'Spectral Curve' curve",
  "-H 1  6x1+51+0 'Help' 'online help for spectral curve' $ENVISION/objects/xvroutine/spectrum/help/10.Curve.doc help",
  "-Q 1 0 6x1+58+0 'Close'",
  "-l 1 0 0 1 1 39x1+1+1.5 0 'Update Mode: ' 'Continuous  (single plot)' 'Button Press (multiple plot)' 'update mode' update_mode",
  "-a 1 0 8.5x1+42+1.5 'Clear' 'clears plot wksp when multiple plots are displayed' clear",
  "-w 300x70+1+3 'spectral curve widget' curve_workspace",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/spectrum/uis/legend.subform",
  "@-F 4.3 1 1 70x3+10+15 +19+0.5 'S P E C T R U M' form",
  "-M 1 1 60x20+0+0 +0+0 'Legend' Legend",
  "-P 1 0 60x20+0+0 +2+0 'Legend Control' legend",
  "-H 1  6x1+43+0 'Help' 'online help for legend' $ENVISION/objects/xvroutine/spectrum/help/07.Legend.doc help",
  "-Q 1 0 6x1+50+0 'Close'",
  "-a 1 0 18x1.13636+1+1.5 'Transfer Class(es)' 'transfer classes' transfer",
  "-a 1 0 19x1.13636+21+1.5 'Hide Selected Classes' 'hide classes' hide",
  "-a 1 0 14.5x1.13636+41+1.5 'Hide ALL Classes' 'hides all classes' hide_all",
  "-a 1 0 18x1.13636+1+2.5 'Catch-All Class' 'catch-all class' catch_all",
  "-a 1 0 19x1.13636+21+2.5 'Show Selected Classes' 'show classes' show",
  "-a 1 0 14.5x1.13636+41+2.5 'Show ALL Classes' 'shows all classes' show_all",
  "-a 1 0 19x1.13636+21+3.5 'Empty Selected Classes' 'empty classes' empty",
  "-a 1 0 14.5x1.13636+41+3.5 'Empty ALL Classes' 'empties all classes' empty_all",
  "-w 430x320+1+5 'legend workspace' legend_workspace",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/spectrum/uis/zoom.subform",
  "@-F 4.3 1 1 70x3+10+15 +19+0.5 'S P E C T R U M' spectrum",
  "-M 1 0 41x16+0+0 +0+0 'Zoom ' Zoom",
  "-P 1 0 41x16+0+0 +1+0 'Zoom On Image' zoom",
  "-H 1  6x1+24+0 'Help' 'online help for Zoom' $ENVISION/objects/xvroutine/spectrum/help/08.Zoom.doc help",
  "-Q 1 0 6x1+31+0 'Close'",
  "-l 1 0 0 1 1 31x1+1+1.5 0 'Update Mode' 'Continuous' 'Button Press' 'zoom update mode' zoommode",
  "-h 1 0 0 1 1 33x1+1+3 0.00001 200 2 0 0 0 'Zoom Factor:' 'zoomfactor' zoomfactor",
  "-w 266x210+1+4.5 'zoom widget' zoom_workspace",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/spectrum/uis/scatterplot.subform",
  "@-F 4.3 1 1 70x3+10+15 +36+0 'S P E C T R U M' spectrum",
  "-M 1 0 57x25+0+0 +0+0 'Scatter Plot' Scatter",
  "-P 1 0 57x25+0+0 +2+0 'Scatter Plot' scatter",
  "-H 1  6x1+41+0 'Help' 'onlinehelp for scatterplot' $ENVISION/objects/xvroutine/spectrum/help/09.Plot.doc help",
  "-Q 1 0 6x1+48+0 'Close'",
  "-a 1 0 22x1+1+1.5 'Band Displayed as X' 'x column' x_column",
  "-a 1 0 22x1+1+2.5 'Band Displayed as Y' 'y column' y_column",
  "-s 1 0 0 1 1 53x1+1+3.5 'M0' 'Function Displayed as X' 'function defining x' x_func",
  "-s 1 0 0 1 1 53x1+1+4.5 'M1' 'Function Displayed as Y' 'function defining y' y_func",
  "-a 1 0 10x1+32+6 'Set Zoom' 'Set zoom' set",
  "-a 1 0 9x1+44+6 'Reset' 'Reset after zoom' reset",
  "-w 425x450+0+7.25 'workspace widget' plot_workspace",
  "#     -c 0 0 0 1 1 37.875x1+3+12 3 1 1 'Plotting Option' 'non-proportional, proportional windowed or nonwindowed' prop 'Non-Proportional' 'Proportional, Windowed' 'Proportional, Non-Windowed'",
  "-b +24+1.5 'Band 1' xcol_blank",
  "-b +24+2.5 'Band 2' ycol_blank",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/spectrum/uis/stats.subform",
  "@-F 4.3 1 0 30x7+10+20 +6+0 'Master Form' form",
  "-M 1 0 30x5+0+0 +0+0 'Cluster Statistics' Stats",
  "-P 1 0 50x5+0+0 +1+0 'Cluster Statistics' stats",
  "-H 1  6x1+43+0 'Help' 'online help page' $ENVISION/objects/xvroutine/spectrum/help/11.Stats.doc help",
  "-Q 1 0 6x1+50+0 'Close'",
  "-w 440x130+1+1.5 'workspace for displaying statistics' stats_wksp",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/spectrum/uis/contents.subform",
  "@-F 4.3 1 0 30x7+10+20 +6+0 'Master Form' form",
  "-M 1 1 59x15+0+0 +0+0 'Class Contents' Contents",
  "-P 1 0 59x15+0+0 +1+0 'Class Contents' contents",
  "-H 1  6x1+43+0 'Help' 'online help page' $ENVISION/objects/xvroutine/spectrum/help/12.Contents.doc help",
  "-Q 1 0 6x1+50+0 'Close'",
  "-O 1 0 0 1 1 1 55x1+1+2 ' ' 'Output File' 'output file' o",
  "-w 440x308+1+3.5 'workspace for displaying contents of classes' contents_wksp",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,0,1,2,3,4,5,6,7,
  8,9,10,11,12,13,14,15,16,17,0,1,2,3,4,5,6,7,8,9,
  10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,
  30,31,32,33,34,35,0,1,2,3,4,5,6,7,8,9,10,0,1,2,
  3,4,5,6,7,8,9,10,11,12,13,14,15,16,0,1,2,3,4,5,
  6,7,8,9,10,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,
  15,16,17,0,1,2,3,4,5,6,7,8,0,1,2,3,4,5,6,7,
  8,9,41,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
  2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,4,4,4,
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,5,5,5,5,5,5,
  5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
  6,6,6,7,7,7,7,7,7,7,7,7,8,8,8,8,8,8,8,8,
  8,8,8,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$ENVISION/objects/xvroutine/spectrum/uis/spectrum.form",
  "$ENVISION/objects/xvroutine/spectrum/uis/files.subform",
  "$ENVISION/objects/xvroutine/spectrum/uis/disp.subform",
  "$ENVISION/objects/xvroutine/spectrum/uis/curve.subform",
  "$ENVISION/objects/xvroutine/spectrum/uis/legend.subform",
  "$ENVISION/objects/xvroutine/spectrum/uis/zoom.subform",
  "$ENVISION/objects/xvroutine/spectrum/uis/scatterplot.subform",
  "$ENVISION/objects/xvroutine/spectrum/uis/stats.subform",
  "$ENVISION/objects/xvroutine/spectrum/uis/contents.subform",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	163,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	9,
	512};


