 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:55:13 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 18:55:13 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "xprism.h"
/*-----------------------------------------------------------
| 
|  Routine Name: xprism_get_args
| 
|       Purpose: Gets command line args for xprism
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname xprism
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void xprism_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for xprism is out of sync with arguments specified in xprism's *.pane file; please rerun ghostwriter on xprism.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the xprism structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "xprism_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "xprism_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "xprism_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i4",
			  &(clui_info->i4_file),
			  &(clui_info->i4_flag))))
	{
	    kerror(NULL, "xprism_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "update",
			  &(clui_info->update_float),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "xprism_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "xprism_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "xprism_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "xprism_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Interactive 2D & 3D Plotting' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' plot",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation ' $ENVISIONBIN/xprism",
  "-H 1  6x1+41+0 'Help' 'man page for xprism' $ENVISION/objects/xvroutine/xprism/help/xprism.hlp help",
  "-Q 1 0 6x1+47+0 'Close'",
  "-I 1 0 1 0 0 1 52x1+0+2 ' ' 'Input File 1' 'Input plot 1' i1",
  "-I 1 0 1 0 0 1 52x1+0+3.1 ' ' 'Input File 2' 'Input plot 2' i2",
  "-I 1 0 1 0 0 1 52x1+0+4.2 ' ' 'Input File 3' 'Input plot 3' i3",
  "-I 1 0 1 0 0 1 52x1+0+5.3 ' ' 'Input File 4' 'Input plot 4' i4",
  "-f 1 0 1 0 0 23x1+0+7 1 1 1 0 1 1 'Update time' 'How often to check input file for modification' update",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$ENVISION/objects/xvroutine/xprism/uis/xprism.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 50x15+10+15 +21+0.5 'XPRISM' xprism",
  "-S 1 0",
  "",
  "-H 1  11x1+45+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-H 1  6x1+58+0 'Help' 'XPRISM Overview Help' $ENVISION/objects/xvroutine/xprism/help/Overview.doc help",
  "-Q 1 0 6x1+66+0 'Quit'",
  "-w 460x425+14+2 'main workspace' workspace",
  "",
  "-n 1 0 12x1+1+10 'RESET WC\\'s' 'Reset the world coordinate system' reset_wcs",
  "-n 1 0 12x1+1+11.5 'INDICATOR' 'Adds a new indicator to current area' add_indicator",
  "",
  "-n 1 0 12x1+1+13 'REMOVE AREA' 'Removes currently selected area' remove_area",
  "",
  "-n 1 0 12x1+1+14.5 'REFRESH' 'Refresh currently selected area' refresh_area",
  "-n 1 0 12x1+1+16 'CLEAR' 'Clears all areas' clear_layout",
  "",
  "-n 1 0 12x1.27273+1+18.5 'Layout' 'activate the menus for layout' layout_menu",
  "-b +18+0.2 'pixmap:$ENVISION/objects/xvroutine/xprism/pixmaps/xprism.xpm' b0",
  "-d 1 0 12x1.27273+1+2 'Plot' Plot",
  "-d 1 0 12x1.3+1+3.4 'Options' Options",
  "-d 1 0 12x1.3+1+6.2 'Screen Dump' Print",
  "-d 1 0 12x1.3+1+7.6 'Colormaps' Colormap",
  "-d 1 0 12x1.27273+1+20 'Defaults' Deflts",
  "-E",
  "@-k $ENVISION/objects/xvroutine/xprism/uis/plot.subform",
  "@-F 4.3 1 0 70x7+10+20 +35+1 ' ' form",
  "-M 1 1 55x17+10+8 +28+0 'Plot Utilities' Plot",
  "-G 1 26x17+0+0 +26+0.3 ' '",
  "",
  "-H 1  6x1+51+0 'Help' 'Help for Plot Subform' $ENVISION/objects/xvroutine/xprism/help/plot/Plot.doc help",
  "-Q 1 0 6x1+59+0 'Close'",
  "",
  "-g 1 0 12x1+1+2 'Files' file",
  "-g 1 1 12x1+1+3.5 'Functions' function",
  "-g 1 0 12x1+1+5 'Plot Types' plot_control",
  "-E",
  "",
  "-P 1 0 -1x-1+14+2 +1+0 'Input Files' file",
  "-b +2+2 'Input filename for Object :' input_blank",
  "",
  "-H 1  6x1+43+0 'Help' 'Help for Input and Output File pane' $ENVISION/objects/xvroutine/xprism/help/plot/Files.doc help",
  "-I 1 0 0 1 1 1 43x1+2+3.5 ' ' 'Filename' 'Filename to be plotted' input_file",
  "-T 1 0 0 1 0 29x2+2+5 +0+0 1 'Where shall I plot?' 'where to put new plot' plot_where",
  "-t 1 0 1 1 0 10x1+3+1 'New Area' 'new plot goes in new area' new_area",
  "-t 1 0 1 0 0 14x1+15+1 'Selected Area' 'new plot goes in selected area' selected_area",
  "-E",
  "-T 1 0 0 1 0 46.5x2.5+2+7.5 +0+0 1 'Plot Dimension' 'type of object: 2d plot, 3d plot, best guess' object_type",
  "-t 1 0 1 1 0 10x1+3+1 'Best Guess' 'choice1' dummy",
  "-t 1 0 1 0 0 10x1+15+1 '2D Plot' 'choice2' dummy",
  "-t 1 0 1 0 0 8.375x1+25+1 '3D Plot' 'choice3' dummy",
  "-E",
  "-E",
  "",
  "-P 1 0 -1x-1+14+2 +1+0 'Input 2D/3D Functions' function",
  "-H 1  6x1+43+0 'Help' 'Input form help' $ENVISION/objects/xvroutine/xprism/help/plot/Functions.doc help",
  "-c 1 0 0 1 1 21.5x1+25+1.5 2 2 2 'Function Dimension' '2D or 3D function' plot_dim '2D' '3D'",
  "-s 1 0 0 1 0 46x2.5+0+2.5 ' ' ' ' '3D function to be plotted' func_3D",
  "-s 1 0 0 1 0 46x2.5+0+2.5 ' ' ' ' '2D function to be plotted' func_2D",
  "-s 1 0 0 1 0 13x1+3+7 '-1.0' ' ' ' ' x_min",
  "-s 1 0 0 1 0 13x1+16+7 '1.0' ' ' ' ' x_max",
  "-s 1 0 0 1 0 9.5x1+30+7 '40' ' ' ' ' xnum_pts",
  "-s 1 0 0 1 0 13x1+3+8 '-1.0' ' ' ' ' y_min",
  "-s 1 0 0 1 0 13x1+16+8 '1.0' ' ' ' ' y_max",
  "-s 1 0 0 1 0 9.5x1+30+8 '40' ' ' ' ' ynum_pts",
  "-T 1 0 0 1 0 28.5x2+1+10.5 +0+0 1 'Where shall I plot?' 'where to put new plot' where_plot",
  "-t 1 0 1 1 0 10x1+3+1 'New Area' 'new plot goes in new area' new_area",
  "-t 1 0 1 0 0 14x1+15+1 'Selected Area' 'new plot goes in selected area' selected_area",
  "-E",
  "-a 1 0 12x1.5+31+11 'PLOT FUNCTION' 'action button description' plot_function",
  "-b +1+1.5 '3D Function  f(x,y)=' func_3D_blk",
  "-b +1+1.5 '2D Function  f(x)=' func_2D_blk",
  "-b +4+6 '  Minimum            Maximum           # Points' blank1",
  "-b +1+7 'X' X_blk",
  "-b +1+8 'Y' Y_blk",
  "-E",
  "",
  "-P 1 0 -1x-1+14+2 +1+0 'Plots Types' plot_control",
  "-H 1  6x1+43+0 'Help' 'Help for Plot Types pane' $ENVISION/objects/xvroutine/xprism/help/PlotTypes.doc help",
  "-T 1 0 0 1 0 42.5x3+1+2 +0+0 1 'Display 2D Plot as :' 'Plot Type to use when plotting' plot2d_type",
  "-t 1 0 1 1 0 10x1+2+1 '2D ' 'choose 2D plot' twod",
  "-t 1 0 1 0 0 10x1+18+1 'Discrete' 'choose discrete plot' discrete",
  "-t 1 0 1 0 0 10x1+31+1 'Bar Graph' 'Choose bar graph' histogram",
  "-t 1 0 1 0 0 10x1+2+2 'Polymarker' 'Choose polymarker plot' polymarker",
  "-t 1 0 1 0 0 10.375x1+18+2 'Linemarker' 'Choose linemarker plot' linemarker",
  "-E",
  "",
  "-T 1 0 0 1 0 49.5x5+1+6 +0+0 1 'Display 3D Plot as :' 'Plot Type to use when plotting' plot3d_type",
  "-t 1 0 1 1 0 10x1+2+1 '3D ' 'choose 3D plot' threed",
  "-t 1 0 1 0 0 10x1+18+1 'Wireframe' 'choose wireframe plot' wireframe",
  "-t 1 0 1 0 0 10x1+31+1 'Mesh' 'Choose mesh' mesh",
  "-t 1 0 1 0 0 10x1+2+2 'Colormesh' 'Choose colormesh plot' colormesh",
  "-t 1 0 1 0 0 10x1+18+2 'Horizon' 'Choose horizon plot' horizon",
  "-t 1 0 1 0 0 10x1+31+2 'Scatter' 'Choose scatter plot' scatter",
  "-t 1 0 1 0 0 10x1+2+3 'Impulse' 'Choose impulse plot' dummy",
  "-t 1 0 1 0 0 12.5x1+18+3 '2D Contour' 'Choose 2D Contour plot' dummy",
  "-t 1 0 1 0 0 12.5x1+31+3 '3D Contour' 'Choose 3D Contour plot' dummy",
  "-E",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/xprism/uis/options.subform",
  "@-F 4.3 1 0 32x5+10+20 +0+0 ' ' form",
  "-M 1 1 45x18+0+0 +0+0 'Options' Options",
  "-P 1 0 -1x-1+0+0 +1+1.5 'Options: Edit Object Attributes / Delete Objects' options",
  "-H 1  6x1+28+0 'Help' 'display online help' $ENVISION/objects/xvroutine/xprism/help/Options.doc help",
  "-Q 1 0 6x1+35+0 'Close'",
  "-z 1 0 0 1 1 16.5x10+3+3 0 1 0 0 'Area List' 'list of areas' area_list",
  "-z 1 0 0 1 1 18.125x10+22+3 0 1 0 0 'Plot & Axis List' 'list of plots' plot_list",
  "-a 1 0 15x1+4+13.5 'Open Menuform' 'opens the area menuform' open_area",
  "-a 1 0 15x1+23+13.5 'Open Menuform' 'opens the plot/axis menuform' open_plot",
  "-a 1 0 15x1+4+15 'Delete' 'deletes area' delete_area",
  "-a 1 0 15x1+23+15 'Delete' 'deletes plot/axis' delete_plot",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/xprism/uis/print.subform",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form",
  "-M 1 0 56x8+10+8 +28+0 'Screen Dump' Print",
  "-P 1 0 -1x-1+0+0 +1+0 'Output: Screen Dump' screen_dump",
  "-b +1+4.5 'Output Screendump File' display_output_blank",
  "",
  "-H 1  6x1+38+0 'Help' 'Help for Input and Output File pane' $ENVISION/objects/xvroutine/xprism/help/Output.doc help",
  "-Q 1 0 6x1+45+0 'Close'",
  "",
  "-T 1 0 0 1 0 28x2+1+1.5 +0+0 2 'Area(s) from which to create screen dump:' 'screen dump to kobject' dump_what",
  "-t 1 0 1 0 0 14x1+3+1 'Selected Area' 'grab image of selected area only' dump_selected",
  "-t 1 0 1 1 0 10x1+18+1 'All Areas' 'grab image of Layout holding plots' dump_all",
  "-E",
  "-O 1 0 0 1 1 1 52x1+1+5.5 ' ' 'Filename' 'output screendump file' display_file",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/xprism/uis/colormap.subform",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form ",
  "-M 1 0 52x14+10+8 +0+0 'Colormap' Colormap",
  "-P 1 0 -1x-1+0+0 +0+0 ' ' colormap",
  "-H 1  6x1+35+0 'Help' 'Help for Colormap subform' $ENVISION/objects/xvroutine/xprism/help/Colormaps.doc help",
  "-Q 1 0 6x1+42+0 'Close'",
  "-w 175x150+1+2.5 'general-purpose workspace' wksp1",
  "-w 175x150+25+2.5 'general-purpose workspace' wksp2",
  "-b +4+1.5 'Autocolor Procedures' b1",
  "-b +29+1.5 'Colormap Operations' b2",
  "-E",
  "-E",
  "@-k $ENVISION/objects/xvroutine/xprism/uis/defaults.subform",
  "@-F 4.3 1 0 170x7+10+20 +35+1 ' ' form",
  "-M 1 1 48x9+0+0 +0+0 'Area Defaults' Deflts",
  "-P 1 0 -1x-1+0+0 +1+0 'Area Defaults' deflts",
  "-H 1  6x1+31+0 'Help' 'Help for Default subform' $ENVISION/objects/xvroutine/xprism/help/Defaults.doc help",
  "-Q 1 0 6x1+38+0 'Close'",
  "-x 1 0 0 1 0 40x1+2+1.5 3 1 3 'Differentiate New Plots' 'Method to use for distinguishing new plots' new_plot 'By Color' 'By Line Type' 'By Color & Line'",
  "-l 1 0 0 1 0 28x1+2+3 0 'Title for New Areas  ' 'Hidden ' 'Displayed' 'Title on or off by Default' display_title",
  "-l 1 0 0 1 0 28x1+2+4 0 'Date for New Areas   ' 'Hidden ' 'Displayed' 'Date on or off by Default' display_date",
  "-y 1 0 0 1 0 40x1+1+5.5 11 2 'Area Background Color' 'Default Background color for areas' background 'white' 'black' 'grey' 'thistle' 'teal' 'magenta' 'red' 'thistle' 'violet' 'seagreen' 'blue'",
  "-y 1 0 0 1 0 40x1+1+6.5 11 1 'Area Foreground Color' 'Default Foreground color for areas' foreground 'white' 'black' 'grey' 'thistle' 'teal' 'magenta' 'red' 'thistle' 'violet' 'seagreen' 'blue'",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
  16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,
  36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,
  56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,0,
  1,2,3,4,5,6,7,8,9,10,11,12,13,0,1,2,3,4,5,6,
  7,8,9,10,11,12,13,14,15,0,1,2,3,4,5,6,7,8,9,10,
  11,0,1,2,3,4,5,6,7,8,9,10,11,12,30,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,
  2,2,2,2,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,
  3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,
  4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$ENVISION/objects/xvroutine/xprism/uis/xprism.form",
  "$ENVISION/objects/xvroutine/xprism/uis/plot.subform",
  "$ENVISION/objects/xvroutine/xprism/uis/options.subform",
  "$ENVISION/objects/xvroutine/xprism/uis/print.subform",
  "$ENVISION/objects/xvroutine/xprism/uis/colormap.subform",
  "$ENVISION/objects/xvroutine/xprism/uis/defaults.subform",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	155,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	6,
	512};


