 /*
  * Khoros: $Id: xprism.h,v 1.14.2.2 1997/05/31 18:55:17 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for xprism
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _xprism_h_
#define _xprism_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <envision.h>
#include <xvinclude.h>
#include "form_info.h"

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Alternate UIS file (optional infile)
 */
char	*form_file;	/* Alternate UIS file FILENAME */
int	 form_flag;	/* Alternate UIS file FLAG */

/*
 *  (x,y) position for automatic GUI placement */

int	 x_int;		/* x position INT */
int	 x_flag;	/* x position FLAG */

int	 y_int;		/* y position INT */
int	 y_flag;	/* y position FLAG */

/*
 *  Input plot 1 (optional infile)
 */
char	*i1_file;	/* Input plot 1 FILENAME */
int	 i1_flag;	/* Input plot 1 FLAG */

/*
 *  Input plot 2 (optional infile)
 */
char	*i2_file;	/* Input plot 2 FILENAME */
int	 i2_flag;	/* Input plot 2 FLAG */

/*
 *  Input plot 3 (optional infile)
 */
char	*i3_file;	/* Input plot 3 FILENAME */
int	 i3_flag;	/* Input plot 3 FLAG */

/*
 *  Input plot 4 (optional infile)
 */
char	*i4_file;	/* Input plot 4 FILENAME */
int	 i4_flag;	/* Input plot 4 FLAG */

/*
 *  How often to check input file for modification (optional float)
 */
float	 update_float;	/* How often to check input file for modification FLOAT */
int	 update_flag;   	/* How often to check input file for modification FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
extern gui_info_struct *gui_info;

extern uis_struct gui_uis_spec;
/* -include_variables */
extern kform_struct *area_list, *plot_list;
extern xvobject     layout, current_area, current_plot;
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void xprism_get_args PROTO((kaddr));
void xprism_usage_additions PROTO((void));
void xprism_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* utilities.c */
void change_area           PROTO((xvobject, kaddr, kaddr));
void create_plot           PROTO((kobject, int, int));
void input_file            PROTO((char *));
void set_function_pane_gui PROTO((void));
void init_colormap_display PROTO((kobject));
void update_area_list      PROTO((xvobject, kaddr, kaddr));
void update_plot_list      PROTO((xvobject, kaddr, kaddr));
void quit_cleanup          PROTO((kaddr));

/* function.c */
void input_function PROTO((void));
/* -include_routines_end */

#endif
