 /*
  * Khoros: $Id: geometry.h,v 1.6.2.2 1997/05/02 15:25:45 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose:
   >>>>
   >>>>    Written By: ghostwriter
   >>>>
   >>>>          Date: 
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _geometry_geometry_h_
#define _geometry_geometry_h_

#include <geometry.h>

	/*-------------------------------------*
	|       #include
	---------------------------------------*/

#include "geometry/geom.h"

	/*-------------------------------------*
	|       #defines
	---------------------------------------*/

/**
  * a somewhat artificial restriction on the length of geom
  * object names.  this is for the rmonster renderer, not geom svcs.
**/
#define KGEOM_MAX_NAME_LENGTH 64


/**
  * interpolation method flags for the 2d gridders.
**/
#define INVERSE_DISTANCE_2D 0
#define FOURIER_ANALYSIS_2D 1

	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/


	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/


	/*-------------------------------------*
	|       macros
	---------------------------------------*/


	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/

int lunion_boxes PROTO((vertex_3d *, vertex_3d *, vertex_3d *, vertex_3d *,
                        vertex_3d *, vertex_3d *));

	/* Ghostwriter Prototypes:  Do Not Erase This Comment */

int lg3daxis PROTO((kobject, kgeom_object *,int,int,int,int,char *,
		    float *,char *));
int lgbindtexture PROTO((kgeom_object *,kgeom_object *,char *));

int lgcmaplegend PROTO((kobject, kgeom_object *, char *, int, int, int, 
			float *, float *, float *, float *,int,int,char *,int,
			char *,float *,float *,int,char *));

int lgcreate2dtex PROTO((kobject, kgeom_object *, float *, int));
int lgisa2dtex PROTO((kgeom_object *));

int lgcuberille PROTO((kobject,kobject,kgeom_object *,float *,char *));

int lgimpfacet PROTO((kfile *, char *, kgeom_object *));

int lgspheres PROTO((kobject, kobject, kgeom_object *, int, float *, char *));

int lgtubeness PROTO((kgeom_object *, float, int, int));

int lgquadmesh PROTO((kobject,int,kobject,kgeom_object *,char *,int,float *,int,int));
int lcompute_quadmesh_vertex_normals PROTO((vertex_3d *,vertex_3d **, int, int));

int lgoctmesh PROTO((kobject,int,kobject,kgeom_object *,char *,int,int));

int lglocstats PROTO((kobject,int));

int lgpoints PROTO((kobject,kobject,int,kobject,int,char *));

int lgtransform PROTO((kgeom_object *,float *,float *,int));


int lglinexyz PROTO((kfile *,kgeom_object *, char *,int));
int lglinecolor PROTO((kfile *, kobject,kgeom_object *, char *));


int lkgridder_2d PROTO((kobject,kobject,int,float *,int, float *,int, int));



void lcompute_3dgrad PROTO((vertex_3d *,int,int,float *,float *,float *,vertex_3d *,vertex_3d *,vertex_3d *,vertex_3d *,int));

int lplot_xyz_color PROTO((kfile *,kobject, kobject, char *));

int lcolorizer PROTO((void));




int lget_coords PROTO((kobject, int, int, int, vertex_3d *));

int lgcolorize PROTO((kobject, kobject, kobject));

int lggencmap PROTO((int, float *, int, float *, int, float *, float *, kobject));



int lkslicer PROTO((kobject, int, int, int, float, int, float, int, int, 
			kobject));

int lcompute_bbox PROTO((vertex_3d *, int, vertex_3d *, vertex_3d *));
int lcompute_bbox_ptrs PROTO((vertex_3d **, int, vertex_3d *, vertex_3d *));
int lget_min_max_ptrs PROTO((vertex_3d **, int, vertex_3d **,vertex_3d **,vertex_3d **,vertex_3d **));
int lresample_memory PROTO((float *src,float *dest,int size_in[5], float size_out[5],int elements_first));

void lerp PROTO((float *s,float *d,int sn,int dn));

#endif /* _geometry_geometry_h_ */
/* Don't add after this point */
