 /*
  * Khoros: $Id: g3daxis.h,v 1.8.2.2 1997/05/31 18:49:30 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for g3daxis
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _g3daxis_h_
#define _g3daxis_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
#include <geometry/geometry.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Data file containing 3d location data. (required infile)
 */
char	*i_file;	/* Data file containing 3d location data. FILENAME */
int	 i_flag;	/* Data file containing 3d location data. FLAG */

/*
 *  Geometry object containing a 3d axis. (required outfile)
 */
char	*o_file;	/* Geometry object containing a 3d axis. FILENAME */
int	 o_flag;	/* Geometry object containing a 3d axis. FLAG */

/*----- required ME group ----*/
/*
 *  Indicates if the extents of the axes should be computed from the input location data. (optional logical)
 */
int	 do_auto_extents_logic;	/* Indicates if the extents of the axes should be computed from the input location data. LOGIC */
int	 do_auto_extents_flag;  	/* Indicates if the extents of the axes should be computed from the input location data. FLAG */

	/*---- nested optional MI group ----*/
/*
 *  Minimum X coordinate for user-specified extents. (optional float)
 */
float	 xmin_float;	/* Minimum X coordinate for user-specified extents. FLOAT */
int	 xmin_flag;   	/* Minimum X coordinate for user-specified extents. FLAG */

/*
 *  Maximum X coordinate for user-specified extents. (optional float)
 */
float	 xmax_float;	/* Maximum X coordinate for user-specified extents. FLOAT */
int	 xmax_flag;   	/* Maximum X coordinate for user-specified extents. FLAG */

/*
 *  Minimum Y coordinate for user-specified extents. (optional float)
 */
float	 ymin_float;	/* Minimum Y coordinate for user-specified extents. FLOAT */
int	 ymin_flag;   	/* Minimum Y coordinate for user-specified extents. FLAG */

/*
 *  Maximum Y coordinate for user-specified extents. (optional float)
 */
float	 ymax_float;	/* Maximum Y coordinate for user-specified extents. FLOAT */
int	 ymax_flag;   	/* Maximum Y coordinate for user-specified extents. FLAG */

/*
 *  Minimum Z coordinate for user-specified extents. (optional float)
 */
float	 zmin_float;	/* Minimum Z coordinate for user-specified extents. FLOAT */
int	 zmin_flag;   	/* Minimum Z coordinate for user-specified extents. FLAG */

/*
 *  Maximum Z coordinate for user-specified extents. (optional float)
 */
float	 zmax_float;	/* Maximum Z coordinate for user-specified extents. FLOAT */
int	 zmax_flag;   	/* Maximum Z coordinate for user-specified extents. FLAG */

	/*-- nested optional MI group end --*/

/*-- required ME group end ---*/

/*
 *  Name used as the internal object name. (optional string)
 */
char	*name_string;	/* Name used as the internal object name. STRING */
int	 name_flag;   	/* Name used as the internal object name. FLAG */

/*----- optional MI group ----*/
/*
 *  Will cause tick marks to be generated along each axis. (optional logical)
 */
int	 do_ticks_logic;	/* Will cause tick marks to be generated along each axis. LOGIC */
int	 do_ticks_flag;  	/* Will cause tick marks to be generated along each axis. FLAG */

/*
 *  Indicates the number of tick marks/text along each axis. (optional integer)
 */
int	 tdensity_int; 	/* Indicates the number of tick marks/text along each axis. INT */
int	 tdensity_flag;	/* Indicates the number of tick marks/text along each axis. FLAG */

/*
 *  Will cause text to appear in the geometry. (optional logical)
 */
int	 do_labels_logic;	/* Will cause text to appear in the geometry. LOGIC */
int	 do_labels_flag;  	/* Will cause text to appear in the geometry. FLAG */

/*
 *  Raw text formatting string used when labels are sprintf'ed.  NOTE: the user's input string is NOT checked for validity.  The format string should be valid for floating point values, eg: %g, %6.4f, etc.. (optional string)
 */
char	*sprintf_format_string;	/* Raw text formatting string used when labels are sprintf'ed.  NOTE: the user's input string is NOT checked for validity.  The format string should be valid for floating point values, eg: %g, %6.4f, etc.. STRING */
int	 sprintf_format_flag;   	/* Raw text formatting string used when labels are sprintf'ed.  NOTE: the user's input string is NOT checked for validity.  The format string should be valid for floating point values, eg: %g, %6.4f, etc.. FLAG */

/*-- optional MI group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void g3daxis_get_args PROTO((kaddr));
void g3daxis_usage_additions PROTO((void));
void g3daxis_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
