 /*
  * Khoros: $Id: usage.c,v 1.8.2.2 1997/05/31 18:49:33 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.8.2.2 1997/05/31 18:49:33 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "g3daxis.h"
/*-----------------------------------------------------------
| 
|  Routine Name: g3daxis_get_args
| 
|       Purpose: Gets command line args for g3daxis
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname g3daxis
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void g3daxis_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for g3daxis is out of sync with arguments specified in g3daxis's *.pane file; please rerun ghostwriter on g3daxis.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the g3daxis structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_auto_extents",
			  &(clui_info->do_auto_extents_logic),
			  &(clui_info->do_auto_extents_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xmin",
			  &(clui_info->xmin_float),
			  &(clui_info->xmin_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xmax",
			  &(clui_info->xmax_float),
			  &(clui_info->xmax_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ymin",
			  &(clui_info->ymin_float),
			  &(clui_info->ymin_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ymax",
			  &(clui_info->ymax_float),
			  &(clui_info->ymax_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "zmin",
			  &(clui_info->zmin_float),
			  &(clui_info->zmin_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "zmax",
			  &(clui_info->zmax_float),
			  &(clui_info->zmax_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_ticks",
			  &(clui_info->do_ticks_logic),
			  &(clui_info->do_ticks_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "tdensity",
			  &(clui_info->tdensity_int),
			  &(clui_info->tdensity_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_labels",
			  &(clui_info->do_labels_logic),
			  &(clui_info->do_labels_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "sprintf_format",
			  &(clui_info->sprintf_format_string),
			  &(clui_info->sprintf_format_flag))))
	{
	    kerror(NULL, "g3daxis_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generates a 3d axis geometry object from data.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' g3daxis",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $GEOMETRY/repos/license/License license",
  "-E",
  "-b +1+3.5 'Use either auto-compute or specify coords for axis extents.' blank1",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/g3daxis",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/g3daxis/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+1+1.5 ' ' 'Input 3D data' 'Data file containing 3d location data.' i",
  "-s 1 0 1 1 0 31x1+1+9.5 '3D_axis' 'Object name' 'Name used as the internal object name.' name",
  "-O 1 0 0 1 0 1 52x1+1+16.5 ' ' 'Output Geometry' 'Geometry object containing a 3d axis.' o",
  "-C 1",
  "-l 1 0 1 1 0 31x1+1+5 1 'Auto-compute extents?' 'No' 'Yes' 'Indicates if the extents of the axes should be computed from the input location data.' do_auto_extents",
  "-B 0",
  "-f 1 0 1 0 0 13x1+1+6 -100 100 0 0 0 0 'Xmin' 'Minimum X coordinate for user-specified extents.' xmin",
  "-f 1 0 1 0 0 13x1+19+6 -100 100 0 0 0 0 'Xmax' 'Maximum X coordinate for user-specified extents.' xmax",
  "-f 1 0 1 0 0 13x1+1+7 -100 100 0 0 0 0 'Ymin' 'Minimum Y coordinate for user-specified extents.' ymin",
  "-f 1 0 1 0 0 13x1+19+7 -100 100 0 0 0 0 'Ymax' 'Maximum Y coordinate for user-specified extents.' ymax",
  "-f 1 0 1 0 0 13x1+1+8 -100 100 0 0 0 0 'Zmin' 'Minimum Z coordinate for user-specified extents.' zmin",
  "-f 1 0 1 0 0 13x1+19+8 -100 100 0 0 0 0 'Zmax' 'Maximum Z coordinate for user-specified extents.' zmax",
  "-E",
  "-E",
  "-B 0",
  "-l 1 0 1 1 0 15x1+1+11.5 0 'Do Ticks? ' 'No' 'Yes' 'Will cause tick marks to be generated along each axis.' do_ticks",
  "-i 1 0 1 1 0 18.5x1+1+13 1 1 4 0 0 'Tick/Text Density' 'Indicates the number of tick marks/text along each axis.' tdensity",
  "-l 1 0 1 1 0 15x1+1+14 1 'Do Labels?' 'No' 'Yes' 'Will cause text to appear in the geometry.' do_labels",
  "-s 1 0 1 1 0 24x1+1+15 '%g' 'Sprintf format ' 'Raw text formatting string used when labels are sprintf\\'ed.  NOTE: the user\\'s input string is NOT checked for validity.  The format string should be valid for floating point values, eg: %g, %6.4f, etc..' sprintf_format",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/g3daxis/uis/g3daxis.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	33,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


