 /*
  * Khoros: $Id: gbindtexture.c,v 1.9.2.2 1997/05/31 18:49:48 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: gbindtexture.c,v 1.9.2.2 1997/05/31 18:49:48 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for gbindtexture
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "gbindtexture.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Assign a Texture to a Geometry Object
|
|       Purpose: main program for gbindtexture
|
|         Input:
|		char *clui_info->i_file; {input geometry object}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->i2_file; {texture object to be bound}
|		int   clui_info->i2_flag; {TRUE if -i2 specified}
|
|		char *clui_info->o_file; {output geometry object with bound texture}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|        Output:
|       Returns:
|
|    Written By: wes
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
	kgeom_object *geom,*texture;
	char         *texture_name;
/* -main_variable_list_end */

	khoros_init(argc, argv, "GEOMETRY", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$GEOMETRY/objects/kroutine/gbindtexture");
	kexit_handler(gbindtexture_free_args, NULL);

/* -main_get_args_call */
	kclui_init("GEOMETRY", "gbindtexture", KGEN_KROUTINE,  &clui_uis_spec,
		   gbindtexture_usage_additions, gbindtexture_get_args,
 		   gbindtexture_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
	geom = kgeom_read_object(clui_info->i_file);
	
	texture_name = clui_info->i2_file;
	texture = kgeom_read_object(texture_name);
/* -main_before_lib_call_end */

/* -main_library_call */
	lgbindtexture(geom,texture,texture_name);
/* -main_library_call_end */

/* -main_after_lib_call */
	kgeom_blast_object(texture);

	/*-- write the geometry back out with the texture name assigned --*/
	kgeom_write_object(geom, clui_info->o_file);
	kgeom_blast_object(geom);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: gbindtexture_usage_additions
| 
|       Purpose: Prints usage additions in gbindtexture_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gbindtexture
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gbindtexture_usage_additions(void)
{
	kfprintf(kstderr, "\tAssign a Texture to a Geometry Object\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: gbindtexture_free_args
| 
|       Purpose: Frees CLUI struct allocated in gbindtexture_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gbindtexture
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
gbindtexture_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->i2_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
