 /*
  * Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:50:10 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:50:10 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gcmaplegend.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gcmaplegend_get_args
| 
|       Purpose: Gets command line args for gcmaplegend
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gcmaplegend
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gcmaplegend_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gcmaplegend is out of sync with arguments specified in gcmaplegend's *.pane file; please rerun ghostwriter on gcmaplegend.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the gcmaplegend structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "orient", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->orient_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->orient_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_logical(pane, "reverse",
			  &(clui_info->reverse_logic),
			  &(clui_info->reverse_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "outline",
			  &(clui_info->outline_logic),
			  &(clui_info->outline_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "length",
			  &(clui_info->length_float),
			  &(clui_info->length_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "thickness",
			  &(clui_info->thickness_float),
			  &(clui_info->thickness_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xpos",
			  &(clui_info->xpos_float),
			  &(clui_info->xpos_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ypos",
			  &(clui_info->ypos_float),
			  &(clui_info->ypos_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_text_labels",
			  &(clui_info->do_text_labels_logic),
			  &(clui_info->do_text_labels_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "num_labels",
			  &(clui_info->num_labels_int),
			  &(clui_info->num_labels_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "sprintf_format",
			  &(clui_info->sprintf_format_string),
			  &(clui_info->sprintf_format_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "text_offset",
			  &(clui_info->text_offset_float),
			  &(clui_info->text_offset_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_title",
			  &(clui_info->do_title_logic),
			  &(clui_info->do_title_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "title_string",
			  &(clui_info->title_string_string),
			  &(clui_info->title_string_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "title_x_offset",
			  &(clui_info->title_x_offset_float),
			  &(clui_info->title_x_offset_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "title_y_offset",
			  &(clui_info->title_y_offset_float),
			  &(clui_info->title_y_offset_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "title_font_size", KVF_LIST_LABEL,
			  &(clui_info->title_font_size_label),
			  &(clui_info->title_font_size_flag)) &&
	      kclui_get_value(pane, "title_font_size", KVF_LIST_VAL,
			  &(clui_info->title_font_size_list),
			  &(clui_info->title_font_size_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "title_font_family", KVF_LIST_LABEL,
			  &(clui_info->title_font_family_label),
			  &(clui_info->title_font_family_flag)) &&
	      kclui_get_value(pane, "title_font_family", KVF_LIST_VAL,
			  &(clui_info->title_font_family_list),
			  &(clui_info->title_font_family_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gcmaplegend_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Construct Geometry Representing a Color Legend' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Color_Legend",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gcmaplegend",
  "-H 1  5x1+41+0 'Help' 'man page for color_legend' $GEOMETRY/objects/kroutine/gcmaplegend/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 51.75x1+0+1.5 ' ' 'Vis Colormap' 'input vis colormap' i",
  "-s 1 0 1 2 0 44.5x1+3+3.5 'color legend' 'Name ' 'color legend' name",
  "-T 1 0 1 2 0 41x1+3+5 +0+0 1 'Legend Orientation' 'legend orientation' orient",
  "-l 1 0 1 1 0 10x1+20+0 0 'Horizontal' 'False' 'True' 'Horizontal' dummy",
  "-l 1 0 1 0 0 10x1+30+0 0 'Vertical' 'False' 'True' 'Vertical' dummy",
  "-E",
  "-l 0 0 1 2 0 20.75x1+3+6.5 0 'Reverse Colors?    ' 'No' 'Yes' 'reverse colors?' reverse",
  "-l 1 0 1 2 0 20.5x1+3+7.5 1 'Make Outline?      ' 'No' 'Yes' 'make outline?' outline",
  "-f 1 0 1 2 0 50.5x1+1+9 0 2 1 2 1 0 'Length    ' 'length of legend' length",
  "-f 1 0 1 2 0 50.5x1+1+10 0 0.25 0.05 2 1 0 'Thickness ' 'thickness of legend' thickness",
  "-f 1 0 1 2 0 50.5x1+1+11.5 -1 1 -0.85 2 1 0 'X Position' 'x position' xpos",
  "-f 1 0 1 2 0 50.5x1+1+12.5 -1 1 -0.5 2 1 0 'Y Position' 'y position' ypos",
  "-l 1 0 1 1 0 19x1+1+14.5 1 'Do Text Labels?' 'No' 'Yes' 'Boolean value indicating whether or not text labels will be drawn.' do_text_labels",
  "-i 1 0 1 1 0 31x1+1+15.5 1 1 2 0 0 'Number of Labels' 'Number of subdivisions along color legend for text labels.' num_labels",
  "-s 1 0 1 1 0 31x1+1+16.5 '%g' 'Sprintf Format  ' 'C-style formatting string.  No error checking is perfomed.  Use %g for most stuff.' sprintf_format",
  "-f 1 0 1 1 0 31x1+1+17.5 0 0 0.1 3 0 0 'Text offset' 'Offset of text in either the horizontal or vertical dimension, depending upon the orientation of the legend.' text_offset",
  "-l 1 0 1 1 0 15x1+1+19.5 0 'Do Title?' 'No' 'Yes' 'Boolean indicating whether or not to generate a title to go along with the legend.' do_title",
  "-s 1 0 1 1 0 45x1+1+20.5 'I am a title.' 'Title String' 'The text for the title.' title_string",
  "-f 1 0 1 1 0 45x1+1+21.5 0 0 0 3 0 0 'Title X-offset' 'X-Offset of title relative to the origin of the legend.' title_x_offset",
  "-f 1 0 1 1 0 45x1+1+22.5 0 0 0 3 0 0 'Title Y-offset' 'Y-offset of title relative to legend origin.' title_y_offset",
  "-x 1 0 1 1 0 27x1+1+23.5 7 1 4 'Title Font Size' 'Choices for point size for the title.' title_font_size '10 point' '12 point' '14 point' '18 point' '20 point' '24 point' '34 point '",
  "-x 1 0 1 1 0 26x1+1+24.5 3 1 1 'Title Font Family' 'List of available font families.  Based upon those commonly available on X servers.  This works reliably only in the software renderer.' title_font_family 'Times' 'Courier' 'Helvetica'",
  "-O 1 0 0 1 0 1 51.5x1+1+26.5 ' ' 'Output Geometry Object' 'output geometry object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gcmaplegend/uis/gcmaplegend.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	35,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


