 /*
  * Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:50:33 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:50:33 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gcolorize.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gcolorize_get_args
| 
|       Purpose: Gets command line args for gcolorize
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gcolorize
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gcolorize_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gcolorize is out of sync with arguments specified in gcolorize's *.pane file; please rerun ghostwriter on gcolorize.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gcolorize structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gcolorize_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "cmap",
			  &(clui_info->cmap_file),
			  &(clui_info->cmap_flag))))
	{
	    kerror(NULL, "gcolorize_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gcolorize_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Map Value Data Through a Visualization Colormap' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Map_Data_Through_Vis_Colormap",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gcolorize",
  "-H 1  5x1+41+0 'Help' 'man page for kgmapdata' $GEOMETRY/objects/kroutine/gcolorize/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Data Object ' 'input data object' i",
  "-I 1 0 0 1 0 1 51.75x1+0+3.5 ' ' 'Vis Colormap' 'input vis colormap' cmap",
  "-O 1 0 0 1 0 1 51.75x1+0+5.5 ' ' 'Output Data Object' 'output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gcolorize/uis/gcolorize.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


