 /*
  * Khoros: $Id: usage.c,v 1.8.2.2 1997/05/31 18:50:51 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.8.2.2 1997/05/31 18:50:51 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gcreate2dtex.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gcreate2dtex_get_args
| 
|       Purpose: Gets command line args for gcreate2dtex
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gcreate2dtex
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gcreate2dtex_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gcreate2dtex is out of sync with arguments specified in gcreate2dtex's *.pane file; please rerun ghostwriter on gcreate2dtex.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gcreate2dtex structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "umin",
			  &(clui_info->umin_float),
			  &(clui_info->umin_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "vmin",
			  &(clui_info->vmin_float),
			  &(clui_info->vmin_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "umax",
			  &(clui_info->umax_float),
			  &(clui_info->umax_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "vmax",
			  &(clui_info->vmax_float),
			  &(clui_info->vmax_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "tex_filter", KVF_LIST_LABEL,
			  &(clui_info->tex_filter_label),
			  &(clui_info->tex_filter_flag)) &&
	      kclui_get_value(pane, "tex_filter", KVF_LIST_VAL,
			  &(clui_info->tex_filter_list),
			  &(clui_info->tex_filter_flag))))
	{
	    kerror(NULL, "gcreate2dtex_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create a 2d texture from an image.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' gcreate2dtex",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $GEOMETRY/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gcreate2dtex",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/gcreate2dtex/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 1 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "-O 1 0 0 1 1 1 52x1+0+3.5 ' ' 'Output' 'Resulting output data object' o",
  "-f 1 0 1 1 0 15x1+1+7 0 1 0 3 0 0 'Umin' 'Minimum u-coordinate value associated with origin of image data.' umin",
  "-f 1 0 1 1 0 15x1+1+8 0 1 0 3 0 0 'Vmin' 'Mininum v-coordinate assigned to the origin of the texture.' vmin",
  "-f 1 0 1 1 0 15x1+1+9.5 0 1 1 3 0 0 'Umax' 'Maximum u-coordinate to use for the non-origin corner of the texture image.' umax",
  "-f 1 0 1 1 0 15x1+1+10.5 0 1 1 3 0 0 'Vmax' 'Maximum v-coordinate to use for the non-origin corner of the texture image.' vmax",
  "-x 0 0 0 1 0 15x1+1+12 2 1 1 'Texture Construction Filter Type' 'Control over the method used in filtering the input image when making a texture.' tex_filter 'Straight Copy' 'MIP Map'",
  "-b +1+5.5 '2D Texture Coordinate Range for this texture:' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gcreate2dtex/uis/gcreate2dtex.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


