 /*
  * Khoros: $Id: gextents.h,v 1.12.2.3 1997/05/31 18:51:26 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gextents
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gextents_h_
#define _gextents_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input data object (required infile)
 */
char	*i_file;	/* input data object FILENAME */
int	 i_flag;	/* input data object FLAG */

/*
 *  output geometry object (required outfile)
 */
char	*o_file;	/* output geometry object FILENAME */
int	 o_flag;	/* output geometry object FLAG */

/*
 *  If true (default), will display the wireframe bounding box of the object. (required logical)
 */
int	 show_bounds_logic;	/* If true (default), will display the wireframe bounding box of the object. LOGIC */
int	 show_bounds_flag;  	/* If true (default), will display the wireframe bounding box of the object. FLAG */

/*
 * If 1, the lines will be colored white, else they will use the red, green, cyan color scheme described above (Optional boolean toggle)
 *	1 (white lines)
 *	2 (colored lines),
 */
int	 color_toggle;		/* If 1, the lines will be colored white, else they will use the red, green, cyan color scheme described above LOGICAL TOGGLE */
int	 color_flag;		/* If 1, the lines will be colored white, else they will use the red, green, cyan color scheme described above FLAG */

/*
 * Select between one of the two box types (Optional boolean toggle)
 *	1 (min/max 3D box)
 *	2 (shrink-wrap bounding hull),
 */
int	 type_toggle;		/* Select between one of the two box types LOGICAL TOGGLE */
int	 type_flag;		/* Select between one of the two box types FLAG */

/*
 *  The name selected here will identify the extents object in the renderer (optional string)
 */
char	*name_string;	/* The name selected here will identify the extents object in the renderer STRING */
int	 name_flag;   	/* The name selected here will identify the extents object in the renderer FLAG */

/*
 *  If true, will cause a two D wire mesh object to be built at u=0. (optional logical)
 */
int	 u_min_logic;	/* If true, will cause a two D wire mesh object to be built at u=0. LOGIC */
int	 u_min_flag;  	/* If true, will cause a two D wire mesh object to be built at u=0. FLAG */

/*
 *  If true, will cause a 2d wire mesh object at u=umax to be build. (optional logical)
 */
int	 u_max_logic;	/* If true, will cause a 2d wire mesh object at u=umax to be build. LOGIC */
int	 u_max_flag;  	/* If true, will cause a 2d wire mesh object at u=umax to be build. FLAG */

/*
 *  If true, will cause a 2d wire mesh object at v=0 to be built. (optional logical)
 */
int	 v_min_logic;	/* If true, will cause a 2d wire mesh object at v=0 to be built. LOGIC */
int	 v_min_flag;  	/* If true, will cause a 2d wire mesh object at v=0 to be built. FLAG */

/*
 *  If true, will cause a 2d wire mesh object at v=1 to be built. (optional logical)
 */
int	 v_max_logic;	/* If true, will cause a 2d wire mesh object at v=1 to be built. LOGIC */
int	 v_max_flag;  	/* If true, will cause a 2d wire mesh object at v=1 to be built. FLAG */

/*
 *  If true, will case a 2d wire mesh object to be built at W=0. (optional logical)
 */
int	 w_min_logic;	/* If true, will case a 2d wire mesh object to be built at W=0. LOGIC */
int	 w_min_flag;  	/* If true, will case a 2d wire mesh object to be built at W=0. FLAG */

/*
 *  If true, will cause a 2d wire mesh object to be built at w=1. (optional logical)
 */
int	 w_max_logic;	/* If true, will cause a 2d wire mesh object to be built at w=1. LOGIC */
int	 w_max_flag;  	/* If true, will cause a 2d wire mesh object to be built at w=1. FLAG */

/*
 *  Controls how much detail is produced.  This variable provides control over the amount of geometry gneerated. (Optional list)
 */
int	 lod_list;	/* Controls how much detail is produced.  This variable provides control over the amount of geometry gneerated. LIST INDEX */
char	 *lod_label;	/* Controls how much detail is produced.  This variable provides control over the amount of geometry gneerated. LIST LABEL */
int	 lod_flag;	/* Controls how much detail is produced.  This variable provides control over the amount of geometry gneerated. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void gextents_get_args PROTO((kaddr));
void gextents_usage_additions PROTO((void));
void gextents_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
int make_extents_box PROTO((kobject, kgeom_object *, int, char *,
			    int,int,int,int,int,int,int,int));
/* -include_routines_end */

#endif
