 /*
  * Khoros: $Id: usage.c,v 1.12.2.3 1997/05/31 18:51:28 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.12.2.3 1997/05/31 18:51:28 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gextents.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gextents_get_args
| 
|       Purpose: Gets command line args for gextents
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gextents
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gextents_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gextents is out of sync with arguments specified in gextents's *.pane file; please rerun ghostwriter on gextents.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the gextents structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "color", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->color_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->color_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_value(pane, "type", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->type_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "show_bounds",
			  &(clui_info->show_bounds_logic),
			  &(clui_info->show_bounds_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "u_min",
			  &(clui_info->u_min_logic),
			  &(clui_info->u_min_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "u_max",
			  &(clui_info->u_max_logic),
			  &(clui_info->u_max_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "v_min",
			  &(clui_info->v_min_logic),
			  &(clui_info->v_min_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "v_max",
			  &(clui_info->v_max_logic),
			  &(clui_info->v_max_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "w_min",
			  &(clui_info->w_min_logic),
			  &(clui_info->w_min_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "w_max",
			  &(clui_info->w_max_logic),
			  &(clui_info->w_max_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "lod", KVF_LIST_LABEL,
			  &(clui_info->lod_label),
			  &(clui_info->lod_flag)) &&
	      kclui_get_value(pane, "lod", KVF_LIST_VAL,
			  &(clui_info->lod_list),
			  &(clui_info->lod_flag))))
	{
	    kerror(NULL, "gextents_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate Geometry Representing Extents Around Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Extents_Box",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gextents",
  "-H 1  5x1+41+0 'Help' 'man page for extents_box' $GEOMETRY/objects/kroutine/gextents/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input Data Object' 'input data object' i",
  "-O 1 0 0 1 0 1 52x1+0+2.5 ' ' 'Output Geometry Object' 'output geometry object' o",
  "-T 1 0 1 2 0 37x1+3+4 +0+0 2 'Colors' 'If 1, the lines will be colored white, else they will use the red, green, cyan color scheme described above' color",
  "-l 1 0 1 0 0 1x1+10+0 1 'White Lines' ' ' ' ' 'white lines' dummy",
  "-l 1 0 1 1 0 1x1+24+0 0 'Colored Lines' ' ' ' ' 'colored lines' dummy",
  "-E",
  "-T 1 0 1 1 0 36.875x1+3+5 +0+0 2 'Box Type' 'Select between one of the two box types' type",
  "-l 1 0 1 0 0 1x1+10+0 1 '3D Min/Max Box' ' ' ' ' 'min/max 3D box' dummy",
  "-l 1 0 1 1 0 1x1+24+0 0 'Bounding Hull' ' ' ' ' 'shrink-wrap bounding hull' dummy",
  "-E",
  "-s 1 0 1 2 0 47x1+3+6.5 'extents box' 'Name ' 'The name selected here will identify the extents object in the renderer' name",
  "-l 1 0 0 1 0 22x1+3+8 1 'Show Bounding Box' 'False' 'True' 'If true (default), will display the wireframe bounding box of the object.' show_bounds",
  "-l 1 0 1 2 0 16x1+3+9.5 0 'Uaxis Min' 'False' 'True' 'If true, will cause a two D wire mesh object to be built at u=0.' u_min",
  "-l 1 0 1 2 0 16x1+25+9.5 0 'Uaxis Max' 'False' 'True' 'If true, will cause a 2d wire mesh object at u=umax to be build.' u_max",
  "-l 1 0 1 2 0 16x1+3+10.5 0 'Vaxis Min' 'False' 'True' 'If true, will cause a 2d wire mesh object at v=0 to be built.' v_min",
  "-l 1 0 1 2 0 16x1+25+10.5 0 'Vaxis Max' 'False' 'True' 'If true, will cause a 2d wire mesh object at v=1 to be built.' v_max",
  "-l 1 0 1 2 0 16x1+3+11.5 0 'Waxis Min' 'False' 'True' 'If true, will case a 2d wire mesh object to be built at W=0.' w_min",
  "-l 1 0 1 2 0 16x1+25+11.5 0 'Waxis Max' 'False' 'True' 'If true, will cause a 2d wire mesh object to be built at w=1.' w_max",
  "-x 0 0 1 2 0 25x1+3+13 2 1 1 'Level of Detail' 'Controls how much detail is produced.  This variable provides control over the amount of geometry gneerated.' lod 'Fine' 'Coarse'",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gextents/uis/gextents.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	31,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


