 /*
  * Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:51:47 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:51:47 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gflipnorms.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gflipnorms_get_args
| 
|       Purpose: Gets command line args for gflipnorms
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gflipnorms
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gflipnorms_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gflipnorms is out of sync with arguments specified in gflipnorms's *.pane file; please rerun ghostwriter on gflipnorms.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gflipnorms structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gflipnorms_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gflipnorms_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Flip all Normals in a Geometry Object.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kflipnorms",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $GEOMETRY/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gflipnorms",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/gflipnorms/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 51.5x1+0+2 ' ' 'Input Geometry Object' 'input object containing normals' i",
  "-O 1 0 0 1 0 1 51.5x1+0+3.5 ' ' 'Output Geometry Object' 'resulting output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gflipnorms/uis/gflipnorms.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	14,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


