 /*
  * Khoros: $Id: usage.c,v 1.12.2.2 1997/05/31 18:52:06 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.12.2.2 1997/05/31 18:52:06 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "ggencmap.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ggencmap_get_args
| 
|       Purpose: Gets command line args for ggencmap
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ggencmap
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ggencmap_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ggencmap is out of sync with arguments specified in ggencmap's *.pane file; please rerun ghostwriter on ggencmap.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ggencmap structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "outf",
			  &(clui_info->outf_file),
			  &(clui_info->outf_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "use_hsv",
			  &(clui_info->use_hsv_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "hs",
			  &(clui_info->hs_float),
			  &(clui_info->hs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "he",
			  &(clui_info->he_float),
			  &(clui_info->he_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ss",
			  &(clui_info->ss_float),
			  &(clui_info->ss_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "se",
			  &(clui_info->se_float),
			  &(clui_info->se_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "vs",
			  &(clui_info->vs_float),
			  &(clui_info->vs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ve",
			  &(clui_info->ve_float),
			  &(clui_info->ve_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "use_rgb",
			  &(clui_info->use_rgb_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "rs",
			  &(clui_info->rs_float),
			  &(clui_info->rs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "re",
			  &(clui_info->re_float),
			  &(clui_info->re_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "gs",
			  &(clui_info->gs_float),
			  &(clui_info->gs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ge",
			  &(clui_info->ge_float),
			  &(clui_info->ge_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "bs",
			  &(clui_info->bs_float),
			  &(clui_info->bs_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "be",
			  &(clui_info->be_float),
			  &(clui_info->be_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "use_alpha",
			  &(clui_info->use_alpha_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "as",
			  &(clui_info->as_float),
			  &(clui_info->as_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ae",
			  &(clui_info->ae_float),
			  &(clui_info->ae_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "minval",
			  &(clui_info->minval_float),
			  &(clui_info->minval_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "maxval",
			  &(clui_info->maxval_float),
			  &(clui_info->maxval_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "std_dev_scale",
			  &(clui_info->std_dev_scale_float),
			  &(clui_info->std_dev_scale_flag))))
	{
	    kerror(NULL, "ggencmap_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create a Visualization Colormap' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Generate_Vis_Colormap",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'Begin Execution of kmakecmap' $GEOMETRYBIN/ggencmap",
  "-H 1  5x1+41+0 'Help' 'Man page for kmakecmap' $GEOMETRY/objects/kroutine/ggencmap/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-i 1 0 1 1 0 43.75x1+1+14.5 2 512 256 0 0 'Number of entries in vis colormap ' 'number of entries in the vis colormap.' n",
  "",
  "-O 1 0 0 1 0 1 50x1+1+22.5 ' ' 'Output Vis Colormap' 'output vis colormap' outf",
  "-C 1",
  "-B 0",
  "-t 1 0 1 1 0 26.375x1+1+1.5 'Color specification in HSV space' 'color parameters in HSV space' use_hsv",
  "-f 1 0 1 1 1 19.75x1+4+2.5 0 1 0 0 0 0 'Hue Start  ' 'hue start value' hs",
  "-f 1 0 1 1 1 19.75x1+25+2.5 0 1 1 0 0 0 'Hue End    ' 'hue end value' he",
  "-f 1 0 1 1 1 19.75x1+4+3.5 0 1 1 0 0 0 'Sat Start  ' 'saturation start value' ss",
  "-f 1 0 1 1 1 19.75x1+25+3.5 0 1 1 0 0 0 'Sat End    ' 'saturation end value' se",
  "-f 1 0 1 1 1 19.75x1+4+4.5 0 1 1 0 0 0 'Val Start  ' 'value start value' vs",
  "-f 1 0 1 1 1 19.75x1+25+4.5 0 1 1 0 0 0 'Val End    ' 'value end value' ve",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 26.375x1+1+6.5 'Color specification in RGB space' 'color parameters in RGB space' use_rgb",
  "-f 1 0 1 0 1 19.75x1+4+7.5 0 1 0 0 0 0 'Red Start   ' 'red start value' rs",
  "-f 1 0 1 0 1 19.75x1+25+7.5 0 1 1 0 0 0 'Red End     ' 'red end value' re",
  "-f 1 0 1 0 1 19.75x1+4+8.5 0 1 1 0 0 0 'Green Start ' 'green start value' gs",
  "-f 1 0 1 0 1 19.75x1+25+8.5 0 1 1 0 0 0 'Green End   ' 'green end value' ge",
  "-f 1 0 1 0 1 19.75x1+4+9.5 0 1 1 0 0 0 'Blue Start  ' 'blue start value' bs",
  "-f 1 0 1 0 1 19.75x1+25+9.5 0 1 1 0 0 0 'Blue End    ' 'blue end value' be",
  "-E",
  "-E",
  "-B 0",
  "-t 1 0 1 1 0 45.125x1+1+11.5 'Add alpha channel to colormap (0==transparent, 1==opaque)' 'include opacity info in alpha channel of colormap' use_alpha",
  "-f 1 0 1 1 1 19.75x1+4+12.5 0 1 0 0 0 0 'Alpha Start  ' 'alpha start value' as",
  "-f 1 0 1 1 1 19.75x1+25+12.5 0 1 1 0 0 0 'Alpha End    ' 'alpha end value' ae",
  "-E",
  "-b +1+16 'How to compute transfer function?' label1",
  "-C 0",
  "-B 0",
  "-f 1 0 1 0 0 44.5x1+4+20 0 0 0 7 0 0 'Minimum value ' 'value used for minimum bracket value in vis colormap' minval",
  "-f 1 0 1 0 0 44.5x1+4+21 0 0 255 7 0 0 'Maximum Value ' 'value assioated with maximum bracket value in map.' maxval",
  "-E",
  "-B 0",
  "-I 1 0 1 1 0 0 45x1+4+17 ' ' 'Input Data' 'input data' i",
  "-f 1 0 1 1 0 42x1+4+18 2 2 3 3 0 0 'Number of Std.Deviations' 'Scale applied to computed standard deviation in setting min/max values.' std_dev_scale",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/ggencmap/uis/ggencmap.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	51,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


