 /*
  * Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:52:24 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:52:24 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "ggridder2d.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ggridder2d_get_args
| 
|       Purpose: Gets command line args for ggridder2d
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ggridder2d
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ggridder2d_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ggridder2d is out of sync with arguments specified in ggridder2d's *.pane file; please rerun ghostwriter on ggridder2d.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ggridder2d structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "grid_size_x",
			  &(clui_info->grid_size_x_int),
			  &(clui_info->grid_size_x_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "grid_size_y",
			  &(clui_info->grid_size_y_int),
			  &(clui_info->grid_size_y_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "inverse_distance_method",
			  &(clui_info->inverse_distance_method_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "inverse_distance_radius",
			  &(clui_info->inverse_distance_radius_double),
			  &(clui_info->inverse_distance_radius_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "inverse_distance_exponent",
			  &(clui_info->inverse_distance_exponent_double),
			  &(clui_info->inverse_distance_exponent_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "inverse_distance_undefined_value",
			  &(clui_info->inverse_distance_undefined_value_double),
			  &(clui_info->inverse_distance_undefined_value_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "idsfft_method",
			  &(clui_info->idsfft_method_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "idsfft_npoints",
			  &(clui_info->idsfft_npoints_double),
			  &(clui_info->idsfft_npoints_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "compute_grid_min_max",
			  &(clui_info->compute_grid_min_max_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "user_grid_min_max",
			  &(clui_info->user_grid_min_max_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "user_grid_x_min",
			  &(clui_info->user_grid_x_min_double),
			  &(clui_info->user_grid_x_min_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "user_grid_y_min",
			  &(clui_info->user_grid_y_min_double),
			  &(clui_info->user_grid_y_min_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "user_grid_x_max",
			  &(clui_info->user_grid_x_max_double),
			  &(clui_info->user_grid_x_max_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "user_grid_y_max",
			  &(clui_info->user_grid_y_max_double),
			  &(clui_info->user_grid_y_max_flag))))
	{
	    kerror(NULL, "ggridder2d_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute z=f(x,y) over a user-defined grid given scatter data.' subform",
  "-P 1 0 53.75x9.5+0+1 +0+0 ' ' Grid_2D_Data",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/ggridder2d",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/ggridder2d/help help",
  "-Q 1 0 5.25x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Data Object' 'input data object' i",
  "-i 1 0 1 1 0 43.25x1+1+17.5 2 2 20 0 0 'Output Grid X-samples ' 'value indicating x-resolution of output grid' grid_size_x",
  "-i 1 0 1 1 0 43.25x1+1+18.5 2 2 20 0 0 'Output Grid Y-samples ' 'value indicating y-resolution of output grid' grid_size_y",
  "-O 1 0 0 1 0 1 51.75x1+0+20.5 ' ' 'Output Data Object' 'output data object' o",
  "#",
  "# ME group, 0 selections required,  defaults to idsfft, to determine numerical method used in interpolating data.",
  "#",
  "-C 0",
  "-B 0",
  "-t 0 0 1 0 0 24.125x1+1+4 'Inverse-distance method' 'use inverse-distance method' inverse_distance_method",
  "-h 0 0 1 0 0 22x1+3+5 2 2 1 10 0 0 'Inclusion Radius    ' 'user-defined radius, inside which points will be averaged ' inverse_distance_radius",
  "-h 0 0 1 0 0 22x1+3+6 2 2 1 10 0 0 'Inversion Exponent  ' 'exponent to use in denominator of inversion equation' inverse_distance_exponent",
  "-h 0 0 1 0 0 22x1+3+7 2 2 1 10 0 0 'Value for Undefined ' 'the value to use when the output grid point is not defined' inverse_distance_undefined_value",
  "-E",
  "-B 0",
  "-t 1 0 1 1 0 22.625x1+28+4 'Fourier analysis' 'use 2d fourier analysis flag' idsfft_method",
  "#",
  "# the maximum value for the following has an upper bound which is the number of input grid points.  we will set the",
  "# upper bound to be artificially high, then adjust down (silently) as necessary",
  "#",
  "-h 1 0 1 1 0 21x1+30+5.5 2 2 5 3 0 0 'Number of points' 'number of points to use in computing partial derivatives' idsfft_npoints",
  "-E",
  "-E",
  "#",
  "# ME group, 0 selection required, that determines method used for setting grid boundaries.  defaults to autocompute",
  "#",
  "-C 0",
  "-t 1 0 1 1 0 30.125x1+1+9.5 'Compute grid min/max from input data.' 'Compute output grid min/max from input location data' compute_grid_min_max",
  "-B 0",
  "-t 1 0 1 0 0 22.125x1+1+11 'User defined grid min/max.' 'user defined grid min/max vertices, in 2D' user_grid_min_max",
  "-h 1 0 1 0 0 47x1+3+12.5 0 0 0 10 0 0 'X min coordinate for interpolation  grid ' 'X min coordinate for interpolation grid' user_grid_x_min",
  "-h 1 0 1 0 0 47x1+3+13.5 0 0 0 10 0 0 'Y min coordinate for interpolation  grid ' 'Y min coordinate for interpolation grid' user_grid_y_min",
  "-h 1 0 1 0 0 47x1+3+14.5 0 0 1 10 0 0 'X max coordinate for interpolation  grid ' 'X max coordinate for interpolation grid' user_grid_x_max",
  "-h 1 0 1 0 0 47x1+3+15.5 0 0 1 10 0 0 'Y max coordinate for interpolation  grid ' 'Y max coordinate for interpolation grid' user_grid_y_max",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/ggridder2d/uis/ggridder2d.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	48,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


