 /*
  * Khoros: $Id: ghogs.h,v 1.5.2.2 1997/05/31 18:52:41 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for ghogs
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _ghogs_h_
#define _ghogs_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input data object containing vector value data. (required infile)
 */
char	*i_file;	/* Input data object containing vector value data. FILENAME */
int	 i_flag;	/* Input data object containing vector value data. FLAG */

/*
 *  Resulting output data object (required outfile)
 */
char	*o_file;	/* Resulting output data object FILENAME */
int	 o_flag;	/* Resulting output data object FLAG */

/*
 *  List of icons used for geometric icon. (Optional list)
 */
int	 icon_choice_list;	/* List of icons used for geometric icon. LIST INDEX */
char	 *icon_choice_label;	/* List of icons used for geometric icon. LIST LABEL */
int	 icon_choice_flag;	/* List of icons used for geometric icon. FLAG */

/*
 *  Used to scale the size of the icon. (optional float)
 */
float	 icon_scale_float;	/* Used to scale the size of the icon. FLOAT */
int	 icon_scale_flag;   	/* Used to scale the size of the icon. FLAG */

/*
 *  Used to control if scaling is done using linear or log10 basis. (Optional list)
 */
int	 linear_log_list;	/* Used to control if scaling is done using linear or log10 basis. LIST INDEX */
char	 *linear_log_label;	/* Used to control if scaling is done using linear or log10 basis. LIST LABEL */
int	 linear_log_flag;	/* Used to control if scaling is done using linear or log10 basis. FLAG */

/*
 *  Controls how finely procedural icons are tesselated. (optional integer)
 */
int	 icon_smooth_int; 	/* Controls how finely procedural icons are tesselated. INT */
int	 icon_smooth_flag;	/* Controls how finely procedural icons are tesselated. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void ghogs_get_args PROTO((kaddr));
void ghogs_usage_additions PROTO((void));
void ghogs_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
int lghogs PROTO((kobject, kgeom_object *, clui_info_struct *));
/* -include_routines_end */

#endif
