 /*
  * Khoros: $Id: usage.c,v 1.5.2.2 1997/05/31 18:52:43 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.5.2.2 1997/05/31 18:52:43 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "ghogs.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ghogs_get_args
| 
|       Purpose: Gets command line args for ghogs
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ghogs
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ghogs_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ghogs is out of sync with arguments specified in ghogs's *.pane file; please rerun ghostwriter on ghogs.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ghogs structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "ghogs_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "ghogs_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "icon_choice", KVF_LIST_LABEL,
			  &(clui_info->icon_choice_label),
			  &(clui_info->icon_choice_flag)) &&
	      kclui_get_value(pane, "icon_choice", KVF_LIST_VAL,
			  &(clui_info->icon_choice_list),
			  &(clui_info->icon_choice_flag))))
	{
	    kerror(NULL, "ghogs_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "icon_scale",
			  &(clui_info->icon_scale_float),
			  &(clui_info->icon_scale_flag))))
	{
	    kerror(NULL, "ghogs_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "linear_log", KVF_LIST_LABEL,
			  &(clui_info->linear_log_label),
			  &(clui_info->linear_log_flag)) &&
	      kclui_get_value(pane, "linear_log", KVF_LIST_VAL,
			  &(clui_info->linear_log_list),
			  &(clui_info->linear_log_flag))))
	{
	    kerror(NULL, "ghogs_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "icon_smooth",
			  &(clui_info->icon_smooth_int),
			  &(clui_info->icon_smooth_flag))))
	{
	    kerror(NULL, "ghogs_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate hedgehog icons at each grid node of a vector field.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' ghogs",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/ghogs",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/ghogs/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Vector Data' 'Input data object containing vector value data.' i",
  "-O 1 0 0 1 0 1 52x1+0+3.5 ' ' 'Output Geometry' 'Resulting output data object' o",
  "-x 1 0 1 2 0 18x1+1+5 4 1 1 'Icon' 'List of icons used for geometric icon.' icon_choice 'Barbs' 'Arrows' 'Cones' 'Footballs '",
  "-f 1 0 1 2 0 45x1+1+6.5 -100 100 1 3 1 0 'Icon Scale' 'Used to scale the size of the icon.' icon_scale",
  "-x 1 0 1 2 0 27x1+1+7.5 2 1 1 'Icon Scale Method' 'Used to control if scaling is done using linear or log10 basis.' linear_log 'Linear' 'Logarithmic'",
  "-i 1 0 1 2 0 45x1+1+8.5 1 5 1 1 0 'Icon Smoothness' 'Controls how finely procedural icons are tesselated.' icon_smooth",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/ghogs/uis/ghogs.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	18,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


