 /*
  * Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:53:01 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:53:01 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gimpfacet.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gimpfacet_get_args
| 
|       Purpose: Gets command line args for gimpfacet
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gimpfacet
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gimpfacet_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gimpfacet is out of sync with arguments specified in gimpfacet's *.pane file; please rerun ghostwriter on gimpfacet.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gimpfacet structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gimpfacet_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "gimpfacet_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gimpfacet_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Import FACET data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Import_FACET_Data",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gimpfacet",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/gimpfacet/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Facet Data ' 'input facet file' i",
  "-s 1 0 1 2 0 37x1+2+3.5 'facets' 'Name ' 'object name' name",
  "-O 1 0 0 1 0 1 51.5x1+0+5 ' ' 'Output Geometry  ' 'output geometry object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gimpfacet/uis/gimpfacet.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


