 /*
  * Khoros: $Id: gisosurface.h,v 1.11.2.2 1997/05/31 18:53:18 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gisosurface
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gisosurface_h_
#define _gisosurface_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input 3d data object (required infile)
 */
char	*i_file;	/* input 3d data object FILENAME */
int	 i_flag;	/* input 3d data object FLAG */

/*
 *  contouring level (required float)
 */
float	 l_float;	/* contouring level FLOAT */
int	 l_flag;   	/* contouring level FLAG */

/*
 *  output geometry object (required outfile)
 */
char	*o_file;	/* output geometry object FILENAME */
int	 o_flag;	/* output geometry object FLAG */

/*
 *  compute normals? (optional logical)
 */
int	 normals_logic;	/* compute normals? LOGIC */
int	 normals_flag;  	/* compute normals? FLAG */

/*
 *  reverse normals? (optional logical)
 */
int	 flip_logic;	/* reverse normals? LOGIC */
int	 flip_flag;  	/* reverse normals? FLAG */

/*
 *  object name (optional string)
 */
char	*name_string;	/* object name STRING */
int	 name_flag;   	/* object name FLAG */

} clui_info_struct;

/* -include_typedefs */
typedef struct vertex3d
{
    float x,y,z;
} vertex;

typedef struct slice
{
    int usize,vsize;
/*    vertex **points; */
    float **xpts,**ypts,**zpts;
    double **data;
    unsigned char **mask;
} slice;
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void gisosurface_get_args PROTO((kaddr));
void gisosurface_usage_additions PROTO((void));
void gisosurface_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
void iso_main PROTO((kobject, kgeom_object *, double, int, int, char *));
/* -include_routines_end */

#endif
