 /*
  * Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:53:56 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:53:56 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "glinexyz.h"
/*-----------------------------------------------------------
| 
|  Routine Name: glinexyz_get_args
| 
|       Purpose: Gets command line args for glinexyz
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname glinexyz
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void glinexyz_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for glinexyz is out of sync with arguments specified in glinexyz's *.pane file; please rerun ghostwriter on glinexyz.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the glinexyz structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "glinexyz_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "glinexyz_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "close",
			  &(clui_info->close_logic),
			  &(clui_info->close_flag))))
	{
	    kerror(NULL, "glinexyz_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "glinexyz_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create Polylines from ASCII XYZ Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Plot_XYZ",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/glinexyz",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/glinexyz/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ASCII Data ' 'input ASCII data containing polyline points' i",
  "-s 1 0 1 2 0 38.5x1+3+4.5 'line' 'Name ' 'object name' name",
  "-l 1 0 1 1 1 20x1+3+6 0 'Close region?' 'No' 'Yes' 'connect first and last points in list of vertices.' close",
  "-O 1 0 0 1 0 1 51x1+0+8.5 ' ' 'Output Geometry Object' 'output geometry object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/glinexyz/uis/glinexyz.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	16,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


