 /*
  * Khoros: $Id: glocstats.c,v 1.8.2.2 1997/05/31 18:54:09 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: glocstats.c,v 1.8.2.2 1997/05/31 18:54:09 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for glocstats
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "glocstats.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Create a directed-points geometry object from raw data.
|
|       Purpose: main program for glocstats
|
|         Input:
|		char *clui_info->i_file; {Input file containing location data.  May be either a geometry object or a plain old VIFF with location data.}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		int clui_info->minmax_logic; {Find min/max values of input location data.}
|		int clui_info->minmax_flag; {TRUE if -minmax specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
    kobject kobj;
    int do_minmax;
/* -main_variable_list_end */

	khoros_init(argc, argv, "GEOMETRY", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$GEOMETRY/objects/kroutine/glocstats");
	kexit_handler(glocstats_free_args, NULL);

/* -main_get_args_call */
	kclui_init("GEOMETRY", "glocstats", KGEN_KROUTINE,  &clui_uis_spec,
		   glocstats_usage_additions, glocstats_get_args,
 		   glocstats_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
    kobj = kpds_open_input_object(clui_info->i_file);
    do_minmax = clui_info->minmax_logic;
/* -main_before_lib_call_end */

/* -main_library_call */
    lglocstats(kobj,do_minmax);
/* -main_library_call_end */

/* -main_after_lib_call */
    kpds_close_object(kobj);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: glocstats_usage_additions
| 
|       Purpose: Prints usage additions in glocstats_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname glocstats
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void glocstats_usage_additions(void)
{
	kfprintf(kstderr, "\tCreate a directed-points geometry object from raw data.\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: glocstats_free_args
| 
|       Purpose: Frees CLUI struct allocated in glocstats_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname glocstats
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
glocstats_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
