 /*
  * Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:54:30 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:54:30 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "goctmesh.h"
/*-----------------------------------------------------------
| 
|  Routine Name: goctmesh_get_args
| 
|       Purpose: Gets command line args for goctmesh
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname goctmesh
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void goctmesh_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for goctmesh is out of sync with arguments specified in goctmesh's *.pane file; please rerun ghostwriter on goctmesh.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the goctmesh structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "goctmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "cmap",
			  &(clui_info->cmap_file),
			  &(clui_info->cmap_flag))))
	{
	    kerror(NULL, "goctmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_normals",
			  &(clui_info->do_normals_logic),
			  &(clui_info->do_normals_flag))))
	{
	    kerror(NULL, "goctmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "flip_normals",
			  &(clui_info->flip_normals_logic),
			  &(clui_info->flip_normals_flag))))
	{
	    kerror(NULL, "goctmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "goctmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "goctmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create an Octmesh Geometry Object from 3D Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Octmesh",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/goctmesh",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/goctmesh/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 1 1 51.75x1+0+1.5 ' ' 'Input 3D Data Object' 'input 3d data for octmesh' i",
  "-I 1 0 1 1 0 1 49x1+0+2.5 ' ' 'Vis Colormap' 'input vis colormap' cmap",
  "-l 1 0 1 1 0 22x1+0+3.5 1 'Generate Normals?' 'No' 'Yes' 'Flag indicating whether or not normals should be generated.  Normals are computed from the value data, and are required for voxel-dot shading.' do_normals",
  "-l 1 0 1 1 0 19x1+0+4.5 1 'Flip Normals?' 'No' 'Yes' 'Causes normals to be flipped or not.' flip_normals",
  "-s 1 0 1 1 0 21x1+0+5.5 'octmesh' 'Name ' 'object name' name",
  "-O 1 0 0 1 1 1 52x1+0+7.5 ' ' 'Output Transport Name ' 'output geometry octmesh' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/goctmesh/uis/goctmesh.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	18,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


