 /*
  * Khoros: $Id: gprgeom.h,v 1.11.2.2 1997/05/31 18:54:42 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gprgeom
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gprgeom_h_
#define _gprgeom_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input geometry object (required infile)
 */
char	*i_file;	/* input geometry object FILENAME */
int	 i_flag;	/* input geometry object FLAG */

/*
 *  print attributes? (optional logical)
 */
int	 att_logic;	/* print attributes? LOGIC */
int	 att_flag;  	/* print attributes? FLAG */

/*
 *  print location data (optional flag)
 */
int	 loc_flag;  	/* print location data FLAG */

/*
 *  print color data (optional flag)
 */
int	 color_flag;  	/* print color data FLAG */

/*
 *  print normals or radii (optional flag)
 */
int	 normrad_flag;  	/* print normals or radii FLAG */

/*
 *  print texture coords (optional flag)
 */
int	 tc_flag;  	/* print texture coords FLAG */

/*
 *  output ASCII text file (optional outfile)
 */
char	*o_file;	/* output ASCII text file FILENAME */
int	 o_flag;	/* output ASCII text file FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void gprgeom_get_args PROTO((kaddr));
void gprgeom_usage_additions PROTO((void));
void gprgeom_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
void kprgeom_util PROTO((kgeom_object *,kfile *,int,int,int,int,int));
/* -include_routines_end */

#endif
