 /*
  * Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:54:44 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.2 1997/05/31 18:54:44 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gprgeom.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gprgeom_get_args
| 
|       Purpose: Gets command line args for gprgeom
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gprgeom
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gprgeom_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gprgeom is out of sync with arguments specified in gprgeom's *.pane file; please rerun ghostwriter on gprgeom.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gprgeom structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gprgeom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "att",
			  &(clui_info->att_logic),
			  &(clui_info->att_flag))))
	{
	    kerror(NULL, "gprgeom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "loc",
			  &(clui_info->loc_flag))))
	{
	    kerror(NULL, "gprgeom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "color",
			  &(clui_info->color_flag))))
	{
	    kerror(NULL, "gprgeom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "normrad",
			  &(clui_info->normrad_flag))))
	{
	    kerror(NULL, "gprgeom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tc",
			  &(clui_info->tc_flag))))
	{
	    kerror(NULL, "gprgeom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gprgeom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Print ASCII Report of Geometry Input' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Print_Geometry",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gprgeom",
  "-H 1  5x1+41+0 'Help' 'man page for kprgreom' $GEOMETRY/objects/kroutine/gprgeom/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Geometry Object' 'input geometry object' i",
  "-l 1 0 1 2 0 29x1+2+4 1 'Print Attributes?         ' 'False' 'True' 'print attributes?' att",
  "-t 1 0 1 0 0 8.375x1+2+6.5 'Location' 'print location data' loc",
  "-t 1 0 1 0 0 6.125x1+14+6.5 'Color' 'print color data' color",
  "-t 1 0 1 0 0 12.125x1+25+6.5 'Normals/Radii' 'print normals or radii' normrad",
  "-t 1 0 1 0 0 12.875x1+39+6.5 'Texture Coords' 'print texture coords' tc",
  "-O 1 0 1 2 0 1 52x1+0+8 ' ' 'Output ASCII Text  ' 'output ASCII text file' o",
  "-b +2+5.5 'For Each Primitive, Print the Following Data :' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gprgeom/uis/gprgeom.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


