 /*
  * Khoros: $Id: usage.c,v 1.11.2.4 1997/05/31 18:54:58 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.4 1997/05/31 18:54:58 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gquadmesh.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gquadmesh_get_args
| 
|       Purpose: Gets command line args for gquadmesh
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gquadmesh
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gquadmesh_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gquadmesh is out of sync with arguments specified in gquadmesh's *.pane file; please rerun ghostwriter on gquadmesh.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gquadmesh structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "opt", KVF_LIST_LABEL,
			  &(clui_info->opt_label),
			  &(clui_info->opt_flag)) &&
	      kclui_get_value(pane, "opt", KVF_LIST_VAL,
			  &(clui_info->opt_list),
			  &(clui_info->opt_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "cmap",
			  &(clui_info->cmap_file),
			  &(clui_info->cmap_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tc2d",
			  &(clui_info->tc2d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "umin2d",
			  &(clui_info->umin2d_double),
			  &(clui_info->umin2d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "umax2d",
			  &(clui_info->umax2d_double),
			  &(clui_info->umax2d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "vmin2d",
			  &(clui_info->vmin2d_double),
			  &(clui_info->vmin2d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "vmax2d",
			  &(clui_info->vmax2d_double),
			  &(clui_info->vmax2d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "tc3d",
			  &(clui_info->tc3d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "umin3d",
			  &(clui_info->umin3d_double),
			  &(clui_info->umin3d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "umax3d",
			  &(clui_info->umax3d_double),
			  &(clui_info->umax3d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "vmin3d",
			  &(clui_info->vmin3d_double),
			  &(clui_info->vmin3d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "vmax3d",
			  &(clui_info->vmax3d_double),
			  &(clui_info->vmax3d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wmin3d",
			  &(clui_info->wmin3d_double),
			  &(clui_info->wmin3d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wmax3d",
			  &(clui_info->wmax3d_double),
			  &(clui_info->wmax3d_flag))))
	{
	    kerror(NULL, "gquadmesh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create a Quadmesh Geometry Object from 2D Data' subform",
  "-P 1 0 53.25x17+0+1 +0+0 ' ' Quadmesh",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gquadmesh",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/gquadmesh/help help",
  "-Q 1 0 5.5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input 2D Data Object' 'input 2d data for quadmesh' i",
  "-s 1 0 1 2 0 36x1+2+5.5 'quadmesh' 'Name ' 'object name' name",
  "-O 1 0 0 1 0 1 51.75x1+0+15.5 ' ' 'Output Geometry Quadmesh' 'ouput geometry quadmesh' o",
  "-x 1 0 1 1 0 24x1+0+17 2 1 1 'Optimization' 'List of ways in which the quadmesh can be optimized.' opt 'None' 't-strips'",
  "-C 0",
  "-I 1 0 1 0 0 1 49x1+0+3.5 ' ' 'Vis Colormap' 'input vis colormap' cmap",
  "-B 0",
  "-t 1 0 1 0 0 25.125x1+1+7.5 'Generate 2D Texture Coords' 'generate 2D texture coords' tc2d",
  "-h 1 0 1 0 0 18x1+3+8.5 0 1 0 10 0 0 'Umin ' 'umin' umin2d",
  "-h 1 0 1 0 0 18x1+22+8.5 0 1 1 10 0 0 'Umax ' 'umax' umax2d",
  "-h 1 0 1 0 0 18x1+3+9.5 0 1 0 10 0 0 'Vmin ' 'vmin' vmin2d",
  "-h 1 0 1 0 0 18x1+22+9.5 0 1 1 10 0 0 'Vmax ' 'vmax' vmax2d",
  "-E",
  "-B 0",
  "-t 1 0 1 0 0 21.875x1+1+11 'Generate 3D Texture Coords' 'generate 3D texture coords' tc3d",
  "-h 1 0 1 0 0 18x1+3+12 0 1 0 10 0 0 'Umin ' 'umin' umin3d",
  "-h 1 0 1 0 0 18x1+22+12 0 1 1 10 0 0 'Umax ' 'umax' umax3d",
  "-h 1 0 1 0 0 18x1+3+13 0 1 0 10 0 0 'Vmin ' 'vmin' vmin3d",
  "-h 1 0 1 0 0 17.75x1+22+13 0 1 1 10 0 0 'Vmax ' 'vmax' vmax3d",
  "-h 1 0 1 0 0 17.75x1+3+14 0 1 0 10 0 0 'Wmin ' 'wmin' wmin3d",
  "-h 1 0 1 0 0 17.75x1+22+14 0 1 1 10 0 0 'Wmax ' 'wmax' wmax3d",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gquadmesh/uis/gquadmesh.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	35,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


