 /*
  * Khoros: $Id: grake.h,v 1.5.2.2 1997/05/31 18:55:13 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for grake
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _grake_h_
#define _grake_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
#include "vrgeometry/vrgeometry.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  This data is that from which the rakes location data will be computed. (required infile)
 */
char	*i_file;	/* This data is that from which the rakes location data will be computed. FILENAME */
int	 i_flag;	/* This data is that from which the rakes location data will be computed. FLAG */

/*
 *  The sample points. (required outfile)
 */
char	*o_file;	/* The sample points. FILENAME */
int	 o_flag;	/* The sample points. FLAG */

/*
 *  Contains a geometry icon for the rake. (required outfile)
 */
char	*orake_geom_file;	/* Contains a geometry icon for the rake. FILENAME */
int	 orake_geom_flag;	/* Contains a geometry icon for the rake. FLAG */

/*
 *  input file (optional infile)
 */
char	*i1_file;	/* input file FILENAME */
int	 i1_flag;	/* input file FLAG */

/*
 *  Number of samples to compute. (optional integer)
 */
int	 nsamples_int; 	/* Number of samples to compute. INT */
int	 nsamples_flag;	/* Number of samples to compute. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void grake_get_args PROTO((kaddr));
void grake_usage_additions PROTO((void));
void grake_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
int compute_original_endpoints PROTO((vertex_3d *, kobject));
int lget_minmax_points PROTO((kobject, vertex_3d *, vertex_3d *));
int create_geometry_icon PROTO((vertex_3d *, char *));
int create_samples PROTO((vertex_3d *, int, char *));
int xform_points PROTO((vertex_3d *, matrix4x4 *, float *, vertex_3d *, int));
/* -include_routines_end */

#endif
