 /*
  * Khoros: $Id: usage.c,v 1.5.2.2 1997/05/31 18:55:16 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.5.2.2 1997/05/31 18:55:16 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "grake.h"
/*-----------------------------------------------------------
| 
|  Routine Name: grake_get_args
| 
|       Purpose: Gets command line args for grake
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname grake
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void grake_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for grake is out of sync with arguments specified in grake's *.pane file; please rerun ghostwriter on grake.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the grake structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "grake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "grake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "grake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "orake_geom",
			  &(clui_info->orake_geom_file),
			  &(clui_info->orake_geom_flag))))
	{
	    kerror(NULL, "grake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "nsamples",
			  &(clui_info->nsamples_int),
			  &(clui_info->nsamples_flag))))
	{
	    kerror(NULL, "grake_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create a computational rake.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' grake",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/grake",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/grake/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Data to Sample' 'This data is that from which the rakes location data will be computed.' i",
  "-I 1 0 1 3 0 1 52x1+0+3 ' ' 'Input Transformation File' 'input file' i1",
  "-O 1 0 0 1 0 1 52x1+0+4.5 ' ' 'Output Samples' 'The sample points.' o",
  "-O 1 0 0 1 0 1 52x1+0+5.5 ' ' 'Output Geometry Icon' 'Contains a geometry icon for the rake.' orake_geom",
  "-i 1 0 1 1 0 45x1+0+7 2 64 8 1 0 'Nsamples' 'Number of samples to compute.' nsamples",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/grake/uis/grake.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


