 /*
  * Khoros: $Id: gresample.h,v 1.1.2.3 1997/05/31 18:55:30 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gresample
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gresample_h_
#define _gresample_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  First Input data object (required infile)
 */
char	*i_file;	/* First Input data object FILENAME */
int	 i_flag;	/* First Input data object FLAG */

/*
 *  Resulting output data object (required outfile)
 */
char	*o_file;	/* Resulting output data object FILENAME */
int	 o_flag;	/* Resulting output data object FLAG */

/*----- required ME group ----*/
	/*---- nested optional MI group ----*/
/*
 *  The size of the width dimension will be set to this amount, unless you specify zero, which means the output will be the same size as the input. (optional float)
 */
float	 w_abs_float;	/* The size of the width dimension will be set to this amount, unless you specify zero, which means the output will be the same size as the input. FLOAT */
int	 w_abs_flag;   	/* The size of the width dimension will be set to this amount, unless you specify zero, which means the output will be the same size as the input. FLAG */

/*
 *  The size of the height dimension will be set to this amount, unless you specify zero, which means the output will be the same size as the input. (optional float)
 */
float	 h_abs_float;	/* The size of the height dimension will be set to this amount, unless you specify zero, which means the output will be the same size as the input. FLOAT */
int	 h_abs_flag;   	/* The size of the height dimension will be set to this amount, unless you specify zero, which means the output will be the same size as the input. FLAG */

/*
 *  The size of the depth dimension will be set to this amount unless you specify zero, which means the output will be the same size as the input (optional float)
 */
float	 d_abs_float;	/* The size of the depth dimension will be set to this amount unless you specify zero, which means the output will be the same size as the input FLOAT */
int	 d_abs_flag;   	/* The size of the depth dimension will be set to this amount unless you specify zero, which means the output will be the same size as the input FLAG */

/*
 *  The size of the time dimension will be set to this value (unless you specify a zero, which means the output will be the same size as the input). (optional float)
 */
float	 t_abs_float;	/* The size of the time dimension will be set to this value (unless you specify a zero, which means the output will be the same size as the input). FLOAT */
int	 t_abs_flag;   	/* The size of the time dimension will be set to this value (unless you specify a zero, which means the output will be the same size as the input). FLAG */

	/*-- nested optional MI group end --*/

	/*---- nested optional MI group ----*/
/*
 *  Width dimension will be scaled by this amount. (optional float)
 */
float	 w_float;	/* Width dimension will be scaled by this amount. FLOAT */
int	 w_flag;   	/* Width dimension will be scaled by this amount. FLAG */

/*
 *  Height dimension will be scaled by this amount. (optional float)
 */
float	 h_float;	/* Height dimension will be scaled by this amount. FLOAT */
int	 h_flag;   	/* Height dimension will be scaled by this amount. FLAG */

/*
 *  Depth dimension will be scaled by this amount. (optional float)
 */
float	 d_float;	/* Depth dimension will be scaled by this amount. FLOAT */
int	 d_flag;   	/* Depth dimension will be scaled by this amount. FLAG */

/*
 *  Time dimension will be scaled by this amount. (optional float)
 */
float	 t_float;	/* Time dimension will be scaled by this amount. FLOAT */
int	 t_flag;   	/* Time dimension will be scaled by this amount. FLAG */

	/*-- nested optional MI group end --*/

/*-- required ME group end ---*/

/*
 *  Will choose between either a data-services processing mode (slow, but for large objects) or an in-memory-mode (fast) for smaller objects. (Optional list)
 */
int	 cmode_list;	/* Will choose between either a data-services processing mode (slow, but for large objects) or an in-memory-mode (fast) for smaller objects. LIST INDEX */
char	 *cmode_label;	/* Will choose between either a data-services processing mode (slow, but for large objects) or an in-memory-mode (fast) for smaller objects. LIST LABEL */
int	 cmode_flag;	/* Will choose between either a data-services processing mode (slow, but for large objects) or an in-memory-mode (fast) for smaller objects. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void gresample_get_args PROTO((kaddr));
void gresample_usage_additions PROTO((void));
void gresample_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
int lgresample_config PROTO((kobject in, kobject out));
int lgresample_value_using_dataservices PROTO((kobject in, kobject out, float *dest_w, float *dest_h,  float *dest_d,  float *dest_t));
int lgresample_value_using_memory PROTO((kobject in,kobject out,float *dest_w,float *dest_h,float *dest_d,float *dest_t));
/* -include_routines_end */

#endif
