 /*
  * Khoros: $Id: usage.c,v 1.1.2.3 1997/05/31 18:55:33 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.1.2.3 1997/05/31 18:55:33 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gresample.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gresample_get_args
| 
|       Purpose: Gets command line args for gresample
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gresample
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gresample_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gresample is out of sync with arguments specified in gresample's *.pane file; please rerun ghostwriter on gresample.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gresample structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "cmode", KVF_LIST_LABEL,
			  &(clui_info->cmode_label),
			  &(clui_info->cmode_flag)) &&
	      kclui_get_value(pane, "cmode", KVF_LIST_VAL,
			  &(clui_info->cmode_list),
			  &(clui_info->cmode_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "w_abs",
			  &(clui_info->w_abs_float),
			  &(clui_info->w_abs_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "h_abs",
			  &(clui_info->h_abs_float),
			  &(clui_info->h_abs_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "d_abs",
			  &(clui_info->d_abs_float),
			  &(clui_info->d_abs_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "t_abs",
			  &(clui_info->t_abs_float),
			  &(clui_info->t_abs_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "w",
			  &(clui_info->w_float),
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "h",
			  &(clui_info->h_float),
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "d",
			  &(clui_info->d_float),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "t",
			  &(clui_info->t_float),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "gresample_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'First-order resizing of value segment.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' gresample",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gresample",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/gresample/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "-O 1 0 0 1 0 1 52x1+0+3.5 ' ' 'Output' 'Resulting output data object' o",
  "-x 1 0 1 1 0 47x1+1+10.5 2 1 2 'Computation Mode' 'Will choose between either a data-services processing mode (slow, but for large objects) or an in-memory-mode (fast) for smaller objects.' cmode '(Slow) Data Services, Large Objects' '(Fast) In-Memory, small objects.'",
  "-C 1",
  "-B 0",
  "-f 1 0 1 1 0 17x1+27+6 0 0 0 2 0 0 'Width' 'The size of the width dimension will be set to this amount, unless you specify zero, which means the output will be the same size as the input.' w_abs",
  "-f 1 0 1 1 0 17x1+27+7 0 0 0 2 0 0 'Height' 'The size of the height dimension will be set to this amount, unless you specify zero, which means the output will be the same size as the input.' h_abs",
  "-f 1 0 1 1 0 17x1+27+8 0 0 0 2 0 0 'Depth' 'The size of the depth dimension will be set to this amount unless you specify zero, which means the output will be the same size as the input' d_abs",
  "-f 1 0 1 1 0 17x1+27+9 0 0 0 2 0 0 'Time' 'The size of the time dimension will be set to this value (unless you specify a zero, which means the output will be the same size as the input).' t_abs",
  "-E",
  "-B 0",
  "-b +2+5 'Scale Factors' blank1",
  "-f 1 0 1 0 0 17x1+2+6 0 0 1 2 0 0 'Width' 'Width dimension will be scaled by this amount.' w",
  "-f 1 0 1 0 0 17x1+2+7 0 0 1 2 0 0 'Height' 'Height dimension will be scaled by this amount.' h",
  "-f 1 0 1 0 0 17x1+2+8 0 0 1 2 0 0 'Depth' 'Depth dimension will be scaled by this amount.' d",
  "-f 1 0 1 0 0 17x1+2+9 0 0 1 2 0 0 'Time' 'Time dimension will be scaled by this amount.' t",
  "-E",
  "-E",
  "-b +27+5 'OR, New Size' blank2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gresample/uis/gresample.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	31,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


