 /*
  * Khoros: $Id: usage.c,v 1.9.2.2 1997/05/31 18:56:13 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.9.2.2 1997/05/31 18:56:13 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gstreamlines.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gstreamlines_get_args
| 
|       Purpose: Gets command line args for gstreamlines
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gstreamlines
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gstreamlines_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gstreamlines is out of sync with arguments specified in gstreamlines's *.pane file; please rerun ghostwriter on gstreamlines.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gstreamlines structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "rake",
			  &(clui_info->rake_file),
			  &(clui_info->rake_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "name",
			  &(clui_info->name_string),
			  &(clui_info->name_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "step",
			  &(clui_info->step_float),
			  &(clui_info->step_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "nsteps",
			  &(clui_info->nsteps_int),
			  &(clui_info->nsteps_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gstreamlines_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute Streamlines through 3-Component Vector/Flow Data.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' gstreamlines",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $GEOMETRY/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gstreamlines",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/gstreamlines/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Flow Data' 'Data object containing flow vectors.  Must have 3 computational dimensions and 3 coordinate dimensions.' i",
  "-I 1 0 0 1 0 1 52x1+0+3.5 ' ' 'Rake Data         ' 'List of x,y,z points used for seeding the streamlines computation.' rake",
  "-s 1 0 1 1 0 42x1+6+5.5 'streamlines' 'Name ' 'Internal name of geometry object.' name",
  "-f 1 0 1 1 0 20x1+6+7 2 2 0.05 4 0 0 'Step Size' 'Controls granularity of integration.  Make smaller for better approximation.' step",
  "-i 1 0 1 1 0 20x1+6+8 1 512 100 0 0 'Num Steps' 'Number of integration steps to compute.' nsteps",
  "-O 1 0 0 1 0 1 52x1+0+10 ' ' 'Output Geometry' 'Geometry representing streamlines.' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gstreamlines/uis/gstreamlines.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	18,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


