 /*
  * Khoros: $Id: gtransform.h,v 1.8.2.3 1997/05/31 18:56:29 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gtransform
   >>>> 
   >>>>    Written By: wes
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gtransform_h_
#define _gtransform_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
#include <geometry/geometry.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input Geometry Object  (required infile)
 */
char	*i_file;	/* Input Geometry Object  FILENAME */
int	 i_flag;	/* Input Geometry Object  FLAG */

/*
 *  Output Geometry Object  (required outfile)
 */
char	*o_file;	/* Output Geometry Object  FILENAME */
int	 o_flag;	/* Output Geometry Object  FLAG */

/*
 *  Scale to be applied to X coordinates of vertices. (optional float)
 */
float	 xscale_float;	/* Scale to be applied to X coordinates of vertices. FLOAT */
int	 xscale_flag;   	/* Scale to be applied to X coordinates of vertices. FLAG */

/*
 *  Translation to be applied to X coordinates of vertices. (optional float)
 */
float	 xtrans_float;	/* Translation to be applied to X coordinates of vertices. FLOAT */
int	 xtrans_flag;   	/* Translation to be applied to X coordinates of vertices. FLAG */

/*
 *  Scale to be applied to Y coordinates of vertices. (optional float)
 */
float	 yscale_float;	/* Scale to be applied to Y coordinates of vertices. FLOAT */
int	 yscale_flag;   	/* Scale to be applied to Y coordinates of vertices. FLAG */

/*
 *  Translation to be applied to Y coordinates of vertices. (optional float)
 */
float	 ytrans_float;	/* Translation to be applied to Y coordinates of vertices. FLOAT */
int	 ytrans_flag;   	/* Translation to be applied to Y coordinates of vertices. FLAG */

/*
 *  Scale to be applied to Z coordinates of vertices. (optional float)
 */
float	 zscale_float;	/* Scale to be applied to Z coordinates of vertices. FLOAT */
int	 zscale_flag;   	/* Scale to be applied to Z coordinates of vertices. FLAG */

/*
 *  Translation to be applied to Z coordinates of vertices. (optional float)
 */
float	 ztrans_float;	/* Translation to be applied to Z coordinates of vertices. FLOAT */
int	 ztrans_flag;   	/* Translation to be applied to Z coordinates of vertices. FLAG */

/*
 *  Toggle to enable or prohibit transformation of the normals, if present. (optional logical)
 */
int	 do_normals_logic;	/* Toggle to enable or prohibit transformation of the normals, if present. LOGIC */
int	 do_normals_flag;  	/* Toggle to enable or prohibit transformation of the normals, if present. FLAG */

/*
 *  indicates how many nodes will be used in a threaded operation. (optional integer)
 */
int	 parallel_int; 	/* indicates how many nodes will be used in a threaded operation. INT */
int	 parallel_flag;	/* indicates how many nodes will be used in a threaded operation. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void gtransform_get_args PROTO((kaddr));
void gtransform_usage_additions PROTO((void));
void gtransform_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
