 /*
  * Khoros: $Id: usage.c,v 1.8.2.3 1997/05/31 18:56:31 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.8.2.3 1997/05/31 18:56:31 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gtransform.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gtransform_get_args
| 
|       Purpose: Gets command line args for gtransform
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gtransform
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gtransform_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gtransform is out of sync with arguments specified in gtransform's *.pane file; please rerun ghostwriter on gtransform.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gtransform structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xscale",
			  &(clui_info->xscale_float),
			  &(clui_info->xscale_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xtrans",
			  &(clui_info->xtrans_float),
			  &(clui_info->xtrans_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yscale",
			  &(clui_info->yscale_float),
			  &(clui_info->yscale_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ytrans",
			  &(clui_info->ytrans_float),
			  &(clui_info->ytrans_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "zscale",
			  &(clui_info->zscale_float),
			  &(clui_info->zscale_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ztrans",
			  &(clui_info->ztrans_float),
			  &(clui_info->ztrans_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "do_normals",
			  &(clui_info->do_normals_logic),
			  &(clui_info->do_normals_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "parallel",
			  &(clui_info->parallel_int),
			  &(clui_info->parallel_flag))))
	{
	    kerror(NULL, "gtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'geometric transformation of geometry objects.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' gtransform",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $GEOMETRY/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gtransform",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/gtransform/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 1 1 52x1+0+2 ' ' 'Input Geometry Object  ' 'Input Geometry Object ' i",
  "-O 1 0 0 1 1 1 52x1+0+3.5 ' ' 'Output Geometry Object ' 'Output Geometry Object ' o",
  "-f 1 0 1 1 1 20x1+1+5.5 0 0 1 0 0 0 'X Scale' 'Scale to be applied to X coordinates of vertices.' xscale",
  "-f 1 0 1 1 1 23x1+23+5.5 0 0 0 0 0 0 'X Translate' 'Translation to be applied to X coordinates of vertices.' xtrans",
  "-f 1 0 1 1 1 20x1+1+6.5 0 0 1 0 0 0 'Y Scale' 'Scale to be applied to Y coordinates of vertices.' yscale",
  "-f 1 0 1 1 1 23x1+23+6.5 0 0 0 0 0 0 'Y Translate' 'Translation to be applied to Y coordinates of vertices.' ytrans",
  "-f 1 0 1 1 1 20x1+1+7.5 0 0 1 0 0 0 'Z Scale' 'Scale to be applied to Z coordinates of vertices.' zscale",
  "-f 1 0 1 1 1 23x1+23+7.5 0 0 0 0 0 0 'Z Translate' 'Translation to be applied to Z coordinates of vertices.' ztrans",
  "-l 0 0 1 0 1 25x1+1+9.5 0 'Transform Normals?' 'No' 'Yes' 'Toggle to enable or prohibit transformation of the normals, if present.' do_normals",
  "-i 1 0 1 1 1 25x1+1+11 1 100 1 0 0 'Parallelism' 'indicates how many nodes will be used in a threaded operation.' parallel",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gtransform/uis/gtransform.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	22,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


