 /*
  * Khoros: $Id: gtubeness.h,v 1.11.2.3 1997/05/31 18:56:47 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for gtubeness
   >>>> 
   >>>>    Written By: wes
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _gtubeness_h_
#define _gtubeness_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>

/* -include_includes */
#include <geometry/geometry.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input geometry object. (required infile)
 */
char	*i_file;	/* Input geometry object. FILENAME */
int	 i_flag;	/* Input geometry object. FLAG */

/*
 *  Tube-ified geometry object (required outfile)
 */
char	*o_file;	/* Tube-ified geometry object FILENAME */
int	 o_flag;	/* Tube-ified geometry object FLAG */

/*
 *  A scalar which indicates the radius of the tube. (optional float)
 */
float	 scale_float;	/* A scalar which indicates the radius of the tube. FLOAT */
int	 scale_flag;   	/* A scalar which indicates the radius of the tube. FLAG */

/*
 *  The number of sides for each tube will be 2^(subdivisions - 1). (optional integer)
 */
int	 subdivisions_int; 	/* The number of sides for each tube will be 2^(subdivisions - 1). INT */
int	 subdivisions_flag;	/* The number of sides for each tube will be 2^(subdivisions - 1). FLAG */

/*
 *  A list of choices for possible methods for capping the tubes. (Optional list)
 */
int	 cap_style_list;	/* A list of choices for possible methods for capping the tubes. LIST INDEX */
char	 *cap_style_label;	/* A list of choices for possible methods for capping the tubes. LIST LABEL */
int	 cap_style_flag;	/* A list of choices for possible methods for capping the tubes. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void gtubeness_get_args PROTO((kaddr));
void gtubeness_usage_additions PROTO((void));
void gtubeness_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
