 /*
  * Khoros: $Id: usage.c,v 1.11.2.3 1997/05/31 18:56:49 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.11.2.3 1997/05/31 18:56:49 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "gtubeness.h"
/*-----------------------------------------------------------
| 
|  Routine Name: gtubeness_get_args
| 
|       Purpose: Gets command line args for gtubeness
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname gtubeness
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void gtubeness_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for gtubeness is out of sync with arguments specified in gtubeness's *.pane file; please rerun ghostwriter on gtubeness.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the gtubeness structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "gtubeness_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "scale",
			  &(clui_info->scale_float),
			  &(clui_info->scale_flag))))
	{
	    kerror(NULL, "gtubeness_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "subdivisions",
			  &(clui_info->subdivisions_int),
			  &(clui_info->subdivisions_flag))))
	{
	    kerror(NULL, "gtubeness_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "cap_style", KVF_LIST_LABEL,
			  &(clui_info->cap_style_label),
			  &(clui_info->cap_style_flag)) &&
	      kclui_get_value(pane, "cap_style", KVF_LIST_VAL,
			  &(clui_info->cap_style_list),
			  &(clui_info->cap_style_flag))))
	{
	    kerror(NULL, "gtubeness_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "gtubeness_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Replace Lines with Tesselated Cylinders' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' ktubeness",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $GEOMETRY/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/gtubeness",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/kroutine/gtubeness/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 1 1 51.5x1+0+2 ' ' 'Input Geometry ' 'Input geometry object.' i",
  "-f 1 0 1 1 1 44.5x1+2+4 1 1 0.1 7 0 0 'Radius Scale' 'A scalar which indicates the radius of the tube.' scale",
  "-i 1 0 1 1 1 44.5x1+2+5 2 6 3 1 0 'Subdivisions' 'The number of sides for each tube will be 2^(subdivisions - 1).' subdivisions",
  "-x 1 0 1 1 1 24x1+2+7 3 1 1 'Cap Style' 'A list of choices for possible methods for capping the tubes.' cap_style 'None' 'Flat Caps' 'Round Caps'",
  "-O 1 0 0 1 1 1 52x1+0+9 ' ' 'Output Geometry' 'Tube-ified geometry object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/gtubeness/uis/gtubeness.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


