 /*
  * Khoros: $Id: usage.c,v 1.12.2.2 1997/05/31 18:57:18 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.12.2.2 1997/05/31 18:57:18 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "kslicer.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kslicer_get_args
| 
|       Purpose: Gets command line args for kslicer
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kslicer
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kslicer_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kslicer is out of sync with arguments specified in kslicer's *.pane file; please rerun ghostwriter on kslicer.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the kslicer structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "p", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->p_flag))))
	{
	    kerror(NULL, "kslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->p_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_flag(pane, "reo",
			  &(clui_info->reo_flag))))
	{
	    kerror(NULL, "kslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "loc",
			  &(clui_info->loc_flag))))
	{
	    kerror(NULL, "kslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "kslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "ps",
			  &(clui_info->ps_float),
			  &(clui_info->ps_flag))))
	{
	    kerror(NULL, "kslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "s",
			  &(clui_info->s_float),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "kslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Extract (N-1)D Region from (N)D Object' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Slice_Data",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/kslicer",
  "-H 1  5x1+41+0 'Help' 'help page for kslicer' $GEOMETRY/objects/kroutine/kslicer/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Data Object' 'input file to slice' i",
  "",
  "-T 1 0 1 1 1 48x2+1+3.5 +0+0 1 'Slice along Orthogonal Slice Plane' 'choose orthogonal slice plane' p",
  "-l 1 0 1 1 1 9.5x1+3+1 0 'Width ' ' ' ' ' 'slice along constant width' w",
  "-l 1 0 1 0 1 9.5x1+13+1 1 'Height ' ' ' ' ' 'slice along constant height' h",
  "-l 1 0 1 0 1 9.5x1+22+1 1 'Depth ' ' ' ' ' 'slice along constant depth' d",
  "-l 1 0 1 0 1 9.5x1+31+1 1 'Time ' ' ' ' ' 'slice along constant time' t",
  "-l 1 0 1 0 1 9.5x1+39+1 1 'Element ' ' ' ' ' 'slice along constant element' e",
  "-E",
  "#      -l 1 0 1 2 0 22x1+4+10.5 1 'Slice at  ' ' Given Position   ' 'Integer Position ' 'take nearest integer slice plane' int",
  "",
  "-t 1 0 1 1 0 27.125x1+10+10 'Reorient Data to Face Image Plane' 'reorient slice to face image plane' reo",
  "-t 1 0 1 0 0 23.375x1+10+11 'Force Explicit Location Data' 'force explicit location data' loc",
  "",
  "-O 1 0 0 1 0 1 51.25x1+0+12.5 ' ' 'Output Data Slice' 'output file containing slice' o",
  "",
  "-C 0",
  "-f 1 0 1 1 1 50x1+1+6.5 0 1 0.5 2 1 0 'Percentage Depth Slice' 'slice at percentage depth on slice plane' ps",
  "-f 1 0 1 0 1 32.5x1+1+8 1 1 0 1 0 0 'Slice Plane           ' 'slice at position on slice plane' s",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/kroutine/kslicer/uis/kslicer.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	32,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


