
/*
 * Copyright (c) 1996,  The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Visualization
 *      Group at Lawrence Berkeley National Laboratory.
 * 4. Neither the name of the University of California, Berkeley nor of the 
 *    Lawrence Berkeley National Laboratory may be used to endorse or 
 *    promote products derived from this software without specific prior 
 *    written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 * This work is supported by the U. S. Department of Energy under contract 
 * number DE-AC03-76SF00098 between the U. S. Department of Energy and the 
 * University of California.
 *
 *	Author: Wes Bethel
 *		Lawrence Berkeley National Laboratory
 *              Berkeley, California 
 *
 *  "this software is 100% hand-crafted by a human being in the USA"
 */
 

/* Khoros: $Id: internals.h,v 1.5 1997/01/23 01:11:03 mirage Exp $ */



/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose:	Private include file for library `geometry'.
   >>>>			This is (should be) included by all source
   >>>>			files comprising the library.  
   >>>>
   >>>>       Toolbox: GEOMETRY
   >>>>
   >>>>    Written By: Steve Kubica
   >>>>
   >>>>          Date: Dec 19, 1993 
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _geometry_internals_h_
#define _geometry_internals_h_



	/*-------------------------------------*
	|	#includes
	\--------------------------------------*/

#include <geometry.h>


	/*-------------------------------------*
	|	#defines
	\--------------------------------------*/

	/*-------------------------------------*
	|	typedefs
	\--------------------------------------*/


typedef struct surface_colors_rgba
{
    KGEOM_VERTEX_TYPE r,g,b,a;
} surface_colors_rgba;


typedef struct surface_colors_rgb
{
    KGEOM_VERTEX_TYPE r,g,b;
} surface_colors_rgb;

typedef struct byte_surface_colors_rgb
{
    unsigned char r,g,b;
} byte_surface_colors_rgb;

typedef struct byte_surface_colors_rgba
{
    unsigned char r,g,b,a;
} byte_surface_colors_rgba;

typedef struct byte_surface_colors_index
{
    unsigned char b;
} byte_surface_colors_index;

typedef struct vertex3d
{
    float x,y,z;
} vertex;

typedef struct octmesh_slice
{
    int usize,vsize;
    float **xpts,**ypts,**zpts;
    float **data;

    union
	{
	    surface_colors_rgb **rgb;
	    surface_colors_rgba **rgba;
	    byte_surface_colors_rgb **urgb;
	    byte_surface_colors_rgba **urgba;
	    byte_surface_colors_index **bindex;
	} colors;
    
    union
	{
	    vertex_3d **normals_v3;
	    vertex **normals_v;
	} normals;
} octmesh_slice;



	/*-------------------------------------*
	|	global variable declarations
	\--------------------------------------*/


	/*-------------------------------------*
	|	macros
	\--------------------------------------*/


	/*-------------------------------------*
	|	routine definitions
	\--------------------------------------*/

int find_location_minmax PROTO((kobject,int,int,int,int,vertex *,vertex *));
void lprim_copy PROTO((kobject, kobject, int, vertex_3d *, vertex_3d *));


#endif /* _geometry_internals_h_ */
/* Don't add after this point */
