 /*
  * Khoros: $Id: lglinexyz.c,v 1.13.2.3 1997/05/31 18:58:50 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: lglinexyz.c,v 1.13.2.3 1997/05/31 18:58:50 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Library Routine for glinexyz
   >>>> 
   >>>>  Private: 
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 	lglinexyz
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "internals.h"

/* -library_includes */
#include "internals.h"
static void get_segments		PROTO((int , kfile *, kgeom_object *, 
					       int, vertex_3d *, vertex_3d *, 
					       int));
/* -library_includes_end */


/****************************************************************
* 
*  Routine Name: lglinexyz - *
* 
*       Purpose: This should be a complete description that anyone
*                could understand;  it should have acceptable grammar
*                and correct spelling.
*
*         Input: argument1 - explanation
*                argument2 - explanation
*                argument3 - explanation
*
*        Output: argument4 - explanation
*                argument5 - explanation
*
*       Returns: TRUE (1) on success, FALSE (0) otherwise
*
*  Restrictions: Restrictions on data or input as applicable
*    Written By: 
*          Date: July 1, 1997
*      Verified: 
*  Side Effects: 
*      Examples: 
* Modifications: 
****************************************************************/
/* -library_def */
int lglinexyz(kfile *infile,
	      kgeom_object *outobj,
	      char *name,
	      int close_region)
/* -library_def_end */

/* -library_code */
{
    int nsegs,seq_no;
    int i;
    vertex_3d bmin,bmax,center;
    char buffer[256];
    
    /* set up the output object */
    outobj->name = kstrdup(name);
    outobj->layout = KPER_VERTEX;
    outobj->has_alpha = FALSE;
    
    kfgets(buffer, KLENGTH, infile);
    ksscanf(buffer,"%d",&nsegs);
    
    seq_no = 0;

    for (i=0;i<3;i++)
    {
	bmin.v[i] = KGEOM_BIGNUM;
	bmax.v[i] = KGEOM_SMALLNUM;
    }
    
    while (!kfeof(infile))
    {
	get_segments(nsegs,infile,outobj,seq_no,&bmin,&bmax,close_region); 
	kfscanf(infile,"%d",&nsegs);
	seq_no++;
    }

    for (i=0;i<3;i++)
	center.v[i] = bmin.v[i] + (bmax.v[i] - bmin.v[i]) * 0.5;

    outobj->has_bounding_box = TRUE;
    outobj->min[0] = bmin.v[0];
    outobj->min[1] = bmin.v[1];
    outobj->min[2] = bmin.v[2];
    outobj->max[0] = bmax.v[0];
    outobj->max[1] = bmax.v[1];
    outobj->max[2] = bmax.v[2];

    outobj->has_center = TRUE;
    outobj->center[0] = center.v[0];
    outobj->center[1] = center.v[1];
    outobj->center[2] = center.v[2];
    
    return TRUE;
}

static void
get_segments(int nverts,
	     kfile *infile,
	     kgeom_object *outobj,
	     int prim_no,
	     vertex_3d *min,
	     vertex_3d *max,
	     int close_region)
{
    int i;
    vertex_3d *v,*v1;
    vertex_3d loc_min,loc_max;
    kgeom_polyline *lines;


    v = v1 = (vertex_3d *) kmalloc((size_t)(sizeof(vertex_3d)*((close_region == 0) ?nverts:nverts+1)));
    
    for (i=0;i<nverts;i++,v++)
    {
	kfscanf(infile,"%f %f %f",&(v->v[0]),&(v->v[1]),&(v->v[2]));
#if 0
	for (j=0;j<3;j++)
	{
	    if (v->v[j] > max->v[j])
		max->v[j] = v->v[j];
	    if (v->v[j] < min->v[j])
		min->v[j] = v->v[j];
	}
#endif
    }

    if (close_region == 1)
	v1[nverts] = v1[0];

    lcompute_bbox(v1,nverts,&loc_min,&loc_max);
    lunion_boxes(min,max,&loc_min,&loc_max,min,max);

    lines = (kgeom_polyline *) kgeom_new_primitive(KGEOM_POLYLINE_CONNECTED);
    lines->nverts = (close_region) ? nverts+1 : nverts;
    lines->locs = (float *) v1;
    kgeom_add_primitive(outobj, (kgeom_primitive *) lines);
}
/* -library_code_end */
