 /*
  * Khoros: $Id: form_info.c,v 1.3.2.2 1997/05/31 18:59:30 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: form_info.c,v 1.3.2.2 1997/05/31 18:59:30 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	FormInfo Extraction Routines
   >>>> 
   >>>>  Private: 
   >>>> 	_xvf_get_form
   >>>> 
   >>>>   Static: 
   >>>> 	_xvf_get_subform
   >>>> 	_xvf_get_pane
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "oslicer.h"


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_form
| 
|       Purpose: Extracts information from GUI
| 
|         Input: forminfo - pointer to gui_info_struct
| 
|        Output: none
|    Written By: conductor -oname oslicer
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_form(
     gui_info_struct *forminfo)
{
	ksubform   *subform;
	if (forminfo->subform_struct != NULL)
	{
	    subform = forminfo->subform_struct->Subformptr;
	    kvf_get_attribute(subform->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->subform_selected));
	    _xvf_get_subform(forminfo->subform);

	}

}

/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_subform
| 
|       Purpose: Extracts information from subform subform
| 
|         Input: subforminfo - pointer to form_subform structure
| 
|        Output: none
|    Written By: conductor -oname oslicer
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_subform(
     form_subform *subforminfo)
{
	kcontrol   *pane;
	if (subforminfo->pane_struct != NULL)
	{
	    pane = subforminfo->pane_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->pane_selected));
	    _xvf_get_pane(subforminfo->pane);
	}


}



/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_pane
| 
|       Purpose: Extracts information from pane pane
| 
|         Input: paneinfo - pointer to subform_pane structure
| 
|        Output: none
|    Written By: conductor -oname oslicer
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_pane(
     subform_pane *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'form->subform->pane' Pane Info structure
	 */

	if (paneinfo->quit_struct != NULL)
	{
	    selection = paneinfo->quit_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->quit));

	}

	if (paneinfo->slice_axis_struct != NULL)
	{
	    selection = paneinfo->slice_axis_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->slice_axis));
	    if (paneinfo->slice_axis_label != NULL) kfree_and_NULL(paneinfo->slice_axis_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->slice_axis_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->slice_axis_selected));
	    }

	}

	if (paneinfo->slice_number_struct != NULL)
	{
	    selection = paneinfo->slice_number_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_INT_VAL,
	                    &(paneinfo->slice_number));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->slice_number_selected));
	    }
	}

}


