 /*
  * Khoros: $Id: form_info.h,v 1.3.2.2 1997/05/31 18:59:32 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Form Info Structure for oslicer Form
   >>>> 
   >>>>    Written By: conductor -oname oslicer
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _form_info_h_
#define _form_info_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

/*
 * Pane Info Struct for 'pane' Pane
 */
typedef struct _subform_pane{

kform_struct *license_struct; /* pass to xvf_set_attributes() */

kform_struct *help_struct; /* pass to xvf_set_attributes() */

int          quit;         /* TRUE when user clicks on 'Quit' button */
kform_struct *quit_struct; /* pass to xvf_set_attributes() */

int          slice_axis;          /* int value of 'slice_axis'*/
char         *slice_axis_label;   /* label representing int value of 'slice_axis'*/
kform_struct *slice_axis_struct;  /* pass to xvf_set_attributes() */
int          slice_axis_selected; /* TRUE on <cr> for 'slice_axis' */

int          slice_number;          /* int for 'slice_number'*/
kform_struct *slice_number_struct;  /* pass to xvf_set_attributes() */
int          slice_number_selected; /* TRUE on <cr> for 'slice_number' */

} subform_pane;

/*
 * Subform Info Struct for 'subform' Subform
 */
typedef struct _form_subform {

subform_pane  *pane;          /* ptr to Pane Info struct for pane 'pane' */
int          pane_selected;          /* TRUE if input was from pane 'pane' */
kform_struct *pane_struct;          /* pass to xvf_set_attributes() */

}  form_subform;

/*
 * Form Info Struct for 'form' form
 */
typedef struct _gui_info_struct {

form_subform  *subform;
int subform_selected;
kform_struct *subform_struct;


 } gui_info_struct; 

        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void _xvf_free_form PROTO((gui_info_struct *));
void _xvf_get_form  PROTO((gui_info_struct *));

int  _xvf_init_form PROTO((kform *, gui_info_struct *));
void run_form       PROTO((kform *, ksubform *, kaddr));

void run_subform      PROTO((form_subform *));
void _xvf_get_subform PROTO((form_subform *));

void run_pane      PROTO((subform_pane *));
void _xvf_get_pane PROTO((subform_pane *));
void pane_slice_axis	PROTO((subform_pane *));
void pane_slice_number	PROTO((subform_pane *));




#endif /* _form_info_h_ */ 
/* Don't add after this point */
