 /*
  * Khoros: $Id: usage.c,v 1.5.2.2 1997/05/31 18:59:39 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.5.2.2 1997/05/31 18:59:39 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "oslicer.h"
/*-----------------------------------------------------------
| 
|  Routine Name: oslicer_get_args
| 
|       Purpose: Gets command line args for oslicer
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname oslicer
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void oslicer_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for oslicer is out of sync with arguments specified in oslicer's *.pane file; please rerun ghostwriter on oslicer.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the oslicer structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "oslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "oslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "oslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "oslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "oslicer_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Interactive Slicing Tool.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' oslicer",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/oslicer",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/xvroutine/oslicer/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "-O 1 0 0 1 0 1 52x1+0+3.5 ' ' 'Output' 'Resulting output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/xvroutine/oslicer/uis/oslicer.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	14,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 20x3+10+15 +38+1 ' ' form",
  "-M 1 1 20x10+10+5 +25+0 'Subform' subform",
  "-P 1 0 49.5x10.6818+5+1.5 +13+0.5 'Pane' pane",
  "-H 1  10.5x1+26+0 'License' 'displays license' $BOOTSTRAP/repos/license/License license",
  "-H 1  6x1+40+0 'Help' 'display online help' $GEOMETRY/objects/xvroutine/oslicer/help/Overview.doc help",
  "-Q 1 0 6x1+48+0 'Quit'",
  "-x 1 0 0 1 1 30x1+1+2 4 1 1 'Slice Along Constant' 'Indicates alongwhich axis we\\'ll do the orthogonal slicing.' slice_axis 'Width' 'Height' 'Depth' 'Time '",
  "-i 1 0 0 1 1 45x1+1+3.5 0 10 0 1 0 'Slice Number' 'The integral number of the slice plane.' slice_number",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$GEOMETRY/objects/xvroutine/oslicer/uis/oslicer.form",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	11,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	1,
	512};


