 /*
  * Khoros: $Id: form_drv.c,v 1.1.2.1 1997/06/07 20:37:19 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: form_drv.c,v 1.1.2.1 1997/06/07 20:37:19 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	GUI Drivers for 'pdb2geom'
   >>>> 
   >>>>  Private: 
   >>>> 	run_form
   >>>> 	run_subform
   >>>> 	run_pane
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "pdb2geom.h"

/*-----------------------------------------------------------
| 
|  Routine Name: run_form
| 
|       Purpose: Main GUI Driver for pdb2geom
| 
|         Input: None
| 
|        Output: Returns TRUE on success, FALSE on failure
|    Written By: conductor -oname pdb2geom
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void run_form(
     kform    *form,
     ksubform *subform,
     kaddr    client_data)
{
	/*
	 * GUI info structure passed in as client_data 
	 */
	gui_info_struct *master_info = (gui_info_struct *) client_data;

	/*
	 * Get information from the forms
	 */
	_xvf_get_form(master_info);

	if (form->quit)
	{
	    xvf_destroy_allforms();
	    _xvf_free_form(master_info);
	    return;
	}

	/*
	 * action came from the 'subform' subform
	 */
	else if (master_info->subform_selected)
	    run_subform(master_info->subform);

	xvf_clear_selections(form);

}

/*-----------------------------------------------------------
| 
|  Routine Name: run_subform
| 
|       Purpose: GUI Driver for subform 'subform'
| 
|         Input: form      - pointer to the form tree
|                subform_info - pointer to form_subform struct
| 
|        Output: None
|    Written By: conductor -program_name pdb2geom
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_subform(
     form_subform *subform_info)
{

	/*
	 * action came from the 'pane' pane
	 */
	if (subform_info->pane_selected)
	    run_pane(subform_info->pane);


}   /* end run_subform */



/*-----------------------------------------------------------
| 
|  Routine Name: run_pane
| 
|       Purpose: GUI Driver for pane 'pane'
| 
|         Input: form - pointer to the form tree
|                pane_info - pointer to subform_pane struct
| 
|        Output: None
|    Written By: conductor -oname pdb2geom
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void run_pane(
     subform_pane *pane_info)

{

	/*
	 * user selected 'live' input file selection 'i'
	 */
	if (pane_info->i_selected)
	{
	    pane_i(pane_info);
	    pane_info->i_selected = FALSE;
	}
	/*
	 * user selected 'live' output file selection 'o'
	 */
	else if (pane_info->o_selected)
	{
	    pane_o(pane_info);
	    pane_info->o_selected = FALSE;
	}
	/*
	 * user selected 'live' list selection 'rep'
	 */
	else if (pane_info->rep_selected)
	{
	    pane_rep(pane_info);
	    pane_info->rep_selected = FALSE;
	}
	/*
	 * user clicked on pane action button selection 'display_now'
	 */
	else if (pane_info->display_now)
	{
	    pane_display_now(pane_info);
	    pane_info->display_now = FALSE;
	}
	/*
	 * user selected 'live' float selection 'radius'
	 */
	else if (pane_info->radius_selected)
	{
	    pane_radius(pane_info);
	    pane_info->radius_selected = FALSE;
	}
	/*
	 * user clicked on pane action button selection 'color_now'
	 */
	else if (pane_info->color_now)
	{
	    pane_color_now(pane_info);
	    pane_info->color_now = FALSE;
	}


}


