 /*
  * Khoros: $Id: form_info.c,v 1.1.2.1 1997/06/07 20:37:21 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: form_info.c,v 1.1.2.1 1997/06/07 20:37:21 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	FormInfo Extraction Routines
   >>>> 
   >>>>  Private: 
   >>>> 	_xvf_get_form
   >>>> 
   >>>>   Static: 
   >>>> 	_xvf_get_subform
   >>>> 	_xvf_get_pane
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "pdb2geom.h"


/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_form
| 
|       Purpose: Extracts information from GUI
| 
|         Input: forminfo - pointer to gui_info_struct
| 
|        Output: none
|    Written By: conductor -oname pdb2geom
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_form(
     gui_info_struct *forminfo)
{
	ksubform   *subform;
	if (forminfo->subform_struct != NULL)
	{
	    subform = forminfo->subform_struct->Subformptr;
	    kvf_get_attribute(subform->back_kformstruct, KVF_SELECTED,
	                    &(forminfo->subform_selected));
	    _xvf_get_subform(forminfo->subform);

	}

}

/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_subform
| 
|       Purpose: Extracts information from subform subform
| 
|         Input: subforminfo - pointer to form_subform structure
| 
|        Output: none
|    Written By: conductor -oname pdb2geom
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_subform(
     form_subform *subforminfo)
{
	kcontrol   *pane;
	if (subforminfo->pane_struct != NULL)
	{
	    pane = subforminfo->pane_struct->Controlptr;
	    kvf_get_attribute(pane->back_kformstruct, KVF_SELECTED,
	                    &(subforminfo->pane_selected));
	    _xvf_get_pane(subforminfo->pane);
	}


}



/*-----------------------------------------------------------
| 
|  Routine Name: _xvf_get_pane
| 
|       Purpose: Extracts information from pane pane
| 
|         Input: paneinfo - pointer to subform_pane structure
| 
|        Output: none
|    Written By: conductor -oname pdb2geom
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void _xvf_get_pane(
     subform_pane *paneinfo)
{
	kselection *selection;

	/*
	 * extracting 'form->subform->pane' Pane Info structure
	 */

	if (paneinfo->quit_struct != NULL)
	{
	    selection = paneinfo->quit_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->quit));

	}

	if (paneinfo->i_struct != NULL)
	{
	    selection = paneinfo->i_struct->Selptr;
	    if (selection->modified)
	    {
		if (paneinfo->i != NULL) kfree_and_NULL(paneinfo->i);
		kvf_get_attribute(selection->back_kformstruct, KVF_FILE_NAME,
		                  &(paneinfo->i));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->i_selected));
	    }
	}

	if (paneinfo->o_struct != NULL)
	{
	    selection = paneinfo->o_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->o != NULL) kfree_and_NULL(paneinfo->o);
	    kvf_get_attribute(selection->back_kformstruct, KVF_FILE_NAME,
	                    &(paneinfo->o));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->o_selected));
	    }
	}

	if (paneinfo->rep_struct != NULL)
	{
	    selection = paneinfo->rep_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->rep));
	    if (paneinfo->rep_label != NULL) kfree_and_NULL(paneinfo->rep_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->rep_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->rep_selected));
	    }

	}

	if (paneinfo->res_name_struct != NULL)
	{
	    selection = paneinfo->res_name_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->res_name));
	    if (paneinfo->res_name_label != NULL) kfree_and_NULL(paneinfo->res_name_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->res_name_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->res_name_optsel));
	    }

	}

	if (paneinfo->displayed_struct != NULL)
	{
	    selection = paneinfo->displayed_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->displayed != NULL) kfree_and_NULL(paneinfo->displayed);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->displayed));
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->displayed_optsel));
	    }

	}

	if (paneinfo->display_now_struct != NULL)
	{
	    selection = paneinfo->display_now_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->display_now));

	}

	if (paneinfo->res_num_struct != NULL)
	{
	    selection = paneinfo->res_num_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_INT_VAL,
	                    &(paneinfo->res_num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->res_num_optsel));
	    }
	}

	if (paneinfo->colored_struct != NULL)
	{
	    selection = paneinfo->colored_struct->Selptr;
	    if (selection->modified)
	    {
	    if (paneinfo->colored != NULL) kfree_and_NULL(paneinfo->colored);
	    kvf_get_attribute(selection->back_kformstruct, KVF_STRING_VAL,
	                    &(paneinfo->colored));
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->colored_optsel));
	    }

	}

	if (paneinfo->radius_struct != NULL)
	{
	    selection = paneinfo->radius_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_FLOAT_VAL,
	                    &(paneinfo->radius));
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->radius_selected));
	    }

	}

	if (paneinfo->chain_name_struct != NULL)
	{
	    selection = paneinfo->chain_name_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->chain_name));
	    if (paneinfo->chain_name_label != NULL) kfree_and_NULL(paneinfo->chain_name_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->chain_name_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->chain_name_optsel));
	    }

	}

	if (paneinfo->color_now_struct != NULL)
	{
	    selection = paneinfo->color_now_struct->Selptr;
	    kvf_get_attribute(selection->back_kformstruct, KVF_SELECTED,
	                    &(paneinfo->color_now));

	}

	if (paneinfo->name_struct != NULL)
	{
	    selection = paneinfo->name_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->name));
	    if (paneinfo->name_label != NULL) kfree_and_NULL(paneinfo->name_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->name_label));
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->name_optsel));
	    }

	}

	if (paneinfo->num_struct != NULL)
	{
	    selection = paneinfo->num_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_INT_VAL,
	                    &(paneinfo->num));
	    kvf_get_attribute(selection->back_kformstruct, KVF_OPTSEL,
	                    &(paneinfo->num_optsel));
	    }
	}

	if (paneinfo->color_struct != NULL)
	{
	    selection = paneinfo->color_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_VAL,
	                    &(paneinfo->color));
	    if (paneinfo->color_label != NULL) kfree_and_NULL(paneinfo->color_label);
	    kvf_get_attribute(selection->back_kformstruct, KVF_LIST_LABEL,
	                    &(paneinfo->color_label));
	    }

	}

	if (paneinfo->red_struct != NULL)
	{
	    selection = paneinfo->red_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_FLOAT_VAL,
	                    &(paneinfo->red));
	    }

	}

	if (paneinfo->green_struct != NULL)
	{
	    selection = paneinfo->green_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_FLOAT_VAL,
	                    &(paneinfo->green));
	    }

	}

	if (paneinfo->blue_struct != NULL)
	{
	    selection = paneinfo->blue_struct->Selptr;
	    if (selection->modified)
	    {
	    kvf_get_attribute(selection->back_kformstruct, KVF_FLOAT_VAL,
	                    &(paneinfo->blue));
	    }

	}

}


