 /*
  * Khoros: $Id: form_info.h,v 1.1.2.1 1997/06/07 20:37:22 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Form Info Structure for pdb2geom Form
   >>>> 
   >>>>    Written By: conductor -oname pdb2geom
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _form_info_h_
#define _form_info_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

/*
 * Pane Info Struct for 'pane' Pane
 */
typedef struct _subform_pane{

kform_struct *license_struct; /* pass to xvf_set_attributes() */

kform_struct *help_struct; /* pass to xvf_set_attributes() */

int          quit;         /* TRUE when user clicks on 'Quit' button */
kform_struct *quit_struct; /* pass to xvf_set_attributes() */

char         *i;         /* filename for 'i'*/
kform_struct *i_struct;  /* pass to xvf_set_attributes() */
int          i_selected; /* TRUE on <cr> for 'i' */

char         *o;         /* filename for 'o'*/
kform_struct *o_struct;  /* pass to xvf_set_attributes() */
int          o_selected; /* TRUE on <cr> for 'o' */

int          rep;          /* int value of 'rep'*/
char         *rep_label;   /* label representing int value of 'rep'*/
kform_struct *rep_struct;  /* pass to xvf_set_attributes() */
int          rep_selected; /* TRUE on <cr> for 'rep' */

int          res_name;          /* int value of 'res_name'*/
char         *res_name_label;   /* label representing int value of 'res_name'*/
kform_struct *res_name_struct;  /* pass to xvf_set_attributes() */
int          res_name_optsel;   /* TRUE if optional box of 'res_name' is ON */

char         *displayed;         /* string for 'displayed'*/
kform_struct *displayed_struct;  /* pass to xvf_set_attributes() */
int          displayed_optsel;   /* TRUE if optional box of 'displayed' is ON */

int          display_now;          /* TRUE when user clicks on 'display_now'*/
kform_struct *display_now_struct;  /* pass to xvf_set_attributes() */

int          res_num;          /* int for 'res_num'*/
kform_struct *res_num_struct;  /* pass to xvf_set_attributes() */
int          res_num_optsel;   /* TRUE if optional box of 'res_num' is ON */

char         *colored;         /* string for 'colored'*/
kform_struct *colored_struct;  /* pass to xvf_set_attributes() */
int          colored_optsel;   /* TRUE if optional box of 'colored' is ON */

float        radius;          /* float value of 'radius'*/
kform_struct *radius_struct;  /* pass to xvf_set_attributes() */
int          radius_selected; /* TRUE on <cr> for 'radius' */

int          chain_name;          /* int value of 'chain_name'*/
char         *chain_name_label;   /* label representing int value of 'chain_name'*/
kform_struct *chain_name_struct;  /* pass to xvf_set_attributes() */
int          chain_name_optsel;   /* TRUE if optional box of 'chain_name' is ON */

int          color_now;          /* TRUE when user clicks on 'color_now'*/
kform_struct *color_now_struct;  /* pass to xvf_set_attributes() */

int          name;          /* int value of 'name'*/
char         *name_label;   /* label representing int value of 'name'*/
kform_struct *name_struct;  /* pass to xvf_set_attributes() */
int          name_optsel;   /* TRUE if optional box of 'name' is ON */

int          num;          /* int for 'num'*/
kform_struct *num_struct;  /* pass to xvf_set_attributes() */
int          num_optsel;   /* TRUE if optional box of 'num' is ON */

int          color;          /* int value of 'color'*/
char         *color_label;   /* label representing int value of 'color'*/
kform_struct *color_struct;  /* pass to xvf_set_attributes() */

float        red;          /* float value of 'red'*/
kform_struct *red_struct;  /* pass to xvf_set_attributes() */

float        green;          /* float value of 'green'*/
kform_struct *green_struct;  /* pass to xvf_set_attributes() */

float        blue;          /* float value of 'blue'*/
kform_struct *blue_struct;  /* pass to xvf_set_attributes() */

kform_struct *blank1_struct; /* pass to xvf_set_attributes() */

kform_struct *blank2_struct; /* pass to xvf_set_attributes() */

kform_struct *blank3_struct; /* pass to xvf_set_attributes() */

} subform_pane;

/*
 * Subform Info Struct for 'subform' Subform
 */
typedef struct _form_subform {

subform_pane  *pane;          /* ptr to Pane Info struct for pane 'pane' */
int          pane_selected;          /* TRUE if input was from pane 'pane' */
kform_struct *pane_struct;          /* pass to xvf_set_attributes() */

}  form_subform;

/*
 * Form Info Struct for 'form' form
 */
typedef struct _gui_info_struct {

form_subform  *subform;
int subform_selected;
kform_struct *subform_struct;


 } gui_info_struct; 

        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

void _xvf_free_form PROTO((gui_info_struct *));
void _xvf_get_form  PROTO((gui_info_struct *));

int  _xvf_init_form PROTO((kform *, gui_info_struct *));
void run_form       PROTO((kform *, ksubform *, kaddr));

void run_subform      PROTO((form_subform *));
void _xvf_get_subform PROTO((form_subform *));

void run_pane      PROTO((subform_pane *));
void _xvf_get_pane PROTO((subform_pane *));
void pane_i	PROTO((subform_pane *));
void pane_o	PROTO((subform_pane *));
void pane_rep	PROTO((subform_pane *));
void pane_display_now	PROTO((subform_pane *));
void pane_radius	PROTO((subform_pane *));
void pane_color_now	PROTO((subform_pane *));




#endif /* _form_info_h_ */ 
/* Don't add after this point */
