 /*
  * Khoros: $Id: usage.c,v 1.1.2.1 1997/06/07 20:36:21 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.1.2.1 1997/06/07 20:36:21 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "pdb2geom.h"
/*-----------------------------------------------------------
| 
|  Routine Name: pdb2geom_get_args
| 
|       Purpose: Gets command line args for pdb2geom
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname pdb2geom
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void pdb2geom_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for pdb2geom is out of sync with arguments specified in pdb2geom's *.pane file; please rerun ghostwriter on pdb2geom.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the pdb2geom structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "pdb2geom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "pdb2geom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "rep", KVF_LIST_LABEL,
			  &(clui_info->rep_label),
			  &(clui_info->rep_flag)) &&
	      kclui_get_value(pane, "rep", KVF_LIST_VAL,
			  &(clui_info->rep_list),
			  &(clui_info->rep_flag))))
	{
	    kerror(NULL, "pdb2geom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "pdb2geom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "pdb2geom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "pdb2geom_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate geometry from PDB models' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' displayPDB",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/pdb2geom",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/xvroutine/pdb2geom/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'PDB file' 'PDB description' i",
  "-O 1 0 0 1 0 1 52x1+0+3.5 ' ' 'Geometry' 'Geometry representing the PDB' o",
  "-x 1 0 0 1 0 26x1+1+5 3 1 1 'Representation' 'How to represent the PDB' rep 'Sticks' 'Balls' 'Sticks & Balls'",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/xvroutine/pdb2geom/uis/pdb2geom.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 20x3+10+15 +38+1 ' ' form",
  "-M 1 1 20x10+10+5 +25+0 'PDB to Geometry' subform",
  "-P 1 0 55.75x16.0385+5+1.5 +0.25+0.0769231 ' ' pane",
  "-H 1  10.5x1+0+0 'License' 'displays license' $BOOTSTRAP/repos/license/License license",
  "-H 1  6x1+40+0 'Help' 'display online help' $GEOMETRY/objects/xvroutine/pdb2geom/help/pdb2geom.hlp help",
  "-Q 1 0 6x1+48+0 'Quit'",
  "-I 1 0 0 1 1 1 54x1+0+1.5 ' ' 'PDB File' 'PDB description' i",
  "-O 1 0 0 1 1 1 54x1+0+3 ' ' 'Geometry' 'Geometry representing the PDB' o",
  "-x 1 0 0 1 1 28x1+0+4.5 3 1 1 'Representation' 'How to represent the PDB' rep 'Sticks' 'Balls' 'Sticks & Balls'",
  "-x 1 0 1 0 0 26x1+0+7 0 1 1 'Residue name  ' 'Name of the residue to color' res_name",
  "-s 0 0 1 2 0 12x1+27+7 '' ' ' 'Elements displayed' displayed",
  "-a 1 0 10x1+39+7 'Display' 'Display matching elements' display_now",
  "-i 1 0 1 0 0 26x1+0+8 2 2 1 0 0 'Residue number' 'Number of residue to color' res_num",
  "-s 0 0 1 2 0 12x1+27+8.5 '' ' ' 'Elements colored' colored",
  "-f 1 0 0 1 1 15x1+39+8.5 2 2 1 3 0 0 'Radius' 'Radius for selected elements' radius",
  "-x 1 0 1 0 0 26x1+0+9 0 1 1 'Chain name    ' 'Name of the chain to color' chain_name",
  "-a 1 0 10x1+39+9.5 'Color' 'Color matching elements' color_now",
  "-x 1 0 1 0 0 26x1+0+10 0 1 1 'Name          ' 'Name to color' name",
  "-i 1 0 1 0 0 26x1+0+11 2 2 1 0 0 'Number        ' 'Number to color' num",
  "-x 1 0 0 1 0 21x1+28+11 13 1 1 'Current color' 'Color to use' color 'RGB' 'Red' 'Orange' 'Yellow' 'Green' 'Cyan' 'Blue' 'Violet' 'Magenta' 'Tan' 'Brown' 'White' 'Gray'",
  "-f 1 0 0 1 0 21x1+28+12.5 0 1 1 3 1 0 'R' 'Red component of color' red",
  "-f 1 0 0 1 0 21x1+28+13.5 0 1 1 3 1 0 'G' 'Green component of color' green",
  "-f 1 0 0 1 0 21x1+28+14.5 0 1 1 3 1 0 'B' 'Blue component of color' blue",
  "-b +31+6 'Matches:' blank1",
  "-b +3+6 'Template:' blank2",
  "-b +41+6 'Actions:' blank3",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$GEOMETRY/objects/xvroutine/pdb2geom/uis/pdb2geom.form",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	29,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	1,
	512};


