 /*
  * Khoros: $Id: render.c,v 1.2.2.1 1997/05/31 19:00:20 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: render.c,v 1.2.2.1 1997/05/31 19:00:20 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for render
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "render.h"

clui_info_struct *clui_info = NULL;

gui_info_struct *gui_info;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Interactive Geometry Visualization
|
|       Purpose: main program for render
|
|         Input:
|		char *clui_info->i1_file; {Input file 1}
|		int   clui_info->i1_flag; {TRUE if -i1 specified}
|
|		char *clui_info->i2_file; {Input file 2}
|		int   clui_info->i2_flag; {TRUE if -i2 specified}
|
|		char *clui_info->i3_file; {Input file 3}
|		int   clui_info->i3_flag; {TRUE if -i3 specified}
|
|		char *clui_info->i4_file; {Input file 4}
|		int   clui_info->i4_flag; {TRUE if -i4 specified}
|
|		char *clui_info->i5_file; {Input file 5}
|		int   clui_info->i5_flag; {TRUE if -i5 specified}
|
|		char *clui_info->i6_file; {Input file 6}
|		int   clui_info->i6_flag; {TRUE if -i6 specified}
|
|		char *clui_info->i7_file; {Input file 7}
|		int   clui_info->i7_flag; {TRUE if -i7 specified}
|
|		char *clui_info->iscene_file; {Specificatio of a so-called scene file.}
|		int   clui_info->iscene_flag; {TRUE if -iscene specified}
|
|		int   clui_info->view_list; {viewing method for rendered image}
|		char *clui_info->view_label;
|		int   clui_info->view_flag; {TRUE if -view specified}
|
|		int clui_info->wsize_int; {width of rendered image}
|		int clui_info->wsize_flag; {TRUE if -wsize specified}
|
|		int clui_info->hsize_int; {height of rendered image}
|		int clui_info->hsize_flag; {TRUE if -hsize specified}
|
|		int clui_info->norm_logic; {compute view so all objects appear in the render window.}
|		int clui_info->norm_flag; {TRUE if -norm specified}
|
|		int   clui_info->proj_list; {Projection method to use when rendering}
|		char *clui_info->proj_label;
|		int   clui_info->proj_flag; {TRUE if -proj specified}
|
|		float clui_info->eye_x_float; {x component of eye position.}
|		int   clui_info->eye_x_flag; {TRUE if -eye_x specified}
|
|		float clui_info->up_x_float; {x component of up vector.}
|		int   clui_info->up_x_flag; {TRUE if -up_x specified}
|
|		float clui_info->at_x_float; {x component of initial look-at point.}
|		int   clui_info->at_x_flag; {TRUE if -at_x specified}
|
|		float clui_info->eye_y_float; {y component of eye position.}
|		int   clui_info->eye_y_flag; {TRUE if -eye_y specified}
|
|		float clui_info->up_y_float; {y component of up vector.}
|		int   clui_info->up_y_flag; {TRUE if -up_y specified}
|
|		float clui_info->at_y_float; {y component of initial look-at point.}
|		int   clui_info->at_y_flag; {TRUE if -at_y specified}
|
|		float clui_info->eye_z_float; {z component of eye position.}
|		int   clui_info->eye_z_flag; {TRUE if -eye_z specified}
|
|		float clui_info->up_z_float; {z component of up vector.}
|		int   clui_info->up_z_flag; {TRUE if -up_z specified}
|
|		float clui_info->at_z_float; {z component of initial look-at point.}
|		int   clui_info->at_z_flag; {TRUE if -at_z specified}
|
|		float clui_info->hither_float; {Location of front clip plane. (1 is look-at point, 0 is view point)}
|		int   clui_info->hither_flag; {TRUE if -hither specified}
|
|		float clui_info->yon_float; {Location of back clip plane. (0 is look-at point, 1 is view point)}
|		int   clui_info->yon_flag; {TRUE if -yon specified}
|
|		int clui_info->bc_logic; {turns back clipping on or off.}
|		int clui_info->bc_flag; {TRUE if -bc specified}
|
|		int clui_info->use_hardware_logic; {When Render is started, if this variable is set to true, render will invoke the hardware renderer.  Otherwise, the default renderer is the software renderer.}
|		int clui_info->use_hardware_flag; {TRUE if -use_hardware specified}
|
|		char *clui_info->o_file; {Output rendered image}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|		char *clui_info->oxfrm_file; {Data object which holds view transformation matrix, and transformation matrix for the top level object.}
|		int   clui_info->oxfrm_flag; {TRUE if -oxfrm specified}
|
|		char *clui_info->oscene_file; {output scene file}
|		int   clui_info->oscene_flag; {TRUE if -oscene specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

	kform  *form;            /* form tree representing UIS        */
	char   *form_fullpath;   /* for use when [-form] is specified */
/* -main_variable_list */
/* -main_variable_list_end */

	khoros_init(argc, argv, "GEOMETRY", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$GEOMETRY/objects/xvroutine/render");
	kexit_handler(render_free_args, NULL);

/* -main_get_args_call */
	kclui_init("GEOMETRY", "render", KGEN_XVROUTINE,  &clui_uis_spec,
		   render_usage_additions, render_get_args,
 		   render_free_args);
/* -main_get_args_call_end */

	/*
	 * Initialize xvwidgets lib
	 */
	if (!(xvw_initialize(XVW_MENUS_XVFORMS)))
	{
	     kinfo(KSTANDARD, "Could not open connection to server");
	     kexit(KEXIT_FAILURE);
	}

	/*
	 * Allocate the GUI Info structure 
	 */
	gui_info = (gui_info_struct *)
				kcalloc ((size_t) 1, sizeof(gui_info_struct));
	/*
	 * Create the forms for render 
	 */
	if (clui_info->form_flag)
	{
	    form_fullpath   = kfullpath(clui_info->form_file, NULL, NULL);
	    form = xvf_create_form(form_fullpath, KNONE, run_Master, gui_info,
				clui_info->x_int, clui_info->y_int,
				XVF_PARTIAL_EDIT);
	    kfree_and_NULL(form_fullpath);
	}
	else
	{
	    form = xvf_build_form(&gui_uis_spec, KNONE, run_Master, gui_info,
				clui_info->x_int, clui_info->y_int,
				XVF_PARTIAL_EDIT);
	}
	if (form == NULL)
	   kexit(KEXIT_FAILURE);

	/*
	 * Initialize the GUI Info structure 
	 */
	if (!(_xvf_init_Master(form, gui_info)))
	    kexit(KEXIT_FAILURE);

/* -main_before_lib_call */
	/* initialize the threads mechanism... */
#ifdef _USE_THREADS
	init_gthreads(clui_info->parallel_int);
#endif

	/* initialize all internal data structures from the
	 clui info. */

	init_from_clui(clui_info);

	/* misc internal initializations */

	internal_init();

	/* sync up the GUI on the forms to reflect settings on the clui */

	init_gui_from_internal(gui_info);
        
	/* if we're gonna have an image, do an initial rendering */
	if (clui_info->view_list != sNO_DISPLAY)
	   renderer_invoke_func();
/* -main_before_lib_call_end */

/* -main_library_call */
	xvf_run_form();
/* -main_library_call_end */

/* -main_after_lib_call */
	free_objects_memory();
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: render_usage_additions
| 
|       Purpose: Prints usage additions in render_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname render
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void render_usage_additions(void)
{
	kfprintf(kstderr, "\tInteractive Geometry Visualization\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: render_free_args
| 
|       Purpose: Frees CLUI struct allocated in render_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname render
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
render_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->form_file);
		kfree_and_NULL(clui_info->i1_file);
		kfree_and_NULL(clui_info->i2_file);
		kfree_and_NULL(clui_info->i3_file);
		kfree_and_NULL(clui_info->i4_file);
		kfree_and_NULL(clui_info->i5_file);
		kfree_and_NULL(clui_info->i6_file);
		kfree_and_NULL(clui_info->i7_file);
		kfree_and_NULL(clui_info->iscene_file);
		kfree_and_NULL(clui_info->view_label);
		kfree_and_NULL(clui_info->proj_label);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info->oxfrm_file);
		kfree_and_NULL(clui_info->oscene_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
