 /*
  * Khoros: $Id: render.h,v 1.2.2.2 1997/05/31 19:00:22 mirage Exp $
  */

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for render
   >>>> 
   >>>>    Written By: 
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _render_h_
#define _render_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <geometry.h>
#include <xvinclude.h>
#include "form_info.h"

/* -include_includes */
#include "geometry/geometry.h"

#include "render_objs.h"
#include "lights.h"
#include "imaging.h"
#include "camera.h"
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/**
  * the following is used in the render code for dealing with
  * input.  it would be nice if this #define could be used in the
  * .pane and .form files, but it's not.  beware that there is a
  * change there (in the number of ports) will necessitate a change
  * here, and vice versa.
  *
  * furthermore, just changing this #define doesn't make everything
  * happen as it should.  you still have to add more code.  look inside
  * object.c.
**/
#define NUMBER_RENDER_INPUT_OBJECT_PORTS 7
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Alternate UIS file (optional infile)
 */
char	*form_file;	/* Alternate UIS file FILENAME */
int	 form_flag;	/* Alternate UIS file FLAG */

/*
 *  (x,y) position for automatic GUI placement */

int	 x_int;		/* x position INT */
int	 x_flag;	/* x position FLAG */

int	 y_int;		/* y position INT */
int	 y_flag;	/* y position FLAG */

/*
 *  Input file 1 (optional infile)
 */
char	*i1_file;	/* Input file 1 FILENAME */
int	 i1_flag;	/* Input file 1 FLAG */

/*
 *  Input file 2 (optional infile)
 */
char	*i2_file;	/* Input file 2 FILENAME */
int	 i2_flag;	/* Input file 2 FLAG */

/*
 *  Input file 3 (optional infile)
 */
char	*i3_file;	/* Input file 3 FILENAME */
int	 i3_flag;	/* Input file 3 FLAG */

/*
 *  Input file 4 (optional infile)
 */
char	*i4_file;	/* Input file 4 FILENAME */
int	 i4_flag;	/* Input file 4 FLAG */

/*
 *  Input file 5 (optional infile)
 */
char	*i5_file;	/* Input file 5 FILENAME */
int	 i5_flag;	/* Input file 5 FLAG */

/*
 *  Input file 6 (optional infile)
 */
char	*i6_file;	/* Input file 6 FILENAME */
int	 i6_flag;	/* Input file 6 FLAG */

/*
 *  Input file 7 (optional infile)
 */
char	*i7_file;	/* Input file 7 FILENAME */
int	 i7_flag;	/* Input file 7 FLAG */

/*
 *  Specificatio of a so-called scene file. (optional infile)
 */
char	*iscene_file;	/* Specificatio of a so-called scene file. FILENAME */
int	 iscene_flag;	/* Specificatio of a so-called scene file. FLAG */

/*
 *  viewing method for rendered image (Optional list)
 */
int	 view_list;	/* viewing method for rendered image LIST INDEX */
char	 *view_label;	/* viewing method for rendered image LIST LABEL */
int	 view_flag;	/* viewing method for rendered image FLAG */

/*
 *  width of rendered image (optional integer)
 */
int	 wsize_int; 	/* width of rendered image INT */
int	 wsize_flag;	/* width of rendered image FLAG */

/*
 *  height of rendered image (optional integer)
 */
int	 hsize_int; 	/* height of rendered image INT */
int	 hsize_flag;	/* height of rendered image FLAG */

/*
 *  compute view so all objects appear in the render window. (optional logical)
 */
int	 norm_logic;	/* compute view so all objects appear in the render window. LOGIC */
int	 norm_flag;  	/* compute view so all objects appear in the render window. FLAG */

/*
 *  Projection method to use when rendering (Optional list)
 */
int	 proj_list;	/* Projection method to use when rendering LIST INDEX */
char	 *proj_label;	/* Projection method to use when rendering LIST LABEL */
int	 proj_flag;	/* Projection method to use when rendering FLAG */

/*
 *  x component of eye position. (optional float)
 */
float	 eye_x_float;	/* x component of eye position. FLOAT */
int	 eye_x_flag;   	/* x component of eye position. FLAG */

/*
 *  x component of up vector. (optional float)
 */
float	 up_x_float;	/* x component of up vector. FLOAT */
int	 up_x_flag;   	/* x component of up vector. FLAG */

/*
 *  x component of initial look-at point. (optional float)
 */
float	 at_x_float;	/* x component of initial look-at point. FLOAT */
int	 at_x_flag;   	/* x component of initial look-at point. FLAG */

/*
 *  y component of eye position. (optional float)
 */
float	 eye_y_float;	/* y component of eye position. FLOAT */
int	 eye_y_flag;   	/* y component of eye position. FLAG */

/*
 *  y component of up vector. (optional float)
 */
float	 up_y_float;	/* y component of up vector. FLOAT */
int	 up_y_flag;   	/* y component of up vector. FLAG */

/*
 *  y component of initial look-at point. (optional float)
 */
float	 at_y_float;	/* y component of initial look-at point. FLOAT */
int	 at_y_flag;   	/* y component of initial look-at point. FLAG */

/*
 *  z component of eye position. (optional float)
 */
float	 eye_z_float;	/* z component of eye position. FLOAT */
int	 eye_z_flag;   	/* z component of eye position. FLAG */

/*
 *  z component of up vector. (optional float)
 */
float	 up_z_float;	/* z component of up vector. FLOAT */
int	 up_z_flag;   	/* z component of up vector. FLAG */

/*
 *  z component of initial look-at point. (optional float)
 */
float	 at_z_float;	/* z component of initial look-at point. FLOAT */
int	 at_z_flag;   	/* z component of initial look-at point. FLAG */

/*
 *  Location of front clip plane. (1 is look-at point, 0 is view point) (optional float)
 */
float	 hither_float;	/* Location of front clip plane. (1 is look-at point, 0 is view point) FLOAT */
int	 hither_flag;   	/* Location of front clip plane. (1 is look-at point, 0 is view point) FLAG */

/*
 *  Location of back clip plane. (0 is look-at point, 1 is view point) (optional float)
 */
float	 yon_float;	/* Location of back clip plane. (0 is look-at point, 1 is view point) FLOAT */
int	 yon_flag;   	/* Location of back clip plane. (0 is look-at point, 1 is view point) FLAG */

/*
 *  turns back clipping on or off. (optional logical)
 */
int	 bc_logic;	/* turns back clipping on or off. LOGIC */
int	 bc_flag;  	/* turns back clipping on or off. FLAG */

/*
 *  When Render is started, if this variable is set to true, render will invoke the hardware renderer.  Otherwise, the default renderer is the software renderer. (optional logical)
 */
int	 use_hardware_logic;	/* When Render is started, if this variable is set to true, render will invoke the hardware renderer.  Otherwise, the default renderer is the software renderer. LOGIC */
int	 use_hardware_flag;  	/* When Render is started, if this variable is set to true, render will invoke the hardware renderer.  Otherwise, the default renderer is the software renderer. FLAG */

/*
 *  Output rendered image (optional outfile)
 */
char	*o_file;	/* Output rendered image FILENAME */
int	 o_flag;	/* Output rendered image FLAG */

/*
 *  Data object which holds view transformation matrix, and transformation matrix for the top level object. (optional outfile)
 */
char	*oxfrm_file;	/* Data object which holds view transformation matrix, and transformation matrix for the top level object. FILENAME */
int	 oxfrm_flag;	/* Data object which holds view transformation matrix, and transformation matrix for the top level object. FLAG */

/*
 *  output scene file (optional outfile)
 */
char	*oscene_file;	/* output scene file FILENAME */
int	 oscene_flag;	/* output scene file FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
extern gui_info_struct *gui_info;

extern uis_struct gui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void render_get_args PROTO((kaddr));
void render_usage_additions PROTO((void));
void render_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
void init_object_list_GUI PROTO((Render_Objects *));
void update_cameras_pane_GUI PROTO((Render_Cameras *));
int init_lights_pane PROTO((Render_Lights *));
int update_lights_gui PROTO((Render_Lights *));
int init_imaging_pane PROTO((Render_Imaging *));
void init_input_pane_GUI PROTO((clui_info_struct *,Render_Input *));
void update_object_pane PROTO((renderobj *));
void update_transformation_pane PROTO((renderobj *));

void init_output_pane_GUI PROTO((Render_Output *));

/**
  * imaging output routines in output.c
**/
int init_image_output PROTO((int, int, int, char *));
int flush_output PROTO((void));
int set_image_dims PROTO((int,int));
int get_image_dims PROTO((int *,int *));
int set_image_display_choice PROTO((int));
int get_image_display_choice PROTO((int *));
int set_do_display_mode PROTO((int));
int get_do_display_mode PROTO((int *));
int init_render_output PROTO((int,int, int,int, int, int, char *));
int shutdown_render_output PROTO((void));
int set_output_transport_name PROTO((char *));
int get_output_transport_name PROTO((char *));
int set_do_named_output PROTO((int));
int get_do_named_output PROTO((int *));
int init_render_buffers PROTO((void));
int init_output_object PROTO((void));
int change_image_dims PROTO((int,int));
int change_image_width PROTO((int));
int change_image_height PROTO((int));

/**
  * input object handlers
**/
int init_object_list PROTO((clui_info_struct *));
int return_objects_names PROTO((char ***, int *));

/**
  * camera stuff
**/
int init_camera PROTO((clui_info_struct *));

/**
  * rendering
**/
int software_render_image PROTO((void));
int software_window_resize PROTO((int,int));

void init_transformations PROTO((Render_Transformations *));

/** 
  * clipping stuff
**/
int clip_line_persp PROTO((float *,float *,float *,float *,float *,float *,float *,int,int));
int clip_line_parallel PROTO((float *,float *,float *,float *,float *,float *,float *,int,int));

int ppmquant PROTO((float *, int, int, unsigned char *, unsigned char *, unsigned char *, unsigned char *));
int ppmdither PROTO((float *, int, int, unsigned char *, unsigned char *, unsigned char *, unsigned char *));


char **get_vof_strings PROTO((void));
int change_vof PROTO((int));
int init_vof PROTO((void));
int change_vof PROTO((int));
int init_vof PROTO((void));
int get_num_vofs PROTO((void));
int set_current_vof PROTO((int));
int get_current_vof PROTO((void));



int is_active_renderer_stereo_capable PROTO((void));


/* object.c */
void sync_root_box PROTO((void));
int free_object_names PROTO((char **,int));
void free_objects_memory PROTO((void));


/* render_mouse.c */
void render_resize PROTO((xvobject, kaddr, XEvent *, int *));
void render_expose PROTO((xvobject, kaddr, XEvent *, int *));
void render_create_gc PROTO((xvobject, kaddr, XEvent *, int *));
void btn3_down_func PROTO((xvobject, kaddr, XEvent *));
void btn3_motion_func PROTO((xvobject, kaddr, XEvent *));
void btn3_up_func PROTO((xvobject, kaddr, XEvent *));
void shift_btn3_down_func PROTO((xvobject, kaddr, XEvent *));
void shift_btn3_motion_func PROTO((xvobject, kaddr, XEvent *));
void shift_btn2_down_func PROTO((xvobject, kaddr, XEvent *));
void shift_btn2_motion_func PROTO((xvobject, kaddr, XEvent *));
void btn2_down_func PROTO((xvobject, kaddr, XEvent *));
void btn2_motion_func PROTO((xvobject, kaddr, XEvent *));
void btn2_up_func PROTO((xvobject, kaddr, XEvent *));
void shift_btn2_up_func PROTO((xvobject, kaddr, XEvent *));
void left_key_func PROTO((xvobject, kaddr, XEvent *));
void right_key_func PROTO((xvobject, kaddr, XEvent *));
void up_key_func PROTO((xvobject, kaddr, XEvent *));
void down_key_func PROTO((xvobject, kaddr, XEvent *));
void page_up_key_func PROTO((xvobject, kaddr, XEvent *));
void page_down_key_func PROTO((xvobject, kaddr, XEvent *));
int get_toggle_cache PROTO((int *, float *));
int set_toggle_cache PROTO((int, float *));
void stereo_mono_toggle_func PROTO((xvobject, kaddr, XEvent *));
void render_configurerequest PROTO((xvobject, kaddr, XEvent *, int *));
void set_up_render_mouse_button_definitions PROTO((xvobject, kobject));
void remove_xvevent_callbacks PROTO((xvobject));
void show_render_cursor PROTO((void));
void clear_render_cursor PROTO((void));
void set_xrot_relative PROTO((float));
void set_yrot_relative PROTO((float));
void set_zrot_relative PROTO((float));
void get_xrot_relative PROTO((float *));
void get_yrot_relative PROTO((float *));
void get_zrot_relative PROTO((float *));
void set_render_deferred_mode PROTO((int));
int get_render_deferred_mode PROTO((void));
int set_render_image_position PROTO((int, int));
int get_render_image_position PROTO((int *, int *));
int move_render_window PROTO((int, int, Window));
int wheres_render_window PROTO((int *, int *));

/* imaging.c */
int select_hardware_renderer PROTO((void));

/* text.c */
unsigned char **build_text_mask PROTO((char *, char *, render_text_struct *));


/* texture.c */
int set_global_2dtexturing_function_index PROTO((int));
int get_global_2dtexturing_function_index PROTO((void));
int init_texturing PROTO((void));
int deinit_texturing PROTO((void));
int load_render_texture PROTO((kgeom_primitive *, render_texture **, int, char *));
int free_render_texture PROTO((render_texture *));


/* ogl.c */
int init_native_renderer PROTO((renderer_struct *));

/* scene.c */
int have_input_scene_filename PROTO((void));
int have_output_scene_filename PROTO((void));
int set_output_scene_filename PROTO((char *));
int get_output_scene_filename PROTO((char *));
int set_input_scene_filename PROTO((char *));
int get_input_scene_filename PROTO((char *));
int write_scene_file PROTO((void));
int read_scene_file PROTO((void));

/* vrxfrm.c */
int init_xform_output PROTO((char *));
int have_named_vr_events PROTO((void));
int set_vr_transport_name PROTO((char *));
int get_vr_transport_name PROTO((char *));
int dump_xform_output PROTO((void));
int vr_process_object PROTO((char *));

#include "init.h"
/* -include_routines_end */

#endif
