 /*
  * Khoros: $Id: usage.c,v 1.2.2.2 1997/05/31 19:00:24 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.2.2.2 1997/05/31 19:00:24 mirage Exp $";
#endif

/*
 * Copyright (C) 1996,1997 , The Regents of the University of California.
 * All rights reserved.  See $GEOMETRY/repos/license/LBL_Copyright.
 */

#include "render.h"
/*-----------------------------------------------------------
| 
|  Routine Name: render_get_args
| 
|       Purpose: Gets command line args for render
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname render
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void render_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for render is out of sync with arguments specified in render's *.pane file; please rerun ghostwriter on render.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the render structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i4",
			  &(clui_info->i4_file),
			  &(clui_info->i4_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i5",
			  &(clui_info->i5_file),
			  &(clui_info->i5_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i6",
			  &(clui_info->i6_file),
			  &(clui_info->i6_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i7",
			  &(clui_info->i7_file),
			  &(clui_info->i7_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "iscene",
			  &(clui_info->iscene_file),
			  &(clui_info->iscene_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "view", KVF_LIST_LABEL,
			  &(clui_info->view_label),
			  &(clui_info->view_flag)) &&
	      kclui_get_value(pane, "view", KVF_LIST_VAL,
			  &(clui_info->view_list),
			  &(clui_info->view_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "norm",
			  &(clui_info->norm_logic),
			  &(clui_info->norm_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "proj", KVF_LIST_LABEL,
			  &(clui_info->proj_label),
			  &(clui_info->proj_flag)) &&
	      kclui_get_value(pane, "proj", KVF_LIST_VAL,
			  &(clui_info->proj_list),
			  &(clui_info->proj_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "eye_x",
			  &(clui_info->eye_x_float),
			  &(clui_info->eye_x_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "up_x",
			  &(clui_info->up_x_float),
			  &(clui_info->up_x_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "at_x",
			  &(clui_info->at_x_float),
			  &(clui_info->at_x_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "eye_y",
			  &(clui_info->eye_y_float),
			  &(clui_info->eye_y_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "up_y",
			  &(clui_info->up_y_float),
			  &(clui_info->up_y_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "at_y",
			  &(clui_info->at_y_float),
			  &(clui_info->at_y_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "eye_z",
			  &(clui_info->eye_z_float),
			  &(clui_info->eye_z_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "up_z",
			  &(clui_info->up_z_float),
			  &(clui_info->up_z_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "at_z",
			  &(clui_info->at_z_float),
			  &(clui_info->at_z_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "hither",
			  &(clui_info->hither_float),
			  &(clui_info->hither_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yon",
			  &(clui_info->yon_float),
			  &(clui_info->yon_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "bc",
			  &(clui_info->bc_logic),
			  &(clui_info->bc_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "use_hardware",
			  &(clui_info->use_hardware_logic),
			  &(clui_info->use_hardware_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "oxfrm",
			  &(clui_info->oxfrm_file),
			  &(clui_info->oxfrm_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "oscene",
			  &(clui_info->oscene_file),
			  &(clui_info->oscene_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "render_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Interactive Geometry Visualization' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' render",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $GEOMETRY/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $GEOMETRYBIN/render",
  "-H 1  5x1+41+0 'Help' 'help page' $GEOMETRY/objects/xvroutine/render/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 1 1 0 1 52x1+0+2 ' ' 'Input 1' 'Input file 1' i1",
  "-I 1 0 1 0 0 1 52x1+0+3 ' ' 'Input 2' 'Input file 2' i2",
  "-I 1 0 1 0 0 1 52x1+0+4 ' ' 'Input 3' 'Input file 3' i3",
  "-I 1 0 1 0 0 1 52x1+0+5 ' ' 'Input 4' 'Input file 4' i4",
  "-I 1 0 1 0 0 1 52x1+0+6 ' ' 'Input 5' 'Input file 5' i5",
  "-I 1 0 1 0 0 1 52x1+0+7 ' ' 'Input 6' 'Input file 6' i6",
  "-I 1 0 1 0 0 1 52x1+0+8 ' ' 'Input 7' 'Input file 7' i7",
  "-I 1 0 1 0 0 1 52x1+0+9 ' ' 'Scene File' 'Specificatio of a so-called scene file.' iscene",
  "",
  "-x 1 0 1 2 0 39.25x1+1+10.5 6 -1 -1 'Image Display Method' 'viewing method for rendered image' view 'Best Possible' '3-3-2 TrueColor' '24-Bit TrueColor' 'Color Quantized' 'Dithered Image' 'No Display'",
  "",
  "-i 1 0 1 2 0 44.5x1+1+12.5 32 4096 256 1 0 'Image Width ' 'width of rendered image' wsize",
  "-i 1 0 1 2 0 44.5x1+1+13.5 32 4096 256 1 0 'Image Height' 'height of rendered image' hsize",
  "",
  "-l 1 0 1 2 0 22x1+1+15.5 1 'Normalize View? ' 'No' 'Yes' 'compute view so all objects appear in the render window.' norm",
  "-x 1 0 1 2 0 25.25x1+25+15.5 2 0 0 'Projection' 'Projection method to use when rendering' proj 'Perspective' 'Orthographic'",
  "",
  "-f 1 0 1 2 0 14x1+2+19 -100 100 0 3 0 0 'X' 'x component of eye position.' eye_x",
  "-f 1 0 1 2 0 14x1+17+19 -100 100 0 3 0 0 'X' 'x component of up vector.' up_x",
  "-f 1 0 1 2 0 14x1+32+19 -100 100 0 3 0 0 'X' 'x component of initial look-at point.' at_x",
  "-f 1 0 1 2 0 14x1+2+20 -100 100 10 3 0 0 'Y' 'y component of eye position.' eye_y",
  "-f 1 0 1 2 0 14x1+17+20 -100 100 1 3 0 0 'Y' 'y component of up vector.' up_y",
  "-f 1 0 1 2 0 14x1+32+20 -100 100 0 3 0 0 'Y' 'y component of initial look-at point.' at_y",
  "-f 1 0 1 2 0 14x1+2+21 -100 100 50 3 0 0 'Z' 'z component of eye position.' eye_z",
  "-f 1 0 1 2 0 14x1+17+21 -100 100 0 3 0 0 'Z' 'z component of up vector.' up_z",
  "-f 1 0 1 2 0 14x1+32+21 -100 100 0 3 0 0 'Z' 'z component of initial look-at point.' at_z",
  "",
  "-f 1 0 1 2 0 21x1+2+24 0.05 1 0.05 3 0 0 'Front' 'Location of front clip plane. (1 is look-at point, 0 is view point)' hither",
  "-f 1 0 1 2 0 21x1+24+24 0 1e+07 2 3 0 0 'Back ' 'Location of back clip plane. (0 is look-at point, 1 is view point)' yon",
  "-l 1 0 1 2 0 23x1+26+25 1 'Back clipping enabled?' 'Off' 'On' 'turns back clipping on or off.' bc",
  "-l 1 0 1 1 0 46.875x1+1+26 1 'Use Hardware Renderer at Startup If Available' 'False' 'True' 'When Render is started, if this variable is set to true, render will invoke the hardware renderer.  Otherwise, the default renderer is the software renderer.' use_hardware",
  "-O 1 0 1 0 0 1 52x1+1+27.5 ' ' 'Output' 'Output rendered image' o",
  "-O 1 0 1 0 0 1 52x1+1+28.5 ' ' 'Output Transformation Matrices' 'Data object which holds view transformation matrix, and transformation matrix for the top level object.' oxfrm",
  "-O 1 0 1 0 0 1 45x1+1+29.5 'render.scenefile' 'Output Scene File Name' 'output scene file' oscene",
  "-b +1+17 'Initial Camera Parameters' blank1",
  "-b +3+18 'Eye Position' blank2",
  "-b +18+18 'Up Direction' blank3",
  "-b +33+18 'Look-At Point' blank4",
  "-b +1+23 'Clipping' blank5",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$GEOMETRY/objects/xvroutine/render/uis/render.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	51,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 0 28x32+00+0 +0+0 ' ' Master",
  "-M 1 1 28x15+0+0 +1+0 'Render' Render",
  "-G 1 28x15+0+0 +15+0.5 ' '",
  "-H 1  10x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-H 1  5x1+43+0 'Help' 'man page for render' $GEOMETRY/objects/xvroutine/render/help help",
  "-Q 1 0 5x1+50+0 'Quit'",
  "",
  "-a 1 0 13x1.5+0+12 'RENDER' 'Invoke Renderer With Current Parms.' refresh",
  "-b +15+0.25 'pixmap:$GEOMETRY/objects/xvroutine/render/pixmaps/render.xpm' b0",
  "#      -b +3+19 '' b1",
  "#      -b +3+19 'pixmap:$GEOMETRY/objects/xvroutine/render/misc/wu.xpm' b1",
  "-g 1 1 13x1+0+1.5 'Objects' Objects",
  "-g 1 0 13x1+0+3 'Cameras' Cameras",
  "-g 1 0 12.75x1+0+4.5 'Lights' Lights",
  "-g 1 0 12.75x1+0+6 'Imaging' Imaging",
  "-g 1 0 12.75x1+0+7.5 'Transformations' Transformations",
  "-g 1 0 13x1.03846+0+9 'Input' Input",
  "-g 1 0 13x1+0+10.5 'Output' Output",
  "-E",
  "",
  "-P 1 0 41x24.9231+14+1.5 +1+0 'Object Controls' Objects",
  "#",
  "# the current object list contains a list of all the currently",
  "# define objects.  these will have been read in at startup time, so",
  "# this list shouldn't need to be updated except at startup time.",
  "#",
  "# this parm is LIVE in that there is the notion of a currently selected",
  "# object.  all other options on the objects menu are operators which",
  "# apply to the currently selected object.",
  "#",
  "-x 1 0 1 2 1 34.25x1+2+1 1 0 0 'Current Object ' 'List of Objects' current_object 'Root Object'",
  "",
  "#",
  "# the shaders are tricky because we lump surface and volumetric",
  "# shaders together.  there will by necessity be a certain amount",
  "# of error checking here - it doesn't make sense to apply a surface",
  "# shader to volume data.  also, as the CurrentObject is updated by",
  "# the user, the shader choice must be updated as well.",
  "#",
  "-x 1 0 1 2 1 28.625x1+2+2.5 9 0 0 'Shader' 'List of Shaders' object_shader 'No Light' 'Flat' 'Gouroud' 'Phong' 'Inherit' 'Voxel Dot' 'Voxel Splat' 'Voxel Splat Gaussian' '3D Texture'",
  "",
  "#",
  "# the 'post' flag will cause an object (and all children) to appear or",
  "# not in the final image.  when an object is 'posted', it is eligible",
  "# for display.  when 'unposted', it is not available for display.",
  "#",
  "-l 1 0 1 2 1 28x1+2+4 1 'Post Object' 'Unposted: no display' 'Posted for display  ' 'Enable or Disable Display of an Object' post_obj",
  "-f 1 0 1 2 1 37x1+1+6.5 0 1 1 0 1 1 ' Red    ' 'Objects Red Component' obj_red",
  "-f 1 0 1 2 1 37x1+1+7.5 0 1 1 0 1 1 ' Green  ' 'Objects Green Component' obj_green",
  "-f 1 0 1 2 1 37x1+1+8.5 0 1 1 0 1 1 ' Blue   ' 'Objects Blue Component' obj_blue",
  "-f 1 0 1 2 1 37x1+1+9.5 0 1 1 0 1 1 ' Alpha  ' 'Objects Alpha Component' obj_alpha",
  "-f 1 0 1 2 1 37x1+1+11 0 1 1 0 1 1 'Ambient ' 'Objects Ambient Component' obj_ambient",
  "-f 1 0 1 2 1 37x1+1+12 0 1 1 0 1 1 'Diffuse ' 'Objects Diffuse Component' obj_diffuse",
  "-f 1 0 1 2 1 37x1+1+13 0 1 1 0 1 1 'SpecCoef' 'Objects Specular Component' obj_spec",
  "-f 1 0 1 2 1 37x1+1+14 0 200 1 0 1 1 'SpecExp ' 'Objects Specular ExponentComponent' obj_spec_exp",
  "-f 1 0 1 2 1 37x1+1+15 0 1 1 0 1 1 'SpecMetl' 'Objects Specular Metalness Component' obj_spec_metal",
  "#",
  "# have a button to pop up a window of object information",
  "#",
  "-a 0 0 11x1+2+16.5 'Object Info' 'Show Object Information' object_info",
  "-a 1 0 28x1+2+18 'Reset Object Transformation Matrix' 'action button' action1",
  "#",
  "# the following section is used to display and update global object",
  "# properties.  this has to get updated each time the selected object",
  "# changes, and upon entry to the render.",
  "#",
  "-b +1+5.5 'Object Properties' object_properties",
  "-E",
  "",
  "-P 1 0 40.75x24.9231+14+1.5 +1+0 'Camera Controls' Cameras",
  "#",
  "# give the user a choice over the projection method.  this selection",
  "# is 'live' in that it will cause a variable in render to change",
  "# state, but no rerendering occurs.",
  "#",
  "-c 1 0 1 2 1 27x1+1+1.5 2 0 0 'Projection ' 'Set Camera Projection' projection_cycle 'perspective' 'parallel'",
  "-f 1 0 1 2 1 14x1+0+4 0 0 0 3 0 0 'X' 'x component of eye position.' eye_x",
  "-f 1 0 1 2 1 13x1+11+4 0 0 0 3 0 0 'X' 'x component of up vector.' up_x",
  "-f 1 0 1 2 1 13x1+22+4 0 0 0 3 0 0 'X' 'x component of look-at point.' at_x",
  "-f 1 0 1 2 1 14x1+0+5 0 0 0 3 0 0 'Y' 'y component of eye position.' eye_y",
  "-f 1 0 1 2 1 13x1+11+5 0 0 0 3 0 0 'Y' 'y component of up vector.' up_y",
  "-f 1 0 1 2 1 13x1+22+5 0 0 0 3 0 0 'Y' 'y component of look-at point.' at_y",
  "-f 1 0 1 2 1 13x1+0+6 0 0 0 3 0 0 'Z' 'z component of eye position.' eye_z",
  "-f 1 0 1 2 1 13x1+11+6 0 0 0 3 0 0 'Z' 'z component of up vector.' up_z",
  "-f 1 0 1 2 1 13x1+22+6 0 0 0 3 0 0 'Z' 'z component of look-at point.' at_z",
  "-f 1 0 1 2 1 18x1+1+9 0.05 1 0.05 3 0 0 'Front ' 'Location of front clip plane.  A value of 1.0 puts the front clip plane at the look-at point; decreasing this value moves the location of the front clip point closer to the viewer.  A value of 0.5 puts the front clip plane halfway between the viewer and the look-at point.' hither_clip_form_loc",
  "-f 1 0 1 2 1 18x1+1+10 0 1e+07 2 3 0 0 'Back  ' 'Location of back clip plane.  A value of 0.0 puts the back clip plane at the look-at point.  Increasing its value moves the back clip plane further away from the viewer along the vector formed by the viewer/look-at point.  A value of 1.0 puts the back clip plane 1 unit away from the viewer along this vector.  The length of this vector is the distance between the viewer and the look-at point.' yon_clip_form_loc",
  "-l 1 0 1 2 1 19.5x1+19+10 1 'Back Clip?' 'Off' 'On' 'Turns back clipping on or off.' back_clip_form_on_off",
  "",
  "# ",
  "# set field of width angle.  parm is live, but only causes a render",
  "# variable to get changed.  no rerendering occurs.",
  "#",
  "-f 1 0 1 2 1 25x1+1+11.5 30 160 90 0 0 1 'Field of View' 'Set field-of-view angle' fov_input",
  "-f 0 0 1 2 1 25x1+1+12.5 2 2 1 7 0 0 'Aspect Ratio ' 'Ratio of pixel width to height.' aspect",
  "-a 1 0 9x1+4+14.5 'Normalize' 'reset camera so all objects appear in render window' normalize_cam",
  "-a 1 0 9x1+14+14.5 'Default' 'reinitialize view parms with startup defaults' reset_camera",
  "-x 1 0 0 1 1 24x1+1+16 2 1 1 'Camera Type' 'List of available cameras, such as mono, stereo, etc.' camera_type 'Monoscopic' 'Stereoscopic'",
  "-f 0 0 0 1 1 34x1+3+17 0 0 1 3 0 0 'Eye Separation' 'Eye separation in degrees.' eye_separation",
  "-f 0 0 0 1 1 34x1+3+18 -100 100 1.5 3 0 0 'Focal Length  ' 'Focal length in world space.' focal_length",
  "-l 0 0 0 1 1 15x1+3+19 1 'Flip L/R?' 'No' 'Yes' 'When set, will cause Left and Right eye viewpoints to be flipped.' lr_flip",
  "-l 0 0 0 1 1 21x1+18+19.5 0 'Multisample' 'Nope' 'Yup' 'If enabled, will use multisampling.' multisample",
  "-x 1 0 0 1 1 30x1+1+21.5 4 1 1 'Choose New VOF' 'List of currently supported video output formats (SGI-IRIX 6.2 speicifc)' do_vof '1280x1024_72.vfo' '1024x768_96s.vfo' '640x480_120s.vfo' '1280x1024_120s.vfo'",
  "-b +1+13.5 'Automatic View' normalize_camera",
  "-b +1+3 'Eye Position' blank1",
  "-b +12+3 'Up Direction' blank2",
  "-b +23+3 'Look-At Point' blank3",
  "-b +1+8 'Clipping' blank4",
  "-E",
  "",
  "-P 1 0 41x24.9231+14+1.5 +2+0 'Lighting Controls' Lights",
  "#",
  "# the light_list provides the user a way to select the current light.",
  "# the string variable immediately following this parm will need to",
  "# be set to reflect the current light type.  as such, it is an ",
  "# output-only UI entry.  this string variable should probably be",
  "# changed to something that the user can't munge with.  the light",
  "# on/off switch is used to activate or deactivate a given light.",
  "# this parm must be updated each timeee a different light is",
  "# selected.  the value of this parm must also be used to turn",
  "# lights on or off.",
  "#",
  "-x 1 0 1 2 1 30.75x1+1+1 3 0 0 'Current Light      ' 'List of Lights' light_list 'Light1' 'Light2' 'Light3 '",
  "-l 1 0 1 2 1 29.5x1+1+2.5 1 'Current Light On/Off' 'Off' '  On  ' 'Turn a Light on or off' light_onoff",
  "",
  "-x 1 0 1 2 1 34x1+1+4 4 0 0 'Current Light Type' 'List of Light Types' light_type_list 'Directional' 'Bidirectional' 'Point' 'Ambient'",
  "#     -s 1 0 1 1 0 30x1+0.5+4 'Directional' 'Light Type' 'Inform User of Light Type' light_type_string",
  "",
  "#",
  "# the following two parms are used to set the light position and/or",
  "# direction.  one, the other or both are valid based upon the type",
  "# of light that is currently selected.  the given string variables",
  "# should be greyed out based upon the type of light.",
  "#",
  "-s 1 0 1 2 1 38x1+1+6.5 'XX.X YY.Y ZZ.Z' 'Current Light Position ' 'Set Light Position' light_position_string",
  "-s 1 0 1 2 1 38x1+1+7.5 'XX.X YY.Y ZZ.Z' 'Current Light Direction' 'Set Light Direction' light_direction_string",
  "",
  "-s 1 0 1 2 1 38x1+1+9 'RR GG BB' 'Current Light Color (RGB)       ' 'Current Light Color (RGB)' current_light_color_string",
  "",
  "-s 1 0 1 2 1 38x1+1+10 'RR GG BB' 'Global Ambient Light Color (RGB)' 'Ambient Light Color (RGB)' ambient_light_color_string",
  "-E",
  "",
  "-P 1 0 40.75x24.9231+14+1.5 +1+0 'Imaging Controls' Imaging",
  "#",
  "# allow the user to set the width or height of the rendered image.",
  "#",
  "-i 1 0 1 2 1 37x1+1+1 32 2048 256 1 1 'Image Width ' 'Set Image Width in Pixels' image_width",
  "-i 1 0 1 2 1 37x1+1+2 32 2048 256 1 1 'Image Height' 'Set Image Height in Pixels' image_height",
  "-x 1 0 1 2 1 34x1+1+4.5 5 0 0 ' ' 'The user has at their disposal a variety of ways to have the image presented to them: 24bit truecolor, 3-3-2 truecolor, no display, quantized, dithered, etc.' image_display_choice '3-3-2 TrueColor' '24-bit TrueColor' 'Quanitized Image' 'Dithered Image' 'No Display'",
  "#",
  "# ",
  "# the user has the following choices for manipulating the final rendered image:",
  "# 1. create and display a 3-3-2 image ( 3 bits each of red and green, 2 bits of blue) (for now",
  "# this is the most sane option for use with an 8bit display), 2. create and display a 24bit image",
  "# or 3. to not display the image at all.",
  "#",
  "# toggle group replaced with a more runtime maintainable list.",
  "# 25 jan 95, wes",
  "#      -T 1 0 0 1 1 41x2.5+1+3.5 +0+0 1 'Image Display Alternatives' 'Logical toggle selection' image_display_choice",
  "#        -l 1 0 1 1 0 10x1+1+1 0 '3-3-2 Image' 'False' 'TRUE' 'choice1' dummy",
  "#        -l 1 0 1 0 0 10x1+15+1 0 '24-bit Image' 'False' 'TRUE' 'choice2' dummy",
  "#        -l 1 0 1 0 0 10x1+30+1 0 'No Display' 'False' 'TRUE' 'choice3' dummy",
  "#      -E",
  "#	-x 1 0 1 1 1 20x1+1+3.5 1 1 1 'Image Display Alternatives' 'Default'",
  "",
  "#",
  "# string to specify background RGB shade.  this should be changed into",
  "# some sliders or something eventually.  for now, this string should",
  "# be updated upon startup to reflect the true default background shade.",
  "#",
  "-f 1 0 1 2 1 38x1+1+6.5 0 1 0.6 0 1 1 'Background Red  ' 'Red component of background' red_background",
  "-f 1 0 1 2 1 38x1+1+7.5 0 1 0.4 0 1 1 'Background Green' 'Green component of background' green_background",
  "-f 1 0 1 2 1 38x1+1+8.5 0 1 0.2 0 1 1 'Background Blue ' 'Blue component of background' blue_background",
  "-x 1 0 1 2 1 34x1+2+12.5 2 1 1 'Renderer            ' 'a list of available renderers the user can choose  from.  typically, this will be a two element list containing a software renderer (the default), or a hardware renderer if its supported on this platform.' renderer_choice 'Software' 'Hardware'",
  "",
  "#",
  "# the rendering activation mode is either 'deferred' or 'immediate'.",
  "# in 'immediate' mode, the renderer is reinvoked _any time_ _any_",
  "# parameter changes.  in 'deferred' mode, nothing happens until the",
  "# user presses the 'refresh' button.",
  "#",
  "-l 1 0 1 2 1 34x1+2+13.5 0 'Renderer Invocation ' 'Deferred' 'Immediate' 'Renderer Invocation Method' invoke_renderer",
  "-x 0 0 1 2 1 37x1+2+15 2 1 1 'Transparency ' 'a list of different methods for rendering transparent objects.' transparency_choice 'Buffered (best, slow)' 'Painters (cheesy, fast)'",
  "-x 1 0 1 2 1 36x1+2+16.5 3 1 1 '2D Texturing        ' 'Method used for rendering textured surfaces.' texture_method_2d 'Point-Sampled' 'Bilinear' 'Disable'",
  "-l 0 0 1 2 1 36x1+2+17.5 0 'Antialias           ' 'False' 'True' 'boolean value indicating whether or not antialiasing should be performed during rendering.' antialias",
  "-b +1+11 'Miscellaneous Rendering Controls' render_controls_label",
  "-b +1+3.5 'Image Display Choice' blank1",
  "-i 1 0 0 1 1 30x1+2+19 2 100 6 0 0 'OpenGL Sphere Subdivisions' 'controls number of lat and lon subdivisions' ogl_sphere_subdivisions",
  "-E",
  "",
  "#",
  "# transformation control submenu.  these contain the sliders, etc. used",
  "# to effect transformations.  for now, only objects may be transformed.",
  "# later, we may wish to allow 'transformation' of lights and cameras.",
  "# these latter two are different than objects because transformation doesn't",
  "# happen by blasting vertices through a transformation matrix, so additional",
  "# thought is required.",
  "#",
  "-P 1 0 41x24.9231+14+1.5 +1+0 'Transformation Controls' Transformations",
  "",
  "-f 1 0 1 2 1 30x1+3+1.5 -360 360 45 2 0 1 ' X-axis Rotate (relative)' 'X Axis Rotation Angle, amount by which the current object will be rotated about the X axis when the +x key (up arrow), (down arrow is -x, or down arrow)' x_rotate",
  "-f 1 0 1 2 1 30x1+3+2.5 -360 360 45 2 0 1 ' Y-axis Rotate (relative)' 'Y Axis Rotation Angle, amount by which the object will be rotated, relative from current position, about y axis when the +y button is pressed (R arrow), or -y degrees when -y button is pressed (L arrow).' y_rotate",
  "-f 1 0 1 2 1 30x1+3+3.5 -360 360 45 2 0 1 ' Z-axis Rotate (relative)' 'Z Axis Rotation Angle, amount by which the current object will be rotated about the Z axis, relative to its current position; the +z button is shift up, the -Z button is shift-down.' z_rotate",
  "",
  "# 7/29/94",
  "# change from this:",
  "#      -f 1 0 1 1 1 28.75x1+1+7 0 0 0 0 1 1 'XTrans' 'X Axis Translation' x_trans",
  "#      -f 1 0 1 1 1 28.75x1+1+8 0 0 0 0 1 1 'YTrans' 'Y Axis Translation' y_trans",
  "#      -f 1 0 1 1 1 28.75x1+1+9 0 0 0 0 1 1 'ZTrans' 'Z Axis Translation' z_trans",
  "#      ",
  "#      -f 1 0 1 1 1 29.75x1+1+11 0 0 1 0 1 1 'Isometric Scale' 'Isometric Scaling' iso_scale",
  "",
  "# to:",
  "-s 1 0 1 2 1 36x1+1+5.5 'XX.X YY.Y ZZ.Z' 'Object Center Point    ' 'Set Object Center point' center_point_string",
  "-s 1 0 1 2 1 36x1+1+7 'XX.X YY.Y ZZ.Z' 'Object Translate Vector' 'Set Object Translate Vector' translate_vector_string",
  "-s 1 0 1 2 1 36x1+1+8.5 'XX.X YY.Y ZZ.Z' 'Object XYZ Scale       ' 'Set Object XYZ Scale' xyz_scale_string",
  "-l 0 0 1 2 1 33x1+2+10.5 1 'Transformation Mode' 'Fully Rendered' 'XOR Box' 'this flag is used to control how interactive transformations are presented to the user.' transformation_mode",
  "-E",
  "",
  "#",
  "# stuff for inputting objects.  if additional input object ports",
  "# are required, then add them here.",
  "#",
  "-P 1 0 41x24.9231+14+1.5 +2+0 'Input Geom Objects' Input",
  "-I 1 0 1 0 1 1 37x1+1+1.5 ' ' 'Object1' 'Input Geom-VIFF for Object 1' input_object_1",
  "-I 1 0 1 0 1 1 37x1+1+2.5 ' ' 'Object2' 'Input Geom-VIFF for Object 2' input_object_2",
  "-I 1 0 1 0 1 1 37x1+1+3.5 ' ' 'Object3' 'Input Geom-VIFF for Object 3' input_object_3",
  "-I 1 0 1 0 1 1 37x1+1+4.5 ' ' 'Object4' 'Input Geom-VIFF for Object 4' input_object_4",
  "-I 1 0 1 0 1 1 37x1+1+5.5 ' ' 'Object5' 'Input Geom-VIFF for Object 5' input_object_5",
  "-I 1 0 1 0 1 1 37x1+1+6.5 ' ' 'Object6' 'Input Geom-VIFF for Object 6' input_object_6",
  "-I 1 0 1 0 1 1 37x1+1+7.5 ' ' 'Object7' 'Input Geom-VIFF for Object 7' input_object_7",
  "-E",
  "#",
  "# stuff for outputting images.  at present, this is the only output port.",
  "#",
  "-P 1 0 40.75x24.9231+14+1.5 +2+0 'Output Data Control' Output",
  "-O 1 0 1 0 1 1 38x1+1+1.5 ' ' 'Output' 'Name of the output image file' output_image_fname",
  "-O 1 0 1 0 1 1 38x1+1+2.5 ' ' 'Output Xforms' 'Object containing camera and object transformation matrices' oxfrm",
  "-O 1 0 1 1 1 1 35x1+1+5 ' ' 'Scene File' 'output scene file name' oscene",
  "-a 1 0 15x1.5+3+6.5 'Write Scene File' 'action button causing scene file to be written.' write_scene_file",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
  61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
  81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,
  101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,
  121,122,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,
  141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,
  161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,
  181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,
  201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,
  221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,
  241,242,243,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$GEOMETRY/objects/xvroutine/render/uis/render.form",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	243,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	1,
	512};


