 /*
  * Khoros: $Id: icolorspace.h,v 1.3.2.2 1997/05/31 19:10:13 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for icolorspace
   >>>> 
   >>>>    Written By: A. Christopher Moorman
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _icolorspace_h_
#define _icolorspace_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <image.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  First Input data object (required infile)
 */
char	*i_file;	/* First Input data object FILENAME */
int	 i_flag;	/* First Input data object FLAG */

/*
 * Destination colorspace model. (Required flag toggle)
 *	1 (Greyscale)
 *	2 (RGB Colorspace)
 *	3 (CMY Colorspace)
 *	4 (YIQ Colorspace)
 *	5 (HSV Colorspace)
 *	6 (HLS Colorspace)
 *	7 (IHS Colorspace)
 *	8 (XYZ Colorspace)
 *	9 (UVW Colorspace)
 *	10 (UCSUVW Colorspace)
 *	11 (UCSSOW Colorspace)
 *	12 (UCSLab Colorspace)
 *	13 (UCSLuv Colorspace)
 *	14 (User Defined Colorspace),
 */
int	 type_toggle;		/* Destination colorspace model. FLAG TOGGLE */
int	 type_flag;		/* Destination colorspace model. FLAG */

/*
 *  List of possible output datatypes. (Required list)
 */
int	 outputtype_list;	/* List of possible output datatypes. LIST INDEX */
char	 *outputtype_label;	/* List of possible output datatypes. LIST LABEL */
int	 outputtype_flag;	/* List of possible output datatypes. FLAG */

/*
 *  Resulting output data object (required outfile)
 */
char	*o_file;	/* Resulting output data object FILENAME */
int	 o_flag;	/* Resulting output data object FLAG */

/*
 *  Set the internal attribute only, leaving the data unconverted. (optional flag)
 */
int	 set_internal_only_flag;  	/* Set the internal attribute only, leaving the data unconverted. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void icolorspace_get_args PROTO((kaddr));
void icolorspace_usage_additions PROTO((void));
void icolorspace_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
