 /*
  * Khoros: $Id: usage.c,v 1.3.2.2 1997/05/31 19:10:16 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.3.2.2 1997/05/31 19:10:16 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "icolorspace.h"
/*-----------------------------------------------------------
| 
|  Routine Name: icolorspace_get_args
| 
|       Purpose: Gets command line args for icolorspace
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname icolorspace
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void icolorspace_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for icolorspace is out of sync with arguments specified in icolorspace's *.pane file; please rerun ghostwriter on icolorspace.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the icolorspace structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "icolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "icolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->type_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_flag(pane, "set_internal_only",
			  &(clui_info->set_internal_only_flag))))
	{
	    kerror(NULL, "icolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "outputtype", KVF_LIST_LABEL,
			  &(clui_info->outputtype_label),
			  &(clui_info->outputtype_flag)) &&
	      kclui_get_value(pane, "outputtype", KVF_LIST_VAL,
			  &(clui_info->outputtype_list),
			  &(clui_info->outputtype_flag))))
	{
	    kerror(NULL, "icolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "icolorspace_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Performs the actual data conversion of a image colorspace.' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kconvert_colorspace",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $IMAGEBIN/icolorspace",
  "-H 1  5x1+41+0 'Help' 'help page' $IMAGE/objects/kroutine/icolorspace/help help",
  "-Q 1 0 5.25x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'First Input data object' i",
  "-T 1 0 0 1 1 45.125x17+2+4 +0+0 1 'Destination Image Colorspace' 'Destination colorspace model.' type",
  "-t 1 0 1 1 0 10x1+1+1 'Greyscale' 'Greyscale' dummy",
  "-t 1 0 1 0 0 10x1+1+2 'RGB Colorspace' 'RGB Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+3 'CMY Colorspace' 'CMY Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+4 'YIQ Colorspace' 'YIQ Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+5 'HSV Colorspace' 'HSV Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+6 'HLS Colorspace' 'HLS Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+7 'IHS Colorspace' 'IHS Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+8 'XYZ Colorspace' 'XYZ Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+9 'UVW Colorspace' 'UVW Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+10 'UCSUVW Colorspace' 'UCSUVW Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+11 'UCSSOW Colorspace' 'UCSSOW Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+12 'UCSLab Colorspace' 'UCSLab Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+13 'UCSLuv Colorspace' 'UCSLuv Colorspace' dummy",
  "-t 1 0 1 0 0 10x1+1+14 'User Defined Colorspace' 'User Defined Colorspace' dummy",
  "-E",
  "-t 1 0 1 0 0 6.125x1+3+19.5 'Set Internal Attribute Only, (Data Unmodified).' 'Set the internal attribute only, leaving the data unconverted.' set_internal_only",
  "-x 1 0 0 1 0 45x1+1+21.5 14 1 1 'Select Output Data Type:' 'List of possible output datatypes.' outputtype 'Propagate Input Type' 'Bit' 'Byte' 'Unsigned Byte' 'Short' 'Unsigned Short' 'Integer' 'Unsigned Integer' 'Long' 'Unsigned Long' 'Float' 'Double' 'Complex' 'Double Complex'",
  "-O 1 0 0 1 0 1 51.75x1+0+23.5 ' ' 'Output' 'Resulting output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/icolorspace/uis/icolorspace.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	32,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


