 /*
  * Khoros: $Id: icomposite.c,v 1.4.2.2 1997/05/31 19:10:35 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: icomposite.c,v 1.4.2.2 1997/05/31 19:10:35 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for icomposite
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "icomposite.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - no short description specified
|
|       Purpose: main program for icomposite
|
|         Input:
|		int clui_info->toggle_toggle; {Flag toggle selection}
|		int clui_info->toggle_flag; {TRUE if -toggle specified}
|
|		char *clui_info->i1_file; {First Input data object}
|		int   clui_info->i1_flag; {TRUE if -i1 specified}
|
|		char *clui_info->i2_file; {input file}
|		int   clui_info->i2_flag; {TRUE if -i2 specified}
|
|		char *clui_info->o_file; {Resulting output data object}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|        Output:
|       Returns:
|
|    Written By: Thomas H. Robey
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
   kobject src1_obj=NULL, src2_obj=NULL, dst_obj=NULL;
/* -main_variable_list_end */

	khoros_init(argc, argv, "IMAGE", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$IMAGE/objects/kroutine/icomposite");
	kexit_handler(icomposite_free_args, NULL);

/* -main_get_args_call */
	kclui_init("IMAGE", "icomposite", KGEN_KROUTINE,  &clui_uis_spec,
		   icomposite_usage_additions, icomposite_get_args,
 		   icomposite_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
   if ((src1_obj=kpds_open_input_object(clui_info->i1_file)) == KOBJECT_INVALID)
   {
      kerror(NULL,"icomposite","Cannot open input object %s.",
             clui_info->i1_file);
      kexit(KEXIT_FAILURE);
   }
   if ((src2_obj=kpds_open_input_object(clui_info->i2_file)) == KOBJECT_INVALID)
   {
      kerror(NULL,"icomposite","Cannot open input object %s.",
             clui_info->i2_file);
      kexit(KEXIT_FAILURE);
   }
   if ((dst_obj=kpds_open_output_object(clui_info->o_file)) == KOBJECT_INVALID)
   {
      kerror(NULL,"icomposite","Cannot open output object %s.",
             clui_info->o_file);
      kexit(KEXIT_FAILURE);
   }
/* -main_before_lib_call_end */

/* -main_library_call */
   if (!(licomposite(src1_obj, src2_obj, dst_obj, clui_info->toggle_toggle)))
   {
      kpds_close_object(src1_obj);
      kpds_close_object(src1_obj);
      kpds_close_object(dst_obj);
      kexit(KEXIT_FAILURE);
   }
/* -main_library_call_end */

/* -main_after_lib_call */
   kpds_close_object(src1_obj);
   kpds_close_object(src2_obj);
   kpds_close_object(dst_obj);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: icomposite_usage_additions
| 
|       Purpose: Prints usage additions in icomposite_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname icomposite
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void icomposite_usage_additions(void)
{
	kfprintf(kstderr, "\tno short description specified\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: icomposite_free_args
| 
|       Purpose: Frees CLUI struct allocated in icomposite_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname icomposite
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
icomposite_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i1_file);
		kfree_and_NULL(clui_info->i2_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
