 /*
  * Khoros: $Id: usage.c,v 1.4.2.2 1997/05/31 19:10:38 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.4.2.2 1997/05/31 19:10:38 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "icomposite.h"
/*-----------------------------------------------------------
| 
|  Routine Name: icomposite_get_args
| 
|       Purpose: Gets command line args for icomposite
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname icomposite
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void icomposite_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for icomposite is out of sync with arguments specified in icomposite's *.pane file; please rerun ghostwriter on icomposite.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the icomposite structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_value(pane, "toggle", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->toggle_flag))))
	{
	    kerror(NULL, "icomposite_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->toggle_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "icomposite_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "icomposite_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "icomposite_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Composites two images ' subform",
  "-P 1 0 71.75x11.5385+0+1 +0+0 ' ' icomposite",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $IMAGEBIN/icomposite",
  "-H 1  5x1+41+0 'Help' 'help page' $IMAGE/objects/kroutine/icomposite/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-T 1 0 0 1 0 15x11+55+0 +0+0 1 'Flag' 'Flag toggle selection' toggle",
  "-t 1 0 1 1 0 8x1+1+1 'aPLUSb' 'First input plus second input ' dummy",
  "-t 1 0 1 0 0 8x1+1+2 'aOVERb' 'First input over second input' dummy",
  "-t 1 0 1 0 0 8x1+1+3 'aOVERb' 'Second input over first input' dummy",
  "-t 1 0 1 0 0 8x1+1+4 'aINb' 'First input in second input' dummy",
  "-t 1 0 1 0 0 8x1+1+5 'bINa' 'Second input in first input' dummy",
  "-t 1 0 1 0 0 8x1+1+6 'aOUTb' 'First input out second input' dummy",
  "-t 1 0 1 0 0 8x1+1+7 'bOUTa' 'Second input out first input' dummy",
  "-t 1 0 1 0 0 8x1+1+8 'aATOPb' 'First input atop second input' dummy",
  "-t 1 0 1 0 0 8x1+1+9 'bATOPa' 'Second input atop first input' dummy",
  "-t 1 0 1 0 0 8x1+1+10 'aXORb' 'First input xor second input' dummy",
  "-E",
  "-I 1 0 0 1 0 1 52x1+0+2.5 ' ' 'Input 1' 'First Input data object' i1",
  "-I 1 0 0 1 0 1 52.25x1+0+4.5 ' ' 'Input 2' 'input file' i2",
  "-O 1 0 0 1 0 1 52x1+0+6.5 ' ' 'Output' 'Resulting output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/icomposite/uis/icomposite.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	27,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


