 /*
  * Khoros: $Id: usage.c,v 1.13.2.2 1997/05/31 19:11:43 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.13.2.2 1997/05/31 19:11:43 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ifiltdesign.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ifiltdesign_get_args
| 
|       Purpose: Gets command line args for ifiltdesign
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ifiltdesign
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ifiltdesign_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ifiltdesign is out of sync with arguments specified in ifiltdesign's *.pane file; please rerun ghostwriter on ifiltdesign.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ifiltdesign structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "pos", KVF_LIST_LABEL,
			  &(clui_info->pos_label),
			  &(clui_info->pos_flag)) &&
	      kclui_get_value(pane, "pos", KVF_LIST_VAL,
			  &(clui_info->pos_cycle),
			  &(clui_info->pos_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "order",
			  &(clui_info->order_int),
			  &(clui_info->order_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "lcutoff",
			  &(clui_info->lcutoff_double),
			  &(clui_info->lcutoff_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ucutoff",
			  &(clui_info->ucutoff_double),
			  &(clui_info->ucutoff_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "eps",
			  &(clui_info->eps_double),
			  &(clui_info->eps_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_cycle),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "lp",
			  &(clui_info->lp_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hp",
			  &(clui_info->hp_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "bp",
			  &(clui_info->bp_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "bs",
			  &(clui_info->bs_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ideal",
			  &(clui_info->ideal_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "but",
			  &(clui_info->but_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "gauss",
			  &(clui_info->gauss_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ch1",
			  &(clui_info->ch1_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ch2",
			  &(clui_info->ch2_flag))))
	{
	    kerror(NULL, "ifiltdesign_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'General 2-D image filter design' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Filter_Design",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'Generate Filter' $IMAGEBIN/ifiltdesign",
  "-H 1  5x1+41+0 'Help' 'man page for object_name' $IMAGE/objects/kroutine/ifiltdesign/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-i 1 0 1 2 0 16x1+2+8 2 2 256 0 0 'Image width  ' 'Image width size (pixels)' wsize",
  "-i 1 0 1 2 0 16x1+2+9 2 2 256 0 0 'Image height ' 'Image height (pixels)' hsize",
  "-c 1 0 1 2 0 31x1+2+10.5 2 0 1 'Low freq position' 'Low frequencies located at image center or corners' pos 'Corners of Image' 'Center of Image'",
  "-i 1 0 1 2 0 16x1+2+12 2 2 1 0 0 'Filter order ' 'Filter order (related to steepness of cutoff and amount of attenuation)' order",
  "-h 1 0 1 2 0 45x1+2+15.5 0 1 0.25 0 1 0 'Lower cutoff ' 'Normalized lower cutoff frequency (fraction of Nyquist)' lcutoff",
  "-h 1 0 1 2 0 45x1+2+16.5 0 1 0.5 0 1 0 'Upper cutoff ' 'Normalized upper cutoff frequency (fraction of Nyquist)' ucutoff",
  "-h 1 0 1 1 0 50x1+2+18 0 1 0.5 0 1 0 'Ripple parameter (Chebyshev only)' 'Ripple parameter (Chebyshev only)' eps",
  "-c 1 0 1 2 0 31x1+2+19.5 2 10 11 'Output data type ' 'Data type for output image' type 'Float' 'Double'",
  "-O 1 0 0 1 0 1 51x1+2+21 ' ' 'Output image ' 'Output image' o",
  "-b +2+1.5 'Type of Filter' blank2",
  "-C 1",
  "-t 1 0 1 1 0 18.875x1+3+2.5 'Low  pass (requires UC)' 'Low pass (requires upper cutoff)' lp",
  "-t 1 0 1 0 0 19.625x1+3+3.5 'High pass (requires LC)' 'High pass (requires lower cutoff)' hp",
  "-t 1 0 1 0 0 24.875x1+3+4.5 'Band pass (requires LC and UC)' 'Band pass (requires lower and upper cutoff)' bp",
  "-t 1 0 1 0 0 24.875x1+3+5.5 'Band stop (requires LC and UC)' 'Band stop (requires lower and upper cutoff)' bs",
  "-E",
  "-b +30+1.5 'Filter Brand' blank3",
  "-C 1",
  "-t 1 0 1 1 0 11.5x1+31+2.5 'Ideal' 'Ideal' ideal",
  "-t 1 0 1 0 0 11.5x1+31+3.5 'Butterworth' 'Butterworth' but",
  "-t 1 0 1 0 0 11.5x1+31+4.5 'Gaussian' 'Gaussian' gauss",
  "-t 1 0 1 0 0 11.5x1+31+5.5 'Chebyshev I' 'Chebyshev1' ch1",
  "-t 1 0 1 0 0 11.5x1+31+6.5 'Chebyshev II' 'Chebyshev2' ch2",
  "-E",
  "-b +6+13.5 'Specify cutoff frequencies in terms of fraction of' blank1",
  "-b +6+14.5 'spatial Nyquist frequency' blank10",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/ifiltdesign/uis/ifiltdesign.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	38,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


