 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:12:03 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:12:03 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "igamut.h"
/*-----------------------------------------------------------
| 
|  Routine Name: igamut_get_args
| 
|       Purpose: Gets command line args for igamut
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname igamut
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void igamut_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for igamut is out of sync with arguments specified in igamut's *.pane file; please rerun ghostwriter on igamut.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the igamut structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "igamut_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "igamut_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "p",
			  &(clui_info->p_int),
			  &(clui_info->p_flag))))
	{
	    kerror(NULL, "igamut_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "r",
			  &(clui_info->r_float),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "igamut_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "igamut_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compress Color Multiband Image to Single Band with Map' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' igamut",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $IMAGEBIN/igamut",
  "-H 1  5x1+41+0 'Help' 'help page for igamut' $IMAGE/objects/kroutine/igamut/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image' 'Multiband input image (elements dimension > 1)' i",
  "-i 1 0 1 2 0 44.5x1+3+4 2 2 240 0 0 'Number of colors    ' 'Number of colors to compress down to' n",
  "-i 1 0 1 2 0 44x1+3+5.5 0 8 8 1 0 'Precision (bits)    ' 'Number of bits of precision to use in each band during quantization' p",
  "-f 1 0 1 2 0 44.5x1+3+7 0 1 0.5 4 1 0 'Allocation fraction ' 'Fraction of color splits based on subspace 2-norm' r",
  "-O 1 0 0 1 0 1 52x1+0+9 ' ' 'Output File' 'output file' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/igamut/uis/igamut.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


