 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:12:16 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:12:16 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "igauss_func.h"
/*-----------------------------------------------------------
| 
|  Routine Name: igauss_func_get_args
| 
|       Purpose: Gets command line args for igauss_func
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname igauss_func
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void igauss_func_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for igauss_func is out of sync with arguments specified in igauss_func's *.pane file; please rerun ghostwriter on igauss_func.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the igauss_func structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wpeak",
			  &(clui_info->wpeak_int),
			  &(clui_info->wpeak_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hpeak",
			  &(clui_info->hpeak_int),
			  &(clui_info->hpeak_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wvar",
			  &(clui_info->wvar_double),
			  &(clui_info->wvar_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hvar",
			  &(clui_info->hvar_double),
			  &(clui_info->hvar_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "coeff",
			  &(clui_info->coeff_double),
			  &(clui_info->coeff_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "peakval",
			  &(clui_info->peakval_double),
			  &(clui_info->peakval_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "norm",
			  &(clui_info->norm_logic),
			  &(clui_info->norm_flag))))
	{
	    kerror(NULL, "igauss_func_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 50x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 50x1+0+0 +1+0 'Generate Gaussian Function Image' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' igauss_func",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+33+0 'Run' 'execute operation' $IMAGEBIN/igauss_func",
  "-H 1  5x1+39+0 'Help' 'help page' $IMAGE/objects/kroutine/igauss_func/help help",
  "-Q 1 0 5x1+45+0 'Close'",
  "-i 1 0 1 2 0 45x1+1+2 2 2 512 0 0 'Width of Output (Number of Columns) ' 'Width of output image (number of columns)' wsize",
  "",
  "-i 1 0 1 2 0 45x1+1+3 2 2 512 0 0 'Height of Output (Number of Rows)   ' 'Height of output image (number of rows)' hsize",
  "",
  "-x 1 0 1 2 0 46x1.09091+1+17 11 1 10 'Select Data Type:  ' 'Data type of 2D Gaussian function data' type 'bit' 'byte' 'unsigned byte' 'short' 'unsigned short' 'integer' 'unsigned integer' 'long' 'unsigned long' 'float' 'double'",
  "-O 1 0 0 1 0 1 50x1+0+19 ' ' 'Output' 'Output file containing Gaussian data' o",
  "",
  "-C 1",
  "-B 0",
  "-i 1 0 1 1 0 45x1+1+6 0 0 256 0 0 'Peak Location along Width (X)    ' 'Width coordinate for peak of 2D Gaussian function' wpeak",
  "-i 1 0 1 1 0 45x1+1+7 0 0 256 0 0 'Peak Location along Height (Y)   ' 'Height coordinate for peak of 2D Gaussian function' hpeak",
  "-h 1 0 1 1 0 45x1+1+8 2 2 1 1 0 0 'Variance along Width             ' 'Variance of the 2D Gaussian function along width' wvar",
  "-h 1 0 1 1 0 45x1+1+9 2 2 1 1 0 0 'Variance along Height            ' 'Variance of the 2D Gaussian function along height' hvar",
  "-h 1 0 1 1 0 45x1+1+10 -1 1 0 1 0 0 'Correlation coefficient          ' 'Correlation coefficient for 2D Gaussian function' coeff",
  "-h 1 0 1 1 0 45x1+1+11 0 0 1 1 0 0 'Peak Value                       ' 'Peak value of the 2D Gaussian function' peakval",
  "-E",
  "",
  "-B 0",
  "-I 1 0 1 0 0 1 49x1+1+14 ' ' 'Parameter File' 'Input file of parameters for multiple Gaussian functions' i",
  "-l 1 0 1 0 0 26x1+1+15 1 'Normalized Amplitude   ' 'No' 'Yes' 'Normalize amplitude of the Gaussian function' norm",
  "-E",
  "-E",
  "-b +1+5 'Parameters for Generating Single Gaussian Function:' b1",
  "-b +1+13 'Multiple Gaussian Parameters' b2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/igauss_func/uis/igauss_func.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	36,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


