 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:12:34 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:12:34 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "igeowarp.h"
/*-----------------------------------------------------------
| 
|  Routine Name: igeowarp_get_args
| 
|       Purpose: Gets command line args for igeowarp
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname igeowarp
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void igeowarp_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for igeowarp is out of sync with arguments specified in igeowarp's *.pane file; please rerun ghostwriter on igeowarp.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the igeowarp structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "planes",
			  &(clui_info->planes_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "wcoeffs",
			  &(clui_info->wcoeffs_file),
			  &(clui_info->wcoeffs_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "a00",
			  &(clui_info->a00_double),
			  &(clui_info->a00_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "a01",
			  &(clui_info->a01_double),
			  &(clui_info->a01_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "a10",
			  &(clui_info->a10_double),
			  &(clui_info->a10_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "a11",
			  &(clui_info->a11_double),
			  &(clui_info->a11_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "hcoeffs",
			  &(clui_info->hcoeffs_file),
			  &(clui_info->hcoeffs_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "b00",
			  &(clui_info->b00_double),
			  &(clui_info->b00_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "b01",
			  &(clui_info->b01_double),
			  &(clui_info->b01_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "b10",
			  &(clui_info->b10_double),
			  &(clui_info->b10_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "b11",
			  &(clui_info->b11_double),
			  &(clui_info->b11_flag))))
	{
	    kerror(NULL, "igeowarp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Perform Direct Bilinear Geometric Warping' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' kgeowarp",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $IMAGEBIN/igeowarp",
  "-H 1  5x1+41+0 'Help' 'help page' $IMAGE/objects/kroutine/igeowarp/help help",
  "-Q 1 0 5.5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input ' 'Input data object' i",
  "-t 1 0 1 1 0 15x1+3+16 'Process by planes' 'Process data by full planes instead of small prisms' planes",
  "-O 1 0 0 1 0 1 52x1+0+18 ' ' 'Output' 'Output data object' o",
  "-C 1",
  "-I 1 0 1 1 0 1 49x1+3+3 ' ' 'W warp coeffs object' 'W warp function coeffs object' wcoeffs",
  "-B 0",
  "-h 1 0 1 0 0 49x1+3+4.5 -100 100 0 7 1 0 'A00 (W warp function, constant term) ' 'A00 (W warp function, constant term)' a00",
  "-h 1 0 1 0 0 49x1+3+5.5 -100 100 0 7 1 0 'A01 (W warp function, w term)        ' 'A01 (W warp function, w term)' a01",
  "-h 1 0 1 0 0 49x1+3+6.5 -100 100 0 7 1 0 'A10 (W warp function, h term)        ' 'A10 (W warp function, h term)' a10",
  "-h 1 0 1 0 0 49x1+3+7.5 -100 100 0 7 1 0 'A11 (W warp function, wh term)       ' 'A11 (W warp function, wh term)' a11",
  "-E",
  "-E",
  "-C 1",
  "-I 1 0 1 1 0 1 49x1+3+9.5 ' ' 'H warp coeffs object' 'H warp function coeffs object' hcoeffs",
  "-B 0",
  "-h 1 0 1 0 0 49x1+3+11 -100 100 0 7 1 0 'B00 (H warp function, constant term) ' 'B00 (H warp function, constant term)' b00",
  "-h 1 0 1 0 0 49x1+3+12 -100 100 0 7 1 0 'B01 (H warp function, w term)        ' 'B01 (H warp function, w term)' b01",
  "-h 1 0 1 0 0 49x1+3+13 -100 100 0 7 1 0 'B10 (H warp function, h term)        ' 'B10 (H warp function, h term)' b10",
  "-h 1 0 1 0 0 49x1+3+14 -100 100 0 7 1 0 'B11 (H warp function, wh term)       ' 'B11 (H warp function, wh term)' b11",
  "-E",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/igeowarp/uis/igeowarp.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	33,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


