 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:12:52 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:12:52 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "igradient.h"
/*-----------------------------------------------------------
| 
|  Routine Name: igradient_get_args
| 
|       Purpose: Gets command line args for igradient
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname igradient
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void igradient_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for igradient is out of sync with arguments specified in igradient's *.pane file; please rerun ghostwriter on igradient.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the igradient structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "igradient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "abs",
			  &(clui_info->abs_logic),
			  &(clui_info->abs_flag))))
	{
	    kerror(NULL, "igradient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "igradient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "roberts",
			  &(clui_info->roberts_flag))))
	{
	    kerror(NULL, "igradient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "sobel",
			  &(clui_info->sobel_flag))))
	{
	    kerror(NULL, "igradient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "prewitt",
			  &(clui_info->prewitt_flag))))
	{
	    kerror(NULL, "igradient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "isotropic",
			  &(clui_info->isotropic_flag))))
	{
	    kerror(NULL, "igradient_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Gradient Operators (Roberts, Sobel, Prewitt, Isotropic)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' Differentiators",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $IMAGEBIN/igradient",
  "-H 1  5x1+41+0 'Help' 'help page for igradient' $IMAGE/objects/kroutine/igradient/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image   ' 'input image filename' i",
  "-l 1 0 1 2 0 38.5x1+5+9.5 0 'Calculate Result Using  ' 'Absolute Value' 'Square Root' 'Calculate gradient using absolute value or square root' abs",
  "-O 1 0 0 1 0 1 51.75x1+0+11.5 ' ' 'Output Image  ' 'output image filename' o",
  "-b +5+4 'Type of Gradient Operator' b0",
  "-C 1",
  "-t 1 0 1 1 0 13x1+7+5.5 'Roberts (2x2)' 'Perform Roberts gradient operation' roberts",
  "-t 1 0 1 0 0 12x1+27+5.5 'Sobel (3x3)' 'Perform Sobel gradient operation' sobel",
  "-t 1 0 1 0 0 13x1+7+7.5 'Prewitt (3x3)' 'Perform Prewitt gradient operation' prewitt",
  "-t 1 0 1 0 0 14x1+27+7.5 'Isotropic (3x3)' 'Perform Isotropic gradient operation' isotropic",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/igradient/uis/igradient.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	22,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


