 /*
  * Khoros: $Id: imedian.h,v 1.14.2.2 1997/05/31 19:13:07 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for imedian
   >>>> 
   >>>>    Written By: Scott Wilson (stolen from K1.5 vhmed and vqmed, which were
written by Ramiro Jordan and Marcelo Teran)
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _imedian_h_
#define _imedian_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <image.h>

/* -include_includes */
#include <kimage_proc/kimage_proc.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input image (required infile)
 */
char	*i_file;	/* Input image FILENAME */
int	 i_flag;	/* Input image FLAG */

/*
 *  Output image (required outfile)
 */
char	*o_file;	/* Output image FILENAME */
int	 o_flag;	/* Output image FLAG */

/*
 *  Width of window (optional integer)
 */
int	 wsize_int; 	/* Width of window INT */
int	 wsize_flag;	/* Width of window FLAG */

/*
 *  Heigth of window (optional integer)
 */
int	 hsize_int; 	/* Heigth of window INT */
int	 hsize_flag;	/* Heigth of window FLAG */

/*
 *  number of repetitions of filter to perform (optional integer)
 */
int	 reps_int; 	/* number of repetitions of filter to perform INT */
int	 reps_flag;	/* number of repetitions of filter to perform FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void imedian_get_args PROTO((kaddr));
void imedian_usage_additions PROTO((void));
void imedian_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
