 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:13:10 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:13:10 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "imedian.h"
/*-----------------------------------------------------------
| 
|  Routine Name: imedian_get_args
| 
|       Purpose: Gets command line args for imedian
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname imedian
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void imedian_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for imedian is out of sync with arguments specified in imedian's *.pane file; please rerun ghostwriter on imedian.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the imedian structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "imedian_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "wsize",
			  &(clui_info->wsize_int),
			  &(clui_info->wsize_flag))))
	{
	    kerror(NULL, "imedian_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hsize",
			  &(clui_info->hsize_int),
			  &(clui_info->hsize_flag))))
	{
	    kerror(NULL, "imedian_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "reps",
			  &(clui_info->reps_int),
			  &(clui_info->reps_flag))))
	{
	    kerror(NULL, "imedian_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "imedian_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Median Filter for Image Data' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' imedian",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $IMAGE/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $IMAGEBIN/imedian",
  "-H 1  5x1+41+0 'Help' 'help page' $IMAGE/objects/kroutine/imedian/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input image' 'Input image' i",
  "-i 1 0 1 1 0 45x1+5+3.5 2 2 3 0 0 'Width  of window' 'Width of window' wsize",
  "-i 1 0 1 1 0 45x1+5+5 2 2 3 0 0 'Heigth of window' 'Heigth of window' hsize",
  "-i 1 0 1 1 0 20x1+5+6.5 1 1 1 0 0 'Repetitions' 'number of repetitions of filter to perform' reps",
  "-O 1 0 0 1 0 1 52x1+0+8 ' ' 'Output image' 'Output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/imedian/uis/imedian.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


