 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:13:39 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:13:39 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "ipostscr.h"
/*-----------------------------------------------------------
| 
|  Routine Name: ipostscr_get_args
| 
|       Purpose: Gets command line args for ipostscr
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname ipostscr
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void ipostscr_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for ipostscr is out of sync with arguments specified in ipostscr's *.pane file; please rerun ghostwriter on ipostscr.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the ipostscr structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "width",
			  &(clui_info->width_double),
			  &(clui_info->width_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "height",
			  &(clui_info->height_double),
			  &(clui_info->height_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "xoffset",
			  &(clui_info->xoffset_double),
			  &(clui_info->xoffset_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "yoffset",
			  &(clui_info->yoffset_double),
			  &(clui_info->yoffset_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "showpage",
			  &(clui_info->showpage_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "f",
			  &(clui_info->f_file),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "portrait",
			  &(clui_info->portrait_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "landscape",
			  &(clui_info->landscape_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "ps",
			  &(clui_info->ps_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "eps",
			  &(clui_info->eps_flag))))
	{
	    kerror(NULL, "ipostscr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Convert Image to Postscript' subform",
  "-P 1 0 50x1+0+1 +0+0 ' ' ipostscr",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $IMAGEBIN/ipostscr",
  "-H 1  5x1+41+0 'Help' 'help page' $IMAGE/objects/kroutine/ipostscr/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Object' 'Object to be output in postscript form' i",
  "-h 1 0 1 0 0 21x1+2+5 2 2 4 2 0 0 'Width        ' 'Desired width in inches of the printed image' width",
  "-h 1 0 1 0 0 22x1+28+5 2 2 4 2 0 0 'Height        ' 'Desired height of printed image in inches' height",
  "-h 1 0 1 0 0 21x1+2+6 2 2 1 2 0 0 'Width Offset ' 'Width offset in inches from bottom left corner of printed page' xoffset",
  "-h 1 0 1 0 0 22x1+28+6 2 2 1 2 0 0 'Height Offset ' 'Height offset in inches from bottom left corner of printed page ' yoffset",
  "-t 1 0 1 1 0 31.625x1+1+8 'Force Output of Page (Issue a Showpage)' 'Issue showpage at end of output' showpage",
  "-O 1 0 0 1 0 1 52x1+0+17 ' ' 'Output Postscript File' 'output postscript file' f",
  "-C 0",
  "-t 1 0 1 1 0 8.375x1+6+15 'Portrait' 'Specify that portrait style output is desired.' portrait",
  "-t 1 0 1 0 0 9.125x1+19+15 'Landscape' 'specifies that landscape output is desired' landscape",
  "-E",
  "-C 0",
  "-t 1 0 1 1 0 9.875x1+5+11.5 'Postscript' 'Specify that regular Postscript output is desired.' ps",
  "-t 1 0 1 0 0 24.875x1+19+11.5 'Encapsulated Postscript (EPSF)' 'Specify that Encapsulated Postscript is desired.' eps",
  "-E",
  "-b +1+10 'Type of Output' uhhhh",
  "-b +1+13.5 'Orientation of Output' uhhh_huhhh",
  "-b +1+4 'Specify Size and Offset Parameters in Inches' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/ipostscr/uis/ipostscr.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	30,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


