 /*
  * Khoros: $Id: irotate.h,v 1.18.2.2 1997/05/31 19:13:55 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for irotate
   >>>> 
   >>>>    Written By: Scott Wilson
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _irotate_h_
#define _irotate_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <image.h>

/* -include_includes */
#include <dataserv.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input data object (required infile)
 */
char	*i_file;	/* Input data object FILENAME */
int	 i_flag;	/* Input data object FLAG */

/*
 *  Output data object (required outfile)
 */
char	*o_file;	/* Output data object FILENAME */
int	 o_flag;	/* Output data object FLAG */

/*----- required ME group ----*/
/*
 *  W coordinate of center of rotation (optional double)
 */
double	 wc_double;	/* W coordinate of center of rotation DOUBLE */
int	 wc_flag;   	/* W coordinate of center of rotation FLAG */

/*
 *  center of rotation in center of W coordinate span (optional flag)
 */
int	 wctr_flag;  	/* center of rotation in center of W coordinate span FLAG */

/*-- required ME group end ---*/

/*----- required ME group ----*/
/*
 *  H coordinate of center of rotation (optional double)
 */
double	 hc_double;	/* H coordinate of center of rotation DOUBLE */
int	 hc_flag;   	/* H coordinate of center of rotation FLAG */

/*
 *  center of rotation in center of H coordinate span (optional flag)
 */
int	 hctr_flag;  	/* center of rotation in center of H coordinate span FLAG */

/*-- required ME group end ---*/

/*
 *  rotation angle (degrees, positive is CW) (optional double)
 */
double	 angle_double;	/* rotation angle (degrees, positive is CW) DOUBLE */
int	 angle_flag;   	/* rotation angle (degrees, positive is CW) FLAG */

/*
 *  resize to fit rotated image (optional flag)
 */
int	 resize_flag;  	/* resize to fit rotated image FLAG */

/*
 *  Process data by WxH planes (fast, but only good for smaller objects) instead of small prisms down D (slow, but works for huge objects) (optional flag)
 */
int	 planes_flag;  	/* Process data by WxH planes (fast, but only good for smaller objects) instead of small prisms down D (slow, but works for huge objects) FLAG */

/*
 *  specify padding behavior (1 - pad with zeros, 2 - pad with pad value, 3 - pad with pad value attribute in input object) (Optional cycle)
 */
int	 padding_cycle;	/* specify padding behavior (1 - pad with zeros, 2 - pad with pad value, 3 - pad with pad value attribute in input object) CYCLE INDEX */
char	 *padding_label;	/* specify padding behavior (1 - pad with zeros, 2 - pad with pad value, 3 - pad with pad value attribute in input object) CYCLE LABEL */
int	 padding_flag;	/* specify padding behavior (1 - pad with zeros, 2 - pad with pad value, 3 - pad with pad value attribute in input object) FLAG */

/*
 *  real constant pad value (optional double)
 */
double	 real_double;	/* real constant pad value DOUBLE */
int	 real_flag;   	/* real constant pad value FLAG */

/*
 *  imaginary constant pad value (optional double)
 */
double	 imag_double;	/* imaginary constant pad value DOUBLE */
int	 imag_flag;   	/* imaginary constant pad value FLAG */

/*
 *  Identify padded data added by this program as valid or invalid in mask (optional logical)
 */
int	 padvalid_logic;	/* Identify padded data added by this program as valid or invalid in mask LOGIC */
int	 padvalid_flag;  	/* Identify padded data added by this program as valid or invalid in mask FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void irotate_get_args PROTO((kaddr));
void irotate_usage_additions PROTO((void));
void irotate_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
