 /*
  * Khoros: $Id: usage.c,v 1.18.2.2 1997/05/31 19:13:57 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.18.2.2 1997/05/31 19:13:57 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "irotate.h"
/*-----------------------------------------------------------
| 
|  Routine Name: irotate_get_args
| 
|       Purpose: Gets command line args for irotate
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname irotate
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void irotate_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for irotate is out of sync with arguments specified in irotate's *.pane file; please rerun ghostwriter on irotate.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the irotate structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "angle",
			  &(clui_info->angle_double),
			  &(clui_info->angle_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "resize",
			  &(clui_info->resize_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "planes",
			  &(clui_info->planes_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "padding", KVF_LIST_LABEL,
			  &(clui_info->padding_label),
			  &(clui_info->padding_flag)) &&
	      kclui_get_value(pane, "padding", KVF_LIST_VAL,
			  &(clui_info->padding_cycle),
			  &(clui_info->padding_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "real",
			  &(clui_info->real_double),
			  &(clui_info->real_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "imag",
			  &(clui_info->imag_double),
			  &(clui_info->imag_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "padvalid",
			  &(clui_info->padvalid_logic),
			  &(clui_info->padvalid_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "wc",
			  &(clui_info->wc_double),
			  &(clui_info->wc_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "wctr",
			  &(clui_info->wctr_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "hc",
			  &(clui_info->hc_double),
			  &(clui_info->hc_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "hctr",
			  &(clui_info->hctr_flag))))
	{
	    kerror(NULL, "irotate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Rotate Object by Arbitrary Angle ' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' krotate",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $IMAGEBIN/irotate",
  "-H 1  5x1+41+0 'Help' 'help page' $IMAGE/objects/kroutine/irotate/help help",
  "-Q 1 0 5.25x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'Input ' 'Input data object' i",
  "-h 1 0 1 2 1 49x1+3+4.5 -360 360 0 6 1 0 'Rotation Angle  ' 'rotation angle (degrees, positive is CW)' angle",
  "-t 1 0 1 0 0 12.125x1+1+10 'Resize to fit' 'resize to fit rotated image' resize",
  "-t 1 0 1 1 0 15.125x1+18+10 'Process by planes' 'Process data by WxH planes (fast, but only good for smaller objects) instead of small prisms down D (slow, but works for huge objects)' planes",
  "-c 1 0 1 2 0 46x1+6+12 3 1 1 'Specify padding behavior' 'specify padding behavior (1 - pad with zeros, 2 - pad with pad value, 3 - pad with pad value attribute in input object)' padding 'Pad with zero' 'Pad with specified pad value' 'Pad with input obj pad attribute'",
  "-h 1 0 1 2 1 30x1+6+13 0 0 0 0 0 0 'Real pad value      ' 'real constant pad value' real",
  "-h 1 0 1 2 1 30x1+6+14 0 0 0 0 0 0 'Imagninary pad value' 'imaginary constant pad value' imag",
  "-l 1 0 1 2 0 30x1+6+15 1 'Identify padded areas as' 'Invalid' 'Valid' 'Identify padded data added by this program as valid or invalid in mask' padvalid",
  "-O 1 0 0 1 0 1 52x1+1+17 ' ' 'Output' 'Output data object' o",
  "-C 1",
  "-h 1 0 1 0 1 40x1+1+6.5 0 0 0 6 0 0 'W coordinate of center of rotation ' 'W coordinate of center of rotation' wc",
  "-t 1 0 1 1 0 9x1+43+6.5 'W center' 'center of rotation in center of W coordinate span' wctr",
  "-E",
  "-C 1",
  "-h 1 0 1 0 1 40x1+1+8 0 0 0 6 0 0 'H coordinate of center of rotation ' 'H coordinate of center of rotation' hc",
  "-t 1 0 1 1 0 9x1+43+8 'H center' 'center of rotation in center of H coordinate span' hctr",
  "-E",
  "-b +1+3.5 'Specify Rotation Angle in Degrees (positive is clockwise)' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/irotate/uis/irotate.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	30,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


