 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:14:14 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:14:14 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "itexture.h"
/*-----------------------------------------------------------
| 
|  Routine Name: itexture_get_args
| 
|       Purpose: Gets command line args for itexture
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname itexture
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void itexture_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for itexture is out of sync with arguments specified in itexture's *.pane file; please rerun ghostwriter on itexture.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the itexture structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5L5",
			  &(clui_info->L5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5L5",
			  &(clui_info->E5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5L5",
			  &(clui_info->S5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5L5",
			  &(clui_info->W5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5L5",
			  &(clui_info->R5L5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5E5",
			  &(clui_info->L5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5E5",
			  &(clui_info->E5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5E5",
			  &(clui_info->S5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5E5",
			  &(clui_info->W5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5E5",
			  &(clui_info->R5E5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5S5",
			  &(clui_info->L5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5S5",
			  &(clui_info->E5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5S5",
			  &(clui_info->S5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5S5",
			  &(clui_info->W5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5S5",
			  &(clui_info->R5S5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5W5",
			  &(clui_info->L5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5W5",
			  &(clui_info->E5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5W5",
			  &(clui_info->S5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5W5",
			  &(clui_info->W5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5W5",
			  &(clui_info->R5W5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "L5R5",
			  &(clui_info->L5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "E5R5",
			  &(clui_info->E5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "S5R5",
			  &(clui_info->S5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "W5R5",
			  &(clui_info->W5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "R5R5",
			  &(clui_info->R5R5_flag))))
	{
	    kerror(NULL, "itexture_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Texture Feature Extraction Using LAW Metrics' feature",
  "-P 1 0 52x1+0+1 +12+0 ' ' ktexture",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $IMAGEBIN/itexture",
  "-H 1  5x1+41+0 'Help' 'man page for ktexture' $IMAGE/objects/kroutine/itexture/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input object ' 'input object' i",
  "-O 1 0 0 1 0 1 52x1+0+11.5 ' ' 'Output object' 'output object' o",
  "-K 0",
  "-t 1 0 1 1 0 5.375x1+2+5 'L5L5' 'If set, apply L5L5 texture kernel' L5L5",
  "-t 1 0 1 0 0 1x1+12+5 'E5L5' 'If set, apply E5L5 texture kernel' E5L5",
  "-t 1 0 1 0 0 1x1+22+5 'S5L5' 'If set, apply S5L5 texture kernel' S5L5",
  "-t 1 0 1 0 0 1x1+32+5 'W5L5' 'If set, apply W5L5 texture kernel' W5L5",
  "-t 1 0 1 0 0 1x1+42+5 'R5L5' 'If set, apply R5L5 texture kernel' R5L5",
  "-t 1 0 1 0 0 1x1+2+6.1 'L5E5' 'If set, apply L5E5 texture kernel' L5E5",
  "-t 1 0 1 0 0 1x1+12+6.1 'E5E5' 'If set, apply E5E5 texture kernel' E5E5",
  "-t 1 0 1 0 0 1x1+22+6.1 'S5E5' 'If set, apply S5E5 texture kernel' S5E5",
  "-t 1 0 1 0 0 1x1+32+6.1 'W5E5' 'If set, apply W5E5 texture kernel' W5E5",
  "-t 1 0 1 0 0 1x1+42+6.1 'R5E5' 'If set, apply R5E5 texture kernel' R5E5",
  "-t 1 0 1 0 0 1x1+2+7.2 'L5S5' 'If set, apply L5S5 texture kernel' L5S5",
  "-t 1 0 1 0 0 1x1+12+7.2 'E5S5' 'If set, apply E5S5 texture kernel' E5S5",
  "-t 1 0 1 0 0 1x1+22+7.2 'S5S5' 'If set, apply S5S5 texture kernel' S5S5",
  "-t 1 0 1 0 0 1x1+32+7.2 'W5S5' 'If set, apply W5S5 texture kernel' W5S5",
  "-t 1 0 1 0 0 1x1+42+7.2 'R5S5' 'If set, apply R5S5 texture kernel' R5S5",
  "-t 1 0 1 0 0 1x1+2+8.3 'L5W5' 'If set, apply L5W5 texture kernel' L5W5",
  "-t 1 0 1 0 0 1x1+12+8.3 'E5W5' 'If set, apply E5W5 texture kernel' E5W5",
  "-t 1 0 1 0 0 1x1+22+8.3 'S5W5' 'If set, apply S5W5 texture kernel' S5W5",
  "-t 1 0 1 0 0 1x1+32+8.3 'W5W5' 'If set, apply W5W5 texture kernel' W5W5",
  "-t 1 0 1 0 0 1x1+42+8.3 'R5W5' 'If set, apply R5W5 texture kernel' R5W5",
  "-t 1 0 1 0 0 1x1+2+9.4 'L5R5' 'If set, apply L5R5 texture kernel' L5R5",
  "-t 1 0 1 0 0 1x1+12+9.4 'E5R5' 'If set, apply E5R5 texture kernel' E5R5",
  "-t 1 0 1 0 0 1x1+22+9.4 'S5R5' 'If set, apply S5R5 texture kernel' S5R5",
  "-t 1 0 1 0 0 1x1+32+9.4 'W5R5' 'If set, apply W5R5 texture kernel' W5R5",
  "-t 1 0 1 0 0 1x1+42+9.4 'R5R5' 'If set, apply R5R5 texture kernel' R5R5",
  "-E",
  "-b +0+4 'Spatial Texture Kernels:' blank0",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$IMAGE/objects/kroutine/itexture/uis/itexture.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	42,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


