 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:36:13 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:36:13 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "mexchg.h"
/*-----------------------------------------------------------
| 
|  Routine Name: mexchg_get_args
| 
|       Purpose: Gets command line args for mexchg
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mexchg
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void mexchg_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for mexchg is out of sync with arguments specified in mexchg's *.pane file; please rerun ghostwriter on mexchg.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the mexchg structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "mexchg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "mexchg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r1",
			  &(clui_info->r1_int),
			  &(clui_info->r1_flag))))
	{
	    kerror(NULL, "mexchg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r2",
			  &(clui_info->r2_int),
			  &(clui_info->r2_flag))))
	{
	    kerror(NULL, "mexchg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c1",
			  &(clui_info->c1_int),
			  &(clui_info->c1_flag))))
	{
	    kerror(NULL, "mexchg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c2",
			  &(clui_info->c2_int),
			  &(clui_info->c2_flag))))
	{
	    kerror(NULL, "mexchg_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Exchange Rows or Columns of a Matrix' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' mexchg",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $MATRIX/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MATRIXBIN/mexchg",
  "-H 1  5x1+41+0 'Help' 'help page' $MATRIX/objects/kroutine/mexchg/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Matrix' 'Input matrix' i",
  "-O 1 0 0 1 0 1 52x1+0+10 ' ' 'Output Matrix' 'Output matrix' o",
  "-B 0",
  "-i 1 0 1 0 0 16x1+5+4 1 1 1 0 0 'Row #1 ' 'row #1' r1",
  "-i 1 0 1 0 0 16x1+5+5 1 1 1 0 0 'Row #2 ' 'row #2' r2",
  "-E",
  "-B 0",
  "-i 1 0 1 0 0 16x1+5+7 1 1 1 0 0 'Column #1 ' 'Column #1' c1",
  "-i 1 0 1 0 0 16x1+5+8 1 1 1 0 0 'Column #2 ' 'Column #2' c2",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MATRIX/objects/kroutine/mexchg/uis/mexchg.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	22,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


