 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:36:38 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:36:38 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "mextract_diag.h"
/*-----------------------------------------------------------
| 
|  Routine Name: mextract_diag_get_args
| 
|       Purpose: Gets command line args for mextract_diag
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mextract_diag
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void mextract_diag_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for mextract_diag is out of sync with arguments specified in mextract_diag's *.pane file; please rerun ghostwriter on mextract_diag.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the mextract_diag structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "mextract_diag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "num",
			  &(clui_info->num_int),
			  &(clui_info->num_flag))))
	{
	    kerror(NULL, "mextract_diag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "mextract_diag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "row",
			  &(clui_info->row_flag))))
	{
	    kerror(NULL, "mextract_diag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "col",
			  &(clui_info->col_flag))))
	{
	    kerror(NULL, "mextract_diag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "diag",
			  &(clui_info->diag_flag))))
	{
	    kerror(NULL, "mextract_diag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Extract diagonal into vector ' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' mextract_diag",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MATRIXBIN/mextract_diag",
  "-H 1  5x1+41+0 'Help' 'help page' $MATRIX/objects/kroutine/mextract_diag/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Matrix' 'Input matrix' i",
  "-i 1 0 1 1 1 44.75x1+6+7.5 1 1 0 0 0 'Row or Column Number' 'Row or column number' num",
  "-O 1 0 0 1 0 1 52x1+0+9.5 ' ' 'Output Vector' 'Output vector' o",
  "-C 1",
  "-t 1 0 1 0 0 10.625x1+6+4 'Extract Row' 'Extract row' row",
  "-t 1 0 1 0 0 12.875x1+6+5 'Extract Column' 'Extract column' col",
  "-t 1 0 1 1 0 14.375x1+6+6 'Extract Diagonal' 'Extract diagonal' diag",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MATRIX/objects/kroutine/mextract_diag/uis/mextract_diag.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


