 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:37:01 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:37:01 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "mgdiag.h"
/*-----------------------------------------------------------
| 
|  Routine Name: mgdiag_get_args
| 
|       Purpose: Gets command line args for mgdiag
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mgdiag
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void mgdiag_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for mgdiag is out of sync with arguments specified in mgdiag's *.pane file; please rerun ghostwriter on mgdiag.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the mgdiag structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_double(pane, "cr",
			  &(clui_info->cr_double),
			  &(clui_info->cr_flag))))
	{
	    kerror(NULL, "mgdiag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_double(pane, "ci",
			  &(clui_info->ci_double),
			  &(clui_info->ci_flag))))
	{
	    kerror(NULL, "mgdiag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "mgdiag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_cycle),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "mgdiag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "mgdiag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "mgdiag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "mgdiag_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate a Diagonal Matrix' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' mgdiag",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $MATRIX/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MATRIXBIN/mgdiag",
  "-H 1  5x1+41+0 'Help' 'help page' $MATRIX/objects/kroutine/mgdiag/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-h 1 0 1 0 0 27x1+7+5 0 0 0 10 0 0 'Constant (real) ' 'Real part of constant diagonal value' cr",
  "-h 1 0 1 0 0 27x1+7+6.5 0 0 0 10 0 0 'Constant (imag) ' 'Imaginary part of constant diagonal value' ci",
  "-I 1 0 1 0 0 1 45x1+7+9.5 ' ' 'Diagonal vector ' 'Vector of diagonal elements' i",
  "-c 1 0 0 1 0 24.5x1+5+11 4 1 1 'Output data type ' 'Output data type' type 'Float' 'Complex' 'Double' 'Double Complex '",
  "-O 1 0 0 1 0 1 50x1+0+12.5 ' ' 'Output' 'Resulting output data object' o",
  "-b +5+3.5 'Specify diagonal constant value as:' blank2",
  "-b +5+8 'OR - specify vector of diagonal values:' blank3",
  "-B 0",
  "-i 1 0 1 0 0 14x1+5+2 2 2 1 0 0 'Rows ' 'Number of rows' r",
  "-i 1 0 1 0 0 16.5x1+26+2 2 2 1 0 0 'Columns ' 'Number of columns' c",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MATRIX/objects/kroutine/mgdiag/uis/mgdiag.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	23,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


