 /*
  * Khoros: $Id: mlud.h,v 1.14.2.2 1997/05/31 19:38:17 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for mlud
   >>>> 
   >>>>    Written By: Scott Wilson
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _mlud_h_
#define _mlud_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <matrix.h>

/* -include_includes */
#include <kmatrix/kmatrix.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input matrix (required infile)
 */
char	*i_file;	/* Input matrix FILENAME */
int	 i_flag;	/* Input matrix FLAG */

/*
 *  Resulting lower triangular output matrix (optional outfile)
 */
char	*o1_file;	/* Resulting lower triangular output matrix FILENAME */
int	 o1_flag;	/* Resulting lower triangular output matrix FLAG */

/*
 *  Resulting upper triangular output  matrix (optional outfile)
 */
char	*o2_file;	/* Resulting upper triangular output  matrix FILENAME */
int	 o2_flag;	/* Resulting upper triangular output  matrix FLAG */

/*
 *  Pivot index vector (optional outfile)
 */
char	*o3_file;	/* Pivot index vector FILENAME */
int	 o3_flag;	/* Pivot index vector FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void mlud_get_args PROTO((kaddr));
void mlud_usage_additions PROTO((void));
void mlud_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
