 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:39:10 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:39:10 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "mpow.h"
/*-----------------------------------------------------------
| 
|  Routine Name: mpow_get_args
| 
|       Purpose: Gets command line args for mpow
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mpow
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void mpow_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for mpow is out of sync with arguments specified in mpow's *.pane file; please rerun ghostwriter on mpow.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the mpow structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "mpow_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "pow",
			  &(clui_info->pow_int),
			  &(clui_info->pow_flag))))
	{
	    kerror(NULL, "mpow_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "mpow_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute the Positive Integral Power of a Square Matrix' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' mpow",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $MATRIX/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MATRIXBIN/mpow",
  "-H 1  5x1+41+0 'Help' 'help page' $MATRIX/objects/kroutine/mpow/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input matrix object' 'Input matrix object' i",
  "-i 1 0 0 1 0 44x1+3+3.5 1 1 2 0 0 'Power (integer, >=0)' 'power to which the matrix should be raised (>=0)' pow",
  "-O 1 0 0 1 0 1 51.5x1+0+5 ' ' 'Output matrix object' 'Output matrix object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MATRIX/objects/kroutine/mpow/uis/mpow.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


