 /*
  * Khoros: $Id: mreplicate.h,v 1.14.2.2 1997/05/31 19:39:50 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for mreplicate
   >>>> 
   >>>>    Written By: Scott Wilson
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _mreplicate_h_
#define _mreplicate_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <matrix.h>

/* -include_includes */
#include <kmatrix/kmatrix.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input mmatrix data object (required infile)
 */
char	*i_file;	/* Input mmatrix data object FILENAME */
int	 i_flag;	/* Input mmatrix data object FLAG */

/*
 *  Resulting matrix output data object (required outfile)
 */
char	*o_file;	/* Resulting matrix output data object FILENAME */
int	 o_flag;	/* Resulting matrix output data object FLAG */

/*
 *  replica count along rows (optional integer)
 */
int	 r_int; 	/* replica count along rows INT */
int	 r_flag;	/* replica count along rows FLAG */

/*
 *  replica count along columns (optional integer)
 */
int	 c_int; 	/* replica count along columns INT */
int	 c_flag;	/* replica count along columns FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void mreplicate_get_args PROTO((kaddr));
void mreplicate_usage_additions PROTO((void));
void mreplicate_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
