 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:39:52 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:39:52 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "mreplicate.h"
/*-----------------------------------------------------------
| 
|  Routine Name: mreplicate_get_args
| 
|       Purpose: Gets command line args for mreplicate
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mreplicate
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void mreplicate_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for mreplicate is out of sync with arguments specified in mreplicate's *.pane file; please rerun ghostwriter on mreplicate.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the mreplicate structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "mreplicate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "mreplicate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "mreplicate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "mreplicate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Replicate a Given Matrix as Submatrices of a Larger Matrix' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' mreplicate",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $MATRIX/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MATRIXBIN/mreplicate",
  "-H 1  5x1+41+0 'Help' 'help page' $MATRIX/objects/kroutine/mreplicate/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input ' 'Input mmatrix data object' i",
  "-i 1 0 1 1 0 28x1+10+3.5 2 2 1 0 0 'Replica count along rows ' 'replica count along rows' r",
  "-i 1 0 1 1 0 28x1+10+5 2 2 1 0 0 'Replica count along cols ' 'replica count along columns' c",
  "-O 1 0 0 1 0 1 51.5x1+0+6.5 ' ' 'Output' 'Resulting matrix output data object' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MATRIX/objects/kroutine/mreplicate/uis/mreplicate.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	16,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


