 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:40:14 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:40:14 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "msvd.h"
/*-----------------------------------------------------------
| 
|  Routine Name: msvd_get_args
| 
|       Purpose: Gets command line args for msvd
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname msvd
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void msvd_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for msvd is out of sync with arguments specified in msvd's *.pane file; please rerun ghostwriter on msvd.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the msvd structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "msvd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "msvd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "msvd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o3",
			  &(clui_info->o3_file),
			  &(clui_info->o3_flag))))
	{
	    kerror(NULL, "msvd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute singular value decomposition (SVD) ' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' msvd",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MATRIXBIN/msvd",
  "-H 1  5x1+41+0 'Help' 'help page' $MATRIX/objects/kroutine/msvd/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Matrix ' 'Input matrix' i",
  "-O 1 0 0 1 0 1 52x1+0+4 ' ' 'Output Matrix U' 'Output matrix U' o1",
  "-O 1 0 0 1 0 1 52x1+0+5 ' ' 'Output Matrix S' 'Output matrix S' o2",
  "-O 1 0 0 1 0 1 52x1+0+6 ' ' 'Output Matrix V' 'Output matrix V' o3",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MATRIX/objects/kroutine/msvd/uis/msvd.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	16,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


