 /*
  * Khoros: $Id: usage.c,v 1.7.2.2 1997/05/31 19:40:32 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.7.2.2 1997/05/31 19:40:32 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "mtransform.h"
/*-----------------------------------------------------------
| 
|  Routine Name: mtransform_get_args
| 
|       Purpose: Gets command line args for mtransform
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mtransform
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void mtransform_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for mtransform is out of sync with arguments specified in mtransform's *.pane file; please rerun ghostwriter on mtransform.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the mtransform structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "mtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "mtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "type", KVF_LIST_LABEL,
			  &(clui_info->type_label),
			  &(clui_info->type_flag)) &&
	      kclui_get_value(pane, "type", KVF_LIST_VAL,
			  &(clui_info->type_list),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "mtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "mtransform_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Transform all vectors in an object using a single matrix' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' mtransform",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $MATRIX/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MATRIXBIN/mtransform",
  "-H 1  5x1+41+0 'Help' 'help page' $MATRIX/objects/kroutine/mtransform/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input matrix' 'matrix to be used to transform the vectors' i1",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Vector object' 'object of vectors (down E) to be transformed' i2",
  "-x 1 0 1 2 0 36.375x1+3+4.5 14 0 0 'Output data type:  ' 'Data type of output' type 'Propagate input type' 'Bit' 'Byte' 'Unsigned byte' 'Short' 'Unsigned short' 'Integer' 'Unsigned integer' 'Long' 'Unsigned long' 'Float' 'Double' 'Complex' 'Double complex'",
  "",
  "-O 1 0 0 1 0 1 52x1+0+6 ' ' 'Output vector object' 'Object of transformed E vectors' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MATRIX/objects/kroutine/mtransform/uis/mtransform.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


