 /*
  * Khoros: $Id: dbcnvrt.c,v 1.14.2.2 1997/05/31 19:33:15 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: dbcnvrt.c,v 1.14.2.2 1997/05/31 19:33:15 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for dbcnvrt
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "dbcnvrt.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Convert from a pre-Khoros 2.0 kdbm file to a 2.0 kdbm file
|
|       Purpose: main program for dbcnvrt
|
|         Input:
|		Required M.E. group:
|		    M.I. group:
|			char *clui_info->i_file; {Input database file}
|			int   clui_info->i_flag; {TRUE if -i specified}
|
|			char *clui_info->o_file; {Output Database Filename}
|			int   clui_info->o_flag; {TRUE if -o specified}
|
|		    char *clui_info->tb_string; {Change the cms databases for a whole toolbox}
|		    int   clui_info->tb_flag; {TRUE if -tb specified}
|
|		int clui_info->rm_flag; {TRUE if -rm specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
/* -main_variable_list_end */

	khoros_init(argc, argv, "MIGRATION", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$MIGRATION/objects/kroutine/dbcnvrt");
	kexit_handler(dbcnvrt_free_args, NULL);

/* -main_get_args_call */
	kclui_init("MIGRATION", "dbcnvrt", KGEN_KROUTINE,  &clui_uis_spec,
		   dbcnvrt_usage_additions, dbcnvrt_get_args,
 		   dbcnvrt_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
   if (clui_info->tb_flag)
   {
      if (convert_tb(clui_info->tb_string) == FALSE)
      {
	 kerror(NULL, NULL, "Unable to convert toolbox dbfiles from '%s'",
		clui_info->tb_string);
         kexit(KEXIT_FAILURE);
      }
   }
   else
   {
      if (convert_file(clui_info->i_file, clui_info->o_file,
		       clui_info->rm_flag) == FALSE)
      {
	 kerror(NULL, NULL, "Unable to convert dbfile from '%s' to '%s'",
		clui_info->i_file, clui_info->o_file);
         kexit(KEXIT_FAILURE);
      }
   }
/* -main_before_lib_call_end */

/* -main_library_call */
/* -main_library_call_end */

/* -main_after_lib_call */
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: dbcnvrt_usage_additions
| 
|       Purpose: Prints usage additions in dbcnvrt_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname dbcnvrt
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void dbcnvrt_usage_additions(void)
{
	kfprintf(kstderr, "\tConvert from a pre-Khoros 2.0 kdbm file to a 2.0 kdbm file\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: dbcnvrt_free_args
| 
|       Purpose: Frees CLUI struct allocated in dbcnvrt_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname dbcnvrt
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
dbcnvrt_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
