 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:33:21 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 19:33:21 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "dbcnvrt.h"
/*-----------------------------------------------------------
| 
|  Routine Name: dbcnvrt_get_args
| 
|       Purpose: Gets command line args for dbcnvrt
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname dbcnvrt
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void dbcnvrt_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for dbcnvrt is out of sync with arguments specified in dbcnvrt's *.pane file; please rerun ghostwriter on dbcnvrt.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the dbcnvrt structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_flag(pane, "rm",
			  &(clui_info->rm_flag))))
	{
	    kerror(NULL, "dbcnvrt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "dbcnvrt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "dbcnvrt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "dbcnvrt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +5+0 'Convert from a pre-Khoros 2.0 kdbm file to a 2.0 kdbm file' subform",
  "-P 1 0 53.25x6.27273+0+1 +0+0 ' ' dbcnvrt",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $MIGRATION/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MIGRATIONBIN/dbcnvrt",
  "-H 1  5x1+41+0 'Help' 'help page' $MIGRATION/objects/kroutine/dbcnvrt/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-t 1 0 1 0 0 15.125x1+0+6 'Remove Old DB files' 'Remove the original unconverted DB files' rm",
  "-C 1",
  "-B 0",
  "-I 1 0 1 1 0 1 52x1+0+2 ' ' 'Input ' 'Input database file' i",
  "-O 1 0 1 1 0 1 52x1+0+3 ' ' 'Output' 'Output Database Filename' o",
  "-E",
  "-s 1 0 1 0 0 52x1+0+4.5 ' ' 'Toolbox ' 'Change the cms databases for a whole toolbox' tb",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MIGRATION/objects/kroutine/dbcnvrt/uis/dbcnvrt.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


