 /*
  * Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 19:33:49 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.16.2.2 1997/05/31 19:33:49 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kdarwin.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kdarwin_get_args
| 
|       Purpose: Gets command line args for kdarwin
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kdarwin
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kdarwin_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kdarwin is out of sync with arguments specified in kdarwin's *.pane file; please rerun ghostwriter on kdarwin.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kdarwin structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "lname",
			  &(clui_info->lname_string),
			  &(clui_info->lname_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "cat",
			  &(clui_info->cat_string),
			  &(clui_info->cat_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "subcat",
			  &(clui_info->subcat_string),
			  &(clui_info->subcat_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "description",
			  &(clui_info->description_string),
			  &(clui_info->description_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "icon",
			  &(clui_info->icon_string),
			  &(clui_info->icon_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "prog",
			  &(clui_info->prog_file),
			  &(clui_info->prog_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "pane",
			  &(clui_info->pane_file),
			  &(clui_info->pane_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "conf",
			  &(clui_info->conf_file),
			  &(clui_info->conf_flag))))
	{
	    kerror(NULL, "kdarwin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +8+0 'A program to evolve Khoros 1.0 programs to Khoros 2 objects' subform",
  "-P 1 0 52.75x16.1818+0+1 +0+0 ' ' kdarwin",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MIGRATIONBIN/kdarwin",
  "-H 1  5x1+41+0 'Help' 'man page for absolute value' $MIGRATION/objects/kroutine/kdarwin/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 0 1 0 50x1+1+8.5 ' ' 'Toolbox' 'Toolbox object to hold the new software object' tb",
  "-s 1 0 0 1 0 50x1+1+9.5 ' ' 'Object Name' 'Software object name to use the for the converted vroutine' oname",
  "-s 1 0 1 0 0 50x1+1+10.5 ' ' 'Library Name' 'Library object to put the vroutine l*.c file into' lname",
  "-s 1 0 0 1 0 50x1+1+11.5 ' ' 'Category' 'Category Name used in Cantata' cat",
  "-s 1 0 0 1 0 50x1+1+12.5 ' ' 'Subcategory' 'Subcategory Name used in Cantata' subcat",
  "-s 1 0 0 1 0 50x1+1+13.5 ' ' 'Description' 'The short description of the object' description",
  "-s 1 0 0 1 0 49.75x1+1+14.5 ' ' 'Icon Name' 'Icon Name used for glyph in Cantata' icon",
  "-C 1",
  "-B 0",
  "-I 1 0 1 1 0 1 51x1+0+3 ' ' 'Prog Filename' 'Khoros 1.0 Prog filename to get program code and documentation information from' prog",
  "-I 1 0 1 1 0 1 51x1+0+4 ' ' 'Pane Filename' 'Khoros 1.0 Pane Filename to get program uis information from' pane",
  "-E",
  "-I 1 0 1 0 0 1 51x1+0+6 ' ' 'Conf Filename' 'Khoros 1.0 conf filename to use to get paths for *.pane and *.prog' conf",
  "-E",
  "-b +24+5 'Or' blank1",
  "-b +14+1 'Input 1.0 routine information' blank2",
  "-b +14+7.5 'Output 2.1 routine information' blank3",
  "-b +21+2 'Enter from' blank4",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MIGRATION/objects/kroutine/kdarwin/uis/kdarwin.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	30,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


