 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:35:00 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 19:35:00 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "mkproto.h"
/*-----------------------------------------------------------
| 
|  Routine Name: mkproto_get_args
| 
|       Purpose: Gets command line args for mkproto
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname mkproto
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void mkproto_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for mkproto is out of sync with arguments specified in mkproto's *.pane file; please rerun ghostwriter on mkproto.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the mkproto structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_logical(pane, "n",
			  &(clui_info->n_logic),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "mkproto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "s",
			  &(clui_info->s_logic),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "mkproto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "v",
			  &(clui_info->v_logic),
			  &(clui_info->v_flag))))
	{
	    kerror(NULL, "mkproto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "d",
			  &(clui_info->d_logic),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "mkproto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "p",
			  &(clui_info->p_logic),
			  &(clui_info->p_flag))))
	{
	    kerror(NULL, "mkproto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "h",
			  &(clui_info->h_logic),
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "mkproto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "mkproto_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Program Name:  Short description of program' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' mkproto",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MIGRATIONBIN/mkproto",
  "-H 1  5x1+41+0 'Help' 'man page for absolute value' $MIGRATION/objects/kroutine/mkproto/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-l 1 0 1 0 0 50x1+1+1.5 0 'Put line numbers of declarations as comments           ' 'False' 'True' 'put line numbers of declarations as comments' n",
  "-l 1 0 1 0 0 50x1+1+2.5 0 'Include declarations for static functions              ' 'False' 'True' 'include declarations for static functions' s",
  "-l 1 0 1 0 0 50x1+1+3.5 0 'Include variable name in declaration                   ' 'False' 'True' 'include variable name in declaration' v",
  "-l 1 0 1 0 0 50x1+1+4.5 0 'Include declaration for the PROTO() definition         ' 'False' 'True' 'include declaration for the PROTO() definition' d",
  "-l 1 0 1 0 0 50x1+1+5.5 1 'Do not make header files readable by non-ANSI compiler ' 'False' 'True' 'do not make header files readable by non-ANSI compiler' p",
  "-l 1 0 1 0 0 50x1+1+6.5 1 'Do file headers                                        ' 'False' 'True' 'do file headers' h",
  "-I 1 0 1 0 0 1 50x1+1+7.5 ' ' 'Input File' 'input file' i",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MIGRATION/objects/kroutine/mkproto/uis/mkproto.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


