eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: kclrgetargs - 
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: kclrgetargs.pl,v 1.5.2.4 1997/05/31 16:12:13 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
if ( ! defined $ENV{'HOME'})
{
   die "The HOME environment variable must be set.\n";
}
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis = '';
@clui_args  = (
        'tb',     'toolbox',      'name of toolbox',
        'oname',  'object-name',  'name of software object',
        '[rgw]',  '',  'Run ghostwriter after clearing the get args section',
        '[warning]',  '',  'Warn user about potential loss'
);

# initialize Khoros perl lib
&khoros'initialize("MIGRATION",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

# ------------------------------------------------------------------------
# Put your code here
# ------------------------------------------------------------------------

$tb_str = $khoros'argval{"tb"}; #'
$oname_str = $khoros'argval{"oname"}; #'
$opt_rgw = $khoros'seenswitch{'rgw'}; #'
$opt_warn = $khoros'seenswitch{'warning'}; #'

$TOOLBOX = "\U$tb_str";
$HOME = $ENV{'HOME'};
$warning_file = "$HOME/.Khoros/stop_migration_warning";

if ( $opt_warn && ! -f "$warning_file" )
{
   warn "\n\nWarning! About to clear the -main_get_args_call section of the\n";
   warn "$oname_str software object in the $TOOLBOX toolbox.  Normally,\n";
   warn "this section is auto generated by Khoros code generators, and is\n";
   warn "never changed by the user.  However, if you have changed this\n";
   warn "section, you should abort this program right now.\n";
   print STDERR "\nDo you want to continue? (Y/N) [N] ";
   chop( $ans = <STDIN> );
   exit 0 unless ( $ans =~ m/^\s*[Yy]/ );
   warn "\nDo you want me to skip this prompt for the rest of the \n";
   print STDERR "objects in this migration run? (Y/N) [N]  ";
   chop( $ans = <STDIN> );
   if ( $ans =~ m/^\s*[Yy]/ )
   {
      open(STOP_WARN, "> $warning_file") || die "Cannot open $warning_file";
      close(STOP_WARN);
   }
   warn "Continuing...\n";
}

chop($opath = `kecho -tb $tb_str -oname $oname_str -echo path 2>&1`);
die "Cannot open object '$oname_str' in toolbox '$TOOLBOX'\n" if $? != 0;

chop($otype = `kecho -tb $tb_str -oname $oname_str -echo type 2>&1`);
die "Cannot get type of object '$oname_str' in toolbox '$TOOLBOX'\n" if $? != 0;

exit 0 if $otype ne "kroutine" && $otype ne "xvroutine";

$file = "$opath/src/$oname_str";
$filename = "$file.c" if -f "$file.c";
$filename = "$file.C" if -f "$file.C";
die "Cannot find a $file.c or $file.C for object '$oname_str'\n" if ! -f "$file.c" || -f "$file.C";

open(GMAIN, "< $filename") ||
   die "Cannot open $filename for object '$oname_str'\n";
open(NGMAIN, "> $filename.new") ||
   die "Cannot open $filename.new for object '$oname_str'\n";
$skipping = 0;
while (<GMAIN>)
{
   $skipping = 0 if (m#^\s*/\* -main_get_args_call_end \*/\s*$#);
   print NGMAIN "$_" if ! $skipping;
   $skipping = 1 if (m#^\s*/\* -main_get_args_call \*/\s*$#);
}
close(GMAIN);
close(NGMAIN);
(unlink($filename) && rename("$filename.new", $filename)) ||
   die "Cannot create the new $filename\n";
print STDERR "The -main_get_args_call section of $oname_str has been cleared\n";

$out = `ghostwriter -tb $TOOLBOX -oname $oname_str -force` if $opt_rgw;
exit 0;
