#=========================================================================
# This file contains a table, where each line contains directions
# on how to execute commands to convert from an older version of Khoros
# to a newer version of Khoros.  The first column is the version you
# should be at currently before applying the migration program.  The section
# column is the version you should be at after applying the command.
# The third column is a list of objects to apply the migration program to
# '*' stands for run on all toolbox objects, '*::*' stands for run on all
# objects in all toolboxes, 'tb1,tb2::*' stands for run on all objects
# in toolboxes tb1 and tb2, '*::obj1,obj2' stands for run on all objects
# called obj1 and obj2 in any toolbox, 'tb1,tb2' stands for run on toolbox
# objects tb1 and tb2, and 'tb1,tb2::obj1,obj2' stands for run on objects
# obj1 and obj2 in both toolboxes tb1 and tb2.  The fourth column is
# the command to run, followed by the commandline arguments.  It will
# substitute the toolbox name for %tbname%, the object name for %oname%,
# and the object type for %type%.  Any line beginning with a '#' is ignored
# assumed to be a comment.
#=========================================================================
#-- Run these programs in order to upgrade from 2.0.1 to 2.0.2
2.0.1	2.0.2	*		kuptbdef -tb %tbname%
2.0.1	2.0.2	*		ktbupdb -tb %tbname%
2.0.1	2.0.2	*		kmigimake -tb %tbname%
2.0.1	2.0.2	*		ksetpaneobj -tb %tbname%
#-- Run these programs in order to upgrade from 2.0.2 to 2.0.3
2.0.2	2.0.3	*		kuptbdef2 -tb %tbname%
2.0.2	2.0.3	*		runcommand -tb %tbname% -allsrc -cmd "ksedsrc__-nosave__-filename__%fname%__-cfile__$MIGRATION/objects/script/ksedsrc/misc/202to203.con"
2.0.2	2.0.3	*		runcommand -tb %tbname% -examples -testsuite -cmd "krmenvp"
#-- Run these programs in order to upgrade from 2.0.3 to 2.0.4
2.0.3	2.0.4	*		runcommand -tb %tbname% -allsrc -cmd "ksedsrc__-nosave__-filename__%fname%__-cfile__$MIGRATION/objects/script/ksedsrc/misc/203to210.con"
#-- Run these programs in order to upgrade from 2.1.0 to 2.2.0
2.1.0	2.2.0	*::*		kclrgetargs -tb %tbname% -oname %oname% -warning
2.1.0	2.2.0	*		kfixdeps -tb %tbname%
2.1.0	2.2.0	*		runcommand -tb %tbname% -allsrc -cmd "ksedsrc__-nosave__-filename__%fname%__-cfile__$MIGRATION/objects/script/ksedsrc/misc/210to220.con"
2.1.0	2.2.0	*		runcommand -tb %tbname% -objects -testsuite -examples -Imakefile -cmd "kgenimake__-recreate__;__make__GenImakefiles"
2.1.0	2.2.0	*		runcommand -tb %tbname% -objects -cmd "make__gw"
2.1.0	2.2.0	*		runcommand -tb %tbname% -objects -cmd "make__gui"
2.1.0	2.2.0	*		/bin/rm -f %home%/.Khoros/stop_migration_warning
