eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: kmigrate - Update Objects from one revision to the next
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: kmigrate.pl,v 1.11.2.2 1997/05/24 20:31:15 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
if ( ! defined $ENV{'HOME'})
{
   die "The HOME environment variable must be set.\n";
}
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

#-- Command line arguments
$whatis = 'Update Toolboxes and Objects from one revision to the next';
@clui_args  = (
        '[tb]',     'toolbox',      'name of toolbox',
	'[i]',      'itbl',         'input table',
	'[verbose]', '',	    'Print verbose output',
);

#-- initialize Khoros perl lib
&khoros'initialize("MIGRATION",$whatis,@clui_args); #'

&khoros'parse_args(@ARGV);                   # parse the command-line '

#-- End of Template Code
$allprint = 0;
$allprint = 1 if $khoros'seenswitch{'verbose'}; #'

#-- make sure this points to toolbox kmigrate is currently in
$curtb = "MIGRATION";
@toolboxes = &khoros'get_toolbox_list(); #'

$curtbpath = &khoros'toolbox_path("$curtb"); #'
$table_path = "$curtbpath/objects/script/kmigrate/misc/migrate.cmd";
$table_path = $khoros'argval{'i'} if $khoros'seenswitch{'i'};

die "Cannot open table file '$table_path\n" unless -r $table_path;

#-- Sort lines into correct order to apply patch (sorted by old version value).
@datacom = split(/\n/, `cat $table_path`);
die "Cannot open table file '$table_path\n" if ($? != 0);
@data = grep(!/^#/, @datacom);
$i=0;
foreach (@data)
{
   push(@datakeys, (split(/[\t ]/))[0]);
   push(@datakeys2, $i);
   $i++;
}
@miglines = @data[sort byoldver $[..$#data];

#-- Now split line into component parts
foreach (@miglines)
{
   ($oldver, $newver, $objlist, $cmd, @rest) = (split(/[\t ]+/));
   $cmd1 = &myfullpath($cmd);
   $cmd2 = join(' ', @rest);
   $command = "$cmd1 $cmd2";
   push(@oldvers, $oldver);
   push(@newvers, $newver);
   push(@objlists, $objlist);
   push(@commands, $command);
}

#-- Use migration toolbox version to indicate the current Khoros version
chop ($curver = `kecho -tb migration -echo version`);
die "Cannot get current version of Khoros\n" if ($? != 0 || (! $curver));
push(@oldvers, $oldver);
push(@oldvers, $oldver);
push(@newvers, $curver);
push(@newvers, $curver);
push(@objlists, "*");
push(@objlists, "*::*");
push(@commands, "kset -tb %tbname% -version %curver%");
push(@commands, "kset -tb %tbname% -oname %oname% -version %curver%");
$i=0;
foreach $oldver (@oldvers)
{
   $alltbs = 0;
   $allobjs = 0;
   $anyobjs = 0;
   $newver = $newvers[$i];
   $objlist = $objlists[$i];
   ($tbstr, $objstr) = split(/::/, $objlist);
   $alltbs = 1 if $tbstr =~ /^\*$/;
   $allobjs = 1 if $objstr =~ /^\*$/;
   $anyobjs = 1 if $objstr =~ /.+/;
   ($commandname, @rest) = split(/[ \t]+/, $commands[$i]);
   $commandname =~ s/(.*\/)?(.+)/$2/;
   @toolop = $alltbs == 1 ? @toolboxes : split(/,/, $tbstr);
   print "Checking for objects to update to '$curver' with command '$commandname'\n";
   foreach $tbname (@toolop)
   {
      $toolbox = "\L$tbname";
      $TOOLBOX = "\U$tbname";
      next unless (grep(/^$TOOLBOX$/i, @toolboxes));
      $tbpath  = $khoros'toolboxPath{$TOOLBOX}; #'
      chop($tbver = `kecho -tb $TOOLBOX -echo version`);
      if ($? != 0 || ( ! $tbver))
      {
	 print "Cannot get version for toolbox '$TOOLBOX'\n";
         next;
      }
      if ( $anyobjs == 0 && (&verval($curver) == &verval($tbver)))
      {
         print "Toolbox '$TOOLBOX' is up to date.  Skipping....\n" if $allprint == 1;
         next;
      }
      elsif ( $anyobjs == 0 && (&verval($newver) <= &verval($tbver)) )
      {
         print "Toolbox '$TOOLBOX' is already at or greater than '$newver'.  Skipping....\n" if $allprint == 1;
         next;
      }
#-- Handle each sub-object in the toolbox as per the user's request
      elsif  ( $anyobjs == 1)
      {
	 @onames = split(/\s/, `kecho -tb $tbname -echo objects`);
         if ($? != 0 )
         {
	    print "Cannot get a list of object names for toolbox '$TOOLBOX'\n";
            next;
         }
         @onameop = $allobjs == 1 ? @onames : split(/,/, $objstr);
	 $checkit = 1;
	 foreach $oname (@onameop)
	 {
	    next unless (grep(/^$oname$/, @onames));
	    chop($over = `kecho -tb $tbname -oname $oname -echo version`);
            if ($? != 0 || (! $over))
            {
	       print "Cannot get version for oname '$oname'\n";
	       next;
            }
	    if (&verval($curver) == &verval($over))
	    {
	       print "Object '$oname' is up to date.  Skipping....\n" if $allprint == 1;
	       next;
	    }
	    if (&verval($newver) <= &verval($over))
	    {
	       print "Object '$oname' is already version '$newver'.  Skipping....\n" if $allprint == 1;
	    }
	    if ($checkit == 1)
	    {
	       print "Checking for objects to update to '$curver' in toolbox '$TOOLBOX'\n";
	       $checkit = 0;
	    }
	    print "Object '$oname' is at version '$over'.  Updating....\n";
	    $command = $commands[$i];
	    $command =~ s/%tbname%/$toolbox/g;
	    $command =~ s/%oname%/$oname/g;
	    $command =~ s/%curver%/$curver/g;
	    $command =~ s/%home%/$HOME/g;
	    print "$command\n" if ($allprint == 1);
#	    $retval = 0;
            $retval = system($command);
	    if ($retval != 0)
	    {
	       print "Cannot run command '$command' on object '$oname'\n";
	       next;
	    }
	 }
	 next;
      }
      print "Toolbox '$TOOLBOX' is at version '$tbver'.  Updating....\n";
      $command = &myfullpath($commands[$i]); #'
      $command =~ s/%tbname%/$toolbox/g;
      $command =~ s/%curver%/$curver/g;
      $command =~ s/%home%/$HOME/g;
      print "$command\n" if ($allprint == 1); 
#      $retval = 0;
      $retval = system($command);
      if ($retval != 0)
      {
	 print "Cannot run command '$command' on toolbox '$tbname'\n";
	 next;
      }
   }
   $i++;
}

# ========================================================================
# Routine Name: byoldver - sort compare function for old version
#
# Purpose:      This function takes is used directly by the sort
#		routine to determine the ordering of the lines in
#		the migration table.  It sorts first by old version,
#		then by order of appearence in the file.
# ========================================================================
sub byoldver
{
   if (&verval($datakeys[$a]) ==  &verval($datakeys[$b]))
   {
      $datakeys2[$a] <=> $datakeys2[$b];
   }
   else
   {
      &verval($datakeys[$a]) <=> &verval($datakeys[$b]);
   }
}

# ========================================================================
# Routine Name: verval - convert a version string into a numerical value
#
# Purpose:      This function turns a 2.x.xx.xx string into a integer
#		2xxxxx, so it can be use in integer comparison.  If the
#		user leaves off parts of the number (eg 2.0 instead of
#		2.0.0.0) it will insert 0's as necessary.
#
# Input:        toolbox - name of the toolbox.
# ========================================================================
sub verval
{
   local($inver) = @_;
   $inver =~ s/\.//g;
   while ($inver < 200000)
   {
      $inver = $inver * 10;
   }
   $inver;
}

# ========================================================================
# Function:	fullpath()
#
# Purpose:	Resolve a path, expanding out any leading toolbox references.
# ========================================================================
sub myfullpath
{
   local($path) = @_;
   local($toolbox);

   print STDERR "Expanding: $path\n" if $verbose;
   if ($path =~ m!(.*)\$([^/]+)/(.*)$!)
   {
      $toolbox = "\U$2";
      $path = $1.&khoros'toolbox_path("$toolbox")."/$3"; #'
   }

   return $path;
}

