eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: krmenvp - removes use of envp[] from example programs
#
#      Purpose:	Update example programs for POSIX compliance between K2.0.2
#		and K2.1; example programs that used envp[] are not POSIX
#		compliant and need to have the references to envp[] removed.
#		argument to the main
#       Author:	Danielle Argiro
# RCS ID:	Khoros: $Id: krmenvp.pl,v 1.8.2.1 1997/03/17 22:43:15 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
if ( ! defined $ENV{'HOME'})
{
   die "The HOME environment variable must be set.\n";
}
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";
require "find.pl";

$whatis = 'removes use of envp[] from example programs';
@clui_args  = ();

# initialize Khoros perl lib
&khoros'initialize("MIGRATION",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

# ------------------------------------------------------------------------
# Here's the main program
# ------------------------------------------------------------------------

# Just do a recursive find on the current directory.. The routine wanted
# does all the work.  It determines whether or not the file is an
# example.c or test.c file, and if so it updates it.
&find('.');

sub wanted
{
   # First three lines find an example.c or test.c that is a normal file
   # The do block is the guts of krmenvp.
   ( /^example\.c$/ || /^test\.c/ ) &&
   ($nlink || (($dev,$ino,$mode,$nlink,$uid,$gid) = lstat($_))) &&
   -f $_ && do
   {
      # You only get here if the file is an example or testsuite source
      # file, and it is a normal file.
      $infile = $_;
      open(FILE, "< $infile") || do
      {
	 warn "Cannot open $infile... Continuing to the next file\n";
	 return;
      };
      $outfile = "$infile.new";
      open(OUTFILE, "> $outfile") || do
      {
	 close(FILE);
	 warn "Cannot open $outfile... Continuing to the next file\n";
	 return;
      };
      while (<FILE>)  # read each line in the text file into $_
      {
         # match incoming "char *argv[]" and replace the comma with a paren
         s/(\s*char\s+\*argv\[\]),/$1)/;

         # match incoming "char **argv" and replace the comma with a paren
         s/(\s*char\s+\*\*argv),/$1)/;

         # substitute nothing for "envp," in
         # khoros_initialize(argc, argv, envp, "DESIGN");
         s/envp,\s*//;

         # write line to output, unless it's the unwanted 
	 # "char *envp[])" or "char **envp" line
         print(OUTFILE  $_) unless (/\s*char\s+\*envp\[\]\)/ ||
				    /\s*char\s+\*\*envp\)/);
      }
      close(FILE);
      close(OUTFILE);
      $mode = (stat($infile))[2];
      chmod $mode, $outfile;
      rename($outfile, $infile);
   };
}
