eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: convert_kfree - Convert kfree calls to kfree_and_NULL calls
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: ksedsrc.pl,v 1.6.2.2 1997/04/14 22:06:54 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
if ( ! defined $ENV{'HOME'})
{
   die "The HOME environment variable must be set.\n";
}
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis = 'Convert source code files in a sed like fashion';
@clui_args  = (
      'filename', 'filename', 'source code file with kfree calls to convert',
      '[nosave]',  '',  'do not create a .sav file',
      'cfile', 'cfile', 'Filename to get conversion strings from'
);

# initialize Khoros perl lib
&khoros'initialize("MIGRATION",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

$filename = $khoros'argval{"filename"}; #'
$cfilename = $khoros'argval{"cfile"}; #'
$savfile = "$filename.sav";
die "   Cannot open conversion string file '$cfilename'\n" unless -r "$cfilename";
@cons = split(/\n/, `cat $cfilename`);

rename($filename, $savfile) || die "   Cannot rename file $filename to $savfile\n";

open ( OLD, "< $savfile") || die "   Cannot open file $savfile for reading";
open ( NEW, "> $filename") || die "   Cannot open file $filename for writing";

while (<OLD>)
{
   
   foreach $conversion (@cons)
   {
      next if $conversion =~ m/^\s*#/;
      next if $conversion =~ m/^\s*$/;
      eval $conversion;
   };
   print NEW "$_";
};
close OLD;
close NEW;

$mode = (stat($savfile))[2];
chmod $mode, $filename;
unlink("$savfile") if ($khoros'seenswitch{"nosave"}); # ')

exit 0;


