eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: ksetpaneobj - no short description specified
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: ksetpaneobj.pl,v 1.8.2.1 1997/03/17 22:43:19 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
if ( ! defined $ENV{'HOME'})
{
   die "The HOME environment variable must be set.\n";
}
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis = 'set associated object for pane object(s)';
@clui_args  = (
        '[tb]',     'toolbox',      'name of toolbox',
        '[oname]',  'object-name',  'name of software object'
);

# initialize Khoros perl lib
&khoros'initialize("MIGRATION",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

# ------------------------------------------------------------------------
# Put your code here
# ------------------------------------------------------------------------

if ($khoros'seenswitch{'tb'} && $khoros'seenswitch{'oname'})
{
   &SetPaneObject($khoros'argval{'tb'}, $khoros'argval{'oname'});
   exit 0;
}

@toolboxes = &khoros'get_toolbox_list();
foreach $toolbox (@toolboxes)
{
   print STDERR "Toolbox: $toolbox\n";
   chop($objlist = `kecho -tb $toolbox -type pane -echo objects`);
   foreach $object (split(/\s+/, $objlist))
   {
      &SetPaneObject($toolbox, $object);
   }
}

sub SetPaneObject
{
   local($toolbox, $object) = @_;
   local($TOOLBOX);
   local($tbpath);
   local($filepath);
   local(*PANE);


   print STDERR "    Object: $object\n";
   $TOOLBOX = "\U$toolbox";
   $tbpath  = $khoros'toolboxPath{$TOOLBOX};
   $filepath = "$tbpath/objects/pane/$object/uis/$object.pane";
   unless (-f $filepath)
   {
      warn "\tpane file for $TOOLBOX::$object not found ($filepath)\n";
      return;
   }

   open(PANE, "< $filepath") || do
   {
      warn "\tunable to read pane for $TOOLBOX::$object ($filepath)\n";
      return;
   };

   while (<PANE>)
   {
      if (/^\s*-R\s+\d\s+\d\s+\d\s+\S+\s+'[^']+'\s+'[^']+'\s+(.*)/)
      {
         $cmd = $1;
         if ($cmd =~ /\$([A-Z]+)BIN\/(\S+)\s*(.*)$/)
         {
            $atb = $1;
            $aoname = $2;
            $aargs = $3;
            print STDERR "\tAssociated Toolbox: $atb\n";
            print STDERR "\tAssociated Object:  $aoname\n";
            print STDERR "\tAssociated Args:    $aargs\n";
            system("kset -tb $toolbox -oname $object -atb $atb -aoname $aoname -aargs \"$aargs\" 2>&1 | sed -e 's/^/\t/'");
         }
         last;
      }
   }
   close PANE;
}
