eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: kuptbdef - no short description specified
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: kuptbdef.pl,v 1.8.2.1 1997/03/17 22:43:21 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
if ( ! defined $ENV{'HOME'})
{
   die "The HOME environment variable must be set.\n";
}
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end
@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis = 'update toolbox.def imake config file';
@clui_args  = (
        '[tb]',    'toolbox',  'name of toolbox',
        '[f]',     '',         'force overwrite of toolbox.def'
);

# initialize Khoros perl lib
&khoros'initialize("MIGRATION",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

# ------------------------------------------------------------------------
# Put your code here
# ------------------------------------------------------------------------

unless (defined $khoros'toolboxPath{'BOOTSTRAP'})
{
   die "Can't determine path to BOOTSTRAP toolbox\n"
}
$bootpath = $khoros'toolboxPath{'BOOTSTRAP'};
# $bootpath = '/research/data/khoros_test/bootstrap';

@toolboxes = &khoros'get_toolbox_list();
print "ALL TOOLBOXES: @toolboxes\n";

foreach $toolbox (@toolboxes)
{
   &UpdateImakeConfig($toolbox);
   print STDERR "\n";
}

#========================================================================
#
#========================================================================
sub UpdateImakeConfig
{
   local($toolbox) = @_;
   local($TOOLBOX);
   local($tbpath);
   local(*OLD, *NEW, *TEMPLATE);
   local($filename);
   local($line);
   local(@deptbs);


   print STDERR "Toolbox: $toolbox\n";
   $TOOLBOX = "\U$toolbox";
   $toolbox = "\L$toolbox";
   $tbpath = $khoros'toolboxPath{$TOOLBOX}; # '

   if (-f "$tbpath/repos/config/imake_config/toolbox.def"
       && !$khoros'seenswitch{'f'})
   {
      print STDERR "    toolbox already has toolbox.def -- won't overwrite it\n";
      return;
   }

   #------------------------------------------------------------------------
   # first we parse the information we want out of the existing imake config
   #------------------------------------------------------------------------
   $filename = "$tbpath/repos/config/imake_config/$toolbox.def";
   open(OLD, "< $filename") || do
   {
      warn "    Could not read old imake config file:\n\t$filename\n";
      return;
   };
   undef $line;
   while (<OLD>)
   {
      $_ = $line.$_;
      # escaped newline, suck in next line.
      if (/\\$/)
      {
         ($line = $_) =~ s/\\$//;
         next;
      }

      s/\n./ /g;

      push(@deptbs, $1) if /^\s*#\s*include\s+<(.*)\.def>/;

      @libs = &GetLibs($1) if /^\s*TOOLBOX_LIBRARIES\s*=\s*(.*)/;
      @flibs = &GetLibs($1) if /^\s*FOR_TOOLBOX_LIBRARIES\s*=\s*(.*)/;
      @xlibs = &GetLibs($1) if /^\s*X_TOOLBOX_LIBRARIES\s*=\s*(.*)/;

      undef $line;
   }
   close;


   #------------------------------------------------------------------------
   # first we parse the information we want out of the existing imake config
   #------------------------------------------------------------------------
   $filename = "$tbpath/repos/config/imake_config/toolbox.def";
   open(NEW, "> $filename") || do
   {
      warn "    Could not write new imake config file:\n\t$filename\n";
      return;
   };

   $filename = "$bootpath/objects/library/kcms/templates/toolbox/toolbox.def";
   open(TEMPLATE, "< $filename") || do
   {
      warn "    Could not read new imake config template:\n\t$filename\n";
      close NEW;
      return;
   };

   while (<TEMPLATE>)
   {
      s/#TOOLBOX-NAME#/$TOOLBOX/g;
      s/#toolbox-name#/$toolbox/g;

      /^#include DESIGN_INCLUDE/ && do
      {
         unless (grep(/design/i, @deptbs))
         {
            if (grep(/dataserv/i, @deptbs))
            {
               print NEW "#include DATASERV_INCLUDE\n";
               next;
            }
            if (grep(/bootstrap/i, @deptbs))
            {
               print NEW "#include BOOTSTRAP_INCLUDE\n";
               next;
            }

            warn "UNEXPECTED ERROR: dependent toolboxes are: @deptbs\n";
         }
      };

      print NEW;

      if (/-toolbox_libraries /)
      {
         foreach $library (@libs) {
            print NEW "AddLibrary($library, C, \$(${TOOLBOX}_NAME)/lib)\n";
         }
         foreach $library (@flibs) {
            print NEW "AddLibrary($library, FOR, \$(${TOOLBOX}_NAME)/lib)\n";
         }
         foreach $library (@xlibs) {
            print NEW "AddLibrary($library, X, \$(${TOOLBOX}_NAME)/lib)\n";
         }
      }
   }
   close TEMPLATE;
   close NEW;
}

sub GetLibs
{
   local($libline) = @_;
   local($item);

   @matchlibs = ();
   foreach $item (split(/\s+/, $libline))
   {
      push(@matchlibs, $1) if $item =~ /^\s*-l(\S+)/;
   }
   @matchlibs = reverse @matchlibs;

   return @matchlibs;
}
