eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: runncommand - Run a command on a directory, or certain file types
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: runcommand.pl,v 1.10.2.1 1997/03/17 22:43:25 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
if ( ! defined $ENV{'HOME'})
{
   die "The HOME environment variable must be set.\n";
}
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";
require "find.pl";

$whatis = 'Run a command on a directory, or certain file types';
@clui_args  = (
        'tb',          'toolbox',      'name of toolbox',
        '[oname]',     'object-name',  'name of software object',
	'[cmd]',       'command',      'command to execute on the object',
	'[examples]',  '',             'run command in examples directory',
	'[testsuite]', '',             'run command in testsuitee directory',
	'[objects]',   '',             'run command in testsuitee directory',
	'[Imakefile]', '',	       'run command in directory if an Imakefile exists',
	'[allsrc]',    '',	       'run command on all source code files',
	'[allfiles]',  '',	       'run command on all files'
);

# initialize Khoros perl lib
&khoros'initialize("MIGRATION",$whatis,@clui_args); #'

&khoros'parse_args(@ARGV);                   # parse the command-line '

# ------------------------------------------------------------------------
# Put your code here
# ------------------------------------------------------------------------

@toolboxes = &khoros'get_toolbox_list(); #'
@command = split(/__/,$khoros'argval{"cmd"}); #'

$ecom = $khoros'argval{"cmd"}; #'
$ecom =~ s/__/ /g;

$opt_examples  = 1 if $khoros'seenswitch{'examples'}; #'
$opt_testsuite = 1 if $khoros'seenswitch{'testsuite'}; #'
$opt_objects   = 1 if $khoros'seenswitch{'objects'}; #'
$opt_oname     = 1 if $khoros'seenswitch{'oname'}; #'
$opt_allsrc    = 1 if $khoros'seenswitch{'allsrc'}; #'
$opt_allfiles  = 1 if $khoros'seenswitch{'allfiles'}; #'
$opt_imakefile = 1 if $khoros'seenswitch{'Imakefile'}; #'
$obj_str       = $khoros'argval{"oname"} if $opt_oname; #'
$opt_toolbox   = 1 if ( ! $opt_examples && ! $opt_testsuite &&
			! $opt_objects  && ! $opt_oname);

foreach $tbname (@toolboxes)
{
   $toolbox = "\L$tbname";
   $TOOLBOX = "\U$tbname";

   # Run command on a number of objects in the toolbox
   if ($opt_oname)
   {
      @onames = split(/\s/, `kecho -tb $tbname -echo objects`);
      if ( $? != 0 )
      {
	 print "Cannot get a list of object names for toolbox '$TOOLBOX'\n";
	 next;
      }
      @onameop = split(/,/, $obj_str);
      foreach $oname (@onameop)
      {
         next unless (grep(/^$oname$/, @onames));
	 $path = `kecho -tb $TOOLBOX -oname $oname -echo path`;
	 if ( $? != 0 )
	 {
	    print "Cannot get a path to the object '$oname' in '$TOOLBOX'\n";
	    next;
	 }
         &runcommand($path, $tbname, $oname);
      }
      next;
   }

   # Run command on examples directory
   if ($opt_examples)
   {
      $path = &khoros'toolbox_path("$TOOLBOX")."/examples"; #'
      &runcommand($path, $tbname)
	if -d $path && (! $opt_imakefile || -f "$path/Imakefile");
   }
   # Run command on testsuite directory
   if ($opt_testsuite)
   {
      $path = &khoros'toolbox_path("$TOOLBOX")."/testsuite"; #'
      &runcommand($path, $tbname)
	if -d $path && (! $opt_imakefile || -f "$path/Imakefile");
   }
   # Run command on objects directory
   if ($opt_objects)
   {
      $path = &khoros'toolbox_path("$TOOLBOX")."/objects"; #'
      &runcommand($path, $tbname)
	if -d $path && (! $opt_imakefile || -f "$path/Imakefile");
   }
   # Run command on whole toolbox
   if ($opt_toolbox)
   {
      $path = &khoros'toolbox_path("$TOOLBOX"); #'
      &runcommand($path, $tbname) if -d $path;
   }
}

sub runcommand
{
   local($path, $tbname, $oname) = @_;
   local($cwd);
   chop($cwd = `pwd`);

   $ecom =~ s#%tbname%#$tbname#g;
   $ecom =~ s#%oname%#$oname#g if $opt_oname;
   $ecom =~ s#%fname%#{}#g if $opt_allsrc || $opt_allfiles;
   $necom = &myfullpath($ecom);
   $ecom = $necom;
   print "Running the following command in directory '$path':\n'$ecom'\n";

   chdir $path;
   if ( $opt_allsrc || $opt_allfiles )
   {
      &find($path);
   }
   else
   {
      system $ecom;
   }
   chdir $cwd;
}

sub wanted
{
    ( ( $opt_allfiles && /^.*$/) ||
      ( $opt_allsrc && ( /^.*\.[chCf]$/ ||
			 /^.*\.sh$/ ||
		         /^.*\.csh$/ ||
			 /^.*\.pl$/ ) ) ) &&
    ($nlink || (($dev,$ino,$mode,$nlink,$uid,$gid) = lstat($_))) &&
    -f _ &&
    &exec(0, $ecom);
}

sub exec
{
   local($ok, @cmd) = @_;

   foreach $word (@cmd)
   {
      $word =~ s#{}#$name#g
   }
   if ($ok)
   {
      local($old) = select(STDOUT);
      $| = 1;
      print "@cmd\n";
      select($old);
      return 0 unless <STDIN> =~ /^y/;
   }

   chdir $cwd;		#sigh
   system @cmd;
#   print @cmd, "\n";
   chdir $dir;
   return !$?;
}

# ========================================================================
# Function:	fullpath()
#
# Purpose:	Resolve a path, expanding out any leading toolbox references.
# ========================================================================
sub myfullpath
{
   local($path) = @_;
   local($toolbox);

   print STDERR "Expanding: $path\n" if $verbose;
   if ($path =~ m!(.*)\$([^/]+)/(.*)$!)
   {
      $toolbox = "\U$2";
      $path = $1.&khoros'toolbox_path("$toolbox")."/$3"; #'
   }

   return $path;
}
