/*
 * Khoros: $Id$
 */
 
/*
 * $Log$
 */
 
/*
 * Copyright (C) 1993, 1994, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>       Purpose: Definitions and prototypes for library lmmach
   >>>>
   >>>>       Toolbox: $MMACH
   >>>>
   >>>>    Written By: Your name goes here!
   >>>>
   >>>>          Date: 
   >>>>
   >>>> Modifications:
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#ifndef _lmmach_h_
#define _lmmach_h_


	/*-------------------------------------*
	|       #include
	---------------------------------------*/
#include "mat_str.h"
#include "vec_str.h"
	/*-------------------------------------*
	|       #defines
	---------------------------------------*/


	/*-------------------------------------*
	|       typedefs
	---------------------------------------*/


	/*-------------------------------------*
	|       global variable declarations
	---------------------------------------*/

/* Queue structures */

typedef struct {
  int address;
} item_str;

typedef struct cell {
  item_str item;
  struct cell *next;
} cell_str;

typedef struct {
  cell_str *first;
  cell_str *last;
} queue_str;

	/*-------------------------------------*
	|       macros
	---------------------------------------*/


	/*-------------------------------------*
	|       routine definitions
	---------------------------------------*/


int gen_const PROTO(( xvimage **, int , int , int , int , float , float ));
int read_str PROTO((char *, mat_str *));
int write_str PROTO((char *, mat_str *));
int copyimagedata1 PROTO((xvimage *, xvimage *));
int setimage PROTO((xvimage *));
int clearimage PROTO((xvimage *));
xvimage *format PROTO((xvimage *, unsigned long *));
void unformat PROTO((xvimage *, xvimage *));
void queue_init PROTO((queue_str *));
int queue_empty PROTO((queue_str *));
void queue_add PROTO((queue_str *, item_str *));
int queue_first PROTO((queue_str *, item_str *));

	/* Ghostwriter Prototypes:  Do Not Erase This Comment */

int lvthreshad PROTO((xvimage *img1, xvimage *img2, int i2_flg, int l, xvimage *img3, int i3_flg, int u, xvimage *img4, int mflg, xvimage *img5));

int lvncdil PROTO((xvimage *img1, xvimage *img2, mat_str *b, int n, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvhomot PROTO((xvimage *img1, xvimage *img2, mat_str *b, xvimage *img3, int mflg, xvimage *img4));

int lvclosrec PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvclosrec PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvsmooth PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, mat_str *b3, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvskthinm PROTO((xvimage *img1, mat_str *b1, mat_str *b2, mat_str *b3, mat_str *b4, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvncthin PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int n, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncthick PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int n, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcthin PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcthick PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcskthin PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcskthick PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvthreshad PROTO((xvimage *img1, xvimage *img2, int i2_flg, int l, xvimage *img3, int i3_flg, int u, xvimage *img4, int mflg, xvimage *img5));

int lvncanon PROTO((xvimage *img1, mat_str *b1, mat_str *b2, int r, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvncanond PROTO((xvimage *img1, mat_str *b1, mat_str *b2, int r, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvgdisk  PROTO((       mat_str  *ker,       int      d,       int      type,       int      offset,       int      dim,       char     *met));

int lvstrset  PROTO((mat_str *ker, int s00, int s10, int s20, int s01, int s11, int s21, int s02, int s12, int s22));

int lvbisset PROTO((xvimage *img1, mat_str *b, int n, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvgradm PROTO((xvimage *img1, mat_str *b, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvsup PROTO((xvimage *img1, xvimage *img2, int img2_flg, int c, xvimage *img3, int mflg, xvimage *img4));

int lvsimdif PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int mflg, xvimage *img4));

int lvinv PROTO((xvimage *img1, xvimage *img2, int mflg, xvimage *img3));

int lvinf PROTO((xvimage *img1, xvimage *img2, int img2_flg, int c, xvimage *img3, int mflg, xvimage *img4));

int lvminf PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int i3_flg, xvimage *img4, int i4_flg, xvimage *img5, int i5_flg, xvimage *img6, int i6_flg, xvimage *img7, int mflg, xvimage *img8));

int lvhomot PROTO((xvimage *img1, xvimage *img2, mat_str *b, xvimage *img3, int mflg, xvimage *img4));

int lvnocofilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvncofilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvncocfilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvcenter PROTO((xvimage *img1, mat_str *b, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvwind PROTO((xvimage *img1, long unsigned int border));

int lvncero PROTO((xvimage *img1, xvimage *img2, mat_str *b, int n, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncdil PROTO((xvimage *img1, xvimage *img2, mat_str *b, int n, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvlabelexp PROTO((xvimage *img1, int cv, xvimage *img2));

int lvcero PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcdil PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvclosrec PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvsup PROTO((xvimage *img1, xvimage *img2, int img2_flg, int c, xvimage *img3, int mflg, xvimage *img4));

int lvthreshad PROTO((xvimage *img1, xvimage *img2, int i2_flg, int l, xvimage *img3, int i3_flg, int u, xvimage *img4, int mflg, xvimage *img5));

int lvsimdif PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int mflg, xvimage *img4));

int lvstrset  PROTO((mat_str *ker, int s00, int s10, int s20, int s01, int s11, int s21, int s02, int s12, int s22));

int lvsmooth PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, mat_str *b3, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvskthinm PROTO((xvimage *img1, mat_str *b1, mat_str *b2, mat_str *b3, mat_str *b4, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvncanon PROTO((xvimage *img1, mat_str *b1, mat_str *b2, int r, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvkopen PROTO((xvimage *img1, mat_str *b_mat, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvnocofilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvncofilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvnkopen PROTO((xvimage *img1, mat_str *b, int n, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvinv PROTO((xvimage *img1, xvimage *img2, int mflg, xvimage *img3));

int lvncthin PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int n, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncthick PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int n, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncero PROTO((xvimage *img1, xvimage *img2, mat_str *b, int n, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncdil PROTO((xvimage *img1, xvimage *img2, mat_str *b, int n, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvbisset PROTO((xvimage *img1, mat_str *b, int n, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvnkclose PROTO((xvimage *img1, mat_str *b, int n, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvgradm PROTO((xvimage *img1, mat_str *b, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvlabelexp PROTO((xvimage *img1, int cv, xvimage *img2));

int lvinf PROTO((xvimage *img1, xvimage *img2, int img2_flg, int c, xvimage *img3, int mflg, xvimage *img4));

int lvncanond PROTO((xvimage *img1, mat_str *b1, mat_str *b2, int r, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvwind PROTO((xvimage *img1, long unsigned int border));

int lvmsup PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int i3_flg, xvimage *img4, int i4_flg, xvimage *img5, int i5_flg, xvimage *img6, int i6_flg, xvimage *img7, int mflg, xvimage *img8));

int lvminf PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int i3_flg, xvimage *img4, int i4_flg, xvimage *img5, int i5_flg, xvimage *img6, int i6_flg, xvimage *img7, int mflg, xvimage *img8));

int lvgdisk  PROTO((       mat_str  *ker,       int      d,       int      type,       int      offset,       int      dim,       char     *met));

int lvcthin PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcthick PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcskthin PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcskthick PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcero PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcdil PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncocfilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvnocfilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvkclose PROTO((xvimage *img1, mat_str *b_mat, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvclosrec PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvhomot PROTO((xvimage *img1, xvimage *img2, mat_str *b, xvimage *img3, int mflg, xvimage *img4));

int lvcenter PROTO((xvimage *img1, mat_str *b, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvmsup PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int i3_flg, xvimage *img4, int i4_flg, xvimage *img5, int i5_flg, xvimage *img6, int i6_flg, xvimage *img7, int mflg, xvimage *img8));

int lvmsup PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int i3_flg, xvimage *img4, int i4_flg, xvimage *img5, int i5_flg, xvimage *img6, int i6_flg, xvimage *img7, int mflg, xvimage *img8));

int lvmsup PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int i3_flg, xvimage *img4, int i4_flg, xvimage *img5, int i5_flg, xvimage *img6, int i6_flg, xvimage *img7, int mflg, xvimage *img8));

int lvsup PROTO((xvimage *img1, xvimage *img2, int img2_flg, int c, xvimage *img3, int mflg, xvimage *img4));

int lvthreshad PROTO((xvimage *img1, xvimage *img2, int i2_flg, int l, xvimage *img3, int i3_flg, int u, xvimage *img4, int mflg, xvimage *img5));

int lvsimdif PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int mflg, xvimage *img4));

int lvstrset  PROTO((mat_str *ker, int s00, int s10, int s20, int s01, int s11, int s21, int s02, int s12, int s22));

int lvsmooth PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, mat_str *b3, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvskthinm PROTO((xvimage *img1, mat_str *b1, mat_str *b2, mat_str *b3, mat_str *b4, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvncanon PROTO((xvimage *img1, mat_str *b1, mat_str *b2, int r, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvkopen PROTO((xvimage *img1, mat_str *b_mat, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvnocofilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvncofilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvnkopen PROTO((xvimage *img1, mat_str *b, int n, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvinv PROTO((xvimage *img1, xvimage *img2, int mflg, xvimage *img3));

int lvncthin PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int n, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncthick PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int n, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncero PROTO((xvimage *img1, xvimage *img2, mat_str *b, int n, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncdil PROTO((xvimage *img1, xvimage *img2, mat_str *b, int n, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvbisset PROTO((xvimage *img1, mat_str *b, int n, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvnkclose PROTO((xvimage *img1, mat_str *b, int n, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvgradm PROTO((xvimage *img1, mat_str *b, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvlabelexp PROTO((xvimage *img1, int cv, xvimage *img2));

int lvinf PROTO((xvimage *img1, xvimage *img2, int img2_flg, int c, xvimage *img3, int mflg, xvimage *img4));

int lvncanond PROTO((xvimage *img1, mat_str *b1, mat_str *b2, int r, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvwind PROTO((xvimage *img1, long unsigned int border));

int lvmsup PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int i3_flg, xvimage *img4, int i4_flg, xvimage *img5, int i5_flg, xvimage *img6, int i6_flg, xvimage *img7, int mflg, xvimage *img8));

int lvminf PROTO((xvimage *img1, xvimage *img2, xvimage *img3, int i3_flg, xvimage *img4, int i4_flg, xvimage *img5, int i5_flg, xvimage *img6, int i6_flg, xvimage *img7, int mflg, xvimage *img8));

int lvgdisk  PROTO((       mat_str  *ker,       int      d,       int      type,       int      offset,       int      dim,       char     *met));

int lvcthin PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcthick PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcskthin PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcskthick PROTO((xvimage *img1, xvimage *img2, mat_str *b1, mat_str *b2, int r, int d, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcero PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvcdil PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvncocfilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvnocfilt PROTO((xvimage *img1, mat_str *b, int n, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvkclose PROTO((xvimage *img1, mat_str *b_mat, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvclosrec PROTO((xvimage *img1, xvimage *img2, mat_str *b_mat, xvimage *img3, int mflg, unsigned long border, xvimage *img4));

int lvhomot PROTO((xvimage *img1, xvimage *img2, mat_str *b, xvimage *img3, int mflg, xvimage *img4));

int lvcenter PROTO((xvimage *img1, mat_str *b, int s, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

int lvgdisk  PROTO((       mat_str  *ker,       int      d,       int      type,       int      offset,       int      dim,       char     *met));

int lvskthinm PROTO((xvimage *, mat_str *, mat_str *, mat_str *, mat_str *, xvimage *, int, unsigned long, xvimage *));


int lvdilexpan PROTO((xvimage *, mat_str *, xvimage *, int , int , int , int , int , int, unsigned long, xvimage *));

xvimage *format PROTO(( xvimage *, unsigned long *));
void   unformat PROTO(( xvimage *, xvimage *));

/* tools */
int lvcast1 PROTO((xvimage **, int, int ));
int lvgdisk PROTO((mat_str *, int, int, int, int, char *));
int lvequal PROTO((xvimage *, xvimage *, int, int , int *));
int lvwind PROTO((xvimage *, unsigned long));
int lvrotstr PROTO((mat_str *, int, int , mat_str *));
int lvstrset PROTO((mat_str *, int, int , int , int , int , int , int , int , int ));
int lvless PROTO((xvimage *, int, int , xvimage *, int , int , int *));
int lviff2str PROTO((xvimage *, mat_str *, int));

/* basic */
int lvtoggle PROTO((xvimage *, xvimage *, xvimage *, xvimage *, int, xvimage *));
int lvthreshad PROTO((xvimage *, xvimage *, int, int , xvimage *, int , int , xvimage *, int , xvimage *));
int lvsup PROTO((xvimage *, xvimage *, int, int , xvimage *, int , xvimage *));
int lvsubm PROTO((xvimage *, xvimage *, int, int , xvimage *, int , xvimage *));
int lvinv PROTO((xvimage *, xvimage *, int, xvimage *));
int lvinf PROTO((xvimage *, xvimage *, int, int , xvimage *, int , xvimage *));
int lvero PROTO((xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvdist PROTO((xvimage *, int, xvimage *));
int lvdil PROTO((xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvaddm PROTO((xvimage *, xvimage *, int, int , xvimage *, int , xvimage *));
int lvwatersh PROTO((xvimage *, int, int , xvimage *));
int lvlabelexp PROTO((xvimage *, int, xvimage *));

/* first */
int lvadil PROTO((xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvaero PROTO((xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvkclose PROTO((xvimage *img1, mat_str *b_mat, xvimage *img2, int mflg, unsigned long border, xvimage *img3));
int lvcdil PROTO((xvimage *, xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvcero PROTO((xvimage *, xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvcthick PROTO((xvimage *, xvimage *, mat_str *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvcthin PROTO((xvimage *, xvimage *, mat_str *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvsimdif PROTO((xvimage *, xvimage *, xvimage *, int, xvimage *));
int lvminf PROTO((xvimage *, xvimage *, xvimage *, int, xvimage *, int , xvimage *, int , xvimage *, int , xvimage *, int , xvimage *));
int lvmsup PROTO((xvimage *, xvimage *, xvimage *, int, xvimage *, int , xvimage *, int , xvimage *, int , xvimage *, int , xvimage *));
int lvgradm PROTO((xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage * ));
int lvkopen PROTO((xvimage *img1, mat_str *b_mat, xvimage *img2, int mflg, unsigned long border, xvimage *img3));
int lvsupgen PROTO((xvimage *, mat_str *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvinfgen PROTO((xvimage *, mat_str *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvthick PROTO((xvimage *, mat_str *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvthin PROTO((xvimage *, mat_str *, mat_str *, xvimage *, int, unsigned long, xvimage *));

/* second*/
int lvnthin PROTO((xvimage *, mat_str *, mat_str *, int, int , int , xvimage *, int , unsigned long, xvimage *));
int lvnthick PROTO((xvimage *, mat_str *, mat_str *, int, int , int , xvimage *, int , unsigned long, xvimage *));
int lvnero PROTO((xvimage *, mat_str *, int, xvimage *, int , unsigned long, xvimage *));
int lvndil PROTO((xvimage *, mat_str *, int, xvimage *, int , unsigned long, xvimage *));
int lvncthin PROTO((xvimage *, xvimage *, mat_str *, mat_str *, int, int , int , xvimage *, int , unsigned long, xvimage *));
int lvncthick PROTO((xvimage *, xvimage *, mat_str *, mat_str *, int, int , int , xvimage *, int , unsigned long, xvimage *));
int lvnocofilt PROTO((xvimage *, mat_str *, int, int , xvimage *, int , unsigned long, xvimage *));
int lvnocfilt PROTO((xvimage *, mat_str *, int, int , xvimage *, int , unsigned long, xvimage *));
int lvncofilt PROTO((xvimage *, mat_str *, int, int , xvimage *, int , unsigned long, xvimage *));
int lvncocfilt PROTO((xvimage *, mat_str *, int, int , xvimage *, int , unsigned long, xvimage *));
int lvncero PROTO((xvimage *, xvimage *, mat_str *, int, xvimage *, int , unsigned long, xvimage *));
int lvncdil PROTO((xvimage *, xvimage *, mat_str *, int, xvimage *, int , unsigned long, xvimage *));
int lvncanond PROTO((xvimage *, mat_str *, mat_str *, int, xvimage *, int , unsigned long, xvimage *));
int lvncanon PROTO((xvimage *, mat_str *, mat_str *, int, xvimage *, int , unsigned long, xvimage *));
int lveroseg PROTO((xvimage *, int, int , unsigned long, xvimage *));
int lvdilseg PROTO((xvimage *, int, int , unsigned long, xvimage *));
int lvcloseseg PROTO((xvimage *, int, int , unsigned long, xvimage *));
int lvopenseg PROTO((xvimage *, int, int , unsigned long, xvimage *));
int lvnkclose PROTO((xvimage *img1, mat_str *b, int n, xvimage *img2, int mflg, unsigned long border, xvimage *img3));
int lvnkopen PROTO((xvimage *img1, mat_str *b, int n, xvimage *img2, int mflg, unsigned long border, xvimage *img3));

/* third */

int lvsmooth PROTO((xvimage *, xvimage *, mat_str *, mat_str *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvskthinm PROTO((xvimage *, mat_str *, mat_str *, mat_str *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvskthin PROTO((xvimage *, mat_str *, mat_str *, int, int , xvimage *, int , unsigned long, xvimage *));
int lvskthick PROTO((xvimage *, mat_str *, mat_str *, int, int , xvimage *, int , unsigned long, xvimage *));
int lvskiz PROTO((xvimage *, xvimage *, int, unsigned long, xvimage *));
int lvskel PROTO((xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvopenrec PROTO((xvimage *, xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvclosrec PROTO((xvimage *, xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvlocmin PROTO((xvimage *, mat_str *, xvimage *, int, xvimage *));
int lvlocmax PROTO((xvimage *, mat_str *, xvimage *, int, xvimage *));
int lvlastero PROTO((xvimage *, mat_str *, xvimage *, int, unsigned long, xvimage *));
int lvhomot PROTO((xvimage *, xvimage *, mat_str *, xvimage *, int, xvimage *));
int lvedgeoff PROTO((xvimage *, mat_str *, unsigned long, xvimage *));
int lvcskthin PROTO((xvimage *, xvimage *, mat_str *, mat_str *, int, int , xvimage *, int , unsigned long, xvimage *));
int lvcskthick PROTO((xvimage *, xvimage *, mat_str *, mat_str *, int, int , xvimage *, int , unsigned long, xvimage *));
int lvclohole PROTO((xvimage *, mat_str *, unsigned long, xvimage *));
int lvcenter PROTO((xvimage *, mat_str *, int, xvimage *, int , unsigned long, xvimage *));
int lvbisset PROTO((xvimage *, mat_str *, int, xvimage *, int , unsigned long, xvimage *));





#endif /* _mmachh_ */
/* Don't add after this point */
