 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vcast1.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vcast1_get_args
| 
|       Purpose: Gets command line args for vcast1
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vcast1
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vcast1_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vcast1 is out of sync with arguments specified in vcast1's *.pane file; please rerun ghostwriter on vcast1.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vcast1 structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i4",
			  &(clui_info->i4_file),
			  &(clui_info->i4_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i5",
			  &(clui_info->i5_file),
			  &(clui_info->i5_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o3",
			  &(clui_info->o3_file),
			  &(clui_info->o3_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o4",
			  &(clui_info->o4_file),
			  &(clui_info->o4_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o5",
			  &(clui_info->o5_file),
			  &(clui_info->o5_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &(clui_info->t_toggle),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vcast1_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Upcast Images to the Highest Input Data Type' subform",
  "-P 1 0 52x1+0+1 +8+0 ' ' vcast1",
  "-Q 1 0 5x1+47+0 'Close'",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-b +1+2 'Input Images:' blank0",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Input Image #1' 'input image #1' i1",
  "-I 1 0 0 1 0 1 52x1+0+4 ' ' 'Input Image #2' 'input image #2' i2",
  "-I 1 0 1 0 0 1 52x1+0+5 ' ' 'Input Image #3' 'input image #3' i3",
  "-I 1 0 1 0 0 1 52x1+0+6 ' ' 'Input Image #4' 'input image #4' i4",
  "-I 1 0 1 0 0 1 52x1+0+7 ' ' 'Input Image #5' 'input image #5' i5",
  "-O 1 0 0 1 0 1 52x1+0+10 ' ' 'Output Image #1' 'output image #1' o1",
  "-O 1 0 0 1 0 1 52x1+0+11 ' ' 'Output Image #2' 'output image #2' o2",
  "-O 1 0 1 0 0 1 52x1+0+12 ' ' 'Output Image #3' 'output image #3' o3",
  "-O 1 0 1 0 0 1 52x1+0+13 ' ' 'Output Image #4' 'output image #4' o4",
  "-O 1 0 1 0 0 1 52x1+0+14 ' ' 'Output Image #5' 'output image #5' o5",
  "-T 1 0 1 0 0 10x1+2+17 +0+0 1 'Select Data Type (Auto Upcast if Not Selected)' 'Select data type [default = Auto Upcast to Highest Input Data Type]' t",
  "-s 1 0 1 1 0 10x1+4+1 'byte' 'Byte' 'choose byte data type' t",
  "-s 1 0 1 0 0 10x1+22+1 'int' 'Integer' 'choose integer data type' t",
  "-s 1 0 1 0 0 10x1+36+1 'complex' 'Complex' 'choose complex data type' t",
  "-s 1 0 1 0 0 10x1+4+2 'short' 'Short' 'choose short data type' t",
  "-s 1 0 1 0 0 10x1+22+2 'float' 'Float' 'choose float data type' t",
  "-s 1 0 1 0 0 10x1+36+2 'double' 'Double' 'choose double data type' t",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MMACHBIN/vcast1",
  "-b +1+9 'Output Images:' blank1",
  "-b +1+16 'Optional Data Casting:' blank2",
  "-H 1 5x1+41+0 'Help' 'man page for vcast1' $MMACH/objects/kroutine/vcast1/help help",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vcast1/uis/vcast1.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	33,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


