 /*
  * Khoros: $Id$
  */

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vcast1
   >>>> 
   >>>>    Written By: Charlie Gage
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: May 12, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vcast1_h_
#define _vcast1_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <mmach.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image #1 (required infile)
 */
char	*i1_file;	/* input image #1 FILENAME */
int	 i1_flag;	/* input image #1 FLAG */

/*
 *  input image #2 (required infile)
 */
char	*i2_file;	/* input image #2 FILENAME */
int	 i2_flag;	/* input image #2 FLAG */

/*
 *  output image #1 (required outfile)
 */
char	*o1_file;	/* output image #1 FILENAME */
int	 o1_flag;	/* output image #1 FLAG */

/*
 *  output image #2 (required outfile)
 */
char	*o2_file;	/* output image #2 FILENAME */
int	 o2_flag;	/* output image #2 FLAG */

/*
 *  input image #3 (optional infile)
 */
char	*i3_file;	/* input image #3 FILENAME */
int	 i3_flag;	/* input image #3 FLAG */

/*
 *  input image #4 (optional infile)
 */
char	*i4_file;	/* input image #4 FILENAME */
int	 i4_flag;	/* input image #4 FLAG */

/*
 *  input image #5 (optional infile)
 */
char	*i5_file;	/* input image #5 FILENAME */
int	 i5_flag;	/* input image #5 FLAG */

/*
 *  output image #3 (optional outfile)
 */
char	*o3_file;	/* output image #3 FILENAME */
int	 o3_flag;	/* output image #3 FLAG */

/*
 *  output image #4 (optional outfile)
 */
char	*o4_file;	/* output image #4 FILENAME */
int	 o4_flag;	/* output image #4 FLAG */

/*
 *  output image #5 (optional outfile)
 */
char	*o5_file;	/* output image #5 FILENAME */
int	 o5_flag;	/* output image #5 FLAG */

/*
 * Select data type [default = Auto Upcast to Highest Input Data Type] (Optional string toggle)
 *	byte (choose byte data type)
 *	int (choose integer data type)
 *	complex (choose complex data type)
 *	short (choose short data type)
 *	float (choose float data type)
 *	double (choose double data type),
 */
char	*t_toggle;		/* Select data type [default = Auto Upcast to Highest Input Data Type] STRING TOGGLE */
int	 t_flag;		/* Select data type [default = Auto Upcast to Highest Input Data Type] FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define MATCHINPUT(program, img1, img2) \
        (void) match_num_images(program,img1,img2,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vcast1_get_args PROTO((kaddr));
void vcast1_usage_additions PROTO((void));
void vcast1_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
