 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vdilexpan.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vdilexpan_get_args
| 
|       Purpose: Gets command line args for vdilexpan
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vdilexpan
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vdilexpan_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vdilexpan is out of sync with arguments specified in vdilexpan's *.pane file; please rerun ghostwriter on vdilexpan.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vdilexpan structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vdilexpan_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "str",
			  &(clui_info->str_file),
			  &(clui_info->str_flag))))
	{
	    kerror(NULL, "vdilexpan_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "vs",
			  &(clui_info->vs_int),
			  &(clui_info->vs_flag))))
	{
	    kerror(NULL, "vdilexpan_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hs",
			  &(clui_info->hs_int),
			  &(clui_info->hs_flag))))
	{
	    kerror(NULL, "vdilexpan_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "voff",
			  &(clui_info->voff_int),
			  &(clui_info->voff_flag))))
	{
	    kerror(NULL, "vdilexpan_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "hoff",
			  &(clui_info->hoff_int),
			  &(clui_info->hoff_flag))))
	{
	    kerror(NULL, "vdilexpan_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vdilexpan_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Expansion by Dilation' image",
  "-P 1 0 52x1+0+1 +12+0 ' Expansion by Dilation ' vdilexpan",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MMACHBIN/vdilexpan",
  "-H 1  5x1+41+0 'Help' 'man page for vdilexpan' $MMACH/objects/kroutine/vdilexpan/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image' 'input image' i",
  "-I 1 0 1 0 0 0 52x1+0+3 ' ' 'Struct Element' 'Structuring Element' str",
  "-i 1 0 1 1 1 47x1+2+6 0 0 2 1 0 ' Vertical Scale Factor    ' 'expansion scale factor' vs",
  "-i 1 0 1 1 1 47x1+2+7 0 0 2 1 0 ' Horizontal Scale Factor  ' 'expansion scale factor' hs",
  "-i 1 0 1 1 1 47x1+2+8 0 0 0 1 0 'Vertical Offset    ' 'expansion scale factor' voff",
  "-i 1 0 1 1 1 47x1+2+9 0 0 0 1 0 'Horizontal Offset  ' 'expansion scale factor' hoff",
  "-O 1 0 0 1 0 1 52x1+0+11 ' ' 'Output Image  ' 'resulting output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vdilexpan/uis/vdilexpan.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


