 /*
  * Khoros: $Id$
  */

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vdilexpan
   >>>> 
   >>>>    Written By: Marco Antonio Carvalho Pessoa
Gerald Jean Francis Banon (for last revision)
Sao Jose dos Campos, SP, Brazil, November, 9th, 94
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: May 12, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vdilexpan_h_
#define _vdilexpan_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <mmach.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  resulting output image (required outfile)
 */
char	*o_file;	/* resulting output image FILENAME */
int	 o_flag;	/* resulting output image FLAG */

/*
 *  Structuring Element (optional infile)
 */
char	*str_file;	/* Structuring Element FILENAME */
int	 str_flag;	/* Structuring Element FLAG */

/*
 *  expansion scale factor (optional integer)
 */
int	 vs_int; 	/* expansion scale factor INT */
int	 vs_flag;	/* expansion scale factor FLAG */

/*
 *  expansion scale factor (optional integer)
 */
int	 hs_int; 	/* expansion scale factor INT */
int	 hs_flag;	/* expansion scale factor FLAG */

/*
 *  expansion scale factor (optional integer)
 */
int	 voff_int; 	/* expansion scale factor INT */
int	 voff_flag;	/* expansion scale factor FLAG */

/*
 *  expansion scale factor (optional integer)
 */
int	 hoff_int; 	/* expansion scale factor INT */
int	 hoff_flag;	/* expansion scale factor FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define CHECKINPUT(program, img1, img2) \
        (void) proper_num_images(program,img1,1,TRUE); \
        (void) match_num_images(program,img1,img2,TRUE); \
        \
        (void) match_num_bands(program,img1,img2,TRUE); \
        \
        (void) proper_map_enable(program,img1,VFF_MAP_OPTIONAL,TRUE); \
        (void) match_map_enable(program,img1,img2,TRUE); \
        \
        (void) matchsize(program,img1,img2,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vdilexpan_get_args PROTO((kaddr));
void vdilexpan_usage_additions PROTO((void));
void vdilexpan_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
