 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vdiskstr.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vdiskstr_get_args
| 
|       Purpose: Gets command line args for vdiskstr
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vdiskstr
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vdiskstr_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vdiskstr is out of sync with arguments specified in vdiskstr's *.pane file; please rerun ghostwriter on vdiskstr.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vdiskstr structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vdiskstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "trigger",
			  &(clui_info->trigger_file),
			  &(clui_info->trigger_flag))))
	{
	    kerror(NULL, "vdiskstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "d",
			  &(clui_info->d_int),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "vdiskstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "dim",
			  &(clui_info->dim_logic),
			  &(clui_info->dim_flag))))
	{
	    kerror(NULL, "vdiskstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "p",
			  &(clui_info->p_logic),
			  &(clui_info->p_flag))))
	{
	    kerror(NULL, "vdiskstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "off",
			  &(clui_info->off_int),
			  &(clui_info->off_flag))))
	{
	    kerror(NULL, "vdiskstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &(clui_info->t_toggle),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vdiskstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generates a disk structuring element' image",
  "-P 1 0 52x1+0+1 +8+0 ' ' vgdisk",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $MMACHBIN/vdiskstr",
  "-H 1  5x1+41+0 'Help' 'man page for vgdisk' $MMACH/objects/kroutine/vdiskstr/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-O 1 0 0 1 0 1 52x1+0+2 ' ' 'Output Struc File' 'output resulting struc file definition' o",
  "-I 1 0 1 0 0 0 52x1+0+3 ' ' 'Trigger Input ' 'trigger input' trigger",
  "-i 1 0 0 1 0 23.5x1+1+5 2 2 5 1 0 'Disk Diameter   ' 'diameter of the disk to be created' d",
  "-l 1 0 0 1 0 22x1+29+5 0 'Dimensionality' '  2D  ' '  3D' '2D/3D dimension' dim",
  "-l 1 0 0 1 0 22.5x1+1+6 0 'Select Type     ' '  Planar  ' 'Nonplanar' 'disk type' p",
  "-i 1 0 0 1 0 23.5x1+1+7 0 0 0 1 0 'Nonplanar offset' 'value to be added to nonplanar elements' off",
  "-T 1 0 0 1 0 50x3+1+9 +0+0 1 'Select Metric' 'lets user choose which kind of disk is to be created' t",
  "-s 1 0 1 1 0 10x1+3+1 'euclidean' 'Euclidean ' 'choose euclidean  metric' t",
  "-s 1 0 1 0 0 10x1+3+2 'city-block' 'City-Block' 'choose city-block metric' t",
  "-s 1 0 1 0 0 10x1+3+3 'chessboard' 'Chessboard' 'choose chessboard metric' t",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vdiskstr/uis/vdiskstr.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	23,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


