 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vedgeoff.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vedgeoff_get_args
| 
|       Purpose: Gets command line args for vedgeoff
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vedgeoff
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vedgeoff_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vedgeoff is out of sync with arguments specified in vedgeoff's *.pane file; please rerun ghostwriter on vedgeoff.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vedgeoff structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vedgeoff_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "str",
			  &(clui_info->str_file),
			  &(clui_info->str_flag))))
	{
	    kerror(NULL, "vedgeoff_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vedgeoff_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Remove objects touching the frame  of the image window' image",
  "-P 1 0 52x1+0+1 +12+0 ' ' vedgeoff",
  "-Q 1 0 5x1+47+0 'Close'",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input Image ' 'Input image' i",
  "-I 1 0 0 1 0 0 52x1+0+3 ' ' 'Struct Element' 'Structuring Element' str",
  "-O 1 0 0 1 0 1 52x1+0+5 ' ' 'Output Image' 'resulting output image' o",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MMACHBIN/vedgeoff",
  "-H 1 5x1+41+0 'Help' 'man page for vedgeoff' $MMACH/objects/kroutine/vedgeoff/help help",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vedgeoff/uis/vedgeoff.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


