 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vequal.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vequal_get_args
| 
|       Purpose: Gets command line args for vequal
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vequal
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vequal_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vequal is out of sync with arguments specified in vequal's *.pane file; please rerun ghostwriter on vequal.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vequal structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vequal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "v",
			  &(clui_info->v_string),
			  &(clui_info->v_flag))))
	{
	    kerror(NULL, "vequal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vequal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vequal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vequal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Informs if two images are equal' image",
  "-P 1 0 52x1+0+1 +6+0 ' ' vequal",
  "-Q 1 0 5x1+47+0 'Close'",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input Image #1' 'input file' i1",
  "-s 1 0 0 1 1 47x1+0+8 ' ' 'Data Variable Name:' 'variable' v",
  "-O 1 0 0 1 0 0 52x1+0+11 ' ' 'Output File' 'The first input file' o",
  "-R 1 0 4 5x1+35+0 'Run' 'Execute operation' $MMACHBIN/vequal",
  "-C 1",
  "-I 1 0 1 1 0 0 50x1+1+4 ' ' 'Input Image #2' 'input file' i2",
  "-i 1 0 1 0 0 50x1+1+5 0 255 0 1 0 'Constant Image' 'constant value' c",
  "-E",
  "-H 1 5x1+41+0 'Help' 'Man page for vequal' $MMACH/objects/kroutine/vequal/help help",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vequal/uis/vequal.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


