 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for vextintersec
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "vextintersec.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Extended Intersection
|
|       Purpose: main program for vextintersec
|
|         Input:
|		char *clui_info->i1_file; {first input image}
|		int   clui_info->i1_flag; {TRUE if -i1 specified}
|
|		char *clui_info->i2_file; {second input image}
|		int   clui_info->i2_flag; {TRUE if -i2 specified}
|
|		char *clui_info->o_file; {resulting output image}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|		char *clui_info->i3_file; {first input image}
|		int   clui_info->i3_flag; {TRUE if -i3 specified}
|
|		char *clui_info->i4_file; {second input image}
|		int   clui_info->i4_flag; {TRUE if -i4 specified}
|
|		char *clui_info->i5_file; {first input image}
|		int   clui_info->i5_flag; {TRUE if -i5 specified}
|
|		char *clui_info->i6_file; {second input image}
|		int   clui_info->i6_flag; {TRUE if -i6 specified}
|
|        Output:
|       Returns:
|
|    Written By: Adriano Nagelschmidt Rodrigues
|          Date: May 12, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
char *program = NULL;
xvimage *img1, *img2, *img3, *img4, *img5, *img6, *img7, *images[7];
xvimage *img11, *img22, *img33, *img44, *img55, *img66, *img77;
int num_images, up_type;
unsigned long border;
/* -main_variable_list_end */

	khoros_init(argc, argv, "MMACH", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$MMACH/objects/kroutine/vextintersec");
	kexit_handler(vextintersec_free_args, NULL);

/* -main_get_args_call */
	kclui_init("MMACH", "vextintersec", KGEN_KROUTINE,  &clui_uis_spec,
		   vextintersec_usage_additions, vextintersec_get_args,
 		   vextintersec_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
        num_images = 0;         /* initialize counter */

        img1 = readimage(clui_info->i1_file);
        if (img1 == NULL)
          kexit(1);                    
        images[num_images++] = img1;

        img2 = readimage(clui_info->i2_file);
        if (img2 == NULL)
          kexit(1);                      
        images[num_images++] = img2;

        CHECKINPUT(program, img1, img2);      /* Verify input images */

	if (clui_info->i3_flag) {
          img3 = readimage(clui_info->i3_file); 
          images[num_images++] = img3;
          if (img3 == NULL)
            kexit(1);
          CHECKINPUT(program, img1, img3); 
        }

	if (clui_info->i4_flag) {
          img4 = readimage(clui_info->i4_file); 
          images[num_images++] = img4;
          if (img4 == NULL)
            kexit(1);
          CHECKINPUT(program, img1, img4); 
        }

	if (clui_info->i5_flag) {
          img5 = readimage(clui_info->i5_file); 
          images[num_images++] = img5;
          if (img5 == NULL)
            kexit(1);
          CHECKINPUT(program, img1, img5); 
        }

	if (clui_info->i6_flag) {
          img6 = readimage(clui_info->i6_file); 
          images[num_images++] = img6;
          if (img6 == NULL)
            kexit(1);
          CHECKINPUT(program, img1, img6); 
        }
/*
        if (clui_info->m_flag) {
          img7 = readimage(clui_info->m_file);
          images[num_images++] = img7;
          if (img7 == NULL)
            kexit(1);
          MATCHINPUT(program, img1, img3);
        }
*/
        up_type = -1;    /* call lvcast1 with auto upconvert */

                         /*  Call lvcast1 to upconvert data types */
        if (!lvcast1(images, num_images, up_type)) {
          (void) kfprintf(kstderr, "ERROR: images could not be cast to the same type\n");
          kexit(1);
        }

       if (img1->data_storage_type == VFF_TYP_BIT) {
         img11 = format(img1, &border);
         img22 = format(img2, &border);
         if (clui_info->i3_flag)
           img33 = format(img3, &border);
         if (clui_info->i4_flag)
           img44 = format(img4, &border);
         if (clui_info->i5_flag)
           img55 = format(img5, &border);
         if (clui_info->i6_flag)
           img66 = format(img6, &border);
/*
         if (clui_info->m_flag)
           img77 = format(img7, &border);
*/
       }
       else {
         img11 = img1;
         img22 = img2;
         img33 = img3;
         img44 = img4;
         img55 = img5;
         img66 = img6;
         img77 = img7;
       }
/* -main_before_lib_call_end */

/* -main_library_call */
if (!lvminf(img11, img22, img33, clui_info->i3_flag, img44, clui_info->i4_flag, img55, clui_info->i5_flag, img66, clui_info->i6_flag, img77, 0/*clui_info->m_flag*/, img11)) {
          (void) kfprintf(kstderr, "lvminf Failed\n");
          kexit(1);
        }
/* -main_library_call_end */

/* -main_after_lib_call */
if (img1->data_storage_type == VFF_TYP_BIT)
          (void) unformat(img11, img1);
        (void) writeimage(clui_info->o_file, img1);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: vextintersec_usage_additions
| 
|       Purpose: Prints usage additions in vextintersec_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vextintersec
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vextintersec_usage_additions(void)
{
	kfprintf(kstderr, "\tExtended Intersection\n");

/* -usage_additions */
kfprintf(kstderr, "\tOptional third input is a masking image.\n");
        kfprintf(kstderr, "\t\n");
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: vextintersec_free_args
| 
|       Purpose: Frees CLUI struct allocated in vextintersec_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vextintersec
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
vextintersec_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i1_file);
		kfree_and_NULL(clui_info->i2_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info->i3_file);
		kfree_and_NULL(clui_info->i4_file);
		kfree_and_NULL(clui_info->i5_file);
		kfree_and_NULL(clui_info->i6_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
