 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for vframe
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "vframe.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Builds a frame image
|
|       Purpose: main program for vframe
|
|         Input:
|		char *clui_info->i_file; {input image}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->o_file; {resulting output image}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|        Output:
|       Returns:
|
|    Written By: Adriano Nagelschmidt Rodrigues
|          Date: May 12, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
char *program = NULL;
xvimage *img1, *img11, *images[1];
int num_images;
unsigned long border;
/* -main_variable_list_end */

	khoros_init(argc, argv, "MMACH", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$MMACH/objects/kroutine/vframe");
	kexit_handler(vframe_free_args, NULL);

/* -main_get_args_call */
	kclui_init("MMACH", "vframe", KGEN_KROUTINE,  &clui_uis_spec,
		   vframe_usage_additions, vframe_get_args,
 		   vframe_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
        num_images = 0;         /* initialize counter */

        img1 = readimage(clui_info->i_file);
        if (img1 == NULL)
            kexit(1);                    
        images[num_images++] = img1;
 
        if (img1->data_storage_type == VFF_TYP_BIT)
          img11 = format(img1, &border);
        else 
          img11 = img1;
/* -main_before_lib_call_end */

/* -main_library_call */
if (!lvwind(img11, border)) {
          (void) kfprintf(kstderr, "lvwind Failed\n");
          kexit(1);
        }
/* -main_library_call_end */

/* -main_after_lib_call */
if (img1->data_storage_type == VFF_TYP_BIT)
         (void) unformat(img11, img1);
       (void) writeimage(clui_info->o_file, img1);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: vframe_usage_additions
| 
|       Purpose: Prints usage additions in vframe_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vframe
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vframe_usage_additions(void)
{
	kfprintf(kstderr, "\tBuilds a frame image\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: vframe_free_args
| 
|       Purpose: Frees CLUI struct allocated in vframe_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vframe
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
vframe_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
