 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vicanon.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vicanon_get_args
| 
|       Purpose: Gets command line args for vicanon
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vicanon
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vicanon_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vicanon is out of sync with arguments specified in vicanon's *.pane file; please rerun ghostwriter on vicanon.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the vicanon structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vicanon_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "str1",
			  &(clui_info->str1_file),
			  &(clui_info->str1_flag))))
	{
	    kerror(NULL, "vicanon_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "str2",
			  &(clui_info->str2_file),
			  &(clui_info->str2_flag))))
	{
	    kerror(NULL, "vicanon_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "r", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vicanon_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->r_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vicanon_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Inf-Canonical Operator' image",
  "-P 1 0 52x1+0+1 +12+0 ' ' vicanon",
  "-Q 1 0 5x1+47+0 'Close'",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input Image ' 'input image' i",
  "-I 1 0 0 1 0 0 52x1+0+3 ' ' 'Struct Element 1' 'Structuring Element' str1",
  "-I 1 0 0 1 0 0 52x1+0+4 ' ' 'Struct Element 2' 'Structuring Element' str2",
  "-T 1 0 0 1 0 40x1+1+6 +0+0 1 'Struct El. Rotation Step' 'Rotation step' r",
  "-i 1 0 1 1 0 2x1+24+0 1 4 1 1 0 '1 ' 'Rotation step' r",
  "-i 1 0 1 0 0 2x1+32+0 1 4 2 1 0 '2 ' 'Rotation step' r",
  "-i 1 0 1 0 0 2x1+40+0 1 4 4 1 0 '4 ' 'Rotation step' r",
  "-E",
  "-O 1 0 0 1 0 0 52x1+0+8 ' ' 'Output Image  ' 'resulting output image' o",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MMACHBIN/vicanon",
  "-H 1 5x1+41+0 'Help' 'man page for vncanond' $MMACH/objects/kroutine/vicanon/help help",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vicanon/uis/vicanon.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	21,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


