 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for viff2str
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "viff2str.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - converts VIFF file to a structuring element (MMACH)
|
|       Purpose: main program for viff2str
|
|         Input:
|		char *clui_info->i_file; {input viff image file}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->o_file; {output resulting struc file definition}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|		int clui_info->t_logic; {kernel format}
|		int clui_info->t_flag; {TRUE if -t specified}
|
|        Output:
|       Returns:
|
|    Written By: Ulisses Braga
|          Date: May 12, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
char *program = NULL;
xvimage *img;
    mat_str        ker;
    int            type;
/* -main_variable_list_end */

	khoros_init(argc, argv, "MMACH", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$MMACH/objects/kroutine/viff2str");
	kexit_handler(viff2str_free_args, NULL);

/* -main_get_args_call */
	kclui_init("MMACH", "viff2str", KGEN_KROUTINE,  &clui_uis_spec,
		   viff2str_usage_additions, viff2str_get_args,
 		   viff2str_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
    READINPUT(program,img);
    CHECKINPUT(program,img);

    if (clui_info->t_flag)
      type = clui_info->t_logic; /* Desired type */
    else
      type = 0;  /* PLANAR, default */
/* -main_before_lib_call_end */

/* -main_library_call */
if(! lviff2str(img,&ker,type))
    {
        (void) kfprintf(kstderr, "viff2str: lviff2str Failed\n");
        kexit(1);
    }
/* -main_library_call_end */

/* -main_after_lib_call */
write_str(clui_info->o_file,&ker);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: viff2str_usage_additions
| 
|       Purpose: Prints usage additions in viff2str_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname viff2str
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void viff2str_usage_additions(void)
{
	kfprintf(kstderr, "\tconverts VIFF file to a structuring element (MMACH)\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: viff2str_free_args
| 
|       Purpose: Frees CLUI struct allocated in viff2str_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname viff2str
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
viff2str_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
