 /*
  * Khoros: $Id$
  */

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for viff2str
   >>>> 
   >>>>    Written By: Ulisses Braga
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: May 12, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _viff2str_h_
#define _viff2str_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <mmach.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input viff image file (required infile)
 */
char	*i_file;	/* input viff image file FILENAME */
int	 i_flag;	/* input viff image file FLAG */

/*
 *  output resulting struc file definition (required outfile)
 */
char	*o_file;	/* output resulting struc file definition FILENAME */
int	 o_flag;	/* output resulting struc file definition FLAG */

/*
 *  kernel format (optional logical)
 */
int	 t_logic;	/* kernel format LOGIC */
int	 t_flag;  	/* kernel format FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT(program,image) \
image = readimage(clui_info->i_file);  \
if (image == NULL) {  \
   (void) kfprintf(kstderr, "%s: Can not read input image \n",program);  \
   kexit(1);  /* Quit if bad image */ \
} 

#define CHECKINPUT(program,image) \
    proper_num_images(program,image,1,TRUE);  \
    proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE);
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void viff2str_get_args PROTO((kaddr));
void viff2str_usage_additions PROTO((void));
void viff2str_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
