 /*
  * Khoros: $Id$
  */

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vless
   >>>> 
   >>>>    Written By: Adriano Nagelschmidt Rodrigues
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: May 12, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vless_h_
#define _vless_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <mmach.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*----- required ME group ----*/
/*
 *  Upper level (optional infile)
 */
char	*i1_file;	/* Upper level FILENAME */
int	 i1_flag;	/* Upper level FLAG */

/*
 *  upper level (optional integer)
 */
int	 u_int; 	/* upper level INT */
int	 u_flag;	/* upper level FLAG */

/*-- required ME group end ---*/

/*
 *  variable (required string)
 */
char	*v_string;	/* variable STRING */
int	 v_flag;   	/* variable FLAG */

/*
 *  The first input image (required outfile)
 */
char	*o_file;	/* The first input image FILENAME */
int	 o_flag;	/* The first input image FLAG */

/*----- required ME group ----*/
/*
 *  Lower level (optional infile)
 */
char	*i2_file;	/* Lower level FILENAME */
int	 i2_flag;	/* Lower level FLAG */

/*
 *  lower level (optional integer)
 */
int	 l_int; 	/* lower level INT */
int	 l_flag;	/* lower level FLAG */

/*-- required ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define CHECKINPUT(program, img1, img2) \
        (void) proper_num_images(program,img1,1,TRUE); \
        (void) match_num_images(program,img1,img2,TRUE); \
        \
        (void) match_num_bands(program,img1,img2,TRUE); \
        \
        (void) proper_map_enable(program,img1,VFF_MAP_OPTIONAL,TRUE); \
        (void) match_map_enable(program,img1,img2,TRUE); \
        \
        (void) matchsize(program,img1,img2,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vless_get_args PROTO((kaddr));
void vless_usage_additions PROTO((void));
void vless_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
