 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vncondthin.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vncondthin_get_args
| 
|       Purpose: Gets command line args for vncondthin
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vncondthin
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vncondthin_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vncondthin is out of sync with arguments specified in vncondthin's *.pane file; please rerun ghostwriter on vncondthin.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the vncondthin structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vncondthin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vncondthin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "str1",
			  &(clui_info->str1_file),
			  &(clui_info->str1_flag))))
	{
	    kerror(NULL, "vncondthin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "str2",
			  &(clui_info->str2_file),
			  &(clui_info->str2_flag))))
	{
	    kerror(NULL, "vncondthin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vncondthin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "r", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vncondthin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->r_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_logical(pane, "d",
			  &(clui_info->d_logic),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "vncondthin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vncondthin_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'N-1 compositions of Conditional Thinnings' image",
  "-P 1 0 52x1+0+1 +12+0 ' ' vncondthin",
  "-Q 1 0 5x1+47+0 'Close'",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input Image #1' 'input image 1' i1",
  "-I 1 0 0 1 0 0 52x1+0+3 ' ' 'Input Image #2' 'input image 2' i2",
  "-I 1 0 0 1 0 0 52x1+0+4 ' ' 'Struct Element 1' 'Structuring Element' str1",
  "-I 1 0 0 1 0 0 52x1+0+5 ' ' 'Struct Element 2' 'Structuring Element' str2",
  "-i 1 0 0 1 0 35x1+1+6 2 2 5 1 0 'Size of Struct Element' 'size of structure element' n",
  "-T 1 0 0 1 0 40x1+1+7 +0+0 1 'Struct El. Rotation Step' 'Rotation step' r",
  "-i 1 0 1 1 0 2x1+24+0 1 4 1 1 0 '1 ' 'Rotation step' r",
  "-i 1 0 1 0 0 2x1+32+0 1 4 2 1 0 '2 ' 'Rotation step' r",
  "-i 1 0 1 0 0 2x1+40+0 1 4 4 1 0 '4 ' 'Rotation step' r",
  "-E",
  "-l 1 0 0 1 0 50x1+1+8 1 'Clockwise Rotation' 'False' 'True ' 'rotation direction' d",
  "-O 1 0 0 1 0 0 52x1+0+10 ' ' 'Output Image  ' 'resulting output image' o",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MMACHBIN/vncondthin",
  "-H 1 5x1+41+0 'Help' 'man page for vncthin' $MMACH/objects/kroutine/vncondthin/help help",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vncondthin/uis/vncondthin.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	24,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


