 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for vneg
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "vneg.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Negation
|
|       Purpose: main program for vneg
|
|         Input:
|		char *clui_info->i_file; {input image}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->o_file; {resulting output image}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|        Output:
|       Returns:
|
|    Written By: Junior Barrera
|          Date: May 12, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
char *program = NULL;
xvimage *img1, *img2, *images[2];
xvimage *img11, *img22;
int num_images, up_type;
unsigned long border;
/* -main_variable_list_end */

	khoros_init(argc, argv, "MMACH", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$MMACH/objects/kroutine/vneg");
	kexit_handler(vneg_free_args, NULL);

/* -main_get_args_call */
	kclui_init("MMACH", "vneg", KGEN_KROUTINE,  &clui_uis_spec,
		   vneg_usage_additions, vneg_get_args,
 		   vneg_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
        num_images = 0;         /* initialize counter */

        img1 = readimage(clui_info->i_file);
        if (img1 == NULL)
            kexit(1);                    
        images[num_images++] = img1;
/* remove mask input, ral 12nov94
        if (clui_info->m_flag) {
          img2 = readimage(clui_info->m_file);
          images[num_images++] = img2;
        }
        if ((clui_info->m_flag) && (img2 == NULL)) kexit(1);         
        if (clui_info->m_flag)  { 
            CHECKINPUT(program, img1, img2);  
        }
*/
        if (img1->data_storage_type == VFF_TYP_BIT) {
          img11 = format(img1, &border);
/*
          if (clui_info->m_flag)
            img22 = format(img2, &border);
*/
        }
        else {
         img11 = img1;
         img22 = img2;
        }
/* -main_before_lib_call_end */

/* -main_library_call */
if (!lvinv(img11, img22, 0 , img11)) {
          (void) kfprintf(kstderr, "lvinv Failed\n");
          kexit(1);
        }
/* -main_library_call_end */

/* -main_after_lib_call */
if (img1->data_storage_type == VFF_TYP_BIT)
          (void) unformat(img11, img1);

        (void) writeimage(clui_info->o_file, img1);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: vneg_usage_additions
| 
|       Purpose: Prints usage additions in vneg_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vneg
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vneg_usage_additions(void)
{
	kfprintf(kstderr, "\tNegation\n");

/* -usage_additions */
kfprintf(kstderr, "\tOptional third input is a masking image.\n");
        kfprintf(kstderr, "\t\n");
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: vneg_free_args
| 
|       Purpose: Frees CLUI struct allocated in vneg_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vneg
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
vneg_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
