 /*
  * Khoros: $Id$
  */

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vnthick
   >>>> 
   >>>>    Written By: Adriano Nagelschmidt Rodrigues
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: May 12, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vnthick_h_
#define _vnthick_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <mmach.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  Structuring Element (required infile)
 */
char	*str1_file;	/* Structuring Element FILENAME */
int	 str1_flag;	/* Structuring Element FLAG */

/*
 *  Structuring Element (required infile)
 */
char	*str2_file;	/* Structuring Element FILENAME */
int	 str2_flag;	/* Structuring Element FLAG */

/*
 *  number of thickenings (required integer)
 */
int	 n_int; 	/* number of thickenings INT */
int	 n_flag;	/* number of thickenings FLAG */

/*
 * Rotation step (Required integer toggle)
 *	1 (Rotation step)
 *	2 (Rotation step)
 *	4 (Rotation step),
 */
int	 r_toggle;		/* Rotation step INT TOGGLE */
int	 r_flag;		/* Rotation step FLAG */

/*
 *  rotation direction (required logical)
 */
int	 d_logic;	/* rotation direction LOGIC */
int	 d_flag;  	/* rotation direction FLAG */

/*
 *  resulting output image (required outfile)
 */
char	*o_file;	/* resulting output image FILENAME */
int	 o_flag;	/* resulting output image FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define CHECKINPUT(program, img1, img2) \
        (void) proper_num_images(program,img1,1,TRUE); \
        (void) match_num_images(program,img1,img2,TRUE); \
        \
        (void) match_num_bands(program,img1,img2,TRUE); \
        \
        (void) proper_map_enable(program,img1,VFF_MAP_OPTIONAL,TRUE); \
        (void) match_map_enable(program,img1,img2,TRUE); \
        \
        (void) matchsize(program,img1,img2,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vnthick_get_args PROTO((kaddr));
void vnthick_usage_additions PROTO((void));
void vnthick_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
