 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vocoASF.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vocoASF_get_args
| 
|       Purpose: Gets command line args for vocoASF
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vocoASF
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vocoASF_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vocoASF is out of sync with arguments specified in vocoASF's *.pane file; please rerun ghostwriter on vocoASF.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vocoASF structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vocoASF_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "str",
			  &(clui_info->str_file),
			  &(clui_info->str_flag))))
	{
	    kerror(NULL, "vocoASF_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vocoASF_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "s",
			  &(clui_info->s_logic),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vocoASF_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vocoASF_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Alternating Sequential Filter of type Opening(Closing(Opening()))' image",
  "-P 1 0 52x1+0+1 +12+0 ' ' vocoASF",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MMACHBIN/vocoASF",
  "-H 1  5x1+41+0 'Help' 'man page for vnocofilt' $MMACH/objects/kroutine/vocoASF/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input Image ' 'input image' i",
  "-I 1 0 0 1 0 0 52x1+0+3 ' ' 'Struct Element' 'Structuring Element' str",
  "-i 1 0 0 1 0 35x1+1+4 2 2 5 1 0 'Number of open/close/opens' 'number of open/close/opens' n",
  "-l 1 0 0 1 0 24x1+1+5 1 'Sequential Filtering' 'False' 'True ' 'iterate from 1 to n' s",
  "-O 1 0 0 1 0 1 52x1+0+7 ' ' 'Output Image  ' 'resulting output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vocoASF/uis/vocoASF.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


