 /*
  * Khoros: $Id$
  */

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vopenseg
   >>>> 
   >>>>    Written By: Adriano Nagelschmidt Rodrigues,
Using Guy Pilchen's veroseg as a template.
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: May 12, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vopenseg_h_
#define _vopenseg_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <mmach.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  angle of the line segment from the horizontal (required integer)
 */
int	 alfa_int; 	/* angle of the line segment from the horizontal INT */
int	 alfa_flag;	/* angle of the line segment from the horizontal FLAG */

/*
 *  length of the line segment (required integer)
 */
int	 length_int; 	/* length of the line segment INT */
int	 length_flag;	/* length of the line segment FLAG */

/*
 *  resulting output image (required outfile)
 */
char	*o_file;	/* resulting output image FILENAME */
int	 o_flag;	/* resulting output image FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define CHECKINPUT(program, img_in, img_out) \
        (void) matchsize(program,img_in,img_out,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vopenseg_get_args PROTO((kaddr));
void vopenseg_usage_additions PROTO((void));
void vopenseg_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
