 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vrotstr.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vrotstr_get_args
| 
|       Purpose: Gets command line args for vrotstr
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vrotstr
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vrotstr_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vrotstr is out of sync with arguments specified in vrotstr's *.pane file; please rerun ghostwriter on vrotstr.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vrotstr structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "str",
			  &(clui_info->str_file),
			  &(clui_info->str_flag))))
	{
	    kerror(NULL, "vrotstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "rot",
			  &(clui_info->rot_int),
			  &(clui_info->rot_flag))))
	{
	    kerror(NULL, "vrotstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "d",
			  &(clui_info->d_logic),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "vrotstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vrotstr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Rotates a structuring element' image",
  "-P 1 0 52x1+0+1 +6+0 ' ' vrotstr",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $MMACHBIN/vrotstr",
  "-H 1  5x1+41+0 'Help' 'man page for vrotstr' $MMACH/objects/kroutine/vrotstr/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 1 0 52x1+0+2 ' ' 'Input Kernel' 'input Morphological Kernel' str",
  "-i 1 0 0 1 0 29.5x1+2+4 0 7 1 1 0 'Rotation step' 'the step of rotation value' rot",
  "-l 1 0 0 1 0 24x1+2+5.5 1 'Clockwise Rotation  ' 'False' 'True ' 'rotation direction' d",
  "-O 1 0 0 1 0 0 51.5x1+0+7.5 ' ' 'Output kernel ' 'output morphological kernel' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vrotstr/uis/vrotstr.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	16,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


