 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vstrflat.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vstrflat_get_args
| 
|       Purpose: Gets command line args for vstrflat
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vstrflat
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vstrflat_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vstrflat is out of sync with arguments specified in vstrflat's *.pane file; please rerun ghostwriter on vstrflat.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vstrflat structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s00",
			  &(clui_info->s00_int),
			  &(clui_info->s00_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s10",
			  &(clui_info->s10_int),
			  &(clui_info->s10_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s20",
			  &(clui_info->s20_int),
			  &(clui_info->s20_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s01",
			  &(clui_info->s01_int),
			  &(clui_info->s01_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s11",
			  &(clui_info->s11_int),
			  &(clui_info->s11_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s21",
			  &(clui_info->s21_int),
			  &(clui_info->s21_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s02",
			  &(clui_info->s02_int),
			  &(clui_info->s02_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s12",
			  &(clui_info->s12_int),
			  &(clui_info->s12_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s22",
			  &(clui_info->s22_int),
			  &(clui_info->s22_flag))))
	{
	    kerror(NULL, "vstrflat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generates a 3 by 3 Flat Structuring Element' image",
  "-P 1 0 52x1+0+1 +6+0 ' ' vstrset",
  "-Q 1 0 5x1+47+0 'Close'",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-O 1 0 0 1 0 1 52x1+0+2 ' ' 'Output kernel ' 'output morphological kernel' o",
  "-i 1 0 0 1 0 8x1+11+4 0 1 1 1 0 ' ' 'position (-1, 1) of the structuring element.' s00",
  "-i 1 0 0 1 0 8x1+21+4 0 1 1 1 0 ' ' 'position (0, 1) of the structuring element.' s10",
  "-i 1 0 0 1 0 8x1+31+4 0 1 1 1 0 ' ' 'position (1, 1) of the structuring element.' s20",
  "-i 1 0 0 1 0 8x1+11+5 0 1 1 1 0 ' ' 'position (-1, 0) of the structuring element.' s01",
  "-i 1 0 0 1 0 8x1+21+5 0 1 1 1 0 ' ' 'position (0, 0) of the structuring element.' s11",
  "-i 1 0 0 1 0 8x1+31+5 0 1 1 1 0 ' ' 'position (1, 0) of the structuring element.' s21",
  "-i 1 0 0 1 0 8x1+11+6 0 1 1 1 0 ' ' 'position (-1, -1) of the structuring element.' s02",
  "-i 1 0 0 1 0 8x1+21+6 0 1 1 1 0 ' ' 'position (0, -1) of the structuring element.' s12",
  "-i 1 0 0 1 0 8x1+31+6 0 1 1 1 0 ' ' 'position (1, -1) of the structuring element.' s22",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $MMACHBIN/vstrflat",
  "-H 1 5x1+41+0 'Help' 'man page for vstrset' $MMACH/objects/kroutine/vstrflat/help help",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vstrflat/uis/vstrflat.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	22,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


