 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for vstrflat
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "vstrflat.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Generates a 3 by 3 Flat Structuring Element
|
|       Purpose: main program for vstrflat
|
|         Input:
|		char *clui_info->o_file; {output morphological kernel}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|		int clui_info->s00_int; {position (-1, 1) of the structuring element.}
|		int clui_info->s00_flag; {TRUE if -s00 specified}
|
|		int clui_info->s10_int; {position (0, 1) of the structuring element.}
|		int clui_info->s10_flag; {TRUE if -s10 specified}
|
|		int clui_info->s20_int; {position (1, 1) of the structuring element.}
|		int clui_info->s20_flag; {TRUE if -s20 specified}
|
|		int clui_info->s01_int; {position (-1, 0) of the structuring element.}
|		int clui_info->s01_flag; {TRUE if -s01 specified}
|
|		int clui_info->s11_int; {position (0, 0) of the structuring element.}
|		int clui_info->s11_flag; {TRUE if -s11 specified}
|
|		int clui_info->s21_int; {position (1, 0) of the structuring element.}
|		int clui_info->s21_flag; {TRUE if -s21 specified}
|
|		int clui_info->s02_int; {position (-1, -1) of the structuring element.}
|		int clui_info->s02_flag; {TRUE if -s02 specified}
|
|		int clui_info->s12_int; {position (0, -1) of the structuring element.}
|		int clui_info->s12_flag; {TRUE if -s12 specified}
|
|		int clui_info->s22_int; {position (1, -1) of the structuring element.}
|		int clui_info->s22_flag; {TRUE if -s22 specified}
|
|        Output:
|       Returns:
|
|    Written By: Junior Barrera & Ulisses Braga
|          Date: May 12, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
char *program = NULL;
mat_str ker;
/* -main_variable_list_end */

	khoros_init(argc, argv, "MMACH", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$MMACH/objects/kroutine/vstrflat");
	kexit_handler(vstrflat_free_args, NULL);

/* -main_get_args_call */
	kclui_init("MMACH", "vstrflat", KGEN_KROUTINE,  &clui_uis_spec,
		   vstrflat_usage_additions, vstrflat_get_args,
 		   vstrflat_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
/* -main_before_lib_call_end */

/* -main_library_call */
if(! lvstrset(&ker,clui_info->s00_int,
           clui_info->s10_int,clui_info->s20_int,clui_info->s01_int, 
           clui_info->s11_int,clui_info->s21_int, clui_info->s02_int, clui_info->s12_int, clui_info->s22_int))
    {
        (void) kfprintf(kstderr, "vstrset: lvstrset Failed\n");
        kexit(1);
    }
/* -main_library_call_end */

/* -main_after_lib_call */
write_str(clui_info->o_file, &ker);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: vstrflat_usage_additions
| 
|       Purpose: Prints usage additions in vstrflat_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vstrflat
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vstrflat_usage_additions(void)
{
	kfprintf(kstderr, "\tGenerates a 3 by 3 Flat Structuring Element\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: vstrflat_free_args
| 
|       Purpose: Frees CLUI struct allocated in vstrflat_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vstrflat
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
vstrflat_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
