 /*
  * Khoros: $Id$
  */

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vstrflat
   >>>> 
   >>>>    Written By: Junior Barrera & Ulisses Braga
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: May 12, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vstrflat_h_
#define _vstrflat_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <mmach.h>

/* -include_includes */
#include <lmmach/lmmach.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  output morphological kernel (required outfile)
 */
char	*o_file;	/* output morphological kernel FILENAME */
int	 o_flag;	/* output morphological kernel FLAG */

/*
 *  position (-1, 1) of the structuring element. (required integer)
 */
int	 s00_int; 	/* position (-1, 1) of the structuring element. INT */
int	 s00_flag;	/* position (-1, 1) of the structuring element. FLAG */

/*
 *  position (0, 1) of the structuring element. (required integer)
 */
int	 s10_int; 	/* position (0, 1) of the structuring element. INT */
int	 s10_flag;	/* position (0, 1) of the structuring element. FLAG */

/*
 *  position (1, 1) of the structuring element. (required integer)
 */
int	 s20_int; 	/* position (1, 1) of the structuring element. INT */
int	 s20_flag;	/* position (1, 1) of the structuring element. FLAG */

/*
 *  position (-1, 0) of the structuring element. (required integer)
 */
int	 s01_int; 	/* position (-1, 0) of the structuring element. INT */
int	 s01_flag;	/* position (-1, 0) of the structuring element. FLAG */

/*
 *  position (0, 0) of the structuring element. (required integer)
 */
int	 s11_int; 	/* position (0, 0) of the structuring element. INT */
int	 s11_flag;	/* position (0, 0) of the structuring element. FLAG */

/*
 *  position (1, 0) of the structuring element. (required integer)
 */
int	 s21_int; 	/* position (1, 0) of the structuring element. INT */
int	 s21_flag;	/* position (1, 0) of the structuring element. FLAG */

/*
 *  position (-1, -1) of the structuring element. (required integer)
 */
int	 s02_int; 	/* position (-1, -1) of the structuring element. INT */
int	 s02_flag;	/* position (-1, -1) of the structuring element. FLAG */

/*
 *  position (0, -1) of the structuring element. (required integer)
 */
int	 s12_int; 	/* position (0, -1) of the structuring element. INT */
int	 s12_flag;	/* position (0, -1) of the structuring element. FLAG */

/*
 *  position (1, -1) of the structuring element. (required integer)
 */
int	 s22_int; 	/* position (1, -1) of the structuring element. INT */
int	 s22_flag;	/* position (1, -1) of the structuring element. FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vstrflat_get_args PROTO((kaddr));
void vstrflat_usage_additions PROTO((void));
void vstrflat_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
