 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vsymdif.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vsymdif_get_args
| 
|       Purpose: Gets command line args for vsymdif
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vsymdif
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vsymdif_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vsymdif is out of sync with arguments specified in vsymdif's *.pane file; please rerun ghostwriter on vsymdif.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vsymdif structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vsymdif_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vsymdif_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vsymdif_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Symmetric Difference' image",
  "-P 1 0 52x1+0+1 +6+0 ' ' vsymdif",
  "-Q 1 0 5x1+47+0 'Close'",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input Image #1' 'input image' i1",
  "-I 1 0 0 1 0 0 52x1+0+3 ' ' 'Input Image #2' 'input image' i2",
  "-O 1 0 0 1 0 0 52x1+0+5 ' ' 'Output Image' 'output image' o",
  "-R 1 0 4 5x1+35+0 'Run' 'Execute operation' $MMACH/bin/vsymdif",
  "-H 1 5x1+41+0 'Help' 'Man page for vsymdif' $MMACH/objects/kroutine/vsymdif/help help",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vsymdif/uis/vsymdif.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


