 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vthreshm.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vthreshm_get_args
| 
|       Purpose: Gets command line args for vthreshm
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vthreshm
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vthreshm_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vthreshm is out of sync with arguments specified in vthreshm's *.pane file; please rerun ghostwriter on vthreshm.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vthreshm structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vthreshm_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vthreshm_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vthreshm_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "l",
			  &(clui_info->l_int),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "vthreshm_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "vthreshm_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "u",
			  &(clui_info->u_int),
			  &(clui_info->u_flag))))
	{
	    kerror(NULL, "vthreshm_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Adaptive Thresholding of an Image' image",
  "-P 1 0 52x1+0+1 +12+0 ' ' vthreshm",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $MMACHBIN/vthreshm",
  "-H 1  5x1+41+0 'Help' 'man page for vthreshad' $MMACH/objects/kroutine/vthreshm/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input image' 'Image to be compared' i1",
  "-O 1 0 0 1 0 0 52x1+0+10 ' ' 'Output Image  ' 'resulting output image' o",
  "-C 1",
  "-I 1 0 1 0 0 0 50x1+1+4 ' ' 'Lower thresh. Image' 'Lower threshold level' i2",
  "-i 1 0 1 1 0 50x1+1+5 -32768 32767 128 1 0 'Lower threshold level' 'lower thresh. level' l",
  "-E",
  "-C 1",
  "-I 1 0 1 0 0 0 50x1+1+7 ' ' 'Upper thresh. Image' 'Upper thres. level' i3",
  "-i 1 0 1 1 0 50x1+1+8 -32768 32767 255 1 0 'Upper threshold level' 'upper thresh. level' u",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vthreshm/uis/vthreshm.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	22,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


