 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

#include "vwatersh.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vwatersh_get_args
| 
|       Purpose: Gets command line args for vwatersh
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vwatersh
|          Date: May 12, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vwatersh_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vwatersh is out of sync with arguments specified in vwatersh's *.pane file; please rerun ghostwriter on vwatersh.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the vwatersh structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vwatersh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "cv", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->cv_flag))))
	{
	    kerror(NULL, "vwatersh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->cv_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_logical(pane, "lw",
			  &(clui_info->lw_logic),
			  &(clui_info->lw_flag))))
	{
	    kerror(NULL, "vwatersh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vwatersh_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Watershed' image",
  "-P 1 0 52x1+0+1 +12+0 ' ' vwatersh",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'Copyright' '(C)' $MMACH/repos/copyright/Copyright copyright",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $MMACHBIN/vwatersh",
  "-H 1  5x1+41+0 'Help' 'man page for vwatersh' $MMACH/objects/kroutine/vwatersh/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input Image' 'input image' i",
  "-T 1 0 0 1 0 40x1+1+4 +0+0 2 'Connectivity' 'connectivity' cv",
  "-i 1 0 1 0 0 2x1+17+0 4 8 4 1 0 '4 ' '4 connectivity' cv",
  "-i 1 0 1 1 0 2x1+25+0 4 8 8 1 0 '8 ' '8 connectivity' cv",
  "-E",
  "-l 1 0 0 1 0 21x1+1+6 0 'Limited Watershed  ' 'False' 'True ' 'Initialize boundary' lw",
  "-O 1 0 0 1 0 0 52x1+0+8 ' ' 'Output Image' 'resulting output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$MMACH/objects/kroutine/vwatersh/uis/vwatersh.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


