 /*
  * Khoros: $Id$
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id$";
#endif

/*
 * Copyright (C) 1993-1997 Junior Barrera, Roberto Lotufo.
 * All rights reserved.  See $MMACH/repos/license/License.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Library Routine for vstrflat
   >>>> 
   >>>>  Private: 
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 	lvstrflat
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "internals.h"

/* -library_includes */
/* -library_includes_end */


/****************************************************************
* 
*  Routine Name: lvstrflat - Customizes a morphological planar kernel via keyboard entry.
* 
*       Purpose: .I vstrset
Creates a new \fBmorphological planar kernel\fP via keyboard entry (writes a file).
.LP
The term \fBStructuring element\fP is more often used than 
morphological kernel.
*         Input: .IP
.br
1.  ker -  the structuring element.
.br
2.  s00  - pixel (-1, 1) of the structuring element.
.br
3.  s10  - pixel (-1, 0) of the structuring element.
.br
4.  s20  - pixel (-1, -1) of the structuring element.
.br
5.  s01  - pixel (0, 1) of the structuring element.
.br
6.  s11  - pixel (0, 0) of the structuring element.
.br
7.  s21  - pixel (0, -1) of the structuring element.
.br
8.  s02  - pixel (1, 1) of the structuring element.
.br
9.  s12  - pixel (1, 0) of the structuring element.
.br
10. s22 - pixel  (1, -1) of the structuring element.
*        Output: 
*       Returns: TRUE (1) on success, FALSE (0) on failure
*  Restrictions: .I vstrset
will only accept values of 0 (background) or 1 (domain) for the kernel pixel value.
.LP
The structuring element is a subset of the matrix 3x3.
*    Written By: Junior Barrera & Ulisses Braga
*          Date: May 12, 1997
*      Verified: 
*  Side Effects: 
*      Examples: 
* Modifications: 
****************************************************************/
/* -library_def */
int
lvstrset (mat_str *ker, int s00, int s10, int s20, int s01, int s11, int s21, int s02, int s12, int s22)
/* -library_def_end */

/* -library_code */
{

    ker->tag = MM_MAT;

    ker->x[0][0] = s00;
    ker->x[0][1] = s01;
    ker->x[0][2] = s02;
    ker->x[1][0] = s10;
    ker->x[1][1] = s11;
    ker->x[1][2] = s12;
    ker->x[2][0] = s20;
    ker->x[2][1] = s21;
    ker->x[2][2] = s22;

    return(1);
}
/* -library_code_end */
