 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:03:36 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:03:36 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "lrfclass.h"
/*-----------------------------------------------------------
| 
|  Routine Name: lrfclass_get_args
| 
|       Purpose: Gets command line args for lrfclass
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname lrfclass
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void lrfclass_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for lrfclass is out of sync with arguments specified in lrfclass's *.pane file; please rerun ghostwriter on lrfclass.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the lrfclass structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "lrfclass_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "lrfclass_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "lrfclass_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i4",
			  &(clui_info->i4_file),
			  &(clui_info->i4_flag))))
	{
	    kerror(NULL, "lrfclass_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "lrfclass_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "lrfclass_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Classify Image Using the Localized Receptive Field Classifier  (K1)' classify",
  "-P 1 0 52x1+0+1 +0+0 ' ' lrfclass",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/lrfclass",
  "-H 1 5x1+41+0 'Help' 'man page for lrfclass' $RETRO/objects/kroutine/lrfclass/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2.5 ' ' 'Input image' 'input image' i1",
  "-I 1 0 0 1 0 1 52x1+0+3.5 ' ' 'Cluster Center image  ' 'cluster center image' i2",
  "-I 1 0 0 1 0 1 52x1+0+4.5 ' ' 'Cluster Variance image' 'cluster variance image' i3",
  "-I 1 0 0 1 0 1 52x1+0+5.5 ' ' 'Weight image' 'weight image' i4",
  "-i 1 0 1 2 0 51x1+1+7 0 100 0 1 0 'Input Image Border Width' 'Border Width' b",
  "-O 1 0 0 1 0 1 52x1+0+10 ' ' 'Classified image' 'classified image' o",
  "-b +0+1.5 'Input Images:' blank0",
  "-b +0+9 'Output Image:' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/lrfclass/uis/lrfclass.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


