 /*
  * Khoros: $Id: lrftrain.h,v 1.14.2.2 1997/05/31 20:03:53 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for lrftrain
   >>>> 
   >>>>    Written By: Tom Sauer and Charlie Gage
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _lrftrain_h_
#define _lrftrain_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i1_file;	/* input image FILENAME */
int	 i1_flag;	/* input image FLAG */

/*
 *  cluster center image (required infile)
 */
char	*i2_file;	/* cluster center image FILENAME */
int	 i2_flag;	/* cluster center image FLAG */

/*
 *  cluster variance image (required infile)
 */
char	*i3_file;	/* cluster variance image FILENAME */
int	 i3_flag;	/* cluster variance image FLAG */

/*
 *  cluster number image (required infile)
 */
char	*i4_file;	/* cluster number image FILENAME */
int	 i4_flag;	/* cluster number image FLAG */

/*
 *  weight image (required outfile)
 */
char	*o_file;	/* weight image FILENAME */
int	 o_flag;	/* weight image FLAG */

/*
 *  output file for training statistics (required outfile)
 */
char	*f_file;	/* output file for training statistics FILENAME */
int	 f_flag;	/* output file for training statistics FLAG */

/*
 *  Border Width (optional integer)
 */
int	 b_int; 	/* Border Width INT */
int	 b_flag;	/* Border Width FLAG */

/*
 *  convergence value (optional float)
 */
float	 cv_float;	/* convergence value FLOAT */
int	 cv_flag;   	/* convergence value FLAG */

/*
 *  weight update value (optional float)
 */
float	 meu_float;	/* weight update value FLOAT */
int	 meu_flag;   	/* weight update value FLAG */

/*
 *  Maximum number of iterations (optional integer)
 */
int	 n_int; 	/* Maximum number of iterations INT */
int	 n_flag;	/* Maximum number of iterations FLAG */

/*
 *  Min delta MSE value (optional float)
 */
float	 delta_float;	/* Min delta MSE value FLOAT */
int	 delta_flag;   	/* Min delta MSE value FLAG */

/*
 *  MSE display interval (optional integer)
 */
int	 d_int; 	/* MSE display interval INT */
int	 d_flag;	/* MSE display interval FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define CHECKTYPE(program, image) \
   if( !(propertype(program, image, (unsigned long) VFF_TYP_FLOAT, TRUE)) ) { \
      kfprintf(kstderr,"%s: data storage type must be FLOAT.",program); \
      kexit(KEXIT_FAILURE); \
    }

#define CHECKTYPEINT(program, image) \
   if( !(propertype(program, image, (unsigned long) VFF_TYP_4_BYTE, TRUE)) ) { \
      kfprintf(kstderr,"%s: data storage type must be INTEGER.",program); \
      kexit(KEXIT_FAILURE); \
    }

#define CHECKINPUT(program, image) \
        (void) proper_num_images(program,image,(unsigned long) 1,TRUE); \
        \
        (void) proper_map_enable(program,image,(unsigned long) VFF_MAP_OPTIONAL,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void lrftrain_get_args PROTO((kaddr));
void lrftrain_usage_additions PROTO((void));
void lrftrain_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
