 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:03:54 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:03:54 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "lrftrain.h"
/*-----------------------------------------------------------
| 
|  Routine Name: lrftrain_get_args
| 
|       Purpose: Gets command line args for lrftrain
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname lrftrain
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void lrftrain_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for lrftrain is out of sync with arguments specified in lrftrain's *.pane file; please rerun ghostwriter on lrftrain.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the lrftrain structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i4",
			  &(clui_info->i4_file),
			  &(clui_info->i4_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "cv",
			  &(clui_info->cv_float),
			  &(clui_info->cv_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "meu",
			  &(clui_info->meu_float),
			  &(clui_info->meu_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "delta",
			  &(clui_info->delta_float),
			  &(clui_info->delta_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "d",
			  &(clui_info->d_int),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "f",
			  &(clui_info->f_file),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "lrftrain_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Calculate Weights for Localized Receptive Field Classifier  (K1)' classify",
  "-P 1 0 52x1+0+1 +0+0 ' ' lrftrain",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/lrftrain",
  "-H 1 5x1+41+0 'Help' 'man page for lrftrain' $RETRO/objects/kroutine/lrftrain/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Input Image' 'input image' i1",
  "-I 1 0 0 1 0 1 52x1+0+4 ' ' 'Cluster Center Image  ' 'cluster center image' i2",
  "-I 1 0 0 1 0 1 52x1+0+5 ' ' 'Cluster Variance Image' 'cluster variance image' i3",
  "-I 1 0 0 1 0 1 52x1+0+6 ' ' 'Cluster Number Image  ' 'cluster number image' i4",
  "-i 1 0 1 1 0 50x1+2+7.5 0 100 0 1 0 'Input Image Border Width' 'Border Width' b",
  "-f 1 0 1 1 0 50x1+2+10 2 2 0.1 0 1 0 'Convergence Value' 'convergence value' cv",
  "-f 1 0 1 1 0 50x1+2+11 0 1 0.5 0 1 0 'Wt. Update Value ' 'weight update value' meu",
  "-i 1 0 1 1 0 50x1+2+12 2 2 10000000 1 0 'Max Iterations   ' 'Maximum number of iterations' n",
  "-f 1 0 1 1 0 50x1+2+13 2 2 1e-09 0 1 0 'MIN Delta MSE    ' 'Min delta MSE value' delta",
  "-i 1 0 1 1 0 50x1+2+15 1 1 0 1 0 'MSE Display Interval' 'MSE display interval' d",
  "-O 1 0 0 1 0 1 52x1+0+18 ' ' 'Weight Image' 'weight image' o",
  "-O 1 0 0 1 0 1 52x1+0+19 ' ' 'Ascii Stats ' 'output file for training statistics' f",
  "-b +0+2 'Input Files:' blank0",
  "-b +0+17 'Output Files:' blank1",
  "-b +0+9 'Training Parameters:' blank2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/lrftrain/uis/lrftrain.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	27,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


