 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:04:23 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:04:23 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vbandsp3.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vbandsp3_get_args
| 
|       Purpose: Gets command line args for vbandsp3
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vbandsp3
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vbandsp3_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vbandsp3 is out of sync with arguments specified in vbandsp3's *.pane file; please rerun ghostwriter on vbandsp3.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vbandsp3 structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o3",
			  &(clui_info->o3_file),
			  &(clui_info->o3_flag))))
	{
	    kerror(NULL, "vbandsp3_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Extract 3 Bands from a Multiband Image  (K1)' data",
  "-P 1 0 52x1+0+1 +5+0 ' ' vbandspt3",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vbandsp3",
  "-H 1  5x1+41+0 'Help' 'man page for vbandspt3' $RETRO/objects/kroutine/vbandsp3/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image     ' 'input image filename' i",
  "-i 1 0 1 1 0 40x1+3+4 1 1 0 1 0 'Starting Data Band Number' 'Data band number to extract' b",
  "-O 1 0 1 1 0 1 52x1+0+6 ' ' 'Output Image 1' 'output image filename' o1",
  "-O 1 0 1 1 0 1 52x1+0+7 ' ' 'Output Image 2' 'output image filename' o2",
  "-O 1 0 1 1 0 1 52x1+0+8 ' ' 'Output Image 3' 'output image filename' o3",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vbandsp3/uis/vbandsp3.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


