 /*
  * Khoros: $Id: vbandsp3.h,v 1.14.2.2 1997/05/31 20:04:27 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vbandsp3
   >>>> 
   >>>>    Written By: Tom Sauer
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vbandsp3_h_
#define _vbandsp3_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image filename (required infile)
 */
char	*i_file;	/* input image filename FILENAME */
int	 i_flag;	/* input image filename FLAG */

/*
 *  Data band number to extract (optional integer)
 */
int	 b_int; 	/* Data band number to extract INT */
int	 b_flag;	/* Data band number to extract FLAG */

/*
 *  output image filename (optional outfile)
 */
char	*o1_file;	/* output image filename FILENAME */
int	 o1_flag;	/* output image filename FLAG */

/*
 *  output image filename (optional outfile)
 */
char	*o2_file;	/* output image filename FILENAME */
int	 o2_flag;	/* output image filename FLAG */

/*
 *  output image filename (optional outfile)
 */
char	*o3_file;	/* output image filename FILENAME */
int	 o3_flag;	/* output image filename FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define APPENDFILENAME(image, vbandspt3) \
    switch (image->color_space_model) { \
      case VFF_CM_ntscRGB: \
      case VFF_CM_genericRGB: \
      case VFF_CM_cieRGB: \
            if (!vbandspt3->o1_flag) \
                 img1_file = kstring_cat (img1_file, ".R", NULL); \
            if (!vbandspt3->o2_flag) \
                 img2_file = kstring_cat (img2_file, ".G", NULL); \
            if (!vbandspt3->o3_flag) \
                 img3_file = kstring_cat (img3_file, ".B", NULL); \
            break; \
        case VFF_CM_ntscYIQ: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".Y", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".I", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".Q", NULL); \
            break; \
        case VFF_CM_HLS: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".H", NULL); \
            if (!vbandspt3->o2_flag) \
               img2_file =  kstring_cat (img2_file, ".L", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".S", NULL); \
            break; \
        case VFF_CM_HSV: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".H", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".S", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".V", NULL); \
            break; \
        case VFF_CM_ntscCMY: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".C", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".M", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".Y", NULL); \
            break; \
        case VFF_CM_IHS: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".I", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".H", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".S", NULL); \
            break; \
        case VFF_CM_cieXYZ: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".X", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".Y", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".Z", NULL); \
            break; \
        case VFF_CM_cieUVW: \
        case VFF_CM_cieucsUVW: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".U", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".V", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".W", NULL); \
            break; \
        case VFF_CM_cieucsSOW: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".S", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".O", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".W", NULL); \
            break; \
        case VFF_CM_cieucsLab: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".L", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".a", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".b", NULL); \
            break; \
        case VFF_CM_cieucsLuv: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".L", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".u", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".v", NULL); \
            break; \
        case VFF_CM_GENERIC: \
        case VFF_CM_NONE: \
        default: \
            if (!vbandspt3->o1_flag) \
                img1_file = kstring_cat (img1_file, ".1", NULL); \
            if (!vbandspt3->o2_flag) \
                img2_file = kstring_cat (img2_file, ".2", NULL); \
            if (!vbandspt3->o3_flag) \
                img3_file = kstring_cat (img3_file, ".3", NULL); \
            break; \
      }
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vbandsp3_get_args PROTO((kaddr));
void vbandsp3_usage_additions PROTO((void));
void vbandsp3_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
