 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:04:38 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:04:38 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vcast.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vcast_get_args
| 
|       Purpose: Gets command line args for vcast
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vcast
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vcast_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vcast is out of sync with arguments specified in vcast's *.pane file; please rerun ghostwriter on vcast.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vcast structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i4",
			  &(clui_info->i4_file),
			  &(clui_info->i4_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i5",
			  &(clui_info->i5_file),
			  &(clui_info->i5_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &(clui_info->t_toggle),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o3",
			  &(clui_info->o3_file),
			  &(clui_info->o3_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o4",
			  &(clui_info->o4_file),
			  &(clui_info->o4_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o5",
			  &(clui_info->o5_file),
			  &(clui_info->o5_flag))))
	{
	    kerror(NULL, "vcast_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Upconvert All Inputs to the Highest Input Data Type  (K1)' data",
  "-P 1 0 52x1+0+1 +8+0 ' ' vcast",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $RETROBIN/vcast",
  "-H 1  5x1+41+0 'Help' 'man page for vcast' $RETRO/objects/kroutine/vcast/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Input Image 1' 'input image 1' i1",
  "-I 1 0 0 1 0 1 52x1+0+4 ' ' 'Input Image 2' 'input image 2' i2",
  "-I 1 0 1 0 0 1 52x1+0+5 ' ' 'Input Image 3' 'input image 3' i3",
  "-I 1 0 1 0 0 1 52x1+0+6 ' ' 'Input Image 4' 'input image 4' i4",
  "-I 1 0 1 0 0 1 52x1+0+7 ' ' 'Input Image 5' 'input image 5' i5",
  "-T 1 0 1 0 0 45.75x1+2+10 +0+0 1 'Select Data Type (Auto Upcast if Not Selected)' 'Select data type [default = Auto Upcast to Highest Input Data Type]' t",
  "-s 1 0 1 1 0 10x1+4+1 'byte' 'Byte' 'choose byte data type' t",
  "-s 1 0 1 0 0 10x1+22+1 'int' 'Integer' 'choose integer data type' t",
  "-s 1 0 1 0 0 10x1+36+1 'complex' 'Complex' 'choose complex data type' t",
  "-s 1 0 1 0 0 10x1+4+2 'short' 'Short' 'choose short data type' t",
  "-s 1 0 1 0 0 10x1+22+2 'float' 'Float' 'choose float data type' t",
  "-s 1 0 1 0 0 10x1+36+2 'double' 'Double' 'choose double data type' t",
  "-E",
  "-O 1 0 0 1 0 1 52x1+0+15 ' ' 'Output Image 1' 'output image 1' o1",
  "-O 1 0 0 1 0 1 52x1+0+16 ' ' 'Output Image 2' 'output image 2' o2",
  "-O 1 0 1 0 0 1 52x1+0+17 ' ' 'Output Image 3' 'output image 3' o3",
  "-O 1 0 1 0 0 1 52x1+0+18 ' ' 'Output Image 4' 'output image 4' o4",
  "-O 1 0 1 0 0 1 52x1+0+19 ' ' 'Output Image 5' 'output image 5' o5",
  "-b +1+2 'Input Images:' blank0",
  "-b +1+14 'Output Images:' blank1",
  "-b +1+9 'Optional Data Casting:' blank2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vcast/uis/vcast.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	33,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


