 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:04:52 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:04:52 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vclose.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vclose_get_args
| 
|       Purpose: Gets command line args for vclose
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vclose
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vclose_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vclose is out of sync with arguments specified in vclose's *.pane file; please rerun ghostwriter on vclose.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vclose structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vclose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vclose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "grad",
			  &(clui_info->grad_int),
			  &(clui_info->grad_flag))))
	{
	    kerror(NULL, "vclose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "len",
			  &(clui_info->len_int),
			  &(clui_info->len_flag))))
	{
	    kerror(NULL, "vclose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vclose_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Close Boundaries of an Edge Image  (K1)' segment",
  "-P 1 0 52x1+0+1 +0+0 ' ' vclose",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do boundaries closing from a boundary image and a gradient image' $RETROBIN/vclose",
  "-H 1  5x1+41+0 'Help' 'documentation for vclose' $RETRO/objects/kroutine/vclose/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input Boundary Image' 'Input Boundary Image (result from vdrf, vgef, vsdef ...)' i1",
  "-I 1 0 0 1 0 0 52x1+0+3 ' ' 'Input Gradient Image' 'Input Gradient Image (result from vdrf, vsdef, sobel...)' i2",
  "-i 1 0 1 2 1 34x1+2+5 1 1 0 1 0 'Gradient Threshold ' 'Gradient Threshold (used by the closing process)' grad",
  "-i 1 0 1 2 1 34x1+2+6 1 1 1 1 0 'Minimum  Gap  Size ' 'Minimum Gap Size In Pixels' len",
  "-O 1 0 0 1 0 0 52x1+0+8 ' ' 'Output Image ' 'resulting output image or file' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vclose/uis/vclose.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


