 /*
  * Khoros: $Id: vclose.h,v 1.14.2.2 1997/05/31 20:04:57 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vclose
   >>>> 
   >>>>    Written By: Pascal ADAM
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vclose_h_
#define _vclose_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input Boundary Image (result from vdrf, vgef, vsdef ...) (required infile)
 */
char	*i1_file;	/* Input Boundary Image (result from vdrf, vgef, vsdef ...) FILENAME */
int	 i1_flag;	/* Input Boundary Image (result from vdrf, vgef, vsdef ...) FLAG */

/*
 *  Input Gradient Image (result from vdrf, vsdef, sobel...) (required infile)
 */
char	*i2_file;	/* Input Gradient Image (result from vdrf, vsdef, sobel...) FILENAME */
int	 i2_flag;	/* Input Gradient Image (result from vdrf, vsdef, sobel...) FLAG */

/*
 *  resulting output image or file (required outfile)
 */
char	*o_file;	/* resulting output image or file FILENAME */
int	 o_flag;	/* resulting output image or file FLAG */

/*
 *  Gradient Threshold (used by the closing process) (optional integer)
 */
int	 grad_int; 	/* Gradient Threshold (used by the closing process) INT */
int	 grad_flag;	/* Gradient Threshold (used by the closing process) FLAG */

/*
 *  Minimum Gap Size In Pixels (optional integer)
 */
int	 len_int; 	/* Minimum Gap Size In Pixels INT */
int	 len_flag;	/* Minimum Gap Size In Pixels FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT(edge,gradient) \
edge = readimage(clui_info->i1_file);  \
gradient = readimage(clui_info->i2_file); \
if (edge == NULL || gradient == NULL) {  \
   (void) kfprintf(kstderr,"vclose: Can not read input images \n");  \
   kexit(KEXIT_FAILURE);  /* Quit if bad image */ \
}
#define CHECKINPUT(program, edge, gradient) \
    propertype(program,edge,VFF_TYP_1_BYTE,TRUE); \
    proper_num_images(program,edge,1,TRUE);  \
    proper_num_bands(program,edge,1,TRUE);  \
    proper_map_enable(program,edge,VFF_MAP_OPTIONAL,TRUE); \
    propertype(program,gradient,VFF_TYP_1_BYTE,TRUE); \
    proper_num_images(program,gradient,1,TRUE);  \
    proper_num_bands(program,gradient,1,TRUE);  \
    proper_map_enable(program,gradient,VFF_MAP_OPTIONAL,TRUE);
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vclose_get_args PROTO((kaddr));
void vclose_usage_additions PROTO((void));
void vclose_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
