 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:05:11 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:05:11 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vcltrans.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vcltrans_get_args
| 
|       Purpose: Gets command line args for vcltrans
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vcltrans
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vcltrans_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vcltrans is out of sync with arguments specified in vcltrans's *.pane file; please rerun ghostwriter on vcltrans.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the vcltrans structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vcltrans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "n",
			  &(clui_info->n_float),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vcltrans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vcltrans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->t_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vcltrans_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Convert Between Tristimulus Color Spaces' color",
  "-P 1 0 50x1+0+1 +4+0 ' ' vcltrans",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vcltrans",
  "-H 1  5x1+41+0 'Help' 'man page for vcltrans' $RETRO/objects/kroutine/vcltrans/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image ' 'input image' i",
  "-f 1 0 1 2 1 39.25x1+2+4 2 2 255 0 1 0 'Normalization Factor' 'specifies normalization factor' n",
  "-T 1 0 1 2 0 37x4+2+5.5 +0+0 1 'Color space model: ' 'lets user chose color space model' t",
  "-i 1 0 1 1 0 10x1+5+1 1 6 1 1 0 'ntscRGB' 'ntscRGB' t",
  "-i 1 0 1 0 0 10x1+25+1 1 6 2 1 0 'genericRGB' 'genericRGB' t",
  "-i 1 0 1 0 0 10x1+5+2 1 6 4 1 0 'ntscCMY' 'ntscCMY' t",
  "-i 1 0 1 0 0 10x1+25+2 1 6 3 1 0 'ntscYIQ' 'ntscYIQ' t",
  "-i 1 0 1 0 0 10x1+5+3 1 6 5 1 0 'cieXYZ' 'cieXYZ' t",
  "-i 1 0 1 0 0 10x1+25+3 1 6 6 1 0 'cieUVW' 'cieUVW' t",
  "-E",
  "-O 1 0 0 1 0 1 52x1+0+10.5 ' ' 'Output Image' 'output resulting image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vcltrans/uis/vcltrans.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	23,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


