 /*
  * Khoros: $Id: vcltrans.c,v 1.14.2.3 1997/05/31 20:05:15 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: vcltrans.c,v 1.14.2.3 1997/05/31 20:05:15 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for vcltrans
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "vcltrans.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Convert Between Tristimulus Color Spaces
|
|       Purpose: main program for vcltrans
|
|         Input:
|		char *clui_info->i_file; {input image}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->o_file; {output resulting image}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|		float clui_info->n_float; {specifies normalization factor}
|		int   clui_info->n_flag; {TRUE if -n specified}
|
|		int clui_info->t_toggle; {lets user chose color space model}
|		int clui_info->t_flag; {TRUE if -t specified}
|
|        Output:
|       Returns:
|
|    Written By: Donna Koechner, Tom Sauer
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
char *program = "vcltrans";
xvimage *image, *dummy=NULL;
/* -main_variable_list_end */

	khoros_init(argc, argv, "RETRO", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$RETRO/objects/kroutine/vcltrans");
	kexit_handler(vcltrans_free_args, NULL);

/* -main_get_args_call */
	kclui_init("RETRO", "vcltrans", KGEN_KROUTINE,  &clui_uis_spec,
		   vcltrans_usage_additions, vcltrans_get_args,
 		   vcltrans_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
READINPUT (image);
CHECKINPUT (program, image);
CHECKCOLORMODEL (program, image);
/* -main_before_lib_call_end */

/* -main_library_call */
if(! lvcltrans(image, clui_info->t_toggle, clui_info->t_flag, clui_info->n_float, clui_info->n_flag, 0, dummy))
 {
    (void) kerror(NULL, NULL, "lvcltrans Failed");
    kexit(1);
 }
/* -main_library_call_end */

/* -main_after_lib_call */
writeimage(clui_info->o_file,image);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: vcltrans_usage_additions
| 
|       Purpose: Prints usage additions in vcltrans_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vcltrans
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vcltrans_usage_additions(void)
{
	kfprintf(kstderr, "\tConvert Between Tristimulus Color Spaces\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: vcltrans_free_args
| 
|       Purpose: Frees CLUI struct allocated in vcltrans_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vcltrans
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
vcltrans_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
