 /*
  * Khoros: $Id: vcltrans.h,v 1.14.2.2 1997/05/31 20:05:18 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vcltrans
   >>>> 
   >>>>    Written By: Donna Koechner, Tom Sauer
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vcltrans_h_
#define _vcltrans_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  output resulting image (required outfile)
 */
char	*o_file;	/* output resulting image FILENAME */
int	 o_flag;	/* output resulting image FLAG */

/*
 *  specifies normalization factor (optional float)
 */
float	 n_float;	/* specifies normalization factor FLOAT */
int	 n_flag;   	/* specifies normalization factor FLAG */

/*
 * lets user chose color space model (Optional integer toggle)
 *	1 (ntscRGB)
 *	2 (genericRGB)
 *	4 (ntscCMY)
 *	3 (ntscYIQ)
 *	5 (cieXYZ)
 *	6 (cieUVW),
 */
int	 t_toggle;		/* lets user chose color space model INT TOGGLE */
int	 t_flag;		/* lets user chose color space model FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT(image) \
    image = readimage(clui_info->i_file); \
    if(image == NULL){ \
        (void) kfprintf(kstderr,"vcltrans: Image could not be read\\n"); \
        kexit(1); \
    }

#define CHECKINPUT(program, image) \
        (void) proper_num_images(program,image,1,TRUE); \
        \
        (void) proper_num_bands(program,image,3,TRUE); \
        \
        (void) proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE); \
        \
        (void) propertype(program, image, VFF_TYP_FLOAT, FALSE)

#define CHECKCOLORMODEL(program, image1) \
   if ( ! (proper_color_model(program, image1, VFF_CM_ntscRGB, FALSE)) && \
       ! (proper_color_model(program, image1, VFF_CM_genericRGB, FALSE)) && \
       ! (proper_color_model(program, image1, VFF_CM_ntscYIQ, FALSE)) && \
       ! (proper_color_model(program, image1, VFF_CM_ntscCMY, FALSE)) && \
       ! (proper_color_model(program, image1, VFF_CM_cieXYZ, FALSE)) && \
       ! (proper_color_model(program, image1, VFF_CM_cieUVW, FALSE))) { \
       kerror(NULL, NULL, "Input image has an invalid color space model"); \
       kerror(NULL, NULL, "Valid color space models are:\n" \
              "ntscRGB, genericRGB, ntscYIQ, ntscCMY, cieXYZ, cieUVW"); \
       kexit(1); \
   }
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vcltrans_get_args PROTO((kaddr));
void vcltrans_usage_additions PROTO((void));
void vcltrans_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
