 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:05:53 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:05:53 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vconvert.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vconvert_get_args
| 
|       Purpose: Gets command line args for vconvert
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vconvert
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vconvert_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vconvert is out of sync with arguments specified in vconvert's *.pane file; please rerun ghostwriter on vconvert.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vconvert structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &(clui_info->t_toggle),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_logical(pane, "b",
			  &(clui_info->b_logic),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "n",
			  &(clui_info->n_float),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "s",
			  &(clui_info->s_float),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vconvert_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Convert Data Storage Type  (K1)' data",
  "-P 1 0 52x1+0+1 +8+0 ' ' vconvert",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vconvert",
  "-H 1 5x1+41+0 'Help' 'man page for vconvert' $RETRO/objects/kroutine/vconvert/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image ' 'input image' i",
  "-T 1 0 1 1 0 49.5x3+2+6.5 +0+0 2 'Output Data Type' 'lets user choose output data type' t",
  "-s 1 0 1 0 0 10x1+4+1 'bit' 'Bit (packed)' 'choose bit data type' t",
  "-s 1 0 1 1 0 10x1+22+1 'int' 'Integer' 'choose integer data type' t",
  "-s 1 0 1 0 0 10x1+36+1 'double' 'Double' 'choose double data type' t",
  "-s 1 0 1 0 0 10x1+4+2 'byte' 'Byte' 'choose byte data type' t",
  "-s 1 0 1 0 0 10x1+22+2 'float' 'Float' 'choose float data type' t",
  "-s 1 0 1 0 0 10x1+36+2 'dcomplex' 'Double Complex' 'choose double data type' t",
  "-s 1 0 1 0 0 10x1+4+3 'short' 'Short' 'choose short data type' t",
  "-s 1 0 1 0 0 10x1+22+3 'complex' 'Complex' 'choose complex data type' t",
  "-E",
  "-l 1 0 1 1 0 34.5x1+2+11.5 0 'Independent band processing' 'False' 'True' 'if true, bands are processed independently' b",
  "-O 1 0 0 1 0 1 52x1+0+13.5 ' ' 'Output Image' 'resulting output image' o",
  "-C 0",
  "-f 1 0 1 0 1 39.5x1+2+4 2 2 255 0 1 0 'Normalization Value' 'specifies normalization value' n",
  "-f 1 0 1 0 1 39.5x1+2+5 0 0 1 0 1 0 'Scale Factor       ' 'specifies scale factor' s",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vconvert/uis/vconvert.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	29,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


