 /*
  * Khoros: $Id: vconvert.h,v 1.14.2.2 1997/05/31 20:05:56 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vconvert
   >>>> 
   >>>>    Written By: Scott Wilson
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vconvert_h_
#define _vconvert_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  resulting output image (required outfile)
 */
char	*o_file;	/* resulting output image FILENAME */
int	 o_flag;	/* resulting output image FLAG */

/*
 * lets user choose output data type (Optional string toggle)
 *	bit (choose bit data type)
 *	int (choose integer data type)
 *	double (choose double data type)
 *	byte (choose byte data type)
 *	float (choose float data type)
 *	dcomplex (choose double data type)
 *	short (choose short data type)
 *	complex (choose complex data type),
 */
char	*t_toggle;		/* lets user choose output data type STRING TOGGLE */
int	 t_flag;		/* lets user choose output data type FLAG */

/*
 *  if true, bands are processed independently (optional logical)
 */
int	 b_logic;	/* if true, bands are processed independently LOGIC */
int	 b_flag;  	/* if true, bands are processed independently FLAG */

/*----- optional ME group ----*/
/*
 *  specifies normalization value (optional float)
 */
float	 n_float;	/* specifies normalization value FLOAT */
int	 n_flag;   	/* specifies normalization value FLAG */

/*
 *  specifies scale factor (optional float)
 */
float	 s_float;	/* specifies scale factor FLOAT */
int	 s_flag;   	/* specifies scale factor FLAG */

/*-- optional ME group end ---*/

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define CHECKINPUT(program, image) \
        (void) proper_num_images(program,image,1,TRUE); \
        \
        (void) proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vconvert_get_args PROTO((kaddr));
void vconvert_usage_additions PROTO((void));
void vconvert_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
