 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:06:31 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:06:31 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vdetilt.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vdetilt_get_args
| 
|       Purpose: Gets command line args for vdetilt
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vdetilt
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vdetilt_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vdetilt is out of sync with arguments specified in vdetilt's *.pane file; please rerun ghostwriter on vdetilt.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vdetilt structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vdetilt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "m",
			  &(clui_info->m_file),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vdetilt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "p",
			  &(clui_info->p_logic),
			  &(clui_info->p_flag))))
	{
	    kerror(NULL, "vdetilt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vdetilt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Remove Illumination Gradient by Subtracting Best-Fit Plane  (K1)' gis_surface",
  "-P 1 0 52x1+0+1 +4+0 ' ' vdetilt",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vdetilt",
  "-H 1  5x1+41+0 'Help' 'man page for vdetilt' $RETRO/objects/kroutine/vdetilt/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image   ' 'input image' i",
  "-I 1 0 1 0 0 1 52x1+0+3 ' ' 'Masking Image ' 'find tilt  operation masking image' m",
  "-l 1 0 1 2 0 20x1+4+5 1 'Remove Mean   ' 'False' 'True' 'if yes, remove mean from image' p",
  "-O 1 0 0 1 0 1 52x1+0+7 ' ' 'Output Image  ' 'resulting detilted image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vdetilt/uis/vdetilt.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	16,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


