 /*
  * Khoros: $Id: vdetilt.h,v 1.14.2.2 1997/05/31 20:06:34 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vdetilt
   >>>> 
   >>>>    Written By: Scott Wilson
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vdetilt_h_
#define _vdetilt_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  resulting detilted image (required outfile)
 */
char	*o_file;	/* resulting detilted image FILENAME */
int	 o_flag;	/* resulting detilted image FLAG */

/*
 *  find tilt  operation masking image (optional infile)
 */
char	*m_file;	/* find tilt  operation masking image FILENAME */
int	 m_flag;	/* find tilt  operation masking image FLAG */

/*
 *  if yes, remove mean from image (optional logical)
 */
int	 p_logic;	/* if yes, remove mean from image LOGIC */
int	 p_flag;  	/* if yes, remove mean from image FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT1(img1) \
    img1 = readimage(clui_info->i_file); \
    if(img1 == NULL){ \
        kerror("vipl","vdetilt", "Image could not be read\n"); \
        kexit(KEXIT_FAILURE); \
    }

#define READINPUT2(img2) \
    img2 = readimage(clui_info->m_file); \
    if(img2 == NULL){ \
        kerror("vipl","vdetilt","Masking image could not be read\n"); \
        kexit(KEXIT_FAILURE); \
    }

#define CHECKINPUT(program, img1) \
        (void) proper_num_images(program,img1,1,TRUE); \
        \
        (void) proper_num_bands(program,img1,1,TRUE); \
        \
        (void) proper_map_enable(program,img1,VFF_MAP_OPTIONAL,TRUE)

#define MATCHINPUT(program, img1, img2) \
        (void) match_num_images(program,img1,img2,TRUE); \
        \
        (void) match_num_bands(program,img1,img2,TRUE); \
        \
        (void) match_map_enable(program,img1,img2,TRUE); \
        \
        (void) matchsize(program,img1,img2,TRUE); \
        (void) matchtype(program,img1,img2,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vdetilt_get_args PROTO((kaddr));
void vdetilt_usage_additions PROTO((void));
void vdetilt_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
