 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:07:00 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:07:00 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vdrf.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vdrf_get_args
| 
|       Purpose: Gets command line args for vdrf
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vdrf
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vdrf_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vdrf is out of sync with arguments specified in vdrf's *.pane file; please rerun ghostwriter on vdrf.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vdrf structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vdrf_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "a1",
			  &(clui_info->a1_float),
			  &(clui_info->a1_flag))))
	{
	    kerror(NULL, "vdrf_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "a2",
			  &(clui_info->a2_float),
			  &(clui_info->a2_flag))))
	{
	    kerror(NULL, "vdrf_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "w",
			  &(clui_info->w_int),
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "vdrf_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "t1",
			  &(clui_info->t1_int),
			  &(clui_info->t1_flag))))
	{
	    kerror(NULL, "vdrf_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "t2",
			  &(clui_info->t2_int),
			  &(clui_info->t2_flag))))
	{
	    kerror(NULL, "vdrf_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "l",
			  &(clui_info->l_int),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "vdrf_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vdrf_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Optimal Difference Recursive Filter for Edge Detection  (K1)' 2Dspatl",
  "-P 1 0 52x1+0+1 +13+0 ' ' vdrf",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vdrf",
  "-H 1  5x1+41+0 'Help' 'man page for visef' $RETRO/objects/kroutine/vdrf/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input  Image' 'input image' i",
  "-f 1 0 1 2 0 48x1+4+5 0 1 0.3 0 1 0 ' a1 ' 'a1 Exponential Filter Parameter for DRF' a1",
  "-f 1 0 1 2 0 48x1+4+6 0 1 0.3 0 1 0 ' a2 ' 'a2 Exponential Filter Parameter for DRF' a2",
  "-i 1 0 1 2 0 48x1+4+7.5 0 11 5 1 0 'Window Size (0-11, odd) ' 'Window size for calculating the adaptive gradient' w",
  "-i 1 0 1 2 0 48x1+4+10 0 255 12 1 0 ' T1 ' '1st Hysteresis Threshold' t1",
  "-i 1 0 1 2 0 48x1+4+11 0 255 15 1 0 ' T2 ' '2nd Hysteresis Threshold' t2",
  "-i 1 0 1 2 0 48x1+4+13.5 0 100000 10 1 0 'Length' 'Minimum Pixel Number in a Segment' l",
  "-O 1 0 0 1 0 1 52x1+0+15.5 ' ' 'Output Image' 'output image' o",
  "-b +2+4 'Filter Parameters:' blank0",
  "-b +2+9 'Hysteresis Thresholds:' blank1",
  "-b +2+12.5 'Minimum Length of a Segment (in Pixels)' blank2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vdrf/uis/vdrf.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	23,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


