 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:07:13 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:07:13 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "venhance.h"
/*-----------------------------------------------------------
| 
|  Routine Name: venhance_get_args
| 
|       Purpose: Gets command line args for venhance
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname venhance
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void venhance_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for venhance is out of sync with arguments specified in venhance's *.pane file; please rerun ghostwriter on venhance.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the venhance structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "venhance_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "w",
			  &(clui_info->w_int),
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "venhance_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "h",
			  &(clui_info->h_int),
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "venhance_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "k",
			  &(clui_info->k_float),
			  &(clui_info->k_flag))))
	{
	    kerror(NULL, "venhance_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "v",
			  &(clui_info->v_float),
			  &(clui_info->v_flag))))
	{
	    kerror(NULL, "venhance_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "venhance_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Enhance Image Using the Local Standard Deviation & Mean  (K1)' histogram",
  "-P 1 0 52x1+0+1 +0+0 ' ' venhance",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/venhance",
  "-H 1  5x1+41+0 'Help' 'man page for venhance' $RETRO/objects/kroutine/venhance/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image   ' 'input image filename' i",
  "-i 1 0 1 2 0 50x1+2+4 1 100 3 1 0 'Window Width ' 'window width of local area' w",
  "-i 1 0 1 2 0 50x1+2+5 1 100 3 1 0 'Window Height' 'window height of local area' h",
  "-f 1 0 1 2 0 50x1+2+6.5 0 1 0.5 0 1 0 'Tuning factor' 'specifies scale factor' k",
  "-f 1 0 1 2 0 50x1+2+7.5 0 2000 1 0 1 0 'Min Std Dev  ' 'specifies minimum standard deviation' v",
  "-O 1 0 0 1 0 1 52x1+0+9.5 ' ' 'Output Image  ' 'output image filename' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/venhance/uis/venhance.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	18,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


