 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:07:27 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:07:27 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vfht.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vfht_get_args
| 
|       Purpose: Gets command line args for vfht
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vfht
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vfht_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vfht is out of sync with arguments specified in vfht's *.pane file; please rerun ghostwriter on vfht.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vfht structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vfht_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "s",
			  &(clui_info->s_logic),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vfht_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vfht_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute 2-D Fast Hadamard Transform  (K1)' trans_2D",
  "-P 1 0 52x1+0+1 +13+0 ' ' vfht",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vfht",
  "-H 1  5x1+41+0 'Help' 'man page for vfht' $RETRO/objects/kroutine/vfht/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input File ' 'input image (viff file)' i",
  "-l 1 0 1 2 0 39.75x1+4+4 0 'Scale Output by 1/N  ' 'No Scale' ' Scale  ' 'scale output by 1/N (0 = no scale, 1 = scale)' s",
  "-O 1 0 0 1 0 1 52x1+0+6 ' ' 'Output File' 'output image (viff file)' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vfht/uis/vfht.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


