 /*
  * Khoros: $Id: vfractal.h,v 1.14.2.2 1997/05/31 20:07:42 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vfractal
   >>>> 
   >>>>    Written By: Charlie Gage
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vfractal_h_
#define _vfractal_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image filename (required infile)
 */
char	*i_file;	/* input image filename FILENAME */
int	 i_flag;	/* input image filename FLAG */

/*
 *  output image filename (required outfile)
 */
char	*o_file;	/* output image filename FILENAME */
int	 o_flag;	/* output image filename FLAG */

/*
 *  region size argument (optional integer)
 */
int	 r_int; 	/* region size argument INT */
int	 r_flag;	/* region size argument FLAG */

/*
 *  initial window size argument (optional integer)
 */
int	 w_int; 	/* initial window size argument INT */
int	 w_flag;	/* initial window size argument FLAG */

/*
 *  step size argument (optional integer)
 */
int	 s_int; 	/* step size argument INT */
int	 s_flag;	/* step size argument FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT(image) \
    image = readimage(clui_info->i_file); \
    if(image == NULL){ \
        (void) kfprintf(kstderr,"vfractal: Image could not be read\n"); \
        kexit(KEXIT_FAILURE); \
    }

#define CHECKINPUT(program, image) \
        (void) proper_num_images(program,image,1,TRUE); \
        \
        (void) proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vfractal_get_args PROTO((kaddr));
void vfractal_usage_additions PROTO((void));
void vfractal_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
