 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:07:52 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:07:52 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vgamth.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vgamth_get_args
| 
|       Purpose: Gets command line args for vgamth
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vgamth
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vgamth_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vgamth is out of sync with arguments specified in vgamth's *.pane file; please rerun ghostwriter on vgamth.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vgamth structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vgamth_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vgamth_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vgamth_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "d",
			  &(clui_info->d_int),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "vgamth_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "e",
			  &(clui_info->e_int),
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "vgamth_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "f",
			  &(clui_info->f_int),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "vgamth_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "g",
			  &(clui_info->g_int),
			  &(clui_info->g_flag))))
	{
	    kerror(NULL, "vgamth_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "v",
			  &(clui_info->v_int),
			  &(clui_info->v_flag))))
	{
	    kerror(NULL, "vgamth_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vgamth_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Generate a Binary Image by Thresholding a Color Image  (K1)' segment",
  "-P 1 0 52x1+0+1 +0+0 ' ' vgamth",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vgamth",
  "-H 1  5x1+41+0 'Help' 'man page for vgamth' $RETRO/objects/kroutine/vgamth/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image ' 'input image' i",
  "-i 1 0 1 2 0 50x1+2+4 0 255 128 1 0 'High Threshold Map Column 1 (RED)  ' 'high threshold for map column 1' b",
  "-i 1 0 1 2 0 50x1+2+5 0 255 128 1 0 'Low Threshold Map Column 1 (RED)   ' 'low threshold for map column 1' c",
  "-i 1 0 1 2 0 50x1+2+6 0 255 128 1 0 'High Threshold Map Column 2 (GREEN)' 'high threshold for map column 2' d",
  "-i 1 0 1 2 0 50x1+2+7 0 255 128 1 0 'Low Threshold Map Column 2 (GREEN) ' 'low threshold for map column 2' e",
  "-i 1 0 1 2 0 50x1+2+8 0 255 128 1 0 'High Threshold Map Column 3 (BLUE) ' 'high threshold for map column 3' f",
  "-i 1 0 1 2 0 50x1+2+9 0 255 128 1 0 'Low Threshold Map Column 3 (BLUE)  ' 'low threshold for map column 3' g",
  "-i 1 0 1 2 0 50x1+2+10 0 255 128 1 0 'Non-Zero Output Value              ' 'non-zero output value' v",
  "-O 1 0 0 1 0 1 52x1+0+12 ' ' 'Output Image' 'resulting image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vgamth/uis/vgamth.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	21,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


