 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 20:08:05 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 20:08:05 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vgbox.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vgbox_get_args
| 
|       Purpose: Gets command line args for vgbox
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vgbox
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vgbox_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vgbox is out of sync with arguments specified in vgbox's *.pane file; please rerun ghostwriter on vgbox.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vgbox structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "trigger",
			  &(clui_info->trigger_file),
			  &(clui_info->trigger_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "px_h",
			  &(clui_info->px_h_float),
			  &(clui_info->px_h_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "px_w",
			  &(clui_info->px_w_float),
			  &(clui_info->px_w_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "px_y_off",
			  &(clui_info->px_y_off_float),
			  &(clui_info->px_y_off_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "px_x_off",
			  &(clui_info->px_x_off_float),
			  &(clui_info->px_x_off_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "h",
			  &(clui_info->h_float),
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "w",
			  &(clui_info->w_float),
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "im_y_off",
			  &(clui_info->im_y_off_float),
			  &(clui_info->im_y_off_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "im_x_off",
			  &(clui_info->im_x_off_float),
			  &(clui_info->im_x_off_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "angle",
			  &(clui_info->angle_float),
			  &(clui_info->angle_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "corner_angl",
			  &(clui_info->corner_angl_float),
			  &(clui_info->corner_angl_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "g_o",
			  &(clui_info->g_o_int),
			  &(clui_info->g_o_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "g_i",
			  &(clui_info->g_i_int),
			  &(clui_info->g_i_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vgbox_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create Image of Parallelogram Projected onto CCD Sensor  (K1)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' vgbox",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vgbox",
  "-H 1  5x1+41+0 'Help' 'Help for vsymbox' $RETRO/objects/kroutine/vgbox/help/vgbox.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 1 0 0 0 52x1+0+2 ' ' 'Trigger Input' 'trigger input' trigger",
  "-i 1 0 1 2 0 46x1+3+4 1 1 512 1 0 'Number of Rows          ' 'Number of Rows (Height in pixels) of the CCD sensor' r",
  "-i 1 0 1 2 0 46x1+3+5 1 1 512 1 0 'Number of Columns       ' 'Number of Columns (Width in pixels) of the CCD sensor' c",
  "-f 1 0 1 2 0 46x1+3+6 0 1 1 0 1 0 'Pixel Height            ' 'Active Pixel Height (vertical)  ' px_h",
  "-f 1 0 1 2 0 46x1+3+7 0 1 1 0 1 0 'Pixel Width             ' 'Active Pixel Width (horizontal) ' px_w",
  "-f 1 0 1 2 0 46x1+3+8 0 1 0 0 1 0 'Pixel Downward Offset   ' 'Active Pixel offset from the top  of the cell' px_y_off",
  "-f 1 0 1 2 0 46x1+3+9 0 1 0 0 1 0 'Pixel Right Offset      ' 'Active Pixel offset from the left of the cell' px_x_off",
  "-f 1 0 1 2 0 46x1+3+11 1 1 40.3 0 1 0 'Box Y Height            ' 'Height of the parallelogram (box) (in pixel unit)' h",
  "-f 1 0 1 2 0 46x1+3+12 2 2 20.6 0 1 0 'Box X Width             ' 'Width  of the parallelogram (box) (in pixel unit)' w",
  "-f 1 0 1 2 0 46x1+3+13 0 0 0 0 1 0 'Box Downward Offset     ' 'Downward offset of box (0 is CCD center = box center)' im_y_off",
  "-f 1 0 1 2 0 46x1+3+14 0 0 0 0 1 0 'Box Right  Offset       ' 'Right    offset of box (0 is CCD center = box center)' im_x_off",
  "-f 1 0 1 2 0 46x1+3+16 0 0 15 0 1 0 'Box Rotation Angle      ' 'Box rotation (clockwise degrees, center = box center)' angle",
  "-f 1 0 1 2 0 46x1+3+17 1e-06 179.999 90 0 1 0 'Box Corner Angle        ' 'the value of the 1st corner angle (degrees)' corner_angl",
  "-i 1 0 1 2 0 46x1+3+18 0 255 10 1 0 'Outside Box Pixels Value' 'Grey level of the background pixels outside of box' g_o",
  "-i 1 0 1 2 0 46x1+3+19 0 255 200 1 0 'Inside  Box Pixels Value' 'Grey level of the lighted pixels inside of box' g_i",
  "-O 1 0 0 1 0 0 52x1+0+21 ' ' 'Output Image Name' 'resulting output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vgbox/uis/vgbox.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	28,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


