 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:08:18 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:08:18 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vgcirc.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vgcirc_get_args
| 
|       Purpose: Gets command line args for vgcirc
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vgcirc
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vgcirc_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vgcirc is out of sync with arguments specified in vgcirc's *.pane file; please rerun ghostwriter on vgcirc.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vgcirc structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "trigger",
			  &(clui_info->trigger_file),
			  &(clui_info->trigger_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "d",
			  &(clui_info->d_float),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "x",
			  &(clui_info->x_float),
			  &(clui_info->x_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "y",
			  &(clui_info->y_float),
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "b",
			  &(clui_info->b_float),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "f",
			  &(clui_info->f_float),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &(clui_info->t_toggle),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vgcirc_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create Image of a Filled Circle  (K1)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' vgcirc",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vgcirc",
  "-H 1  5x1+41+0 'Help' 'man page for vgcirc' $RETRO/objects/kroutine/vgcirc/help/vgcirc.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 1 0 0 0 52x1+0+2 ' ' 'Trigger Input' 'trigger input' trigger",
  "-i 1 0 1 2 1 30x1+3+4 2 2 512 1 0 'Rows    ' 'Number of rows in output image' r",
  "-i 1 0 1 2 1 30x1+3+5 2 2 512 1 0 'Columns ' 'Number of columns in output image' c",
  "-f 1 0 1 2 1 46x1+3+7 1 1 256 0 1 0 'Diameter of circle (in pixels)  ' 'Diameter of circle (in pixels)' d",
  "-f 1 0 1 2 1 46x1+3+8 0 0 256 0 1 0 'X coordinate of center of circle' 'X coordinate of center of circle' x",
  "-f 1 0 1 2 1 46x1+3+9 0 0 256 0 1 0 'Y coordinate of center of circle' 'Y coordinate of center of circle' y",
  "-f 1 0 1 2 1 35x1+3+11 0 0 0 0 1 0 'Background level' 'Background level' b",
  "-f 1 0 1 2 1 35x1+3+12 0 0 255 0 1 0 'Foreground level' 'Foreground level' f",
  "-T 1 0 1 2 0 39.5x1+3+14 +0+0 1 'Output data type:' 'Selects data type of output image' t",
  "-s 1 0 1 1 0 2x1+20+0 'byte' 'BYTE' 'choose Byte data storage type' not_used",
  "-s 1 0 1 0 0 2x1+31+0 'float' 'FLOAT' 'choose Float data storage type' not_used",
  "-E",
  "-O 1 0 0 1 0 1 52x1+0+16 ' ' 'Output image' 'output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vgcirc/uis/vgcirc.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	25,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


