 /*
  * Khoros: $Id: vgcirc.h,v 1.14.2.2 1997/05/31 20:08:20 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vgcirc
   >>>> 
   >>>>    Written By: Scott Wilson
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vgcirc_h_
#define _vgcirc_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  output image (required outfile)
 */
char	*o_file;	/* output image FILENAME */
int	 o_flag;	/* output image FLAG */

/*
 *  trigger input (optional infile)
 */
char	*trigger_file;	/* trigger input FILENAME */
int	 trigger_flag;	/* trigger input FLAG */

/*
 *  Number of rows in output image (optional integer)
 */
int	 r_int; 	/* Number of rows in output image INT */
int	 r_flag;	/* Number of rows in output image FLAG */

/*
 *  Number of columns in output image (optional integer)
 */
int	 c_int; 	/* Number of columns in output image INT */
int	 c_flag;	/* Number of columns in output image FLAG */

/*
 *  Diameter of circle (in pixels) (optional float)
 */
float	 d_float;	/* Diameter of circle (in pixels) FLOAT */
int	 d_flag;   	/* Diameter of circle (in pixels) FLAG */

/*
 *  X coordinate of center of circle (optional float)
 */
float	 x_float;	/* X coordinate of center of circle FLOAT */
int	 x_flag;   	/* X coordinate of center of circle FLAG */

/*
 *  Y coordinate of center of circle (optional float)
 */
float	 y_float;	/* Y coordinate of center of circle FLOAT */
int	 y_flag;   	/* Y coordinate of center of circle FLAG */

/*
 *  Background level (optional float)
 */
float	 b_float;	/* Background level FLOAT */
int	 b_flag;   	/* Background level FLAG */

/*
 *  Foreground level (optional float)
 */
float	 f_float;	/* Foreground level FLOAT */
int	 f_flag;   	/* Foreground level FLAG */

/*
 * Selects data type of output image (Optional string toggle)
 *	byte (choose Byte data storage type)
 *	float (choose Float data storage type),
 */
char	*t_toggle;		/* Selects data type of output image STRING TOGGLE */
int	 t_flag;		/* Selects data type of output image FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vgcirc_get_args PROTO((kaddr));
void vgcirc_usage_additions PROTO((void));
void vgcirc_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
