 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:08:55 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:08:55 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vgfractal.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vgfractal_get_args
| 
|       Purpose: Gets command line args for vgfractal
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vgfractal
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vgfractal_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vgfractal is out of sync with arguments specified in vgfractal's *.pane file; please rerun ghostwriter on vgfractal.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vgfractal structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "trigger",
			  &(clui_info->trigger_file),
			  &(clui_info->trigger_flag))))
	{
	    kerror(NULL, "vgfractal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vgfractal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "h",
			  &(clui_info->h_float),
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "vgfractal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "d",
			  &(clui_info->d_float),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "vgfractal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s",
			  &(clui_info->s_int),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vgfractal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "c",
			  &(clui_info->c_logic),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vgfractal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "m",
			  &(clui_info->m_logic),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vgfractal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vgfractal_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create Fractal Image with Specified Fractal Dimension  (K1)' create2D",
  "-P 1 0 52x1+0+1 +20+0 ' ' vgfractal",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  5x1+41+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vgfractal",
  "-H 1  5x1+41+0 'Help' 'help page for vgfractal' $RETRO/objects/kroutine/vgfractal/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 1 0 0 0 52x1+0+2 ' ' 'Trigger Input' 'trigger input' trigger",
  "-i 1 0 1 2 0 50x1+2+5 2 10 6 1 0 'Number of recursions' 'Number of recursions' r",
  "-f 1 0 1 2 0 50x1+2+6 0 1 0.5 0 1 0 'Hurst coefficient   ' 'Hurst coefficient' h",
  "-f 1 0 1 2 0 50x1+2+7 2 2 1 0 1 0 'Standard deviation  ' 'Standard deviation' d",
  "-i 1 0 1 2 0 50x1+2+8 1 1 0 1 0 'Seed                ' 'Seed' s",
  "-l 1 0 1 2 0 30x1+2+10 0 'Coastlines?      ' 'No ' 'Yes' 'Generate coastline' c",
  "-l 1 0 1 2 0 30x1+2+11 0 'Random additions?' 'No ' 'Yes' 'Add random elements to each point' m",
  "-O 1 0 0 1 0 1 52x1+0+13 ' ' 'Output Image' 'Output image filename' o",
  "-b +1+4 'Fractal Image Generation:' blank0",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vgfractal/uis/vgfractal.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	21,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


