 /*
  * Khoros: $Id: vgfractal.h,v 1.14.2.2 1997/05/31 20:08:58 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vgfractal
   >>>> 
   >>>>    Written By: Charlie Gage
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vgfractal_h_
#define _vgfractal_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Output image filename (required outfile)
 */
char	*o_file;	/* Output image filename FILENAME */
int	 o_flag;	/* Output image filename FLAG */

/*
 *  trigger input (optional infile)
 */
char	*trigger_file;	/* trigger input FILENAME */
int	 trigger_flag;	/* trigger input FLAG */

/*
 *  Number of recursions (optional integer)
 */
int	 r_int; 	/* Number of recursions INT */
int	 r_flag;	/* Number of recursions FLAG */

/*
 *  Hurst coefficient (optional float)
 */
float	 h_float;	/* Hurst coefficient FLOAT */
int	 h_flag;   	/* Hurst coefficient FLAG */

/*
 *  Standard deviation (optional float)
 */
float	 d_float;	/* Standard deviation FLOAT */
int	 d_flag;   	/* Standard deviation FLAG */

/*
 *  Seed (optional integer)
 */
int	 s_int; 	/* Seed INT */
int	 s_flag;	/* Seed FLAG */

/*
 *  Generate coastline (optional logical)
 */
int	 c_logic;	/* Generate coastline LOGIC */
int	 c_flag;  	/* Generate coastline FLAG */

/*
 *  Add random elements to each point (optional logical)
 */
int	 m_logic;	/* Add random elements to each point LOGIC */
int	 m_flag;  	/* Add random elements to each point FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vgfractal_get_args PROTO((kaddr));
void vgfractal_usage_additions PROTO((void));
void vgfractal_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
