 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:09:07 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:09:07 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vgpwl.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vgpwl_get_args
| 
|       Purpose: Gets command line args for vgpwl
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vgpwl
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vgpwl_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vgpwl is out of sync with arguments specified in vgpwl's *.pane file; please rerun ghostwriter on vgpwl.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vgpwl structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "trigger",
			  &(clui_info->trigger_file),
			  &(clui_info->trigger_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "s",
			  &(clui_info->s_float),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "l",
			  &(clui_info->l_float),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "m",
			  &(clui_info->m_float),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xp",
			  &(clui_info->xp_float),
			  &(clui_info->xp_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yp",
			  &(clui_info->yp_float),
			  &(clui_info->yp_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xr",
			  &(clui_info->xr_float),
			  &(clui_info->xr_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yr",
			  &(clui_info->yr_float),
			  &(clui_info->yr_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xf",
			  &(clui_info->xf_float),
			  &(clui_info->xf_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yf",
			  &(clui_info->yf_float),
			  &(clui_info->yf_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "xw",
			  &(clui_info->xw_float),
			  &(clui_info->xw_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "yw",
			  &(clui_info->yw_float),
			  &(clui_info->yw_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "t", KVF_TOGGLE_VAL,
			  &(clui_info->t_toggle),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vgpwl_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create 2D Piecewise Linear Periodic Function  (K1)' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' vgpwl",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vgpwl",
  "-H 1  5x1+41+0 'Help' 'man page for vgpwl' $RETRO/objects/kroutine/vgpwl/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 1 0 0 0 52x1+0+2 ' ' 'Trigger Input' 'trigger input' trigger",
  "-i 1 0 1 2 0 23x1+1+3.5 2 2 512 1 0 'Number Rows  ' 'number of rows' r",
  "-f 1 0 1 2 0 24x1+28+3.5 2 2 1 0 1 0 'Sampling Freq ' 'sampling frequency' s",
  "-i 1 0 1 2 0 23x1+1+4.5 2 2 512 1 0 'Number Cols  ' 'number of columns' c",
  "-f 1 0 1 2 0 24x1+28+4.5 0 0 0 0 1 0 'Minimum Value ' 'signal minimum' l",
  "-i 1 0 1 2 0 23x1+1+5.5 2 2 1 1 0 'Number Bands ' 'number of bands' b",
  "-f 1 0 1 2 0 24x1+28+5.5 0 0 1 0 1 0 'Maximum Value ' 'signal maximum' m",
  "-f 1 0 1 2 0 23x1+1+7.5 2 2 1 0 1 0 'X Period     ' 'signal period in X-direction' xp",
  "-f 1 0 1 2 0 24x1+28+7.5 2 2 1 0 1 0 'Y Period      ' 'signal period in Y-direction' yp",
  "-f 1 0 1 2 0 23x1+1+8.5 1 1 0 0 1 0 'X Rise Time  ' 'rise time in X-direction' xr",
  "-f 1 0 1 2 0 24x1+28+8.5 1 1 0 0 1 0 'Y Rise Time   ' 'rise time in Y-direction ' yr",
  "-f 1 0 1 2 0 23x1+1+9.5 1 1 0 0 1 0 'X Fall Time  ' 'fall time in X-direction ' xf",
  "-f 1 0 1 2 0 24x1+28+9.5 1 1 0 0 1 0 'Y Fall Time   ' 'fall time in Y-direction ' yf",
  "-f 1 0 1 2 0 23x1+1+10.5 1 1 0 0 1 0 'X Pulse Width' 'pulse width in X-direction ' xw",
  "-f 1 0 1 2 0 24x1+28+10.5 1 1 0 0 1 0 'Y Pulse Width ' 'pulse width in Y-direction ' yw",
  "-T 1 0 1 2 0 23.75x3+1+12.5 +0+0 1 'Toggle: Float, Complex' 'lets user choose data type of image' t",
  "-s 1 0 1 1 0 20x1+4+1 'float' 'Float Image Type' 'select data type' a",
  "-s 1 0 1 0 0 20x1+4+2 'complex' 'Complex Image Type' 'choose data type' a",
  "-E",
  "-O 1 0 0 1 0 1 52x1+0+16.5 ' ' 'Output Image' 'resulting image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vgpwl/uis/vgpwl.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	32,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


