 /*
  * Khoros: $Id: vgpwl.h,v 1.14.2.2 1997/05/31 20:09:10 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vgpwl
   >>>> 
   >>>>    Written By: Jeremy Worley
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vgpwl_h_
#define _vgpwl_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  resulting image (required outfile)
 */
char	*o_file;	/* resulting image FILENAME */
int	 o_flag;	/* resulting image FLAG */

/*
 *  trigger input (optional infile)
 */
char	*trigger_file;	/* trigger input FILENAME */
int	 trigger_flag;	/* trigger input FLAG */

/*
 *  number of rows (optional integer)
 */
int	 r_int; 	/* number of rows INT */
int	 r_flag;	/* number of rows FLAG */

/*
 *  sampling frequency (optional float)
 */
float	 s_float;	/* sampling frequency FLOAT */
int	 s_flag;   	/* sampling frequency FLAG */

/*
 *  number of columns (optional integer)
 */
int	 c_int; 	/* number of columns INT */
int	 c_flag;	/* number of columns FLAG */

/*
 *  signal minimum (optional float)
 */
float	 l_float;	/* signal minimum FLOAT */
int	 l_flag;   	/* signal minimum FLAG */

/*
 *  number of bands (optional integer)
 */
int	 b_int; 	/* number of bands INT */
int	 b_flag;	/* number of bands FLAG */

/*
 *  signal maximum (optional float)
 */
float	 m_float;	/* signal maximum FLOAT */
int	 m_flag;   	/* signal maximum FLAG */

/*
 *  signal period in X-direction (optional float)
 */
float	 xp_float;	/* signal period in X-direction FLOAT */
int	 xp_flag;   	/* signal period in X-direction FLAG */

/*
 *  signal period in Y-direction (optional float)
 */
float	 yp_float;	/* signal period in Y-direction FLOAT */
int	 yp_flag;   	/* signal period in Y-direction FLAG */

/*
 *  rise time in X-direction (optional float)
 */
float	 xr_float;	/* rise time in X-direction FLOAT */
int	 xr_flag;   	/* rise time in X-direction FLAG */

/*
 *  rise time in Y-direction  (optional float)
 */
float	 yr_float;	/* rise time in Y-direction  FLOAT */
int	 yr_flag;   	/* rise time in Y-direction  FLAG */

/*
 *  fall time in X-direction  (optional float)
 */
float	 xf_float;	/* fall time in X-direction  FLOAT */
int	 xf_flag;   	/* fall time in X-direction  FLAG */

/*
 *  fall time in Y-direction  (optional float)
 */
float	 yf_float;	/* fall time in Y-direction  FLOAT */
int	 yf_flag;   	/* fall time in Y-direction  FLAG */

/*
 *  pulse width in X-direction  (optional float)
 */
float	 xw_float;	/* pulse width in X-direction  FLOAT */
int	 xw_flag;   	/* pulse width in X-direction  FLAG */

/*
 *  pulse width in Y-direction  (optional float)
 */
float	 yw_float;	/* pulse width in Y-direction  FLOAT */
int	 yw_flag;   	/* pulse width in Y-direction  FLAG */

/*
 * lets user choose data type of image (Optional string toggle)
 *	float (select data type)
 *	complex (choose data type),
 */
char	*t_toggle;		/* lets user choose data type of image STRING TOGGLE */
int	 t_flag;		/* lets user choose data type of image FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vgpwl_get_args PROTO((kaddr));
void vgpwl_usage_additions PROTO((void));
void vgpwl_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
