 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:09:31 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:09:31 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vhmed.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vhmed_get_args
| 
|       Purpose: Gets command line args for vhmed
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vhmed
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vhmed_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vhmed is out of sync with arguments specified in vhmed's *.pane file; please rerun ghostwriter on vhmed.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vhmed structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vhmed_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "w",
			  &(clui_info->w_int),
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "vhmed_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "h",
			  &(clui_info->h_int),
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "vhmed_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vhmed_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Median Filter the Image Using Histogram to Find Median  (K1)' 2Dspatl",
  "-P 1 0 52x1+0+1 +8+0 ' ' vhmed",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vhmed",
  "-H 1  5x1+41+0 'Help' 'man page for vhmed' $RETRO/objects/kroutine/vhmed/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image ' 'input image filename' i",
  "-i 1 0 1 2 0 50x1+2+4 1 32 3 1 0 'Window Width ' 'window width argument' w",
  "-i 1 0 1 2 0 50x1+2+5 1 32 3 1 0 'Window Height' 'window height argument' h",
  "-O 1 0 0 1 0 1 52x1+0+7 ' ' 'Output Image' 'output image filename' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vhmed/uis/vhmed.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	16,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


