 /*
  * Khoros: $Id: vhxray.c,v 1.14.2.3 1997/05/31 20:09:46 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: vhxray.c,v 1.14.2.3 1997/05/31 20:09:46 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for vhxray
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "vhxray.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - Stretch or Equalize Histogram Using Overlapping Windows  (K1)
|
|       Purpose: main program for vhxray
|
|         Input:
|		char *clui_info->i_file; {first input image}
|		int   clui_info->i_flag; {TRUE if -i specified}
|
|		char *clui_info->o_file; {resulting output image}
|		int   clui_info->o_flag; {TRUE if -o specified}
|
|		int clui_info->w_int; {selects the width of the window}
|		int clui_info->w_flag; {TRUE if -w specified}
|
|		int clui_info->h_int; {selects the height of the window}
|		int clui_info->h_flag; {TRUE if -h specified}
|
|		int clui_info->t_logic; {Choose Histogram Stretch (true) or Equalization (false)}
|		int clui_info->t_flag; {TRUE if -t specified}
|
|        Output:
|       Returns:
|
|    Written By: Tom Sauer, Charlie Gage
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
char *program = "vhxray";
xvimage *image;
/* -main_variable_list_end */

	khoros_init(argc, argv, "RETRO", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$RETRO/objects/kroutine/vhxray");
	kexit_handler(vhxray_free_args, NULL);

/* -main_get_args_call */
	kclui_init("RETRO", "vhxray", KGEN_KROUTINE,  &clui_uis_spec,
		   vhxray_usage_additions, vhxray_get_args,
 		   vhxray_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
image = readimage(clui_info->i_file);
    if (image == NULL) kexit(1);    /* Quit if bad image */

    CHECKINPUT(program,image);  /* Verify input image */
/* -main_before_lib_call_end */

/* -main_library_call */
if(! lvhxray(image, clui_info->t_logic, clui_info->w_int, clui_info->h_int))
    {
        (void) kerror(NULL, NULL, "lvhxray Failed\n");
        kexit(1);
    }
/* -main_library_call_end */

/* -main_after_lib_call */
writeimage(clui_info->o_file,image);
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: vhxray_usage_additions
| 
|       Purpose: Prints usage additions in vhxray_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vhxray
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vhxray_usage_additions(void)
{
	kfprintf(kstderr, "\tStretch or Equalize Histogram Using Overlapping Windows  (K1)\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: vhxray_free_args
| 
|       Purpose: Frees CLUI struct allocated in vhxray_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vhxray
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
vhxray_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->i_file);
		kfree_and_NULL(clui_info->o_file);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
