 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:09:58 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:09:58 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vlabel.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vlabel_get_args
| 
|       Purpose: Gets command line args for vlabel
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vlabel
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vlabel_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vlabel is out of sync with arguments specified in vlabel's *.pane file; please rerun ghostwriter on vlabel.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the vlabel structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_int(pane, "w",
			  &(clui_info->w_int),
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "m", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->m_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_value(pane, "c", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->c_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_float(pane, "s",
			  &(clui_info->s_float),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "merge",
			  &(clui_info->merge_logic),
			  &(clui_info->merge_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "asc",
			  &(clui_info->asc_file),
			  &(clui_info->asc_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "f",
			  &(clui_info->f_float),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "vlabel_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Perform Labeling on Multiband or Cluster Image  (K1)' classify",
  "-P 1 0 52x1+0+1 +2+0 ' ' vlabel",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vlabel",
  "-H 1  5x1+41+0 'Help' 'man page for vlabel3' $RETRO/objects/kroutine/vlabel/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-i 1 0 1 2 0 38x1+6+9 0 16 0 1 0 'Border Width ' 'Specify the border width in pixels' w",
  "-T 1 0 1 2 0 37.75x2+3+10.5 +0+0 1 'Type of Distance Metric (Choose One): ' 'Distance Metric: 1 = Euclidean distance, 2 = city block' m",
  "-i 1 0 1 1 0 10x1+3+1 1 2 1 1 0 'Euclidean ' 'Use Euclidean Distance' d",
  "-i 1 0 1 0 0 10x1+22+1 1 2 2 1 0 'City Block' 'Use City block Distance' d",
  "-E",
  "-T 1 0 1 2 0 37.75x2+3+13 +0+0 1 'Type of Connectivity (Choose One): ' 'Connectivity: 1 = 4-connectivity, 2 = 8-connectivity' c",
  "-i 1 0 1 1 0 13.75x1+3+1 1 2 1 1 0 '4 Connectivity' 'use 4 Connectivity' c",
  "-i 1 0 1 0 0 13.75x1+22+1 1 2 2 1 0 '8 Connectivity' 'use 8 Connectivity' c",
  "-E",
  "-f 1 0 1 2 0 49x1+3+20.5 0 100 1 0 1 0 'Minimum Region Size in %  ' 'Minimum number of pixel to keep in label region' s",
  "-l 1 0 1 2 0 47x1+3+22 0 'Small Region Treatment' 'Labeled Undefined' '      Merged      ' 'if flag= 1 the small regions will be merged together in connected regions, or will be included to existing labeled regions' merge",
  "-O 1 0 0 1 0 1 52x1+0+24 ' ' 'Output Labeled Image' 'output image after the labeling process' o",
  "-O 1 0 1 1 0 1 52x1+0+26.5 ' ' 'Output ASCII File' 'Output ASCII file for vlabel result display' asc",
  "-b +0+1.5 'Input (Choose One):' blank0",
  "-C 1",
  "-I 1 0 1 1 0 1 52x1+0+2.5 ' ' 'Initial Image       ' 'input image' i1",
  "-B 0",
  "-I 1 0 1 0 0 1 52x1+0+3.5 ' ' 'Cluster Center Image' 'input image for cluster centers' i2",
  "-I 1 0 1 0 0 1 52x1+0+6 ' ' 'Cluster Number Image' 'input image for cluster numbers' i3",
  "-E",
  "-E",
  "-b +0+5 'If Cluster Center SELECTED, Cluster Number Image is REQUIRED:' blank2",
  "-b +0+25.5 'Ascii File for Labeling Information:' blank3",
  "-b +3+8 'The Image Will Not Be Processed Outside of Borders' blank4",
  "-b +3+15.5 'Choose One (Automatic Labeling: 1st Option)' blank5",
  "-b +6+17.5 'or' blank6",
  "-C 1",
  "-i 1 0 1 0 0 46x1+6+16.5 2 2500 10 1 0 'Approximate Number of Regions Expected ' 'Number of region to get from labeling process' n",
  "-f 1 0 1 1 0 46x1+6+18.5 0 1 0.07 0 1 0 'Split and Merge Factor' 'Split & Merge Factor: higher values result in finer regions' f",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vlabel/uis/vlabel.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	42,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


