 /*
  * Khoros: $Id: vlabel.h,v 1.14.2.2 1997/05/31 20:10:01 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vlabel
   >>>> 
   >>>>    Written By: Pascal ADAM
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vlabel_h_
#define _vlabel_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  output image after the labeling process (required outfile)
 */
char	*o_file;	/* output image after the labeling process FILENAME */
int	 o_flag;	/* output image after the labeling process FLAG */

/*----- required ME group ----*/
/*
 *  input image (optional infile)
 */
char	*i1_file;	/* input image FILENAME */
int	 i1_flag;	/* input image FLAG */

	/*---- nested optional MI group ----*/
/*
 *  input image for cluster centers (optional infile)
 */
char	*i2_file;	/* input image for cluster centers FILENAME */
int	 i2_flag;	/* input image for cluster centers FLAG */

/*
 *  input image for cluster numbers (optional infile)
 */
char	*i3_file;	/* input image for cluster numbers FILENAME */
int	 i3_flag;	/* input image for cluster numbers FLAG */

	/*-- nested optional MI group end --*/

/*-- required ME group end ---*/

/*----- required ME group ----*/
/*
 *  Number of region to get from labeling process (optional integer)
 */
int	 n_int; 	/* Number of region to get from labeling process INT */
int	 n_flag;	/* Number of region to get from labeling process FLAG */

/*
 *  Split & Merge Factor: higher values result in finer regions (optional float)
 */
float	 f_float;	/* Split & Merge Factor: higher values result in finer regions FLOAT */
int	 f_flag;   	/* Split & Merge Factor: higher values result in finer regions FLAG */

/*-- required ME group end ---*/

/*
 *  Specify the border width in pixels (optional integer)
 */
int	 w_int; 	/* Specify the border width in pixels INT */
int	 w_flag;	/* Specify the border width in pixels FLAG */

/*
 * Distance Metric: 1 = Euclidean distance, 2 = city block (Optional integer toggle)
 *	1 (Use Euclidean Distance)
 *	2 (Use City block Distance),
 */
int	 m_toggle;		/* Distance Metric: 1 = Euclidean distance, 2 = city block INT TOGGLE */
int	 m_flag;		/* Distance Metric: 1 = Euclidean distance, 2 = city block FLAG */

/*
 * Connectivity: 1 = 4-connectivity, 2 = 8-connectivity (Optional integer toggle)
 *	1 (use 4 Connectivity)
 *	2 (use 8 Connectivity),
 */
int	 c_toggle;		/* Connectivity: 1 = 4-connectivity, 2 = 8-connectivity INT TOGGLE */
int	 c_flag;		/* Connectivity: 1 = 4-connectivity, 2 = 8-connectivity FLAG */

/*
 *  Minimum number of pixel to keep in label region (optional float)
 */
float	 s_float;	/* Minimum number of pixel to keep in label region FLOAT */
int	 s_flag;   	/* Minimum number of pixel to keep in label region FLAG */

/*
 *  if flag= 1 the small regions will be merged together in connected regions, or will be included to existing labeled regions (optional logical)
 */
int	 merge_logic;	/* if flag= 1 the small regions will be merged together in connected regions, or will be included to existing labeled regions LOGIC */
int	 merge_flag;  	/* if flag= 1 the small regions will be merged together in connected regions, or will be included to existing labeled regions FLAG */

/*
 *  Output ASCII file for vlabel result display (optional outfile)
 */
char	*asc_file;	/* Output ASCII file for vlabel result display FILENAME */
int	 asc_flag;	/* Output ASCII file for vlabel result display FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vlabel_get_args PROTO((kaddr));
void vlabel_usage_additions PROTO((void));
void vlabel_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
