 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:10:12 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:10:12 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vmarr.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vmarr_get_args
| 
|       Purpose: Gets command line args for vmarr
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vmarr
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vmarr_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vmarr is out of sync with arguments specified in vmarr's *.pane file; please rerun ghostwriter on vmarr.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vmarr structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "trigger",
			  &(clui_info->trigger_file),
			  &(clui_info->trigger_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "v",
			  &(clui_info->v_float),
			  &(clui_info->v_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vmarr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Create a Marr Type Edge Detection Filter Kernel  (K1)' create2D",
  "-P 1 0 52x1+0+1 +7+0 ' ' vmarr",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vmarr",
  "-H 1  5x1+41+0 'Help' 'man page for vmarr' $RETRO/objects/kroutine/vmarr/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 1 0 0 0 52x1+0+2 ' ' 'Trigger Input' 'trigger input' trigger",
  "-i 1 0 1 2 1 38x1+2+4 2 2 3 1 0 'Number of Rows    ' 'specify the number of rows in the kernel' r",
  "-i 1 0 1 2 1 38x1+2+5 2 2 3 1 0 'Number of Columns ' 'specify the number of columns in the kernel' c",
  "-f 1 0 1 2 1 38x1+2+6.5 2 2 1 0 1 0 'Gaussian Variance ' 'variance of the Gaussian' v",
  "-O 1 0 0 1 0 1 52x1+0+8.5 ' ' 'Output Image' 'Marr kernel output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vmarr/uis/vmarr.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


