 /*
  * Khoros: $Id: vmindis.h,v 1.14.2.2 1997/05/31 20:10:40 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vmindis
   >>>> 
   >>>>    Written By: Tom Sauer
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vmindis_h_
#define _vmindis_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image to be classified (required infile)
 */
char	*i1_file;	/* input image to be classified FILENAME */
int	 i1_flag;	/* input image to be classified FLAG */

/*
 *  input center/class image (required infile)
 */
char	*i2_file;	/* input center/class image FILENAME */
int	 i2_flag;	/* input center/class image FLAG */

/*
 *  output specifying which vector belongs to which cluster (required outfile)
 */
char	*o_file;	/* output specifying which vector belongs to which cluster FILENAME */
int	 o_flag;	/* output specifying which vector belongs to which cluster FLAG */

/*
 *   specifies the border width in pixels (default = 0) (optional integer)
 */
int	 b_int; 	/*  specifies the border width in pixels (default = 0) INT */
int	 b_flag;	/*  specifies the border width in pixels (default = 0) FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT1(image) \
    image = readimage(clui_info->i1_file); \
    if(image == NULL){ \
        kerror("vmindis", "main", "Image could not be read\\n"); \
        kexit(KEXIT_FAILURE); \
    }
#define READINPUT2(image) \
    center = readimage(clui_info->i2_file); \
    if(center == NULL){ \
        kerror("vmindis", "main", "Image could not be read\\n"); \
        kexit(KEXIT_FAILURE); \
    }
#define CHECKINPUT(program, image) \
        (void) proper_num_images(program,image,1,TRUE); \
        \
        (void) proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE); \
        \
        (void) propertype(program, image, VFF_TYP_FLOAT, TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vmindis_get_args PROTO((kaddr));
void vmindis_usage_additions PROTO((void));
void vmindis_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
