 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:10:52 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:10:52 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vmos2band.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vmos2band_get_args
| 
|       Purpose: Gets command line args for vmos2band
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vmos2band
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vmos2band_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vmos2band is out of sync with arguments specified in vmos2band's *.pane file; please rerun ghostwriter on vmos2band.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vmos2band structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "r",
			  &(clui_info->r_int),
			  &(clui_info->r_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "c",
			  &(clui_info->c_int),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "bs",
			  &(clui_info->bs_int),
			  &(clui_info->bs_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "bm",
			  &(clui_info->bm_int),
			  &(clui_info->bm_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x",
			  &(clui_info->x_int),
			  &(clui_info->x_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y",
			  &(clui_info->y_int),
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s",
			  &(clui_info->s_int),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vmos2band_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Convert Mosaic Image to Multiband Image  (K1)' data",
  "-P 1 0 52x1+0+1 +9+0 ' ' vmos2band",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vmos2band",
  "-H 1  5x1+41+0 'Help' 'man page for vmos2band' $RETRO/objects/kroutine/vmos2band/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image ' 'input image' i",
  "-i 1 0 1 2 0 50x1+2+4 1 1 16 1 0 'Number of rows per subimage         ' 'number of subimage rows (must be equal for all subimages)' r",
  "-i 1 0 1 2 0 50x1+2+5 1 1 16 1 0 'Number of columns per subimage      ' 'number of subimage columns (must be equal for all subimages)' c",
  "-i 1 0 1 2 0 50x1+2+6 1 1 0 1 0 'Subimage border size (inner border) ' 'Subimage border size in pixels (inner borders)' bs",
  "-i 1 0 1 2 0 50x1+2+7 1 1 0 1 0 'Mosaic border size (outer border)   ' 'Mosaic image border size in pixels (outer border)' bm",
  "-i 1 0 1 2 0 50x1+2+8 1 1 0 1 0 'Horizontal index of first subimage  ' 'Horizontal index of first subimage (will be first band)' x",
  "-i 1 0 1 2 0 50x1+2+9 1 1 0 1 0 'Vertical index of first subimage    ' 'Vertical index of first subimage (will be first band)' y",
  "-i 1 0 1 2 0 50x1+2+10 1 1 0 1 0 'Subimage skip value                 ' 'Number of subimages to skip (periodic) when putting subimages into band format' s",
  "-i 1 0 1 2 0 50x1+2+11 1 1 1 1 0 'Number of subimages to be banded    ' 'Number of subimages to be put into band format' n",
  "-O 1 0 0 1 0 1 52x1+0+13 ' ' 'Output Image' 'resulting output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vmos2band/uis/vmos2band.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	22,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


