 /*
  * Khoros: $Id: vmos2band.h,v 1.14.2.2 1997/05/31 20:10:54 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vmos2band
   >>>> 
   >>>>    Written By: Donna Koechner
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vmos2band_h_
#define _vmos2band_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  resulting output image (required outfile)
 */
char	*o_file;	/* resulting output image FILENAME */
int	 o_flag;	/* resulting output image FLAG */

/*
 *  number of subimage rows (must be equal for all subimages) (optional integer)
 */
int	 r_int; 	/* number of subimage rows (must be equal for all subimages) INT */
int	 r_flag;	/* number of subimage rows (must be equal for all subimages) FLAG */

/*
 *  number of subimage columns (must be equal for all subimages) (optional integer)
 */
int	 c_int; 	/* number of subimage columns (must be equal for all subimages) INT */
int	 c_flag;	/* number of subimage columns (must be equal for all subimages) FLAG */

/*
 *  Subimage border size in pixels (inner borders) (optional integer)
 */
int	 bs_int; 	/* Subimage border size in pixels (inner borders) INT */
int	 bs_flag;	/* Subimage border size in pixels (inner borders) FLAG */

/*
 *  Mosaic image border size in pixels (outer border) (optional integer)
 */
int	 bm_int; 	/* Mosaic image border size in pixels (outer border) INT */
int	 bm_flag;	/* Mosaic image border size in pixels (outer border) FLAG */

/*
 *  Horizontal index of first subimage (will be first band) (optional integer)
 */
int	 x_int; 	/* Horizontal index of first subimage (will be first band) INT */
int	 x_flag;	/* Horizontal index of first subimage (will be first band) FLAG */

/*
 *  Vertical index of first subimage (will be first band) (optional integer)
 */
int	 y_int; 	/* Vertical index of first subimage (will be first band) INT */
int	 y_flag;	/* Vertical index of first subimage (will be first band) FLAG */

/*
 *  Number of subimages to skip (periodic) when putting subimages into band format (optional integer)
 */
int	 s_int; 	/* Number of subimages to skip (periodic) when putting subimages into band format INT */
int	 s_flag;	/* Number of subimages to skip (periodic) when putting subimages into band format FLAG */

/*
 *  Number of subimages to be put into band format (optional integer)
 */
int	 n_int; 	/* Number of subimages to be put into band format INT */
int	 n_flag;	/* Number of subimages to be put into band format FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT(image) \
    image = readimage(clui_info->i_file); \
    if(image == NULL){ \
        kerror("vmos2band", "main", "Image could not be read\n"); \
        exit(1); \
    }

#define CHECKINPUT(program, image) \
        (void) proper_num_images(program,image,1,TRUE); \
        \
        (void) proper_num_bands(program,image,1,TRUE); \
        \
        (void) proper_dim(program,image,0,TRUE); \
        \
        (void) proper_loc_type(program,image,VFF_LOC_IMPLICIT,TRUE); \
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vmos2band_get_args PROTO((kaddr));
void vmos2band_usage_additions PROTO((void));
void vmos2band_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
