 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:11:06 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:11:06 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vpml.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vpml_get_args
| 
|       Purpose: Gets command line args for vpml
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vpml
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vpml_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vpml is out of sync with arguments specified in vpml's *.pane file; please rerun ghostwriter on vpml.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vpml structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "l",
			  &(clui_info->l_int),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "u",
			  &(clui_info->u_int),
			  &(clui_info->u_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "s",
			  &(clui_info->s_int),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "q",
			  &(clui_info->q_int),
			  &(clui_info->q_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "f1",
			  &(clui_info->f1_file),
			  &(clui_info->f1_flag))))
	{
	    kerror(NULL, "vpml_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Estimate Fractal Dimension of Image Based on P(m,L)  (K1)' feature",
  "-P 1 0 52x1+0+1 +10+0 ' ' vpml",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vpml",
  "-H 1  5x1+41+0 'Help' 'man page for vpml' $RETRO/objects/kroutine/vpml/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image      ' 'input image' i",
  "-i 1 0 1 2 0 50x1+2+4 3 10000 3 1 0 'Lower window size' 'select the initial size of the sliding window' l",
  "-i 1 0 1 2 0 50x1+2+5 5 10000 5 1 0 'Upper window size' 'select the final size of the sliding window' u",
  "-i 1 0 1 2 0 50x1+2+6 2 10000 2 1 0 'Window step size ' 'select the window step size or interval' s",
  "-i 1 0 1 2 0 50x1+2+7.5 3 1000 3 1 0 'Range of moments ' 'select the range of moments (-r/2 <= 0 >= r/2)' q",
  "-O 1 0 0 1 0 1 52x1+0+10.5 ' ' 'Output Image     ' 'resulting multiband fractal dimension output image' o1",
  "-O 1 0 0 1 0 1 52x1+0+11.5 ' ' 'Output FD Image  ' 'output image specifying fractal dimension of each class' o2",
  "-O 1 0 1 1 0 1 52x1+0+12.5 ' ' 'Output ASCII File' 'output file for P(m,L) statistics' f1",
  "-b +4+8.5 '(-r/2 <= 0 >= r/2)' blank0",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vpml/uis/vpml.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	21,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


