 /*
  * Khoros: $Id: vpml.h,v 1.14.2.2 1997/05/31 20:11:09 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vpml
   >>>> 
   >>>>    Written By: Charlie Gage
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vpml_h_
#define _vpml_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  resulting multiband fractal dimension output image (required outfile)
 */
char	*o1_file;	/* resulting multiband fractal dimension output image FILENAME */
int	 o1_flag;	/* resulting multiband fractal dimension output image FLAG */

/*
 *  output image specifying fractal dimension of each class (required outfile)
 */
char	*o2_file;	/* output image specifying fractal dimension of each class FILENAME */
int	 o2_flag;	/* output image specifying fractal dimension of each class FLAG */

/*
 *  select the initial size of the sliding window (optional integer)
 */
int	 l_int; 	/* select the initial size of the sliding window INT */
int	 l_flag;	/* select the initial size of the sliding window FLAG */

/*
 *  select the final size of the sliding window (optional integer)
 */
int	 u_int; 	/* select the final size of the sliding window INT */
int	 u_flag;	/* select the final size of the sliding window FLAG */

/*
 *  select the window step size or interval (optional integer)
 */
int	 s_int; 	/* select the window step size or interval INT */
int	 s_flag;	/* select the window step size or interval FLAG */

/*
 *  select the range of moments (-r/2 <= 0 >= r/2) (optional integer)
 */
int	 q_int; 	/* select the range of moments (-r/2 <= 0 >= r/2) INT */
int	 q_flag;	/* select the range of moments (-r/2 <= 0 >= r/2) FLAG */

/*
 *  output file for P(m,L) statistics (optional outfile)
 */
char	*f1_file;	/* output file for P(m,L) statistics FILENAME */
int	 f1_flag;	/* output file for P(m,L) statistics FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT(image) \
    image = readimage(clui_info->i_file); \
    if(image == NULL){ \
        kerror("vipl","vpml", "Image could not be read\\n"); \
        kexit(KEXIT_FAILURE); \
    }

#define CHECKINPUT(program, image) \
        (void) proper_num_images(program,image,1,TRUE); \
        \
        (void) proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE); \
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vpml_get_args PROTO((kaddr));
void vpml_usage_additions PROTO((void));
void vpml_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
