 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:11:20 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:11:20 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vqerr.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vqerr_get_args
| 
|       Purpose: Gets command line args for vqerr
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vqerr
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vqerr_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vqerr is out of sync with arguments specified in vqerr's *.pane file; please rerun ghostwriter on vqerr.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vqerr structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vqerr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vqerr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "m",
			  &(clui_info->m_file),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vqerr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vqerr_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute Error between Quantized Image and Original  (K1)' classify",
  "-P 1 0 52x1+0+1 +12+0 ' ' vqerr",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $RETROBIN/vqerr",
  "-H 1  5x1+41+0 'Help' 'man page for vqerr' $RETRO/objects/kroutine/vqerr/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Quantized image' 'Quantized image' i1",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Original  image' 'Original image' i2",
  "-I 1 0 1 0 0 1 52x1+0+4 ' ' 'Masking Image' 'operation masking image' m",
  "-O 1 0 0 1 0 1 52x1+0+6 ' ' 'Output ASCII File' 'Output ASCII File' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vqerr/uis/vqerr.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	16,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


