 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:11:34 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:11:34 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vquant.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vquant_get_args
| 
|       Purpose: Gets command line args for vquant
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vquant
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vquant_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vquant is out of sync with arguments specified in vquant's *.pane file; please rerun ghostwriter on vquant.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the vquant structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "m",
			  &(clui_info->m_logic),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "s",
			  &(clui_info->s_logic),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "axis", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->axis_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->axis_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vquant_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Perform N-Dimensional Vector Quantization or Classification (K1)' classify",
  "-P 1 0 52x1+0+1 +10+0 ' ' vquant",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vquant",
  "-H 1  5x1+41+0 'Help' 'man page for vquant' $RETRO/objects/kroutine/vquant/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image   ' 'Input image' i",
  "-i 1 0 1 2 0 50x1+2+4 2 2 128 1 0 'Number of vectors' 'Number of vectors' n",
  "-l 1 0 1 2 0 50x1+2+5.5 1 'Output Image Map Enable ' 'False' 'True ' 'Output Image Map Enable' m",
  "-l 1 0 1 2 0 50x1+2+7 0 'Split point             ' 'Mid-Span' 'Mean' 'Select split point:  false = mid-span, true = mean' s",
  "-T 1 0 1 2 0 24x4+2+8.5 +0+0 1 'Splitting axis' 'Select splitting axis' axis",
  "-i 1 0 1 1 0 15.125x1+3+1 1 3 1 1 0 'Maximum span axis' 'Maximum span axis' axis",
  "-i 1 0 1 0 0 19x1+3+2 1 3 2 1 0 'Maximum variance axis' 'Maximum variance axis' axis",
  "-i 1 0 1 0 0 19x1+3+3 1 3 3 1 0 'Principal eigenvector' 'Principal eigenvector' axis",
  "-E",
  "-O 1 0 0 1 0 1 52x1+0+13.5 ' ' 'Output Image  ' 'Output cluster number image' o",
  "-O 1 0 1 1 0 1 52x1+0+14.5 ' ' 'CC Output Image' 'Output cluster center image' o1",
  "-O 1 0 1 1 0 1 52x1+0+15.5 ' ' 'CV Output Image' 'Output cluster variance image' o2",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vquant/uis/vquant.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	24,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


