 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:11:47 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:11:47 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vsamp.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vsamp_get_args
| 
|       Purpose: Gets command line args for vsamp
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vsamp
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vsamp_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vsamp is out of sync with arguments specified in vsamp's *.pane file; please rerun ghostwriter on vsamp.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vsamp structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x1",
			  &(clui_info->x1_int),
			  &(clui_info->x1_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "x2",
			  &(clui_info->x2_int),
			  &(clui_info->x2_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y1",
			  &(clui_info->y1_int),
			  &(clui_info->y1_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "y2",
			  &(clui_info->y2_int),
			  &(clui_info->y2_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vsamp_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Sample an Image Along an Arbitrary Line  (K1)' subregion",
  "-P 1 0 52x1+0+1 +10+0 ' ' vsamp",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vsamp",
  "-H 1  5x1+41+0 'Help' 'documentation for vsamp' $RETRO/objects/kroutine/vsamp/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 0 52x1+0+2 ' ' 'Input image ' 'input image' i",
  "-i 1 0 1 2 1 17x1+3+5 1 1 0 1 0 'x ' 'starting x coordinate for line' x1",
  "-i 1 0 1 2 1 17x1+26+5 1 1 511 1 0 'x ' 'ending x coordinate for line' x2",
  "-i 1 0 1 2 1 17x1+3+6 1 1 255 1 0 'y ' 'starting y coordinate for line' y1",
  "-i 1 0 1 2 1 17x1+26+6 1 1 255 1 0 'y ' 'ending y coordinate for line' y2",
  "-i 1 0 1 2 1 29.5x1+2+8 2 2 1 1 0 'Number of samples ' 'number of samples' n",
  "-O 1 0 0 1 0 0 52x1+0+10 ' ' 'Output image' 'output image' o",
  "-b +25+4 'Ending coordinates:' blank0",
  "-b +2+4 'Starting coordinates:' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vsamp/uis/vsamp.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	21,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


