 /*
  * Khoros: $Id: vsamp.h,v 1.14.2.2 1997/05/31 20:11:50 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vsamp
   >>>> 
   >>>>    Written By: Richard Krukar
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vsamp_h_
#define _vsamp_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image (required infile)
 */
char	*i_file;	/* input image FILENAME */
int	 i_flag;	/* input image FLAG */

/*
 *  output image (required outfile)
 */
char	*o_file;	/* output image FILENAME */
int	 o_flag;	/* output image FLAG */

/*
 *  starting x coordinate for line (optional integer)
 */
int	 x1_int; 	/* starting x coordinate for line INT */
int	 x1_flag;	/* starting x coordinate for line FLAG */

/*
 *  ending x coordinate for line (optional integer)
 */
int	 x2_int; 	/* ending x coordinate for line INT */
int	 x2_flag;	/* ending x coordinate for line FLAG */

/*
 *  starting y coordinate for line (optional integer)
 */
int	 y1_int; 	/* starting y coordinate for line INT */
int	 y1_flag;	/* starting y coordinate for line FLAG */

/*
 *  ending y coordinate for line (optional integer)
 */
int	 y2_int; 	/* ending y coordinate for line INT */
int	 y2_flag;	/* ending y coordinate for line FLAG */

/*
 *  number of samples (optional integer)
 */
int	 n_int; 	/* number of samples INT */
int	 n_flag;	/* number of samples FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vsamp_get_args PROTO((kaddr));
void vsamp_usage_additions PROTO((void));
void vsamp_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
