 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:12:01 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:12:01 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vsdef.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vsdef_get_args
| 
|       Purpose: Gets command line args for vsdef
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vsdef
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vsdef_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vsdef is out of sync with arguments specified in vsdef's *.pane file; please rerun ghostwriter on vsdef.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vsdef structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "a0",
			  &(clui_info->a0_float),
			  &(clui_info->a0_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "t1",
			  &(clui_info->t1_int),
			  &(clui_info->t1_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "t2",
			  &(clui_info->t2_int),
			  &(clui_info->t2_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "l",
			  &(clui_info->l_int),
			  &(clui_info->l_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vsdef_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Second Derivative Operator for Symmetric Exponential Filter  (K1)' 2Dspatl",
  "-P 1 0 52x1+0+1 +14+0 ' ' vsdef",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vsdef",
  "-H 1  5x1+41+0 'Help' 'man page for visef' $RETRO/objects/kroutine/vsdef/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input  Image' 'Input Image' i",
  "-f 1 0 1 2 0 48x1+4+4.5 0 1 0.45 0 1 0 ' a0 ' 'Exponential Filter Parameter for GEF' a0",
  "-i 1 0 1 2 0 48x1+4+7 0 255 3 1 0 ' T1 ' '1st Hysteresis Threshold' t1",
  "-i 1 0 1 2 0 48x1+4+8 0 255 4 1 0 ' T2 ' '2nd Hysteresis Threshold' t2",
  "-i 1 0 1 2 0 48x1+4+10.5 0 100000 10 1 0 'Length' 'Minimum Number of Pixels in a Segment' l",
  "-O 1 0 0 1 0 1 52x1+0+12.5 ' ' 'Output Image' 'Output Image' o",
  "-b +2+3.5 'Filter Parameter:' blank1",
  "-b +2+6 'Hysteresis Thresholds:' blank2",
  "-b +2+9.5 'Minimum Length of a Segment (in Pixels):' blank3",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vsdef/uis/vsdef.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	21,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


