 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:12:14 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:12:14 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vshape.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vshape_get_args
| 
|       Purpose: Gets command line args for vshape
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vshape
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vshape_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vshape is out of sync with arguments specified in vshape's *.pane file; please rerun ghostwriter on vshape.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vshape structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_logical(pane, "ms",
			  &(clui_info->ms_logic),
			  &(clui_info->ms_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "mc",
			  &(clui_info->mc_logic),
			  &(clui_info->mc_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "mi",
			  &(clui_info->mi_logic),
			  &(clui_info->mi_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "mr",
			  &(clui_info->mr_logic),
			  &(clui_info->mr_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "col",
			  &(clui_info->col_logic),
			  &(clui_info->col_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o1",
			  &(clui_info->o1_file),
			  &(clui_info->o1_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o2",
			  &(clui_info->o2_file),
			  &(clui_info->o2_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o3",
			  &(clui_info->o3_file),
			  &(clui_info->o3_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "f",
			  &(clui_info->f_file),
			  &(clui_info->f_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vshape_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Perform Shape Analysis on Image  (K1)' feature",
  "-P 1 0 52x1+0+1 +15+0 ' ' vshape",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vshape",
  "-H 1  5x1+41+0 'Help' 'man page for vshape' $RETRO/objects/kroutine/vshape/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-l 1 0 1 2 0 47x1+5+5.5 0 'Standard Moments       ' 'Not Necessary  ' '   Needed      ' 'if true, compute standard moments' ms",
  "-l 1 0 1 2 0 47x1+5+6.5 0 'Central Moments        ' 'Not Necessary  ' '   Needed      ' 'if true, compute central moments' mc",
  "-l 1 0 1 2 0 47x1+5+7.5 0 'Invariant Moments      ' 'Not Necessary  ' '   Needed      ' 'if true, compute invariant moments' mi",
  "-l 1 0 1 2 0 47x1+5+8.5 0 'Axis Representation    ' 'X and Y Moments' 'Principal  Axis' 'if false, computes axis of bounded box' mr",
  "-l 1 0 1 2 0 47x1+5+9.5 0 'Axis and Outlines Color' '   All White   ' '= Region Number' 'if false, color = white, with black background' col",
  "-O 1 0 1 0 0 1 52x1+0+12.5 ' ' 'Axis Image           ' 'output Axis image' o1",
  "-O 1 0 1 0 0 1 52x1+0+13.5 ' ' 'Outline Image        ' 'output outline image' o2",
  "-O 1 0 1 0 0 1 52x1+0+14.5 ' ' 'VIFF Statistics File ' 'output VIFF file containing statistics' o3",
  "-O 1 0 1 1 0 1 52x1+0+15.5 ' ' 'ASCII File           ' 'output ASCII file' f",
  "-C 1",
  "-b +0+1.5 'INPUT IMAGE (choose one):' blank0",
  "-I 1 0 1 1 0 1 52x1+0+2.5 ' ' 'Clust/Label Image' 'Input Cluster/Label Image' i1",
  "-I 1 0 1 0 0 1 52x1+0+3.5 ' ' 'Grey Level  Image' 'Input Grey Level Image' i2",
  "-E",
  "-b +0+11.5 'OUTPUT IMAGE(S):' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vshape/uis/vshape.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	27,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


