 /*
  * Khoros: $Id: vshape.h,v 1.14.2.2 1997/05/31 20:12:17 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vshape
   >>>> 
   >>>>    Written By: Pascal ADAM, Shirley Lee
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vshape_h_
#define _vshape_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*----- required ME group ----*/
/*
 *  Input Cluster/Label Image (optional infile)
 */
char	*i1_file;	/* Input Cluster/Label Image FILENAME */
int	 i1_flag;	/* Input Cluster/Label Image FLAG */

/*
 *  Input Grey Level Image (optional infile)
 */
char	*i2_file;	/* Input Grey Level Image FILENAME */
int	 i2_flag;	/* Input Grey Level Image FLAG */

/*-- required ME group end ---*/

/*
 *  if true, compute standard moments (optional logical)
 */
int	 ms_logic;	/* if true, compute standard moments LOGIC */
int	 ms_flag;  	/* if true, compute standard moments FLAG */

/*
 *  if true, compute central moments (optional logical)
 */
int	 mc_logic;	/* if true, compute central moments LOGIC */
int	 mc_flag;  	/* if true, compute central moments FLAG */

/*
 *  if true, compute invariant moments (optional logical)
 */
int	 mi_logic;	/* if true, compute invariant moments LOGIC */
int	 mi_flag;  	/* if true, compute invariant moments FLAG */

/*
 *  if false, computes axis of bounded box (optional logical)
 */
int	 mr_logic;	/* if false, computes axis of bounded box LOGIC */
int	 mr_flag;  	/* if false, computes axis of bounded box FLAG */

/*
 *  if false, color = white, with black background (optional logical)
 */
int	 col_logic;	/* if false, color = white, with black background LOGIC */
int	 col_flag;  	/* if false, color = white, with black background FLAG */

/*
 *  output Axis image (optional outfile)
 */
char	*o1_file;	/* output Axis image FILENAME */
int	 o1_flag;	/* output Axis image FLAG */

/*
 *  output outline image (optional outfile)
 */
char	*o2_file;	/* output outline image FILENAME */
int	 o2_flag;	/* output outline image FLAG */

/*
 *  output VIFF file containing statistics (optional outfile)
 */
char	*o3_file;	/* output VIFF file containing statistics FILENAME */
int	 o3_flag;	/* output VIFF file containing statistics FLAG */

/*
 *  output ASCII file (optional outfile)
 */
char	*f_file;	/* output ASCII file FILENAME */
int	 f_flag;	/* output ASCII file FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define CHECKINPUT(program, image) \
        if ((image->data_storage_type != VFF_TYP_1_BYTE) && \
            (image->data_storage_type != VFF_TYP_2_BYTE) && \
            (image->data_storage_type != VFF_TYP_4_BYTE) && \
            (image->data_storage_type != VFF_TYP_FLOAT) ) { \
            (void) kfprintf(kstderr,  \
                   "vshape:  Can't accept this Data Storage Type!\n\n"); \
            kexit(KEXIT_FAILURE); \
            } \
        (void) proper_num_images(program,image,1,TRUE); \
        (void) proper_num_bands(program,image,1,TRUE); \
        (void) proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vshape_get_args PROTO((kaddr));
void vshape_usage_additions PROTO((void));
void vshape_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
