 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:12:26 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:12:26 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vslope.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vslope_get_args
| 
|       Purpose: Gets command line args for vslope
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vslope
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vslope_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vslope is out of sync with arguments specified in vslope's *.pane file; please rerun ghostwriter on vslope.";

	kform *pane = (kform *) opane;

	char  *value_string;


	/*
	 * allocate the vslope structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_value(pane, "so", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->so_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->so_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_value(pane, "to", KVF_TOGGLE_VAL,
			  &value_string,
			  &(clui_info->to_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	else
	{
	    clui_info->to_toggle = atoi(value_string);
	    kfree_and_NULL(value_string);
	}
	if (!(kclui_get_float(pane, "z",
			  &(clui_info->z_float),
			  &(clui_info->z_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "s",
			  &(clui_info->s_file),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "t",
			  &(clui_info->t_file),
			  &(clui_info->t_flag))))
	{
	    kerror(NULL, "vslope_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute Slope and Aspect Images from Elevation Data  (K1)' gis_surface",
  "-P 1 0 52x1+0+1 +12+0 ' ' vslope",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $RETROBIN/vslope",
  "-H 1  5x1+41+0 'Help' 'man page for vslope' $RETRO/objects/kroutine/vslope/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image ' 'input image' i",
  "-T 1 0 1 2 0 47x2+2+3.5 +0+0 1 'Slope Options (select one):' 'slope options' so",
  "-i 1 0 1 1 0 10x1+4+1 0 0 0 1 0 'Degrees' 'Output Slope in Degrees' so",
  "-i 1 0 1 0 0 10x1+19+1 1 1 1 1 0 'Radians' 'Output Slope in Radians' so",
  "-i 1 0 1 0 0 10x1+34+1 2 2 2 1 0 'Percent Rise' 'Output Slope in Percent Rise' so",
  "-E",
  "-T 1 0 1 2 0 47x2+2+6 +0+0 1 'Aspect Options (select one):' 'aspect options' to",
  "-i 1 0 1 1 0 10x1+4+1 0 0 0 1 0 'Degrees' 'Output Aspect in Degrees' to",
  "-i 1 0 1 0 0 10x1+19+1 1 1 1 1 0 'Radians' 'Output Aspect in Radians' to",
  "-i 1 0 1 0 0 10x1+34+1 2 2 2 1 0 'Quadrants' 'Output Aspect in Quadrants' to",
  "-E",
  "-f 1 0 1 2 0 50x1+2+8.5 0 0 0 0 1 0 'Value for Regions With no Aspect (flat) ' 'Value for Regions With no Aspect (flat)' z",
  "-O 1 0 1 1 0 1 52x1+0+10.5 ' ' 'Slope Image ' 'output slope image' s",
  "-O 1 0 1 1 0 1 52x1+0+11.5 ' ' 'Aspect Image' 'output aspect image' t",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vslope/uis/vslope.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	26,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


