 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:12:40 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:12:40 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vspatial.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vspatial_get_args
| 
|       Purpose: Gets command line args for vspatial
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vspatial
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vspatial_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vspatial is out of sync with arguments specified in vspatial's *.pane file; please rerun ghostwriter on vspatial.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vspatial structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "w",
			  &(clui_info->w_int),
			  &(clui_info->w_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "h",
			  &(clui_info->h_int),
			  &(clui_info->h_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "m",
			  &(clui_info->m_logic),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "s",
			  &(clui_info->s_logic),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "c",
			  &(clui_info->c_logic),
			  &(clui_info->c_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "v",
			  &(clui_info->v_logic),
			  &(clui_info->v_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "e",
			  &(clui_info->e_logic),
			  &(clui_info->e_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "d",
			  &(clui_info->d_logic),
			  &(clui_info->d_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vspatial_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Compute Spatial Features Using NxM Window  (K1)' feature",
  "-P 1 0 52x1+0+1 +6+0 ' ' vspatial",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vspatial",
  "-H 1  5x1+41+0 'Help' 'man page for vspatial' $RETRO/objects/kroutine/vspatial/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image ' 'input image filename' i",
  "-i 1 0 1 2 0 50x1+2+4 1 64 3 1 0 'Window width ' 'window width argument' w",
  "-i 1 0 1 2 0 50x1+2+5 1 64 3 1 0 'Window height' 'window height argument' h",
  "-l 1 0 1 2 0 18x1+2+8 1 'Mean     ' 'False' 'True ' 'apply the Mean Spatial Operator ' m",
  "-l 1 0 1 2 0 25x1+26+8 0 'Ang. 2nd Moment ' 'False' 'True ' 'apply the Angular 2nd Moment Spatial Operator ' s",
  "-l 1 0 1 2 0 18x1+2+9 0 'Contrast ' 'False' 'True ' 'apply the Contrast Spatial Operator ' c",
  "-l 1 0 1 2 0 25x1+26+9 0 'Variance        ' 'False' 'True ' 'apply the Variance Spatial Operator ' v",
  "-l 1 0 1 2 0 18x1+2+10 0 'Entropy  ' 'False' 'True ' 'apply the Entropy Spatial Operator ' e",
  "-l 1 0 1 2 0 25x1+26+10 0 'Dispersion      ' 'False' 'True ' 'apply the Dispersion Spatial Operator ' d",
  "-O 1 0 0 1 0 1 52x1+0+12 ' ' 'Output Image' 'output image filename' o",
  "-b +0+7 'Spatial Operators:' blank0",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vspatial/uis/vspatial.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	23,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


