 /*
  * Khoros: $Id: vspatial.h,v 1.14.2.2 1997/05/31 20:12:43 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vspatial
   >>>> 
   >>>>    Written By: Charlie Gage
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vspatial_h_
#define _vspatial_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  input image filename (required infile)
 */
char	*i_file;	/* input image filename FILENAME */
int	 i_flag;	/* input image filename FLAG */

/*
 *  output image filename (required outfile)
 */
char	*o_file;	/* output image filename FILENAME */
int	 o_flag;	/* output image filename FLAG */

/*
 *  window width argument (optional integer)
 */
int	 w_int; 	/* window width argument INT */
int	 w_flag;	/* window width argument FLAG */

/*
 *  window height argument (optional integer)
 */
int	 h_int; 	/* window height argument INT */
int	 h_flag;	/* window height argument FLAG */

/*
 *  apply the Mean Spatial Operator  (optional logical)
 */
int	 m_logic;	/* apply the Mean Spatial Operator  LOGIC */
int	 m_flag;  	/* apply the Mean Spatial Operator  FLAG */

/*
 *  apply the Angular 2nd Moment Spatial Operator  (optional logical)
 */
int	 s_logic;	/* apply the Angular 2nd Moment Spatial Operator  LOGIC */
int	 s_flag;  	/* apply the Angular 2nd Moment Spatial Operator  FLAG */

/*
 *  apply the Contrast Spatial Operator  (optional logical)
 */
int	 c_logic;	/* apply the Contrast Spatial Operator  LOGIC */
int	 c_flag;  	/* apply the Contrast Spatial Operator  FLAG */

/*
 *  apply the Variance Spatial Operator  (optional logical)
 */
int	 v_logic;	/* apply the Variance Spatial Operator  LOGIC */
int	 v_flag;  	/* apply the Variance Spatial Operator  FLAG */

/*
 *  apply the Entropy Spatial Operator  (optional logical)
 */
int	 e_logic;	/* apply the Entropy Spatial Operator  LOGIC */
int	 e_flag;  	/* apply the Entropy Spatial Operator  FLAG */

/*
 *  apply the Dispersion Spatial Operator  (optional logical)
 */
int	 d_logic;	/* apply the Dispersion Spatial Operator  LOGIC */
int	 d_flag;  	/* apply the Dispersion Spatial Operator  FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT(image) \
    image = readimage(clui_info->i_file); \
    if(image == NULL){ \
        (void) kfprintf(kstderr,"vspatial: Image could not be read\\n"); \
        kexit(KEXIT_FAILURE); \
    }

#define CHECKINPUT(program, image) \
        (void) proper_num_images(program,image,1,TRUE); \
        \
        (void) proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE); \
        \
        (void) propertype(program, image, VFF_TYP_1_BYTE, TRUE)
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vspatial_get_args PROTO((kaddr));
void vspatial_usage_additions PROTO((void));
void vspatial_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
