 /*
  * Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 20:12:53 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.2 1997/05/31 20:12:53 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vspeckle.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vspeckle_get_args
| 
|       Purpose: Gets command line args for vspeckle
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vspeckle
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vspeckle_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vspeckle is out of sync with arguments specified in vspeckle's *.pane file; please rerun ghostwriter on vspeckle.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vspeckle structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vspeckle_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "n",
			  &(clui_info->n_int),
			  &(clui_info->n_flag))))
	{
	    kerror(NULL, "vspeckle_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vspeckle_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Reduce Speckle Noise Using the Crimmins Algorithm  (K1)' 2Dspatl",
  "-P 1 0 52x1+0+1 +0+0 ' ' vspeckle",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vspeckle",
  "-H 1  5x1+41+0 'Help' 'man page for vspeckle' $RETRO/objects/kroutine/vspeckle/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image   ' 'input image' i",
  "-i 1 0 1 2 0 49.75x1+2+4 1 20 1 1 0 'Number of Iterations' 'Iterations' n",
  "-O 1 0 0 1 0 1 52x1+0+6 ' ' 'Output Image  ' 'output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vspeckle/uis/vspeckle.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


