 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:13:19 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:13:19 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vtilt.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vtilt_get_args
| 
|       Purpose: Gets command line args for vtilt
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vtilt
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vtilt_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vtilt is out of sync with arguments specified in vtilt's *.pane file; please rerun ghostwriter on vtilt.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vtilt structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i",
			  &(clui_info->i_file),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "vtilt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "m",
			  &(clui_info->m_file),
			  &(clui_info->m_flag))))
	{
	    kerror(NULL, "vtilt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "x",
			  &(clui_info->x_float),
			  &(clui_info->x_flag))))
	{
	    kerror(NULL, "vtilt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "y",
			  &(clui_info->y_float),
			  &(clui_info->y_flag))))
	{
	    kerror(NULL, "vtilt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vtilt_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Add a Specified Illumination Gradient Plane to Image  (K1)' gis_surface",
  "-P 1 0 52x1+0+1 +2+0 ' ' vtilt",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'do operation' $RETROBIN/vtilt",
  "-H 1  5x1+41+0 'Help' 'man page for vtilt' $RETRO/objects/kroutine/vtilt/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image   ' 'input image' i",
  "-I 1 0 1 0 0 1 52x1+0+3 ' ' 'Masking Image ' 'tilt operation masking image' m",
  "-f 1 0 1 2 1 42x1+4+5 0 0 0 0 1 0 'Slope in X-dir' 'specifies the slope in the X direction' x",
  "-f 1 0 1 2 1 42x1+4+6 0 0 0 0 1 0 'Slope in Y-dir' 'specifies the slope in the Y direction' y",
  "-O 1 0 0 1 0 1 52x1+0+8 ' ' 'Output Image  ' 'resulting output image' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vtilt/uis/vtilt.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	17,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


