 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:13:32 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:13:32 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "vwmdd.h"
/*-----------------------------------------------------------
| 
|  Routine Name: vwmdd_get_args
| 
|       Purpose: Gets command line args for vwmdd
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname vwmdd
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void vwmdd_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for vwmdd is out of sync with arguments specified in vwmdd's *.pane file; please rerun ghostwriter on vwmdd.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the vwmdd structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "i1",
			  &(clui_info->i1_file),
			  &(clui_info->i1_flag))))
	{
	    kerror(NULL, "vwmdd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i2",
			  &(clui_info->i2_file),
			  &(clui_info->i2_flag))))
	{
	    kerror(NULL, "vwmdd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "i3",
			  &(clui_info->i3_file),
			  &(clui_info->i3_flag))))
	{
	    kerror(NULL, "vwmdd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_float(pane, "k",
			  &(clui_info->k_float),
			  &(clui_info->k_flag))))
	{
	    kerror(NULL, "vwmdd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_int(pane, "b",
			  &(clui_info->b_int),
			  &(clui_info->b_flag))))
	{
	    kerror(NULL, "vwmdd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_logical(pane, "s",
			  &(clui_info->s_logic),
			  &(clui_info->s_flag))))
	{
	    kerror(NULL, "vwmdd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_outfile(pane, "o",
			  &(clui_info->o_file),
			  &(clui_info->o_flag))))
	{
	    kerror(NULL, "vwmdd_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'Weighted Minimum Distance Detector  (K1)' classify",
  "-P 1 0 52x1+0+1 +1+0 ' ' vmwdd",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 6x1+34+0 'Run' 'do operation' $RETROBIN/vwmdd",
  "-H 1  5x1+41+0 'Help' 'man page for vmwdd' $RETRO/objects/kroutine/vwmdd/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+2 ' ' 'Input Image             ' 'Input Image' i1",
  "-I 1 0 0 1 0 1 52x1+0+3 ' ' 'Input Center/Class Image' 'Input Cluster Center/Class Image' i2",
  "-I 1 0 0 1 0 1 52x1+0+4 ' ' 'Input Variance Image    ' 'Input Variance Image' i3",
  "-f 1 0 1 2 0 41x1+3+6 2 2 1 0 1 0 'Scaling Factor       ' ' Scaling factor' k",
  "-i 1 0 1 2 0 41x1+3+7 0 100 0 1 0 'Border Width         ' ' Border width in pixels' b",
  "-l 1 0 1 2 0 31x1+3+8.5 0 'Use Summed Method?   ' 'False' 'True ' 'If true, Use Summed Method' s",
  "-O 1 0 0 1 0 1 52x1+0+10.5 ' ' 'Output Classified Image ' 'Output specifying which vector belongs to which cluster' o",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$RETRO/objects/kroutine/vwmdd/uis/vwmdd.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	19,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


