 /*
  * Khoros: $Id: vwmdd.h,v 1.14.2.2 1997/05/31 20:13:35 mirage Exp $
  */

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>>       Purpose: Include file for vwmdd
   >>>> 
   >>>>    Written By: Tom Sauer
   >>>> 
   >>>> Modifications: 
   >>>> 
   >>>>          Date: July 1, 1997
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _vwmdd_h_
#define _vwmdd_h_

        /*-------------------------------------*
         |       #includes
        ---------------------------------------*/

#include <retro.h>

/* -include_includes */
#include <vipl/vipl.h>
/* -include_includes_end */


        /*-------------------------------------*
         |       #defines
        ---------------------------------------*/

/* -include_defines */
/* -include_defines_end */

        /*-------------------------------------*
         |       typedefs
        ---------------------------------------*/

typedef struct _clui_info_struct {

/*
 *  Input Image (required infile)
 */
char	*i1_file;	/* Input Image FILENAME */
int	 i1_flag;	/* Input Image FLAG */

/*
 *  Input Cluster Center/Class Image (required infile)
 */
char	*i2_file;	/* Input Cluster Center/Class Image FILENAME */
int	 i2_flag;	/* Input Cluster Center/Class Image FLAG */

/*
 *  Input Variance Image (required infile)
 */
char	*i3_file;	/* Input Variance Image FILENAME */
int	 i3_flag;	/* Input Variance Image FLAG */

/*
 *  Output specifying which vector belongs to which cluster (required outfile)
 */
char	*o_file;	/* Output specifying which vector belongs to which cluster FILENAME */
int	 o_flag;	/* Output specifying which vector belongs to which cluster FLAG */

/*
 *   Scaling factor (optional float)
 */
float	 k_float;	/*  Scaling factor FLOAT */
int	 k_flag;   	/*  Scaling factor FLAG */

/*
 *   Border width in pixels (optional integer)
 */
int	 b_int; 	/*  Border width in pixels INT */
int	 b_flag;	/*  Border width in pixels FLAG */

/*
 *  If true, Use Summed Method (optional logical)
 */
int	 s_logic;	/* If true, Use Summed Method LOGIC */
int	 s_flag;  	/* If true, Use Summed Method FLAG */

} clui_info_struct;

/* -include_typedefs */
/* -include_typedefs_end */


        /*-------------------------------------*
         |       global variable declarations
        ---------------------------------------*/

extern clui_info_struct *clui_info;
extern uis_struct clui_uis_spec;
/* -include_variables */
/* -include_variables_end */


        /*-------------------------------------*
         |       macros
        ---------------------------------------*/

/* -include_macros */
#define READINPUT1(image) \
    image = readimage(clui_info->i1_file); \
    if(image == NULL){ \
        kerror("vwmdd", "main", "Image could not be read\\n"); \
        kexit(KEXIT_FAILURE); \
    }
#define READINPUT2(center) \
    center = readimage(clui_info->i2_file); \
    if(center == NULL){ \
        kerror("vwmdd", "main", "Image could not be read\\n"); \
        kexit(KEXIT_FAILURE); \
    }
#define READINPUT3(varimg) \
    varimg = readimage(clui_info->i3_file); \
    if(varimg == NULL){ \
        kerror("vwmdd", "main", "Image could not be read\\n"); \
        kexit(KEXIT_FAILURE); \
    }
#define CHECKINPUT(program, image) \
        (void) proper_num_images(program,image,1,TRUE); \
        \
        (void) proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE);
/* -include_macros_end */

        /*-------------------------------------*
         |       routine definitions
        ---------------------------------------*/

int main PROTO((int, char **));
void vwmdd_get_args PROTO((kaddr));
void vwmdd_usage_additions PROTO((void));
void vwmdd_free_args PROTO((kexit_status, kaddr));

/* -include_routines */
/* -include_routines_end */

#endif
