/*
  * Khoros: $Id: mat_map_en.c,v 1.7 1997/01/20 07:40:54 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: mat_map_en.c,v 1.7 1997/01/20 07:40:54 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 match_map_enable()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"	  

/************************************************************
*
*  Routine Name: match_map_enable() 
*
*       Purpose: Check to see if two viff files or structures have the
*               same map enable type.
*
*       Input:  prog 	- program name
*		*img1	- viff data one
*		*img2	- viff data two
*		exit_flag
*
*	Output:
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: Restrictions on data or input as applicable
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int match_map_enable(char *prog, xvimage *img1, xvimage *img2, int exit_flag)
{
    if (img1->map_enable != img2->map_enable) {
	if (exit_flag == TRUE) {
		(void) kfprintf(kstderr,"\nError in program %s.\n",prog);
		(void) kfprintf(kstderr,
"The viff map enables are incompatible.\n");
		(void) kfprintf(kstderr,
"The maps can be removed or modified by using one of the other programs.\n");
		kexit(KEXIT_FAILURE);
	}
	else return(0);
    }
return(1);
}
