/*
  * Khoros: $Id: mat_map_sc.c,v 1.7 1997/01/20 07:40:55 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: mat_map_sc.c,v 1.7 1997/01/20 07:40:55 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 match_map_scheme()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"	  

/************************************************************
*
*  Routine Name: match_map_scheme()
*
*       Purpose: Check to see if the two viff data files have the same
*		mapping scheme.
*
*         Input: prog 	- program name
*		*img1	- viff data one
*		*img2	- viff data two
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int match_map_scheme(char *prog, xvimage *img1, xvimage *img2, int exit_flag)
{
    if( img1->map_scheme != img2->map_scheme ){
	if (exit_flag == TRUE) {
		(void) kfprintf(kstderr,"\nError in program %s.\n",prog);
		(void) kfprintf(kstderr,
"The viff data files use different mapping schemes.\n");
		(void) kfprintf(kstderr,
"viff data mapping schemes can be modified or removed by using one\n");
		(void) kfprintf(kstderr,
"of the other programs.");
		kexit(KEXIT_FAILURE);
	}
    else return(0);
    }
return(1);
}
