/*
  * Khoros: $Id: mat_map_ty.c,v 1.7 1997/01/20 07:40:56 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: mat_map_ty.c,v 1.7 1997/01/20 07:40:56 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 match_map_type()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: match_map_type
*
*       Purpose: Check to see if two viff files or structures have the
*               same map data type.
*
*         Input: prog 	- program name
*		*img1	- viff structure one
*		*img2	- viff structure two
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int match_map_type(char *prog, xvimage *img1, xvimage *img2, int exit_flag)
{
    if (img1->map_storage_type != img2->map_storage_type) {
	if (exit_flag == TRUE) {
		(void) kfprintf(kstderr,"\nError in program %s.\n",prog);
		(void) kfprintf(kstderr,
"The viff data maps use a different data type storage.\n");
		kexit(KEXIT_FAILURE);
	}
	else return(0);
    }
return(1);
}
