/*
  * Khoros: $Id: match_dim.c,v 1.7 1997/01/20 07:40:58 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: match_dim.c,v 1.7 1997/01/20 07:40:58 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 match_dim()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: match_dim
*
*       Purpose: Check to see that two viff files have the same
*		location dimensions.
*
*         Input: prog 	- program name
*		*img1	- viff data structure one
*		*img2	- viff data structure two
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int match_dim(char *prog, xvimage *img1, xvimage *img2, int exit_flag)
{
    if (img1->location_dim != img2->location_dim) {
	if (exit_flag == TRUE) {
		(void) kfprintf(kstderr,"\nError in program %s.\n",prog);
		(void) kfprintf(kstderr,
"The viff location dimensions do not match.\n");
		(void) kfprintf(kstderr,
"This indicates that dimensionality of the viff data structures is different.\n");
		kexit(KEXIT_FAILURE);
	}
	else return(0);
    }
return(1);
}
