/*
  * Khoros: $Id: match_loc.c,v 1.7 1997/01/20 07:41:00 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: match_loc.c,v 1.7 1997/01/20 07:41:00 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 match_loc_type()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: match_loc_type
*
*       Purpose: Check to see that two viff data structures have the same
*		location type.
*
*         Input: prog 	- program name
*		*img1	- viff data structure one
*		*img2	- viff data structure two
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int match_loc_type(char *prog, xvimage *img1, xvimage *img2, int exit_flag)
{
    if (img1->location_type != img2->location_type) {
	if (exit_flag == TRUE) {
		(void) kfprintf(kstderr,"\nError in program %s.\n",prog);
		(void) kfprintf(kstderr,
"The viff data structures have incompatible location types.\n");
		(void) kfprintf(kstderr,
"One may be implied while the other is explicit.\n");
		kexit(KEXIT_FAILURE);
	}
	else return(0);
    }
return(1);
}
