/*
  * Khoros: $Id: match_numi.c,v 1.7 1997/01/20 07:41:02 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: match_numi.c,v 1.7 1997/01/20 07:41:02 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 match_num_images()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: match_num_images
*
*       Purpose: Check to see that two viff data structures have the same number
*		of images.
*
*         Input: prog 	- program name
*		*img1	- viff data structure one
*		*img2	- viff data structure two
*		exit_flag
*
*        Output:
*
*       Returns: If exit_flag is true and match fails, an error  
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int match_num_images(char *prog, xvimage *img1, xvimage *img2, int exit_flag)
{
    if (img1->num_of_images != img2->num_of_images) {
	if (exit_flag == TRUE) {
		(void) kfprintf(kstderr,"\nError in program %s.\n",prog);
		(void) kfprintf(kstderr,
"The viff files have a different number of images.\n");
		kexit(KEXIT_FAILURE);
	}
	else return(0);
    }
return(1);
}
