/*
  * Khoros: $Id: matchsize.c,v 1.7 1997/01/20 07:41:03 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: matchsize.c,v 1.7 1997/01/20 07:41:03 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 matchsize()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: matchsize
*
*       Purpose: Check to see if two viff data structures are the same size. 
*
*         Input: prog 	- program name
*		*img1	- viff data structure one
*		*img2	- viff data structure two
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int matchsize(char *prog, xvimage *img1, xvimage *img2, int exit_flag)
{
    if( ! (img1->col_size==img2->col_size && img1->row_size==img2->row_size) ){
	if (exit_flag == TRUE) {
		(void) kfprintf(kstderr,"\nError in program %s.\n",prog);
		(void) kfprintf(kstderr,
"The viff data structures are of different sizes.\n");
		(void) kfprintf(kstderr,
"The number of rows and columns is different between the two viff files.\n");
		(void) kfprintf(kstderr,
"The viff files can be resized with other programs.\n");
		kexit(KEXIT_FAILURE);
	}
	else return(0);
    }
return(1);
}
