/*
  * Khoros: $Id: matchtype.c,v 1.7 1997/01/20 07:41:04 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: matchtype.c,v 1.7 1997/01/20 07:41:04 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 matchtype()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: matchtype
*
*       Purpose: Check to see if two viff data structures are of the 
*		same data type. 
*
*         Input: prog 	- program name
*		*img1	- viff data structure one
*		*img2	- viff data structure two
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*               message is printed.
*               If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int matchtype(char *prog, xvimage *img1, xvimage *img2, int exit_flag)
{
    if (img1->data_storage_type != img2->data_storage_type) {
	if (exit_flag == TRUE) {
		(void) kfprintf(kstderr,"\nError in program %s.\n",prog);
		(void) kfprintf(kstderr,
"viff data structures are of different data storage type.\n");
		(void) kfprintf(kstderr,
"The viff data storage type can be converted using the convert programs.\n");
		(void) kfprintf(kstderr,
"See vconvert(1).\n");
		kexit(KEXIT_FAILURE);
	}
	else return(0);
    }
return(1);
}
