/*
  * Khoros: $Id: pro_map_co.c,v 1.7 1997/01/20 07:41:05 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: pro_map_co.c,v 1.7 1997/01/20 07:41:05 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 proper_map_rowsize()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: proper_map_rowsize
*
*       Purpose: Check to see if map row size is correct.
*
*         Input: prog 	- program name
*		*image	- viff data
*		proper_row_size - desired row_size
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int proper_map_rowsize(char *prog, xvimage *image, long unsigned int proper_row_size, int exit_flag)
{
    if( ! (image->map_row_size==proper_row_size) ) {
	if (exit_flag == TRUE) {
	    (void) kfprintf(kstderr,"\nError in program %s. ",prog);
	    (void) kfprintf(kstderr,"viff data map is not the specified size required for this program.\n");
	    (void) kfprintf(kstderr,"You may need to modify or remove the map, or perhaps use different data.\n");
	    (void) kfprintf(kstderr,
                        "Map should contain %d rows\n",proper_row_size);
	    (void) kfprintf(kstderr,
                        "currently contains %d rows\n",image->map_row_size);
	    kexit(KEXIT_FAILURE);
	}
	else return(0);
    }
return(1);
}
