/*
  * Khoros: $Id: pro_map_en.c,v 1.7 1997/01/20 07:41:06 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: pro_map_en.c,v 1.7 1997/01/20 07:41:06 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 proper_map_enable()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: proper_map_enable
*
*       Purpose: Check to see if a viff file or structure has the
*               proper map enable value.
*
*         Input: prog 	- program name
*		*image	- viff data
*		type	- desired enable value
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int proper_map_enable(char *prog, xvimage *image, long unsigned int type, int exit_flag)
{
   if(image->map_enable != type) {
      if (exit_flag == TRUE) {
         (void) kfprintf(kstderr, "\nError in program %s: \n",prog);
         switch(type){
            case VFF_MAP_OPTIONAL :
               (void) kfprintf(kstderr, 
"Map enable value should be to VFF_MAP_OPTIONAL.\n");
               (void) kfprintf(kstderr, 
"The viff data uses a map that is not optional, the map should be removed.\n");
               (void) kfprintf(kstderr, 
"One way to accomplish this is to use vmapdata(1).\n");
               (void) kfprintf(kstderr, 
"It is likely that the viff data has a map of VFF_MAP_FORCE because of a\n");
               (void) kfprintf(kstderr, 
"psuedo coloring or color compression operation.\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_MAP_FORCE :
               (void) kfprintf(kstderr, 
"Map enable value should be set to VFF_MAP_FORCE.\n");
               (void) kfprintf(kstderr, 
"A map type of FORCE indicates that the data should be mapped to have its\n");
               (void) kfprintf(kstderr, 
"correct value or interpretation.\n");
               kexit(KEXIT_FAILURE);
               break;
            default :
               (void) kfprintf(kstderr, "Map enable value is unknown.\n");
               kexit(KEXIT_FAILURE);
               break;
	 }
      }
      else return(0);
   }
return(1);
}
