/*
  * Khoros: $Id: pro_map_ty.c,v 1.7 1997/01/20 07:41:08 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: pro_map_ty.c,v 1.7 1997/01/20 07:41:08 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 proper_map_type()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: proper_map_type
*
*       Purpose: Check to see if a viff file or structure has the
*               proper map data type.
*
*         Input: prog 	- program name
*		*image	- viff data
*		type	- desired data type
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int proper_map_type(char *prog, xvimage *image, long unsigned int type, int exit_flag)
{
   if(image->map_storage_type != type) {
      if (exit_flag == TRUE) {
         (void) kfprintf(kstderr, "\nError in program %s: \n",prog);
         (void) kfprintf(kstderr, 
"The viff data map is the wrong type, it should be modified or other data\n");
         (void) kfprintf(kstderr, 
"should be used.\n");
         switch(type){
            case VFF_MAPTYP_1_BYTE :
               (void) kfprintf(kstderr, "Map data type should be VFF_MAPTYP_1_BYTE\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_MAPTYP_2_BYTE :
               (void) kfprintf(kstderr, "Map data type should be VFF_MAPTYP_2_BYTE\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_MAPTYP_4_BYTE :
               (void) kfprintf(kstderr, "Map data type should be VFF_MAPTYP_4_BYTE\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_MAPTYP_FLOAT :
               (void) kfprintf(kstderr, "Map data type should be VFF_MAPTYP_FLOAT\n");
               kexit(KEXIT_FAILURE);
               break;
            case VFF_MAPTYP_COMPLEX :
               (void) kfprintf(kstderr, "Map data type should be VFF_MAPTYP_COMPLEX\n");
               kexit(KEXIT_FAILURE);
               break;
            default :
               (void) kfprintf(kstderr, "Map data type is unknown.\n");
               kexit(KEXIT_FAILURE);
               break;
	 }
      }
      else return(0);
   }
return(1);
}
