/*
  * Khoros: $Id: prope_numb.c,v 1.7 1997/01/20 07:41:10 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: prope_numb.c,v 1.7 1997/01/20 07:41:10 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 proper_num_bands()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: proper_num_bands
*
*       Purpose: Check to see if a viff file or structure has the proper
*               number of data bands.
*
*         Input: prog 	- program name
*		image	- viff data
*		proper_number - desired number of bands
*		exit_flag
*
*        Output: 
*
*       Returns: If exit_flag is true and match fails, an error 
*          	message is printed.
*      		If exit_flag is false and match fails, return(0).
*
*  Restrictions: 
*    Written By:
*          Date: 
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int proper_num_bands(char *prog, xvimage *image, long unsigned int proper_number, int exit_flag)
{
    if( ! (image->num_data_bands==proper_number) ){
	if (exit_flag == TRUE) {
		(void) kfprintf(kstderr,
"\nError in program %s.\n",prog);
		(void) kfprintf(kstderr,
"The number of bands in the viff data file is incorrect.\n");
		(void) kfprintf(kstderr,
"The number of bands can be changed by inserting or deleting bands.\n");
		(void) kfprintf(kstderr,
"The number of bands should be: %d .\n",proper_number);
		(void) kfprintf(kstderr,"BUT is: %d .\n",image->num_data_bands);
		kexit(KEXIT_FAILURE);
	}
	else return(0);
    }
return(1);
}
