/*
  * Khoros: $Id: copyimage.c,v 1.6 1997/01/20 07:45:10 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: copyimage.c,v 1.6 1997/01/20 07:45:10 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>   Public:
   >>>>                 copyimage()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "internals.h"

/************************************************************
*
*  Routine Name: copyimage - copy  an image 
*
*       Purpose: Copy the image
*
*         Input: image - the source image
*        Output:
*       Returns: returns a pointer to an xvimage cloned from the input
*  Restrictions:
*    Written By: Scott Wilson
*          Date: 5-Jan-91
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
xvimage *copyimage(xvimage *image)
{
        xvimage *copy;

        copy = (xvimage *)kmalloc(sizeof(xvimage));
        if (copy == NULL)
          {
            kfprintf(kstderr, "copyimage: unable to allocate header space\n");
            return(NULL);
          }

        copyheader(image,copy);

        if (copyimagedata(image,&copy,1) != 1)
          {
            kfprintf(kstderr,"copyimage: copyimagedata failed\n");
            freeimage(copy);
            return(NULL);
          }
        if (copylocationdata(image,&copy,1) != 1)
          {
            kfprintf(kstderr,"copyimage: copylocationdata failed\n");
            freeimage(copy);
            return(NULL);
          }
        if (copymapdata(image,&copy,1) != 1)
          {
            kfprintf(kstderr,"copyimage: copymapdata failed\n");
            freeimage(copy);
            return(NULL);
          }
        return(copy);
}
