/*
  * Khoros: $Id: cr_imglist.c,v 1.7 1997/01/20 07:45:15 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: cr_imglist.c,v 1.7 1997/01/20 07:45:15 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>  Private:
   >>>>                 create_images_list()
   >>>>   Public:
   >>>>                 create_image_list()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"


/************************************************************
*
*  Routine Name: create_image_list - create a list of pointers to xvimage
*				     structures
*
*       Purpose: Create a list of pointers to xvimage structures
*		 Both the list and each xvimage structure is malloced
*
*         Input: image1 - the source image
*		 image_num - the number of images in the list
*        Output:
*       Returns: a pointer to a list of pointers to xvimage structures.
*
*  Restrictions:
*    Written By: Tom Sauer
*          Date: 5/25/89
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
xvimage **create_images_list(unsigned int image_num)
{

   int i;
   xvimage **image1;

	image1 = (xvimage **) kmalloc(image_num*sizeof(xvimage *));
        if (image1 == NULL) {
             (void) kfprintf(kstderr,
                   "create_images_list: No space for image - malloc failed!\n");
              return(NULL);
        }

	for (i = 0 ; i < image_num; i++) {
	   image1[i] = (xvimage *) kcalloc((size_t)1,sizeof(xvimage));
 	   if (image1[i] == NULL) {
               (void) kfprintf(kstderr,
                   "create_image_list: No space for image - malloc failed!\n");
              return(NULL);
           }
        }

	return(image1);
}
