/*
  * Khoros: $Id: vget_type.c,v 1.6 1997/01/20 07:45:24 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: vget_type.c,v 1.6 1997/01/20 07:45:24 mirage Exp $";
#endif


/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>
   >>>>		File Contents Title
   >>>>		
   >>>>  Private:
   >>>>                 vget_type()
   >>>>   Public:
   >>>>                 vgettype()
   >>>>
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */

#include "internals.h"

/************************************************************
*
*  Routine Name: vgettype - a utility to convert an input string to a
*			    xvimage data type
*
*
*       Purpose: This routine takes as input a string that should be one of
*                bit, byte, short, int, float, complex, or double.
*		 Given this string, it will return a TRUE indicating that no
*		 error has occured, and * the integer argument will be
*		 returned with the corresponding VFF data type.
*
*         Input: stype - string describing the type of data wanted
*        Output: type - address of integer that will hold resulting
*			data type.
*       Returns: (1) TRUE on success, (0) FALSE otherwise
*  Restrictions:
*    Written By: Jeremy Worley
*          Date: Jan 1990
*      Verified:
*  Side Effects:
* Modifications:
*************************************************************/
int vget_type(
	int *type,
	char *stype)
{
  int i;
 
/* 
**  We wanna have the flexibility to enter in upper or lower case type name
*/

  for(i=0;i<kstrlen(stype);i++)
      if(isupper(stype[i]))stype[i]=tolower((int)stype[i]);

/*
** Check first (and if necessary, the second) letter and identify data type
*/

  switch(stype[0]){
       case '0' : *type=VFF_TYP_BIT;
                  return(TRUE);
       case '1' : *type=VFF_TYP_1_BYTE;
                  return(TRUE);
       case 'b' : if(stype[1]=='i'){
                     *type=VFF_TYP_BIT;
                     return(TRUE);
                  }else if(stype[1]=='y'){
                     *type=VFF_TYP_1_BYTE;
                     return(TRUE);
                  }
                  return(FALSE);
       case '2' :
       case 's' : *type=VFF_TYP_2_BYTE;
                  return(TRUE);
       case '3' :
       case 'l' :				/* added 'long' 6/2/90 jw */
       case 'i' : *type=VFF_TYP_4_BYTE;
                  return(TRUE);
       case '4' :
       case 'f' : *type=VFF_TYP_FLOAT;
                  return(TRUE);  
       case '6' :
       case 'c' : *type=VFF_TYP_COMPLEX;
                  return(TRUE);
       case '5' :
       case 'd' : if(stype[1]=='o'){
                     *type=VFF_TYP_DOUBLE;
                     return(TRUE);
                  }else if(stype[1]=='c'){
                     *type=VFF_TYP_DCOMPLEX;
                     return(TRUE);
                  }
       default  : return(FALSE);
   }
}

