 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:00:20 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:00:20 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kdbmcat.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kdbmcat_get_args
| 
|       Purpose: Gets command line args for kdbmcat
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kdbmcat
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kdbmcat_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kdbmcat is out of sync with arguments specified in kdbmcat's *.pane file; please rerun ghostwriter on kdbmcat.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kdbmcat structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kdbmcat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kdbmcat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "manpage",
			  &(clui_info->manpage_flag))))
	{
	    kerror(NULL, "kdbmcat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "cms",
			  &(clui_info->cms_flag))))
	{
	    kerror(NULL, "kdbmcat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "functions",
			  &(clui_info->functions_flag))))
	{
	    kerror(NULL, "kdbmcat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "dbm",
			  &(clui_info->dbm_string),
			  &(clui_info->dbm_flag))))
	{
	    kerror(NULL, "kdbmcat_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'kdbmcat:  prints out stats of software objects' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kdbmcat",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute kdbmcat' $SUPPORTBIN/kdbmcat",
  "-H 1 5x1+41+0 'Help' 'man page for kdbmcat' $SUPPORT/objects/kroutine/kdbmcat/help/kdbmcat.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 1 0 50.75x1+1+2 ' ' 'Toolbox Name' 'name of toolbox' tb",
  "-s 1 0 1 1 0 50.75x1+1+3.5 ' ' 'Object Name' 'name of object' oname",
  "-t 1 0 1 0 0 11.125x1+6+5 'Manpage' 'select the manpage dbm' manpage",
  "-t 1 0 1 0 0 11.375x1+6+6 'CMS database' 'display the cms database' cms",
  "-t 1 0 1 0 0 6.125x1+6+7 'Functions' 'display the functions database' functions",
  "-s 1 0 1 1 0 50.75x1+1+9 ' ' 'DBM Path' 'path to dbm file' dbm",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$SUPPORT/objects/kroutine/kdbmcat/uis/kdbmcat.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	18,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


