 /*
  * Khoros: $Id: usage.c,v 1.1.2.1 1997/06/08 15:29:07 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.1.2.1 1997/06/08 15:29:07 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kdbmupdate.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kdbmupdate_get_args
| 
|       Purpose: Gets command line args for kdbmupdate
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kdbmupdate
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kdbmupdate_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kdbmupdate is out of sync with arguments specified in kdbmupdate's *.pane file; please rerun ghostwriter on kdbmupdate.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kdbmupdate structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_infile(pane, "dbm",
			  &(clui_info->dbm_file),
			  &(clui_info->dbm_flag))))
	{
	    kerror(NULL, "kdbmupdate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "key",
			  &(clui_info->key_string),
			  &(clui_info->key_flag))))
	{
	    kerror(NULL, "kdbmupdate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "printval",
			  &(clui_info->printval_flag))))
	{
	    kerror(NULL, "kdbmupdate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "delete",
			  &(clui_info->delete_flag))))
	{
	    kerror(NULL, "kdbmupdate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "update",
			  &(clui_info->update_string),
			  &(clui_info->update_flag))))
	{
	    kerror(NULL, "kdbmupdate_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'print, delete, or update (ascii) DBM key value' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kdbmupdate",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $SUPPORTBIN/kdbmupdate",
  "-H 1  5x1+41+0 'Help' 'help page' $SUPPORT/objects/kroutine/kdbmupdate/help help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-I 1 0 0 1 0 1 52x1+0+1.5 ' ' 'DBM file' 'DBM file' dbm",
  "-s 1 0 0 1 0 51x1+1+3 ' ' 'Key Name' 'DBM key' key",
  "-C 1",
  "-t 1 0 1 1 0 11.375x1+1+5.5 'Print Value' 'print value of key' printval",
  "-t 1 0 1 0 0 10.625x1+1+6.5 'Delete Key' 'delete key' delete",
  "-s 1 0 1 0 0 51x1+1+7.5 ' ' 'Update Value' 'update value' update",
  "-E",
  "-b +0+4.5 'Select One' blank1",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$SUPPORT/objects/kroutine/kdbmupdate/uis/kdbmupdate.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


