 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:01:06 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:01:06 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kfindobj.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kfindobj_get_args
| 
|       Purpose: Gets command line args for kfindobj
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kfindobj
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kfindobj_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kfindobj is out of sync with arguments specified in kfindobj's *.pane file; please rerun ghostwriter on kfindobj.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kfindobj structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kfindobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kfindobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "type",
			  &(clui_info->type_string),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kfindobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'search for software objects in toolboxes' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kfindobj",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute kfindobj' $SUPPORTBIN/kfindobj",
  "-H 1  5x1+41+0 'Help' 'help page for kfindobj' $SUPPORT/objects/kroutine/kfindobj/help/kfindobj.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 0 0 52x1+0+2 ' ' 'Toolbox Name' 'Toolbox to search' tb",
  "-s 1 0 1 0 0 52x1+0+3.5 ' ' 'Object Name ' 'Software object name' oname",
  "-s 1 0 1 0 0 52x1+0+5 ' ' 'Object Type ' 'Software object type' type",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$SUPPORT/objects/kroutine/kfindobj/uis/kfindobj.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	15,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


