 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:01:22 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:01:22 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgenman.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgenman_get_args
| 
|       Purpose: Gets command line args for kgenman
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenman
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgenman_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgenman is out of sync with arguments specified in kgenman's *.pane file; please rerun ghostwriter on kgenman.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgenman structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kgenman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "lib",
			  &(clui_info->lib_string),
			  &(clui_info->lib_flag))))
	{
	    kerror(NULL, "kgenman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "section",
			  &(clui_info->section_string),
			  &(clui_info->section_flag))))
	{
	    kerror(NULL, "kgenman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "dir",
			  &(clui_info->dir_string),
			  &(clui_info->dir_flag))))
	{
	    kerror(NULL, "kgenman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "install",
			  &(clui_info->install_flag))))
	{
	    kerror(NULL, "kgenman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "list",
			  &(clui_info->list_flag))))
	{
	    kerror(NULL, "kgenman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "all",
			  &(clui_info->all_flag))))
	{
	    kerror(NULL, "kgenman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "i",
			  &(clui_info->i_string),
			  &(clui_info->i_flag))))
	{
	    kerror(NULL, "kgenman_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'kgenman:  generate man3 pages from source code headers' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kgenman",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1 6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute kgenman' $SUPPORTBIN/kgenman",
  "-H 1 5x1+41+0 'Help' 'help page for kgenman' $SUPPORT/objects/kroutine/kgenman/help/kgenman.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 0 1 0 58.75x1+2+1 ' ' 'Toolbox Name' 'toolbox the library belongs to' tb",
  "-s 1 0 0 1 0 58.75x1+2+2 ' ' 'Library Name' 'library to generate man pages for' lib",
  "-s 1 0 1 0 0 58.5x1+2+3 ' ' 'Man Section' 'Man section to put the man page into' section",
  "-C 1",
  "-s 1 0 1 0 0 59.75x1+2+5 '.' 'Generate man pages and install' 'generate and install in the directory specified' dir",
  "-t 1 0 1 0 0 49.75x1+2+6 'Generate and install the man pages in $TOOLBOX/man/man3' 'Install the man pages in $TOOLBOX/man/man3' install",
  "-t 1 0 1 1 0 49.75x1+2+7 'List Man Pages Only' 'List the man pages rather than generate them' list",
  "-E",
  "-C 1",
  "-t 1 0 1 1 0 49.75x1+2+9 'All src files in library object' 'create man pages for all src in the library object' all",
  "-s 1 0 1 0 0 49.5x1+2+10 ' ' 'Input Source Code File' 'input source code file' i",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$SUPPORT/objects/kroutine/kgenman/uis/kgenman.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	24,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


