 /*
  * Khoros: $Id: kgenwhatis.c,v 1.14.2.2 1997/05/31 20:01:50 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: kgenwhatis.c,v 1.14.2.2 1997/05/31 20:01:50 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>> 
   >>>> 	Main program for kgenwhatis
   >>>> 
   >>>>  Private: 
   >>>> 	main
   >>>> 
   >>>>   Static: 
   >>>>   Public: 
   >>>> 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */


#include "kgenwhatis.h"

clui_info_struct *clui_info = NULL;

/*-----------------------------------------------------------
|
|  Routine Name: main() - generate database of available manpages (whatis)
|
|       Purpose: main program for kgenwhatis
|
|         Input:
|		char *clui_info->tb_string; {toolbox name}
|		int   clui_info->tb_flag; {TRUE if -tb specified}
|
|        Output:
|       Returns:
|
|    Written By: 
|          Date: July 1, 1997
| Modifications:
|
------------------------------------------------------------*/

int main(
   int  argc,
   char **argv)
{

/* -main_variable_list */
/* -main_variable_list_end */

	khoros_init(argc, argv, "SUPPORT", PRODUCT_RELEASE_DATE,
	            PRODUCT_RELEASE_NAME, PRODUCT_RELEASE_VERSION,
	            PRODUCT_RELEASE_MAJOR, PRODUCT_RELEASE_MINOR,
	            "$SUPPORT/objects/kroutine/kgenwhatis");
	kexit_handler(kgenwhatis_free_args, NULL);

/* -main_get_args_call */
	kclui_init("SUPPORT", "kgenwhatis", KGEN_KROUTINE,  &clui_uis_spec,
		   kgenwhatis_usage_additions, kgenwhatis_get_args,
 		   kgenwhatis_free_args);
/* -main_get_args_call_end */

/* -main_before_lib_call */
/* -main_before_lib_call_end */

/* -main_library_call */
        if (!(whatis(clui_info->tb_string)))
        {
           kerror(NULL, "main",
                "An Error occured during the generation of the 'whatis' file\nAs a result the 'whatis' file was not generated\n");
           kexit(1);
        }
/* -main_library_call_end */

/* -main_after_lib_call */
/* -main_after_lib_call_end */


	kexit(KEXIT_SUCCESS);
}


/*-----------------------------------------------------------
| 
|  Routine Name: kgenwhatis_usage_additions
| 
|       Purpose: Prints usage additions in kgenwhatis_usage routine
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenwhatis
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgenwhatis_usage_additions(void)
{
	kfprintf(kstderr, "\tgenerate database of available manpages (whatis)\n");

/* -usage_additions */
/* -usage_additions_end */

}
/*-----------------------------------------------------------
| 
|  Routine Name: kgenwhatis_free_args
| 
|       Purpose: Frees CLUI struct allocated in kgenwhatis_get_args()
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgenwhatis
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
/* ARGSUSED */
void
kgenwhatis_free_args(
    kexit_status status,
    kaddr        client_data)
{

	/* do the wild and free thing */
	if (clui_info != NULL)
	{
		kfree_and_NULL(clui_info->tb_string);
		kfree_and_NULL(clui_info);
	}

/* -free_handler_additions */
/* -free_handler_additions_end */
}
