 /*
  * Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:02:12 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.14.2.2 1997/05/31 20:02:12 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kgrepobj.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kgrepobj_get_args
| 
|       Purpose: Gets command line args for kgrepobj
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kgrepobj
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kgrepobj_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kgrepobj is out of sync with arguments specified in kgrepobj's *.pane file; please rerun ghostwriter on kgrepobj.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kgrepobj structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "tb",
			  &(clui_info->tb_string),
			  &(clui_info->tb_flag))))
	{
	    kerror(NULL, "kgrepobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "oname",
			  &(clui_info->oname_string),
			  &(clui_info->oname_flag))))
	{
	    kerror(NULL, "kgrepobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "type",
			  &(clui_info->type_string),
			  &(clui_info->type_flag))))
	{
	    kerror(NULL, "kgrepobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "function",
			  &(clui_info->function_string),
			  &(clui_info->function_flag))))
	{
	    kerror(NULL, "kgrepobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "string",
			  &(clui_info->string_string),
			  &(clui_info->string_flag))))
	{
	    kerror(NULL, "kgrepobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_string(pane, "routine",
			  &(clui_info->routine_string),
			  &(clui_info->routine_flag))))
	{
	    kerror(NULL, "kgrepobj_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}


}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'grep for strings, routines or function in an object' subform",
  "-P 1 0 52x1+0+1 +0+0 ' ' kgrepobj",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute kgrepobj' $SUPPORTBIN/kgrepobj",
  "-H 1  5x1+41+0 'Help' 'help page for kgrepobj' $SUPPORT/objects/kroutine/kgrepobj/help/kgrepobj.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 1 1 0 51.75x1+1+1.5 ' ' 'Toolbox' 'Toolbox to search' tb",
  "-s 1 0 1 1 0 51.75x1+1+3 ' ' 'Object' 'Object to search' oname",
  "-s 1 0 1 0 0 51.75x1+1+4.5 ' ' 'Object Type' 'Software object type' type",
  "-C 1",
  "-s 1 0 1 0 0 51.75x1+1+6 ' ' 'Function' 'Specific function to search for' function",
  "-s 1 0 1 1 0 51.75x1+1+7 ' ' 'String' 'String expression to search for' string",
  "-s 1 0 1 0 0 51.75x1+1+8 ' ' 'Routine' 'Specific routine to search for' routine",
  "-E",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$SUPPORT/objects/kroutine/kgrepobj/uis/kgrepobj.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	20,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};


