eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: kad2doc - generate documentation source from app-defaults
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: kad2doc.pl,v 1.8.2.1 1997/03/17 22:51:35 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
die "The HOME environment variable must be set.\n" if ( !defined $ENV{'HOME'});
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis = 'generate documentation source from app-defaults';
@clui_args  = (
        '[i]',   'file-name',   'input file',
        '[o]',   'file-name',   'output file'
);

chop($VERSION = `kecho -tb support -oname kattrtable -echo version`);
chop($DATE = `date`);
($PROGRAM = $0) =~ s/.*\///;

# initialize Khoros perl lib
&khoros'initialize("SUPPORT",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

if ($opt_i)
{
   $relpath = $opt_i;
   foreach $toolbox (keys %khoros'toolboxPath)
   {
      $relpath =~ s/$khoros'toolboxPath{"\U$toolbox"}/\$\U$toolbox\E/;
   }
}
else
{
   $relpath = "(unknown)";
}

# ------------------------------------------------------------------------
# Was an input file specified?  If not, default to stdin
# ------------------------------------------------------------------------

if ($khoros'seenswitch{'i'})
{
   open(INFILE, "< $khoros'argval{'i'}") || do
   {
      die "Unable to read input file $khoros'argval{'i'}: $!\n";
   };
}
else
{
   *INFILE = *STDIN;
}

# ------------------------------------------------------------------------
# Was an output file specified?  If not, default to stdout
# ------------------------------------------------------------------------

if ($khoros'seenswitch{'o'})
{
   open(OUTFILE, "> $khoros'argval{'o'}") || do
   {
      die "Unable to write output file $khoros'argval{'o'}: $!\n";
   };
}
else
{
   *OUTFILE = *STDOUT;
}

&GenerateHeader(*OUTFILE);
&GenerateFromInput(*INFILE, *OUTFILE);

close INFILE if $khoros'seenswitch{'i'};
close OUTFILEFILE if $khoros'seenswitch{'o'};

# ========================================================================
# Function Name: GenerateHeader() - generate comment block at head of file
# Purpose:       This function generates a block of roff comments to go
#		 at the head of the generated file.
# ========================================================================
sub GenerateHeader
{
   local(*HANDLE) = @_;
   local($oldfh);


   $oldfh = select(HANDLE);
   print ".\\\" ----------------------------------------------------------\n";
   print ".\\\" DO NOT MODIFY - this file is auto-generated\n";
   print ".\\\"\n";
   print ".\\\" Generated by:   $PROGRAM $VERSION\n";
   print ".\\\" Date Generated: $DATE\n";
   print ".\\\" ----------------------------------------------------------\n";
   select($oldfh);
}

# ========================================================================
# Function Name: GenerateFromInput
# Purpose:       This function generates a block of roff comments to go
#		 at the head of the generated file.
# ========================================================================
sub GenerateFromInput
{
   local(*IN, *OUT) = @_;
   local($inbody);
   local($intagged);


   $inbody = 0;
   while (<IN>)
   {
      if ($inbody == 0 && /^!\s*INHERITANCE:/)
      {
         print OUT ".begin tagged\n";
         print OUT ".item \"Generated From App-defaults file:\"\n";
         print OUT "\\f(CW\\s-2$relpath\\s+2\\fP\n";
         print OUT ".item \"Inheritance\"\n";
         s/^!\s*INHERITANCE:\s*//;
         print OUT ".nf\n";
         print OUT;
         $intagged = 1;
         next;
      }

      if ($intagged && /^!\s*CLASS-SPECIFIC RESOURCES:/)
      {
         print OUT ".fi\n";
         print OUT ".item \"Class-Specific Resources\"\n";
         s/^!\s*CLASS-SPECIFIC RESOURCES:\s*//;
         print OUT ".nf\n";
         print OUT;
         next;
      }

      if ($inbody == 0 && /^!(\s*)SUB-PARTS:/)
      {
         $indent = $1;
         print OUT ".fi\n";
         print OUT ".item \"Sub-Parts\"\n";
         s/^!\s*SUB-PARTS:\s*//;
         print OUT ".begin code\n";
         print OUT;
         $insubparts=1;
         next;
      }

      if ($inbody == 0 && /^!\s*Corresponding Attribute:/i)
      {
         if ($insubparts)
         {
            print OUT ".end code\n";
         }
         elsif ($intagged)
         {
            print OUT ".fi\n";
         }
	 $inbody=1;
	 $intagged=0;
         $insubparts=0;
         print OUT ".item \"Resource Specifications in App-defaults File\"\n";
	 print OUT ".begin code\n";
      }

      next unless $inbody || $intagged;

      if ($insubparts)
      {
         if (/^!$indent/)
         {
            s/^!$indent//;
         }
         else
         {
            s/^!\s*$//;
         }
         print OUT;
         next;
      }

      if ($intagged)
      {
         s/^!\s*//;
         next if /^$/;
         print OUT;
         next;
      }

      print OUT;
   }

   if ($inbody)
   {
      print OUT ".end code\n.end tagged\n";
   }
   elsif ($insubparts)
   {
      print OUT ".end code\n.end tagged\n";
   }
   elsif ($intagged)
   {
      print OUT ".end tagged\n";
   }
}
