eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

#========================================================================
# Program Name: kdeclchk - 
# Purpose:	long description goes here
#
# RCS ID:	Khoros: $Id: kdeclchk.pl,v 1.7.2.1 1997/03/17 22:51:45 mirage Exp $
#========================================================================

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
die "The HOME environment variable must be set.\n" if ( !defined $ENV{'HOME'});
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis = '';
@clui_args  = (
        'tb',     'toolbox',      'name of toolbox',
        '[oname]',  'object-name',  'name of software object'
);

# initialize Khoros perl lib
&khoros'initialize("SUPPORT",$whatis,@clui_args);

&khoros'parse_args(@ARGV);                   # parse the command-line

@toolboxes = &khoros'get_toolbox_list(); #'
$allobjs = 1 if  ( ! $khoros'seenswitch{'oname'} ); #'
$objstr = $khoros'argval{'oname'} if $khoros'seenswitch{'oname'};

foreach $tbname (@toolboxes)
{
   $toolbox = "\L$tbname";
   $TOOLBOX = "\U$tbname";
   @onames = split(/\s/, `kecho -tb $tbname -type library -echo objects`);
   if ($? != 0 )
   {
      print "Cannot get a list of object names for the toolbox '$TOOLBOX'\n";
      next;
   }
   @onameop = $allobjs == 1 ? @onames : split(/,/,$objstr);
   foreach $oname (@onameop)
   {
      next unless (grep(/^$oname$/, @onames));
      @files = split(/\s/, `kecho -tb $tbname -oname $oname -echo src`);
      if ($? != 0)
      {
	 print "Cannot get a list of source code files for the object '$TOOLBOX::$oname'\n";
	 next;
      }
      foreach $file (@files)
      {
	 $basename = $1 if ($file =~ m#^.*/(.*)$#);
	 @routines = split(/\n/, `mkproto -s 1 -p 0 -h 0 -i '$file' 2>&1`);
         if ($? != 0)
	 {
	    print "Cannot get a list of routines for the file:\n'$file'\n\n";
	    next;
	 }
	 @public = split(/\s/, `kgenman -tb $tbname -lib $oname -list -i $basename 2>&1`);
         if ($? != 0)
	 {
	    print "Cannot get a list of public routines for the file:\n'$file'\n\n";
	    next;
	 }
	 @static = grep(/^static /, @routines);
	 @private = ();
	 foreach $routine (@routines)
	 {
	    @private = (@private, $routine)
	               if ( ! grep(/\b$routine\b/, (@static, @public))); 
	 }
	 $path = &khoros'fullpath($file); #'
	 $oldpath = "$path.old";
	 $hdrpath = "$path.hdr";
	 $usehdrpath = 0;
	 rename($path, $oldpath) || do
	 {
	    warn "Cannot rename current file '$path' to '$oldpath'\n";
	    $usehdrpath = 1;
	 };
         $usehdrpath || open(SRC, "<$oldpath") || do
#         $usehdrpath || open(SRC, "<$path") || do
	 {
	    warn "Cannot open $basename to read.\n";
	    $usehdrpath = 1;
	 };
	 if ($usehdrpath == 0)
	 {
	    open(OUT, ">$path") || do
	    {
	       warn "Cannot open $basename to write.\n";
	       next;
	    };
	    undef $foundhdr;
	    undef $inhdr;
	    undef $title;
	    $noroutines = 1;
	    while (<SRC>)
	    {
	        $inhdr = 1 if ( ! $foundhdr && m#^\s*/\* >{15,}\s*<{15,}\s*$# );
		if ($inhdr)
		{
		   $foundhdr = 1;
		   undef $inhdr if ( m#^\s*>{15,}\s*<{15,}\s*\*/\s*$# );
		   undef $noroutines
		    if (m/^\s*>>>>\s*\S+:/ || m#^\s*>{15,}\s*<{15,}\s*\*/\s*$#);
		   if ($noroutines && m/^\s*>>>>\s*(.*)$/)
		   {
		       $title = ($title) ? $title."#nl#".$1 : $1
		   }
		   &SpitHeaderInfo($title) if (!$inhdr);
		}
		else
		{
		   print OUT "$_";
		}
	    }
	    close SRC;
	    close OUT;
	 }
	 if ((! $foundhdr) || $usehdrpath == 1)
	 {
	      warn "File '$basename' did not have a routine header\n"
		  if ($usehdrpath == 0);
	      open(OUT, ">$hdrpath") || do
	      {
		 warn "Cannot open $basename.hdr to save header information\n";
		 next;
	      };
	      &SpitHeaderInfo("Routines in $basename");
	      close OUT;
	 }
      }
   }
}

sub SpitHeaderInfo
{
   local($title) = @_;

   print OUT "/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<\n";
   print OUT "   >>>>\n";
   $title =~ s/#nl#/\n   >>>>\t\t/g;
   print OUT "   >>>>\t\t$title\n";
   print OUT "   >>>>  Private:\n" if (@private);
   foreach $routine (@private)
   {
      print OUT "   >>>>                 $routine()\n";
   }
   print OUT "   >>>>   Static:\n" if (@static);
   foreach $routine (@static)
   {
      $out = $1 if ($routine =~ m/^static (.*)/);
      print OUT "   >>>>                 $out()\n";
   }
   print OUT "   >>>>   Public:\n" if (@public);
   foreach $routine (@public)
   {
      print OUT "   >>>>                 $routine()\n";
   }
   print OUT "   >>>>\n";
   print OUT "   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<< */\n";
}
	
