: # use perl
        eval 'exec perl -S $0 ${1+"$@"}'
                if $runnning_under_some_shell;

# Khoros: $Id: kdocdepend.pl,v 1.8.2.1 1997/03/17 22:51:49 mirage Exp $

# Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
# All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.

# -khoros_perl_init

$notfound = 1;
foreach $toolbox_file (sort split(/:/, $ENV{'KHOROS_TOOLBOX'}))
{
   push(@files, $toolbox_file);
   push(@lineno, 0);
}
die "The HOME environment variable must be set.\n" if ( !defined $ENV{'HOME'});
$HOME = $ENV{'HOME'};
if ( @files == 0 )
{
   push(@files, "$HOME/.Toolboxes");
   push(@lineno, 0);
}
while (@files > 0)
{
   $toolbox_file = pop @files;
   $start_char   = pop @lineno;
   open(TBS,"<$toolbox_file") || do
   {
      warn "Can not open $toolbox_file.  Please check to make sure your\n";
      die  "referenced Toolboxes file(s) exist.\n";
   };
   seek(TBS, $start_char, 0);

   while (<TBS>)
   {
      chop($_);
      if (/^#include\s+([^\s]*)/)
      {
	 push(@files, "$toolbox_file", "$1");
	 push(@lineno, tell TBS, 0);
	 last;
      }
      next if /^\s*#/;
      @line = m/^([^:]+):([^\;]+)\;?(.*)$/;

      if ($line[1] =~ /kfile:/ || $tbpath =~ /kexec:/)
      {
         print "$line[0] is a remote toolbox.  It is not added to list\n";
         print "because remote toolboxes not supported at this time.\n";
      }
      else
      {
         push(@INC, "$line[1]/repos/perl") if $line[0] eq "SRCMACH";

         if ($line[0] eq "SUPPORT")
         {
            if ( $notfound )
            {
               $support_path = $line[1];
               undef $notfound;
            }
            else
            {
               warn "The SUPPORT toolbox is defined twice.  Please check\n";
	       warn "your environment toolboxes file(s) and make sure that\n";
	       warn "all toolboxes are only defined once.\n";
	       $support_path = $line[1];
            }
         }
      }
   }
   close TBS;
}

if ( $notfound )
{
   print "The SUPPORT toolbox is not defined in any of the files pointed to\n";
   die   "by the environment toolboxes file(s).\n";
}

# -khoros_perl_init_end

@INC = ("$support_path/repos/perl", @INC);
require "khoros.pl";
require "kutils.pl";

$whatis	= 'generate dependencies for khoros manual';
@cli_args	=
(
 'target',	'target-file',	'the make target for manual',
 'toplevel',	'top-file',	'the toplevel file of manual',
 's',           'comment',      'comment which marks start of dependencies',
 '[verbose]',   '',             'verbose reporting information'
);

# initialize Khoros perl lib
&khoros'initialize("SUPPORT", $whatis, @cli_args);

# parse the command-line arguments
&khoros'parse_args(@ARGV);
$delimiter = $khoros'argval{'s'};

# build associative array which contains toolbox paths
&GetToolboxPaths();


@dependencies = ();
&GenerateDependencies($khoros'argval{'target'}, $khoros'argval{'toplevel'});
&UpdateMakefile();

sub UpdateMakefile
{
   open(MAKEFILE, "< Makefile") || die "Can't read Makefile.\n";
   open(NEW, "> Makefile.$$") || die "Can't write Makefile.$$\n";
   while (<MAKEFILE>)
   {
      last if /^$delimiter/;
      print NEW;
   }
   print NEW "$delimiter\n";
   foreach $dep (@dependencies)
   {
      print NEW "$dep\n";
   }

   close NEW;
   close MAKEFILE;
   rename ("Makefile", "Makefile.bak") && rename("Makefile.$$", "Makefile");
   unlink ("Makefile.bak");
}

sub GenerateDependencies
{
   local($root,$filename) = @_;
   local(*INFILE);
   local($toolbox);
   local($_);


   return if $ignoreFile{$filename};

   if ($filename =~ m!\$([^/]+)/(.*)$!)
   {
      $toolbox = "\U$1";
      unless (defined $toolboxPath{"$toolbox"})
      {
         print STDERR "Could not resolve path: $filename ";
         print STDERR "(toolbox \$$toolbox unknown)\n";
         return;
      }
      $filename = "$toolboxPath{$toolbox}/$2";
   }

   push(@dependencies, "$root: $filename") unless $root eq $filename;
   open(INFILE,"< $filename") || do
   {
      warn "kdocdepend: file $filename not found\n";
      return;
   };

   while (<INFILE>)
   {
      if (/^\.\\"\s*kdocdepend:\s*ignore\s+(\S+)/)
      {
	 print STDERR "Ignoring file $1\n" if $opt_verbose;
         $ignoreFile{$1} = 1;
      }
      &GenerateDependencies($root,$1) if /^\.\s*include\s+(\S+)/;
      &GenerateDependencies($root,$1) if /^\.\s*so\s+(\S+)/;
      &GenerateDependencies($root,$1) if /^\.\s*help\s+\d+\s+(\S+)/;
   }
   close INFILE;
}

sub GetToolboxPaths
{
   return unless defined $ENV{'KHOROS_TOOLBOX'};
   @TBFILES = split(/:/,$ENV{'KHOROS_TOOLBOX'});
   foreach $file (@TBFILES)
   {
      open(TBFILE, "<$file") || next;
      while (<TBFILE>)
      {
         chop;
         next if /^\s*#/ ;
         ($toolbox, $tbpath) = m/^([^:]+):([^\;]+)\;?(.*)$/;
         if ($tbpath =~ /kfile:/ || $tbpath =~ /kexec:/)
         {
             print "$toolbox is a remote toolbox.  It is not added to list\n";
             print "because remote toolboxes not supported at this time.\n";
         }
         else
         {
            $toolboxPath{$toolbox} = $tbpath;
         }
      }
   }
}

