#ifndef __keyinfo_h_
#define __keyinfo_h_

static kstring kcmskeys[] =
{
   "ALIAS_FILE",
   "APP_DEFAULTS",
   "AUTHOR",
   "AUTHOR_EMAIL",
   "BNAME",
   "BUGS_FILE",
   "C++SRCS",
   "CATEGORY",
   "CHANGELOG_FILE",
   "CMS_VERSION",
   "COBJS",
   "COND_LEVELS",
   "CONFIG_FILE",
   "CPLUSOBJS",
   "DEPENDENCIES",
   "DONE_FILE",
   "FOBJS",
   "FSRCS",
   "GENERATE_EXECUTABLE",
   "GHOST_HEADER",
   "GHOST_HELP",
   "GHOST_LIB",
   "GHOST_MAN1",
   "GHOST_MAN3",
   "GHOST_SCRIPT",
   "GHOST_SRC",
   "HEADERS",
   "ICON_NAME",
   "INCLUDE_FILE",
   "INFO_FILE",
   "IN_CANTATA",
   "KEYWORDS",
   "LANG",
   "LOBJS",
   "LONG_COPYRIGHT",
   "LSRCS",
   "MISC_FILES",
   "PIXMAPS",
   "PROG_TYPE",
   "SCRIPTS",
   "SHORT_COPYRIGHT",
   "SHORT_DESCRIPTION",
   "SOFTWARE_OBJECTS",
   "SRCS",
   "STATE_CTYPE",
   "STATE_LOCKED",
   "STATUS",
   "SUBCATEGORY",
   "TB_NAME",
   "TITLE",
   "TODO_FILE",
   "UIS_FORM",
   "UIS_MISC",
   "UIS_PANE",
   "UNSHARED_OBJS",
   "VERSION",
   "VERSION_MAJOR",
   "VERSION_MINOR",
   "WORKSPACE",
   "YOBJS",
   "YSRCS",
};

static kstring key_descriptions[] =
{
   "Path to the Aliases file for a toolbox. ",
   "List of app-defaults files associated with a software object. ",
   "The full name of the author, or point-of-contact, for a toolbox or software object. ",
   "Email address of author, or point-of-contact, for a toolbox or software object. ",
   "The binary name of a software object. ",
   "Path to the `bugs' info file for a software object. ",
   "A list of C++ source files associated with a software object. ",
   "A list of toolboxes on which this toolbox depends. ",
   "The category string for a software object. ",
   "Path to the `change log' info file for a software object. ",
   "Version of kcms which generated the database. ",
   "List of C object files for a software object. ",
   "Extraction levels to use when generating GUI code. ",
   "Path to the imake configuration file for a toolbox. ",
   "List of C++ object files for a software object. ",
   "Path to the `done' info file for a software object. ",
   "List of Fortran object files for a software object. ",
   "A list of Fortran source files associated with a software object. ",
   "Should an executable be generated for a pane object. ",
   "The path to the include file for a kroutine or xvroutine software object, which contains the code generation tags. ",
   "The path to the help file for a software object. ",
   "The name of the library which contains an associated library function for a kroutine software object. ",
   "The path to the man page for a kroutine, xvroutine, pane, or script object. ",
   "The path to the library man page associated with a kroutine software object. ",
   "The path to the generate script for a pane object. ",
   "The path to the main source file for a kroutine or xvroutine software object, which contains the code generation tags. ",
   "A list of header files (includes) associated with a software object. ",
   "The `icon name' for a software object. ",
   "Path to the toolbox include file. ",
   "Path to the toolbox `info', or description, file. ",
   "A flag which specifies whether a software object should appear in cantata. ",
   "List of keywords associated with toolbox or software object. ",
   "The programming language used to implement the software object. ",
   "List of Lex object files for a software object. ",
   "The `long' copyright statement associated with a toolbox. ",
   "A list of Lex source files associated with a software object. ",
   "List of miscellaneous files associated with a toolbox or software object. ",
   "List of pixmap files associated with a toolbox or software object. ",
   "The type of a software object. ",
   "A list of script files associated with a script object. ",
   "The `short' copyright statement associated with a toolbox. ",
   "The short description of a software object. ",
   "The list of software objects contained within a toolbox. ",
   "A list of source files associated with a software object. ",
   "Type of C used -- K&R or ANSI? ",
   "Is the object locked against changes? ",
   "The status of a toolbox. ",
   "The subcategory string for a software object. ",
   "The name of a toolbox. ",
   "The title string for a toolbox. ",
   "Path to the `todo' info file for a software object. ",
   "The path to the form UIS file of an xvroutine. ",
   "A list of miscellaneous UIS files associated with a software object. ",
   "The path to the pane UIS file of a kroutine, xvroutine, or script. ",
   "List of unshared object files for a software object. ",
   "Version of the toolbox or software object. ",
   "Major version of the software object. ",
   "Minor version of the software object. ",
   "The path to the workspace file associated with a pane object. ",
   "List of Yacc object files for a software object. ",
   "A list of Lex source files associated with a software object. ",
};

#endif
