 /*
  * Khoros: $Id: usage.c,v 1.15.2.3 1997/05/31 20:04:43 mirage Exp $
  */

#if !defined(__lint) && !defined(__CODECENTER__)
static char rcsid[] = "Khoros: $Id: usage.c,v 1.15.2.3 1997/05/31 20:04:43 mirage Exp $";
#endif

/*
 * Copyright (C) 1993 - 1997, Khoral Research, Inc., ("KRI").
 * All rights reserved.  See $BOOTSTRAP/repos/license/License or run klicense.
 */

#include "kdbmedit.h"
/*-----------------------------------------------------------
| 
|  Routine Name: kdbmedit_get_args
| 
|       Purpose: Gets command line args for kdbmedit
| 
|         Input: None
| 
|        Output: None
|    Written By: ghostwriter -oname kdbmedit
|          Date: July 1, 1997
| Modifications: 
| 
------------------------------------------------------------*/
void kdbmedit_get_args(
    kaddr opane)
{

	static char *sync_error_mesg = "Generated code for kdbmedit is out of sync with arguments specified in kdbmedit's *.pane file; please rerun ghostwriter on kdbmedit.";

	kform *pane = (kform *) opane;


	/*
	 * allocate the kdbmedit structure
	 */
	clui_info = (clui_info_struct *) 
	       kcalloc((size_t)1, sizeof (clui_info_struct));

	if (!(kclui_get_string(pane, "dbm",
			  &(clui_info->dbm_string),
			  &(clui_info->dbm_flag))))
	{
	    kerror(NULL, "kdbmedit_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_flag(pane, "view",
			  &(clui_info->view_flag))))
	{
	    kerror(NULL, "kdbmedit_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

	if (!(kclui_get_infile(pane, "form",
	                &(clui_info->form_file),
	                &(clui_info->form_flag))))
	{
	    kerror(NULL, "kdbmedit_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "x",
	                &(clui_info->x_int),
	                &(clui_info->x_flag))))
	{
	    kerror(NULL, "kdbmedit_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}
	if (!(kclui_get_int(pane, "y",
	                &(clui_info->y_int),
	                &(clui_info->y_flag))))
	{
	    kerror(NULL, "kdbmedit_get_args", sync_error_mesg);
	    kexit(KEXIT_FAILURE);
	}

}



/*
 * internal representation of clui UIS file
 */
char *clui_uis[] = {

  "-F 4.3 1 0 52x1+0+0 +0+0 'Cantata' cantata",
  "-M 1 1 52x1+0+0 +1+0 'DBM database editor (ascii only)' subform",
  "-P 1 0 52x1+0+1 +1+0 ' ' Program_Name",
  "-D 1 0 9x1+0+0 'Options' _gui_options",
  "-H 1  6x1+0+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-R 1 0 1 5x1+35+0 'Run' 'execute operation' $SUPPORTBIN/kdbmedit ",
  "-H 1  5x1+41+0 'Help' 'man page for kdbmedit' $SUPPORT/objects/xvroutine/kdbmedit/help/kdbmedit.hlp help",
  "-Q 1 0 5x1+47+0 'Close'",
  "-s 1 0 0 1 0 51x1+1+2 ' ' 'KDBM File' 'path to dbm file, including basename' dbm",
  "-t 1 0 1 0 0 11.125x1+1+3.5 'View only' 'flag for read-only session' view",
  "-E",
  "-E",
  "-E",
};

size_t clui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,};

size_t clui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *clui_filenames[] = {
  "$SUPPORT/objects/xvroutine/kdbmedit/uis/kdbmedit.pane",
};

/*
 * UIS struct for clui
 */
uis_struct clui_uis_spec = {
	clui_uis,
	14,
	clui_file_lookup,
	clui_line_lookup,
	clui_filenames,
	1,
	512};
/*
 * internal representation of gui UIS file
 */
char *gui_uis[] = {

  "-F 4.3 1 1 70x3+10+15 +38+1 ' ' form",
  "-M 1 1 70x11.5+10+5 +3+4.5 'Khoros DBM editor' kdbmedit",
  "-G 1 15x11+0+1 +18+0.5 ' '",
  "-D 1 0 9.25x1+1+0.5 'Options' options",
  "-H 1  11x1+1+0 'License' 'license' $BOOTSTRAP/repos/license/License license",
  "-E",
  "-H 1  6x1+55+0.5 'Help' 'display online help' $SUPPORT/objects/xvroutine/kdbmedit/help/Overview.doc help",
  "-Q 1 0 6x1+63+0.5 'Quit'",
  "-z 1 0 0 1 1 19x7.5+1+2 1 1 1 0 'Database Keys' 'list of keys in database' keylist 'First'",
  "-a 1 0 9x1+1+10 'Edit Key' 'Edit currently selected key' edit",
  "-a 1 0 9x1+11+10 'Delete Key' 'Edit currently selected key' del",
  "-b +28+0 'pixmap:$SUPPORT/objects/xvroutine/kdbmedit/misc/kdbmedit.xpm' pixmap",
  "-g 1 1 20x1+21+10 'Show contents of key' pane",
  "-g 1 0 22x1+42+10 'Add Key to Database' addpane",
  "-E",
  "-P 1 0 48x7.5+21+2 +25+3 'Khoros DBM Editor' pane",
  "-w 380x161+0+0 'workspace to hold text widget' workspace",
  "-E",
  "-P 1 0 48x7.5+21+2 +0+0 '  ' addpane",
  "-z 1 0 0 1 1 20x6.5+0+0 1 1 1 0 'Legal Keys' 'list of legal keys' allkeys 'First'",
  "-w 220x110+20+1 'workspace to hold text widget' workspace",
  "-a 1 0 18x1+1+6.5 'Add Selected Key' 'Add selected key' addkey",
  "-s 1 0 0 1 1 28x1+20+6.5 ' ' 'Add:' 'add your own key' custom",
  "-b +28+0 'Description of Key' description",
  "-E",
  "-E",
  "-E",
};

size_t gui_line_lookup[] = {
  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
  21,22,23,24,25,26,27,};

size_t gui_file_lookup[] = {
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,};
/*
 * array of uis filenames and line numbers for error messaging
 */
char *gui_filenames[] = {
  "$SUPPORT/objects/xvroutine/kdbmedit/uis/kdbmedit.form",
};

/*
 * UIS struct for gui
 */
uis_struct gui_uis_spec = {
	gui_uis,
	27,
	gui_file_lookup,
	gui_line_lookup,
	gui_filenames,
	1,
	512};


